!   Matrix Multiplication (4096 x 4096) 
!   Copy right Fujitsu Shizuoka Engineering Limited  
!
!
	.text
	.align 8

        .global _startup
_startup:
        jmp     gr3

        .global _terminate
_terminate:
        jmp     gr3

        .global _main
_main:

!   Register usage
!
!  ======== General Register ==========
!
!  gr01 : Vector Length 
!  gr02 : Address of A
!  gr03 : Address of B
!  gr04 : Address of C
!  gr05 : Index of L
!  gr06 : Loop counter L
!  gr07 : Index of A
!  gr08 : none 
!  gr09 : Loop counter J
!  gr10 : none
!  gr11 : none 
!  gr12 : loop counter K
!  gr13 : base  of B
!  gr14 : index of C
!  gr15
!  gr16
!  gr17
!  gr18
!  gr19
!  gr20
!  gr21
!  gr22
!  gr23
!  gr24
!  gr25 : Base of B
!  gr26 : Base of B
!  gr27 : Base of B
!  gr28 : Base of C
!  gr29 : work
!  gr30 : base of A
!  gr31
!
        seti     2048, gr01               !  
        seti        A, gr02               !  
        seti        B, gr03               !  
        seti        C, gr04 	          !  
        seti        0, gr05               !  
        seti        2, gr06               !  loop counter L
L:      
        seti        0, gr07               !  index of A
        seti     4096, gr09               !  loop counter J
J:
        addl     gr02, gr07, gr31
        addl     gr31, gr05, gr30         !  base of A

        vpt
vwt1:   brcs     es1, vwt1                !  vwt (su and vu)
        vlvl     gr01
        vld      gr30, gr00,vr000,mr000   !  load A(I,J)

        seti     1024, gr12               !  loop counter K
        addl     gr03, gr05, gr13         !  index of B
	seti        0, gr14               !  index of C 

K:
        addl     gr04, gr14, gr29         !
        addl     gr29, gr07, gr28         !  base of C
        ld.d     gr28,    0, fr01         !  load C(K+0,J)        
        ld.d     gr28,    8, fr02         !  load C(K+1,J)
        ld.d     gr28,   16, fr03         !  load C(K+2,J)
        ld.d     gr28,   24, fr04         !  load C(K+3,J)
        addli25  gr13,32768, gr27         !  base of B(I,K+1)
        addli25  gr13,65536, gr26         !  base of B(I,K+2)
        addli25  gr13,98304, gr25         !  base of B(I,K+3)

        vld      gr13, gr00,vr032,mr000   !
        vmsd     fr01,vr032,vr064,mr000   !
        vad     vr000,vr064,vr096,mr000   !
        vld      gr27, gr00,vr128,mr000   !
        vmsd     fr02,vr128,vr160,mr000   !
        vad     vr096,vr160,vr192,mr000   !
        vld      gr26, gr00,vr224,mr000   !
        vmsd     fr03,vr224,vr000,mr000   !
        vad     vr192,vr000,vr032,mr000   !
        vld      gr25, gr00,vr064,mr000   !
        vmsd     fr04,vr064,vr096,mr000   !
        vad     vr032,vr096,vr128,mr000   !

        addli25  gr13,    0 ,gr13         ! increment index of B
        addli25  gr14,   32, gr14         ! increment index of C
        subli5   gr12,    1, gr12         ! decrement Loop count K
        brnc     iccp.z    , K            ! 

        vlvl     gr01        
        vstd    vr128, gr30, gr00,mr000   

	vpt
        addli25  gr07,   0 , gr07         ! increment index of A
vwt2:   brcs     es1, vwt2                !  vwt (su and vu)

        subli5   gr09,    1, gr09         ! decrement loop count J
        brnc     iccp.z     , J           !   

        addli25  gr05,     0, gr05        ! increment index of B
        subli5   gr06,     1, gr06        ! decrement Loop count L
        brnc     iccp.z     , L           !

        brnc     true       , NEND        ! End of job
NEND:   brc     true,_exit

!
!  Data division
!
        .data
A:      .fill   4096,8,0
B:      .fill   4096,8,0
C:      .fill   4066,8,0

             
        


