!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 8.   P.D.E Integration                      
!                                                    
!   General Registar Usage                           
!                                                    
!     gr01 : base or A11                             
!     gr02 : loop counter KX                         
!     gr03 : base of DU1
!     gr04 : base of DU2
!     gr05 : base of DU3
!     gr06 : base of U1 
!     gr07 : base of U2 
!     gr08 : base of U3 
!     gr09 : distance (const)

 
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:

        seti     10000, gr30

loopc:  seti      base, gr01            ! get base address
	seti         2, gr02            ! loop conter KX  
	addli25   gr01,   80, gr03      ! base of DU1     
	addli25   gr01,   88, gr04      ! base of DU2     
	addli25   gr01,   96, gr05      ! base of DU3     
	addli25   gr01,  104, gr06      ! base of U1      
	addli25   gr01,  112, gr07      ! base of U2      
	addli25   gr01,  120, gr08      ! base of U3      
	seti        40, gr09            ! Distance         

	seti        88, gr10            ! (KX,KY+1,1)      
	seti         8, gr11            ! (KX,KY-1,1) or KY

	seti        48, gr12            ! (KX,KY,1)        
	seti       928, gr13            ! (KX,KY,2)        
	addli25   gr13,    8, gr14      ! (KX+1,KY,1)      
	subli25   gr13,    8, gr15      ! (KX-1,KY,1)      


	vpt                                                
VW1:	brcs       es1, VW1                                

loop:   seti       20, gr31             ! Vector Length    
	vlvl     gr31

	addl      gr06, gr10, gr16      ! U1(KX,KY+1,1)
	vld      gr16, gr09,vr000,mr000 
	addl      gr06, gr11, gr17      ! U1(KX,KY-1,1)
	vld      gr17, gr09,vr001,mr000 
	addl      gr07, gr10, gr18      ! U2(KX,KY+1,1)
	vld      gr18, gr09,vr002,mr000 
	addl      gr07, gr11, gr19      ! U2(KX,KY-1,1)
	vld      gr19, gr09,vr003,mr000 
	addl      gr08, gr10, gr20      ! U3(KX,KY+1,1)
	vld      gr20, gr09,vr004,mr000 
	addl      gr08, gr11, gr21      ! U4(KX,KY-1,1)
	vld      gr21, gr09,vr005,mr000 
	vsd     vr000,vr001,vr006,mr000 ! DU1
	vsd     vr002,vr003,vr007,mr000 ! DU2
	vsd     vr004,vr005,vr008,mr000 ! DU3
!
!       U1(KX,KY,2) = U1(KX,KY,1) + A11*DU1(KY) + A12*DU2(KY) + A13*DU1(KY) + 
!                     SIG*(U1(KX+1,KY,1)-2.0*U1(KX,KY,2)+U1(KX-1,KY,1)) 
!
	ld.d     gr01,   72, fr02       ! 2.0d+00
	addl     gr06, gr12, gr25       ! U1(KX,KY,1)
	vld      gr25, gr09,vr009,mr000 !
	vmsd     fr02,vr009,vr010,mr000 !
	addl     gr06, gr14, gr26       ! U1(KX+1,KY,1)
	vld      gr26, gr09,vr011,mr000 !
	vsd     vr011,vr010,vr012,mr000 !
	addl     gr06, gr15, gr27       ! U1(KX-1,KY,1)
	vld      gr27, gr09,vr013,mr000 !
	vad     vr013,vr012,vr014,mr000 !
	ld.d     gr01,   64, fr04       ! SIG 
	vmsd     fr04,vr014,vr015,mr000 ! 
	ld.d     gr01,    0, fr06       ! A11
	vmsd     fr06,vr006,vr016,mr000 !
	ld.d     gr01,    8, fr08       ! A12
	vmsd     fr08,vr007,vr017,mr000 !
	ld.d     gr01,   16, fr10       ! A13
	vmsd     fr10,vr008,vr018,mr000 !
	vad     vr015,vr016,vr019,mr000 !
	vad     vr017,vr018,vr020,mr000 !
	vad     vr020,vr009,vr021,mr000 !
	addl     gr06, gr13, gr28       ! U1(KX,KY,2)
	vstd    vr021, gr28, gr09,mr000 ! 
!
!       U2(KX,KY,2) = U2(KX,KY,1) + A21*DU1(KY) + A22*DU2(KY) + A23*DU2(KY) + 
!                     SIG*(U2(KX+1,KY,1)-2.0*U2(KX,KY,2)+U2(KX-1,KY,1)) 
!
	addl     gr07, gr12, gr25       ! U2(KX,KY,1)
	vld      gr25, gr09,vr022,mr000 !
	vmsd     fr02,vr022,vr023,mr000 !
	addl     gr07, gr14, gr26       ! U2(KX+1,KY,1)
	vld      gr26, gr09,vr024,mr000 !
	vsd     vr023,vr022,vr025,mr000 !
	addl     gr07, gr15, gr27       ! U2(KX-1,KY,1)
	vld      gr27, gr09,vr026,mr000 !
	vad     vr026,vr025,vr027,mr000 !
	vmsd     fr04,vr027,vr028,mr000 ! 
	ld.d     gr01,   24, fr12       ! A21
	vmsd     fr12,vr006,vr029,mr000 !
	ld.d     gr01,   32, fr14       ! A22
	vmsd     fr14,vr007,vr030,mr000 !
	ld.d     gr01,   40, fr16       ! A33
	vmsd     fr16,vr008,vr031,mr000 !
	vad     vr028,vr029,vr032,mr000 !
	vad     vr029,vr030,vr033,mr000 !
	vad     vr033,vr022,vr034,mr000 !
	addl     gr07, gr13, gr28       ! U1(KX,KY,2)
	vstd    vr034, gr28, gr09,mr000 ! 

!
!       U3(KX,KY,2) = U3(KX,KY,1) + A31*DU1(KY) + A32*DU2(KY) + A33*DU3(KY) + 
!                     SIG*(U3(KX+1,KY,1)-2.0*U3(KX,KY,2)+U3(KX-1,KY,1)) 
!
	addl     gr08, gr12, gr25       ! U3(KX,KY,1)
	vld      gr25, gr09,vr035,mr000 !
	vmsd     fr02,vr035,vr036,mr000 !
	addl     gr08, gr14, gr26       ! U3(KX+1,KY,1)
	vld      gr26, gr09,vr037,mr000 !
	vsd     vr037,vr036,vr038,mr000 !
	addl     gr08, gr15, gr27       ! U3(KX-1,KY,1)
	vld      gr27, gr09,vr039,mr000 !
	vad     vr039,vr038,vr040,mr000 !
	vmsd     fr04,vr040,vr041,mr000 ! 
	ld.d     gr01,   48, fr18       ! A31
	vmsd     fr18,vr006,vr042,mr000 !
	ld.d     gr01,   56, fr20       ! A32
	vmsd     fr20,vr007,vr043,mr000 !
	ld.d     gr01,   64, fr22       ! A33
	vmsd     fr22,vr008,vr044,mr000 !
	vad     vr041,vr042,vr045,mr000 !
	vad     vr043,vr044,vr046,mr000 !
	vad     vr046,vr035,vr047,mr000 !
	addl     gr08, gr13, gr28       ! U3(KX,KY,2)
	vstd    vr047, gr28, gr09,mr000 ! 
	
        addli25  gr10,    8, gr10
        addli25  gr11,    8, gr10
        addli25  gr12,    8, gr10
        addli25  gr13,    8, gr10
        addli25  gr14,    8, gr10
        addli25  gr15,    8, gr10
        addli25  gr16,    8, gr10
        addli25  gr17,    8, gr10
        addli25  gr18,    8, gr10
        addli25  gr19,    8, gr10
        addli25  gr20,    8, gr10
        addli25  gr21,    8, gr10

	subli5   gr02,    1, gr02       
	brnc    iccp.z,loop              

        vpt
        subli25  gr30,    1, gr30
        brcs    es1  , .

	brnc    iccp.z,loopc               ! End of Job     
 
NEND:	brc	true,_exit





!       Data Division
!       Simple Var 
	.data      
base:
A11:    .double   1.0e+00 ! 
A12:    .double   1.0e+00 ! 8
A13:    .double   1.0e+00 ! 16
A21:    .double   1.0e+00 ! 24
A22:    .double   1.0e+00 ! 32
A23:    .double   1.0e+00 ! 40
A32:    .double   1.0e+00 ! 48
A33:    .double   1.0e+00 ! 56
SIG:    .double   1.0e+00 ! 64
TWO:    .double   2.0e+00 ! 72
!
!	Arry Var
!
DU1:    .skip     200
DU2:    .skip     200
DU3:    .skip     200
U1:     .skip     1760
U2:     .skip     1760
U3:     .skip     1760



