#define abs(a) ((a) > 0 ? (a) : -(a))

pepa_start__()
{
        pepa_start();
}

pepa_stop__()
{
        pepa_stop();
}

double pow(x, r) double x, r;
{
  double exp(), log();

  return(exp(r * log(x)));
}

double log(x) double x;
{
  int n = 7;
  double ln2 = 0.6931471805599453094172321;
  double a, l;
  int i;

  if (x > 0) {
    l = 0;
    while (x >= 2) {
      x /= 2;
      l += ln2;
    }
    while (x < 1) {
      x *= 2;
      l -= ln2;
    }
    x -= 1;
    a = 0;
    for (i=n; i>=1; i--) {
      a = i * x / (2 + i * x / (2 * i + 1 + a));
    }
    return(l + x / (1 + a));
  }
  else
    return(0);
}

double exp(x) double x;
{
  int n = 22;
  int i, intx;
  double absx, a, e;

  absx = abs(x);
  intx = absx;
  absx -= intx;
  a = absx * absx;
  e = 0;
  i = n;
  do {
    e = a / (i + e);
    i -= 4;
  } while (i != 2);
  e = 1 + 2 * absx / (2 - absx + e);
  a = 2.71828182845904523536;
  while (intx > 0) {
    if (intx & 1)
      e *= a;
    intx /= 2;
    a = a * a;
  }
  if (x >= 0)
    return(e);
  else
    return(1 / e);
}

double sqrt(x) double x;
{
  double lasts, s;

  if (x > 0) {
    s = 1;
    do {
      lasts = s; 
      s = (x / s + s) / 2;
    } while (abs(s - lasts) > 1.0e-6);
    return(s);
  }
  else
    return(0.0);
}

double sin(x) double x;
{
  double halfpi = 1.57079632679489661923;
  int i, k;
  double lasts, s, a;

  k = x / halfpi;
  x -= k * halfpi;
  a = -(x * x);
  if (k & 1) {
    i = 0;
    x = 1;
  }
  else
    i = 1;
  if (k < 0)
    k--;
  if ((k / 2) & 1)
    x = -x;
  s = x;
  do {
    lasts = s;
    i += 2;
    x *= a / ((i - 1) * i);
    s += x;
  } while (s != lasts);
  return(s);
}

double cos(x) double x;
{
  double halfpi = 1.57079632679489661923;
  int i, k;
  double lastc, c, a;

  k = x / halfpi;
  x -= k * halfpi;
  a = -(x * x);
  if (k & 1) {
    i = 1;
    x = -x;
  }
  else {
    i = 0;
    x = 1;
  }
  if (k < 0)
    k--;
  if ((k / 2) & 1)
    x = -x;
  c = x;
  do {
    lastc = c;
    i += 2;
    x *= a / ((i - 1) * i);
    c += x;
  } while (c != lastc);
  return(c);
}

double tan(x) double x;
{
  int n = 15;
  double halfpi = 1.57079632679489661923;
  int i, k;
  double t, x2;

  k = x / halfpi;
  x -= k * halfpi;
  x2 = x * x;
  t = 0;
  i = n;
  do {
    t = x2 / (i - t);
    i -= 2;
  } while (i != 1);
  if (k & 1)
    return((t - 1) / x);
  else
    return(x / (1 - t));
}

double atan(x) double x;
{
  int n = 16;
  double pi = 3.14159265359;
  int i;
  double a, t;

  if (abs(x) <= 1)
    t = x;
  else
    t = 1 / x;
  a = 0;
  for (i=n; i>=1; i--)
    a = (i * i * t * t) / (2 * i + 1 + a);
  if (x > 1)
    return(pi / 2 - t / (1 + a));
  else if (x < -1)
    return(-pi / 2 - t / (1 + a));
  else
    return(t / (1 + a));
}

double floor(x) double x;
{
  int f;

  f = x;
  if (f > x)
    f--;
  return(f);
}

