! SDAR                  = 00000000
! start FSbus adrs      = 0xFCA00000
! MWDR                  = 0x20
! cpu memory adrs       = 0x200100 -- 0x240100 ( 1024*1024/8 byte)

        .set    IPLKIBUSRETA,   0x00400000
        .set    CTLACREGRETA,   0x00400004
        .set    OLDGR2,         0x00400008 
        .set    OLDGR6,         0x0040000c
        .set    OLDGR7,         0x00400010
        .set    IOCCBS,   	0xffff6810 
        .set    IOCCB0,   	0xffff6930 
        .set    IOCCB1,   	0xffff6938 
        .set    IOCCB2,   	0xffff6940 
        .set    IOCCB3,   	0xffff6948 
        .set    IOCCB4,   	0xffff6950 
        .set    IOCCB5,   	0xffff6958 
        .set    ICISTA,   	0xffff6800 
        .set    IOCRB2,   	0xffff6d40 
        .set    IOCRB3,   	0xffff6d48 
	.set	ABSOLUTEBASE,0		! 0 is assumed
	.using	$gr0,ABSOLUTEBASE	! for absolute base
	.text
	.global	_display
	.align  16
_display:
	st	gr2,OLDGR2
	st	gr6,OLDGR6
	st	gr7,OLDGR7
	st	gr3,IPLKIBUSRETA	! save return address
	seti	0xc0000000,gr2
	st.mcr	gr2,ICISTA
	seti	0x52080000,gr2		! command
	st.mcr	gr2,IOCCB0		!
	seti	0x840c0000,gr2		! inst_code (write FSBA)
	st.mcr	gr2,IOCCB2		!
					!
!---------------------------------------!
!  data send ( cpu memory ---> FSbus )  !
!---------------------------------------!
	seti	0xFCA00000,gr16		! FSbus start adrs 
	seti	0x00200100,gr17		! cpu memory data start adrs 
write:
	st.mcr  gr16,IOCCB3             !
	ld	gr17,gr0,gr30		! gr7 = mono_data
	st.mcr  gr30,IOCCB5		!
	call	bdawritefb,gr2		! write FSbus
	addi5	gr16,2,gr16
	st.mcr  gr16,IOCCB3             !
	st.mcr  gr30,IOCCB5		!
	call	bdawritefb,gr2		! write FSbus
	addli5	gr16,2,gr16		! FSbus  adrs inc
	addli5	gr17,4,gr17		! memory adrs inc
	subli25 gr17,0x232100,gr0       ! 0x200100+1280*1280/8=0x232100
	brc	iccp.l,write	

!---------------------------------------!
! write BDA control register 		!
!					!
!   work->		 		!
!     gr2: IOCCB !     gr3: constant	!
!---------------------------------------!
	seti	0x00008702,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0xC0C0C0C0,gr2		!  
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg1,gr2		! write

	seti	0x00008704,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x33333333,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg1,gr2		! write 

	seti	0x00008705,gr2   	!
        st.mcr  gr2,IOCCB3              !
        seti    0x04040404,gr2          !
        st.mcr  gr2,IOCCB5              !
        call    bdactlreg1,gr2          ! write

	seti	0x00008706,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x07070707,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg1,gr2		! write 

	seti	0x00008707,gr2   	!
        st.mcr  gr2,IOCCB3              !
        seti    0x2F2F2F2F,gr2          !
        st.mcr  gr2,IOCCB5              !
        call    bdactlreg1,gr2          ! write

	seti	0x00008708,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x02A002A0,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x0000870a,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x00090009,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x0000870c,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x001F001F,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x0000870e,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x029F029F,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x000087ce,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x02010201,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x00008710,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x00000000,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x00008712,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x00000000,gr2		! real = 00280000 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x00008714,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x00280028,gr2		! real = 0028
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x00008700,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0xE2E2E2E2,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg1,gr2		! write 

	seti	0x000087c8,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x00010001,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x000087ca,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x00000000,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x000087cc,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x00000000,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x000087c0,gr2   	!
	st.mcr  gr2,IOCCB3              !
	seti	0x01000100,gr2		! 
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	seti	0x00008798,gr2   	!
	st.mcr  gr2,IOCCB3              ! level 4 excp by mouse ( reset valid )
	seti	0x00C000C0,gr2		! MSIE,MSIS bit on (p130)
	st.mcr  gr2,IOCCB5		!
	call	bdactlreg,gr2		! write 

	ld	OLDGR2,gr2
	ld	OLDGR6,gr6
	ld	OLDGR7,gr7
	ld	IPLKIBUSRETA,gr3
	jmp 	gr3

!----------------------------------------------------------------------!
! BDA control reg	                                               !
!----------------------------------------------------------------------!
	.align	8
bdactlreg1:
	st	gr2,CTLACREGRETA	! save return address
	ld.mcr	IOCCB2,gr2		! modify IOCCB2
	and	gr2,0x0000fff0,gr2	! FSLN,DMID,MODE copy
	seti	0x84010000,gr3		! BC = 0
	or	gr2,gr3,gr2		! inst_code (write FSbus)
	st.mcr	gr2,IOCCB2		!
	st.mcr	gr0,IOCCBS		! activate command
bdactlreg1loop:				!
	ld.mcr	ICISTA,gr2		! get rppend
	seti	0x40000000,gr3		!
	and	gr2,gr3,gr0		! if rppend == 0 then
	brcs	iccp.z,bdactlreg1loop	!   continue
	seti	0xc0000000,gr2		! reset rpwait,rppend
	st.mcr	gr2,ICISTA		!
	ld	CTLACREGRETA,gr2	! return
	jmp	gr2			!

!----------------------------------------------------------------------!
! BDA control reg                                                      !
!----------------------------------------------------------------------!
        .align  8
bdactlreg:
        st      gr2,CTLACREGRETA        ! save return address
        ld.mcr  IOCCB2,gr2              ! modify IOCCB2
        and     gr2,0x0000fff0,gr2      ! FSLN,DMID,MODE copy
        seti    0x84010001,gr3          ! BC = 1
        or      gr2,gr3,gr2             ! inst_code (write FSbus)
        st.mcr  gr2,IOCCB2              !
	st.mcr	gr0,IOCCBS		! activate command
bdactlregloop:				!
	ld.mcr	ICISTA,gr2		! get rppend
	seti	0x40000000,gr3		!
	and	gr2,gr3,gr0		! if rppend == 0 then
	brcs	iccp.z,bdactlregloop	!   continue
	seti	0xc0000000,gr2		! reset rpwait,rppend
	st.mcr	gr2,ICISTA		!
        ld      CTLACREGRETA,gr2        ! return
        jmp     gr2                     !

!----------------------------------------------------------------------!
! BDA control reg	                                               !
!----------------------------------------------------------------------!
	.align	8
bdawritefb:
	st	gr2,CTLACREGRETA	! save return address
	ld.mcr	IOCCB2,gr2		! modify IOCCB2
	and	gr2,0x0000fff0,gr2	! FSLN,DMID,MODE copy
	seti	0x840d0001,gr3		! BC = 1
	or	gr2,gr3,gr2		! inst_code (write FSbus)
	st.mcr	gr2,IOCCB2		!
	st.mcr	gr0,IOCCBS		! activate command
bdawritefbloop:				!
	ld.mcr	ICISTA,gr2		! get rppend
	seti	0x40000000,gr3		!
	and	gr2,gr3,gr0		! if rppend == 0 then
	brcs	iccp.z,bdawritefbloop	!   continue
	seti	0xc0000000,gr2		! reset rpwait,rppend
	st.mcr	gr2,ICISTA		!
	ld	CTLACREGRETA,gr2	! return
	jmp	gr2			!

