#ident  "@(#)bar.h	1.1 12/16/92 16:57:34 - FUJITSU UXP/VPP"


#ident	"@(#)bar.h	1.2 12/9/92 17:46:52 - FUJITSU UXP/VPP"

/***********************************************/
/*  KAI BPU controller. header                 */
/*  Copyright (c) 1992 by FUJITSU LIMITED      */
/*   Mainframe division                        */
/*   Supercomputer development department      */
/*            Primary writer: H.Ueno           */
/*    ueno@ayame.mfd.cs.fujitsu.co.jp          */
/***********************************************/

#ifndef _IO_DTU_BAR_H
#define _IO_DTU_BAR_H

/*
 *	value for command of px_barcntl
 */
#define	PX_BARSTAT	0
#define	PX_BARSTOP	1

typedef  struct px_barinfo {
	int     bar_migrated;
} px_barinfo_t; 

typedef  uint_t	px_bmask_t;

/*
 *	system calls
 */
#if 0
extern int  px_barctl( int cmd, px_barinfo_t *barinfop,
			caddr_t rmask_area, int byte_len     );
extern int  px_barmask( px_bmask_t *vmask, px_bmask_t *rmask );
extern int  px_barrcov( px_bmask_t *rmask );
#endif

#ifdef _KERNEL

/*
 *	defintion for os
 */
#define	NUM_OF_BSD      2		/* number of BSD per PE */
#define	BMSK0_WORD_LEN	4
#define	BMSK01_WORD_LEN	8

/*
 *	value for barcon
 */
#define	BPU_CONNECT	4     /* or 1 */
#define	BPU_DISCONN	0

/*
 *	value for bmmap
 */
#define	BPU_CON_MAP_0   0
#define	BPU_CON_MAP_1   1
#define	BPU_DEV_MAP_0   0
#define	BPU_DEV_MAP_1   1
#define	BPU_DEV_MAP_2   2
#define	BPU_DEV_MAP_3   3
#define	BPU_DEV_MAP_4   4
#define	BPU_DEV_MAP_5   5
#define	BPU_DEV_MAP_6   6
#define	BPU_DEV_MAP_7   7

#define	BSI_ST_INITIALIZED	0x80000000
#define	BSI_ST_START      	0x00008000
#define	BSI_ST_STOP       	0x00000000
#define	BSI_ST_NULL       	0

typedef struct bar_side_info_s {
    uint_t        status;
    uint_t        barcon ;
    uint_t        bmmap;
    uint_t        bstnl;  
    uint_t        bstnl_other;
    /* other side bstnl for connected mode */
    px_barinfo_t  *barinfo ; 
    caddr_t        rm_area;   /* rmask-area address */
    int            rm_len;    /* rmask-area byte length */
}  bar_side_info_t ; 

#else  /* not _KERNEL */

#include <sys/syskai.h>		/* for API */

#define  px_barctl( cmd, infop, addr, len ) syskai(SKAIBARCTL, cmd, infop, addr, len)
#define  px_barmask( vmask, rmask ) syskai(SKAIBARMASK, vmask, rmask)
#define  px_barrcov( rmask )        syskai(SKAIBARRCOV, rmask)

#endif /* _KERNEL */

#endif /* _IO_DTU_BAR_H */
