#ident  "@(#)dc.c	1.3 1/6/93 16:12:17 - FUJITSU UXP/VPP"

/* #ident "@(#)dc.c	1.16 12/16/92" */

/*  KAI DTP driver                           */
/*  DC Layer [ DTP Control service entries ] */
/*  Copyright (c) 1991 by FUJITSU LIMITED    */
/*   Mainframe division                      */
/*   Supercomputer development department    */
/*            Primary writer: Y.Nakashima    */
/*    nakashim@ayame.mfd.cs.fujitsu.co.jp    */

#include "util/types.h"
#include "util/param.h"
#include "util/sysmacros.h"
#include "util/bootinfo.h"
#include "util/debug.h"
#include "mem/immu.h"
#include "mem/page.h"
#include "mem/kmem.h"
#include "mem/kaidep.h"
#include "proc/proc.h"
#include "util/cmn_err.h"
#include "util/mcr.h"
#include "util/mcr_field.h"
#include "io/dtu/dc.h"			
#include "io/dtu/usr_dtu.h"			
#include "svc/errno.h"			
#include "proc/sched.h"			/*  udtu adds 9/29 1992  */
#include "proc/pms/partition.h"		/*  udtu adds 9/29 1992  */

extern ppageinfo_t *vtop_pagelock();
extern void vtop_pageunlock();

extern void 		lc_rintr();

/* udtu adds following external functions on 1992/9/29 */
extern void             udtu_snd_rupt();
extern void             udtu_rcv_rupt();

STATIC struct mb*	dc_hq_find();
STATIC char*		dc_p_alloc();
STATIC void		dc_p_free();
STATIC struct mb*	dc_mb_alloc();
STATIC void		dc_mb_clear();
STATIC void		dc_mb_free();
STATIC void		dc_mb_enq();
STATIC struct mb*	dc_mb_deq();
STATIC struct dcb* 	dc_dcb_alloc();
STATIC void		dc_dcb_free();
STATIC int		dc_dcb_enq();
STATIC void 		dc_dcb_deq();
STATIC struct tok*	dc_tok_alloc();
STATIC void 		dc_tok_free();
STATIC void		dc_tok_enq();
STATIC void 		dc_tok_deq();
STATIC struct tok*	dc_tok_find();
STATIC void 		dc_hq_setup();
STATIC unsigned		dc_gettod();
STATIC void 		dc_timer();
STATIC void             dc_intr_sndmrp();
STATIC void             dc_intr_sndsrp();
STATIC int              dc_intr_rcvmrp();
STATIC void             dc_intr_rcvsrp();

STATIC struct mb*	mb01f;
STATIC struct mb*	mb32f;
STATIC struct mb*	mb01fbot;
STATIC struct mb*	mb32fbot;
STATIC struct dcb*	dcbf;
STATIC struct tok*	tokf;
STATIC struct dcb  	dcbq;
STATIC struct tok  	tokq;
STATIC int		cdcbid;
STATIC int		ctokid;
       struct hqa*	hqa;
STATIC struct mb*	hq[2];
STATIC unsigned	        hqwp[2];
STATIC struct mb*       rb[2];
STATIC struct mb        rbq[TOTSEL];
STATIC int*             rbs01max;
STATIC int*             rbs32max;
STATIC int*             rbf01max;
STATIC int*             rbf32max;
STATIC int              rbr01max;
STATIC int              rbr32max;
STATIC int		mbs01add;
STATIC int		mbs32add;
STATIC int              rbr01cta;
STATIC int              rbr32cta;
STATIC int		rbs01maxsa[] =
			{  1,  0,  0,  3,  1,128,128,  0,  1, 10,  0,128,  0,  2,  0,  1,
			 128,  0,  0,  0,  0,  0,  0,  0,128,  0,  2,  0,  0,  0,  2,  1};
STATIC int		rbs32maxsa[] =
			{  1,  0,  0,  0,  1,128,128,  0,  1,  1,128,  1,  0,  2,  0,  0,
			 128,  0,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1};
STATIC int		rbf01maxsa[] =
			{  1,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
			   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};
STATIC int		rbf32maxsa[] =
			{  1,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
			   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};
STATIC int		rbr01maxsa   = 128;
STATIC int		rbr32maxsa   = 128;
STATIC int		mbs01addsa   = 128;
STATIC int		mbs32addsa   = 128;
STATIC int		rbs01maxpe[] =
			{  1,  0,  0,  3,  1,  4,  0, 12,  1, 10,  0,128,128, 16,  0,128,
			  64,  0,  0,  0,  0,  0,  0,  0,  4,  0,  2,  0,  0,  0,  2,  1};
STATIC int		rbs32maxpe[] =
			{  1,  0,  0,  0,  1,  0,  0, 12,  1,  1,  1,  1,  0,  2,  0,  0,
			   2,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1};
STATIC int		rbf01maxpe[] =
			{  1,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
			   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};
STATIC int		rbf32maxpe[] =
			{  1,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
			   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};
STATIC int		rbr01maxpe   = 16;
STATIC int		rbr32maxpe   = 16;
STATIC int		mbs01addpe   = 16;
STATIC int		mbs32addpe   = 16;
STATIC void 		(*intrfunc[TOTSEL])();
STATIC char		dc_lock_msg[TOTPE][TOTSEL];
STATIC char		dc_lock_fun[TOTPE][TOTSEL];
STATIC char		dc_lock_ldt[TOTPE];
STATIC char		dc_lock_rpl[TOTPE];
STATIC short		dc_seqn_msg[TOTPE][TOTSEL];
STATIC short		dc_seqn_fun[TOTPE][TOTSEL];
STATIC short		dc_seqn_ldt[TOTPE];
STATIC short		dc_seqn_rpl[TOTPE];
STATIC int 		dc_memwait;
STATIC int 		dc_retrycount;
STATIC int 		dc_failcount;
STATIC int 		dc_mb01pcount;
STATIC int 		dc_mb01bcount;
STATIC int 		dc_mb32pcount;
STATIC int 		dc_mb32bcount;
STATIC int 		dc_ldtpcount;
STATIC int 		dc_ldtbcount;
       short            dc_n2p[TOTPE];
       short            dc_p2n[TOTPE];
STATIC unsigned		last_fault_flag;
STATIC unsigned		last_fault_time;

/* udtu adds following variables on 1992/3/18 */
STATIC int              snd_stop_semafo;
STATIC boolean_t        snd_stop_flag;
STATIC int              rcv_stop_semafo;
STATIC boolean_t        rcv_stop_flag;
#ifdef SLOW
       int		dtu_ss = 1;	/* dtu_subset version = 1 */
#else
       int		dtu_ss = 0;	/* dtu_subset version = 0 */
#endif	

int    dc_repflg = 0;	/* dtu error report flag : default off */

void
dc_init()
{
  struct dcb* tdcb;
  struct tok* ttok;
  int i, totmb01, totmb32;

  rbs01max  = IS_SA() ? rbs01maxsa  : rbs01maxpe;
  rbs32max  = IS_SA() ? rbs32maxsa  : rbs32maxpe;
  rbf01max  = IS_SA() ? rbf01maxsa  : rbf01maxpe;
  rbf32max  = IS_SA() ? rbf32maxsa  : rbf32maxpe;
  rbr01max  = IS_SA() ? rbr01maxsa  : rbr01maxpe;
  rbr32max  = IS_SA() ? rbr32maxsa  : rbr32maxpe;
  mbs01add  = IS_SA() ? mbs01addsa  : mbs01addpe;
  mbs32add  = IS_SA() ? mbs32addsa  : mbs32addpe;
  
  for (totmb01=rbr01max+mbs01add, i=0; i<TOTSEL; i++)
      totmb01 += rbs01max[i] + rbf01max[i];
  for (totmb32=rbr32max+mbs32add, i=0; i<TOTSEL; i++)
      totmb32 += rbs32max[i] + rbf32max[i];

  mb01f  = (struct mb*)  dc_p_alloc((HEDRSIZE+MB01SIZE)*totmb01);
  mb32f  = (struct mb*)  dc_p_alloc((HEDRSIZE+MB32SIZE)*totmb32);
  dcbf   = (struct dcb*) dc_p_alloc(sizeof(struct dcb)*TOTDCB);
  tokf   = (struct tok*) dc_p_alloc(sizeof(struct tok)*TOTTOK);
  hqa    = (struct hqa*) dc_p_alloc(sizeof(struct hqa));
  hq[0]  = (struct mb*)  dc_p_alloc(HEDRSIZE*HQNUM);
  hq[1]  = (struct mb*)  dc_p_alloc(HEDRSIZE*HQNUM);

  bzero(mb01f,(HEDRSIZE+MB01SIZE)*totmb01);
  bzero(mb32f,(HEDRSIZE+MB32SIZE)*totmb32);
  bzero(dcbf,  sizeof(struct dcb)*TOTDCB);
  bzero(tokf,  sizeof(struct tok)*TOTTOK);
  bzero(hqa,   sizeof(struct hqa));
  bzero(hq[0], HEDRSIZE*HQNUM);
  bzero(hq[1], HEDRSIZE*HQNUM);

  for (mb01fbot=mb01f,i=0; mb01fbot->size=MB01SIZE,i<totmb01-1; i++)
    mb01fbot = mb01fbot->llink = (struct mb*)((char*)mb01fbot+HEDRSIZE+MB01SIZE);
  for (mb32fbot=mb32f,i=0; mb32fbot->size=MB32SIZE,i<totmb32-1; i++)
    mb32fbot = mb32fbot->llink = (struct mb*)((char*)mb32fbot+HEDRSIZE+MB32SIZE);
  for (tdcb=dcbf,i=0; i<TOTDCB-1; i++)
    tdcb = tdcb->llink = tdcb+1;
  for (ttok=tokf,i=0; i<TOTTOK-1; i++)
    ttok = ttok->llink = ttok+1;
  dcbq.llink = dcbq.rlink = &dcbq;
  tokq.llink = tokq.rlink = &tokq;
  hqa->sltqt = kvtophys(hq[0]);
  hqa->shtqt = kvtophys(hq[1]);
  for (i=0; i<TOTSEL; i++)
    rbq[i].llink = rbq[i].rlink = &rbq[i];
  intrfunc[0] = lc_rintr;
  for (i=1; i<TOTSEL; i++)
    intrfunc[i] = NULL;
  for (i=0; i<TOTPE; i++) {
    dc_n2p[i] = dc_p2n[i] = DC_CC_RPDOWN;
#ifdef DEBUG
    if( i == MASTER_NETPA() || i == MY_NETPA() )
        dc_n2p[i] = dc_p2n[i] = i;
#endif
  }
    
  lc_init();

#ifdef __uxpx__
  global_init();
#else
  mcr_store(MCR_MTC,    0x000d0001); /* PS=13, DNUPRO=1 */
#endif
    
  mcr_store(MCR_RTOPW,  0x02000000); /* 2 sec.   */
  mcr_store(MCR_HRSHTW, 0x00000000); /* SDVSHT=0 */
  mcr_store(MCR_HRSLTW, 0x00000000); /* SDVSLT=0 */
  mcr_store(MCR_HWSHTW, 0x00000000); /* HQWSHT=0 */
  mcr_store(MCR_HWSLTW, 0x00000000); /* HQWSLT=0 */
  mcr_store(MCR_HQALAW, kvtophys(hqa)); /* HQALA=real(hqa) */
  mcr_store(MCR_HQSZ,   0x03000000); /* SHQS/U0HQS/U1HQS=2048/256/256 */
  mcr_store(MCR_HRSHTW, 0x00010000); /* SDVSHT=1 */
  mcr_store(MCR_HRSLTW, 0x00010000); /* SDVSLT=1 */
  mcr_store(MCR_RBAR0,  kvtophys(rb[0]=dc_mb_alloc(MB32SIZE, 0, 0))|1); /* RBAR0, RB0VL=1 */
  mcr_store(MCR_RBAR1,  kvtophys(rb[1]=dc_mb_alloc(MB32SIZE, 0, 0))|1); /* RBAR1, RB1VL=1 */

  /* udtu adds on 1992/9/29: initialise dtu_stop_variables */
  snd_stop_semafo = rcv_stop_semafo = 0;
  snd_stop_flag = rcv_stop_flag = B_FALSE;
  /* end of added part */

  timeout(dc_timer, NULL, TIMER_INTERVAL);
}

#ifdef DEBUG

int
dc_rp_ctl( p )
dc_rpctl_t *p;
{
    int errflg=0;

    int spl,rc,outlen;
    short dp;
    spl = splhi();
        switch (p->cmd) {
        case DC_RPUP:
                dc_rp_up( p->rp, p->pp );
                rc = 0;
                break;
        case DC_RPDOWN:
                dc_rp_down( p->rp );
                rc = 0;
                break;
        case DC_REPON:	/* report ON */
		dc_repflg = 1;
                rc = 0;
                break;
        case DC_REPOFF:	/* report OFF */
		dc_repflg = 0;
                rc = 0;
                break;
        case DC_REPMCR:	/* display MCRs */
		rc = oc_repmcr( (int*)(p->rp), p->pp );
                break;
        case DC_REPN2P:	/* display n2p */
		if((p->rp==NULL)||(p->pp<0)||(p->pp==0)) return(EFAULT);
		outlen= p->pp > sizeof(dc_n2p) ? p->pp : sizeof(dc_n2p);
		if(copyout( &dc_n2p[0], p->rp, outlen )) return(EFAULT);
                rc = 0;
                break;
        case DC_REPP2N:	/* display p2n */
		if((p->rp==NULL)||(p->pp<0)||(p->pp==0)) return(EFAULT);
		outlen= p->pp > sizeof(dc_p2n) ? p->pp : sizeof(dc_p2n);
		if(copyout( &dc_p2n[0], p->rp, outlen )) return(EFAULT);
                rc = 0;
                break;
        default:
                errflg=1;
                break;
        }
    splx(spl);
        if(errflg) return(EINVAL);
        return(rc);
}

dc_rp_up( rp, pp )
int rp;
int pp;
{
    if( (rp< 0)||(rp==TOTPE)||(rp>TOTPE) ) return( EINVAL );
    dc_n2p[rp] = pp;
    dc_p2n[pp] = rp;
}

dc_rp_down( rp )
int rp;
{
    int pp;
    if( (pp< 0)||(pp==TOTPE)||(pp>TOTPE) ) return( EINVAL );
    if( (pp = dc_n2p[rp]) < 0 ) return( EINVAL );
    dc_n2p[rp] = DC_CC_RPDOWN;
    dc_p2n[pp] = DC_CC_RPDOWN;
}

#endif /* DEBUG */

STATIC
struct mb*
dc_hq_find(cmd, prior)
  unsigned cmd;
  unsigned prior;
{
  union mcr_form hrstw;

#ifdef DEBUG
  dtrace("hq_find","prior",prior,0);
#endif
  mcr_load(prior ? MCR_HRSHTW : MCR_HRSLTW, hrstw);
  if ((hrstw.hrshtw.hqrsht-hqwp[prior]-1)&(HQNUM-1) < (cmd == DC_CMD_ACK ? 1 : HQNUM/2))
    return(NULL);
#ifdef DEBUG
  dtrace("hq_find","ok",0,0);
#endif
  return((struct mb*)((char*)hq[prior]+hqwp[prior]*HEDRSIZE));
}

STATIC
char *
dc_p_alloc(size)
  unsigned  size;
{
  page_t *pp, *pp1;

  size = ((size-1)|(PAGESIZE-1))+1;
  if ((pp = page_get(size,P_NOSLEEP|P_PHYSCONTIG)) == 0) {
    cmn_err(CE_WARN, "dc_palloc: no more page.");
    return 0;
  }
  pp1 = pp;
  do {
    pp1->p_type = P_SYS_PAGE;
    pp1 = pp1->p_next;
  } while (pp1 != pp);
  return ((char *)pfntokv(page_pptonum(pp)));
}

STATIC
void 
dc_p_free(addr)
  char*  addr;
{
  page_t *pp, *pp1;
  
  if (!addr)
    return;
  pp = page_numtopp(kvtopfn(addr));
  do {
    pp1 = pp;
    pp1->p_keepcnt = 0;
    pp1->p_type = P_UNIX_PAGE;
    page_sub(&pp, pp1);
    page_free(pp1,1);
  } while (pp != NULL);
  return;
}

STATIC
struct mb*
dc_mb_alloc(size, mode, sel)
  unsigned   size;
  unsigned   mode; /* 0:none,1:SND,2:FUN,3:RPL */
  unsigned   sel;
{
  struct mb* tmb;
  
#ifdef DEBUG
	dtrace("mb_alloc","sel",sel,0);
#endif
  if (sel >= TOTSEL)
    return(NULL);
  if (size <= MB01SIZE) {
    switch (mode) {
    case 0:
      break;
    case 1:
      if (rbq[sel].srceln > rbs01max[sel])
        return(NULL);
      break;
    case 2:
      if (rbq[sel].dsteln > rbf01max[sel])
        return(NULL);
      break;
    case 3:
      if (rbr01cta > rbr01max)
        return(NULL);
      break;
    default:
      return(NULL);
      /* break; *//* NOTREACHED */
    }
    if (mb01f == NULL)
      return(NULL);
    mb01f = (tmb = mb01f)->llink;
    switch (mode) {
    case 1:
      rbq[sel].srceln++;
      break;
    case 2:
      rbq[sel].dsteln++;
      break;
    case 3:
      rbr01cta++;
      break;
    }
  }
  else {
    switch (mode) {
    case 0:
      break;
    case 1:
      if (rbq[sel].srccta > rbs32max[sel])
        return(NULL);
      break;
    case 2:
      if (rbq[sel].dstcta > rbf32max[sel])
        return(NULL);
      break;
    case 3:
      if (rbr32cta > rbr32max)
        return(NULL);
      break;
    default:
      return(NULL);
      /* break; *//* NOTREACHED */
    }
    if (mb32f == NULL)
      return(NULL);
    mb32f = (tmb = mb32f)->llink;
    switch (mode) {
    case 1:
      rbq[sel].srccta++;
      break;
    case 2:
      rbq[sel].dstcta++;
      break;
    case 3:
      rbr32cta++;
      break;
    }
  }
#ifdef DEBUG
	dtrace("mb_alloc","ok",tmb,0);
#endif
  return(tmb);
}

STATIC
void
dc_mb_clear(mb)
  struct mb* mb;
{
  struct mb* tmb;

#ifdef DEBUG
	dtrace("mb_clear","mb",mb,0);
#endif
  if (!mb)
    return;
  if (mb->size == MB01SIZE) {
    bzero(mb, HEDRSIZE+MB01SIZE);
    mb->size = MB01SIZE;
  }
  else {
    bzero(mb, HEDRSIZE+MB32SIZE);
    mb->size = MB32SIZE;
  }
}

STATIC
void
dc_mb_free(mb, mode)
  struct mb* mb;
  unsigned   mode; /* 0:none,1:SND,2:FUN,3:RPL */
{
  struct mb* tmb;

#ifdef DEBUG
	dtrace("mb_free","mb",mb,0);
#endif
  if (!mb)
    return;
  if (mb->size == MB01SIZE) {
    switch (mode) {
    case 1:
      rbq[mb->sel].srceln--;
      break;
    case 2:
      rbq[mb->sel].dsteln--;
      break;
    case 3:
      rbr01cta--;
      break;
    }
    mb->llink = NULL;
    if (mb01f == NULL) {
      mb01f    = mb;
      mb01fbot = mb;
    }
    else {
      mb01fbot->llink = mb;
      mb01fbot = mb;
    }
#ifdef DEBUG
	dtrace("mb_free","01ok",0,0);
#endif
  }
  else {
    switch (mode) {
    case 1:
      rbq[mb->sel].srccta--;
      break;
    case 2:
      rbq[mb->sel].dstcta--;
      break;
    case 3:
      rbr32cta--;
      break;
    }
    mb->llink = NULL;
    if (mb32f == NULL) {
      mb32f    = mb;
      mb32fbot = mb;
    }
    else {
      mb32fbot->llink = mb;
      mb32fbot = mb;
    }
#ifdef DEBUG
	dtrace("mb_free","32ok",0,0);
#endif
  }
}

STATIC
void
dc_mb_enq(mb, sel)
  struct mb* mb;
  unsigned   sel;
{
#ifdef DEBUG
	dtrace("mb_enq","sel",sel,0);
#endif
  if (!mb || sel >= TOTSEL)
    return;
  mb->llink = &rbq[sel];
  mb->rlink = rbq[sel].rlink;
  rbq[sel].rlink->llink = mb;
  rbq[sel].rlink = mb;
#ifdef DEBUG
	dtrace("mb_enq","wakeup",&rbq[sel],0);
#endif
  wakeup(&rbq[sel]);
}

STATIC
struct mb*
dc_mb_deq(sel)
  unsigned   sel;
{
  struct mb* tmb;

#ifdef DEBUG
	dtrace("mb_deq","sel",sel,0);
#endif
  if (sel >= TOTSEL || rbq[sel].llink == &rbq[sel])
    return(NULL);
  tmb = rbq[sel].llink;
  tmb->llink->rlink = tmb->rlink;
  tmb->rlink->llink = tmb->llink;
#ifdef DEBUG
	dtrace("mb_deq","ok",tmb,0);
#endif
  return(tmb);
}

STATIC
struct dcb*
dc_dcb_alloc()
{
  struct dcb* tdcb;

#ifdef DEBUG
	dtrace("dcb_alloc","enter",0,0);
#endif
  if (dcbf == NULL)
    return(NULL);
  dcbf = (tdcb = dcbf)->llink;
  tdcb->flag = 0;
#ifdef DEBUG
	dtrace("dcb_alloc","ok",tdcb,0);
#endif
  return(tdcb);
}

STATIC
void
dc_dcb_free(dcb)
  struct dcb* dcb;
{
  struct dcb* tdcb;

#ifdef DEBUG
	dtrace("dcb_free","enter",dcb,0);
#endif
  if (!dcb)
    return;
  dcb->llink = dcbf;
  dcb->dcbid = 0;
  dcbf = dcb;
#ifdef DEBUG
	dtrace("dcb_free","ok",0,0);
#endif
}

STATIC
int
dc_dcb_enq(dcb, dcbid, t_pe)
  struct dcb* dcb;
  int dcbid;
  px_peid_t   t_pe; /* Physical PE */
{
  struct dcb* tdcb;

#ifdef DEBUG
	dtrace("dcb_enq","dcb",dcb,0);
#endif
  if (!dcb)
    return;
  if (dcbid)
    dcb->dcbid = dcbid;
  else {
    do {
      if (!(++cdcbid & DCBIDMASK)) 
        cdcbid = 1;
      for (tdcb = dcbq.llink; tdcb != &dcbq; tdcb = tdcb->llink) {
	if (tdcb->dcbid == cdcbid)
	  break;
      }
    } while (tdcb->dcbid == cdcbid);
    dcb->dcbid = cdcbid;
  }
  dcb->llink  = &dcbq;
  dcb->rlink  = dcbq.rlink;
  dcbq.rlink->llink = dcb;
  dcbq.rlink  = dcb;
  dcb->status = DC_STATUS_ACKWAIT;	/* modified later */
  dcb->cc     = DC_CC_NORMALEND;	/* modified later */
  dcb->dstnpa = t_pe;
#ifdef DEBUG
	dtrace("dcb_enq","ok",0,0);
#endif
  return(dcb->dcbid);
}

STATIC
void
dc_dcb_deq(dcb)
  struct dcb* dcb;
{
#ifdef DEBUG
	dtrace("dcb_deq","dcb",dcb,0);
#endif
  if (!dcb)
    return;
  dcb->rlink->llink = dcb->llink;
  dcb->llink->rlink = dcb->rlink;
  dcb->dcbid = 0;
#ifdef DEBUG
	dtrace("dcb_deq","ok",0,0);
#endif
}

STATIC
struct tok*
dc_tok_alloc()
{
  struct tok* ttok;

#ifdef DEBUG
	dtrace("tok_alloc","enter",0,0);
#endif
  if (tokf == NULL)
    return(NULL);
  tokf = (ttok = tokf)->llink;
  ttok->flag = 0;
#ifdef DEBUG
	dtrace("tok_alloc","ok",ttok,0);
#endif
  return(ttok);
}

STATIC
void
dc_tok_free(tok)
  struct tok* tok;
{
  struct tok* ttok;

#ifdef DEBUG
	dtrace("tok_free","tok",tok,0);
#endif
  if (!tok)
    return;
  tok->llink = tokf;
  tok->tokid = 0;
  tokf = tok;
#ifdef DEBUG
	dtrace("tok_free","ok",0,0);
#endif
}

STATIC
void
dc_tok_enq(tok, t_pe)
  struct tok* tok;
  px_peid_t   t_pe; /* Physical PE */
{
  struct tok* ttok;

#ifdef DEBUG
	dtrace("tok_enq","tok",tok,0);
#endif
  if (!tok)
    return;
  do {
    if (!(++ctokid & TOKIDMASK)) 
      ctokid = 1;
    for (ttok = tokq.llink; ttok != &tokq; ttok = ttok->llink) {
      if (ttok->tokid == ctokid)
        break;
    }
  } while (ttok->tokid == ctokid);
  tok->llink  = &tokq;
  tok->rlink  = tokq.rlink;
  tokq.rlink->llink = tok;
  tokq.rlink  = tok;
  tok->tokid  = ctokid;
  tok->status = DC_STATUS_RPLWAIT;	/* modified later */
  tok->cc     = DC_CC_NORMALEND;	/* modified later */
  tok->dstnpa = t_pe;
  tok->mb     = NULL;			/* modified later */
#ifdef DEBUG
	dtrace("tok_enq","ok",0,0);
#endif
}

STATIC
void
dc_tok_deq(tok)
  struct tok* tok;
{
#ifdef DEBUG
	dtrace("tok_deq","tok",tok,0);
#endif
  if (!tok)
    return;
  tok->rlink->llink = tok->llink;
  tok->llink->rlink = tok->rlink;
  tok->tokid = 0;
#ifdef DEBUG
	dtrace("tok_deq","ok",0,0);
#endif
}

STATIC
struct tok *
dc_tok_find(tokid)
  int         tokid;
{
  struct tok* ttok;

#ifdef DEBUG
	dtrace("tok_find","tokid",tokid,0);
#endif
  for (ttok = tokq.llink; ttok != &tokq; ttok = ttok->llink) {
    if (ttok->tokid == tokid)
      return(ttok);
  }
#ifdef DEBUG
	dtrace("tok_find","fail",0,0);
#endif
  return(NULL);
}

STATIC
void
dc_hq_setup(hq, mb, dcb, dcbid, tok, tokid, cc, t_pe, cmd, prior, mode, sel, src, len, dst, key, param)
  struct mb*  hq;
  struct mb*  mb;
  struct dcb* dcb;
  int         dcbid;
  struct tok* tok;
  int         tokid;
  unsigned    cc;
  px_peid_t   t_pe;
  unsigned    cmd;
  unsigned    prior;
  unsigned    mode;
  unsigned    sel;
  unsigned    src;
  unsigned    len;
  unsigned    dst;
  unsigned    key;
  unsigned*   param;
{
  *((unsigned*)hq+0) = 0;
  *((unsigned*)hq+2) = 0;
  *((unsigned*)hq+3) = 0;
  *((unsigned*)hq+5) = 0;

  switch (mode) {
  case DC_MODE_NLDT:
  case DC_MODE_ALDT:
    switch (sel) {
    case DC_SEL_REAL:
      *((unsigned*)hq+4) = 0x01c00000;
      break;
    case DC_SEL_LOCAL0:
      *((unsigned*)hq+4) = 0x01c04000;
      break;
    case DC_SEL_LOCAL1:
      *((unsigned*)hq+4) = 0x01c04001;
      break;
    case DC_SEL_GLOBAL0:
      *((unsigned*)hq+4) = 0x01c05000;
      break;
    case DC_SEL_GLOBAL1:
      *((unsigned*)hq+4) = 0x01c05001;
      break;
    }
  default:
    *((unsigned*)hq+4) = 0x01c00000;
    break;
  }

  hq->dstnpa = t_pe;
  hq->elnum  = (mode & DM_MOD) || (mode & DM_MSG) ? (len-1|7)+1>>3 : (len-1|3)+1>>2;
  hq->rbbsf  = (mode & DM_MSG) ? 1 : 0;
  hq->type   = (mode & DM_MOD) || (mode & DM_MSG);
  hq->srcpci = (cmd != DC_CMD_ACK);
  hq->dstpci = (cmd == DC_CMD_ACK) || (mode && mode != DC_MODE_PUSH);
  hq->ipl    = (mode == DC_MODE_NIPL) ? 1 : 0;
  hq->srcbad = (mode & DM_MSG && mode != DC_MODE_PUSH) ? kvtophys(mb->msg) : src;
  hq->dstbad = (mode & DM_MSG) ? NULL : dst;
  hq->srcad1 = (mode & DM_MOD) || (mode & DM_MSG) ? 8 : 4;
  hq->dstad1 = (mode & DM_MOD) || (mode & DM_MSG) ? 8 : 4;

  hq->llink  = mb;
  hq->rlink  = NULL;
  hq->dcb    = dcb;
  hq->dcbid  = dcbid;
  hq->tok    = tok;
  hq->tokid  = tokid;
  hq->status = DC_STATUS_PCIWAIT;
  hq->cc     = cc;
  hq->cmd    = cmd;
  hq->prior  = prior;
  hq->mode   = mode;
  hq->sel    = sel;
  hq->size   = mb ? mb->size : 0;
  hq->len    = len;
  hq->key    = key;
  if (mode & DM_MSG && mode != DC_MODE_PUSH && param) {
    hq->param[0] = *(param  );
    hq->param[1] = *(param+1);
    hq->param[2] = *(param+2);
    hq->param[3] = *(param+3);
  }
  else {
    hq->param[0] = 0;
    hq->param[1] = 0;
    hq->param[2] = 0;
    hq->param[3] = 0;
  }

  hqwp[prior] = (hqwp[prior]+1)&(HQNUM-1);
  mcr_store(prior ? MCR_HWSHTW : MCR_HWSLTW, hqwp[prior]);
}

STATIC
unsigned
dc_gettod()
{
  asm("movtg %gr16");
}

STATIC
void
dc_timer()
{
  struct mb* tmb;
  struct mb* stb;
  struct mb* trb;
  struct statistics* tstat;
  struct dcb* tdcb;
  struct tok* ttok;
  unsigned limit;
  int spl, i;

  limit = dc_gettod()-DC_TIMEOUT;        /* seconds (not punctual) */
  spl = splhi();
  for (tdcb = dcbq.llink; tdcb != &dcbq; tdcb = tdcb->llink) {
    if (tdcb->status == DC_STATUS_ACKWAIT && tdcb->tod < limit) {
      tdcb->status = DC_STATUS_ACKDONE;
      tdcb->cc = DC_CC_ECOMM;
      dc_dcb_deq(tdcb);
      wakeup(tdcb);
    }
    else
      break;
  }

#ifdef DEBUG
  if (stb = dc_mb_alloc(MB01SIZE, 1, 0)) {
    tstat = (struct statistics*)(stb->msg);
    tstat->retrycount = dc_retrycount;
    tstat->failcount  = dc_failcount;
    tstat->mb01pcount = dc_mb01pcount; dc_mb01pcount = 0;
    tstat->mb01bcount = dc_mb01bcount; dc_mb01bcount = 0;
    tstat->mb32pcount = dc_mb32pcount; dc_mb32pcount = 0;
    tstat->mb32bcount = dc_mb32bcount; dc_mb32bcount = 0;
    tstat->ldtpcount  = dc_ldtpcount;  dc_ldtpcount  = 0;
    tstat->ldtbcount  = dc_ldtbcount;  dc_ldtbcount  = 0;

    tstat->mb01f_enum = 0;
    tstat->mb32f_enum = 0;
    tstat->dcbf_enum  = 0;
    tstat->tokf_enum  = 0;
    tstat->dcbq_enum  = 0;
    tstat->tokq_enum  = 0;
    for (i=0; i<TOTSEL; i++)
    tstat->rbq_enum[i] = 0;

    for (tmb=mb01f; tmb; tmb=tmb->llink) tstat->mb01f_enum++;
    for (tmb=mb32f; tmb; tmb=tmb->llink) tstat->mb32f_enum++;
    for (tdcb=dcbf; tdcb; tdcb=tdcb->llink) tstat->dcbf_enum++;
    for (ttok=tokf; ttok; ttok=ttok->llink) tstat->tokf_enum++;
    for (tdcb=dcbq.llink; tdcb!=&dcbq; tdcb=tdcb->llink) tstat->dcbq_enum++;
    for (ttok=tokq.llink; ttok!=&tokq; ttok=ttok->llink) tstat->tokq_enum++;
    for (i=0; i<TOTSEL; i++)
    for (trb=rbq[i].llink; trb!=&rbq[i]; trb=trb->llink) tstat->rbq_enum[i]++;
    stb->status = DC_STATUS_MONITOR;
    stb->cc     = DC_CC_NORMALEND;
    stb->cmd    = DC_CMD_SND;
    stb->mode   = DC_MODE_NMSG;
    stb->sel    = 0;
    stb->len    = 0x111;
    dc_mb_enq(stb, 0);
  }
#endif

  splx(spl);
  wakeup(&dc_memwait);
  timeout(dc_timer, NULL, TIMER_INTERVAL);
}

dc_forcedown(t_pe)
  px_peid_t   t_pe; /* Physical PE */
{
  struct dcb* tdcb;
  struct tok* ttok;
  int spl, i;

  spl = splhi();
  for (tdcb = dcbq.llink; tdcb != &dcbq; tdcb = tdcb->llink) {
    if (tdcb->status == DC_STATUS_ACKWAIT) {
      if (tdcb->dstnpa == t_pe)
        tdcb->flag = 1;
    }
    else
      break;
  }
  for (ttok = tokq.llink; ttok != &tokq; ttok = ttok->llink) {
    if (ttok->status == DC_STATUS_ACKWAIT) {
      if (ttok->dstnpa == t_pe) {
        ttok->status = DC_STATUS_RPLDONE;
        ttok->cc     = DC_CC_FORCEDOWN;
        ttok->flag = 1;
        wakeup(ttok);
      }
    }
    else
      break;
  }
  splx(spl);
}

dc_sync(t_pe, mode)
  px_peid_t   t_pe; /* Real PE */
  unsigned    mode;
{
  if (t_pe >= TOTPE)
    return(DC_CC_RPDOWN);
  if (dc_n2p[t_pe] < 0)
    return(dc_n2p[t_pe]);
  return(dc_ppsync(dc_n2p[t_pe], mode));
}

dc_ppsync(t_pe, mode)
  px_peid_t   t_pe; /* Physical PE */
  unsigned    mode;
{
  struct mb* tmb;
  struct mb* trb;
  struct dcb* tdcb;
  struct tok* ttok;
  int spl, i, any_wait, retry;

  if (t_pe >= TOTPE)
    return(DC_CC_EINVAL);
  switch (mode) {
  case DC_MODE_WAIT:
  case DC_MODE_NOWAIT:
    break;
  default:
    return(DC_CC_EINVAL);
  }

  spl = splhi();

dc_ppsyncloop:
  any_wait = 0;
  for (tdcb = dcbq.llink; tdcb != &dcbq; tdcb = tdcb->llink) {
    if (tdcb->dstnpa == t_pe && tdcb->status == DC_STATUS_ACKWAIT) {
      if (mode == DC_MODE_WAIT)
	any_wait++;
      else {
	tdcb->status = DC_STATUS_ACKDONE;
	tdcb->cc = DC_CC_ECOMM;
	dc_dcb_deq(tdcb);
	wakeup(tdcb);
      }
    }
  }
  if (any_wait) {
    if (RETRY_INTERVAL*retry++ < DC_TIMEOUT*2) {
      delay(RETRY_INTERVAL);
      goto dc_ppsyncloop;
    }
    else {
      mode = DC_MODE_NOWAIT;
      goto dc_ppsyncloop;
    }
  }

  splx(spl);
  wakeup(&dc_memwait);
  return(DC_CC_NORMALEND);
}

dc_send(t_pe, prior, mode, sel, src, len, dst, key, param)
  px_peid_t   t_pe; /* Real PE */
  unsigned    prior;
  unsigned    mode;
  unsigned    sel;
  char*       src;
  unsigned    len;
  char*       dst;
  char*       key;
  unsigned*   param;
{
#ifdef DEBUG
	dtrace("dc_send","RP",t_pe,0);
#endif
  if (t_pe >= TOTPE)
    return(DC_CC_RPDOWN);
  if (dc_n2p[t_pe] < 0)
    return(dc_n2p[t_pe]);
  return(dc_ppsend(dc_n2p[t_pe], prior, mode, sel, src, len, dst, key, param));
}

dc_ppsend(t_pe, prior, mode, sel, src, len, dst, key, param)
  px_peid_t   t_pe; /* Physical PE */
  unsigned    prior;
  unsigned    mode;
  unsigned    sel;
  char*       src;
  unsigned    len;
  char*       dst;
  char*       key;
  unsigned*   param;
{
  struct mb*   thq  = NULL;
  struct mb*   tmb  = NULL;
  struct dcb*  tdcb = NULL;
  struct tok*  ttok = NULL;
  int	       spl, cc, flag, dcbid = 0;
  int          pcatch, retry_edtudmg = 0, retry_ecomm = 0;

#ifdef DEBUG
	dtrace("ppsend","PP",t_pe,0);
#endif
  if (t_pe >= TOTPE)
    return(DC_CC_EINVAL);

  prior = prior > 0;

  pcatch = mode & DC_MODE_PCATCH ? 1 : 0;
  mode &= ~DC_MODE_PCATCH;

  switch (mode) {
  case DC_MODE_PUSH:
  case DC_MODE_NMSG:
  case DC_MODE_NFUN:
  case DC_MODE_AMSG:
  case DC_MODE_AFUN:
  case DC_MODE_TMSG:
    if (sel >= TOTSEL || len > MB32SIZE)
      return(DC_CC_EINVAL);
    if (len <= MB01SIZE) {
      dc_mb01pcount++;
      dc_mb01bcount+=len;
    }
    else {
      dc_mb32pcount++;
      dc_mb32bcount+=len;
    }
    break;
  case DC_MODE_NIPL:
    if ((unsigned)src & 7 || len > MAXPSIZE || (unsigned)dst & 7)
      return(DC_CC_EINVAL);
    dc_ldtpcount++;
    dc_ldtbcount+=len;
    break;
  case DC_MODE_NLDT:
  case DC_MODE_ALDT:
    switch(sel) {
    case DC_SEL_REAL:
    case DC_SEL_LOCAL0:
    case DC_SEL_LOCAL1:
    case DC_SEL_GLOBAL0:
    case DC_SEL_GLOBAL1:
      break;
    default:
      return(DC_CC_EINVAL);
    }
    if ((unsigned)src & 3 || len > MAXPSIZE || (unsigned)dst & 3)
      return(DC_CC_EINVAL);
    dc_ldtpcount++;
    dc_ldtbcount+=len;
    break;
  default:
    return(DC_CC_EINVAL);
  }

  spl = splhi();

  switch (mode) {
  case DC_MODE_AMSG:
  case DC_MODE_TMSG:
    while (dc_lock_msg[t_pe][sel]) {
      if (sleep(&dc_lock_msg[t_pe][sel], pcatch?(PZERO+1)|PCATCH:PZERO) == 1) {
        cc = DC_CC_SIGNAL;
        goto dc_send_abort;
      }
    }
    dc_lock_msg[t_pe][sel] = 1;
    break;
  case DC_MODE_AFUN:
    while (dc_lock_fun[t_pe][sel]) {
      if (sleep(&dc_lock_fun[t_pe][sel], pcatch?(PZERO+1)|PCATCH:PZERO) == 1) {
        cc = DC_CC_SIGNAL;
        goto dc_send_abort;
      }
    }
    dc_lock_fun[t_pe][sel] = 1;
    break;
  case DC_MODE_ALDT:
    while (dc_lock_ldt[t_pe]) {
      if (sleep(&dc_lock_ldt[t_pe], pcatch?(PZERO+1)|PCATCH:PZERO) == 1) {
        cc = DC_CC_SIGNAL;
        goto dc_send_abort;
      }
    }
    dc_lock_ldt[t_pe] = 1;
    break;
  }

dc_send_retry:
dc_send_waitmem:
  if (((thq = dc_hq_find(DC_CMD_SND, prior)) == NULL)
   || (mode & DM_MSG && mode != DC_MODE_PUSH && (tmb = dc_mb_alloc(len, 0, 0)) == NULL)
   || (mode & DM_ACK && (tdcb = dc_dcb_alloc()) == NULL)
   || (mode & DM_TOK && (ttok = dc_tok_alloc()) == NULL)) {
    dc_mb_free(tmb, 0);
    dc_dcb_free(tdcb);
    dc_tok_free(ttok);
    if (mode & DM_ACK) {
#ifdef DEBUG
	dtrace("ppsend","memwait",0,0);
#endif
      sleep(&dc_memwait, PZERO);
      goto dc_send_waitmem;
    }
    else {
      cc = DC_CC_ESNOMEM;
      goto dc_send_exit;
    }
  }

  if (mode & DM_MSG && mode != DC_MODE_PUSH)
    bcopy(src, tmb->msg, len);
  dcbid = dc_dcb_enq(tdcb, dcbid, t_pe);
  dc_tok_enq(ttok, t_pe);
  dc_hq_setup(thq, tmb, tdcb, tdcb?tdcb->dcbid:0, ttok, ttok?ttok->tokid:0, DC_CC_NORMALEND, t_pe, DC_CMD_SND, prior, mode, sel, src, len, dst, key, param);

  if (mode & DM_ACK) {
    sleep(tdcb, PZERO);
    if ((cc = tdcb->cc) == DC_CC_NORMALEND) {
      if (mode & DM_TOK)
        cc = ttok->tokid;
    }
    else {
      dc_tok_deq(ttok);
      dc_tok_free(ttok);
    }
    flag = tdcb->flag;
    dc_dcb_free(tdcb);
    wakeup(&dc_memwait);
    if (mode & DM_MSG && cc == DC_CC_EUMEMDMG)
      cc = DC_CC_EDTUDMG;
    switch (cc) {
    case DC_CC_EUMEMDMG:
      break;
    case DC_CC_EDTUDMG:
      if (flag) {
        cc = DC_CC_ECOMM;
        goto dc_send_exit;
      }
      if (retry_edtudmg++ < RETRYN_PERSISTENT) {
        dc_retrycount++;
        goto dc_send_retry;
      }
      else {
        dc_failcount++;
        cmn_err(CE_PANIC,"dc_send: DC_CC_EDTUDMG");
      }
      break;
    case DC_CC_ERNOMEM:
      break;
    case DC_CC_ECOMM:
      if (flag)
        goto dc_send_exit;
      if (retry_ecomm++ < RETRYN_SIMPLE) {
        dc_retrycount++;
        goto dc_send_retry;
      }
      else {
        dc_failcount++;
        /* DAPF here */
      }
      break;
    default:
      break;
    }
  }
  else
    cc = DC_CC_NORMALEND;

dc_send_exit:
  switch (mode) {
  case DC_MODE_AMSG:
  case DC_MODE_TMSG:
    dc_lock_msg[t_pe][sel] = 0;
    wakeup(&dc_lock_msg[t_pe][sel]);
    break;
  case DC_MODE_AFUN:
    dc_lock_fun[t_pe][sel] = 0;
    wakeup(&dc_lock_fun[t_pe][sel]);
    break;
  case DC_MODE_ALDT:
    dc_lock_ldt[t_pe] = 0;
    wakeup(&dc_lock_ldt[t_pe]);
    break;
  }

dc_send_abort:
  splx(spl);
#ifdef DEBUG
	dtrace("ppsend","return",cc,0);
#endif
  return(cc);
}

dc_broadcast(prior, sel, src, len)
  unsigned    prior;
  unsigned    sel;
  char*       src;
  unsigned    len;
{
  px_peid_t   t_pe;
  unsigned    pe_b[8];
  unsigned    rb_b[8];
  unsigned    hw_b[8];

  { /* append by harada */
  int i;
  for(i=0;i<8;i++){pe_b[i]=0;rb_b[i]=0;hw_b[i]=0;}
  }

  for (t_pe=0; t_pe<TOTPE; t_pe++) {
    *(pe_b+(dc_n2p[t_pe]>>5)) = dc_n2p[t_pe] >= 0
      ? *(pe_b+(dc_n2p[t_pe]>>5))| ((unsigned)0x80000000>>(dc_n2p[t_pe]&31))
      : *(pe_b+(dc_n2p[t_pe]>>5))&~((unsigned)0x80000000>>(dc_n2p[t_pe]&31));
  }
#ifdef DEBUG
  dbg_printf("[dc_bcast:%x %x %x %x %x %x %x %x]",
    pe_b[0],pe_b[1],pe_b[2],pe_b[3],pe_b[4],pe_b[5],pe_b[6],pe_b[7]);
  dtrace("dc_cast","ppcal",(int)pe_b[0],0);
#endif
  return(dc_ppbroadcast(pe_b, rb_b, hw_b, prior, sel, src, len));
}

dc_ppbroadcast(pe_b, rb_b, hw_b, prior, sel, src, len)
  unsigned*   pe_b; /* Physical PE */
  unsigned*   rb_b;
  unsigned*   hw_b;
  unsigned    prior;
  unsigned    sel;
  char*       src;
  unsigned    len;
{
  px_peid_t    t_pe;
  struct mb*   thq  = NULL;
  struct mb*   tmb[TOTPE];
  struct dcb*  tdcb[TOTPE];
  int	       spl, cc;

  prior = prior > 0;

  if (sel >= TOTSEL || len > MB32SIZE)
    return(DC_CC_EINVAL);
  if (len <= MB01SIZE) {
    dc_mb01pcount++;
    dc_mb01bcount+=len;
  }
  else {
    dc_mb32pcount++;
    dc_mb32bcount+=len;
  }

  spl = splhi();
#ifdef DEBUG
dtrace("ppcast","enter",pe_b,0);
#endif

  for (t_pe=0; t_pe<TOTPE>>5; t_pe++) {
    *(rb_b+t_pe) = 0;
    *(hw_b+t_pe) = 0;
  }
  for (t_pe=0; t_pe<TOTPE; t_pe++) {
    if (*(pe_b+(t_pe>>5)) & (0x80000000>>(t_pe&31))) {
dc_broadcast_waitmem:
      if (((thq = dc_hq_find(DC_CMD_SND, prior)) == NULL)
       || ((tmb[t_pe]  = dc_mb_alloc(len, 0, 0)) == NULL)
       || ((tdcb[t_pe] = dc_dcb_alloc()) == NULL)) {
        dc_mb_free(tmb[t_pe], 0);
        dc_dcb_free(tdcb[t_pe]);
        sleep(&dc_memwait, PZERO);
        goto dc_broadcast_waitmem;
      }

      bcopy(src, tmb[t_pe]->msg, len);
      dc_dcb_enq(tdcb[t_pe], 0, t_pe);
      dc_hq_setup(thq, tmb[t_pe], tdcb[t_pe], tdcb[t_pe]->dcbid, NULL, 0, DC_CC_NORMALEND, t_pe, DC_CMD_SND, prior, DC_MODE_AMSG, sel, src, len, NULL, NULL, NULL);
    }
  }

#ifdef DEBUG
dtrace("ppcast","sendend",cc,0);
#endif

  cc = DC_CC_NORMALEND;
  for (t_pe=0; t_pe<TOTPE; t_pe++) {
    if (*(pe_b+(t_pe>>5)) & (0x80000000>>(t_pe&31))) {
      if( tdcb[t_pe]->status == DC_STATUS_ACKWAIT ) /* append harada */
      sleep(tdcb[t_pe], PZERO);
      *(rb_b+(t_pe>>5)) = tdcb[t_pe]->cc == DC_CC_ERNOMEM
        ? *(rb_b+(t_pe>>5))| ((unsigned)0x80000000>>(t_pe&31))
        : *(rb_b+(t_pe>>5))&~((unsigned)0x80000000>>(t_pe&31));
      *(hw_b+(t_pe>>5)) = tdcb[t_pe]->cc == DC_CC_ECOMM
        ? *(hw_b+(t_pe>>5))| ((unsigned)0x80000000>>(t_pe&31))
        : *(hw_b+(t_pe>>5))&~((unsigned)0x80000000>>(t_pe&31));
      cc = cc | (tdcb[t_pe]->cc != DC_CC_NORMALEND);
      dc_dcb_free(tdcb[t_pe]);
    }
  }

  wakeup(&dc_memwait);
#ifdef DEBUG
dtrace("ppcast","return",cc,0);
#endif
  splx(spl);
  return(cc);
}

dc_repl(t_pe, prior, mode, tokid, src, len, param)
  px_peid_t   t_pe;
  unsigned    prior;
  int         tokid;
  char*       src;
  unsigned    len;
  unsigned*   param;
{
#ifdef DEBUG
	dtrace("dc_repl","RP",t_pe,0);
#endif
  if (t_pe >= TOTPE)
    return(DC_CC_RPDOWN);
  if (dc_n2p[t_pe] < 0)
    return(dc_n2p[t_pe]);
  return(dc_pprepl(t_pe, prior, mode, tokid, src, len, param));
}

dc_pprepl(t_pe, prior, mode, tokid, src, len, param)
  px_peid_t   t_pe;
  unsigned    prior;
  unsigned    mode;
  int         tokid;
  char*       src;
  unsigned    len;
  unsigned*   param;
{
  struct mb*   thq  = NULL;
  struct mb*   tmb  = NULL;
  struct dcb*  tdcb = NULL;
  int	       spl, cc, flag, dcbid = 0;
  int          pcatch, retry_edtudmg = 0, retry_ecomm = 0;

#ifdef DEBUG
	dtrace("pprepl","PP",t_pe,0);
#endif
  if (t_pe >= TOTPE)
    return(DC_CC_EINVAL);

  prior = prior > 0;

  pcatch = mode & DC_MODE_PCATCH ? 1 : 0;
  mode &= ~DC_MODE_PCATCH;

  switch (mode) {
  case DC_MODE_AMSG:
    break;
  default:
    return(DC_CC_EINVAL);
  }

  if (tokid <= 0 || len > MB32SIZE)
    return(DC_CC_EINVAL);

  spl = splhi();

  while (dc_lock_rpl[t_pe]) {
    if (sleep(&dc_lock_rpl[t_pe], pcatch?(PZERO+1)|PCATCH:PZERO) == 1) {
      cc = DC_CC_SIGNAL;
      goto dc_repl_abort;
    }
  }
  dc_lock_rpl[t_pe] = 1;

dc_repl_retry:
dc_repl_waitmem:
  if (((thq  = dc_hq_find(DC_CMD_RPL, prior)) == NULL)
   || ((tmb  = dc_mb_alloc(len, 0, 0)) == NULL)
   || ((tdcb = dc_dcb_alloc()) == NULL)) {
    dc_mb_free(tmb, 0);
    dc_dcb_free(tdcb);
#ifdef DEBUG
	dtrace("pprepl","memwait",0,0);
#endif
    sleep(&dc_memwait, PZERO);
    goto dc_repl_waitmem;
  }

  bcopy(src, tmb->msg, len);
  dcbid = dc_dcb_enq(tdcb, dcbid, t_pe);
  dc_hq_setup(thq, tmb, tdcb, tdcb?tdcb->dcbid:0, NULL, tokid, DC_CC_NORMALEND, t_pe, DC_CMD_RPL, prior, mode, 0, NULL, len, NULL, NULL, param);

  sleep(tdcb, PZERO);
  cc = tdcb->cc;
  dc_dcb_free(tdcb);
  wakeup(&dc_memwait);
  if (mode & DM_MSG && cc == DC_CC_EUMEMDMG)
    cc = DC_CC_EDTUDMG;
  switch (cc) {
  case DC_CC_EUMEMDMG:
    break;
  case DC_CC_EDTUDMG:
    if (flag) {
      cc = DC_CC_ECOMM;
      goto dc_repl_exit;
    }
    if (retry_edtudmg++ < RETRYN_PERSISTENT) {
      dc_retrycount++;
      goto dc_repl_retry;
    }
    else {
      dc_failcount++;
      cmn_err(CE_PANIC,"dc_repl: DC_CC_EDTUDMG");
    }
    break;
  case DC_CC_ERNOMEM:
    break;
  case DC_CC_ECOMM:
    if (flag)
      goto dc_repl_exit;
    if (retry_ecomm++ < RETRYN_SIMPLE) {
      dc_retrycount++;
      goto dc_repl_retry;
    }
    else {
      dc_failcount++;
      /* DAPF here */
    }
    break;
  default:
    break;
  }

dc_repl_exit:
  dc_lock_rpl[t_pe] = 0;
  wakeup(&dc_lock_rpl[t_pe]);

dc_repl_abort:
  splx(spl);
#ifdef DEBUG
	dtrace("pprepl","return",cc,0);
#endif
  return(cc);
}

dc_wait(mode, tokid, mb)
  unsigned    mode;
  int         tokid;
  struct mb** mb;
{
  struct tok* ttok;
  int         spl, cc, pcatch;

  *mb = NULL;
#ifdef DEBUG
	dtrace("dc_wait","tokid",tokid,0);
#endif
  pcatch = mode & DC_MODE_PCATCH ? 1 : 0;
  mode &= ~DC_MODE_PCATCH;

  switch (mode) {
  case DC_MODE_NOWAIT:
  case DC_MODE_WAIT:
    if (tokid <= 0)
      return(DC_CC_EINVAL);
    break;
  default:
    return(DC_CC_EINVAL);
  }

  spl = splhi();

  if (!(ttok = dc_tok_find(tokid))) {
    cc = DC_CC_ENOTOK;
    goto dc_wait_abort;
  }

  if (ttok->status != DC_STATUS_RPLDONE) {
    if (mode == DC_MODE_NOWAIT) {
      cc = DC_CC_NOMSG;
      goto dc_wait_abort;
    }
    else if (sleep(ttok, pcatch?(PZERO+1)|PCATCH:PZERO) == 1) {
      cc = DC_CC_SIGNAL;
      goto dc_wait_abort;
    }
  }

  if ((cc = ttok->cc) == DC_CC_NORMALEND)
    *mb = ttok->mb;
  else
    dc_mb_free(ttok->mb, 0);

  dc_tok_deq(ttok);
  dc_tok_free(ttok);

dc_wait_abort:
  splx(spl);
#ifdef DEBUG
	dtrace("dc_wait","return",cc,0);
#endif
  return(cc);
}

dc_mbfree(mb)
  struct mb* mb;
{
  int         spl;

  if (!mb)
    return(DC_CC_EINVAL);
  spl = splhi();
  switch (mb->cmd) {
  case DC_CMD_SND:
    switch (mb->mode) {
    case DC_MODE_NMSG:
    case DC_MODE_AMSG:
    case DC_MODE_TMSG:
      dc_mb_free(mb, 1);
      break;
    case DC_MODE_NFUN:
    case DC_MODE_AFUN:
      dc_mb_free(mb, 2);
      break;
    default:
      dc_mb_free(mb, 0);
      break;
    }
    break;
  case DC_CMD_RPL:
    dc_mb_free(mb, 3);
    break;
  default:
    dc_mb_free(mb, 0);
    break;
  }
  splx(spl);
  return(DC_CC_NORMALEND);
}

dc_cancel(tokid)
  int         tokid;
{
  struct tok* ttok;
  int         spl, cc;

#ifdef DEBUG
	dtrace("_cancel","tokid",tokid,0);
#endif
  if (tokid <= 0)
    return(DC_CC_EINVAL);

  spl = splhi();

  if (!(ttok = dc_tok_find(tokid)))
    cc = DC_CC_ENOTOK;
  else {
    ttok->status = DC_STATUS_RPLDONE;
    ttok->cc     = DC_CC_CANTOK;
    wakeup(ttok);
    cc = DC_CC_NORMALEND;
  }

  splx(spl);
#ifdef DEBUG
	dtrace("_cancel","return",cc,0);
#endif
  return(cc);
}

dc_regist(func, sel)
  void        (*func)();
  unsigned    sel;
{
#ifdef DEBUG
	dtrace("_regist","sel",sel,0);
#endif
  if (sel >= TOTSEL)
    return(DC_CC_EINVAL);

  if (intrfunc[sel])
    return(DC_CC_EINUSE);

  intrfunc[sel] = func;
#ifdef DEBUG
	dtrace("_regist","ok",func,0);
#endif
  return(DC_CC_NORMALEND);
}

dc_recv(mode, sel, t_pe, tokid, mb)
  unsigned    mode;
  unsigned    sel;
  px_peid_t*  t_pe;
  int*        tokid;
  struct mb** mb;
{
  int cc;
#ifdef DEBUG
	dtrace("dc_recv","sel",sel,0);
#endif
  if ((cc = dc_pprecv(mode, sel, t_pe, tokid, mb)) == DC_CC_NORMALEND)
    *t_pe = (px_peid_t)((*mb)->srcrp);
#ifdef DEBUG
	dtrace("dc_recv","return",cc,0);
#endif
  return(cc);
}

dc_pprecv(mode, sel, t_pe, tokid, mb)
  unsigned    mode;
  unsigned    sel;
  px_peid_t*  t_pe;
  int*        tokid;
  struct mb** mb;
{
  struct mb*  trbq;
  int         spl, cc, pcatch;

  *t_pe  = DC_CC_RPDOWN;
  *tokid = 0;
  *mb    = NULL;
#ifdef DEBUG
	dtrace("pprecv","sel",sel,0);
#endif
  pcatch = mode & DC_MODE_PCATCH ? 1 : 0;
  mode &= ~DC_MODE_PCATCH;

  switch (mode) {
  case DC_MODE_NOWAIT:
  case DC_MODE_WAIT:
    if (sel >= TOTSEL)
      return(DC_CC_EINVAL);
    break;
  default:
    return(DC_CC_EINVAL);
  }
  
  spl = splhi();

  while ((trbq = dc_mb_deq(sel)) == NULL) {
    if (mode == DC_MODE_NOWAIT) {
      cc = DC_CC_NOMSG;
      goto dc_recv_abort;
    }
    else if (sleep(&rbq[sel], pcatch?(PZERO+1)|PCATCH:PZERO) == 1) {
      cc = DC_CC_SIGNAL;
      goto dc_recv_abort;
    }
  }

  *t_pe  = trbq->srcnpa;
  *tokid = trbq->tokid;
  *mb    = trbq;
  cc = DC_CC_NORMALEND;

dc_recv_abort:
  splx(spl);
#ifdef DEBUG
	dtrace("pprecv","return",cc,0);
#endif
  return(cc);
}

#define  WDT_2SEC	0x01E80000 
dc_intr()
{
  union mcr_form mrprmi;
  union mcr_form sndmri;
  union mcr_form smiphi;
  unsigned mcr;
  int spl;
  
dc_intr_top:

  mcr_storei(MCR_WDTW, WDT_2SEC);
  mcr_load(MCR_MRPRMI, mrprmi);
#ifdef DEBUG
  dtrace("dc_intr","enter",(int)mrprmi.ful,0);
#endif

  if( !(mrprmi.ful & 0xf0000000) ) {
    wakeup(&dc_memwait);
#ifdef DEBUG
    dtrace("dc_intr","return",0,0);
#endif
    return;
  }

  if (mrprmi.mrprmi.sndmrp) {
    mcr_load(MCR_SNDMRI, sndmri);
    mcr_load(MCR_SMIPHI, smiphi);
    dc_intr_sndmrp(sndmri, smiphi);
  }
  
  if (mrprmi.mrprmi.sndsrp)
    dc_intr_sndsrp();
  
  if (mrprmi.mrprmi.rcvmrp) {
    if( dc_intr_rcvmrp(mrprmi) )
      mrprmi.mrprmi.rcvmrp = 0;   /* not erase rcvmrp */
  }
  
  if (mrprmi.mrprmi.rcvsrp)
    dc_intr_rcvsrp();
  
  mcr_store(MCR_MRPRMI, mrprmi.ful);

  goto dc_intr_top;
}

STATIC
void
dc_intr_sndmrp(sndmri, smiphi)
  union mcr_form sndmri;
  union mcr_form smiphi;
{
  struct mb*   thq;
  struct mb*   tmb;
  struct dcb*  tdcb;

#ifdef DEBUG
  dtrace("sndmrp","enter",(int)sndmri.ful,0);
  dtrace("sndmrp","-----",(int)smiphi.ful,0);
#endif

  if( smiphi.smiphi.smiqty < 2 ) {  /* if user header queue */
    udtu_sndmrp( sndmri, smiphi );
    return;
  }

  /* sndmri.psdsup is ignored */
  /* sndmri.sndcti is ignored */
  /* smiphi.smiuid is ignored */
  
  /* header address is unknown */
  if (!sndmri.sndmri.phav) {
#ifdef DEBUG
  dtrace("sndmrp","!phav",(int)sndmri.ful,0);
#endif
    if (tmb = dc_mb_alloc(0, 1, 0)) {
      tmb->cc     = DC_CC_ECOMM;
      tmb->status = DC_STATUS_SERROR;
      tmb->cmd    = DC_CMD_SND;
      tmb->mode   = DC_MODE_NMSG;
      tmb->sel    = 0;
      tmb->key    = (unsigned)sndmri.ful; /* RAS info */
      dc_mb_enq(tmb, 0);
    }
    return;
  }
  
  /* classify priority */
  switch (smiphi.smiphi.smiqty) {
  case 2:
    thq = (struct mb*)((char*)hq[1]+(smiphi.ful&0xffffff80)-kvtophys(hq[1]));
    break;
  case 3:
    thq = (struct mb*)((char*)hq[0]+(smiphi.ful&0xffffff80)-kvtophys(hq[0]));
    break;
  default:
    return;
  }
  
  /* machine check (dtu) */
  if (sndmri.sndmri.sndnte || sndmri.sndmri.sndmte || sndmri.sndmri.sndnce || sndmri.sndmri.sndmie) {
#ifdef DEBUG
  dtrace("sndmrp","mchk",(int)sndmri.ful,0);
#endif
    dc_mb_free(thq->llink, 0);
    if (thq->dcb && thq->dcb->dcbid == thq->dcbid) {
      thq->dcb->status = DC_STATUS_SERROR;
      thq->dcb->cc     = DC_CC_EDTUDMG;
      dc_dcb_deq(thq->dcb);
      wakeup(thq->dcb);
    }
    else if (tmb = dc_mb_alloc(0, 1, 0)) {
      tmb->cc     = DC_CC_EDTUDMG;
      tmb->status = DC_STATUS_SERROR;
      tmb->cmd    = DC_CMD_SND;
      tmb->mode   = DC_MODE_NMSG;
      tmb->sel    = 0;
      tmb->key    = (unsigned)sndmri.ful; /* RAS info */
      dc_mb_enq(tmb, 0);
    }
    return;
  }
  
  /* machine check (mem) */
  if (sndmri.sndmri.sndse) {
#ifdef DEBUG
  dtrace("sndmrp","sndse",(int)sndmri.ful,0);
#endif
    dc_mb_clear(thq->llink);
    dc_mb_free(thq->llink, 0);
    if (thq->dcb && thq->dcb->dcbid == thq->dcbid) {
      thq->dcb->status = DC_STATUS_SERROR;
      thq->dcb->cc     = sndmri.sndmri.sndsea == 6 ? DC_CC_EUMEMDMG : DC_CC_EDTUDMG;
      dc_dcb_deq(thq->dcb);
      wakeup(thq->dcb);
    }
    else if (tmb = dc_mb_alloc(0, 1, 0)) {
      tmb->cc     = sndmri.sndmri.sndsea == 6 ? DC_CC_EUMEMDMG : DC_CC_EDTUDMG;
      tmb->status = DC_STATUS_SERROR;
      tmb->cmd    = DC_CMD_SND;
      tmb->mode   = DC_MODE_NMSG;
      tmb->sel    = 0;
      tmb->key    = (unsigned)sndmri.ful; /* RAS info */
      dc_mb_enq(tmb, 0);
    }
    return;
  }
  
  /* programmed error */
  if (sndmri.sndmri.sndalx || sndmri.sndmri.sndtsx || sndmri.sndmri.sndprx || sndmri.sndmri.sndadx) {
#ifdef DEBUG
  dtrace("sndmrp","perr",(int)sndmri.ful,0);
#endif
    dc_mb_free(thq->llink, 0);
    if (thq->dcb && thq->dcb->dcbid == thq->dcbid) {
      thq->dcb->status = DC_STATUS_SERROR;
      thq->dcb->cc     = DC_CC_ECOMM;
      dc_dcb_deq(thq->dcb);
      wakeup(thq->dcb);
    }
    else if (tmb = dc_mb_alloc(0, 1, 0)) {
      tmb->cc     = DC_CC_ECOMM;
      tmb->status = DC_STATUS_SERROR;
      tmb->cmd    = DC_CMD_SND;
      tmb->mode   = DC_MODE_NMSG;
      tmb->sel    = 0;
      tmb->key    = (unsigned)sndmri.ful; /* RAS info */
      dc_mb_enq(tmb, 0);
    }
    return;
  }
  
  /* programmed interruption */
  if (sndmri.sndmri.sndpci) {
    dc_mb_free(thq->llink, 0);
    if (thq->dcb && thq->dcb->dcbid == thq->dcbid) {
      thq->dcb->status = DC_STATUS_ACKWAIT;
      thq->dcb->tod    = dc_gettod();
    }
    if (thq->key)
      wakeup(thq->key);
    return;
  }
}

STATIC
void
dc_intr_sndsrp()
{
  int     spl;
  /* udtu changes on 1992/09/29  */

#ifdef DEBUG
    dtrace("sndsrp","enter",0,0);
#endif

  spl = splhi();
  if( snd_stop_semafo > 0 ) {
    snd_stop_flag = B_TRUE;
    wakeup(&snd_stop_semafo);
  }
  else {
    mcr_store( MCR_MRPRMI, 0x40000000 );
    asm("brcs %asam,.");
    mcr_store( MCR_MCMDW, 0 );   /* start snd */
    snd_stop_flag = B_FALSE;
    asm("brcs %asam,.");
  }
  splx(spl);

#ifdef DEBUG
    dtrace("sndsrp","return",0,0);
#endif
  return;
}

STATIC
int	/* returns  not_erase_mrprmi.rcvmrp */
dc_intr_rcvmrp(mrprmi)
  union mcr_form mrprmi;
{
  struct mb*  trb;  /* virtual address of receive buffer */
  struct mb*  trb2;  /* virtual address of receive buffer */
  struct mb*  thq;
  struct mb*  tmb;
  struct dcb* tdcb;
  struct tok* ttok;
  unsigned    rbar; /* MCR address of RBARX */
  unsigned    rbra; /* real address of receive buffer */

  /*  udtu adds on 1992/9/30  */  
  int         snd_qid;    /* snd queue-id                  */
  int         snd_netpa;  /* snd netpa                     */
  int         dest_side;  /* destination user side         */
  int         rbnum;	  /* rb number			   */

#ifdef DEBUG
  dtrace("rcvmrp","enter",(int)mrprmi.ful,0);
#endif
  /* mrprmi.rcvsea is ignored */
  /* mrprmi.rcvcti is ignored */
  /* mrprmi.srcmte is ignored */
  /* mrprmi.srcnce is ignored */
  /* mrprmi.srcmie is ignored */
  /* mrprmi.srcse  is ignored */
  /* mrprmi.srcexc is ignored */

  /* classify rb */
  switch (rbnum=mrprmi.mrprmi.rbn) {
  case 0:
    trb  = rb[0];
    trb2 = rb[1];
    rbar = MCR_RBAR0;
    break;
  case 1:
    trb  = rb[1];
    trb2 = rb[0];
    rbar = MCR_RBAR1;
    break;
  default:
    /* cannot be reached */
    break;
  }

  /* udtu:  get snd_qid, snd_netpa, dest_side */

  if(!mrprmi.mrprmi.rbhv) {
    snd_netpa = -1;	/* unknown */
    snd_qid = -1;	/* unknown */
    dest_side = -1;   /* unknown */
  }
  else if( mrprmi.ful & 0x007fe000 ) { /* if machine check */
    unsigned  q1,q2,q3,q4;
    int             sidenum;
    px_partition_t  *p;
    short   vp;     /* virtual processor id */
    px_rpid_t       rp;     /* real processor id    */
    int             ss;     /* side of sender       */

    srcnetpa_ecc( (int)trb->srcnpa, (int)trb->srcecc, &snd_netpa );
    /* snd_netpa = -1 when unable to correction */
    q1 = trb->srcqid1;
    q2 = trb->srcqid2;
    q3 = trb->srcqid3;
    q4 = trb->srcqid4;
    if( q1==q2 && q1==q3 || q1==q2 && q1==q4 || q1==q3 && q1==q4 )
      snd_qid = q1;
    else if( q2==q3 && q2==q4 )
      snd_qid = q2;
    else
      snd_qid = -1;
    
    /*  search sender and get dest_side  */
    dest_side = -1;
    if( snd_netpa !=-1 && snd_qid != -1 && ((snd_qid&8) == 0) )  {  /* user */
      ss = snd_qid & 3;
      for( sidenum = 0; sidenum < PX_PE_MULTIPLEXY && dest_side==-1; ++sidenum ) {
	if( (p = pms_partition[sidenum]) != NULL ) {
	  for(vp=0; vp< p->ptn_vpnbr && dest_side==-1; ++vp){
	    rp = p->ptn_rpid[ vp ];
	    if(RPID2NETPA(rp)==snd_netpa && RPID2DUPID(rp)==ss )
	      dest_side = sidenum;
	  }
	}
      }
    }
  }
  else {  /* rb is valid and no machine check */
    snd_netpa = trb->srcnpa;
    snd_qid   = trb->srcqid1;
    dest_side = trb->dstpid;
  }

 /* rqoverflow occurs, rbrrbv is valid  and no mck and exception  */

  if( mrprmi.mrprmi.rbhv==1 && ((mrprmi.ful&0x007fe1ff) == 3) && dest_side != -1 ) {
    int	rupt_state;
    boolean_t	gen_sigiot; 
    
    udtu_rqo( rbnum, dest_side, trb, trb2, &rupt_state, &gen_sigiot );
    if( gen_sigiot ) {
      udtu_rcvmrp( mrprmi, trb, snd_netpa, snd_qid, dest_side );
    }
    switch( rupt_state ) {
    case RMR_ERASED:	/* rcvmrp is erased */
    case RMR_CHANGED:	/* rcvmrp is changed */
      return( -1 );
    case RMR_NOCHANGE:
    default:
      break;
    }
  }
  else if( !mrprmi.mrprmi.rbhv || snd_qid == -1 || ((snd_qid&8) == 0) ) {
    udtu_rcvmrp( mrprmi, trb, snd_netpa, snd_qid, dest_side );
  }
  
  /* if user packet then goto_epilogue */
  if( snd_qid >= 0 && snd_qid < 8 ) {
    goto dc_intr_rcvmrp_abort;
  }
  
  /*
   *	supervisor or unknown_snder packet 
   */

  /* header contents is unknown */
  if ( !mrprmi.mrprmi.rbhv ) {
#ifdef DEBUG
  dtrace("rcvmrp","!rbhv",(int)mrprmi.ful,0);
#endif
    if (tmb = dc_mb_alloc(0, 1, 0)) {
      tmb->cc     = DC_CC_ECOMM;
      tmb->status = DC_STATUS_RERROR;
      tmb->cmd    = DC_CMD_SND;
      tmb->mode   = DC_MODE_NMSG;
      tmb->sel    = 0;
      tmb->key    = (unsigned)mrprmi.ful; /* RAS info */
      dc_mb_enq(tmb, 0);
    }
    goto dc_intr_rcvmrp_abort;
  }

  /* destination machine check */
  if (mrprmi.mrprmi.rcvmte || mrprmi.mrprmi.rcvnce || mrprmi.mrprmi.rcvmie) {
    unsigned cur_time;
#ifdef DEBUG
  dtrace("rcvmrp","mchk",(int)mrprmi.ful,0);
#endif

    if (tmb = dc_mb_alloc(0, 1, 0)) {
      tmb->cc     = DC_CC_ECOMM;
      tmb->status = DC_STATUS_RERROR;
      tmb->cmd    = DC_CMD_SND;
      tmb->mode   = DC_MODE_NMSG;
      tmb->sel    = 0;
      tmb->key    = (unsigned)mrprmi.ful; /* RAS info */
      dc_mb_enq(tmb, 0);
    }
    cur_time = dc_gettod();
    if (last_fault_flag && last_fault_time + 120 > cur_time)
      cmn_err(CE_PANIC,"dc_intr_rcvmrp: frequent rcvmte/rcvnce/rcvmie");
    else {
      last_fault_flag = 1;
      last_fault_time = cur_time;
    }
    goto dc_intr_rcvmrp_abort;
  }
  else
    last_fault_flag = 0;

  /* destination machine check | programmed error */
  if (mrprmi.mrprmi.rcvse  || mrprmi.mrprmi.netde  || mrprmi.mrprmi.rdicl
   || mrprmi.mrprmi.rcvalx || mrprmi.mrprmi.rcvtsx || mrprmi.mrprmi.rcvprx
   || mrprmi.mrprmi.rcvadx) {
#ifdef DEBUG
  dtrace("rcvmrp","perr",(int)mrprmi.ful,0);
#endif
    if (tmb = dc_mb_alloc(0, 1, 0)) {
      tmb->cc     = DC_CC_ECOMM;
      tmb->status = DC_STATUS_RERROR;
      tmb->cmd    = DC_CMD_SND;
      tmb->mode   = DC_MODE_NMSG;
      tmb->sel    = 0;
      tmb->key    = (unsigned)mrprmi.ful; /* RAS info */
      dc_mb_enq(tmb, 0);
    }
    goto dc_intr_rcvmrp_abort;
  }

  /* programmed interruption */
  if (mrprmi.mrprmi.rcvpci) {
    trb->srcrp = dc_p2n[trb->srcnpa];
    switch (trb->cmd) {
    case DC_CMD_ACK:
#ifdef DEBUG
  dtrace("rcvmrp","ack",0,0);
#endif
      if (trb->dcb && trb->dcb->dcbid == trb->dcbid) {
        trb->dcb->status = DC_STATUS_ACKDONE;
        trb->dcb->cc     = trb->cc;
        dc_dcb_deq(trb->dcb);
        wakeup(trb->dcb);
      }
      break;
    case DC_CMD_SND:
#ifdef DEBUG
  dtrace("rcvmrp","snd",0,0);
#endif
      if (trb->mode & DM_ACK) {
        if ((thq = dc_hq_find(DC_CMD_ACK, trb->prior)) == NULL) {
          if (tmb = dc_mb_alloc(0, 1, 0)) {
            tmb->cc     = DC_CC_ESNOMEM;
            tmb->status = DC_STATUS_SERROR;
            tmb->cmd    = DC_CMD_SND;
            tmb->mode   = DC_MODE_NMSG;
            tmb->sel    = 0;
            tmb->key    = (unsigned)mrprmi.ful; /* RAS info */
            dc_mb_enq(tmb, 0);
          }
	}
	else if (trb->mode & DM_MSG) {
	  if (trb->mode & DM_FUN && !intrfunc[trb->sel])
	    dc_hq_setup(thq, NULL, trb->dcb, trb->dcbid, NULL, 0, DC_CC_ENOFUNC, trb->srcnpa, DC_CMD_ACK, trb->prior, DC_MODE_NACK, 0, NULL, 0, NULL, NULL, NULL);
	  else if ((tmb = dc_mb_alloc(trb->len, trb->mode & DM_FUN ? 2 : 1, trb->sel)) == NULL)
	    dc_hq_setup(thq, NULL, trb->dcb, trb->dcbid, NULL, 0, DC_CC_ERNOMEM, trb->srcnpa, DC_CMD_ACK, trb->prior, DC_MODE_NACK, 0, NULL, 0, NULL, NULL, NULL);
	  else {
	    dc_hq_setup(thq, NULL, trb->dcb, trb->dcbid, NULL, 0, DC_CC_NORMALEND, trb->srcnpa, DC_CMD_ACK, trb->prior, DC_MODE_NACK, 0, NULL, 0, NULL, NULL, NULL);
	    if (tmb->size == MB32SIZE) {
	      switch (mrprmi.mrprmi.rbn) {
	      case 0:
		mcr_store(MCR_RBAR0, kvtophys(rb[0]=tmb)|1);
		break;
	      case 1:
		mcr_store(MCR_RBAR1, kvtophys(rb[1]=tmb)|1);
		break;
	      }
	      if (trb->mode & DM_FUN) {
                if (dc_seqn_fun[trb->srcnpa][trb->sel] != trb->dcbid) {
                  dc_seqn_fun[trb->srcnpa][trb->sel] = trb->dcbid;
		  (intrfunc[trb->sel])(trb->srcnpa, trb);
                }
              }
	      else {
                if (dc_seqn_msg[trb->srcnpa][trb->sel] != trb->dcbid) {
                  dc_seqn_msg[trb->srcnpa][trb->sel] = trb->dcbid;
		  dc_mb_enq(trb, trb->sel);
                }
              }
	      return(0);
	    }
	    else {
	      bcopy(trb, tmb, HEDRSIZE+trb->len);
	      if (trb->mode & DM_FUN) {
                if (dc_seqn_fun[trb->srcnpa][trb->sel] != trb->dcbid) {
                  dc_seqn_fun[trb->srcnpa][trb->sel] = trb->dcbid;
		  (intrfunc[trb->sel])(trb->srcnpa, tmb);
                }
              }
	      else {
                if (dc_seqn_msg[trb->srcnpa][trb->sel] != trb->dcbid) {
                  dc_seqn_msg[trb->srcnpa][trb->sel] = trb->dcbid;
		  dc_mb_enq(tmb, trb->sel);
                }
              }
	    }
	  }
	}
	else {
	  dc_hq_setup(thq, NULL, trb->dcb, trb->dcbid, NULL, 0, DC_CC_NORMALEND, trb->srcnpa, DC_CMD_ACK, trb->prior, DC_MODE_NACK, 0, NULL, 0, NULL, NULL, NULL);
          dc_seqn_ldt[trb->srcnpa] = trb->dcbid;
        }
      }
      else {
	if (trb->mode & DM_MSG && trb->mode != DC_MODE_PUSH) {
	  if (trb->mode & DM_FUN && !intrfunc[trb->sel])
            ;
	  else if (tmb = dc_mb_alloc(trb->len, trb->mode & DM_FUN ? 2 : 1, trb->sel)) {
	    if (tmb->size == MB32SIZE) {
	      switch (mrprmi.mrprmi.rbn) {
	      case 0:
		mcr_store(MCR_RBAR0, kvtophys(rb[0]=tmb)|1);
		break;
	      case 1:
		mcr_store(MCR_RBAR1, kvtophys(rb[1]=tmb)|1);
		break;
	      }
	      if (trb->mode & DM_FUN)
		(intrfunc[trb->sel])(trb->srcnpa, trb);
	      else
		dc_mb_enq(trb, trb->sel);
	      return(0);
	    }
	    else {
	      bcopy(trb, tmb, HEDRSIZE+trb->len);
	      if (trb->mode & DM_FUN)
		(intrfunc[trb->sel])(trb->srcnpa, tmb);
	      else
		dc_mb_enq(tmb, trb->sel);
	    }
	  }
	}
      }
      break;
    case DC_CMD_RPL:
#ifdef DEBUG
  dtrace("rcvmrp","rpl",0,0);
#endif
      if ((thq = dc_hq_find(DC_CMD_ACK, trb->prior)) == NULL) {
	if (tmb = dc_mb_alloc(0, 1, 0)) {
	  tmb->cc     = DC_CC_ESNOMEM;
	  tmb->status = DC_STATUS_SERROR;
          tmb->cmd    = DC_CMD_SND;
          tmb->mode   = DC_MODE_NMSG;
          tmb->sel    = 0;
          tmb->key    = (unsigned)mrprmi.ful; /* RAS info */
	  dc_mb_enq(tmb, 0);
	}
      }
      else if ((tmb = dc_mb_alloc(trb->len, 3, 0)) == NULL)
	dc_hq_setup(thq, NULL, trb->dcb, trb->dcbid, NULL, 0, DC_CC_ERNOMEM, trb->srcnpa, DC_CMD_ACK, trb->prior, DC_MODE_NACK, 0, NULL, 0, NULL, NULL, NULL);
      else {
	dc_hq_setup(thq, NULL, trb->dcb, trb->dcbid, NULL, 0, DC_CC_NORMALEND, trb->srcnpa, DC_CMD_ACK, trb->prior, DC_MODE_NACK, 0, NULL, 0, NULL, NULL, NULL);
	if (tmb->size == MB32SIZE) {
	  switch (mrprmi.mrprmi.rbn) {
	  case 0:
	    mcr_store(MCR_RBAR0, kvtophys(rb[0]=tmb)|1);
	    break;
	  case 1:
	    mcr_store(MCR_RBAR1, kvtophys(rb[1]=tmb)|1);
	    break;
	  }
          if (dc_seqn_rpl[trb->srcnpa] != trb->dcbid) {
            dc_seqn_rpl[trb->srcnpa] = trb->dcbid;
            if (ttok = dc_tok_find(trb->tokid)) {
	      ttok->status = DC_STATUS_RPLDONE;
	      ttok->mb     = trb;
	      wakeup(ttok);
            }
          }
	  return(0);
	}
	else {
	  bcopy(trb, tmb, HEDRSIZE+trb->len);
          if (dc_seqn_rpl[trb->srcnpa] != trb->dcbid) {
            dc_seqn_rpl[trb->srcnpa] = trb->dcbid;
	    if (ttok = dc_tok_find(trb->tokid)) {
	      ttok->status = DC_STATUS_RPLDONE;
	      ttok->mb     = tmb;
	      wakeup(ttok);
	    }
	  }
	}
      }
      break;
    }
  }

dc_intr_rcvmrp_abort:
  /* activate current receive buffer */
  mcr_load(rbar, rbra); /* get current rbra */
  mcr_store(rbar, rbra|1);

#ifdef DEBUG
  dtrace("rcvmrp","return",0,0);
#endif
  return(0);
}

STATIC
void
dc_intr_rcvsrp()
{
  /*  utdu changes on 1992/03/18  */
  int         spl;

  spl = splhi();
  if( rcv_stop_semafo > 0 ) {
    rcv_stop_flag = B_TRUE;
    wakeup(&rcv_stop_semafo);
  }
  else {
    mcr_store( MCR_MRPRMI, 0x10000000 );
    asm("brcs  %asam,.");
    mcr_store( MCR_MCMDW, 2 );    /* start rcv */
    rcv_stop_flag = B_FALSE;
    asm("brcs  %asam,.");
  }
  splx(spl);
  
  return;
}


/*****
 *****  Udtu adds following functions on 1992 9/30.
 *****/

void
dtu_snd_stop( sleep_mode )            /* add nosleep on 1992 9/30 */
     int        sleep_mode;
{
  int         spl;

#ifdef DEBUG
    dtrace("sndstop","enter",0,0);
#endif
  spl = splhi();
  ++snd_stop_semafo;
  if( snd_stop_semafo == 1 && !snd_stop_flag )
    mcr_store( MCR_MCMDW, 1 );   /* stop snd */
  if( !snd_stop_flag && sleep_mode == DTU_STOP_SLEEP ) {
    /* sleep(&snd_stop_semafo, PZERO); */
    sleep(&snd_stop_semafo, (PZERO+1)|PCATCH);
  }
  splx(spl);
#ifdef DEBUG
    dtrace("sndstop","return",0,0);
#endif
}

void
dtu_snd_restart()
{
  int         spl;

#ifdef DEBUG
    dtrace("sndrst","enter",0,0);
#endif
  spl = splhi();
  if( --snd_stop_semafo <= 0 && snd_stop_flag ) {
    mcr_store( MCR_MRPRMI, 0x40000000 );
    asm("brcs  %asam,.");
    mcr_store( MCR_MCMDW, 0 );  /* start snd */
    snd_stop_flag = B_FALSE ;
    asm("brcs  %asam,.");
  }
#ifdef DEBUG
    dtrace("sndrst","return",0,0);
#endif
  splx(spl);
}

void
dtu_rcv_stop( sleep_mode )              /* add nosleep on 1992 4/1 */
     int        sleep_mode;
{
  int         spl;

#ifdef DEBUG
    dtrace("rcvstop","enter",0,0);
#endif
  spl = splhi();
  ++rcv_stop_semafo;
  if( rcv_stop_semafo == 1 && !rcv_stop_flag )
    mcr_store( MCR_MCMDW, 3 );   /* stop rcv */
  if( !snd_stop_flag && sleep_mode == DTU_STOP_SLEEP )
    /* sleep(&rcv_stop_semafo, PZERO); */
    sleep(&rcv_stop_semafo, (PZERO+1)|PCATCH);
  splx(spl);
#ifdef DEBUG
    dtrace("rcvstop","return",0,0);
#endif
}

void
dtu_rcv_restart()
{
  int         spl;

#ifdef DEBUG
    dtrace("rcvrst","enter",0,0);
#endif
  spl = splhi();
  if( --rcv_stop_semafo <= 0 && rcv_stop_flag ) {
    mcr_store( MCR_MRPRMI, 0x10000000 );
    asm( "brcs %asam,.");
    mcr_store( MCR_MCMDW, 2 );  /* start rcv */
    rcv_stop_flag = B_FALSE ;
    asm("brcs  %asam,.");
  }
  splx(spl);
#ifdef DEBUG
    dtrace("rcvrst","return",0,0);
#endif
}

int
srcnetpa_ecc( inn, ecc, outn )
    int         inn;    /* input netpa */
    int         ecc;    /* ecc. lowest 6bits */
    int         *outn;  /* corrected netpa. -1 when unable to correct */
{
  int         i,j;
  unsigned    n[16];  /* input-netpa bit-x    */
  unsigned    c[6];   /* ecc bit-x            */
  unsigned    s[6];   /* syndrome bit-x       */
  /*
   *      syndrome correction table
   *              index   syndrome
   *              value   bit position of correction
   *                100:   no need to correct
   *                 -1:   cannot correct
   *                0-15:  netpa bit position to correct
   *               16-21:  ecc bit position to correct
   */
  static short st[0x40] = {
    /*low4bits  0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F*/
    /* 0x */  100, 21, 20, -1, 19, -1, -1,  0, 18, -1, -1,  1, -1,  2, -1, -1,
    /* 1x */   17, -1, -1,  3, -1, -1,  4, -1, -1,  5,  6, -1,  7, -1, -1, -1,
    /* 2x */   16, -1, -1, -1, -1,  8,  9, -1, -1, 10, 11, -1, 12, -1, -1, -1,
    /* 3x */   -1, 13, 14, -1, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};

#ifdef DEBUG
    dtrace("netpaecc","enter",0,0);
#endif
  for( i=15, j=inn; i>=0; --i ) {
    n[ i ] = j & 1;
    j >>= 1;
  }
  for( i=5, j=ecc; i>=0; --i ) {
    c[ i ] = j & 1;
    j >>= 1;
  }
  s[0] = n[ 8]^n[ 9]^n[10]^n[11]^n[12]^n[13]^n[14]^n[15]^c[0];
  s[1] = n[ 3]^n[ 4]^n[ 5]^n[ 6]^n[ 7]^n[13]^n[14]^n[15]^c[1];
  s[2] = n[ 1]^n[ 2]^n[ 5]^n[ 6]^n[ 7]^n[10]^n[11]^n[12]^c[2];
  s[3] = n[ 0]^n[ 2]^n[ 4]^n[ 7]^n[ 8]^n[ 9]^n[12]^n[15]^c[3];
  s[4] = n[ 0]^n[ 1]^n[ 3]^n[ 4]^n[ 6]^n[ 9]^n[11]^n[14]^c[4];
  s[5] = n[ 0]^n[ 1]^n[ 2]^n[ 3]^n[ 5]^n[ 8]^n[10]^n[13]^c[5];
  
  for( i=0, j=0; i<=5; ++i ) {
    j |= s[i];
    j <<= 1;
  }
  
  i = st[j];     /* i = bit_pos of correction */
  if( i < 0 ) {
    *outn = -1;
#ifdef DEBUG
        dtrace("netpaecc","return",-1,0);
#endif
    return( -1 );
  }
  else if( i >= 16 ) {
    *outn = inn;
#ifdef DEBUG
        dtrace("netpaecc","return",0,0);
#endif
    return( 0 );
  }
  else {
    *outn = inn ^ ( 0x8000u >> i );
#ifdef DEBUG
        dtrace("netpaecc","return",0,0);
#endif
    return( 0 );
  }
}
