#ident  "@(#)dc.h	1.3 1/6/93 16:13:22 - FUJITSU UXP/VPP"

/* #ident "@(#)dc.h	1.6 12/16/92" */

/*  KAI DTP driver                           */
/*  DC Layer [ DTP Control service entries ] */
/*  Copyright (c) 1991 by FUJITSU LIMITED    */
/*   Mainframe division                      */
/*   Supercomputer development department    */
/*            Primary writer: Y.Nakashima    */
/*    nakashim@ayame.mfd.cs.fujitsu.co.jp    */

#ifndef _IO_DTU_DC_H
#define _IO_DTU_DC_H

#define	TOTPE		 256

#ifdef SIM
#define	RETRY_INTERVAL     5
#define	TIMER_INTERVAL    10
#define	DC_TIMEOUT         1
#else
#define	RETRY_INTERVAL   500
#define	TIMER_INTERVAL  1000
#define	DC_TIMEOUT        30
#endif

#define RETRYN_PERSISTENT 7
#define RETRYN_SIMPLE	   1

#define HEDRSIZE         128
#define MB01SIZE   (1024+128)
#define MB32SIZE  (32768+128)
#define MAXPSIZE   (33554432)
#define HQNUM           2048
#define	TOTSEL	    	  32 /* max 256 */
#define	TOTDCB          2048
#define	TOTTOK          2048
#define	DCBIDMASK     0x7fff
#define	TOKIDMASK     0x7fff

#define DC_STATUS_EMPTY	   0
#define DC_STATUS_SERROR   1
#define DC_STATUS_RERROR   2
#define DC_STATUS_PCIWAIT  3
#define DC_STATUS_PCIDONE  4
#define DC_STATUS_ACKWAIT  5
#define DC_STATUS_ACKDONE  6
#define DC_STATUS_RPLWAIT  7
#define DC_STATUS_RPLDONE  8
#define DC_STATUS_MONITOR  9
#define DC_STATUS_MONITOR_SEND  10
#define DC_STATUS_MONITOR_RECV  11

#define	DC_CC_NORMALEND	   0
#define DC_CC_RPDOWN	  -1
#define DC_CC_RPSWAP	  -2
#define	DC_CC_EINVAL	  -3
#define	DC_CC_EINUSE	  -4
#define	DC_CC_ENOTOK	  -5
#define	DC_CC_ESNOMEM	  -6
#define	DC_CC_ERNOMEM	  -7
#define	DC_CC_ENOFUNC	  -8
#define	DC_CC_EUMEMDMG    -9
#define	DC_CC_EDTUDMG    -10
#define	DC_CC_ECOMM	 -11
#define	DC_CC_FORCEDOWN	 -12
#define	DC_CC_CANTOK  	 -13
#define	DC_CC_SIGNAL	 -14
#define	DC_CC_NOMSG	 -15

#define	DC_CMD_ACK	   0
#define DC_CMD_SND	   1
#define	DC_CMD_RPL	   2

#define	DC_MODE_PCATCH	0x80
#define	DM_MOD		0x10
#define	DM_MSG		0x08
#define	DM_ACK		0x04
#define	DM_TOK	   	0x02
#define	DM_FUN		0x01

#define	DC_MODE_NACK	(0                                 )
#define	DC_MODE_NMSG	(       DM_MSG                     )
#define	DC_MODE_PUSH	(DM_MOD|DM_MSG                     )
#define	DC_MODE_NFUN	(       DM_MSG              |DM_FUN)
#define	DC_MODE_NLDT	(0                                 )
#define	DC_MODE_NIPL	(DM_MOD                            )
#define	DC_MODE_AMSG	(       DM_MSG|DM_ACK              )
#define	DC_MODE_AFUN    (       DM_MSG|DM_ACK       |DM_FUN)
#define	DC_MODE_ALDT    (              DM_ACK              )
#define	DC_MODE_TMSG	(       DM_MSG|DM_ACK|DM_TOK       )
#define	DC_MODE_NOWAIT	(0                                 )
#define	DC_MODE_WAIT	(1                                 )

#define	DC_SEL_REAL	   0
#define	DC_SEL_LOCAL0	   2
#define	DC_SEL_LOCAL1	   3
#define	DC_SEL_GLOBAL0	   4
#define	DC_SEL_GLOBAL1	   5

struct hqa {
        unsigned   shtqt, resv0;
        unsigned   sltqt, resv1;
        unsigned   u0rqt, resv2;
        unsigned   u0tqt, resv3;
        unsigned   u1rqt, resv4;
        unsigned   u1tqt, resv5;
        unsigned   dmy00, dmy01;
        unsigned   dmy02, dmy03;
        unsigned   dmy04, dmy05;
        unsigned   dmy06, dmy07;
        unsigned   dmy08, dmy09;
        unsigned   dmy10, dmy11;
        unsigned   dmy12, dmy13;
        unsigned   dmy14, dmy15;
        unsigned   dmy16, dmy17;
        unsigned   dmy18, dmy19;
};

struct mb {
	unsigned   dmy0    : 16 ; /* word 0 */
	unsigned   dstnpa  : 16 ;
	unsigned   elnum   : 32 ; /* word 1 */
	unsigned   srcecc  :  8 ; /* word 2 */
	unsigned   dmy2    :  8 ;
	unsigned   srcnpa  : 16 ;
	unsigned   srcqid1 :  4 ; /* word 3 */
	unsigned   srcqid2 :  4 ; 
	unsigned   srcqid3 :  4 ;
	unsigned   srcqid4 :  4 ;
	unsigned   dmy3    : 16 ;
	unsigned   srcdam  :  2 ; /* word 4 */
	unsigned   dstdam  :  2 ;
	unsigned   rbbsf   :  1 ;
	unsigned   dmy4a   :  2 ;
	unsigned   type    :  1 ;
	unsigned   srcpci  :  1 ;
	unsigned   dstpci  :  1 ;
	unsigned   srccti  :  1 ;
	unsigned   dstcti  :  1 ;
	unsigned   srccen  :  1 ;
	unsigned   dstcen  :  1 ;
	unsigned   dmy4b   :  1 ;
	unsigned   dstnpf  :  1 ;
	unsigned   srcvaf  :  1 ;	
	unsigned   dstvaf  :  1 ;
	unsigned   srcvas  :  1 ;
	unsigned   dstvas  :  1 ;
	unsigned   lsync   :  1 ;
	unsigned   hsync   :  1 ;
	unsigned   dmy4c   :  1 ;
	unsigned   svspid  :  1 ;
	unsigned   ipl     :  1 ;
	unsigned   dmy4d   :  6 ;	
	unsigned   dstpid  :  1 ;
	unsigned   dmy5    : 32 ; /* word 5 */
	unsigned   srcbad  : 32 ; /* word 6 */
	unsigned   dstbad  : 32 ; /* word 7 */
	unsigned   srcad1  : 32 ; /* word 8 */
	unsigned   dstad1  : 32 ; /* word 9 */
	unsigned   srcad2  : 32 ; /* word 10 */
	unsigned   dstad2  : 32 ; /* word 11 */
	unsigned   srceln  : 32 ; /* word 12 */
	unsigned   dsteln  : 32 ; /* word 13 */
	unsigned   srccta  : 32 ; /* word 14 */
	unsigned   dstcta  : 32 ; /* word 15 */

	struct mb* llink        ; /* word 16 */
	struct mb* rlink        ; /* word 17 */
	struct dcb*dcb          ; /* word 18 */
	struct tok*tok          ; /* word 19 */
        int        dcbid   : 16 ; /* word 20 */
        int        tokid   : 16 ;
	int        status  :  8 ; /* word 21 */
	int        cc      :  8 ;
	int                : 16 ;
	unsigned   cmd     :  8 ; /* word 22 */
	unsigned   prior   :  8 ;
	unsigned   mode    :  8 ;
	unsigned   sel     :  8 ;
        unsigned   size    : 16 ; /* word 23 */
        unsigned   len     : 16 ;
	unsigned   key          ; /* word 24 */
	unsigned   srcrp        ; /* word 25 */
	unsigned           : 32 ; /* word 26 */
	unsigned           : 32 ; /* word 27 */
	unsigned   param[4]     ; /* word 28-31 */

	char	   msg[1]	;
};

struct statistics {
        unsigned   retrycount;
        unsigned   failcount;
        unsigned   mb01pcount;
        unsigned   mb01bcount;
        unsigned   mb32pcount;
        unsigned   mb32bcount;
        unsigned   ldtpcount;
        unsigned   ldtbcount;
        unsigned   mb01f_enum;
        unsigned   mb32f_enum;
        unsigned   dcbf_enum;
        unsigned   tokf_enum;
        unsigned   dcbq_enum;
        unsigned   tokq_enum;
        unsigned   rbq_enum[TOTSEL];
};

struct dcb {
        struct dcb*llink;
        struct dcb*rlink;
        int        dcbid   : 16 ;
        int        status  :  8 ;
        int        cc      :  8 ;
	unsigned   flag    : 16 ;
	unsigned   dstnpa  : 16 ;
	unsigned   tod;
};

struct tok {
        struct tok*llink;
        struct tok*rlink;
        int        tokid   : 16 ;
        int        status  :  8 ;
        int        cc      :  8 ;
	unsigned   flag    : 16 ;
	unsigned   dstnpa  : 16 ;
        struct mb* mb;
};

#ifdef DEBUG
#define DC_RPUP         0
#define DC_RPDOWN       1
#define DC_REPON        2
#define DC_REPOFF       3
#define DC_REPMCR       4
#define DC_REPN2P       5
#define DC_REPP2N       6

typedef struct dc_rpctl {
        int cmd;        /* UP/DOWN */
        int rp;         /* real processor ID */
        int pp;         /* physical processor ID */
} dc_rpctl_t;
#endif

/*
 *      udtu adds on 1992 10/1
 */

#define DTU_STOP_SLEEP          0
#define DTU_STOP_NOSLEEP        1

#endif /* _IO_DTU_DC_H */

