
#ident "@(#)lc.h	1.1 12/12/92"

/*  KAI DTP driver                            */
/*  LC Layer [ LINK Control service entries ] */
/*          Primary rewriter: Y.Nakashima     */
/*    nakashim@ayame.mfd.cs.fujitsu.co.jp     */

/*	Copyright (c) 1990, 1991 UNIX System Laboratories, Inc.	*/
/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved                             	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF     	*/
/*	UNIX System Laboratories, Inc.                     	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _IO_DC_LC_H	/* wrapper symbol for kernel use */
#define _IO_DC_LC_H	/* subject to change without notice */

/*
 * Ethernet Media Driver header file.
 */

#ifdef _KERNEL

#ifndef _UTIL_TYPES_H
#include <util/types.h>	/* REQUIRED */
#endif

#ifndef _IO_STREAM_H
#include <io/stream.h>	/* REQUIRED */
#endif

#ifndef _IO_DC_LCUSER_H
#include <io/dc/lcuser.h>	/* REQUIRED */
#endif

#ifndef _IO_QUEUE_H
/*#include <io/queue.h>	/* REQUIRED */
#endif

#endif /* _KERNEL */

/*
 * Module information definitions.
 */
#define LC_MID		0x4c43
#define LC_NAME		"LC"
#define LC_HIWAT	4800
#define LC_LOWAT	2000

/*
 * Stream state structure - one per stream (minor device).
 */
struct lc {
	struct lc_ucb* lc_ucb ;
	queue_t*lc_rdq;	/* read queue of stream */
	queue_t*lc_wrq;	/* read queue of stream */
	ushort	lc_state;	/* DLPI state flags */
	ushort	lc_sap;	/* protocol type of this stream */
	ushort	lc_unit ;	/* LC unit no */
};

/*
 * Information kept about each LC adapter.
 * NOTE: The size of this structure in in the lc master file in 
 * raw fromat. This size must be calculated by using the sizes of
 * each item in this structure.
 */
struct lc_ucb {
	dev_t		lu_major;	/* major dev number of the LC adapter */
	struct lc*	lu_lcp;		/* top of lc structures for unit */
	struct ifstats*	lu_ifstat;	/* ifstats for backward compatibility */
	unsigned char	lu_addr[PHYAD_SIZE]; /* network address */
	dev_t		lu_maj ;	/* external major number */
	lc_stat_t	lu_stat ;	/* LC specific statistics */

	caddr_t		lu_frag;	/* recieved fragment buffer */
	int		lu_fragsize;	/* data size in fragment buffer */

	mblk_t*		lu_mp;		/* mblk for ioctl return */
	queue_t*	lu_qp;		/* queue to be ioctl returned */

	int		lu_swcnt;	/* number of send waiting message */
	mblk_t*		lu_sendh;	/* send waiting message queue head */
	mblk_t*		lu_sendt;	/* send waiting message queue tail */
};

#define spllc() spl6()

#define LCTIME	6000L	/* timeout value */
#define DLYVALUE 	50000	/* delay for LC to reset */

/*
 *	Error returns
 */
#define UNINIT	-1
#define FULQUE	-2
#define EMPQUE	-3
#define BAD_ID	-4
#define MEM_FAIL -5
#define MEMFLW	-6
#define PAGE_ERR	-7

/*
 * LCLOG(mid,sid,level,flags,fmt,args) should be used for those trace
 * calls that are only to be made during debugging.
 */

#define REUSEABLE(BP, SIZE) \
	(((BP)->b_datap->db_ref == 1) && \
	(((BP)->b_datap->db_lim - (BP)->b_datap->db_base) >= (SIZE)))

#define liacpy(FROM, TO) { \
				register char *from = (char *)(FROM); \
				register char *to = (char *)(TO); \
				*to++ = *from++; \
				*to++ = *from++; \
				*to++ = *from++; \
				*to++ = *from++; \
				*to++ = *from++; \
				*to = *from; \
			 }



#endif /* _IO_DC_LC_H */

