
#ident "@(#)lcuser.h	1.1 12/12/92"

/*  KAI DTP driver                            */
/*  LC Layer [ LINK Control service entries ] */
/*          Primary rewriter: Y.Nakashima     */
/*    nakashim@ayame.mfd.cs.fujitsu.co.jp     */

/*	Copyright (c) 1990, 1991 UNIX System Laboratories, Inc.	*/
/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF     	*/
/*	UNIX System Laboratories, Inc.                     	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _IO_DC_LCUSER_H	/* wrapper symbol for kernel use */
#define _IO_DC_LCUSER_H	/* subject to change without notice */

/* @(#)lcuser.h	1.1 5/13/92 */

/*
 * LC user interface definitions.
 */

#ifdef _KERNEL

#ifndef _UTIL_TYPES_H
#include <util/types.h>	/* REQUIRED */
#endif

#endif /* _KERNEL */

/*
 * Ethernet address size.
 */
#define PHYAD_SIZE	6

#define LI_LOADBSIZE 128

/*
 * download command structure.
 */
struct liload {
	unsigned short size;
	unsigned short level;
	unsigned char data[LI_LOADBSIZE];
};
#define	LI_LOADLVL_FIRST	0
#define	LI_LOADLVL_MIDDLE	1
#define	LI_LOADLVL_LAST		2

/*
 * Structure for EI_SETA ioctl.
 */
struct liseta {
	char	lis_addr[PHYAD_SIZE];
};

/*
 * ioctl definitions
 */
#define	LI_CODE	('L' << 8)
#define	LI_RESET	(LI_CODE | 1)		/* reset board (is used?) */
#define	LI_LOAD		(LI_CODE | 2)		/* download firmware */
#define	LI_SYSGEN	(LI_CODE | 3)		/* do sysgen (set line/mode) */
#define	LI_SETA		(LI_CODE | 10)		/* set ehter address */
#define	LI_GETA		(LI_CODE | 11)		/* get ehter address */

/*
 * Ethernet header format.
 */
struct ehead {
	char dest_addr[PHYAD_SIZE];
	char src_addr[PHYAD_SIZE];
	union {
		ushort val;
		unsigned char bytes[2];
	} pro_type;
};
#define	EHEAD_OFF_DEST	0		/* offset of destination address */
#define	EHEAD_OFF_SRC	PHYAD_SIZE	/* offset of source address */
#define	EHEAD_OFF_SAP	(PHYAD_SIZE*2)	/* offset of SAP number */

#define EHEADSIZE 14
#define DATINDSIZE (PHYAD_SIZE+PHYAD_SIZE+DL_UNITDATA_IND_SIZE)

#define LCMINPSZ	64
#define LCMAXPSZ	1514

/*
 * Error return codes.
 */

#define LC_NOTOPEN		0x101
#define LC_NOTBIND		0x102
#define LC_ISBIND		0x103
#define LC_802_ERROR		0x104
#define LC_BADPARA		0x105
#define LC_NOMEM		0x106
#define LC_DUP_MUXTYPE	0x107
#define LC_PACK_SIZE		0x108
#define LC_ALR_OPEN		0x109
#define LC_NOSTRUCT		0x10a
#define LC_MAX_MSGLEN		0x10b
#define LC_MTC_ONLY		0x10c
#define LC_BADPROT		0x118
#define LC_BADPULL		0x122	/* more than 4 cont blocks, and */
					/* pullup failed */
#define LC_EVTOP		0x133
#define LC_EFW		0x134
#define LC_XPAGE		0x135	/* too many buffers crossed page */
					/* boundary */

/*
 * Complete return codes.
 */
#define	LC_FINISHED		0x200	/* just return don't free up the bp */

typedef struct	lc_stat
{
	struct
	{
		time_t		start ;	/* LC start time */
		time_t		update ;/* statistics time */
		unsigned long	interrupts ;	/* LC interrupts count */
		unsigned long	memory_error ;	/* LC memory errors count */
		unsigned long	drop_packets ;
	} com ;
	struct
	{
		unsigned long	frames ;	/* Xmt Packets count */
		unsigned long	babbles ;	/* Babblings count */
		unsigned long	collisions ;	/* Collisions count */
		unsigned long	more_collisions; /* More collisions count */
		unsigned long	defferds ;	/* defferd errors count */
		unsigned long	buffer_errors ;	/* BUffer errors count */
		unsigned long	underflows ;	/* underflow errors count */
		unsigned long	late_collisions;/* Late Collisions count */
		unsigned long	loss_of_carrier;/* Carrier Loss count */
		unsigned long	retry_errors ;	/* Retry Errors count */
	} tx ;
	struct
	{
		unsigned long	frames ;	/* Rcv Packets count */
		unsigned long	miss_packets ;	/* Missed Packets count */
		unsigned long	frame_errors ;	/* Framing Errors count */
		unsigned long	overflows ;	/* Overflow errors count */
		unsigned long	crc_errors ;	/* CRC Errors count */
		unsigned long	buffer_errors ;	/* Buffer errors count */
		unsigned long	long_packets ;	/* Long packets count */
		unsigned long	short_packets ;	/* Short packets count */
	#define		LC_STAT_SIZES_UNIT	128
	#define		LC_STAT_SIZES_NUM	16
		unsigned long	sizes[LC_STAT_SIZES_NUM] ;
	} rx ;
}	lc_stat_t ;

#endif /* _IO_DC_LCUSER_H */

