#ident  "@(#)oc.h	1.2 12/21/92 22:12:27 - FUJITSU UXP/VPP"

/* #ident "@(#)oc.h	1.3 10/01/92" */

#ifndef _IO_DTU_OC_H
#define _IO_DTU_OC_H

/*  KAI DTP driver                           */
/*  OC Layer [ DTP Control service entries ] */
/*  Copyright (c) 1991 by FUJITSU LIMITED    */
/*   Mainframe division                      */
/*   Supercomputer development department    */
/*            Primary writer: Y.Nakashima    */
/*    nakashim@ayame.mfd.cs.fujitsu.co.jp    */

#ifndef _IO_DTU_DC_H
#include "io/dtu/dc.h"
#endif

typedef struct px_page_info {
    int   * from;   /* sending data address (virtual) */
    u_int * to;     /* write data dest-address (real) */
    int     len;    /* write data length              */
} px_page_info_t;

#define DTU_NORMALEND   DC_CC_NORMALEND
#define DTU_EINVAL      DC_CC_EINVAL
#define DTU_ENOMEM      DC_CC_ESNOMEM
#define DTU_SIGNAL      DC_CC_SIGNAL
#define DTU_NOMSG       DC_CC_NOMSG
#define DTU_ENOENT      DC_CC_ENOFUNC 
#define DTU_ETMO        DC_CC_ECOMM

#define DTU_ENETPA	DC_CC_RPDOWN   /* temporary definition */
#define DTU_RPDOWN	DC_CC_RPDOWN   /* temporary definition */
#define DTU_RPSWAP	DC_CC_RPSWAP   /* temporary definition */
#define DTU_EMLEN	-100           /* temporary definition */
#define DTU_PFATAL	-101           /* temporary definition */

#define DTU_BASE        0
#define DTU_HIGH        1

#define DTU_NOREPLY     DC_MODE_NMSG
#define DTU_ASYNCREPL   DC_MODE_AMSG

#define DTU_NOWAIT      DC_MODE_NOWAIT
#define DTU_WAIT        DC_MODE_WAIT

/*
 * Message Receive Queue ID define
 */
#define DTU_ERR_MQ          -2    /* for dtu-driver */
#define DTU_DC_CANCEL_MQ    -1       /* for dtu cancel           */
#define DTU_ERR_LOG_MQ       0       /* for dtu-error            */
#define DTU_OC_MQ            1       /* for dtu misc server      */
#define DTU_DLPI_MQ          2       /* for DLPI                 */
#define DTU_DTUSVR_MQ        3       /* for User-dtu and Barrier */
#define DTU_ETC_MQ           4       /* for OS-communicate test  */
#define DTU_OPR_MQ           5    /* for system-manager */
#define DTU_SA_PMS_MQ        6    /* for scheduler */
#define DTU_PE_PMS_MQ        7
#define DTU_PRSVR_MQ         8
#define DTU_PRMSVR_MQ        9
#define DTU_PAGER_MQ        10    /* for memory-manager */
#define DTU_SWAPPER_MQ      11
#define DTU_GS_MQ           12
#define DTU_IPC1_MQ         13    /* for IPC */
#define DTU_IPC2_MQ         14
#define DTU_IPC3_MQ         15
#define DTU_PFS_MQ          16    /* for file manager */
#define DTU_SCFS_MQ         17
#define DTU_PE_CONSOLE_MQ   18    /* console and etc. server's Queue */
#define DTU_PFS_FILED_MQ    19    /* for PFS */
#define DTU_PFS_PFSD_MQ     20
#define DTU_PFS_BIOD_MQ     21
#define DTU_PFS_PIPED_MQ    22
#define DTU_PFS_SPECD_MQ    23
#define DTU_PFS_ASYNCD_MQ   24
#define DTU_PFS_GLIST_MQ    25
#define DTU_PRSVR2_MQ       26

#define DTU_MISC_MQ2    DTU_PE_CONSOLE_MQ

#ifdef SPMS
#define DTU_SPMS_MQ         30
#endif /* SPMS */

/* data type defintion */
/* typedef short      px_peid_t; */
typedef int        oc_msqid_t;
typedef unsigned   wait_token_t;

/* #define dtu_allocb(n)   dc_p_alloc(n) */
/* #define dtu_freeb(addr) dc_p_free(addr) */

#ifdef DEBUG
/*
 * for test environ
 */ 
typedef struct  parm{
    int    testcode;
    int    target;
    int    msqid;  
    int    mtype; 
    int    msglen;
    int    prior;
    int    mode;
}dtuparm_t;

extern int dtutest();
extern int dtusend();
extern int dturpc();
extern int dturead();
extern int dtuwrite();

#define DTU_TEST_NORMAL     0xF0
#define DTU_TEST_NOREPL     0xF1
#define DTU_TEST_TIMEOUT    0xF2
#define DTU_TEST_PANIC      0xF3

#endif /* DEBUG */

#endif /* _IO_DTU_OC_H */
