static char SccsId[] = "@(#)macc.c	4.10    9/25/91    15:06:41";

/*************************************************************************
*
*  HISTORY  :
*        V00/L01 89.10.23                                 by k.sekine
*        V01/L01 89.11.02                                 by k.sekine
*        V01/L02 89.11.10                                 by k.sekine
*        V01/L03 90.01.18                                 by h.koseki
*        V01/L04 90.02.25                                 by h.koseki
*
*************************************************************************/

#define MAC_INIT

#include "macc.h"

main(argc, argv )
    int     argc;
    char    *argv[];
{
    FILE            *fprl;
    FILE            *fpwl, *fpwo;
    int             i, cnt, err_skip;
    int             m_hashval, err_code;
    char            *tmp, *dp;
    char            ver_buf[64];
    char            ext_buf[256];
    static  char    wnam_buf[256];
    static  char    lnam_buf[256];
    static  char    sym_buf[256];
    static  char    nam_buf[256];

    fp[0].fpr = fprl = stdin;
    fpwo = stdout;
    fpwl = NULL;
    ext_buf[0] = NULL;
    err_skip = 0;
    next_level = 256;
    prm_cnt = 0;
    hashval = 0;
    
    if((eintent = (unsigned *)calloc(MINTENT_SIZ,sizeof(unsigned *))) == NULL ){
        err_mes( "memory allocation error\n");
        goto err_exit;
    }
    if((macent = (char *) malloc(MACENT_SIZ)) == NULL) {
        err_mes( "memory allocation error\n");
        goto err_exit;
    }
    if((shift_ent = (char *) malloc(SHIFT_SIZ)) == NULL) {
        err_mes( "memory allocation error\n");
        goto err_exit;
    }
    if((mac_lst = (MAC_LLST *) calloc(MACTBL_CNT,sizeof(MAC_LLST))) == NULL) {
        err_mes( "memory allocation error\n");
        goto err_exit;
    }

    for( i=cnt=1 ; i<argc ; i++ ){
        if( *argv[i] == '-' ){
            /*
            if( strlen( argv[i] ) > 2 ){
                err_mes( "can't option %s\n", argv[i] );
                goto err_exit;
            }
            */
            switch( *(++argv[i]) ){
                case 'l' :
                    if( ++i < argc ){
                        if( ( fpwl = fopen( argv[i], "w" ) ) == NULL ){
                            err_mes( "can't open %s\n", argv[i] );
                            goto err_exit;
                        }
                    }
                    else{
                        err_mes( "can't find -l file\n" );
                        goto err_exit;
                    }
                    break;
                case 'o' :
                    if( ++i < argc ){
                        if( ( fpwo = fopen( argv[i], "w" ) ) == NULL ){
                            err_mes( "can't open %s\n", argv[i] );
                            goto err_exit;
                        }
                    }
                    else{
                        err_mes( "can't find -o file\n" );
                        goto err_exit;
                    }
                    break;
                case 'u' :
                    if( ++i < argc ){
                        if( ( fprl = fopen( argv[i], "r" ) ) == NULL ){
                            err_mes( "can't open %s\n", argv[i] );
                            goto err_exit;
                        }
                    }
                    else{
                        err_mes( "can't find -f file\n" );
                        goto err_exit;
                    }
                    break;

                case 'x' :
                    if( ++i < argc ){
                        strcpy( ext_buf, argv[i] );
                    }
                    else{
                        err_mes( "can't find -x ext_name\n" );
                        goto err_exit;
                    }
                    break;
                case 'L' :
                    if( ++i < argc ){
                        next_level = atoi( argv[i] );
                    }
                    else{
                        err_mes( "can't find -L ext_name\n" );
                        goto err_exit;
                    }
                    break;
                case 'e' :
                    err_skip = 1;
                    break;
                case 'v' :
                    if( ( fp[0].fpr = fopen( MAS_VER, "r" ) ) == NULL ){
                        err_mes( "can't open %s\n", argv[i] );
                        goto err_exit;
                    }
                    fgets( ver_buf, 64, fp[0].fpr );
                    fclose( fp[0].fpr );
                    fprintf( stderr, "TaChyon Macro processor V%s", ver_buf );
                    fprintf( stderr,
                    "All Rights Reserved Copyright (C) FUJITSU LIMITED 1990\n" );
                    fprintf( stderr, "Licensed Material Property of FUJITSU\n" );
                    fp[0].fpr = stdin;
                    break;
                case 'D' :
                    ++argv[i];
                    strcpy( sym_buf, argv[i] );
                    if( *sym_buf != '"' ){
                        if( ( tmp = strtok( sym_buf, "=" ) ) == NULL ){
                            err_mes( "can't option %s\n", argv[i] );
                            goto err_exit;
                        }
                        tmp = strtok( NULL, "=" );
                        p_sthash( sym_buf, tmp, MAC_DFS, asn_tbl );
                    }
                    else{
                        ++argv[i];
                        if( *( argv[i] + strlen( argv[i] ) - 1 )  != '"' ){
                            err_mes( "can't option %s\n", argv[i] );
                            goto err_exit;
                        }
                        *( argv[i] + strlen( argv[i] ) - 1 ) = NULL;
                        p_sthash( argv[i], NULL, MAC_DFS, asn_tbl );
                    }
                    break;
                case 'A' :
                    ++argv[i];
                    strcpy( sym_buf, argv[i] );
                    if( *sym_buf != '"' ){
                        if( ( tmp = strtok( sym_buf, "=" ) ) == NULL ){
                            err_mes( "can't option %s\n", argv[i] );
                            goto err_exit;
                        }
                        tmp = strtok( NULL, "=" );
                        p_sthash( sym_buf, tmp, MAC_ASS, asn_tbl );
                    }
                    else{
                        ++argv[i];
                        if( *( argv[i] + strlen( argv[i] ) - 1 )  != '"' ){
                            err_mes( "can't option %s\n", argv[i] );
                            goto err_exit;
                        }
                        *( argv[i] + strlen( argv[i] ) - 1 ) = NULL;
                        p_sthash( argv[i], NULL, MAC_ASS, asn_tbl );
                    }
                    break;
                default :
                    err_mes( "can't option -%s\n", argv[i] );
                    goto err_exit;
                    break;
            }
        }
        else{
            argv[cnt++] = argv[i];
        }
    }

    fpr_level = 0;

    p_sthash( "null", NULL, MAC_DEF, asn_tbl );
    p_sthash( ".",    "." , MAC_DEF, asn_tbl );

    /*
    for( i=0 ; *mname[i] != '?' ; i++ ){
        tmp = mname[i] + 1;
        if((m_hashval = sthash(tmp)) == -1){
            goto err_exit;
        }
        (macro_lst+m_hashval)->name = (char *)entrycd(tmp);
        (macro_lst+m_hashval)->hash = NULL;
        (macro_lst+m_hashval)->type = i;
        (macro_lst+m_hashval)->pcnt = NULL;
    }
    for( i=0 ; *ra_name[i] != '?' ; i++ ){
        if((m_hashval = sthash(ra_name[i])) == -1){
            goto err_exit;
        }
        (macro_lst+m_hashval)->name = (char *)entrycd(ra_name[i]);
        (macro_lst+m_hashval)->hash = NULL;
        (macro_lst+m_hashval)->type = M_ASM;
        (macro_lst+m_hashval)->pcnt = NULL;
    }
    */

    if( cnt > 1 ){
        for( i=1 ; i<cnt ; i++ ){
            if( ( fp[0].fpr = fopen( argv[i], "r" ) ) == NULL ){
                err_mes( "can't open %s\n", argv[i] );
                goto err_exit;
            }
            strcpy( fp[0].name, argv[i] );
            if( err_code = setjmp( sjenv ) ){
                error_ctl( err_code );
                goto err_exit;
            }
            maccbody( fpwo, fpwl );
            fclose( fp[0].fpr );
        }
    }
    else{
        if( err_code = setjmp( sjenv ) ){
            error_ctl( err_code );
            goto err_exit;
        }
        maccbody( fpwo, fpwl );
    }
    if( fpwo != stdout ){
        fclose( fpwo );
    }
    if( fpwl ){
        fclose( fpwl );
    }
    if( fprl != stdin ){
        if( !*ext_buf ){
            strcpy( ext_buf, "mao" );
        }
        while( fgets( fp[0].name, 256, fprl ) ){
            if( ( tmp = strtok( fp[0].name, " \t\n:,!" ) ) == NULL ){
                 err_mes( "index file format error\n" );
                 goto err_exit;
            }
            *wnam_buf = NULL;
            *lnam_buf = NULL;
            if( ( dp = strtok( NULL, "\n" ) ) ){
                for( ; *dp ;  ){
                    for( ; isspace( *dp ) ; dp++ );
                    if( *dp == '-' ){
                        switch( *(++dp) ){
                            case 'l' :
                                for( ++dp ; isspace( *dp ) ; dp++ );
                                if( ( tmp = strtok( dp, " \t" ) ) == NULL ){
                                    err_mes( "can't find -l file\n" );
                                    goto err_exit;
                                }
                                else{
                                    strcpy( lnam_buf, tmp );
                                    dp += ( strlen(tmp) + 1 );
                                }
                                break;
                            case 'o' :
                                for( ++dp ; isspace( *dp ) ; dp++ );
                                if( ( tmp = strtok( dp, " \t" ) ) == NULL ){
                                    err_mes( "can't find -o file\n" );
                                    goto err_exit;
                                }
                                else{
                                    strcpy( wnam_buf, tmp );
                                    dp += ( strlen(tmp) + 1 );
                                }
                                break;
                            case 'D' :
                                dp++;
                                tmp = nam_buf;
                                *sym_buf = NULL;
                                while( tmp ){
                                    for( ; isspace( *dp ) ; dp++ );
                                    if( *dp == '"' ){
                                        *tmp++ = *dp++;
                                        for( ; *dp && ( ( *dp != '"' ) ||
                                                ( *(dp-1) == '\\' ) ) ; dp++ ){
                                            *tmp++ = *dp;
                                        }
                                        if( !*dp ){
                                            err_mes( "undefined parameter\n" );
                                            goto err_exit;
                                        }
                                        *tmp++ = *dp++;
                                    }
                                    else{
                                        for( ; *dp && ( *dp != '=' ) &&
                                               !isspace(*dp) && ( *dp != ',' ) ;
                                                                         dp++ ){
                                            *tmp++ = *dp;
                                        }
                                    }
                                    *tmp = NULL;
                    
                                    switch( *dp ){
                                        case '=' :
                                            if( *sym_buf == NULL ){
                                                strcpy( sym_buf, nam_buf );
                                            }
                                            else{
                                                err_mes(
                                                  "double \"=\" parameter\n" );
                                                goto err_exit;
                                            }
                                            tmp = nam_buf;
                                            dp++;
                                            break;
                                        default :
                                            if( *sym_buf == NULL ){
                                                p_sthash( nam_buf, NULL,
                                                            MAC_DFS, asn_tbl );
                                            }
                                            else{
                                                p_sthash( sym_buf, nam_buf,
                                                            MAC_DFS, asn_tbl );
                                            }
                                            *sym_buf = NULL;
                                            tmp = 0;
                                            break;
                                    } 
                                } 
                                break;
                            case 'A' :
                                dp++;
                                tmp = nam_buf;
                                *sym_buf = NULL;
                                while( tmp ){
                                    for( ; isspace( *dp ) ; dp++ );
                                    if( *dp == '"' ){
                                        *tmp++ = *dp++;
                                        for( ; *dp && ( ( *dp != '"' ) ||
                                                ( *(dp-1) == '\\' ) ) ; dp++ ){
                                            *tmp++ = *dp;
                                        }
                                        if( !*dp ){
                                            err_mes( "undefined parameter\n" );
                                            goto err_exit;
                                        }
                                        *tmp++ = *dp++;
                                    }
                                    else{
                                        for( ; *dp && ( *dp != '=' ) &&
                                               !isspace(*dp) && ( *dp != ',' ) ;
                                                                         dp++ ){
                                            *tmp++ = *dp;
                                        }
                                    }
                                    *tmp = NULL;
                    
                                    switch( *dp ){
                                        case '=' :
                                            if( *sym_buf == NULL ){
                                                strcpy( sym_buf, nam_buf );
                                            }
                                            else{
                                                err_mes(
                                                  "double \"=\" parameter\n" );
                                                goto err_exit;
                                            }
                                            tmp = nam_buf;
                                            dp++;
                                            break;
                                        default :
                                            if( *sym_buf == NULL ){
                                                p_sthash( nam_buf, NULL,
                                                            MAC_ASS, asn_tbl );
                                            }
                                            else{
                                                p_sthash( sym_buf, nam_buf,
                                                            MAC_ASS, asn_tbl );
                                            }
                                            *sym_buf = NULL;
                                            tmp = 0;
                                            break;
                                    } 
                                } 
                                break;
                            default :
                                err_mes( "can't option -%s\n", dp );
                                goto err_exit;
                                break;
                        }
                    }
                    else{
                        break;
                    }
                }
            }

            if( ( fp[0].fpr = fopen( fp[0].name, "r" ) ) == NULL ){
                err_mes( "can't open %s\n", fp[0].name );
                goto err_exit;
            }      
            if( *wnam_buf == NULL ){
                strcpy( wnam_buf, fp[0].name );
#ifdef  UTS
                for( tmp=wnam_buf+strlen(wnam_buf)-1 ;
                     ( *tmp != '.' ) && ( tmp>=wnam_buf ) ; tmp-- );
                if( tmp <= wnam_buf ){
                    strcat( wnam_buf, ext_buf );
                }
                else{
                    strcpy( ++tmp, ext_buf );
                }
#else
                if( ( tmp = rindex( wnam_buf, '.' ) ) ){
                    strcpy( ++tmp, ext_buf );
                }
                else{
                    strcat( wnam_buf, ext_buf );
                }
#endif
            }
            if( ( fpwo = fopen( wnam_buf, "w" ) ) == NULL ){
                err_mes( "can't open %s\n", wnam_buf );
                goto err_exit;
            }
            if( *lnam_buf != NULL ){
                if( ( fpwl = fopen( lnam_buf, "w" ) ) == NULL ){
                    err_mes( "can't open %s\n", lnam_buf );
                    goto err_exit;
                }
            }
            else{
                fpwl = NULL;
            }
            if( err_code = setjmp( sjenv ) ){
                err_mes( "**** %s write error break *****\n\n", wnam_buf );
                error_ctl( err_code );
                if( !err_skip ){
                    goto err_exit;
                }
            }
            maccbody( fpwo, fpwl );
            fclose( fp[0].fpr );
            if( fpwo != stdout ){
                fclose( fpwo );
            }
            if( fpwl ){
                fclose( fpwl );
            }
        }
    }
    exit( 0 );
err_exit:
    for( i = 0 ; i < fpr_level ; i++ ){
        if( fp[i].fpr != stdin ){
            fclose( fp[i].fpr );
        }
    }
    if( fprl != stdin ){
        fclose( fprl );
    }
    if( fpwo != stdout ){
        fclose( fpwo );
    }
    if( fpwl ){
        fclose( fpwl );
    }
    exit( 1 );
}


maccbody( fpwo, fpwl )
    FILE    *fpwo, *fpwl;
{
    int      tmp, lab_cnt;
    char     *dp, *s1, *lab, *tokp, *svchr;
    static char lab_buf[256];
    static char linep[FGET_SIZ];
    static char stl_buf[FGET_SIZ];
    static char char_type[256] = {
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   /* @ABCDEFGHIJKLMNO */
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   /* PQRSTUVWXYZ[\]^_ */
       0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0,   /* _!"#$%&'()*+,-./ */
       1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0,   /* 0123456789:;<=>? */
       0, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,   /* @ABCDEFGHIJKLMNO */
       3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 0, 0, 0, 3,   /* PQRSTUVWXYZ[\]^_ */
       0, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,   /* `abcdefghijklmno */
       3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 3, 0, 0,   /* pqrstuvwxyz{|}~. */
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

    fp[fpr_level].cnt = 0;
    while(strgets(linep, &svchr) != NULL ){
        linep[strlen(linep) - 1] = NULL;;
        for( s1 = linep ; isspace( *s1 ) ; s1++ );
        if( char_type[*s1] & 2 ){
            lab_cnt = 0;
            lab_buf[lab_cnt++] = *s1;
            for( lab=s1+1 ; char_type[*lab] & 1 ; lab++ ){
                lab_buf[lab_cnt++] = *lab;
            }
            if( *lab == ':' ){
                lab_buf[lab_cnt++] = ':';
                lab_buf[lab_cnt++] = NULL;
                /* s1 = ++lab; */
                for( s1 = lab+1 ; isspace( *s1 ) ; s1++ );
            }
            else{
                if( *s1 == '.' ){
                    lab_buf[0] = NULL;
                    lab_cnt = 0;
                }
                else{
                    for( dp=lab ; isspace( *dp ) ; dp++ );
                    if( *dp == '.' ){
                        lab_buf[lab_cnt++] = NULL;
                        s1 = dp;
                        lab_cnt = 0;
                    }
                    else{
                        lab_buf[0] = NULL;
                        lab_cnt = 0;
                    }
                }
            }
        }
        else{
            lab_buf[0] = NULL;
            lab_cnt = 0;
        }

        /* for( s1 = linep ; isspace( *s1 ) ; s1++ ); */
        
        if( *s1 == '.' && isalpha(*(s1+1)) ){
            /* '.' find */
            if( (tokp = strtok( s1, " \t\n" ) ) != NULL ){
                tmp = chkhash( tokp );
                switch( tmp ){
                    case M_USER :
                        if( mac_f ){
                            if( lab_cnt ){
                                mkbdy(lab_buf);
                            }
                            convbuf(tokp, fpwo, fpwl, svchr);
                        }
                        else{
                            if( lab_cnt ){
                                strputs( fpwo, fpwl, lab_buf, lab_buf); 
                            }
                            for( tmp = 0 ; tmp < PRITBL_CNT + 1 ; tmp++ ){
                                prm_tbl[tmp].name = NULL;
                            }
                            mac_cnt = 0;
                            ifflg = 0;
                            ncnt = 0;
                            convdt(tokp, fpwo, fpwl, svchr);
                            if( mac_cnt ){
                                sprintf( error_buf, "%d next macro error (%d)",
                                                  fp[fpr_level].cnt, mac_cnt );
                                longjmp( sjenv, 1 );
                            }
                            mac_cnt = -1;
                        }
                        break;
                    case M_ASM :
                        if( mac_f ){
                            mkbdy(svchr);
                        }
                        else{
                            s1 = (char *)argcal( svchr, stl_buf, NULL);
                            strputs( fpwo, fpwl, s1, stl_buf );
                        }
                        break;
                    case M_MACRO   :
                    case M_IFDEF   :
                    case M_IFNDEF  :
                    case M_IFASS   :
                    case M_IFNASS  :
                    case M_ELSE    :
                    case M_ENDIF   :
                    case M_AIF     :
                    case M_AELSE   :
                    case M_AENDI   :
                    case M_AREPEAT :
                    case M_AENDR   :
                    case M_AWHILE  :
                    case M_AENDW   :
                    case M_ENDM    :
                    case M_EXITM   :
                    case M_INCLUDE :
                    case M_ERROR   :
                        for( s1 = linep ; isspace( *s1 ) ; s1++ );
                        if( *s1 != '.' ){
                            sprintf( error_buf, "%d macro label error %s %s", 
                                        fp[fpr_level].cnt, linep, tokp ); 
                            longjmp( sjenv, 2 );
                        }
                        mklst(tmp);
                        break;
                    case M_ASSIGNS :
                    case M_ASSIGNA :
                    case M_ASSIGNB :
                    case M_ASSIGNO :
                    case M_ASSIGND :
                    case M_ASSIGNX :
                    case M_DEFINES :
                    case M_DEFINEA :
                        /*
                        if( !mac_f ){
                            sprintf( error_buf,
                                   "%d invalid statement",fp[fpr_level].cnt );
                            longjmp( sjenv, 3 );
                        }
                        */
                        mklst_assign( lab_buf, tokp, tmp, svchr );
                        break;
                    default :
                        sprintf( error_buf, "%d macc error 1 %s",
                                                    fp[fpr_level].cnt, tokp );
                        longjmp( sjenv, 4 );
                        break;
                }
            }
            else{
                sprintf( error_buf, "%d macc error 2 %s",
                                                    fp[fpr_level].cnt, tokp );
                longjmp( sjenv, 5 );
            }
        }
        else{
            if( mac_f ){
                mkbdy(svchr);
            }
            else{
                s1 = (char *)argcal( svchr, stl_buf, NULL);
                strputs( fpwo, fpwl, s1, stl_buf );
            }
        }
    }
}

    /*
mac_check( dp )
    char    *dp;
{
    int     m_hashval;
    char    *tmp;

    if((m_hashval = chkhash(dp)) == -1)
        return( M_ASM );

    return( (macro_lst+m_hashval)->type );
    
    if( !isupper( *( dp + 1 ) ) ){
        return( M_ASM );
    }
    for( tmp=0 ; *mname[tmp] != '?' ; tmp++ ){
        if( !strcmp( dp, mname[tmp] ) ){
            break;
        }
    }
    if( *mname[tmp] != '?' ){
        return( tmp );
    }
    else{
        return( M_USER );
    }
}
    */

label_check( sp, dp, fpwo, fpwl ) 
    char    *sp, *dp;
    FILE    *fpwo, *fpwl;
{
    char    *tmp;
 
    for( ; isspace( *sp ) ; sp++ );
    if( sp < dp ){
        *dp = ' ';
        for( tmp=sp ; !isspace( *tmp ) ; tmp++ );
        if( *(tmp - 1) == ':' ){ 
            *( tmp ) = NULL; 
            strputs( fpwo, fpwl, sp, sp ); 
            for( tmp++ ; tmp<dp ; tmp++ ){
                if( isspace( *tmp ) ){ 
                    sprintf( error_buf, "%d macro label error %s %s", 
                                              fp[fpr_level].cnt, sp, tmp ); 
                    longjmp( sjenv, 6 );
                }
            }   
        } 
        else{ 
            sprintf( error_buf, "%d macro define label error %s", 
                                                   fp[fpr_level].cnt, sp ); 
            longjmp( sjenv, 7 );
        }
    } 
    return( 0 ); 
}


comment_cut( pptr )
    char    *pptr;
{
    char    *dp;

    for( ; isspace( *pptr ) ; pptr++ );
    for( dp=pptr ; *dp ; dp++ ){
        if( *dp == '\"' ){
            for( dp++ ; *dp && ((*dp != '\"') || (*(dp-1) == '\\')) ; dp++ );
            if( !( *dp ) ){
                return( -1 );
            }
        }
        else{
            if( *dp == '\\' ){
                if( *(dp+1) == '!' ){
                    *dp = NULL;
                    break;
                }
                if( *(dp+1) ){
                    dp++;
                }
            }
            else{
                if( *dp == '!' ){
                    *dp = NULL;
                    break;
                }
            }
        }
    }
    for( dp=pptr+strlen( pptr )-1 ; isspace( *dp ) ; dp-- ){
        *dp = NULL;
    }
    return((long) dp);
}

mkbdy(lptr)
char  *lptr;
{
    char  *spptr;

    spptr = lptr;
    /*
    for( spptr = lptr ; isspace( *spptr ) ; spptr++ );
    if( ( *spptr == NULL ) || ( *spptr == '\n' ) ){
        return;
    }
    for( ; *spptr && ( ( *spptr != '\\' ) || ( *(spptr+1) != '!' ) ) ; spptr++);
    if( ( *spptr != NULL ) && ( *spptr != '\n' ) ){
        *spptr++ = '\n';
        *spptr = NULL;
    }
    */
    (mac_lst+hashval)->type = MAC_BDY;
    (mac_lst+hashval)->llink = (char *)entrycd(lptr);
    if(if_flag) {
        tbl_id->llink = (char *) (mac_lst+hashval);
        if_flag = 0;
    }
    else
        tbl_id->rlink = (char *) (mac_lst+hashval);
    tbl_id = mac_lst+hashval;
    hashval++;
}



char  svdt[PARA_TMP];

entrycd(ptr)
char  *ptr;
{
    char  *stptr;

    if( ptr ){
        if( entsize+strlen(ptr)+2 >= MACENT_SIZ ){
            strcpy( svdt, ptr );
            if( (macent = (char *) malloc(MACENT_SIZ) ) == NULL ){
                longjmp( sjenv, 8 );
            }
            entsize = 0;
            stptr = macent;
            strcpy( macent, svdt);
            entsize += ( strlen(svdt)+1 );
            macent += ( strlen(svdt)+1 );
            return( (long)stptr );
        }
        stptr = macent;
        strcpy(macent,ptr);
        entsize += ( strlen(ptr)+1 );
        macent += ( strlen(ptr)+1 );
    }
    else {
        if( entsize++ >= MACENT_SIZ ){
            if( ( macent = (char *) malloc(MACENT_SIZ) ) == NULL ){
                longjmp( sjenv, 8 );
            }
            entsize = 0;
        }
        stptr = macent;
        *macent++ = NULL;
    }
    return( (long)stptr );
}

unsigned svint1,svint2,svint3;

entryint( tmp1, tmp2, tmp3)
unsigned tmp1, tmp2, tmp3;
{
    unsigned  *stptr;

    if( (eintsize+2) >= MINTENT_SIZ ){
        svint1 = tmp1;
        svint2 = tmp2;
        svint3 = tmp3;
        if( (eintent =
            (unsigned *) calloc(MINTENT_SIZ,sizeof(unsigned *)) ) == NULL ){
            longjmp( sjenv, 8 );
        }
        eintsize = 0;
        stptr = eintent;
        *eintent     = svint1;
        *(eintent+1) = svint2;
        *(eintent+2) = svint3;
        eintsize += 3;
        eintent  += 3;
        return( (unsigned)stptr );
    }
    stptr = eintent;
    *eintent     = tmp1;
    *(eintent+1) = tmp2;
    *(eintent+2) = tmp3;
    eintsize += 3;
    eintent  += 3;
    return( (unsigned)stptr );
}



/*
strcpy(a, b) char *a, *b;
{
    if (!b) return;
    while (*b)
        *a++ = *b++;
        *a = NULL;
    return;
}
*/

/*
strlen(aa) char *aa;
{
    int cc = 0;
    if (!aa) return(0);
    while (*aa++) cc++;
    return(cc);
}
*/

bufc(cptr,ccnt)
char *cptr;
register int ccnt;
{
    while(ccnt >= 0)
        *(cptr+ccnt--) = NULL;
}


err_mes(s, i, j, k, l)
    char    *s;
    int     i, j, k, l;
{
    fprintf( stderr, s, i, j, k, l);
    fflush( stderr );
    return( -1 );
}


err_mes_r(s, i, j, k, l)
    char    *s;
    int     i, j, k, l;
{
    fprintf( stderr, s, i, j, k, l);
    fprintf( stderr, " ***** %s *****\n", fp[fpr_level].name );
    fflush( stderr );
    return( -1 );
}


strgets(ptr, svchr)
    char  *ptr;
    char  **svchr;
{
    static char    svbuf[FGET_SIZ];
    int            dp;

strgets_top:
    if( fgets( svbuf, FGET_SIZ, fp[fpr_level].fpr ) != NULL ){
        fp[fpr_level].cnt++;
        for( dp = 0;
             svbuf[dp] && ( ( svbuf[dp] != '\\' ) || ( svbuf[dp+1] != '!' ) ) ;
             dp++);
        if( !dp ){
            goto strgets_top;
        }
        if( ( svbuf[dp] != NULL ) && ( svbuf[dp] != '\n' ) ){
            svbuf[dp] = '\n';
            svbuf[dp+1] = NULL;
        }
        /*
        svbuf[strlen(svbuf) - 1] = NULL;;
        */
        strncpy( ptr, svbuf, FGET_SIZ );
        *svchr = svbuf;
        return( 1 );
    }
    else{
        if( fpr_level ){
            fclose( fp[fpr_level--].fpr );
            goto strgets_top;
        }
        *svchr = NULL;
        return( NULL );
    }
}


strputs_m(ptr, fpwo, fpwl, svchr)
    char  *ptr;
    FILE  *fpwo, *fpwl;
    char  *svchr;
{
    if( fpwl ){
        fputs( ">  ", fpwl );
        if( *svchr == '#' ){
            fputs( svchr+1, fpwl );
        }
        else{
            fputs( svchr, fpwl );
        }
    }
    if( *ptr == '#' ){
        fputs( "!  ", fpwo );
        fputs( ptr+1, fpwo );
    }
    else{
        fputs( "   ", fpwo );
        fputs( ptr, fpwo );
    }
}

strputs( fpwo, fpwl, svchr, svchrl)
    FILE  *fpwo, *fpwl;
    char  *svchr, *svchrl;
{
    if( fpwl ){
        fputs( "   ", fpwl );
        fputs( svchrl, fpwl );
    }
    fputs( "   ", fpwo );
    fputs( svchr, fpwo );
}

strputs_s( fpwo, fpwl, svchr)
    FILE  *fpwo, *fpwl;
    char  *svchr;
{
    if( fpwl ){
        fputs( "   ", fpwl );
        fputs( svchr, fpwl );
    }
    fputs( "!  ", fpwo );
    fputs( svchr, fpwo );
}
