/* @(#)macc.h	4.8    8/10/93 */

/* COPYRIGHT FUJITSU LIMITED 1990 */

/*************************************************************************
*
*  NAME  : macinc.h
*
*  FUNCTION : tachyon architecture MACRO converter include file
*
*  SYNOPSIS :
*
*  RETURN   :
*
*  HISTORY  :
*        V01/L01 90.04.16                                 by h.koseki
*
*************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <setjmp.h>
#ifndef  UTS
#include <strings.h>
#endif

typedef struct {
        char  *name;
        int   hash;
        int   type;
        int   pcnt;
} MACRO_LIST;
        
typedef struct {
        int   type;
        char  *llink;
        char  *rlink;
} MAC_LLST;
        
typedef struct {
        MAC_LLST *adr;
        int   flag;
        int   mode;
} NOD_TBL;
        
typedef struct {
        char  *name;
        char  *pram;
} PRM_BUF;

typedef struct {
        char  *name;
        char  *pram;
        short mode;
        short len;
} PRM_TBL;

typedef struct {
        FILE  *fpr;
        int   cnt;
        char  name[256];
} FPR_TYPE;

#ifndef MAS_VER
#define   MAS_VER      "/usr/kai/lib/version.macc"
#endif

enum mac_symbol_def {  MAC_NULL,
                       MAC_DEF,
                       MAC_MAC,
                       MAC_END,
                       MAC_PRM,
                       MAC_BDY,
                       MAC_IFD,
                       MAC_NFD,
                       MAC_IFA,
                       MAC_NFA,
                       MAC_AIF,
                       MAC_CHK,
                       MAC_IFT,
                       MAC_CHR,
                       MAC_IRH,
                       MAC_CHW,
                       MAC_IWH,
                       MAC_EXT,
                       MAC_INC,
                       MAC_ERR,
                       MAC_ASS,
                       MAC_ASA,
                       MAC_ASB,
                       MAC_ASO,
                       MAC_ASX,
                       MAC_DFS,
                       MAC_DFA,
                    };

#define   NULL         0
#define   MACROTBL_CNT 0x400
#define   MACTBL_CNT   40960
#define   MACENT_SIZ   0x20000
#define   MINTENT_SIZ  0x0100
#define   MACENT_LNG   8000
#define   PARA_TMP     0x4000

#define   PRITBL_CNT   0x200
#define   PRIBUF_CNT   0x2000

#define   SHIFT_SIZ    2000

#define   FGET_SIZ     512
#define   FGET_BUF     2048
/*
 * #define   ARG_MAX      32
 */
#define   rehash(x)    ((x+137) % MACROTBL_CNT + 1)
#define   p_rehash(x)  ((x+137) % PRITBL_CNT + 1)

#define   M_ASM        -2
#define   M_USER       -1

enum macro_symbol_def {  M_MACRO,
                         M_IFDEF,
                         M_IFNDEF,
                         M_IFASS,
                         M_IFNASS,
                         M_ELSE,
                         M_ENDIF,
                         M_AIF,
                         M_AELSE,
                         M_AENDI,
                         M_AREPEAT,
                         M_AENDR,
                         M_AWHILE,
                         M_AENDW,
                         M_ENDM,
                         M_EXITM,
                         M_INCLUDE,
                         M_ERROR,
                         M_ASSIGNS,
                         M_ASSIGNA,
                         M_ASSIGNB,
                         M_ASSIGNO,
                         M_ASSIGND,
                         M_ASSIGNX,
                         M_DEFINES,
                         M_DEFINEA,
                         M_NULL      };

#define   C_SUBSTR     0
#define   C_SUBNSTR    1
#define   C_INSTR      2
#define   C_LENGTH     3
#define   C_SHIFT      4
#define   C_ARGC       5
#define   C_CONVSTR    6
#define   C_CONVNSTR   7
#define   C_NULL       8

#define   CHK_STRING   1
#define   CHK_ISDIGIT  2

#ifdef    MAC_INIT
#ifdef    MAC_MAKE
char  *mname[] = { ".MACRO",
                   ".IFDEF",
                   ".IFNDEF",
                   ".IFASS",
                   ".IFNASS",
                   ".ELSE",
                   ".ENDIF",
                   ".AIF",
                   ".AELSE",
                   ".AENDI",
                   ".AREPEAT",
                   ".AENDR",
                   ".AWHILE",
                   ".AENDW",
                   ".ENDM",
                   ".EXITM",
                   ".INCLUDE",
                   ".ERROR",
                   ".ASSIGNS",
                   ".ASSIGNA",
                   ".ASSIGNA.B",
                   ".ASSIGNA.O",
                   ".ASSIGNA.D",
                   ".ASSIGNA.X",
                   ".DEFINES",
                   ".DEFINEA",
                   "?" };

char  *ra_name[] = { "abort",
                     "align",
                     "ascii",
                     "asciz",
                     "byte",
                     "char",
                     "comm",
                     "common",
                     "data",
                     "data1",
                     "data2",
                     "def",
                     "desc",
                     "dfloat",
                     "double",
                     "ebcdic",
                     "even",
                     "extended",
                     "ffloat",
                     "file",
                     "fill",
                     "float",
                     "gdbbeg",
                     "gdbblock",
                     "gdbend",
                     "gdbline",
                     "gdblinetab",
                     "gdbsym",
                     "gfloat",
                     "global",
                     "globl",
                     "half",
                     "hexa",
                     "hfloat",
                     "ident",
                     "int",
                     "lcomm",
                     "lcommon",
                     "line",
                     "ln",
                     "long",
                     "lsym",
                     "octa",
                     "org",
                     "proc",
                     "quad",
                     "reserve",
                     "seg",
                     "set",
                     "short",
                     "single",
                     "skip",
                     "space",
                     "stabd",
                     "stabn",
                     "stabs",
                     "text",
                     "tfloat",
                     "using",
                     "value",
                     "version",
                     "word",
                     "?" };

MACRO_LIST macro_lst[MACROTBL_CNT+1];
#else
#include "macroini.def"
#endif
 
char  *iftbl[] = { "..", "EQ", "NE", "LT", "LE", "GT", "GE", "?" };
char  *cname[] = { ".SUBSTR(",
                   ".SUBNSTR(",
                   ".INSTR(",
                   ".LENGTH(",
                   ".SHIFT(",
                   ".ARGC(",
                   ".CONVSTR(",
                   ".CONVNSTR(",
                   "?" };
int    c_len[] = { 8, 9, 7, 8, 7, 6, 9, 10, 0 };
 
char  nuladr[2];
char  nulnam[6] = { "null" };
#else
extern char *iftbl[];
extern char *cname[];
extern int  c_len[];

extern char nuladr[];
extern char nulnam[];

extern MACRO_LIST macro_lst[];
#endif

int   ael_f;
int   mac_f;
int   prm_cnt;
int   lst_cnt;
int   mac_cnt;
int   nod_cnt;
int   if_flag;
int   entsize;
int   eintsize;

int   next_level;
int   fpr_level;

int   ifflg;
int   ncnt;
char  *ntbl[512];
int   rtbl[512];
int   exitm[512];

char  error_buf[1024];

jmp_buf sjenv;

int   prm_st_cnt;
int   prm_st[PRITBL_CNT + 1];

FPR_TYPE fp[8];
 
MAC_LLST   *tbl_id;
MAC_LLST   *nod_id;
MAC_LLST   *mac_id;
MAC_LLST   *mac_lst;
int        hashval;
 
PRM_TBL  asn_tbl[PRITBL_CNT + 1];
PRM_TBL  prm_tbl[PRITBL_CNT + 1];

PRM_BUF  prm_buf[PRIBUF_CNT + 1];

char      *macent;
unsigned  *eintent;
char      *shift_ent;

NOD_TBL nod_tbl[256];
