static char SccsId[] = "@(#)asl.c	1.4(11/6/91)";

/* asl.c - listing program. 1989/12/1 by Y.Nakashima */

#include <stdio.h>
 
#define BUF_LINE 2048

int	SCOL  = 62;
int	WRAP  = 144;
int	LINES = 60;
int	b;
int	line;

char	buf_l  [BUF_LINE];
char	buf_r  [BUF_LINE];
char	buf_o  [BUF_LINE];
char    label  [BUF_LINE];
char    pseudo [BUF_LINE];
char    comment[BUF_LINE];
 
main(argc, argv) int argc; char **argv;
{
        FILE	*fp_l = stdin;
	FILE	*fp_r = NULL;
        int	l_count;
	int	r_count;
	int	done_l;
	int	done_r;
 
        for (argc--; argc > 0; argc--) {
          if (*argv[argc] == '-') {
            if (*(argv[argc]+1)) { /* number is expected */
              if (sscanf(argv[argc]+1, "%d", &LINES) != 1) {
                fprintf(stderr, "'%s' not positive number\n", argv[argc]+1);
                exit(1);
              }
              if (LINES <= 0) {
                fprintf(stderr, "'%s' not positive number\n", argv[argc]+1);
                exit(1);
              }
            }
            else { /* single '-' */
              SCOL = 48;
              WRAP = 80;
            }
          }
          else { /* filename is expected */
            if (fp_r == NULL) {
              if ((fp_r = fopen(argv[argc], "r")) == NULL) {
                fprintf(stderr, "can't open %s\n", argv[argc]);
                exit(1);
	      }
            }
            else if (fp_l == stdin) {
              if ((fp_l = fopen(argv[argc], "r")) == NULL) {
                fprintf(stderr, "can't open %s\n", argv[argc]);
                exit(1);
	      }
            }
            else {
              fprintf(stderr, "too many filenames\n");
	      exit(1);
	    }
          }
        }

        if (fp_r == NULL) {
	  fprintf(stderr, "usage: %s [-] [-<n>] <right_file>\n", *argv);
	  fprintf(stderr, "       %s [-] [-<n>] <left_file> <right_file>\n", *argv);
          exit(1);
        }

	line = LINES;

	for (;;) {
          if (!getline(buf_l, fp_l))
	    exit(1);
          sscanf(buf_l, "%d", &l_count);
          if (l_count)
   	    break;
	}

	r_count = 1;

	for (;;) {
	  if (l_count < r_count) {
            if (!getline(buf_l, fp_l))
	      break;
            sscanf(buf_l, "%d", &l_count);
            if (l_count == 0)
   	      continue;
	  }

	  if (l_count < r_count) {
	    sprintf(buf_o, "%s\n", buf_l+6);
	  }
	  else if (l_count > r_count) {
	    if (!getline(buf_r, fp_r))
	      exit(1);

	    if (SCOL == 48)
	      sprintf(buf_o, "%-46s%6d %s\n", "", r_count, buf_r);
	    else
              sprintf(buf_o, "%-62s%6d %s\n", "", r_count, buf_r);
 	    r_count ++;
	  }
	  else {
	    if (!getline(buf_r, fp_r))
	      exit(1);
	    if (SCOL == 48)
	      sprintf(buf_o, "%-46s%6d %s\n", buf_l+6, r_count, buf_r);
	    else
              sprintf(buf_o, "%-62s%6d %s\n", buf_l+6, r_count, buf_r);
 	    r_count ++;
	  }
	  putline(buf_o);
	}
	while (getline(buf_r, fp_r)) {
	  if (SCOL == 48)
	    sprintf(buf_o, "%-46s%6d %s\n", "", r_count, buf_r);
	  else
            sprintf(buf_o, "%-62s%6d %s\n", "", r_count, buf_r);
 	  r_count ++;
	  putline(buf_o);
	}
	/* fclose (buf_l); */
	/* fclose (buf_r); */
	exit(0);
}

putline(bufp) char *bufp;
{
	int	a;
	char	c;
	char	*i = bufp;

	while (c = *i++) {
          if (line >= LINES) {
            if (SCOL == 48)
              printf("##FORMFEED##\n*ADDR*     DATA+----1----+----2----+----3---  *LINE*    SOURCE---1----+----2----\n");
            else
              printf("##FORMFEED##\n*ADDR*     DATA+----1----+----2----+----3----+----4----+----  *LINE*    SOURCE---1----+----2----+----3----+----4----+----5----+----6----+----7--\n");
            line = 0;
          }
	  switch (c) {
          case '\n':
          case '\r':
            a = 0;
            break;
          case '\t':
            a = (b + 8) & ~7;
            break;
          default:
            a = b + 1;
          }
          if (a > WRAP) {
            if (++line >= LINES) {
              if (SCOL == 48)
                printf("\n##FORMFEED##\n*ADDR*     DATA+----1----+----2----+----3---  *LINE*    SOURCE---1----+----2----");
              else
                printf("\n##FORMFEED##\n*ADDR*     DATA+----1----+----2----+----3----+----4----+----  *LINE*    SOURCE---1----+----2----+----3----+----4----+----5----+----6----+----7--");
              line = 0;
            }
            if (SCOL == 48) {
	      printf("\n%-53s+  ", "");
              b = 56;
            }
            else {
              printf("\n%-69s+  ", "");
              b = 72;
            }
          }
          putchar(c);
          switch (c) {
          case '\n':
          case '\r':
            line++;
            b = 0;
            break;
          case '\t':
            b += 8;
            b &= ~7;
            break;
          default:
            b++;
            break;
          }
        }
}

getline(bufp, stream) char *bufp; FILE *stream;
{
	char	*i;

    	if (fgets(bufp, BUF_LINE, stream) != NULL) {
	  for (i = bufp; *i; i++);
	  *(i - 1) = NULL;
	  return (1);
	}
	return (0);
}

extract(bufp) char *bufp;
{
#define skip_space() {for(;*i&&(*i==' '||*i=='\t'||*i=='\n');i++);}

	char	*i, *j;
	int	label_exist;
	int	pseudo_exist;
	int	comment_exist;

	*label   = NULL;
	*pseudo  = NULL;
	*comment = NULL;

	i = bufp;

/* extract label */
	skip_space();
	for (label_exist=0, j=i; *j; j++) {
	  if (*j==':') {
	    label_exist = 1;
	    break;
	  }
	  else if (!(*j=='.'||*j=='_'||*j=='$'||(*j>='0'&&*j<='9')
	   ||(*j>='A'&&*j<='Z')||(*j>='a'&&*j<='z'))) {
	    label_exist = 0;
	    break;
	  }
	}
	if (label_exist) {
	  strncpy(label, i, BUF_LINE);
	  *(label+(j-i)+1) = NULL;
	  i = j+1;
	}
	else
	  i = bufp;

/* extract pseudo */
	skip_space();
	if (*i == '.') {
	  strncpy(pseudo, i, BUF_LINE);
	  for (comment_exist=0, j=i; *j; j++) {
            if (*j=='|'||*j=='!'||*j=='#'||(*j=='/'&&*(j+1)=='*')) {
	      comment_exist = 1;
	      break;
	    }
	  }
	  if (comment_exist) {
	    *(pseudo+(j-i)) = NULL;
	    strncpy(comment, j, BUF_LINE);
	  }
	}

/* extract comment */
	else {
	  for (comment_exist=0, j=i; *j; j++) {
            if (*j=='|'||*j=='!'||*j=='#'||(*j=='/'&&*(j+1)=='*')) {
	      comment_exist = 1;
	      break;
	    }
	  }
	  if (comment_exist)
	    strncpy(comment, j, BUF_LINE);
	}
}

