/* @(#)tachyon.h	1.4    6/13/90 */

/* tachyon.h -- Header file for the TaChyon
   Copyright (C) 1989 Free Software Foundation, Inc.

This file is part of GAS, the GNU Assembler.

GAS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GAS; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
 * The following enum and struct were borrowed from
 * sunOS  /usr/include/sun4/a.out.h
 *
 */

enum reloc_type
{
    RELOC_5,         RELOC0_5,        RELOC1_5,
    RELOC_U5,        RELOC0_U5,       RELOC1_U5,
    RELOC_12,        RELOC_25,        RELOC_32,
    RELOC_BASE25,    RELOC_PCREL12,   RELOC_PCREL32,   
    RELOC_SYSU4,     RELOC_SYSU8,     RELOC_SYS25,
    RELOC_SYSBASE25, RELOC_JMP_TBL,   RELOC_RELATIVE,

    NO_RELOC
};

struct reloc_info_tachyon
{
    unsigned long int r_address;
/*
 * Using bit fields here is a bad idea because the order is not portable. :-(
 */
    unsigned int r_index    : 24;
    unsigned int r_extern   : 1;
    unsigned int unused     : 2;
    unsigned int r_type     : 5;
    long int r_addend;
};

#define relocation_info reloc_info_tachyon

/*
 * For listing to stdout
 */
struct listing {
    unsigned char type; /* 0:insn, 1:data, 2:string */
    unsigned char term; /* 1:terminate, 0:continue */
    unsigned char *top;
    unsigned char *buf;
    unsigned offset;
    unsigned size; 
    unsigned lineno;
    char *str[3];
    char indr[3];
    struct listing *nextptr;
} listing_buf;

struct listing *listing_top;
struct listing *listing_cur;
