static char SccsId[] = "@(#)main.c	1.3    8/26/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* main.c	89/10/1 */

#include "tim.h"
#include "ip-decode.h"
#include "disasm.c"

swap4(x) unsigned x;
{
  return (((x)<<24)|(((x)&0xff00)<<8)|(((x)&0xff0000)>>8)|((x)>>24));
}

main(argc, argv) int argc; char **argv;
{
    if (argc == 2) {
      *(unsigned*)(pe[0].symtbl=(unsigned char *)malloc(4))=4;
      pe[0].symsize = 4;
      pe[T_PE].map_free[0].abs_addr = 0;
      pe[T_PE].map_free[0].bytes    = MEM_SIZE;
      if (read_module(0, 'r', 0, argv[1], 2, 0, 'n')) {
        disasm(0, 'r', swap4(*(unsigned *)(pe[T_PE].header+20)), swap4(*(unsigned *)(pe[T_PE].header+4))/8, 0);
        exit(0);
      }
    }
    exit(1);
}

o_nop(){} o_call(){} o_brc0(){} o_brnc0(){} o_brc1(){} o_brnc1(){}
o_seti(){} o_brcs0(){} o_brncs0(){} o_brcs1(){} o_brncs1(){} o_jmp(){}
o_ld_c(){} o_ld_cu(){} o_ld_s(){} o_ld_su(){} o_ld(){} o_ld_l(){}
o_ld_f(){} o_ld_d(){} o_ld_pf(){} o_ld_pd(){} o_st_c(){} o_st_s(){}
o_st(){} o_st_d(){} o_st_f(){} o_mov_if(){} o_mov_fi(){} o_mov_ld(){}
o_mov_dl(){} o_mult(){} o_mult_l(){} o_mult_lu(){} o_ld_c25(){}
o_ld_cu25(){} o_ld_s25(){} o_ld_su25(){} o_ld25(){} o_ld_l25(){}
o_ld_f25(){} o_ld_d25(){} o_ld_pf25(){} o_ld_pd25(){} o_st_c25(){}
o_st_s25(){} o_st25(){} o_addi25(){} o_addli25(){} o_subi25(){}
o_subli25(){} o_and25(){} o_or25(){} o_xor25(){} o_st_f25(){}
o_st_d25(){} o_mult25(){} o_mult_l25(){} o_mult_lu25(){} o_add(){}
o_addl(){} o_sub(){} o_subl(){} o_and(){} o_or(){} o_xor(){} 
o_sra(){} o_srl(){} o_sll(){} o_addi5(){} o_addli5(){} o_subi5(){}
o_subli5(){} o_sra5(){} o_srl5(){} o_sll5(){} o_fadd(){} o_fadd_d(){}
o_fadd_x(){} o_fsub(){} o_fsub_d(){} o_fsub_x(){} o_fcmp(){} o_fcmp_d(){}
o_fcmp_x(){} o_fmul(){} o_fmul_d(){} o_fdiv(){} o_fdiv_d(){} o_fcnv_fd(){}
o_fcnv_df(){} o_fcnv_if(){} o_fcnv_fi(){} o_fcnv_id(){} o_fcnv_di(){}
o_fcnv_dx(){} o_fcnv_xd(){} o_fcnz_fi(){} o_fcnz_di(){} o_svc(){}
o_fwc(){} o_ldsr(){} o_stsr(){} o_ld_mcr(){} o_st_mcr(){} o_wbst(){}
o_movgs(){} o_movsg(){} o_movgt(){} o_movtg(){} o_ptlbe(){} o_ptlbp(){}
o_ptlba(){} o_flche(){} o_flcha(){} o_aki(){} o_rti(){} o_cs(){} o_COP(){}

/******************* MEM ************************************************/

#define         MEMHASH_SIZE     8192
#define         memrehash(x)     ((x+137) % MEMHASH_SIZE)
static struct   memshash  { char *name; unsigned memaddr; };
static struct   memahash  { unsigned type, memaddr; char *name; };
static struct   memshash  MEMSHASH[PE_NUM][MEMHASH_SIZE];
static struct   memahash  MEMAHASH[PE_NUM][MEMHASH_SIZE];

init_memhash(t_pe) unsigned t_pe;
{
    unsigned       t_syms, i;
    unsigned char  *t_strings;
    unsigned       tmp;

    t_syms    = swap4(*(unsigned *) (pe[T_PE].header+16));
    t_strings = pe[T_PE].symtbl+t_syms;

    for (i=0; i<MEMHASH_SIZE; i++) {
        MEMSHASH[T_PE][i].name = NULL;
        MEMAHASH[T_PE][i].type = 0;
    }
    /* read symbols from a.out */
    for (i=0; i<t_syms; i+=12) {
        if (!pe[T_PE].symtbl[i+4] & 0xfe) {
            message("undefined: %s\n",t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]));
            continue;
        }
        MEMSHASH[T_PE][put_memshash(t_pe, t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]), swap4(*(unsigned*)&pe[T_PE].symtbl[i+8]))].memaddr
        = swap4(*(unsigned*)&pe[T_PE].symtbl[i+8]);
        tmp = put_memahash(t_pe, swap4(*(unsigned*)&pe[T_PE].symtbl[i+8]), t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]));
        MEMAHASH[T_PE][tmp].name = (char*)(t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]));
        MEMAHASH[T_PE][tmp].type = pe[T_PE].symtbl[i+4] & 0xfe;
    }
}

mem_hash(s) char *s;
{
    unsigned hashval;
        
    for (hashval=0; *s == '$' || *s == '_' || *s == '.' || isalnum(*s);)
        hashval += *s++;
    return(hashval % MEMHASH_SIZE);
}

put_memshash(t_pe, name, memaddr) unsigned t_pe, memaddr; char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = mem_hash(name);
    while (MEMSHASH[T_PE][hashval].name != NULL) {
        if (!strcmp(name, MEMSHASH[T_PE][hashval].name)) {
	  /* message("duplicated label: %s (0x%08.8X -> 0x%08.8X)\n", name, MEMSHASH[T_PE][hashval].memaddr, memaddr); */
	  return(hashval);
	}
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (MEMSHASH[T_PE][hashval].name != NULL) message("too many SYMBOLs: %s is ignored\n", name);
    MEMSHASH[T_PE][hashval].name = name;
    return(hashval);
}

put_memahash(t_pe, memaddr, name) unsigned t_pe, memaddr; char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = memaddr % MEMHASH_SIZE;
    while (MEMAHASH[T_PE][hashval].type) {
        if (memaddr == MEMAHASH[T_PE][hashval].memaddr) {
	  /* message("duplicated address: 0x%08.8X (%-16s -> %-16s)\n", memaddr, MEMAHASH[T_PE][hashval].name, name); */
	  return(hashval);
	}
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (MEMAHASH[T_PE][hashval].type) message("too many SYMBOLs: %s is ignored\n", name);
    MEMAHASH[T_PE][hashval].memaddr = memaddr;
    return(hashval);
}

get_memname(t_pe, memaddr, name) unsigned t_pe, memaddr; char **name;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned  hashval, hashsave;
#define EXT_MEMNAME_SIZE 82
    static char ext_memname[EXT_MEMNAME_SIZE];
 
    hashval = hashsave = memaddr % MEMHASH_SIZE;
    while (MEMAHASH[T_PE][hashval].type) {
        if (memaddr == MEMAHASH[T_PE][hashval].memaddr) {
          strncpy(*name = ext_memname, MEMAHASH[T_PE][hashval].name, 81);
          ext_memname[81] = NULL;
          return(0);
        }
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    sprintf(*name = ext_memname, "0x%08.8X", memaddr);
    return(1);
}

cmd_mem_map(t_pe, num, prot, start, end, abs_addr)
    unsigned t_pe;
    unsigned num; /* MAP[] entry */
    unsigned prot;
    unsigned start;
    unsigned end;
    unsigned *abs_addr;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned bytes, tmp;

    if (start > end) {
      message("mapping length < 0\n");
      return(1);
    }
    for (tmp = 0; tmp < MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (!(start < pe[T_PE].map[tmp].start && end < pe[T_PE].map[tmp].start)
          &&!(start > pe[T_PE].map[tmp].end   && end > pe[T_PE].map[tmp].end)) {
	  message("mapping duplicated\n");
	  return(1);
	}
      }
    }

    bytes = end - start + 1;

    if (bytes) {
      for (tmp = 0; tmp < MAP_FREE_NUM; tmp++) {
        if (pe[T_PE].map_free[tmp].bytes >= bytes) {
          *abs_addr = pe[T_PE].map_free[tmp].abs_addr;
	  pe[T_PE].map_free[tmp].abs_addr += bytes;
	  pe[T_PE].map_free[tmp].bytes    -= bytes;
          pe[T_PE].map[num].prot           = prot;
          pe[T_PE].map[num].start          = start;
          pe[T_PE].map[num].end            = end;
          pe[T_PE].map[num].abs_addr       = *abs_addr;
	  return(0);
        }
      }
    }

    message("not enough continuous memory\n");

    return(1);
}

cmd_mem_access(t_pe, t_mode, addr, len, rw, d, t_forcew)
    unsigned t_pe;
    unsigned t_mode; /* 'r': real 'v' : virtual */
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned *d;
    unsigned t_forcew;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned real_addr;
    unsigned abs_addr;
    unsigned *abs_ptr;

    if (len != 8 && len != 1) {
        message("illegal: mem len=%u\n", len);
        return(1);
    }
    if (addr & (len-1)) {
        message("not aligned: mem addr=0x%08.8X len=%u\n", addr, len);
        return(1);
    }

    if (get_mem_real_addr(t_pe, t_mode, rw, addr, &real_addr, t_forcew))
	return(1);

    if (get_abs_addr(t_pe, rw, real_addr, &abs_addr, t_forcew))
        return(1);
        
    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
      switch (len) {
      case 8:
        *d++ = swap4(*abs_ptr++);
        *d   = swap4(*abs_ptr);
	break;
      case 1:
	*d   = *(unsigned char *) abs_ptr;
	break;
      }
      return(0);
    }
    else if (rw == _W_) {
      switch (len) {
      case 8:
        *abs_ptr++ = swap4(*d++);
        *abs_ptr   = swap4(*d);
	break;
      case 1:
	*(unsigned char *) abs_ptr = *d;
	break;
      }
      return(0);
    }
    else {
      message("internal error: cmd_mem_access.rw=0x%X (must be _R_ or _W_)\n", rw);
      return(1);
    }
}

get_mem_real_addr(t_pe, t_mode, rw, addr, real_addr, t_forcew)
    unsigned t_pe;
    unsigned t_mode;
    unsigned rw;
    unsigned addr;
    unsigned *real_addr;
    unsigned t_forcew;
    /* return 1 if failed, 0 if succeeded */
{
    if (t_mode == 'r') {
        *real_addr = addr;
    }
    else {
        message("internal error: get_mem_real_addr.mode='%c' (must be 'r' or 'v')\n", t_mode);
        return(1);
    }
    return(0);
}

get_abs_addr(t_pe, rw, real_addr, abs_addr, t_forcew)
    unsigned t_pe;
    unsigned rw;
    unsigned real_addr;
    unsigned *abs_addr;
    unsigned t_forcew; /* 'y', 'n', 's'(for SVP) */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned tmp;

    for (tmp=0; tmp<MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (real_addr>=pe[T_PE].map[tmp].start&&real_addr<=pe[T_PE].map[tmp].end) {
          if (pe[T_PE].map[tmp].prot & rw) {
            *abs_addr = pe[T_PE].map[tmp].abs_addr+(real_addr-pe[T_PE].map[tmp].start);
            return(0);
	  }
	  else {
            message("memory map protection error: prot=%s%s%s\n",
 	      pe[T_PE].map[tmp].prot & _R_ ? "R" : "-",
              pe[T_PE].map[tmp].prot & _W_ ? "W" : "-",
              pe[T_PE].map[tmp].prot & _X_ ? "X" : "-");
            return(1);
	  }
        }  
      } 
    } 
    message("memory not exist: real_addr=0x%08.8X\n", real_addr);
    return(1);
}

message(s, i, j, k, l, m, n, o)
    char *s; int i, j, k, l, m, n, o;
{
    printf(s, i, j, k, l, m, n, o);
}

read_module(t_pe, t_mode, addr, s, f, use_addr, t_forcew)
    /* return 0 if failed, size if succeeded */
    unsigned t_pe;	  /* pe# */
    unsigned t_mode;	  /* 'r': real 'v': virtual */
    unsigned addr;	  /* target address */
    char *s;		  /* file name */
    unsigned f;		  /* 0: line asm module        */
    			  /* 1: read full load module  */
    			  /* 2: memmap & read full load module */
    unsigned use_addr;    /* 1:use addr(parameter->a_entry) 0:use a_entry */
    unsigned t_forcew;    /* 'y':ignore protection 'n':obey protection */
{
    unsigned char TMP_HEADER[HEADER_SIZE];
    unsigned char *a_header;
    unsigned *a_info, *a_text,  *a_data,   *a_bss;
    unsigned *a_syms, *a_entry, *a_trsize, *a_drsize;
    unsigned *strings;
    unsigned read_buf[2];
    unsigned abs_addr;
    int fd, i;

    if (f) { /* case a.out header/full load module */
        a_header = pe[T_PE].header;
        a_info   = (unsigned *)  pe[T_PE].header    ;
        a_text   = (unsigned *) (pe[T_PE].header+ 4);
        a_data   = (unsigned *) (pe[T_PE].header+ 8);
        a_bss    = (unsigned *) (pe[T_PE].header+12);
        a_syms   = (unsigned *) (pe[T_PE].header+16);
        a_entry  = (unsigned *) (pe[T_PE].header+20);
        a_trsize = (unsigned *) (pe[T_PE].header+24);
        a_drsize = (unsigned *) (pe[T_PE].header+28);
    }
    else {
        a_header = TMP_HEADER;
        a_info   = (unsigned *)  TMP_HEADER    ;
        a_text   = (unsigned *) (TMP_HEADER+ 4);
        a_data   = (unsigned *) (TMP_HEADER+ 8);
        a_bss    = (unsigned *) (TMP_HEADER+12);
        a_syms   = (unsigned *) (TMP_HEADER+16);
        a_entry  = (unsigned *) (TMP_HEADER+20);
        a_trsize = (unsigned *) (TMP_HEADER+24);
        a_drsize = (unsigned *) (TMP_HEADER+28);
    }

    if ((fd = open(s, O_RDONLY)) == -1) {
        message("can't open \"%s\"\n", s);
        goto exit_read_module;
    }

    if (read(fd, a_header, HEADER_SIZE) != HEADER_SIZE) {
        message("can't read %s's header\n", s);
        goto exit_read_module;
    }

    if (swap4(*a_info) != (TACHYONMAGIC | OMAGIC)) {
        message("%s not tim-type module\n", s);
        goto exit_read_module;
    }

    if ((i = ((swap4(*a_text)+swap4(*a_data)+swap4(*a_bss)+PAGE_SIZE-1) & ~(PAGE_SIZE-1)) / PAGE_SIZE) > PAGE_NUM) {
        message("too many pages required: %u\n", i);
        goto exit_read_module;
    }

    if (use_addr)
        *a_entry = swap4(addr);

    if (f == 2) { /* get real memory first */
        if (i > 0 && cmd_mem_map(t_pe, 0, _R_|_W_|_X_, swap4(*a_entry), swap4(*a_entry)+i*PAGE_SIZE-1, &abs_addr)) {
            goto exit_read_module;
	}
    }

    for (i=0; i<swap4(*a_text); i+=1) {
        if (read(fd, read_buf, 1) != 1) {
            message("can't read %s's text\n", s);
            goto exit_read_module;
	}
        if (cmd_mem_access(t_pe, t_mode, swap4(*a_entry)+i, 1, _W_, read_buf, t_forcew)) {
            goto exit_read_module;
	}
    }
    for (i=0; i<swap4(*a_data); i+=1) {
        if (read(fd, read_buf, 1) != 1) {
            message("can't read %s's data\n", s);
            goto exit_read_module;
        }
        if (cmd_mem_access(t_pe, t_mode, swap4(*a_entry)+swap4(*a_text)+i, 1, _W_, read_buf, t_forcew)) {
            goto exit_read_module;
	}
    }
    read_buf[0] = read_buf[1] = 0;
    for (i=0; i<swap4(*a_bss); i+=8) {
        if (cmd_mem_access(t_pe, t_mode, swap4(*a_entry)+swap4(*a_text)+swap4(*a_data)+i, 8, _W_, read_buf, t_forcew)) {
            goto exit_read_module;
	}
    }

    if (f && swap4(*a_syms)) {
      if ((pe[T_PE].symtbl = (unsigned char*)realloc(pe[T_PE].symtbl, i = swap4(*a_syms)+4))==NULL) {
        message("too large symbol table: %u\n", i);
        goto exit_read_module;
      }
      if (read(fd, pe[T_PE].symtbl, swap4(*a_syms)+4) != swap4(*a_syms)+4) {
        message("can't read %s's symbol\n", s);
        goto exit_read_module;
      }
      strings = (unsigned *) (pe[T_PE].symtbl+swap4(*a_syms));
      if ((pe[T_PE].symtbl = (unsigned char*)realloc(pe[T_PE].symtbl, i = swap4(*a_syms) + swap4(*strings)))==NULL) {
        message("too large symbol table: %u\n", i);
        goto exit_read_module;
      }
      if (read(fd, pe[T_PE].symtbl+swap4(*a_syms)+4, swap4(*strings)-4) != swap4(*strings)-4) {
        message("can't read %s's symbol\n", s);
        goto exit_read_module;
      }
      pe[T_PE].symsize = i;
      init_memhash(t_pe);
    }

    if (swap4(*a_text))
      message("text=0x%08.8X-0x%08.8X\n", swap4(*a_entry), swap4(*a_entry)+swap4(*a_text)-1);
    if (swap4(*a_data))
      message("data=0x%08.8X-0x%08.8X\n", swap4(*a_entry)+swap4(*a_text), swap4(*a_entry)+swap4(*a_text)+swap4(*a_data)-1);
    if (swap4(*a_bss))
      message("bss =0x%08.8X-0x%08.8X\n", swap4(*a_entry)+swap4(*a_text)+swap4(*a_data), swap4(*a_entry)+swap4(*a_text)+swap4(*a_data)+swap4(*a_bss)-1);

    close(fd);
    return(swap4(*a_entry)+swap4(*a_text)+swap4(*a_data)+swap4(*a_bss));

exit_read_module:
    *a_info = swap4(TACHYONMAGIC | OMAGIC);
    *a_syms = 0;
    pe[T_PE].symsize = 0;
    close(fd);
    return(0);
}

sprint_symbol(t_pe, addr, buf) unsigned t_pe, addr; char *buf;
{
  char *sym;

  if (get_memname(t_pe, addr, &sym))
    sprintf(buf, "0x%08.8X", addr);
  else
    sprintf(buf, "0x%08.8X(%s)", addr, sym);
}

scan_mfc(t_pe) unsigned t_pe;
{}
