/* @(#)tim.h	1.3    7/7/92 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>

/* constants */

#define         	TACHYONMAGIC    	0x00c80000
#define         	OMAGIC          	0x00000107
#define         	NMAGIC          	0x00000108
#define         	ZMAGIC          	0x0000010b

#define			_N_	     	 	0
#define			_R_	     	 	4
#define			_W_	     	 	2
#define			_X_	     	 	1
#define			_A_	     	 	6
#define			_O_	     	 	8

/* configuration parameters */

#define			PE_NUM 		 	(1)
#define			T_PE		 	(0)
#define			PAGE_NUM	 	(256)
#define			HEADER_SIZE	 	(32)
#define			PAGE_SIZE	 	(32768)
#define			MEM_SIZE	 	(PAGE_SIZE * PAGE_NUM)
#define                 MAP_NUM                 (64)
#define                 MAP_FREE_NUM            (MAP_NUM * 2)

/************************ PE FACILITIES ************************/

struct map_used
{
  unsigned prot;      /* _R_ | _W_ | _X_ (0-7) */
  unsigned start;
  unsigned end;
  unsigned abs_addr;  /* MEM[] entry */
};

struct map_free
{
  unsigned abs_addr;  /* MEM[] entry */
  unsigned bytes;
};

struct	pe_form	{
		struct map_used map[MAP_NUM];           /* mem_map info */
                struct map_free map_free[MAP_FREE_NUM]; /* free_map info */
		unsigned char	header[HEADER_SIZE];	/* a.out header */
		unsigned char	*symtbl;		/* a.out symbols */
		unsigned     	symsize;		/* size of SYMTBL */
		unsigned char	mem[MEM_SIZE];		/* Absolute MEMORY */
	};

struct	pe_form	pe[PE_NUM];

