static char SccsId[] = "@(#)files.c	1.12    8/7/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

#include "tim.h"
#include "terminal.h"

static int LINES;
#ifndef USG
static struct tchars TCHARS;
#endif
static char save_eofc;
static char terminal;
int has_no_fixed_region;

init_env()
{
    int  uid;
    int  pid;
    unsigned tmp;
 
    ENV_PROMPT1  = "(pe";
    ENV_PROMPT2  = ")";
    ENV_MODULE   = "";
    ENV_INITRC   = ".timrc";
    ENV_COMMAND  = "";
    ENV_CMDDIR   = "";
    ENV_HISTORY  = ".timhis"; 
    ENV_DISPLOG  = ".timlog";  
    ENV_GDBREPL  = "";  
    ENV_ALLFAC   = "";
    ENV_DASD     = "";
    ENV_SSU      = "";
 
#if PE_NUM == penum
    penum   = DEFAULT_PE_NUM;
#else
    penum   = PE_NUM;
#endif
    pagenum = DEFAULT_PAGE_NUM;
    memsize = PAGE_SIZE * DEFAULT_PAGE_NUM;

    uid = getuid();
    pid = getpid();
    sprintf(ENV_COIN  ,"/tmp/timin%u", pid);
    sprintf(ENV_COUT  ,"/tmp/timut%u", pid);
    sprintf(ENV_TMPAS ,"/tmp/timas%u", pid);
    sprintf(ENV_TMPOB ,"/tmp/timob%u", pid);
    sprintf(ENV_TMPLD ,"/tmp/timld%u", pid);
}

setup_scr(term, lines) char **term, **lines;
    /* return 0 if no emulator can be used */
    /* return 1 if 'vtem' must be used */
    /* return 2 if 'screen+vtem' must be used */
{
    struct stat stbuf;
    char *tptr[1024];
    char *termtype;
    char *getenv();
    unsigned tmp;

    termtype = getenv("TERM");
    switch(tgetent(tptr,termtype)) {
      case -1:
        message("can't read termcap\n");
        LINES = 24;
        break;
      case 0:
        message("can't find your terminal type (%s) in termcap\n", termtype);
        LINES = 24;
        break;
      default:
        LINES = tgetnum("li");
	break;
    }

    for (tmp = 0; tmp < (sizeof termlist)/(sizeof *termlist); tmp++) {
        if (!strncmp(termtype, termlist[tmp].name, termlist[tmp].len))
	    break;
    }
    if (tmp < (sizeof termlist)/(sizeof *termlist)) {
        terminal = termlist[tmp].terminal;
	has_no_fixed_region = termlist[tmp].has_no_fixed_region;
    }
    else {
	terminal     = ' ';
        has_no_fixed_region = 3;
    }

    if (has_no_fixed_region) {
        if (LINES < 24) {                                    return(has_no_fixed_region); }
        if (LINES < 34) { *term = "vt100";    *lines = "24"; return(has_no_fixed_region); }
        if (LINES < 44) { *term = "vt100-34"; *lines = "34"; return(has_no_fixed_region); }
        if (LINES < 54) { *term = "vt100-44"; *lines = "44"; return(has_no_fixed_region); }
        if (LINES < 64) { *term = "vt100-54"; *lines = "54"; return(has_no_fixed_region); }
        else            { *term = "vt100-64"; *lines = "64"; return(has_no_fixed_region); }
    }
    else {
        scr_setr(1);
        return(has_no_fixed_region);
    }
}

setup_tty()
{
    char cmd[16];

    if (!batchmode) {

#ifndef USG
      ioctl(0, TIOCGETC, &TCHARS);
      save_eofc = TCHARS.t_eofc;
      TCHARS.t_eofc = 'w'-0x60;
      ioctl(0, TIOCSETC, &TCHARS);
#else
      sprintf(cmd, "stty eof %c", 'w'-0x60);
      system(cmd);
#endif

    }
}

restore_tty()
{
    char cmd[16];

    if (!batchmode) {
      scr_res();

#ifndef USG
      TCHARS.t_eofc = save_eofc;
      ioctl(0, TIOCSETC, &TCHARS);
#else
      sprintf(cmd, "stty eof %c", 'd'-0x60);
      system(cmd);
#endif

    }
}

FILE *
create_file(s, mode)
    char *s;
    int  mode;
{
    int  tmp_fd;

    if (!*s)
        return(NULL);
    if ((tmp_fd = creat(s, mode)) == -1) {
        message("can't create %s\n", s);
        return(NULL);
    }
    return(fdopen(tmp_fd, "w"));
}

FILE *
open_file(s, m)
    char *s, *m;
{
    FILE *tmp_fp;

    if (!*s)
        return(NULL);
    if ((tmp_fp = fopen(s, m)) == NULL) {
        message("can't open \"%s\"\n", s);
        return(NULL);
    }
    return(tmp_fp);
}

FILE *
open_rc(s)
    char *s;
{
    FILE *tmp_fp;

    if (!*s)
        return(NULL);
    if ((tmp_fp = fopen(s, "r")) == NULL) {
        if (strcmp(s, ".timrc"))
            message("can't open \"%s\"\n", s);
        return(NULL);
    }
    return(tmp_fp);
}

create_console(s, rw)
    char *s; unsigned rw;
{
    if (!*s)
      return;
    if (rw == _R_) {
      unlink(s);
      if (mknod(s, 0666 | S_IFIFO, 0) == -1) {
        message("can't create \"%s\"\n", s);
        return;
      }
    }
    else if (rw == _W_) {
      unlink(s);
      if (mknod(s, 0666 | S_IFIFO, 0) == -1) {
        message("can't create \"%s\"\n", s);
        return;
      }
    }
    else {
      message("internal error: create_console.rw=0x%X (must be _R_ or _W_)\n", rw);
      return;
    }
}

open_console(s, rw)
    char *s; unsigned rw;
{
    struct sgttyb termiosArg;
    int tmp_fd;

    if (!*s)
      return(0);
    if (rw == _R_) {
      message("connecting kbd...");
      fflush(stdout);
      if ((tmp_fd = open(s, O_RDONLY | O_NDELAY)) == -1) {
        message("can't open \"%s\"\n", s);
        return(0);
      }
      ioctl(tmp_fd, TIOCGETP, &termiosArg);
      termiosArg.sg_flags |= O_RAW;
      ioctl(tmp_fd, TIOCSETP, &termiosArg);
      message("done\n");
      return(tmp_fd);
    }
    else if (rw == _W_) {
      message("connecting display...");
      fflush(stdout);
      if ((tmp_fd = open(s, O_WRONLY)) == -1) {
        message("can't open \"%s\"\n", s);
        return(0);
      }
      ioctl(tmp_fd, TIOCGETP, &termiosArg);
      termiosArg.sg_flags |= O_RAW;
      ioctl(tmp_fd, TIOCSETP, &termiosArg);
      message("done\n");
      return(tmp_fd);
    }
    else {
      message("internal error: open_console.rw=0x%X (must be _R_ or _W_)\n", rw);
      return(0);
    }
}

open_ssu(s)
    char *s;
{
    int tmp_fd;

    if (!*s)
      return(0);
    if ((tmp_fd = open(s, O_RDWR)) == -1) {
      message("can't open \"%s\"\n", s);
      return(0);
    }
    return(tmp_fd);
}

open_dasd(s)
    char *s;
{
    int tmp_fd;

    if (!*s)
      return(0);
    if ((tmp_fd = open(s, O_RDWR)) == -1) {
      message("can't open \"%s\"\n", s);
      return(0);
    }
    return(tmp_fd);
}

FILE *
open_command(s)
    char *s;
{
    FILE *tmp_fp;

    if (!*s)
        return(stdin);
    if ((tmp_fp = fopen(s, "r")) == NULL) {
        message("can't open \"%s\"\n", s);
        return(NULL);
    }
    return(tmp_fp);
}

prompt(t_pe, fp)
    unsigned t_pe; FILE *fp;
{
    if (displog_fp) {
	if (history_fp)
            fprintf(displog_fp, "<%u>%s%u%s ", history_num+1, ENV_PROMPT1, t_pe, ENV_PROMPT2);
	else
            fprintf(displog_fp, "<>%s%u%s ", ENV_PROMPT1, t_pe, ENV_PROMPT2);
        fflush(displog_fp);
    }
    if (fp == stdin) {
	if (history_fp)
            stdoutprintf("<%u>%s%u%s ", history_num+1, ENV_PROMPT1, t_pe, ENV_PROMPT2);
	else
            stdoutprintf("<>%s%u%s ", ENV_PROMPT1, t_pe, ENV_PROMPT2);
    }
}

arrow_prompt(fp)
    FILE *fp;
{
    if (displog_fp) {
        fprintf(displog_fp, "<%-5d   -->", history_num+1);
        fflush(displog_fp);
    }
    if (fp == stdin) {
        stdoutprintf("<%-5d   -->", history_num+1);
    }
}

log_command(s)
    char *s;
{
    if (displog_fp) {
        fprintf(displog_fp, "%s\n", s);
        fflush(displog_fp);
    }
    if (history_fp) {
        fprintf(history_fp, "%s\n", s);
        fflush(history_fp);
    }
    history_num++;
}

smessage(s, i, j, k, l, m, n, o)
    char *s; int i, j, k, l, m, n, o;
{
    char *t = s;

    if (displog_fp) {
        fprintf(displog_fp, s, i, j, k, l, m, n, o);
        fflush(displog_fp);
    }

    while (*t++);

    if (t >= s && *(t-2) == '\n') {
      *(t-2) = NULL;
      scr_sobegin();
      stdoutprintf(s, i, j, k, l, m, n, o);
      scr_soend();
      stdoutprintf("\n");
      *(t-2) = '\n';
    }
    else {
      scr_sobegin();
      stdoutprintf(s, i, j, k, l, m, n, o);
      scr_soend();
    }
}

lmessage(s, i, j, k, l, m, n, o)
    char *s; int i, j, k, l, m, n, o;
{
    char *t = s;

    if (displog_fp) {
        fprintf(displog_fp, s, i, j, k, l, m, n, o);
        fflush(displog_fp);
    }

    while (*t++);

    if (t >= s && *(t-2) == '\n') {
      *(t-2) = NULL;
      scr_ulbegin();
      stdoutprintf(s, i, j, k, l, m, n, o);
      scr_ulend();
      stdoutprintf("\n");
      *(t-2) = '\n';
    }
    else {
      scr_ulbegin();
      stdoutprintf(s, i, j, k, l, m, n, o);
      scr_ulend();
    }
}

message(s, i, j, k, l, m, n, o)
    char *s; int i, j, k, l, m, n, o;
{
    if (displog_fp) {
        fprintf(displog_fp, s, i, j, k, l, m, n, o);
        fflush(displog_fp);
    }
    stdoutprintf(s, i, j, k, l, m, n, o);
}

stdoutprintf(s, i, j, k, l, m, n, o)
    char *s; int i, j, k, l, m, n, o;
{
    if (!batchmode)
        fprintf(stdout, s, i, j, k, l, m, n, o);
}

gdbrepl(s, i, j, k, l, m, n, o)
    char *s; int i, j, k, l, m, n, o;
{
    if (gdbrepl_fp) {
        fprintf(gdbrepl_fp, s, i, j, k, l, m, n, o);
        fflush(gdbrepl_fp);
    }
}

scr_sobegin()
{
    switch (terminal) {
    case 'g':
	stdoutprintf("\033[?7m");
   	break;
    default:
	stdoutprintf("\033[32;7m");
   	break;
    case ' ':
	break;
    }
}

scr_soend()
{
    switch (terminal) {
    case 'g':
	stdoutprintf("\033[?27m");
   	break;
    default:
	stdoutprintf("\033[0;0m");
   	break;
    case ' ':
	break;
    }
}

scr_ulbegin()
{
    switch (terminal) {
    case 'g':
	stdoutprintf("\033[?4m");
   	break;
    default:
	stdoutprintf("\033[36;4m");
   	break;
    case ' ':
	break;
    }
}

scr_ulend()
{
    switch (terminal) {
    case 'g':
	stdoutprintf("\033[?24m");
   	break;
    default:
	stdoutprintf("\033[0;0m");
   	break;
    case ' ':
	break;
    }
}

scr_mscanbegin()
{
    switch (terminal) {
    case 'g':
        break;
    default:
        stdoutprintf("\033[32m");
        break;
    case ' ':
        break;
    }
}

scr_fscanbegin()
{
    switch (terminal) {
    case 'g':
        break;
    default:
        stdoutprintf("\033[36m");
        break;
    case ' ':
        break;
    }
}

scr_cscanbegin()
{
    switch (terminal) {
    case 'g':
        break;
    default:
        stdoutprintf("\033[33m");
        break;
    case ' ':
        break;
    }
}

scr_scanend()
{
    switch (terminal) {
    case 'g':
        break;
    default:
        stdoutprintf("\033[0m");
        break;
    case ' ':
        break;
    }
}

scan_mfc(t_pe) unsigned t_pe;
{
        message(" %1u:", t_pe);
        if (pe[T_PE].sr[STAR1].star1.asam) {
          scr_mscanbegin();
          message("|");
          scr_scanend();
        }
        else
          message(" ");
        if (pe[T_PE].sr[STAR1].star1.asaf) {
          scr_fscanbegin();
          message("|");
          scr_scanend();
        }
        else
          message(" ");
        if (pe[T_PE].sr[STAR1].star1.cba) {
          scr_cscanbegin();
          message("|");
          scr_scanend();
        }
        else
          message(" ");
}

scr_move(r)
{
    switch (terminal) {
    case 'g':
	stdoutprintf("\033[;%uH", r);
   	break;
    default:
	stdoutprintf("\033[%uH", r);
   	break;
    case ' ':
	break;
    }
}

scr_eol()
{
    switch (terminal) {
    case 'g':
   	break;
    default:
	stdoutprintf("\033[K");
   	break;
    case ' ':
	break;
    }
}

scr_up()
{
    switch (terminal) {
    case 'g':
	stdoutprintf("\033[;%uH\n", LINES);
   	break;
    default:
	stdoutprintf("\033[%uH\n", LINES);
   	break;
    case ' ':
	break;
    }
}

scr_bot()
{
    switch (terminal) {
    case 'g':
	stdoutprintf("\033[;%uH", LINES);
   	break;
    case 'r':
    case 's':
	stdoutprintf("\033[%uH", LINES);
   	break;
    default:
	stdoutprintf("\033[%uH", LINES-1);
   	break;
    case ' ':
	break;
    }
}

scr_setr(r)
{
    if (!has_no_fixed_region) {
	stdoutprintf("\033[%uH\033[K", LINES);
	stdoutprintf("\033[%u;%ur", r, LINES-1);
    }
    scr_bot();
    scr_eol();
}

scr_res()
{
    if (!has_no_fixed_region) {
	stdoutprintf("\033[1;%ur", LINES);
	stdoutprintf("\033[%uH", LINES-1);
    }
    if (!batchmode)
        fflush(stdout);
}

read_module(t_pe, t_mode, addr, s, f, use_addr, t_forcew)
    /* return 0 if failed, size if succeeded */
    unsigned t_pe;	  /* pe# */
    unsigned t_mode;	  /* 'r': real 'v': virtual */
    unsigned addr;	  /* target address */
    char *s;		  /* file name */
    unsigned f;		  /* 0: line asm module        */
    			  /* 1: read full load module  */
    			  /* 2: memmap & read full load module */
    unsigned use_addr;    /* 1:use addr(parameter->a_entry) 0:use a_entry */
    unsigned t_forcew;    /* 'y':ignore protection 'n':obey protection */
{
    unsigned char TMP_HEADER[HEADER_SIZE];
    unsigned char *a_header;
    unsigned *a_info, *a_text,  *a_data,   *a_bss;
    unsigned *a_syms, *a_entry, *a_trsize, *a_drsize;
    unsigned *strings;
    unsigned read_buf[2];
    unsigned abs_addr;
    int fd, i;

    if (f) { /* case a.out header/full load module */
        a_header = pe[T_PE].header;
        a_info   = (unsigned *)  pe[T_PE].header    ;
        a_text   = (unsigned *) (pe[T_PE].header+ 4);
        a_data   = (unsigned *) (pe[T_PE].header+ 8);
        a_bss    = (unsigned *) (pe[T_PE].header+12);
        a_syms   = (unsigned *) (pe[T_PE].header+16);
        a_entry  = (unsigned *) (pe[T_PE].header+20);
        a_trsize = (unsigned *) (pe[T_PE].header+24);
        a_drsize = (unsigned *) (pe[T_PE].header+28);
    }
    else {
        a_header = TMP_HEADER;
        a_info   = (unsigned *)  TMP_HEADER    ;
        a_text   = (unsigned *) (TMP_HEADER+ 4);
        a_data   = (unsigned *) (TMP_HEADER+ 8);
        a_bss    = (unsigned *) (TMP_HEADER+12);
        a_syms   = (unsigned *) (TMP_HEADER+16);
        a_entry  = (unsigned *) (TMP_HEADER+20);
        a_trsize = (unsigned *) (TMP_HEADER+24);
        a_drsize = (unsigned *) (TMP_HEADER+28);
    }

    if ((fd = open(s, O_RDONLY)) == -1) {
        message("can't open \"%s\"\n", s);
        goto exit_read_module;
    }

    if (read(fd, a_header, HEADER_SIZE) != HEADER_SIZE) {
        message("can't read %s's header\n", s);
        goto exit_read_module;
    }

    if (*a_info != (TACHYONMAGIC | OMAGIC)) {
        message("%s not tim-type module\n", s);
        goto exit_read_module;
    }

    if ((i = ((*a_text+*a_data+*a_bss+PAGE_SIZE-1) & ~(PAGE_SIZE-1)) / PAGE_SIZE) > pagenum) {
        message("too many pages required: %u\n", i);
        goto exit_read_module;
    }

    if (use_addr)
        *a_entry = addr;

    if (f == 2) { /* get real memory first */
        if (i > 0  && cmd_mem_map(t_pe, 0, _R_|_W_|_X_, *a_entry, *a_entry+i*PAGE_SIZE-1, &abs_addr)) {
            goto exit_read_module;
	}
    }

    for (i=0; i<*a_text; i+=8) {
        if (read(fd, read_buf, 8) != 8) {
            message("can't read %s's text\n", s);
            goto exit_read_module;
	}
        if (cmd_mem_access(t_pe, t_mode, *a_entry+i, 8, _W_, read_buf, t_forcew)) {
            goto exit_read_module;
	}
    }
    for (i=0; i<*a_data; i+=8) {
        if (read(fd, read_buf, 8) != 8) {
            message("can't read %s's data\n", s);
            goto exit_read_module;
        }
        if (cmd_mem_access(t_pe, t_mode, *a_entry+*a_text+i, 8, _W_, read_buf, t_forcew)) {
            goto exit_read_module;
	}
    }
    read_buf[0] = read_buf[1] = 0;
    for (i=0; i<*a_bss; i+=8) {
        if (cmd_mem_access(t_pe, t_mode, *a_entry+*a_text+*a_data+i, 8, _W_, read_buf, t_forcew)) {
            goto exit_read_module;
	}
    }

    if (f && *a_syms) {
      if ((pe[T_PE].symtbl = (unsigned char*)realloc(pe[T_PE].symtbl, i = *a_syms+4))==NULL) {
        message("too large symbol table: %u\n", i);
        goto exit_read_module;
      }
      if (read(fd, pe[T_PE].symtbl, *a_syms+4) != *a_syms+4) {
        message("can't read %s's symbol\n", s);
        goto exit_read_module;
      }
      strings = (unsigned *) (pe[T_PE].symtbl+*a_syms);
      if ((pe[T_PE].symtbl = (unsigned char*)realloc(pe[T_PE].symtbl, i = *a_syms + *strings))==NULL) {
        message("too large symbol table: %u\n", i);
        goto exit_read_module;
      }
      if (read(fd, pe[T_PE].symtbl+*a_syms+4, *strings-4) != *strings-4) {
        message("can't read %s's symbol\n", s);
        goto exit_read_module;
      }
      pe[T_PE].symsize = i;
      init_memhash(t_pe);
    }

    if (*a_text)
      message("text=0x%08.8X-0x%08.8X\n", *a_entry, *a_entry+*a_text-1);
    if (*a_data)
      message("data=0x%08.8X-0x%08.8X\n", *a_entry+*a_text, *a_entry+*a_text+*a_data-1);
    if (*a_bss)
      message("bss =0x%08.8X-0x%08.8X\n", *a_entry+*a_text+*a_data, *a_entry+*a_text+*a_data+*a_bss-1);

    if (f == 2)
        pe[T_PE].sr[PC].ful = *a_entry;

    close(fd);
    return(*a_entry+*a_text+*a_data+*a_bss);

exit_read_module:
    *a_info = TACHYONMAGIC | OMAGIC;
    *a_syms = 0;
    pe[T_PE].symsize = 0;
    close(fd);
    return(0);
}

access_header(t_pe, rw, a_text, a_data, a_bss, a_entry)
    unsigned t_pe;	/* pe# */
    unsigned rw;	/* 'r', 'w', 'p' */
    unsigned *a_text, *a_data, *a_bss, *a_entry;
{
    unsigned char *a_header = pe[T_PE].header;

    switch (rw) {
    case 'r':
      *a_text  = *(unsigned *) (pe[T_PE].header+ 4);
      *a_data  = *(unsigned *) (pe[T_PE].header+ 8);
      *a_bss   = *(unsigned *) (pe[T_PE].header+12);
      *a_entry = *(unsigned *) (pe[T_PE].header+20);
      break;
    case 'w':
      *(unsigned *)  pe[T_PE].header     = TACHYONMAGIC | OMAGIC;
      *(unsigned *) (pe[T_PE].header+ 4) = *a_text;
      *(unsigned *) (pe[T_PE].header+ 8) = *a_data;
      *(unsigned *) (pe[T_PE].header+12) = *a_bss;
      *(unsigned *) (pe[T_PE].header+20) = *a_entry;
      *(unsigned *) (pe[T_PE].header+24) = 0;
      *(unsigned *) (pe[T_PE].header+28) = 0;
      break;
    case 'p':
      message("a_info  =0x%08.8X " , *(unsigned *)  pe[T_PE].header);
      message("a_text  =0x%08.8X " , *(unsigned *) (pe[T_PE].header+ 4));
      message("a_data  =0x%08.8X " , *(unsigned *) (pe[T_PE].header+ 8));
      message("a_bss   =0x%08.8X\n", *(unsigned *) (pe[T_PE].header+12));
      message("a_syms  =0x%08.8X " , *(unsigned *) (pe[T_PE].header+16));
      message("a_entry =0x%08.8X " , *(unsigned *) (pe[T_PE].header+20));
      message("a_trsize=0x%08.8X " , *(unsigned *) (pe[T_PE].header+24));
      message("a_drsize=0x%08.8X\n", *(unsigned *) (pe[T_PE].header+28));
      break;
    }
}

write_module(t_pe, t_mode, s)
    unsigned t_pe;	/* pe# */
    unsigned t_mode;	/* 'r': real 'v': virtual */
    char *s;		/* file name */
{
    unsigned char *a_header = pe[T_PE].header;
    unsigned *a_info, *a_text,  *a_data,   *a_bss;
    unsigned *a_syms, *a_entry, *a_trsize, *a_drsize;
    unsigned *strings;
    unsigned write_buf[2];
    int fd, i;

    a_info   = (unsigned *)  pe[T_PE].header    ;
    a_text   = (unsigned *) (pe[T_PE].header+ 4);
    a_data   = (unsigned *) (pe[T_PE].header+ 8);
    a_bss    = (unsigned *) (pe[T_PE].header+12);
    a_syms   = (unsigned *) (pe[T_PE].header+16);
    a_entry  = (unsigned *) (pe[T_PE].header+20);
    a_trsize = (unsigned *) (pe[T_PE].header+24);
    a_drsize = (unsigned *) (pe[T_PE].header+28);

    if ((fd = open(s, O_RDONLY)) != -1) {
        message("%s already exist\n", s);
	goto exit_write_module;
    }

    if ((fd = open(s, O_CREAT, 0777)) == -1) {
        message("can't create %s\n", s);
	goto exit_write_module;
    }

    close(fd);

    if ((fd = open(s, O_WRONLY)) == -1) {
        message("can't open \"%s\"\n", s);
	goto exit_write_module;
    }

    if (write(fd, a_header, HEADER_SIZE) == -1) {
        message("can't write %s's header\n", s);
	goto exit_write_module;
    }

    if ((i = ((*a_text+*a_data+*a_bss+PAGE_SIZE-1) & ~(PAGE_SIZE-1)) / PAGE_SIZE) > pagenum) {
        message("too many pages exist: %u\n", i);
	goto exit_write_module;
    }

    for (i=0; i<*a_text; i+=8) {
        if (cmd_mem_access(t_pe, t_mode, *a_entry+i, 8, _R_, write_buf, 'n'))
	    goto exit_write_module;
        if (write(fd, write_buf, 8) == -1) {
            message("can't write %s's text\n", s);
	    goto exit_write_module;
        }
    }

    for (i=0; i<*a_data; i+=8) {
        if (cmd_mem_access(t_pe, t_mode, *a_entry+*a_text+i, 8, _R_, write_buf, 'n'))
	    goto exit_write_module;
        if (write(fd, write_buf, 8) == -1) {
            message("can't write %s's data\n", s);
	    goto exit_write_module;
        }
    }

    if (write(fd, pe[T_PE].symtbl, *a_syms+4) == -1) {
        message("can't write %s's symbol\n", s);
	goto exit_write_module;
    }

    strings = (unsigned *) (pe[T_PE].symtbl+*a_syms);

    if (write(fd, pe[T_PE].symtbl+*a_syms+4, *strings-4) == -1) {
        message("can't write %s's symbol\n", s);
	goto exit_write_module;
    }

    if (*a_text)
      message("text=0x%08.8X-0x%08.8X\n", *a_entry, *a_entry+*a_text-1);
    if (*a_data)
      message("data=0x%08.8X-0x%08.8X\n", *a_entry+*a_text, *a_entry+*a_text+*a_data-1);
    if (*a_bss)
      message("bss =0x%08.8X-0x%08.8X\n", *a_entry+*a_text+*a_data, *a_entry+*a_text+*a_data+*a_bss-1);

exit_write_module:
    close(fd);
    return;
}

read_all(s)
    char *s;		/* file name */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned      t_pe;
    unsigned char **saveP;
    int           fd;

    if ((saveP=(unsigned char**)malloc(sizeof(unsigned char*)*PE_NUM))==NULL) {
        message("can't allocate temporary symbolP\n");
        exit(1);
    }

    for (t_pe = 0; t_pe < PE_NUM; t_pe++)
        saveP[T_PE] = pe[T_PE].symtbl;

    if ((fd = open(s, O_RDONLY)) == -1) {
        message("can't open \"%s\"\n", s);
	goto exit_read_all;
    }

    if (read(fd, (char*)&tim_clock, sizeof (tim_clock)) != sizeof (tim_clock)) {
        message("can't read %s's content\n", s);
	goto exit_read_all;
    }

    for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
        if (read(fd, (char*)&pe[T_PE], sizeof (struct pe_form)) != sizeof (struct pe_form)) {
            message("can't read %s's content\n", s);
	    goto exit_read_all;
        }
        if (memsize != pe[T_PE].memsize) {
            message("memory size mismatch (mysize=0x%08.8X file=0x%08.8X)\n", memsize, pe[T_PE].memsize);
	    goto exit_read_all;
        }
        if (read(fd, pe[T_PE].mem, pe[T_PE].memsize) != pe[T_PE].memsize) {
            message("can't read %s's content\n", s);
	    goto exit_read_all;
        }
        if (read(fd, pe[T_PE].mbp, pe[T_PE].memsize/8) != pe[T_PE].memsize/8) {
            message("can't read %s's content\n", s);
	    goto exit_read_all;
        }
        if ((pe[T_PE].symtbl=(unsigned char*)realloc(saveP[T_PE],pe[T_PE].symsize))==NULL) {
            message("too large symbol table: %u\n", pe[T_PE].symsize);
	    goto exit_read_all;
        }
        if (read(fd, pe[T_PE].symtbl, pe[T_PE].symsize) != pe[T_PE].symsize) {
            message("can't read %s's content\n", s);
	    goto exit_read_all;
        }
        init_memhash(t_pe);
    }

    close(fd);
    free(saveP);
    return(0);

exit_read_all:
    pe[T_PE].symsize = 0;
    close(fd);
    free(saveP);
    return(1);
}

write_all(s)
    char *s;		/* file name */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned t_pe;
    int fd;

    if ((fd = open(s, O_RDONLY)) != -1) {
        message("%s already exist\n", s);
	goto exit_write_all;
    }

    if ((fd = open(s, O_CREAT, 0777)) == -1) {
        message("can't create %s\n", s);
	goto exit_write_all;
    }

    close(fd);

    if ((fd = open(s, O_WRONLY)) == -1) {
        message("can't open \"%s\"\n", s);
	goto exit_write_all;
    }

    if (write(fd, (char*)&tim_clock, sizeof (tim_clock)) == -1) {
        message("can't write %s's content\n", s);
	goto exit_write_all;
    }

    for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
        if (write(fd, (char*)&pe[T_PE], sizeof (struct pe_form)) == -1) {
            message("can't write %s's content\n", s);
	    goto exit_write_all;
        }
        if (write(fd, pe[T_PE].mem, pe[T_PE].memsize) == -1) {
            message("can't write %s's content\n", s);
	    goto exit_write_all;
        }
        if (write(fd, pe[T_PE].mbp, pe[T_PE].memsize/8) == -1) {
            message("can't write %s's content\n", s);
	    goto exit_write_all;
        }
        if (write(fd, pe[T_PE].symtbl, pe[T_PE].symsize) == -1) {
            message("can't write %s's content\n", s);
	    goto exit_write_all;
        }
    }

    close(fd);
    return(0);

exit_write_all:
    close(fd);
    return(1);
}

