static char SccsId[] = "@(#)fp.c	1.1    6/12/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Koseki      */

 /* fp.c    89/10/1 */

#include "tim.h"
#include "facility.h"
#include "fp-form.def"

extern union    fp_vp_cnt     un_fcr;
extern union    fp_vp_flag    un_fvct[];
extern union    fp_vp_reg     un_fr[];
extern union    fp_vp_temp    un_t[];

int      fp_fpu_RIEH();
int      fp_fpu_RIEL();
int      fp_fadd();
int      fp_fsub();
int      fp_fmul();
int      fp_fdiv();
int      fp_fcmp();
int      fp_fadd_d();
int      fp_fsub_d();
int      fp_fmul_d();
int      fp_fdiv_d();
int      fp_fcmp_d();
int      fp_fadd_x();
int      fp_fsub_x();
int      fp_fcmp_x();
int      fp_fcnv_fd();
int      fp_fcnv_df();
int      fp_fcnv_dx();
int      fp_fcnv_xd();
int      fp_fcnv_if();
int      fp_fcnv_fi();
int      fp_fcnv_id();
int      fp_fcnv_di();
int      fp_fcnz_fi();
int      fp_fcnz_di();

int      fp_ac_fpu_RIE();
int      fp_ac_fadd();
int      fp_ac_fsub();
int      fp_ac_fmul();
int      fp_ac_fdiv();
int      fp_ac_fcmp();
int      fp_ac_fadd_d();
int      fp_ac_fsub_d();
int      fp_ac_fmul_d();
int      fp_ac_fdiv_d();
int      fp_ac_fcmp_d();
int      fp_ac_fadd_x();
int      fp_ac_fsub_x();
int      fp_ac_fcmp_x();
int      fp_ac_fcnv_fd();
int      fp_ac_fcnv_df();
int      fp_ac_fcnv_dx();
int      fp_ac_fcnv_xd();
int      fp_ac_fcnv_if();
int      fp_ac_fcnv_fi();
int      fp_ac_fcnv_id();
int      fp_ac_fcnv_di();
int      fp_ac_fcnz_fi();
int      fp_ac_fcnz_di();

int (*fpu_func_H[])() = { fp_fpu_RIEH,   /* reserved instruction       (00) */
                          fp_fpu_RIEH,   /* reserved instruction       (01) */
                          fp_fadd,       /* floating add               (02) */
                          fp_fadd_d,     /* floating add double        (03) */
                          fp_fsub,       /* floating subtract          (04) */
                          fp_fsub_d,     /* floating subtract double   (05) */
                          fp_fpu_RIEH,   /* reserved instruction       (06) */
                          fp_fpu_RIEH,   /* reserved instruction       (07) */
                          fp_fpu_RIEH,   /* reserved instruction       (08) */
                          fp_fpu_RIEH,   /* reserved instruction       (09) */
                          fp_fcnv_fd,    /* convert float to double    (0a) */
                          fp_fcnv_df,    /* convert double to float    (0b) */
                          fp_fcnv_if,    /* convert integer to float   (0c) */
                          fp_fcnv_fi,    /* convert float to integer   (0d) */
                          fp_fcnv_id,    /* convert integer to double  (0e) */
                          fp_fcnv_di,    /* convert double to integer  (0f) */
                          fp_fpu_RIEH,   /* reserved instruction       (10) */
                          fp_fcnz_fi,    /* convert float to integer   (11) */
                          fp_fpu_RIEH,   /* reserved instruction       (12) */
                          fp_fcnz_di,    /* convert double to integer  (13) */
                          fp_fcmp,       /* floating compare           (14) */
                          fp_fcmp_d,     /* floating compare double    (15) */
                          fp_fcmp_x,     /* floating compare extended  (16) */
                          fp_fpu_RIEH,   /* reserved instruction       (17) */
                          fp_fpu_RIEH,   /* reserved instruction       (18) */
                          fp_fpu_RIEH,   /* reserved instruction       (19) */
                          fp_fadd_x,     /* floating add extended      (1a) */
                          fp_fpu_RIEH,   /* reserved instruction       (1b) */
                          fp_fsub_x,     /* floating subtract extended (1c) */
                          fp_fpu_RIEH,   /* reserved instruction       (1d) */
                          fp_fcnv_dx,    /* convert double to extended (1e) */
                          fp_fcnv_xd,    /* convert extended to double (1f) */
                          };
int (*fpu_func_L[])() = { fp_fpu_RIEL,   /* reserved instruction       (00) */
                          fp_fpu_RIEL,   /* reserved instruction       (01) */
                          fp_fpu_RIEL,   /* reserved instruction       (02) */
                          fp_fpu_RIEL,   /* reserved instruction       (03) */
                          fp_fpu_RIEL,   /* reserved instruction       (04) */
                          fp_fpu_RIEL,   /* reserved instruction       (05) */
                          fp_fmul,       /* floating multiply          (06) */
                          fp_fmul_d,     /* floating multiply double   (07) */
                          fp_fdiv,       /* floating divide            (08) */
                          fp_fdiv_d,     /* floating divide double     (09) */
                          fp_fpu_RIEL,   /* reserved instruction       (0a) */
                          fp_fpu_RIEL,   /* reserved instruction       (0b) */
                          fp_fpu_RIEL,   /* reserved instruction       (0c) */
                          fp_fpu_RIEL,   /* reserved instruction       (0d) */
                          fp_fpu_RIEL,   /* reserved instruction       (0e) */
                          fp_fpu_RIEL,   /* reserved instruction       (0f) */
                          fp_fpu_RIEL,   /* reserved instruction       (10) */
                          fp_fpu_RIEL,   /* reserved instruction       (11) */
                          fp_fpu_RIEL,   /* reserved instruction       (12) */
                          fp_fpu_RIEL,   /* reserved instruction       (13) */
                          fp_fpu_RIEL,   /* reserved instruction       (14) */
                          fp_fpu_RIEL,   /* reserved instruction       (15) */
                          fp_fpu_RIEL,   /* reserved instruction       (16) */
                          fp_fpu_RIEL,   /* reserved instruction       (17) */
                          fp_fpu_RIEL,   /* reserved instruction       (18) */
                          fp_fpu_RIEL,   /* reserved instruction       (19) */
                          fp_fpu_RIEL,   /* reserved instruction       (1a) */
                          fp_fpu_RIEL,   /* reserved instruction       (1b) */
                          fp_fpu_RIEL,   /* reserved instruction       (1c) */
                          fp_fpu_RIEL,   /* reserved instruction       (1d) */
                          fp_fpu_RIEL,   /* reserved instruction       (1e) */
                          fp_fpu_RIEL,   /* reserved instruction       (1f) */
                          };

int (*fpu_acfc[])() = { fp_ac_fpu_RIE, /* reserved instruction       (00) */
                        fp_ac_fpu_RIE, /* reserved instruction       (01) */
                        fp_ac_fadd,    /* floating add               (02) */
                        fp_ac_fadd_d,  /* floating add double        (03) */
                        fp_ac_fsub,    /* floating subtract          (04) */
                        fp_ac_fsub_d,  /* floating subtract double   (05) */
                        fp_ac_fmul,    /* floating multiply          (06) */
                        fp_ac_fmul_d,  /* floating multiply double   (07) */
                        fp_ac_fdiv,    /* floating divide            (08) */
                        fp_ac_fdiv_d,  /* floating divide double     (09) */
                        fp_ac_fcnv_fd, /* convert float to double    (0a) */
                        fp_ac_fcnv_df, /* convert double to float    (0b) */
                        fp_ac_fcnv_if, /* convert integer to float   (0c) */
                        fp_ac_fcnv_fi, /* convert float to integer   (0d) */
                        fp_ac_fcnv_id, /* convert integer to double  (0e) */
                        fp_ac_fcnv_di, /* convert double to integer  (0f) */
                        fp_ac_fpu_RIE, /* reserved instruction       (10) */
                        fp_ac_fcnz_fi, /* convert float to integer   (11) */
                        fp_ac_fpu_RIE, /* reserved instruction       (12) */
                        fp_ac_fcnz_di, /* convert double to integer  (13) */
                        fp_ac_fcmp,    /* floating compare           (14) */
                        fp_ac_fcmp_d,  /* floating compare double    (15) */
                        fp_ac_fcmp_x,  /* floating compare extended  (16) */
                        fp_ac_fpu_RIE, /* reserved instruction       (17) */
                        fp_ac_fpu_RIE, /* reserved instruction       (18) */
                        fp_ac_fpu_RIE, /* reserved instruction       (19) */
                        fp_ac_fadd_x,  /* floating add extended      (1a) */
                        fp_ac_fpu_RIE, /* reserved instruction       (1b) */
                        fp_ac_fsub_x,  /* floating subtract extended (1c) */
                        fp_ac_fpu_RIE, /* reserved instruction       (1d) */
                        fp_ac_fcnv_dx, /* convert double to extended (1e) */
                        fp_ac_fcnv_xd, /* convert extended to double (1f) */
                        };

unsigned char w_divide[] = { F_DIVIDE_OFF, /* reserved instruction       (00) */
                             F_DIVIDE_OFF, /* reserved instruction       (01) */
                             F_DIVIDE_OFF, /* floating add               (02) */
                             F_DIVIDE_OFF, /* floating add double        (03) */
                             F_DIVIDE_OFF, /* floating subtract          (04) */
                             F_DIVIDE_OFF, /* floating subtract double   (05) */
                             F_DIVIDE_OFF, /* floating multiply          (06) */
                             F_DIVIDE_OFF, /* floating multiply double   (07) */
                             F_DIVIDE_ON , /* floating divide            (08) */
                             F_DIVIDE_ON , /* floating divide double     (09) */
                             F_DIVIDE_OFF, /* convert float to double    (0a) */
                             F_DIVIDE_OFF, /* convert double to float    (0b) */
                             F_DIVIDE_OFF, /* convert integer to float   (0c) */
                             F_DIVIDE_OFF, /* convert float to integer   (0d) */
                             F_DIVIDE_OFF, /* convert integer to double  (0e) */
                             F_DIVIDE_OFF, /* convert double to integer  (0f) */
                             F_DIVIDE_OFF, /* reserved instruction       (10) */
                             F_DIVIDE_OFF, /* reserved instruction       (11) */
                             F_DIVIDE_OFF, /* reserved instruction       (12) */
                             F_DIVIDE_OFF, /* reserved instruction       (13) */
                             F_DIVIDE_OFF, /* floating compare           (14) */
                             F_DIVIDE_OFF, /* floating compare double    (15) */
                             F_DIVIDE_OFF, /* floating compare extended  (16) */
                             F_DIVIDE_OFF, /* reserved instruction       (17) */
                             F_DIVIDE_OFF, /* reserved instruction       (18) */
                             F_DIVIDE_OFF, /* reserved instruction       (19) */
                             F_DIVIDE_OFF, /* floating add extended      (1a) */
                             F_DIVIDE_OFF, /* reserved instruction       (1b) */
                             F_DIVIDE_OFF, /* floating subtract extended (1c) */
                             F_DIVIDE_OFF, /* reserved instruction       (1d) */
                             F_DIVIDE_OFF, /* convert double to extended (1e) */
                             F_DIVIDE_OFF, /* convert extended to double (1f) */
                             };

sim_fp( t_pe, sync )
    int t_pe;
    unsigned sync; /* synchronous with instruction or exception */
    /* unsigned  cmd; 'r' read : 'x' write */
{
    int              i, fqe_no, asaf;
    int              ret_h, ret_l;
    unsigned         reg_vol[4][3];
    int 	     (*tmpfh)(), (*tmpfl)();

    if( pe[T_PE].sr[PEV].pev.fstop ){
        pe[T_PE].sr[STAR1].star1.asaf = 0;
        pe[T_PE].fp_op_exist = 0;
        return( 0 );
    }
    asaf = 0;
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
#ifdef FPUDEBUG
    for( i=FP_WRITE_DELAY-1 ; i>=0 ; i-- ){
        message("AVN=%d\n", pe[T_PE].avn_fpwd );
        message("FQE%2.2dH  ne=%d status=%d",
                                          pe[T_PE].fpwd[i].fqno-1,
                                          pe[T_PE].fpwd[i].ne_h,
                                          pe[T_PE].fpwd[i].status_h );
        message("  regsize=%d  register=%d",
                                          pe[T_PE].fpwd[i].len_h,
                                          pe[T_PE].fpwd[i].reg_h);
        message("  %08x-%08x  %08x-%08x",
                                          pe[T_PE].fpwd[i].val_h0,
                                          pe[T_PE].fpwd[i].val_h1,
                                          pe[T_PE].fpwd[i].val_h2,
                                          pe[T_PE].fpwd[i].val_h3 );
        message("  cmp=%d cmp status=%d\n",
                                          pe[T_PE].fpwd[i].cmp_h,
                                          pe[T_PE].fpwd[i].cmp_val_h );
        message("FQE%2.2dL  ne=%d status=%d",
                                          pe[T_PE].fpwd[i].fqno-1,
                                          pe[T_PE].fpwd[i].ne_l,
                                          pe[T_PE].fpwd[i].status_l );
        message("  regsize=%d  register=%d",
                                          pe[T_PE].fpwd[i].len_l,
                                          pe[T_PE].fpwd[i].reg_l);
        message("  %08x-%08x  %08x-%08x\n",
                                          pe[T_PE].fpwd[i].val_l0,
                                          pe[T_PE].fpwd[i].val_l1,
                                          pe[T_PE].fpwd[i].val_l2,
                                          pe[T_PE].fpwd[i].val_l3 );
        /*
        message("        cmp=%d cmp status=%d\n",
                                          pe[T_PE].fpwd[i].cmp_h,
                                          pe[T_PE].fpwd[i].cmp_val_l );
        */
    }
    message("FQE%2.2dD  ne=%d status=%d",
                                          pe[T_PE].fpdb.fqno-1,
                                          pe[T_PE].fpdb.ne_l,
                                          pe[T_PE].fpdb.status_l );
    message("  regsize=%d  register=%d",
                                          pe[T_PE].fpdb.len_l,
                                          pe[T_PE].fpdb.reg_l );
    message("  %08x-%08x  %08x-%08x  cnt=%d\n",
                                          pe[T_PE].fpdb.val_l0,
                                          pe[T_PE].fpdb.val_l1,
                                          pe[T_PE].fpdb.val_l2,
                                          pe[T_PE].fpdb.val_l3,
                                          pe[T_PE].fpdb.cnt);
#endif
    if( sync && pe[T_PE].work_ird0.fir ){
        fp_reg_write( t_pe, sync );
        if( pe[T_PE].avn_fpwd || ( pe[T_PE].fpdb.fqno > 0 ) ){
            pe[T_PE].sr[STAR1].star1.asaf = 1;
            return;
        }
        else{
            pe[T_PE].sr[STAR1].star1.asaf = 0;
            pe[T_PE].fp_op_exist = 0;
        }
        return;
    }
    else{
        if( fp_reg_write( t_pe, sync ) == FPU_SUCCEED ){
            if( ( fqe_no = fp_fqe_no( t_pe ) ) >= 0 ){
                switch( pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.ne * 2 +
                                         pe[T_PE].sr[FQE0L+fqe_no*2].fqel.ne ){
                    case 0:
                        pe[T_PE].fpwd[0].fqno      = fqe_no+1;
                        pe[T_PE].fpwd[0].ne_h      = 0;
                        pe[T_PE].fpwd[0].ne_l      = 0;
                        pe[T_PE].fpwd[0].divide    = 0;
                        pe[T_PE].fpwd[0].error     = FPU_SUCCEED;

                        pe[T_PE].avn_fpwd++;
                        pe[T_PE].fqi[fqe_no].write = 1;
                        pe[T_PE].fq_top++;
                        pe[T_PE].sr[STAR1].star1.asaf = 1;
                        return;
                        break;
                    case 1:
			tmpfl = fpu_acfc[pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_op];
                        asaf = tmpfl(t_pe, fqe_no,
                                  pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r1,
                                  pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r2,
                                  pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r3 );
                        if( asaf & SCORE_EXCEPTION ){
                            if( pe[T_PE].avn_fpwd || (pe[T_PE].fpdb.fqno > 0) ){
                                pe[T_PE].sr[STAR1].star1.asaf = 1;
                            }
                            else{
                                pe[T_PE].sr[STAR1].star1.asaf = 0;
                                pe[T_PE].fp_op_exist = 0;
                            }
                            return;
                        }
                        else{
                            pe[T_PE].sr[STAR1].star1.asaf = 1;
                            if( asaf == SCORE_FREE ){
                                fp_temp_clear( t_pe );
			        tmpfl = fpu_func_L[pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_op];
                                pe[T_PE].fpwd[0].error =
                                    tmpfl( t_pe, fqe_no+1,
                                    pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r1,
                                    pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r2,
                                    pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r3 );

                                pe[T_PE].fpwd[0].fqno      = fqe_no+1;
                                pe[T_PE].fpwd[0].ne_h      = 0;
    
                                pe[T_PE].avn_fpwd++;
                                pe[T_PE].fqi[fqe_no].write = 1;
                                pe[T_PE].fq_top++;
                            }
                            return;
                        }
                        break;
                    case 2:
			tmpfh = fpu_acfc[pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_op];
                        asaf =  tmpfh(t_pe, fqe_no,
                                  pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r1,
                                  pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r2,
                                  pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r3 );
                        if( asaf & SCORE_EXCEPTION ){
                            if( pe[T_PE].avn_fpwd || (pe[T_PE].fpdb.fqno > 0) ){
                                pe[T_PE].sr[STAR1].star1.asaf = 1;
                            }
                            else{
                                pe[T_PE].sr[STAR1].star1.asaf = 0;
                                pe[T_PE].fp_op_exist = 0;
                            }
                            return;
                        }
                        else{
                            pe[T_PE].sr[STAR1].star1.asaf = 1;
                            if( asaf == SCORE_FREE ){
                                fp_temp_clear( t_pe );
			        tmpfh = fpu_func_H[pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_op];
                                pe[T_PE].fpwd[0].error =
                                    tmpfh( t_pe, fqe_no+1,
                                      pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r1,
                                      pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r2,
                                      pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r3 );

                                pe[T_PE].fpwd[0].fqno      = fqe_no+1;
                                pe[T_PE].fpwd[0].ne_l      = 0;

                                pe[T_PE].avn_fpwd++;
                                pe[T_PE].fqi[fqe_no].write = 1;
                                pe[T_PE].fq_top++;
                            }
                            return;
                        } 
                        break;
                    case 3:
			tmpfh = fpu_acfc[pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_op];
			tmpfl = fpu_acfc[pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_op];
                        asaf = tmpfh( t_pe, fqe_no,
                                pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r1,
                                pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r2,
                                pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r3 ) |
                              tmpfl( t_pe, fqe_no,
                                pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r1,
                                pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r2,
                                pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r3 ) ;
                        if( asaf & SCORE_EXCEPTION ){
                            if( pe[T_PE].avn_fpwd || (pe[T_PE].fpdb.fqno > 0) ){
                                pe[T_PE].sr[STAR1].star1.asaf = 1;
                            }
                            else{
                                pe[T_PE].sr[STAR1].star1.asaf = 0;
                                pe[T_PE].fp_op_exist = 0;
                            }
                            return;
                        }
                        else{
                            pe[T_PE].sr[STAR1].star1.asaf = 1;
                            if( asaf == SCORE_FREE ){
                                fp_temp_clear( t_pe );
			        tmpfh = fpu_func_H[pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_op];
                                ret_h = tmpfh(
                                        t_pe,
                                        fqe_no+1,
                                        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r1,
                                        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r2,
                                        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.fopc_r3);
                                fp_temp_clear( t_pe );
			        tmpfl = fpu_func_L[pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_op];
                                ret_l = tmpfl(
                                        t_pe,
                                        fqe_no+1,
                                        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r1,
                                        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r2,
                                        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.sfopc_r3);
                                pe[T_PE].fpwd[0].error     = ret_h | ret_l;

                                pe[T_PE].avn_fpwd++;
                                pe[T_PE].fqi[fqe_no].write = 1;
                                pe[T_PE].fq_top++;
                            }
                            return;
                        }   
                        break;
                    default :
#ifdef FPUDEBUG
                        message(
                           "FQE not reserved code ( high_ne = low_ne = 1 )\n");
#endif
                        break;
                }
                pe[T_PE].sr[STAR1].star1.asaf = 1;
                return;
            }
        }
    }
    if( pe[T_PE].avn_fpwd || ( pe[T_PE].fpdb.fqno > 0 ) ){
        pe[T_PE].sr[STAR1].star1.asaf = 1;
        return;
    }
    else{
        pe[T_PE].sr[STAR1].star1.asaf = 0;
        pe[T_PE].fp_op_exist = 0;
    }
    return;
}

fp_fqe_no( t_pe )
    int     t_pe;
{
    int     fqe_no;

    for( fqe_no=pe[T_PE].fq_top ; fqe_no<FQ_NUM ; fqe_no++ ){
        if( pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.av ){
            if( !pe[T_PE].fqi[fqe_no].write ){
                return( fqe_no );
            }
            else{
                continue;
            }
        }
        return( -1 );
    }
    return( -1 );
}


fp_reg_write( t_pe, sync )
    int          t_pe;
    unsigned     sync; /* synchronous with instruction or exception */
{
    register int     i;
    register int     ret_h, ret_l, ret_p;
    unsigned         reg_vol[4][3];

    if( !pe[T_PE].avn_fpwd && !pe[T_PE].fpdb.fqno ){
        return( 0 );
    }

    reg_vol[0][0] = reg_vol[1][0] = reg_vol[2][0] = reg_vol[3][0] = 0;
    if( ( pe[T_PE].fpwd[0].fqno > 0 ) &&
        ( pe[T_PE].fpwd[0].error & ( FPU_DZ_ERROR | FPU_IVO_ERROR |
                                    FPU_UNI_ERROR | FPU_SRC_ERROR ) ) ){
        if( pe[T_PE].fpwd[0].ne_h &&
            ( pe[T_PE].fpwd[0].error_h & ( FPU_DZ_ERROR | FPU_IVO_ERROR |
                                          FPU_UNI_ERROR | FPU_SRC_ERROR ) ) ){
            pe[T_PE].sr[FQE0H+(pe[T_PE].fpwd[0].fqno-1)*2].fqeh.ne = 0;
            ret_p = fp_fpu_error_H( t_pe, pe[T_PE].fpwd[0].error_h,
                                          pe[T_PE].fpwd[0].fqno-1,
                                          pe[T_PE].fpwd[0].status_hf,
                                          pe[T_PE].fpwd[0].status_hs );
        }
        else{
            ret_p = FPU_SUCCEED;
        }
        if( pe[T_PE].fpwd[0].ne_l ){
            if( pe[T_PE].fpwd[0].divide ){
                if( pe[T_PE].fpdb.error_l & ( FPU_DZ_ERROR | FPU_IVO_ERROR |
                                             FPU_UNI_ERROR | FPU_SRC_ERROR ) ){
                    ret_p |= fp_fpu_error_L( t_pe, pe[T_PE].fpdb.error_l,
                                                  pe[T_PE].fpdb.fqno-1,
                                                  pe[T_PE].fpdb.status_lf,
                                                  pe[T_PE].fpdb.status_ls );
                    pe[T_PE].sr[FQE0L+(pe[T_PE].fpdb.fqno-1)*2].fqel.ne = 0;
                    pe[T_PE].fpdb.fqno = 0;
                }
                else{
                    if( pe[T_PE].fpdb.fqno == pe[T_PE].fpwd[0].fqno ){
                        pe[T_PE].fpdb.fqno = 0;
                    }
                }
                pe[T_PE].fpwd[0].divide = 0;
            }
            else{
                if( pe[T_PE].fpwd[0].error_l & ( FPU_DZ_ERROR | FPU_IVO_ERROR |
                                             FPU_UNI_ERROR | FPU_SRC_ERROR ) ){
                    ret_p |= fp_fpu_error_L( t_pe, pe[T_PE].fpwd[0].error_l,
                                                  pe[T_PE].fpwd[0].fqno-1,
                                                  pe[T_PE].fpwd[0].status_lf,
                                                  pe[T_PE].fpwd[0].status_ls );
                    pe[T_PE].sr[FQE0L+(pe[T_PE].fpwd[0].fqno-1)*2].fqel.ne = 0;
                }
            }
        }
        pe[T_PE].fqi[pe[T_PE].fpwd[0].fqno-1].write = 0;
        pe[T_PE].fpwd[0].fqno = 0;
        pe[T_PE].fq_top = FQ_NUM+1;
        pe[T_PE].avn_fpwd--;
    }
    else{
        ret_p = 0;
        ret_h = ret_l = FPU_SUCCEED;
    }

    if( pe[T_PE].fpwd[FP_WRITE_DELAY-1].fqno > 0 ){
        unsigned tmp;

        if( pe[T_PE].fpwd[FP_WRITE_DELAY-1].ne_h ){

            switch( pe[T_PE].fpwd[FP_WRITE_DELAY-1].len_h ){
                case 1 :
                    /* single/double */
                    reg_vol[1][0] =
                          (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_h;
                    reg_vol[1][1] = pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h0;
                    reg_vol[1][2] = pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h1;
                    break;
                case 2 :
                    /* extended */
                    if( pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_h & 1 ){
                        reg_vol[1][0] =
                            (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_h;
                        reg_vol[1][1] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h2;
                        reg_vol[1][2] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h3;
                    }
                    else{
                        reg_vol[0][0] =
                            (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_h;
                        reg_vol[0][1] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h0;
                        reg_vol[0][2] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h1;
                        reg_vol[1][0] =
                        (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_h | 1;
                        reg_vol[1][1] = 
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h2;
                        reg_vol[1][2] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_h3;
                    }
                    break;
                default : 
                    break;
            }
            if( pe[T_PE].fpwd[FP_WRITE_DELAY-1].cmp_h ){
                switch( pe[T_PE].fpwd[FP_WRITE_DELAY-1].cmp_val_h ){
                    case DATA_EQ :
                            pe[T_PE].sr[STAR0].star0.fcc_e = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                            break;
                    case DATA_LT : 
                            pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_l = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                            break;
                    case DATA_GT :  
                            pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_g = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                            break;
                    case DATA_UN :
                            pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_u = 1;
                            pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                            pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                            break;
                    default : 
                            message("fcmp final error!!\n");
                            break;
                }
            }
            ret_h = fp_fpu_error_H( t_pe,
                                  pe[T_PE].fpwd[FP_WRITE_DELAY-1].error_h,
                                  pe[T_PE].fpwd[FP_WRITE_DELAY-1].fqno-1,
                                  pe[T_PE].fpwd[FP_WRITE_DELAY-1].status_hf,
                                  pe[T_PE].fpwd[FP_WRITE_DELAY-1].status_hs );
        }
        else{
            ret_h = FPU_SUCCEED;
        }
        if( pe[T_PE].fpwd[FP_WRITE_DELAY-1].ne_l ){

            if( pe[T_PE].fpwd[FP_WRITE_DELAY-1].divide ){
                pe[T_PE].fpdb.ret_h = ret_h;
                pe[T_PE].fpwd[FP_WRITE_DELAY-1].divide = 0;
                ret_l = FPU_SUCCEED;
                goto divide_pass;
            }
            else{
                switch( pe[T_PE].fpwd[FP_WRITE_DELAY-1].len_l ){
                    case 1 :
                        /* single/double */
                        reg_vol[3][0] =
                            (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_l;
                        reg_vol[3][1] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l0;
                        reg_vol[3][2] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l1;
                        break;
                    case 2 :
                        /* extended */
                        if( pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_l & 1 ){
                            reg_vol[3][0] =
                           (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_l;
                            reg_vol[3][1] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l2;
                            reg_vol[3][2] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l3;
                        }
                        else{
                            reg_vol[2][0] =
                           (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_l;
                            reg_vol[2][1] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l0;
                            reg_vol[2][2] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l1;
                            reg_vol[3][0] =
                        (unsigned)pe[T_PE].fpwd[FP_WRITE_DELAY-1].reg_l | 1;
                            reg_vol[3][1] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l2;
                            reg_vol[3][2] =
                                     pe[T_PE].fpwd[FP_WRITE_DELAY-1].val_l3;
                        }
                        break;
                    default : 
                        break;
                }
                ret_l = fp_fpu_error_L( t_pe,
                                 pe[T_PE].fpwd[FP_WRITE_DELAY-1].error_l,
                                 pe[T_PE].fpwd[FP_WRITE_DELAY-1].fqno-1,
                                 pe[T_PE].fpwd[FP_WRITE_DELAY-1].status_lf,
                                 pe[T_PE].fpwd[FP_WRITE_DELAY-1].status_ls );
            }
        }
        else{
            ret_l = FPU_SUCCEED;
        }
        /* fqe clear root */
        fp_fqe_set( t_pe, sync,
                    pe[T_PE].fpwd[FP_WRITE_DELAY-1].fqno, ret_h, ret_l );

divide_pass:
        tmp = 0xffffffff;
        sys_fr_access( t_pe, reg_vol[0][0], _W_, tmp, tmp );
        sys_fr_access( t_pe, reg_vol[2][0], _W_, tmp, tmp );
        sys_fr_access( t_pe, reg_vol[0][0], _A_, reg_vol[0][1], reg_vol[0][2] );
        sys_fr_access( t_pe, reg_vol[2][0], _A_, reg_vol[2][1], reg_vol[2][2] );
        sys_fr_access( t_pe, reg_vol[1][0], _W_, tmp, tmp );
        sys_fr_access( t_pe, reg_vol[3][0], _W_, tmp, tmp );
        sys_fr_access( t_pe, reg_vol[1][0], _A_, reg_vol[1][1], reg_vol[1][2] );
        sys_fr_access( t_pe, reg_vol[3][0], _A_, reg_vol[3][1], reg_vol[3][2] );
        /*
        for( i=0 ; i<4 ; i++ ){
            sys_fr_access( t_pe, reg_vol[i][0], _A_,
                                                 reg_vol[i][1], reg_vol[i][2] );
        }
        */
        pe[T_PE].avn_fpwd--;
        pe[T_PE].fpwd[FP_WRITE_DELAY-1].fqno = 0;
    }

    if( pe[T_PE].fpdb.fqno > 0 ){
        if( pe[T_PE].fpdb.ne_l  && !( --pe[T_PE].fpdb.cnt ) ){
            if( pe[T_PE].fpdb.len_l ){
                /* single/double/extended_high */
                sys_fr_access( t_pe, pe[T_PE].fpdb.reg_l,
                                _W_, pe[T_PE].fpdb.val_l0,
                                     pe[T_PE].fpdb.val_l1);
                if( pe[T_PE].fpdb.len_l == 2 ){
                    /* extended_low */
                    sys_fr_access( t_pe, pe[T_PE].fpdb.reg_l | 1,
                                    _W_, pe[T_PE].fpdb.val_l2,
                                         pe[T_PE].fpdb.val_l3);
                }
            }
            ret_l = fp_fpu_error_L( t_pe, pe[T_PE].fpdb.error_l,
                                          pe[T_PE].fpdb.fqno-1,
                                          pe[T_PE].fpdb.status_lf,
                                          pe[T_PE].fpdb.status_ls );
            ret_p |= ret_l;
            /* fqe clear root */
            fp_fqe_set( t_pe, sync,
                        pe[T_PE].fpdb.fqno, pe[T_PE].fpdb.ret_h, ret_l );
            pe[T_PE].fpdb.fqno = pe[T_PE].fpdb.cnt = 0;
            pe[T_PE].fpdb.ne_l  = pe[T_PE].fpdb.len_l = 0;
            ret_h |= pe[T_PE].fpdb.ret_h;
            /*
            ret_h |= pe[T_PE].fpdb.ret_h;
             */
        }
    }
    if( pe[T_PE].avn_fpwd ){
        for( i = FP_WRITE_DELAY - 1 ; i > 0 ; i-- ){
            pe[T_PE].fpwd[i] = pe[T_PE].fpwd[i-1];
#ifdef FPUDEBUG2
        message(" fqno=%d  ne_h=%d ne_l=%d",    pe[T_PE].fpwd[3].fqno,
                                                pe[T_PE].fpwd[3].ne_h,
                                                pe[T_PE].fpwd[3].ne_l);
        message(" status h=%d l=%d\n",          pe[T_PE].fpwd[3].status_h,
                                                pe[T_PE].fpwd[3].status_l);
        message("         len h=%d reg h=%d",   pe[T_PE].fpwd[3].len_h,
                                                pe[T_PE].fpwd[3].reg_h);
        message(" %08x %08x %08x %08x\n",       pe[T_PE].fpwd[3].val_h0,
                                                pe[T_PE].fpwd[3].val_h1,
                                                pe[T_PE].fpwd[3].val_h2,
                                                pe[T_PE].fpwd[3].val_h3);
        message("         len l=%d reg l=%d",   pe[T_PE].fpwd[3].len_l,
                                                pe[T_PE].fpwd[3].reg_l);
        message(" %08x %08x %08x %08x\n",       pe[T_PE].fpwd[3].val_l0,
                                                pe[T_PE].fpwd[3].val_l1,
                                                pe[T_PE].fpwd[3].val_l2,
                                                pe[T_PE].fpwd[3].val_l3);
#endif
        }
        pe[T_PE].fpwd[0].fqno = 0;
        pe[T_PE].fpwd[0].ne_h = pe[T_PE].fpwd[0].ne_l  = 0;
        pe[T_PE].fpwd[0].cmp_h = 0;
        pe[T_PE].fpwd[0].divide = 0;
    }
    return( ret_h | ret_l | ret_p );
}

fp_fqe_set( t_pe, sync, fqno, ret_h, ret_l )
    int          t_pe;
    unsigned     sync; /* synchronous with instruction or exception */
    int          fqno, ret_h, ret_l;
{
    int          i;

    fqno--;

    /* fqe clear root */

    switch( ( (ret_h == FPU_SUCCEED) * 2 ) + (ret_l == FPU_SUCCEED) ){
        case 0 :
        case 1 :
        case 2 :
            /* not executed clear of high and low */
            pe[T_PE].sr[FQE0H+fqno*2].fqeh.av = 1;
            pe[T_PE].sr[FQE0H+fqno*2].fqeh.ne = 0;
            pe[T_PE].sr[FQE0L+fqno*2].fqel.ne = 0;
            pe[T_PE].fqi[fqno].write  = 0;
            break;
            /* fq entry low word only */
            /*
            pe[T_PE].sr[FQE0L+fqno*2].ful     = 0;
            pe[T_PE].sr[FQE0H+fqno*2].fqeh.av = 1;
            pe[T_PE].sr[FQE0H+fqno*2].fqeh.ne = 0;
            pe[T_PE].fqi[fqno].write  = 0;
            break;
            */
            /* fq entry high word only */
            /*
            pe[T_PE].sr[FQE0H+fqno*2].ful     = 0;
            pe[T_PE].sr[FQE0H+fqno*2].fqeh.av = 1;
            pe[T_PE].sr[FQE0L+fqno*2].fqel.ne = 0;
            pe[T_PE].fqi[fqno].write  = 0;
            break;
            */
        case 3 :
            /* fq entry high and low word */
            if( ( fqno < 2 ) &&
                pe[T_PE].sr[FQE0H+fqno*2].fqeh.av &&
                !( sync && pe[T_PE].work_ird0.fir ) &&
                !( pe[T_PE].sr[FQE0H].ful & 0x3f000000 ) &&
                !( pe[T_PE].sr[FQE0L].ful & 0x3f000000 ) &&
                !( pe[T_PE].sr[FQE0H+2].ful & 0x3f000000 ) &&
                !( pe[T_PE].sr[FQE0L+2].ful & 0x3f000000 ) ){

                /* delete queue entry */

                for( i=fqno ; i<FQ_NUM-1 ; i++){
                    pe[T_PE].sr[FQE0H+i*2].ful = pe[T_PE].sr[FQE0H+i*2+2].ful;
                    pe[T_PE].sr[FQE0L+i*2].ful = pe[T_PE].sr[FQE0L+i*2+2].ful;
                    pe[T_PE].fqi[i].write      = pe[T_PE].fqi[i+1].write;
                }
                if( pe[T_PE].fpdb.fqno > fqno+1 ){
                    pe[T_PE].fpdb.fqno--;
                }
                for( i = 0 ; i < FP_WRITE_DELAY ; i++ ){
                    if( pe[T_PE].fpwd[i].fqno > fqno+1 ){
                        pe[T_PE].fpwd[i].fqno--;
                    }
                }
                pe[T_PE].sr[FQE0H + ( FQ_NUM-1 )*2].ful   = 0;
                pe[T_PE].sr[FQE0L + ( FQ_NUM-1 )*2].ful   = 0;
                pe[T_PE].fqi[FQ_NUM-1].write = 0;
                if( ( --pe[T_PE].fq_top ) < 0 ){
                    pe[T_PE].fq_top = 0;
                }
            }
            else{
                pe[T_PE].sr[FQE0H+(fqno)*2].fqeh.av = 1;
                pe[T_PE].sr[FQE0H+(fqno)*2].fqeh.ne = 0;
                pe[T_PE].sr[FQE0L+(fqno)*2].fqel.ne = 0;
                pe[T_PE].fqi[fqno].write            = 0;
            }
            break;
        default :
            break;
    }
}

fp_fpu_error_H( t_pe, error_code, fqe_no, ff, sts )
int t_pe, error_code, fqe_no, ff, sts;
{
    pe[T_PE].sr[FPC].ful |= ( ( sts & 0x001f ) << 20 );
    if( error_code ){
        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.irv |= ( ff & FPU_IRV_ERROR )?1:0;
        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.iru |= ( ff & FPU_IRU_ERROR )?1:0;
        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.uni |= ( ff & FPU_UNI_ERROR )?1:0;
        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.ivo |= ( ff & FPU_IVO_ERROR )?1:0;
        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.dz  |= ( ff & FPU_DZ_ERROR )?1:0;
        pe[T_PE].sr[FQE0H+fqe_no*2].fqeh.ine |= ( ff & FPU_INE_ERROR )?1:0;
        pe[T_PE].work_ird0.fir = 1;
        return( error_code );
    }
    return( FPU_SUCCEED );
}

fp_fpu_error_L( t_pe, error_code, fqe_no, ff, sts )
int t_pe, error_code, fqe_no, ff, sts;
{
    pe[T_PE].sr[FPC].ful |= ( ( sts & 0x001f ) << 20 );
    if( error_code ){
        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.irv |= ( ff & FPU_IRV_ERROR )?1:0;
        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.iru |= ( ff & FPU_IRU_ERROR )?1:0;
        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.uni |= ( ff & FPU_UNI_ERROR )?1:0;
        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.ivo |= ( ff & FPU_IVO_ERROR )?1:0;
        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.dz  |= ( ff & FPU_DZ_ERROR )?1:0;
        pe[T_PE].sr[FQE0L+fqe_no*2].fqel.ine |= ( ff & FPU_INE_ERROR )?1:0;
        pe[T_PE].work_ird0.fir = 1;
        return( error_code );
    }
    return( FPU_SUCCEED );
}

fp_ac_fpu_RIE( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fadd( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fsub( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3; 
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}
fp_ac_fmul( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;  
{ 
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) ); 
}
fp_ac_fdiv( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;  
{ 
    if( pe[T_PE].fpdb.fqno ){
        return( SCORE_BUSY );
    }
    else{
        return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
                sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
                sys_fr_check_score(t_pe,fr3,_W_,fqe_no) ); 
    }
}
fp_ac_fcmp( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) );
}

fp_ac_fadd_d( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fsub_d( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fmul_d( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fdiv_d( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    if( pe[T_PE].fpdb.fqno ){
        return( SCORE_BUSY );
    }
    else{
        return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
                sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
                sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
    }
}

fp_ac_fcmp_d( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) );
}

fp_ac_fadd_x( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr1 | 0x00000001,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2 | 0x00000001,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) |
            sys_fr_check_score(t_pe,fr3 | 0x00000001,_W_,fqe_no) );
}

fp_ac_fsub_x( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr1 | 0x00000001,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2 | 0x00000001,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) |
            sys_fr_check_score(t_pe,fr3 | 0x00000001,_W_,fqe_no) );
}

fp_ac_fcmp_x( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr1 | 0x00000001,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr2 | 0x00000001,_R_,fqe_no) );
}

fp_ac_fcnv_fd( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnv_df( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnv_dx( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) |
            sys_fr_check_score(t_pe,fr3 | 0x00000001,_W_,fqe_no) );
}

fp_ac_fcnv_xd( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr1 | 0x00000001,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnv_if( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnv_fi( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnv_id( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnv_di( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnz_fi( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_ac_fcnz_di( t_pe, fqe_no, fr1, fr2, fr3 )
int       t_pe, fqe_no;
unsigned  fr1, fr2, fr3;
{
    return( sys_fr_check_score(t_pe,fr1,_R_,fqe_no) |
            sys_fr_check_score(t_pe,fr3,_W_,fqe_no) );
}

fp_fpu_RIEH( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1;
    unsigned fr2;
    unsigned fr3;
{

#ifdef FPUDEBUG
    message("FPU reserved instruction exception !!\n");
#endif
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = FPU_SUCCEED;
    pe[T_PE].fpwd[0].status_hf = 0;
    pe[T_PE].fpwd[0].status_hs = 0;
    pe[T_PE].fpwd[0].len_h     = 0;
    return( FPU_SUCCEED );
}

fp_fpu_RIEL( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1;
    unsigned fr2;
    unsigned fr3;
{

#ifdef FPUDEBUG
    message("FPU reserved instruction exception !!\n");
#endif
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_l      = 1;
    pe[T_PE].fpwd[0].error_l   = FPU_SUCCEED;
    pe[T_PE].fpwd[0].status_lf = 0;
    pe[T_PE].fpwd[0].status_ls = 0;
    pe[T_PE].fpwd[0].len_l     = 0;
    pe[T_PE].fpwd[0].divide    = 0;
    return( FPU_SUCCEED );
}

fp_fadd( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_add_temp( t_pe, FTREG1, FTREG2, FTREG3, FLOAT_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;
        pe[T_PE].fpwd[0].reg_h = fr3;
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = 0x00000000;
    }
#endif
    return( ret );
}

fp_fadd_d( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_add_temp( t_pe, FTREG1, FTREG2, FTREG3, DOUBLE_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1; 
        pe[T_PE].fpwd[0].reg_h = fr3; 
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0]; 
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fsub( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    un_fr[FTREG2].f_data.s = un_fr[FTREG2].f_data.s ^ 0x00000001;
    ret = fp_add_temp( t_pe, FTREG1, FTREG2, FTREG3, FLOAT_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;  
        pe[T_PE].fpwd[0].reg_h = fr3;  
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = 0x00000000;
    }
#endif
    return( ret );
} 

fp_fsub_d( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    un_fr[FTREG2].d_data.s = un_fr[FTREG2].d_data.s ^ 0x00000001;
    ret = fp_add_temp( t_pe, FTREG1, FTREG2, FTREG3, DOUBLE_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;  
        pe[T_PE].fpwd[0].reg_h = fr3;  
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fmul( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_mul_temp( t_pe, FTREG1, FTREG2, FTREG3, FLOAT_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_l      = 1;
    pe[T_PE].fpwd[0].error_l   = ret;
    pe[T_PE].fpwd[0].status_lf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_ls = un_fcr.fck.sts;
    pe[T_PE].fpwd[0].divide    = 0;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_l = 1;  
        pe[T_PE].fpwd[0].reg_l = fr3;  
        pe[T_PE].fpwd[0].val_l0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_l1 = 0x00000000;
    }
#endif
    return( ret );
} 

fp_fmul_d( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_mul_temp( t_pe, FTREG1, FTREG2, FTREG3, DOUBLE_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_l      = 1;
    pe[T_PE].fpwd[0].error_l   = ret;
    pe[T_PE].fpwd[0].status_lf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_ls = un_fcr.fck.sts;
    pe[T_PE].fpwd[0].divide    = 0;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_l = 1;  
        pe[T_PE].fpwd[0].reg_l = fr3;  
        pe[T_PE].fpwd[0].val_l0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_l1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fdiv( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_div_temp( t_pe, FTREG1, FTREG2, FTREG3, FLOAT_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpdb.fqno      = fqe_no;
    pe[T_PE].fpdb.ne_l      = 1;
    pe[T_PE].fpdb.error_l   = ret;
    pe[T_PE].fpdb.status_lf = un_fcr.fck.ff;
    pe[T_PE].fpdb.status_ls = un_fcr.fck.sts;
    pe[T_PE].fpdb.cnt       = FP_DIVF_DELAY;
    pe[T_PE].fpwd[0].divide = 1;
    pe[T_PE].fpwd[0].ne_l   = 1;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpdb.len_l = 1;  
        pe[T_PE].fpdb.reg_l = fr3;  
        pe[T_PE].fpdb.val_l0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpdb.val_l1 = 0x00000000;
    }
#endif
    return( ret );
} 

fp_fdiv_d( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_div_temp( t_pe, FTREG1, FTREG2, FTREG3, DOUBLE_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpdb.fqno      = fqe_no;
    pe[T_PE].fpdb.ne_l      = 1;
    pe[T_PE].fpdb.error_l   = ret;
    pe[T_PE].fpdb.status_lf = un_fcr.fck.ff;
    pe[T_PE].fpdb.status_ls = un_fcr.fck.sts;
    pe[T_PE].fpdb.cnt       = FP_DIVD_DELAY;
    pe[T_PE].fpwd[0].divide = 1;
    pe[T_PE].fpwd[0].ne_l   = 1;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpdb.len_l = 1;  
        pe[T_PE].fpdb.reg_l = fr3;  
        pe[T_PE].fpdb.val_l0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpdb.val_l1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fcnv_fd( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_temp( t_pe, FTREG1, FTREG3, FLOAT_DATA, DOUBLE_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;  
        pe[T_PE].fpwd[0].reg_h = fr3;  
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fcnv_df( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;
 
    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_temp( t_pe, FTREG1, FTREG3, DOUBLE_DATA, FLOAT_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;
        pe[T_PE].fpwd[0].reg_h = fr3;
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = 0x00000000;
    }
#endif
    return( ret );
} 

fp_fcnv_if( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_it_temp( t_pe, FTREG1, FTREG3, INTEGER_DATA, FLOAT_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;  
        pe[T_PE].fpwd[0].reg_h = fr3;  
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = 0x00000000;
    }
#endif
    return( ret );
} 

fp_fcnv_fi( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_ti_temp( t_pe, FTREG1, FTREG3, FLOAT_DATA, INTEGER_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;  
        pe[T_PE].fpwd[0].reg_h = fr3;  
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fcnv_id( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_it_temp( t_pe, FTREG1, FTREG3, INTEGER_DATA, DOUBLE_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;  
        pe[T_PE].fpwd[0].reg_h = fr3;  
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fcnv_di( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{
    register unsigned ret;
 
    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_ti_temp( t_pe, FTREG1, FTREG3, DOUBLE_DATA, INTEGER_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;
        pe[T_PE].fpwd[0].reg_h = fr3;
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
} 

fp_fcnz_fi( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1;
    unsigned fr2;
    unsigned fr3;
{
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_ti_temp( t_pe, FTREG1, FTREG3, FLOAT_DATA, INTEGER_DATA_Z );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] );
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;
        pe[T_PE].fpwd[0].reg_h = fr3;
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
}

fp_fcnz_di( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1;
    unsigned fr2;
    unsigned fr3;
{
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_ti_temp( t_pe, FTREG1, FTREG3, DOUBLE_DATA, INTEGER_DATA_Z );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] );
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;
        pe[T_PE].fpwd[0].reg_h = fr3;
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
}

fp_fcmp( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_cmp_temp( t_pe, FTREG1, FTREG2, FTREG3, FLOAT_DATA, 0 );
#ifdef  FPUTEST
    switch( un_fcr.ctl.cmd ){
        case DATA_EQ :
                pe[T_PE].sr[STAR0].star0.fcc_e = 1;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                break;
       case DATA_LT : 
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 1;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                break;
       case DATA_GT :  
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 1;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                break;
       case DATA_UN :
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 1;
                pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                break;
       default : 
                message("fcmp final error!!\n");
                break;
    }
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].len_h     = 0;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].cmp_h = 1;
        pe[T_PE].fpwd[0].cmp_val_h = un_fcr.ctl.cmd;
    }
#endif
    return( ret );
} 

fp_fcmp_d( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    ret = fp_cmp_temp( t_pe, FTREG1, FTREG2, FTREG3, DOUBLE_DATA, 0 );
#ifdef  FPUTEST
    switch( un_fcr.ctl.cmd ){
        case DATA_EQ :
                pe[T_PE].sr[STAR0].star0.fcc_e = 1;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                break;
       case DATA_LT : 
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 1;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                break;
       case DATA_GT :  
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 1;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                break;
       case DATA_UN :
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 1;
                pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                break;
       default : 
                message("fcmp final error!!\n");
                break;
    }
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].len_h     = 0;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].cmp_h = 1;
        pe[T_PE].fpwd[0].cmp_val_h = un_fcr.ctl.cmd;
    }
#endif
    return( ret );
} 

fp_fcmp_x( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr1 | 1, _R_, un_fr[FTREG1].fr[2], un_fr[FTREG1].fr[3] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    sys_fr_access( t_pe, fr2 | 1, _R_, un_fr[FTREG2].fr[2], un_fr[FTREG2].fr[3] );
    ret = fp_cmp_temp( t_pe, FTREG1, FTREG2, FTREG3, EXTENDED_DATA, 0 );
#ifdef  FPUTEST
    switch( un_fcr.ctl.cmd ){
        case DATA_EQ :
                pe[T_PE].sr[STAR0].star0.fcc_e = 1;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                break;
       case DATA_LT : 
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 1;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                break;
       case DATA_GT :  
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 1;
                pe[T_PE].sr[STAR0].star0.fcc_u = 0;
                pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 1;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 0;
                break;
       case DATA_UN :
                pe[T_PE].sr[STAR0].star0.fcc_e = 0;
                pe[T_PE].sr[STAR0].star0.fcc_l = 0;
                pe[T_PE].sr[STAR0].star0.fcc_g = 0;
                pe[T_PE].sr[STAR0].star0.fcc_u = 1;
                pe[T_PE].sr[STAR0].star0.fcc_le = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ge = 0;
                pe[T_PE].sr[STAR0].star0.fcc_ue = 1;
                break;
       default : 
                message("fcmp final error!!\n");
                break;
    }
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].len_h     = 0;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].cmp_h = 1;
        pe[T_PE].fpwd[0].cmp_val_h = un_fcr.ctl.cmd;
    }
#endif
    return( ret );
} 

fp_fadd_x( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr1 | 1, _R_, un_fr[FTREG1].fr[2], un_fr[FTREG1].fr[3] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    sys_fr_access( t_pe, fr2 | 1, _R_, un_fr[FTREG2].fr[2], un_fr[FTREG2].fr[3] );
    ret = fp_add_temp( t_pe, FTREG1, FTREG2, FTREG3, EXTENDED_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] );
    sys_fr_access( t_pe, fr3 | 0x01, _W_,
                       un_fr[FTREG3].fr[2], un_fr[FTREG3].fr[3] );
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 2;  
        pe[T_PE].fpwd[0].reg_h = fr3;  
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
        pe[T_PE].fpwd[0].val_h2 = un_fr[FTREG3].fr[2];
        pe[T_PE].fpwd[0].val_h3 = un_fr[FTREG3].fr[3];
    }
#endif
    return( ret );
} 
fp_fsub_x( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;

    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr1 | 1, _R_, un_fr[FTREG1].fr[2], un_fr[FTREG1].fr[3] );
    sys_fr_access( t_pe, fr2, _R_, un_fr[FTREG2].fr[0], un_fr[FTREG2].fr[1] );
    sys_fr_access( t_pe, fr2 | 1, _R_, un_fr[FTREG2].fr[2], un_fr[FTREG2].fr[3] );
    un_fr[FTREG2].e_data.s = un_fr[FTREG2].e_data.s ^ 0x00000001;
    ret = fp_add_temp( t_pe, FTREG1, FTREG2, FTREG3, EXTENDED_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
    sys_fr_access( t_pe, fr3 | 0x01, _W_,
                       un_fr[FTREG3].fr[2], un_fr[FTREG3].fr[3] );
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 2;   
        pe[T_PE].fpwd[0].reg_h = fr3;   
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0]; 
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1]; 
        pe[T_PE].fpwd[0].val_h2 = un_fr[FTREG3].fr[2];
        pe[T_PE].fpwd[0].val_h3 = un_fr[FTREG3].fr[3];
    }
#endif
    return( ret );
} 
fp_fcnv_dx( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;
 
    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    ret = fp_cnv_temp( t_pe, FTREG1, FTREG3, DOUBLE_DATA, EXTENDED_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
    sys_fr_access( t_pe, fr3 | 0x01, _W_, un_fr[FTREG3].fr[2], un_fr[FTREG3].fr[3] );
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 2;   
        pe[T_PE].fpwd[0].reg_h = fr3;   
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0]; 
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1]; 
        pe[T_PE].fpwd[0].val_h2 = un_fr[FTREG3].fr[2];
        pe[T_PE].fpwd[0].val_h3 = un_fr[FTREG3].fr[3];
    }
#endif
    return( ret );
} 

fp_fcnv_xd( t_pe, fqe_no, fr1, fr2, fr3 )
    int      t_pe, fqe_no;
    unsigned fr1; 
    unsigned fr2; 
    unsigned fr3; 
{ 
    register unsigned ret;
 
    sys_fr_access( t_pe, fr1, _R_, un_fr[FTREG1].fr[0], un_fr[FTREG1].fr[1] );
    sys_fr_access( t_pe, fr1|1, _R_, un_fr[FTREG1].fr[2], un_fr[FTREG1].fr[3] );
    ret = fp_cnv_temp( t_pe, FTREG1, FTREG3, EXTENDED_DATA, DOUBLE_DATA );
#ifdef  FPUTEST
    sys_fr_access( t_pe, fr3, _W_, un_fr[FTREG3].fr[0], un_fr[FTREG3].fr[1] ); 
#else
    pe[T_PE].fpwd[0].fqno      = fqe_no;
    pe[T_PE].fpwd[0].ne_h      = 1;
    pe[T_PE].fpwd[0].error_h   = ret;
    pe[T_PE].fpwd[0].status_hf = un_fcr.fck.ff;
    pe[T_PE].fpwd[0].status_hs = un_fcr.fck.sts;
    if( !un_fcr.ctl.trct ){
        pe[T_PE].fpwd[0].len_h = 1;
        pe[T_PE].fpwd[0].reg_h = fr3;
        pe[T_PE].fpwd[0].val_h0 = un_fr[FTREG3].fr[0];
        pe[T_PE].fpwd[0].val_h1 = un_fr[FTREG3].fr[1];
    }
#endif
    return( ret );
}

fp_interruption_check( t_pe, treg1, treg2, treg3 )
int       t_pe;
unsigned  treg1, treg2, treg3;
{ 

    if( un_fcr.ctl.ivo && pe[T_PE].sr[FPC].fpc.fom ){
            return( FPU_IVO_ERROR );
    }
    else{
        if( un_fcr.ctl.uni ){
            return( FPU_UNI_ERROR );
        }
        else{
            if( un_fcr.ctl.dz && pe[T_PE].sr[FPC].fpc.fdm ){
                return( FPU_DZ_ERROR );
            }
            else{
                if( un_fcr.ctl.irv ){
                    return( FPU_IRV_ERROR );
                }
                else{
                    if( un_fcr.ctl.iru ){
                        return( FPU_IRU_ERROR );
                    }
                    else{
                        if( un_fcr.ctl.ine && pe[T_PE].sr[FPC].fpc.fim ){
                            return( FPU_INE_ERROR );
                        }
                        else{
                             return( FPU_SUCCEED );
                        }
                    }
                }
            }
        }
    }
} 
