/* @(#)ip-oper.c	1.11    3/4/93 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* ip-oper.c    89/10/1 */
 
/********************************
*	nop			*
* 'c'  return SCORE_FREE        *
* 'r'  return SCORE_FREE        *
* 'x'  return SCORE_FREE        *
********************************/

o_nop(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  return(SCORE_FREE);
}

/********************************
*	branch			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_brcs0(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(pe[T_PE].sr[STAR0].ful & ((unsigned)0x80000000 >> insn.i3_12_5.r3))
      pe[T_PE].sr[PC].ful += (((int)(insn.i3_12_5.im << 20) >> 20) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

o_brncs0(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(!(pe[T_PE].sr[STAR0].ful & ((unsigned)0x80000000 >> insn.i3_12_5.r3)))
      pe[T_PE].sr[PC].ful += (((int)(insn.i3_12_5.im << 20) >> 20) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

o_brc0(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(pe[T_PE].sr[STAR0].ful & ((unsigned)0x80000000 >> insn.i3_32_5.r3))
      pe[T_PE].sr[PC].ful += (((insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

o_brnc0(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(!(pe[T_PE].sr[STAR0].ful & ((unsigned)0x80000000 >> insn.i3_32_5.r3)))
      pe[T_PE].sr[PC].ful += (((insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l) << 3);
    else if (!insn.i3_32_5.r3) {
      pe[T_PE].cntl_block = pe[T_PE].sr[PC].ful + (((insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l) << 3);
      serialize(-1, 0);
    }
    return;
  }
  else
    return(SCORE_FREE);
}

o_brcs1(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(pe[T_PE].sr[STAR1].ful & ((unsigned)0x80000000 >> insn.i3_12_5.r3))
      pe[T_PE].sr[PC].ful += (((int)(insn.i3_12_5.im << 20) >> 20) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

o_brncs1(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(!(pe[T_PE].sr[STAR1].ful & ((unsigned)0x80000000 >> insn.i3_12_5.r3)))
      pe[T_PE].sr[PC].ful += (((int)(insn.i3_12_5.im << 20) >> 20) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

o_brc1(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(pe[T_PE].sr[STAR1].ful & ((unsigned)0x80000000 >> insn.i3_32_5.r3))
      pe[T_PE].sr[PC].ful += (((insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

o_brnc1(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    if(!(pe[T_PE].sr[STAR1].ful & ((unsigned)0x80000000 >> insn.i3_32_5.r3)))
      pe[T_PE].sr[PC].ful += (((insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

/********************************
*	call			*
* 'c'  return SCORE_FREE        *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_call(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  if (cmd == 'x') {
    sys_gr_access(t_pe, insn.i3_32_5.r3, _W_,pe[T_PE].sr[PC].ful);
    pe[T_PE].sr[PC].ful += (((insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l) << 3);
    return;
  }
  else
    return(SCORE_FREE);
}

/********************************
*	seti			*
* 'c'  return SCORE_FREE        *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_seti(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  unsigned tmp;

  if (cmd == 'x') {
    tmp = (insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l;
    sys_gr_access(t_pe, insn.i3_32_5.r3, _W_, tmp);
    return;
  }
  else
    return(SCORE_FREE);
}

/********************************
*	jmp			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_jmp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_,src1);
    return;
  }
  else if (cmd == 'x') {
    pe[T_PE].sr[PC].ful = src1;
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

/********************************
*	arithmetics		*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute (EXCEPTION)      *
********************************/

o_addp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x01000000),%0":"=g"(tmp3));
      asm("addcc %2,%3,%0;bvc,a  .LADDV0;or %4,%5,%1;andn %4,%5,%1;.LADDV0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("bz,a   .LADDZ0;or %1,%2,%0;andn %1,%2,%0;.LADDZ0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LADDN0;or %1,%2,%0;andn %1,%2,%0;.LADDN0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_adds(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x00010000),%0":"=g"(tmp3));
      asm("addcc %2,%3,%0;bvc,a  .LADDV1;or %4,%5,%1;andn %4,%5,%1;.LADDV1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("bz,a   .LADDZ1;or %1,%2,%0;andn %1,%2,%0;.LADDZ1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LADDN1;or %1,%2,%0;andn %1,%2,%0;.LADDN1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_addi5p(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x01000000),%0":"=g"(tmp3));
      asm("addcc %2,%3,%0;bvc,a  .LADDI5V0;or %4,%5,%1;andn %4,%5,%1;.LADDI5V0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("bz,a   .LADDI5Z0;or %1,%2,%0;andn %1,%2,%0;.LADDI5Z0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LADDI5N0;or %1,%2,%0;andn %1,%2,%0;.LADDI5N0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_addi5s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x00010000),%0":"=g"(tmp3));
      asm("addcc %2,%3,%0;bvc,a  .LADDI5V1;or %4,%5,%1;andn %4,%5,%1;.LADDI5V1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("bz,a   .LADDI5Z1;or %1,%2,%0;andn %1,%2,%0;.LADDI5Z1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LADDI5N1;or %1,%2,%0;andn %1,%2,%0;.LADDI5N1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_addi25p(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x01000000),%0":"=g"(tmp3));
      asm("addcc %2,%3,%0;bvc,a  .LADDI25V0;or %4,%5,%1;andn %4,%5,%1;.LADDI25V0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("bz,a   .LADDI25Z0;or %1,%2,%0;andn %1,%2,%0;.LADDI25Z0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LADDI25N0;or %1,%2,%0;andn %1,%2,%0;.LADDI25N0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_addi25s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x00010000),%0":"=g"(tmp3));
      asm("addcc %2,%3,%0;bvc,a  .LADDI25V1;or %4,%5,%1;andn %4,%5,%1;.LADDI25V1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("bz,a   .LADDI25Z1;or %1,%2,%0;andn %1,%2,%0;.LADDI25Z1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LADDI25N1;or %1,%2,%0;andn %1,%2,%0;.LADDI25N1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_subp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x01000000),%0":"=g"(tmp3));
      asm("subcc %2,%3,%0;bvc,a  .LSUBV0;or %4,%5,%1;andn %4,%5,%1;.LSUBV0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("bz,a   .LSUBZ0;or %1,%2,%0;andn %1,%2,%0;.LSUBZ0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LSUBN0;or %1,%2,%0;andn %1,%2,%0;.LSUBN0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x20000000),%0":"=g"(tmp3));
      asm("bl,a .LSUBL0;or %1,%2,%0;andn %1,%2,%0;.LSUBL0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x10000000),%0":"=g"(tmp3));
      asm("ble,a .LSUBLE0;or %1,%2,%0;andn %1,%2,%0;.LSUBLE0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x08000000),%0":"=g"(tmp3));
      asm("blu,a .LSUBLU0;or %1,%2,%0;andn %1,%2,%0;.LSUBLU0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x04000000),%0":"=g"(tmp3));
      asm("bleu,a .LSUBLUE0;or %1,%2,%0;andn %1,%2,%0;.LSUBLUE0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_subs(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x00010000),%0":"=g"(tmp3));
      asm("subcc %2,%3,%0;bvc,a  .LSUBV1;or %4,%5,%1;andn %4,%5,%1;.LSUBV1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("bz,a   .LSUBZ1;or %1,%2,%0;andn %1,%2,%0;.LSUBZ1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LSUBN1;or %1,%2,%0;andn %1,%2,%0;.LSUBN1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00200000),%0":"=g"(tmp3));
      asm("bl,a .LSUBL1;or %1,%2,%0;andn %1,%2,%0;.LSUBL1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00100000),%0":"=g"(tmp3));
      asm("ble,a .LSUBLE1;or %1,%2,%0;andn %1,%2,%0;.LSUBLE1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00080000),%0":"=g"(tmp3));
      asm("blu,a .LSUBLU1;or %1,%2,%0;andn %1,%2,%0;.LSUBLU1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00040000),%0":"=g"(tmp3));
      asm("bleu,a .LSUBLUE1;or %1,%2,%0;andn %1,%2,%0;.LSUBLUE1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_subi5p(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x01000000),%0":"=g"(tmp3));
      asm("subcc %2,%3,%0;bvc,a  .LSUBI5V0;or %4,%5,%1;andn %4,%5,%1;.LSUBI5V0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("bz,a   .LSUBI5Z0;or %1,%2,%0;andn %1,%2,%0;.LSUBI5Z0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LSUBI5N0;or %1,%2,%0;andn %1,%2,%0;.LSUBI5N0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x20000000),%0":"=g"(tmp3));
      asm("bl,a .LSUBI5L0;or %1,%2,%0;andn %1,%2,%0;.LSUBI5L0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x10000000),%0":"=g"(tmp3));
      asm("ble,a .LSUBI5LE0;or %1,%2,%0;andn %1,%2,%0;.LSUBI5LE0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x08000000),%0":"=g"(tmp3));
      asm("blu,a .LSUBI5LU0;or %1,%2,%0;andn %1,%2,%0;.LSUBI5LU0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x04000000),%0":"=g"(tmp3));
      asm("bleu,a .LSUBI5LUE0;or %1,%2,%0;andn %1,%2,%0;.LSUBI5LUE0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_subi5s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x00010000),%0":"=g"(tmp3));
      asm("subcc %2,%3,%0;bvc,a  .LSUBI5V1;or %4,%5,%1;andn %4,%5,%1;.LSUBI5V1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("bz,a   .LSUBI5Z1;or %1,%2,%0;andn %1,%2,%0;.LSUBI5Z1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LSUBI5N1;or %1,%2,%0;andn %1,%2,%0;.LSUBI5N1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00200000),%0":"=g"(tmp3));
      asm("bl,a .LSUBI5L1;or %1,%2,%0;andn %1,%2,%0;.LSUBI5L1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00100000),%0":"=g"(tmp3));
      asm("ble,a .LSUBI5LE1;or %1,%2,%0;andn %1,%2,%0;.LSUBI5LE1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00080000),%0":"=g"(tmp3));
      asm("blu,a .LSUBI5LU1;or %1,%2,%0;andn %1,%2,%0;.LSUBI5LU1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00040000),%0":"=g"(tmp3));
      asm("bleu,a .LSUBI5LUE1;or %1,%2,%0;andn %1,%2,%0;.LSUBI5LUE1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_subi25p(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x01000000),%0":"=g"(tmp3));
      asm("subcc %2,%3,%0;bvc,a  .LSUBI25V0;or %4,%5,%1;andn %4,%5,%1;.LSUBI25V0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("bz,a   .LSUBI25Z0;or %1,%2,%0;andn %1,%2,%0;.LSUBI25Z0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LSUBI25N0;or %1,%2,%0;andn %1,%2,%0;.LSUBI25N0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x20000000),%0":"=g"(tmp3));
      asm("bl,a .LSUBI25L0;or %1,%2,%0;andn %1,%2,%0;.LSUBI25L0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x10000000),%0":"=g"(tmp3));
      asm("ble,a .LSUBI25LE0;or %1,%2,%0;andn %1,%2,%0;.LSUBI25LE0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x08000000),%0":"=g"(tmp3));
      asm("blu,a .LSUBI25LU0;or %1,%2,%0;andn %1,%2,%0;.LSUBI25LU0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x04000000),%0":"=g"(tmp3));
      asm("bleu,a .LSUBI25LUE0;or %1,%2,%0;andn %1,%2,%0;.LSUBI25LUE0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_subi25s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x00010000),%0":"=g"(tmp3));
      asm("subcc %2,%3,%0;bvc,a  .LSUBI25V1;or %4,%5,%1;andn %4,%5,%1;.LSUBI25V1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("bz,a   .LSUBI25Z1;or %1,%2,%0;andn %1,%2,%0;.LSUBI25Z1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LSUBI25N1;or %1,%2,%0;andn %1,%2,%0;.LSUBI25N1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00200000),%0":"=g"(tmp3));
      asm("bl,a .LSUBI25L1;or %1,%2,%0;andn %1,%2,%0;.LSUBI25L1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00100000),%0":"=g"(tmp3));
      asm("ble,a .LSUBI25LE1;or %1,%2,%0;andn %1,%2,%0;.LSUBI25LE1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00080000),%0":"=g"(tmp3));
      asm("blu,a .LSUBI25LU1;or %1,%2,%0;andn %1,%2,%0;.LSUBI25LU1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00040000),%0":"=g"(tmp3));
      asm("bleu,a .LSUBI25LUE1;or %1,%2,%0;andn %1,%2,%0;.LSUBI25LUE1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_andp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("andcc %2,%3,%0;bz,a  .LANDZ0;or %4,%5,%1;andn %4,%5,%1;.LANDZ0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LANDN0;or %1,%2,%0;andn %1,%2,%0;.LANDN0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_ands(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("andcc %2,%3,%0;bz,a  .LANDZ1;or %4,%5,%1;andn %4,%5,%1;.LANDZ1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LANDN1;or %1,%2,%0;andn %1,%2,%0;.LANDN1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_and25p(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("andcc %2,%3,%0;bz,a  .LANDI25Z0;or %4,%5,%1;andn %4,%5,%1;.LANDI25Z0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LANDI25N0;or %1,%2,%0;andn %1,%2,%0;.LANDI25N0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_and25s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("andcc %2,%3,%0;bz,a  .LANDI25Z1;or %4,%5,%1;andn %4,%5,%1;.LANDI25Z1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LANDI25N1;or %1,%2,%0;andn %1,%2,%0;.LANDI25N1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_orp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("orcc %2,%3,%0;bz,a  .LORZ0;or %4,%5,%1;andn %4,%5,%1;.LORZ0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LORN0;or %1,%2,%0;andn %1,%2,%0;.LORN0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_ors(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("ld %1,%0":"=g"(tmp2):"g"(src2));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("orcc %2,%3,%0;bz,a  .LORZ1;or %4,%5,%1;andn %4,%5,%1;.LORZ1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LORN1;or %1,%2,%0;andn %1,%2,%0;.LORN1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_or25p(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
      asm("orcc %2,%3,%0;bz,a  .LORI25Z0;or %4,%5,%1;andn %4,%5,%1;.LORI25Z0:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
      asm("bneg,a .LORI25N0;or %1,%2,%0;andn %1,%2,%0;.LORI25N0:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_or25s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
      asm("ld %1,%0":"=g"(tmp1):"g"(src1));
      asm("sethi %%hi(0x00400000),%0":"=g"(tmp3));
      asm("orcc %2,%3,%0;bz,a  .LORI25Z1;or %4,%5,%1;andn %4,%5,%1;.LORI25Z1:"
         :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
      asm("sethi %%hi(0x00020000),%0":"=g"(tmp3));
      asm("bneg,a .LORI25N1;or %1,%2,%0;andn %1,%2,%0;.LORI25N1:"
         :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_xorp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned	  z1, z2, z3, z4;
  unsigned        tmp;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    dest = src1 ^ src2;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
      pe[T_PE].sr[STAR0].star0.iccp_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v   = z1 | z2 | z3 | z4;
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_xors(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned	  z1, z2, z3, z4;
  unsigned        tmp;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    dest = src1 ^ src2;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
      pe[T_PE].sr[STAR0].star0.iccs_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v   = z1 | z2 | z3 | z4;
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_xor25p(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned	  z1, z2, z3, z4;
  unsigned        tmp;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
  }
  else if (cmd == 'x') {
    dest = src1 ^ src2;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
      pe[T_PE].sr[STAR0].star0.iccp_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v   = z1 | z2 | z3 | z4;
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_xor25s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned	  z1, z2, z3, z4;
  unsigned        tmp;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
  }
  else if (cmd == 'x') {
    dest = src1 ^ src2;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
      pe[T_PE].sr[STAR0].star0.iccs_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v   = z1 | z2 | z3 | z4;
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_sll(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
/*  dest = src1 << (src2 & 0x1f);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
*/
    star0 = pe[T_PE].sr[STAR0].ful;
    asm("ld %1,%0":"=g"(tmp1):"g"(src1));
    asm("ld %1,%0":"=g"(tmp2):"g"(src2));
    asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
    asm("sll %2,%3,%0;bz,a  .LSLLZ0;or %4,%5,%1;andn %4,%5,%1;.LSLLZ0:"
       :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
    asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
    asm("bneg,a .LSLLN0;or %1,%2,%0;andn %1,%2,%0;.LSLLN0:"
       :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_sll5(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
/*  dest = src1 << src2;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
*/
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = insn.i5_5_5_5.r2;
    asm("ld %1,%0":"=g"(tmp1):"g"(src1));
    asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
    asm("sll %2,%3,%0;bz,a  .LSLL5Z0;or %4,%5,%1;andn %4,%5,%1;.LSLL5Z0:"
       :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
    asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
    asm("bneg,a .LSLL5N0;or %1,%2,%0;andn %1,%2,%0;.LSLL5N0:"
       :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_sra(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static int src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
/*  dest = src1 >> (src2 & 0x1f);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
*/
    star0 = pe[T_PE].sr[STAR0].ful;
    asm("ld %1,%0":"=g"(tmp1):"g"(src1));
    asm("ld %1,%0":"=g"(tmp2):"g"(src2));
    asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
    asm("sra %2,%3,%0;bz,a  .LSRAZ0;or %4,%5,%1;andn %4,%5,%1;.LSRAZ0:"
       :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
    asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
    asm("bneg,a .LSRAN0;or %1,%2,%0;andn %1,%2,%0;.LSRAN0:"
       :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_sra5(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static int src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
/*  dest = src1 >> src2;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
*/
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = insn.i5_5_5_5.r2;
    asm("ld %1,%0":"=g"(tmp1):"g"(src1));
    asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
    asm("sra %2,%3,%0;bz,a  .LSRA5Z0;or %4,%5,%1;andn %4,%5,%1;.LSRA5Z0:"
       :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
    asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
    asm("bneg,a .LSRA5N0;or %1,%2,%0;andn %1,%2,%0;.LSRA5N0:"
       :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_srl(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
/*  dest = src1 >> (src2 & 0x1f);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
*/
    star0 = pe[T_PE].sr[STAR0].ful;
    asm("ld %1,%0":"=g"(tmp1):"g"(src1));
    asm("ld %1,%0":"=g"(tmp2):"g"(src2));
    asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
    asm("srl %2,%3,%0;bz,a  .LSRLZ0;or %4,%5,%1;andn %4,%5,%1;.LSRLZ0:"
       :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
    asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
    asm("bneg,a .LSRLN0;or %1,%2,%0;andn %1,%2,%0;.LSRLN0:"
       :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

o_srl5(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned        dest;
  unsigned        star0;
  unsigned        tmp1, tmp2, tmp3;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
/*  dest = src1 >> src2;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
*/
    star0 = pe[T_PE].sr[STAR0].ful;
    tmp2 = insn.i5_5_5_5.r2;
    asm("ld %1,%0":"=g"(tmp1):"g"(src1));
    asm("sethi %%hi(0x40000000),%0":"=g"(tmp3));
    asm("srl %2,%3,%0;bz,a  .LSRL5Z0;or %4,%5,%1;andn %4,%5,%1;.LSRL5Z0:"
       :"=g"(dest),"=g"(star0):"g"(tmp1),"g"(tmp2),"g"(star0),"g"(tmp3));
    asm("sethi %%hi(0x02000000),%0":"=g"(tmp3));
    asm("bneg,a .LSRL5N0;or %1,%2,%0;andn %1,%2,%0;.LSRL5N0:"
       :"=g"(star0):"g"(star0),"g"(tmp3));
    if (star0 & 0x40400000) star0 |= 0x08000000;
    else                    star0 &= 0xf7ffffff;
    pe[T_PE].sr[STAR0].ful = star0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
  }
  else {
    return(SCORE_FREE);
  }
}

/********************************
*	ld			*
* 'c'  check (EXCEPTION)        *
* 'r'  read                     *
* 'x'  EMPTY                    *
********************************/

o_ld(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (addr & 3) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 4, _R_, NULL, insn.i5_5_5_5.r3, 0x06, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 4, _R_, NULL, insn.i5_5_5_5.r3, 0x06))
      return;
    if (real_addr < memsize) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, *(unsigned *) &pe[T_PE].mem[real_addr]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}   

o_ld25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (addr & 3) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 4, _R_, NULL, insn.i5_5_25_5.r3, 0x06, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 4, _R_, NULL, insn.i5_5_25_5.r3, 0x06))
      return;
    if (real_addr < memsize) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, *(unsigned *) &pe[T_PE].mem[real_addr]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_ld_l(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (addr & 7) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 8, _R_, NULL, insn.i5_5_5_5.r3, 0x07, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 8, _R_, NULL, insn.i5_5_5_5.r3, 0x07))
      return;
    if (real_addr < memsize) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3  , _W_, *(unsigned *) &pe[T_PE].mem[real_addr]);
      sys_gr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, *(unsigned *) &pe[T_PE].mem[real_addr+4]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else {
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
  }
}   

o_ld_l25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (addr & 7) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 8, _R_, NULL, insn.i5_5_25_5.r3, 0x07, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 8, _R_, NULL, insn.i5_5_25_5.r3, 0x07))
      return;
    if (real_addr < memsize) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3  , _W_, *(unsigned *) &pe[T_PE].mem[real_addr]);
      sys_gr_access(t_pe, insn.i5_5_25_5.r3+1, _W_, *(unsigned *) &pe[T_PE].mem[real_addr+4]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else {
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
  }
}
   
o_ld_c(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 1, _R_, NULL, insn.i5_5_5_5.r3, 0x02))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned char*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, (int) ((char) d[0]));
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}   

o_ld_c25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 1, _R_, NULL, insn.i5_5_25_5.r3, 0x02))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned char*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, (int) ((char) d[0]));
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_ld_cu(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 1, _R_, NULL, insn.i5_5_5_5.r3, 0x03))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned char*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, d[0]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}   

o_ld_cu25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 1, _R_, NULL, insn.i5_5_25_5.r3, 0x03))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned char*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, d[0]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_ld_s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (addr & 1) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 2, _R_, NULL, insn.i5_5_5_5.r3, 0x04, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 2, _R_, NULL, insn.i5_5_5_5.r3, 0x04))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned short*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, (int) ((short) d[0]));
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}   

o_ld_s25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (addr & 1) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 2, _R_, NULL, insn.i5_5_25_5.r3, 0x04, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 2, _R_, NULL, insn.i5_5_25_5.r3, 0x04))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned short*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, (int) ((short) d[0]));
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_ld_su(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (addr & 1) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 2, _R_, NULL, insn.i5_5_5_5.r3, 0x05, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 2, _R_, NULL, insn.i5_5_5_5.r3, 0x05))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned short*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, d[0]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}

o_ld_su25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (addr & 1) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 2, _R_, NULL, insn.i5_5_25_5.r3, 0x05, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 2, _R_, NULL, insn.i5_5_25_5.r3, 0x05))
      return;
    if (real_addr < memsize) {
      d[0] = *(unsigned short*) &pe[T_PE].mem[real_addr];
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, d[0]);
    }
    else
      sys_mem_a_exception(t_pe, real_addr);
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_ld_d(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+src2,8,_R_,d,0x09)==RW_SUCCESS)
      sys_fr_access(t_pe, insn.i5_5_5_5.r3, _W_, d[0], d[1]);
    return;
    break;
  }
}   

o_ld_d25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7),8,_R_,d,0x09)==RW_SUCCESS)
      sys_fr_access(t_pe, insn.i5_5_25_5.r3, _W_, d[0], d[1]);
    return;
    break;
  }
}
   
o_ld_f(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+src2,4,_R_,d,0x08)==RW_SUCCESS) {
      d[1] = 0;
      sys_fr_access(t_pe, insn.i5_5_5_5.r3, _W_, d[0], d[1]);
    }
    return;
    break;
  }
}   

o_ld_f25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7),4,_R_,d,0x08)==RW_SUCCESS) {
      d[1] = 0;
      sys_fr_access(t_pe, insn.i5_5_25_5.r3, _W_, d[0], d[1]);
    }
    return;
    break;
  }
}
   
o_ld_pd(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+src2,16,_R_,d,0x0b)==RW_SUCCESS) {
      sys_fr_access(t_pe, insn.i5_5_5_5.r3  , _W_, d[0], d[1]);
      sys_fr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, d[2], d[3]);
    }
    return;
    break;
  }
}   

o_ld_pd25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7),16,_R_,d,0x0b)==RW_SUCCESS) {
      sys_fr_access(t_pe, insn.i5_5_25_5.r3  , _W_, d[0], d[1]);
      sys_fr_access(t_pe, insn.i5_5_25_5.r3+1, _W_, d[2], d[3]);
    }
    return;
    break;
  }
}

o_ld_pf(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+src2,8,_R_,d,0x0a)==RW_SUCCESS){
      d[2] = 0;
      sys_fr_access(t_pe, insn.i5_5_5_5.r3  , _W_, d[0], d[2]);
      sys_fr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, d[1], d[2]);
    }
    return;
    break;
  }
}   

o_ld_pf25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7),8,_R_,d,0x0a)==RW_SUCCESS) {
      d[2] = 0;
      sys_fr_access(t_pe, insn.i5_5_25_5.r3  , _W_, d[0], d[2]);
      sys_fr_access(t_pe, insn.i5_5_25_5.r3+1, _W_, d[1], d[2]);
    }
    return;
    break;
  }
}
   
/********************************
*	st			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  EMPTY                    *
********************************/

o_st(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  static unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _R_, d[0]);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (addr & 3) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 4, _W_, d, 0, 0x13, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 4, _W_, d, 0, 0x13))
      return;
    if (real_addr < memsize) {
      *(unsigned *) &pe[T_PE].mem[real_addr] = *d;
    }
    else {
      pe[T_PE].work_ird0.cir  = 1;
      pe[T_PE].work_ird1.crr1 = 1;
    }
    return;
  }
  else
    return(SCORE_FREE);
}

o_st25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  static unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _R_, d[0]);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (addr & 3) { /* not aligned exception */
      sys_mem_l_exception(t_pe, addr, 4, _W_, d, 0, 0x13, 1, 0);
      return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
      real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 4, _W_, d, 0, 0x13))
      return;
    if (real_addr < memsize) {
      *(unsigned *) &pe[T_PE].mem[real_addr] = *d;
    }
    else {
      pe[T_PE].work_ird0.cir  = 1;
      pe[T_PE].work_ird1.crr1 = 1;
    }
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_st_c(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  static unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _R_, d[0]);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (!pe[T_PE].sr[PEV].pev.va)
        real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 1, _W_, d, 0, 0x11))
      return;
    if (real_addr < memsize) {
      *(unsigned char*) &pe[T_PE].mem[real_addr] = *d;
    }
    else {
      pe[T_PE].work_ird0.cir  = 1;
      pe[T_PE].work_ird1.crr1 = 1;
    }
    return;
  }
  else
    return(SCORE_FREE);
}   

o_st_c25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  static unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _R_, d[0]);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (!pe[T_PE].sr[PEV].pev.va)
        real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 1, _W_, d, 0, 0x11))
      return;
    if (real_addr < memsize) {
      *(unsigned char*) &pe[T_PE].mem[real_addr] = *d;
    }
    else {
      pe[T_PE].work_ird0.cir  = 1;
      pe[T_PE].work_ird1.crr1 = 1;
    }
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_st_s(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  static unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _R_, d[0]);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+src2;
    if (addr & 1) { /* not aligned exception */
        sys_mem_l_exception(t_pe, addr, 2, _W_, d, 0, 0x12, 1, 0);
        return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
        real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 2, _W_, d, 0, 0x12))
      return;
    if (real_addr < memsize) {
      *(unsigned short*) &pe[T_PE].mem[real_addr] = *d;
    }
    else {
      pe[T_PE].work_ird0.cir  = 1;
      pe[T_PE].work_ird1.crr1 = 1;
    }
    return;
  }
  else
    return(SCORE_FREE);
}   

o_st_s25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src3;
  static unsigned d[4];
  unsigned addr, real_addr;

  if (cmd == 'r') {
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _R_, d[0]);
    return;
  }
  else if (cmd == 'x') {
    addr = src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7);
    if (addr & 1) { /* not aligned exception */
        sys_mem_l_exception(t_pe, addr, 2, _W_, d, 0, 0x12, 1, 0);
        return;
    }
    else if (!pe[T_PE].sr[PEV].pev.va)
        real_addr = addr;
    else if (sys_mem_v2r(t_pe, addr, &real_addr, 2, _W_, d, 0, 0x12))
      return;
    if (real_addr < memsize) {
      *(unsigned short*) &pe[T_PE].mem[real_addr] = *d;
    }
    else {
      pe[T_PE].work_ird0.cir  = 1;
      pe[T_PE].work_ird1.crr1 = 1;
    }
    return;
  }
  else
    return(SCORE_FREE);
}
   
o_st_d(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  static unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _R_, d[0], d[1]);
    return;
    break;
  case 'x':
    sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+src2,8,_W_,d,0x1d);
    return;
    break;
  }
}   

o_st_d25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  static unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_fr_access(t_pe, insn.i5_5_25_5.r3, _R_, d[0], d[1]);
    return;
    break;
  case 'x':
    sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7),8,_W_,d,0x1d);
    return;
    break;
  }
}
   
o_st_f(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  static unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _R_, d[0], d[1]);
    return;
    break;
  case 'x':
    sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+src2,4,_W_,d,0x1c);
    return;
    break;
  }
}   

o_st_f25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  static unsigned d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_fr_access(t_pe, insn.i5_5_25_5.r3, _R_, d[0], d[1]);
    return;
    break;
  case 'x':
    sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)(((insn.i5_5_25_5.im_u<<7)|insn.i5_5_25_5.im_l)<<7)>>7),4,_W_,d,0x1c);
    return;
    break;
  }
}
   
/********************************
*	cs			*
* 'c'  check                    *
* 'r'  read/execute             *
* 'x'  EMPTY                    *
********************************/

o_cs(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  unsigned        src1, src2, src3, d[4];

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.cs.r1, _R_, src1);
    sys_gr_access(t_pe, insn.cs.r3, _R_, src3);
    sys_gr_access(t_pe,(insn.cs.r2_u<<2)+insn.cs.r2_l, _R_, src2);
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src2+((int)(insn.cs.im<<7)>>7),4,_R_,d,0,0x31)!=RW_SUCCESS) {
      pe[T_PE].nullify = 1;
      return;
    }
    sys_gr_access(t_pe, insn.cs.r4, _W_, d[0]);
    if (src1 == d) {
      pe[T_PE].sr[STAR0].star0.iccp_z = 1;
      if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src2+((int)(insn.cs.im<<7)>>7),4,_A_,&src3,0,0x31)!=RW_SUCCESS) {
        return;
      }
    }
    else {
      pe[T_PE].sr[STAR0].star0.iccp_z = 0;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}   

/********************************
*	coprocessor		*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  EMPTY                    *
********************************/

o_COP(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  pe[T_PE].work_ird0.cux = 1;
  return(SCORE_EXCEPTION);
}

/********************************
*	floating		*
* 'c'  check (EXCEPTION)        *
* 'r'  lock                     *
* 'x'  EMPTY                    *
********************************/

o_fnop(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fadd(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fadd_d(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fadd_x(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    if ((insn.i5_5_5_5.r1 & 1) || (insn.i5_5_5_5.r2 & 1)
     || (insn.i5_5_5_5.r3 & 1)) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

o_fsub(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fsub_d(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fsub_x(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    if ((insn.i5_5_5_5.r1 & 1) || (insn.i5_5_5_5.r2 & 1)
     || (insn.i5_5_5_5.r3 & 1)) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

o_fcmp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}

o_fcmp_d(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}   

o_fcmp_x(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    if ((insn.i5_5_5_5.r1 & 1) || (insn.i5_5_5_5.r2 & 1)) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}   

o_fmul(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fmul_d(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fdiv(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fdiv_d(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_df(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_di(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnz_di(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_dx(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

o_fcnv_fd(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_fi(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnz_fi(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_id(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_if(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_xd(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    if (insn.i5_5_5_5.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

/********************************
*	mov			*
* 'c'  check (EXCEPTION)        *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_mov_if(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    src2 = 0;
    return;
    break;
  case 'x':
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _W_, src1, src2);
    return;
    break;
  }
}

o_mov_fi(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_fr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1, src2);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, src1);
    return;
    break;
  }
}

o_mov_ld(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;

  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r1+1, _R_, src2);
    return;
    break;
  case 'x':
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _W_, src1, src2);
    return;
    break;
  }
}

o_mov_dl(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;

  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_fr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1, src2);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.i5_5_5_5.r3  , _W_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, src2);
    return;
    break;
  }
}

o_movgs(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;

  switch (cmd) {
  case 'c':
    if (insn.sys_mov.r2 < 512) {
      if (pe[T_PE].sr[PEV].pev.u) {
        pe[T_PE].work_ird0.pox = 1;
        return(SCORE_EXCEPTION);
      }
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.sys_mov.r1, _R_, src1); 
    return;
    break;
  case 'x':
    sys_sr_access(t_pe, insn.sys_mov.r2, _W_, &src1);
    return;
    break;
  }
}

o_movsg(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;

  switch (cmd) {
  case 'c':
    if (insn.sys_mov.r2 < 512) {
      if (pe[T_PE].sr[PEV].pev.u) {
        pe[T_PE].work_ird0.pox = 1;
        return(SCORE_EXCEPTION);
      }
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_sr_access(t_pe, insn.sys_mov.r2, _R_, &src1);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.sys_mov.r1, _W_, src1);
    return;
    break;
  }
}

o_movgt(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (insn.sys_mov.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.sys_mov.r1  , _R_, src1); 
    sys_gr_access(t_pe, insn.sys_mov.r1+1, _R_, src2); 
    return;
    break;
  case 'x':
    sys_tod_access(t_pe, _W_, src1, src2);
    return;
    break;
  }
}

o_movtg(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;

  switch (cmd) {
  case 'c':
    if (insn.sys_mov.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_tod_access(t_pe, _R_, src1, src2);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.sys_mov.r1  , _W_, src1);
    sys_gr_access(t_pe, insn.sys_mov.r1+1, _W_, src2);
    return;
    break;
  }
}

/********************************
*	mult			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_mult(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    dest = src1 * src2;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
    break;
  }
}

o_mult_l(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d, n;

  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    if ((src1 & 0x80000000) ^ (src2 & 0x80000000))
      n = 1;
    else
      n = 0;
    if (src1 & 0x80000000) src1 = -src1;
    if (src2 & 0x80000000) src2 = -src2;
    a = src1 >> 16; b = src1 & 0xffff;
    c = src2 >> 16; d = src2 & 0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    if (n) {
      dest1 = ~dest1; dest2 = ~dest2;
      if (((1+(dest2&0xffff))&0x10000) && ((1+(dest2>>16))&0x10000)) dest1++;
      dest2++;
    }
    sys_gr_access(t_pe, insn.i5_5_5_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

o_mult_lu(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d;

  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    a = src1 >> 16; b = src1 &  0xffff;
    c = src2 >> 16; d = src2 &  0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

o_mult25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest;

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'x':
    dest = src1 * src2;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
    break;
  }
}

o_mult_l25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d, n;

  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'x':
    if ((src1 & 0x80000000) ^ (src2 & 0x80000000))
      n = 1;
    else
      n = 0;
    if (src1 & 0x80000000) src1 = -src1;
    if (src2 & 0x80000000) src2 = -src2;
    a = src1 >> 16; b = src1 &  0xffff;
    c = src2 >> 16; d = src2 &  0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    if (n) {
      dest1 = ~dest1; dest2 = ~dest2;
      if (((1+(dest2&0xffff))&0x10000) && ((1+(dest2>>16))&0x10000)) dest1++;
      dest2++;
    }
    sys_gr_access(t_pe, insn.i5_5_25_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

o_mult_lu25(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d;

  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'x':
    a = src1 >> 16; b = src1 &  0xffff;
    c = src2 >> 16; d = src2 &  0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

/********************************
*	system			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_aki(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}

o_flcha(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  unsigned	  ent;
  static unsigned src1;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 6) & (CACHE_NUM-1);
    pe[T_PE].text_cache[ent].v = 0;
    pe[T_PE].data_cache[ent].v = 0;
    return;
    break;
  }
}   

o_flche(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  unsigned	  ent;
  static unsigned src1;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 6) & (CACHE_NUM-1);
    pe[T_PE].text_cache[ent].v = 0;
    pe[T_PE].data_cache[ent].v = 0;
    return;
    break;
  }
}   

o_ldsr(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned d[4];

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_, src1);
    return;
    break;
  case 'x':
    if (sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)((insn.sys_25.im)<<7)>>7),4,_R_,d,0x22)==RW_SUCCESS)
      sys_sr_access(t_pe, insn.sys_25.r3, _W_, &d[0]);
    return;
    break;
  }
}   

o_stsr(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  static unsigned d[4];

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_, src1);
    sys_sr_access(t_pe, insn.sys_25.r3, _R_, &d[0]);
    return;
    break;
  case 'x':
    sys_mem_access(t_pe,pe[T_PE].sr[PEV].pev.va?'v':'r',src1+((int)((insn.sys_25.im)<<7)>>7),4,_W_,d,0x23);
    return;
    break;
  }
}
	
o_ld_mcr(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  return(SCORE_FREE);
}

o_st_mcr(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  return(SCORE_FREE);
}

o_wbst(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  return(SCORE_FREE);
}

o_ptlbe(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1;
  unsigned	  ent;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 15) & (TLB_NUM-1);
    pe[T_PE].text_tlb[ent].vmc &= ~4;
    pe[T_PE].data_tlb[ent].vmc &= ~4;
    return;
    break;
  }
}   

o_ptlbp(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned	  ent;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    src2 = pe[T_PE].sr[PID].pid.pid;
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 15) & (TLB_NUM-1);
    if (!(pe[T_PE].text_tlb[ent].vmc & 1) && src2 == pe[T_PE].text_tlb[ent].pid)
      pe[T_PE].text_tlb[ent].vmc &= ~4;
    if (!(pe[T_PE].data_tlb[ent].vmc & 1) && src2 == pe[T_PE].data_tlb[ent].pid)
      pe[T_PE].data_tlb[ent].vmc &= ~4;
    return;
    break;
  }
}   

o_ptlba(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  static unsigned src1, src2;
  unsigned	  ent;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    src2 = pe[T_PE].sr[PID].pid.pid;
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 15) & (TLB_NUM-1);
    if ((pe[T_PE].text_tlb[ent].vmc & 1) || src2 == pe[T_PE].text_tlb[ent].pid)
      pe[T_PE].text_tlb[ent].vmc &= ~4;
    if ((pe[T_PE].data_tlb[ent].vmc & 1) || src2 == pe[T_PE].data_tlb[ent].pid)
      pe[T_PE].data_tlb[ent].vmc &= ~4;
    return;
    break;
  }
}   

o_rti(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  case 'r':
    return;
    break;
  case 'x':
    pe[T_PE].sr[PC].ful  = pe[T_PE].sr[OPC].ful;
    pe[T_PE].sr[PEV].ful = pe[T_PE].sr[OPEV].ful;
    pe[T_PE].firmstate = 0;
    return;
    break;
  }
}   

o_svc(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    return;
    break;
  case 'x':
    pe[T_PE].svc_interrupt = insn.sys_svc.im | 0x80000000;
    return;
    break;
  }
}   

o_fwc(t_pe, insn, cmd)
  unsigned t_pe, cmd;
  union insn_form insn;
{
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    return;
    break;
  case 'x':
    switch (insn.ful.u >> 8) {
    case 0xbf83ff:
      pe[T_PE].ip_status = STATUS_HALT;
      message("PE#%u reached to fwc (no sync). COMPLETION CODE=0x%08.8X\n", t_pe, insn.ful.l);
      break;
    case 0xbf83d3:
      pe[T_PE].ip_status = STATUS_HALT;
      lmessage("PE#%u reached to fwc (no sync). MALFUNCTION CODE=0x%08.8X\n", t_pe, insn.ful.l);
      break;
    default:
      pe[T_PE].fwc_interrupt = insn.sys_svc.im | 0x80000000;
      break;
    }
    return;
    break;
  }
}   
