static char SccsId[] = "@(#)ip.c	1.19    8/18/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* ip.c    89/10/1 */

#include "tim.h"
#include "facility.h"

sim_ip(t_pe)
    unsigned t_pe;
{
    unsigned i;
    struct tachyon_insn *ti;
    unsigned type, index0, index1, index2;
    unsigned addr, real_addr;
    unsigned fqe_ent, map_ent;
    unsigned char *s_mapP;

    if (!(pe[T_PE].tod.l += 32))
        pe[T_PE].tod.u++;

    if (EXCEPTION_EXIST) {
      handle_interruption(t_pe);
      return;
    }

    if (!(s_mapP = pe[T_PE].s_map[map_ent = pe[T_PE].sr[PC].ful>>3])) {
        addr = pe[T_PE].sr[PC].ful;
        if (addr & 7) { /* not aligned exception */
          sys_mem_l_exception(t_pe, addr, 8, _X_, NULL, 0, 0, 0, 0);
          return;
        }
        else if (!pe[T_PE].sr[PEV].pev.va)
          real_addr = addr;
        else if (sys_mem_v2r(t_pe, addr, &real_addr, 8, _X_, NULL, 0, 0))
          return;
        if (real_addr < memsize) {
          pe[T_PE].insn0.ful.u = *(unsigned *) &pe[T_PE].mem[real_addr];
          pe[T_PE].insn0.ful.l = *(unsigned *) &pe[T_PE].mem[real_addr+4];
        }
        else {
          sys_mem_a_exception(t_pe, real_addr);
          return;
        }

        if ((s_mapP = pe[T_PE].s_bot) >= pe[T_PE].s_lim) {
          message("Warning: s_code is full. Flushing s_map.\n");
          memset(pe[T_PE].s_map, 0, memsize/8);
          s_mapP = pe[T_PE].s_bot = pe[T_PE].s_code;
        }

        type     = pe[T_PE].insn0.ful.u >> 28;
        ti       = &(insn_type[type]);
        if (ti->op0) {
	  index0 = (pe[T_PE].insn0.ful.u>>ti->sft0)&ti->mask0;
          pe[T_PE].o_type0 = (ti->op0)[index0].type;
	  if ((pe[T_PE].o_func0 = (ti->op0)[index0].func) == NULL)
            pe[T_PE].work_ird0.opx = 1;
          else
            (pe[T_PE].o_func0)(t_pe,&pe[T_PE].insn0,'c');
        }
        else {
          pe[T_PE].o_type0 = O_NL;
          pe[T_PE].o_func0 = NULL;
        }
        if (ti->op1) {
          pe[T_PE].insn1.ful.u = type<<28|pe[T_PE].insn0.ful.u<<20&0x0fffffff|pe[T_PE].insn0.ful.l>>12;
          pe[T_PE].insn1.ful.l = pe[T_PE].insn0.ful.l<<20;
          index1 = (pe[T_PE].insn1.ful.u>>ti->sft1)&ti->mask1;
          pe[T_PE].o_type1 = (ti->op1)[index1].type;
	  if ((pe[T_PE].o_func1 = (ti->op1)[index1].func) == NULL)
            pe[T_PE].work_ird0.opx = 1;
          else
            (pe[T_PE].o_func1)(t_pe,&pe[T_PE].insn1,'c');
        }
        else {
	  pe[T_PE].o_type1 = O_NL;
	  pe[T_PE].o_func1 = NULL;
        }
        if (ti->op2) {
          pe[T_PE].insn2.ful.u = type<<28|pe[T_PE].insn0.ful.l<<8&0x0fffff00;
          index2 = (pe[T_PE].insn2.ful.u>>ti->sft2)&ti->mask2;
          pe[T_PE].o_type2 = (ti->op2)[index2].type;
	  if ((pe[T_PE].o_func2 = (ti->op2)[index2].func) == NULL)
            pe[T_PE].work_ird0.opx = 1;
          else
            (pe[T_PE].o_func2)(t_pe,&pe[T_PE].insn2,'c');
        }
        else {
	  pe[T_PE].o_type2 = O_NL;
	  pe[T_PE].o_func2 = NULL;
        }

        if (EXCEPTION_EXIST) {
          if (IP_EXCEPTION_EXIST) {
            if (scan_on & SCAN_LIST) disasm(t_pe, pe[T_PE].sr[PEV].pev.va?'v':'r', pe[T_PE].sr[PC].ful,1,1);
            pe[T_PE].sr[PC].ful = (pe[T_PE].lpc = pe[T_PE].sr[PC].ful) + 8;
          }
          return;
        }

        pe[T_PE].s_map[map_ent] = s_mapP;
        *(unsigned*)(s_mapP   ) = pe[T_PE].insn0.ful.u;
        *(unsigned*)(s_mapP+ 4) = pe[T_PE].insn0.ful.l;
        *(unsigned*)(s_mapP+ 8) = pe[T_PE].insn1.ful.u;
        *(unsigned*)(s_mapP+12) = pe[T_PE].insn1.ful.l;
        *(unsigned*)(s_mapP+16) = pe[T_PE].insn2.ful.u;
        *(unsigned*)(s_mapP+20) = pe[T_PE].o_type0;
        *(unsigned*)(s_mapP+24) = pe[T_PE].o_type1;
        *(unsigned*)(s_mapP+28) = pe[T_PE].o_type2;
        *(unsigned*)(s_mapP+32) = pe[T_PE].o_func0;
        *(unsigned*)(s_mapP+36) = pe[T_PE].o_func1;
        *(unsigned*)(s_mapP+40) = pe[T_PE].o_func2;
        if (pe[T_PE].o_type0==O_FH||pe[T_PE].o_type0==O_FL
          ||pe[T_PE].o_type1==O_FH||pe[T_PE].o_type1==O_FL
          ||pe[T_PE].o_type2==O_FH||pe[T_PE].o_type2==O_FL)
          *(unsigned*)(s_mapP+44) = pe[T_PE].fp_op_exist = 1;
        else
          *(unsigned*)(s_mapP+44) = pe[T_PE].fp_op_exist = 0;
        pe[T_PE].s_bot += 48;
    }
    else {
        pe[T_PE].insn0.ful.u = *(unsigned*)(s_mapP   );
        pe[T_PE].insn1.ful.u = *(unsigned*)(s_mapP+ 8);
        pe[T_PE].insn2.ful.u = *(unsigned*)(s_mapP+16);
        pe[T_PE].o_type0     = *(unsigned*)(s_mapP+20);
        pe[T_PE].o_type1     = *(unsigned*)(s_mapP+24);
        pe[T_PE].o_type2     = *(unsigned*)(s_mapP+28);
        pe[T_PE].fp_op_exist = *(unsigned*)(s_mapP+44);
    }

    if (pe[T_PE].o_type2==O_IP) {
        pe[T_PE].o_func2     = *(unsigned*)(s_mapP+40);
        (pe[T_PE].o_func2)(t_pe,&pe[T_PE].insn2,'r');
    }
    if (pe[T_PE].o_type1==O_IP) {
        pe[T_PE].insn1.ful.l = *(unsigned*)(s_mapP+12);
        pe[T_PE].o_func1     = *(unsigned*)(s_mapP+36);
        (pe[T_PE].o_func1)(t_pe,&pe[T_PE].insn1,'r');
    }
    if (pe[T_PE].o_type0==O_IP) {
        pe[T_PE].insn0.ful.l = *(unsigned*)(s_mapP+ 4);
        pe[T_PE].o_func0     = *(unsigned*)(s_mapP+32);
        (pe[T_PE].o_func0)(t_pe,&pe[T_PE].insn0,'r');
    }

    if (scan_on & SCAN_LIST) disasm(t_pe, pe[T_PE].sr[PEV].pev.va?'v':'r', pe[T_PE].sr[PC].ful,1,1);
    pe[T_PE].sr[PC].ful = (pe[T_PE].lpc = pe[T_PE].sr[PC].ful) + 8;

    if (pe[T_PE].o_type2==O_IP) (pe[T_PE].o_func2)(t_pe,&pe[T_PE].insn2,'x');
    if (pe[T_PE].o_type1==O_IP) (pe[T_PE].o_func1)(t_pe,&pe[T_PE].insn1,'x');
    if (pe[T_PE].o_type0==O_IP) (pe[T_PE].o_func0)(t_pe,&pe[T_PE].insn0,'x');

    if (pe[T_PE].fp_op_exist) {
	  for (fqe_ent = 0; fqe_ent < FQ_NUM; fqe_ent++) {
	    if (!pe[T_PE].sr[FQE0H+fqe_ent*2].fqeh.av)
	      break;
	  }
	  *(unsigned*)&pe[T_PE].sr[FQE0H+fqe_ent*2].fqeh = 0x80000000;
	  *(unsigned*)&pe[T_PE].sr[FQE0L+fqe_ent*2].fqel = 0x00000000;
	  switch (pe[T_PE].o_type0) {
	  case O_FH:
	    *(unsigned*)&pe[T_PE].sr[FQE0H+fqe_ent*2].fqeh |= 0x40000000 | (pe[T_PE].insn0.ful.u >> 8 & 0xfffff);
	    break;
	  case O_FL:
	    *(unsigned*)&pe[T_PE].sr[FQE0L+fqe_ent*2].fqel |= 0x40000000 | (pe[T_PE].insn0.ful.u >> 8 & 0xfffff);
	    break;
	  }
	  switch (pe[T_PE].o_type1) {
	  case O_FH:
	    *(unsigned*)&pe[T_PE].sr[FQE0H+fqe_ent*2].fqeh |= 0x40000000 | (pe[T_PE].insn1.ful.u >> 8 & 0xfffff);
	    break;
	  case O_FL:
	    *(unsigned*)&pe[T_PE].sr[FQE0L+fqe_ent*2].fqel |= 0x40000000 | (pe[T_PE].insn1.ful.u >> 8 & 0xfffff);
	    break;
	  }
	  switch (pe[T_PE].o_type2) {
	  case O_FH:
	    *(unsigned*)&pe[T_PE].sr[FQE0H+fqe_ent*2].fqeh |= 0x40000000 | (pe[T_PE].insn2.ful.u >> 8 & 0xfffff);
	    break;
	  case O_FL:
	    *(unsigned*)&pe[T_PE].sr[FQE0L+fqe_ent*2].fqel |= 0x40000000 | (pe[T_PE].insn2.ful.u >> 8 & 0xfffff);
	    break;
	  }
    }
}

#include "ip-oper.c"
#include "disasm.c"

handle_interruption(t_pe)
        unsigned t_pe;
{
        unsigned i, t_fsba;

        do {
	  sim_fp(t_pe, 1);
          pe[T_PE].sr[STAR1].star1.asa = pe[T_PE].sr[STAR1].star1.asam
                                       | pe[T_PE].sr[STAR1].star1.asaf
                                       | pe[T_PE].sr[STAR1].star1.cbs;
          if (scan_on & SCAN_STATUS) {
            scan_mfc(t_pe);
            message("         WAIT(SYNC)\n");
          }
        } while (pe[T_PE].sr[STAR1].star1.asa);
  
        pe[T_PE].fq_top = 0; /* reset fq_top */
        for (i = 0; i < FQ_NUM; i++ ){
          if(pe[T_PE].sr[FQE0H + i*2].fqeh.av ){
            pe[T_PE].work_ird0.fqr = 1;
            break;
          }
        }

        pe[T_PE].if_multiple_cycle = 0;
        pe[T_PE].ip_multiple_cycle = 0;
  
        if (pe[T_PE].timeout_req) {
          /* timeout request */
          pe[T_PE].ip_status = STATUS_HALT;
          lmessage("PE#%u halts. (TIMEOUT) PC=0x%08.8X\n", t_pe, pe[T_PE].sr[PC].ful);
        }
        else if (EXCEPTION_EXIST) {
          /* program interruption */
	  if (pe[T_PE].svc_interrupt) {
            pe[T_PE].sr[PC].ful -= 8;
	    pe[T_PE].svc_interrupt = 0;
	  }
	  else if (pe[T_PE].fwc_interrupt) {
            pe[T_PE].sr[PC].ful -= 8;
	    pe[T_PE].fwc_interrupt = 0;
	  }
          pe[T_PE].sr[OPEV].ful       = pe[T_PE].sr[PEV].ful;
          pe[T_PE].sr[OPC].ful        = pe[T_PE].sr[PC].ful;
          pe[T_PE].sr[LPC].ful        = pe[T_PE].lpc;
	  pe[T_PE].sr[PEV].pev.arm    = 0;
	  pe[T_PE].sr[PEV].pev.u      = 0;
	  pe[T_PE].sr[PEV].pev.spu    = 0;
          pe[T_PE].sr[PEV].pev.fstop |= pe[T_PE].work_ird0.fqr;
	  if (pe[T_PE].work_ird0.opx + pe[T_PE].work_ird0.pox + pe[T_PE].work_ird0.spx + pe[T_PE].work_ird0.ivx
	    + pe[T_PE].work_ird0.cux + pe[T_PE].work_ird0.cir + pe[T_PE].work_ird0.fax + pe[T_PE].work_ird0.fir
	    + pe[T_PE].work_ird0.nlax+ pe[T_PE].work_ird0.pax > 1)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x100;
	  else if (pe[T_PE].work_ird0.opx)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x110;
	  else if (pe[T_PE].work_ird0.pox)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x120;
	  else if (pe[T_PE].work_ird0.spx)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x130;
	  else if (pe[T_PE].work_ird0.ivx)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x140;
	  else if (pe[T_PE].work_ird0.cux)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x150;
	  else if (pe[T_PE].work_ird0.cir) {
	    if (pe[T_PE].work_ird1.crr0  + pe[T_PE].work_ird1.crr1
              + pe[T_PE].work_ird1.crr2  + pe[T_PE].work_ird1.crr3
              + pe[T_PE].work_ird1.crr4  + pe[T_PE].work_ird1.crr5
	      + pe[T_PE].work_ird1.crr6  + pe[T_PE].work_ird1.crr7
              + pe[T_PE].work_ird1.crr8  + pe[T_PE].work_ird1.crr9
              + pe[T_PE].work_ird1.crr10 + pe[T_PE].work_ird1.crr11
	      + pe[T_PE].work_ird1.crr12 + pe[T_PE].work_ird1.crr13
              + pe[T_PE].work_ird1.crr14 + pe[T_PE].work_ird1.crr15 > 1)
              pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x100;
	    else {
	      for (i = 0; i < 16; i++) {
	        if (*(unsigned*)&pe[T_PE].work_ird1 << i & 0x8000) {
		  pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x300 + 0x10*i;
		  break;
	        }
	      }
	    }
	  }
	  else if (pe[T_PE].work_ird0.fax)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x160;
	  else if (pe[T_PE].work_ird0.fir)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x170;
	  else if (pe[T_PE].work_ird0.nlax)
            pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x200 + 0x10*pe[T_PE].sr[CLAXC0].laxc.lirc;
	  else if (pe[T_PE].work_ird0.pax) {
            if ((pe[T_PE].work_ird1.paxk0 > 0) + (pe[T_PE].work_ird1.paxk1 > 0)
              + (pe[T_PE].work_ird1.paxk2 > 0) + (pe[T_PE].work_ird1.paxk3 > 0)
              + (pe[T_PE].work_ird1.paxk4 > 0) + (pe[T_PE].work_ird1.paxk5 > 0)
              + (pe[T_PE].work_ird1.paxk6 > 0) + (pe[T_PE].work_ird1.paxk7 > 0) > 1)
              pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x100;
            else
              pe[T_PE].sr[PC].ful = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x280;
          }
          pe[T_PE].sr[IRD0].ful = *(unsigned*)&pe[T_PE].work_ird0;
          pe[T_PE].sr[IRD1].ful = *(unsigned*)&pe[T_PE].work_ird1;
          *(unsigned*)&pe[T_PE].work_ird0 = *(unsigned*)&pe[T_PE].work_ird1 = 0;
          if (scan_on & SCAN_INTR) {
            scan_mfc(t_pe);
            message("         INTR(PRG) VEC=0x%04.4X IRD0=0x%08.8X IRD1=0x%08.8X PEV=0x%08.8X PID=0x%04.4X TOD=0x%08.8X_%08.8X\n",
	      pe[T_PE].sr[PC].ful - (pe[T_PE].sr[IREB].ireb.ireb << 12),
              pe[T_PE].sr[IRD0].ful, pe[T_PE].sr[IRD1].ful, pe[T_PE].sr[PEV].ful, pe[T_PE].sr[PID].pid.pid,
	      pe[T_PE].tod.u, pe[T_PE].tod.l);
          }
	  if (!pe[T_PE].sr[OPEV].pev.arm) {
            pe[T_PE].ip_status = STATUS_HALT;
	    lmessage("PE#%u halts. (OPEV.ARM=0) OPC=0x%08.8X PC=0x%08.8X\n", t_pe, pe[T_PE].sr[OPC].ful, pe[T_PE].sr[PC].ful);
	  }
        }
        else if (pe[T_PE].svc_interrupt) {
          /* supervisor call interruption */
          pe[T_PE].sr[OPEV].ful     = pe[T_PE].sr[PEV].ful;
          pe[T_PE].sr[OPC].ful      = pe[T_PE].sr[PC].ful;
          pe[T_PE].sr[LPC].ful      = pe[T_PE].lpc;
          pe[T_PE].sr[PEV].pev.arm  = 0;
	  pe[T_PE].sr[PEV].pev.u    = 0;
	  pe[T_PE].sr[PEV].pev.spu  = 0;
	  pe[T_PE].sr[PC].ful       = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x800
			       + 0x10*(pe[T_PE].svc_interrupt & 0xff);
	  pe[T_PE].svc_interrupt = 0;
          if (scan_on & SCAN_INTR) {
            scan_mfc(t_pe);
            message("         INTR(SVC) VEC=0x%04.4X IRD0=0x%08.8X IRD1=0x%08.8X PEV=0x%08.8X PID=0x%04.4X TOD=0x%08.8X_%08.8X\n",
	      pe[T_PE].sr[PC].ful - (pe[T_PE].sr[IREB].ireb.ireb << 12),
              pe[T_PE].sr[IRD0].ful, pe[T_PE].sr[IRD1].ful, pe[T_PE].sr[PEV].ful, pe[T_PE].sr[PID].pid.pid,
	      pe[T_PE].tod.u, pe[T_PE].tod.l);
          }
	  if (!pe[T_PE].sr[OPEV].pev.arm) {
            pe[T_PE].ip_status = STATUS_HALT;
	    lmessage("PE#%u halts. (OPEV.ARM=0) OPC=0x%08.8X PC=0x%08.8X\n", t_pe, pe[T_PE].sr[OPC].ful, pe[T_PE].sr[PC].ful);
	  }
        }
        else if (pe[T_PE].fwc_interrupt) {
          /* firmware call interruption */
          pe[T_PE].sr[OPEV].ful     = pe[T_PE].sr[PEV].ful;
          pe[T_PE].sr[OPC].ful      = pe[T_PE].sr[PC].ful;
          pe[T_PE].sr[LPC].ful      = pe[T_PE].lpc;
          pe[T_PE].sr[PEV].pev.arm  = 0;
	  pe[T_PE].sr[PEV].pev.u    = 0;
	  pe[T_PE].sr[PEV].pev.va   = 0;
	  pe[T_PE].sr[PEV].pev.spu  = 0;
	  pe[T_PE].sr[PC].ful       = (pe[T_PE].sr[IREB].ireb.ireb << 12) + 0x800
			       + 0x10*(pe[T_PE].fwc_interrupt & 0xff);
	  pe[T_PE].fwc_interrupt = 0;
	  pe[T_PE].firmstate = 1;
          if (scan_on & SCAN_INTR) {
            scan_mfc(t_pe);
            message("         INTR(FWC) VEC=0x%04.4X IRD0=0x%08.8X IRD1=0x%08.8X PEV=0x%08.8X PID=0x%04.4X TOD=0x%08.8X_%08.8X\n",
	      pe[T_PE].sr[PC].ful - (pe[T_PE].sr[IREB].ireb.ireb << 12),
              pe[T_PE].sr[IRD0].ful, pe[T_PE].sr[IRD1].ful, pe[T_PE].sr[PEV].ful, pe[T_PE].sr[PID].pid.pid,
	      pe[T_PE].tod.u, pe[T_PE].tod.l);
          }
	  if (!pe[T_PE].sr[OPEV].pev.arm) {
            pe[T_PE].ip_status = STATUS_HALT;
	    lmessage("PE#%u halts. (OPEV.ARM=0) OPC=0x%08.8X PC=0x%08.8X\n", t_pe, pe[T_PE].sr[OPC].ful, pe[T_PE].sr[PC].ful);
	  }
        }
}

