static char SccsId[] = "@(#)pe.c	1.3    8/7/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* pe.c    89/10/1 */

#include "tim.h"
#include "facility.h"

serialize(c_pe, scantype)
    unsigned c_pe, scantype;
{
    unsigned t_pe, t_fsba, async_any_busy;

/* consume FP/AP/VP operations */
    for (;;) {
      async_any_busy = 0;
      for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
        if (pe[T_PE].ip_status != STATUS_HALT) {
          if (pe[T_PE].fp_op_exist) 
            do {
              sim_fp(t_pe, 0);
            } while (pe[T_PE].sr[STAR1].star1.asaf);
#ifdef VCP
          sim_vp(t_pe);
          if (pe[T_PE].sr[STAR1].star1.cba)
            async_any_busy++;
#endif
#ifdef MOVER
          sim_mv(t_pe);
#endif
#ifdef BARRIER
          sim_bp(t_pe);
#endif
#ifdef SSUMOVER
          sim_ssumv(t_pe);
#endif
#ifdef GSIGP
          sim_gsigp(t_pe);
#endif
#ifdef FSBA
          for (t_fsba=0; t_fsba<FSBA_NUM; t_fsba++)
            sim_fsba(t_pe, t_fsba);
#endif
#ifdef DAPF
          sim_dapf(t_pe);
#endif
          pe[T_PE].sr[STAR1].star1.asa = pe[T_PE].sr[STAR1].star1.asaf;
#ifdef VCP
          pe[T_PE].sr[STAR1].star1.es1 = pe[T_PE].sr[STAR1].star1.asam
                                       | pe[T_PE].sr[STAR1].star1.es0;
#endif
        }
      }   
      tim_clock++;
      if (!async_any_busy)
        break;
    }   

/* consume waiting IP operations */
    for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
      if (pe[T_PE].ip_status == STATUS_FREE && EXCEPTION_EXIST) {
	if ((scantype & SCAN_ALL) || t_pe == c_pe) scan_on = scantype;
	else                                       scan_on = 0;
        sim_ip(t_pe);
      }
      else {
        while (pe[T_PE].if_multiple_cycle > 0
           || (pe[T_PE].ip_status != STATUS_FREE
            && pe[T_PE].ip_status != STATUS_HALT)) {
	  if ((scantype & SCAN_ALL) || t_pe == c_pe) scan_on = scantype;
	  else                                       scan_on = 0;
          sim_ip(t_pe);
	}
      }
    }

/* consume side effected FP/AP/VP operations */
    for (;;) {
      async_any_busy = 0;
      for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
        if (pe[T_PE].ip_status != STATUS_HALT) {
          if (pe[T_PE].fp_op_exist)
            do {
              sim_fp(t_pe, 0);
            } while (pe[T_PE].sr[STAR1].star1.asaf);
#ifdef VCP
          sim_vp(t_pe);
          if (pe[T_PE].sr[STAR1].star1.cba)
            async_any_busy++;
#endif
#ifdef MOVER
          sim_mv(t_pe);
#endif
#ifdef BARRIER
          sim_bp(t_pe);
#endif
#ifdef SSUMOVER
          sim_ssumv(t_pe);
#endif
#ifdef GSIGP
          sim_gsigp(t_pe);
#endif
#ifdef FSBA
          for (t_fsba=0; t_fsba<FSBA_NUM; t_fsba++)
            sim_fsba(t_pe, t_fsba);
#endif
#ifdef DAPF
          sim_dapf(t_pe);
#endif
          pe[T_PE].sr[STAR1].star1.asa = pe[T_PE].sr[STAR1].star1.asaf;
#ifdef VCP
          pe[T_PE].sr[STAR1].star1.es1 = pe[T_PE].sr[STAR1].star1.asam
                                       | pe[T_PE].sr[STAR1].star1.es0;
#endif
        }   
      }     
      tim_clock++;
      if (!async_any_busy)
        break;
    }   

/* consume exceptions */
    for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
      if (pe[T_PE].ip_status == STATUS_FREE && EXCEPTION_EXIST) {
	if ((scantype & SCAN_ALL) || t_pe == c_pe) scan_on = scantype;
	else                                       scan_on = 0;
        sim_ip(t_pe);
      }
    }

/* reset fp_top */
    for (t_pe = 0; t_pe < PE_NUM; t_pe++)
      pe[T_PE].fq_top = 0;

/* reset if_multiple_cycle */
    for (t_pe = 0; t_pe < PE_NUM; t_pe++)
      pe[T_PE].if_multiple_cycle = 0;

/* check if all score_boards FREEed */
    for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
      if (score_busy_found(t_pe))
        message("PE#%u still busy (internal)\n", t_pe);
    }

/* check if extended function exists */
    for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
      if (pe[T_PE].cntl_block != -1) {
        if (pe[T_PE].ip_status != STATUS_HALT)
          extended_function(t_pe);
        pe[T_PE].cntl_block = -1;
      }
    }
}

all_halts()
/* return 1:all halts 0:any busy */
{
	unsigned t_pe, pe_any_busy;

        pe_any_busy = 0;
        for (t_pe = 0; t_pe < PE_NUM; t_pe++) {
          if (pe[T_PE].ip_status != STATUS_HALT)
            pe_any_busy++;
        }     
        return (!pe_any_busy);
}

