static char SccsId[] = "@(#)bp.c	1.2    9/30/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* bp.c    90/12/16 */

#ifdef BARRIER

#include "tim.h"

sim_bp(t_pe)
    unsigned t_pe;
{
    unsigned	i, mskcount;
    unsigned	bst0count, bst1count;

/******** broadcast is done every 1.5 micro seconds ********/

    if (++pe[T_PE].bpu_5nano >= 300) {
      pe[T_PE].bpu_5nano = 0;

      if (pe[T_PE].mcr[BSDCMC].bsdcmc.bsdcon) {

        /* BSD connected */
        mskcount = bst0count = bst1count = 0;
        for (i=0; i<256; i++) {
	  if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
            mskcount++;
            if (pe[T_PE].mcr[BMMAP0].ful & 1) {
              if (i < PE_NUM && pe[i].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
            else {
              if (i < PE_NUM && pe[i].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
        }
        if (mskcount == bst0count) { /* includes (mskcount == 0) */
          pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0 = 0;
          switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 2: break;
          case 1: case 3: pe[T_PE].sr[STAR1].star1.es2 = 0; break;
          }
        }
        else if (mskcount == bst1count) {
	  pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0 = 1;
          switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 2: break;
          case 1: case 3: pe[T_PE].sr[STAR1].star1.es2 = 1; break;
          }
        }
      }
      else {

        /* BSD0 */
        mskcount = bst0count = bst1count = 0;
        switch (pe[T_PE].mcr[BMMAP0].ful & 7) {
        case 0:
          for (i=0; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 1:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 2:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 3:
          for (i=0; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 4:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i-64 < PE_NUM && pe[i-64].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 5:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+64 < PE_NUM && pe[i+64].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 6:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+64 < PE_NUM && pe[i+64].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 7:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+192 < PE_NUM && pe[i+192].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK00+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;
        }
        if (mskcount == bst0count) { /* includes (mskcount == 0) */
          pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0 = 0;
          switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 2: break;
          case 1: case 3: pe[T_PE].sr[STAR1].star1.es2 = 0; break;
          }
        }
        else if (mskcount == bst1count) {
	  pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0 = 1;
          switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 2: break;
          case 1: case 3: pe[T_PE].sr[STAR1].star1.es2 = 1; break;
          }
        }

        /* BSD1 */
        mskcount = bst0count = bst1count = 0;
        switch (pe[T_PE].mcr[BMMAP1].ful & 7) {
        case 0:
          for (i=0; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 1:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 2:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 3:
          for (i=0; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 4:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i-64 < PE_NUM && pe[i-64].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 5:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+64 < PE_NUM && pe[i+64].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i < PE_NUM && pe[i].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 6:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+64 < PE_NUM && pe[i+64].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;

        case 7:
          for (i=0; i<64; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+192 < PE_NUM && pe[i+192].mcr[BSTN0W].bstn0w.bstnl0) bst1count++;
              else bst0count++;
            }
          }
          for (i=64; i<128; i++) {
	    if (pe[T_PE].mcr[BMSK10+(i>>5)].ful & ((unsigned)0x80000000>>(i&31))) {
              mskcount++;
              if (i+128 < PE_NUM && pe[i+128].mcr[BSTN1W].bstn1w.bstnl1) bst1count++;
              else bst0count++;
            }
          }
	  break;
        }
        if (mskcount == bst0count) { /* includes (mskcount == 0) */
          pe[T_PE].mcr[LBSY1W].lbsy1w.lbsy1 = 0;
          switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 1: break;
          case 2:         pe[T_PE].sr[STAR1].star1.es2 = 0; break;
          case 3:         pe[T_PE].sr[STAR1].star1.es3 = 0; break;
          }
        }
        else if (mskcount == bst1count) {
	  pe[T_PE].mcr[LBSY1W].lbsy1w.lbsy1 = 1;
          switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 1: break;
          case 2:         pe[T_PE].sr[STAR1].star1.es2 = 1; break;
          case 3:         pe[T_PE].sr[STAR1].star1.es3 = 1; break;
          }
        }
      }
    }
}

#endif

