/* @(#)disasm.c	1.5    11/19/93 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* disasm.c	89/10/1 */

#define BUF_SIZE 256

disasm(t_pe, t_mode, addr, count, scan)
    unsigned t_pe, t_mode, addr, count, scan;
{
    struct tachyon_insn   *ti;
    struct tachyon_opcode *tmp_op;
    unsigned insn[2];
    unsigned insn_u1, insn_u2;
    unsigned insn_l1, insn_l2;
    unsigned type;
    unsigned index0, index1, index2;
    char buf[BUF_SIZE], *sym;

    for (; count; count--, addr+=8) {
	if (cmd_mem_access(t_pe,t_mode,addr,8,_R_,insn,'n'))
	    break;
	type = insn[0] >> 28;
        if (scan)
          scan_mfc(t_pe);
	message("%08.8X ", addr);
        if (!get_memname(t_pe, addr, &sym)) {
          message("%s:\n", sym);
          if (scan)
            scan_mfc(t_pe);
          message("         ");
        }
	message("[%c%1.1X]", type_exchange_loc[type] ? 'X':' ', type);

	ti = &(insn_type[type]);
	insn_u1 = (type<<28)|(insn[0]<<20&0x0fffffff)|(insn[1]>>12);
        insn_l1 = insn[1] <<20;
	insn_u2 = (type<<28)|(insn[1]<<8&0x0fffff00);
        insn_l2 = 0;
        if (ti->op0 == oper_cop) {
          index0 = ((insn[0] >> ti->sft0) & ti->mask0)
                 | ((insn[1] >> ti->sft1) & ti->mask1)
                 | ((insn[1] >> ti->sft2) & ti->mask2);
	  if (index0 > 0)
	    message(" @.%1.1X", (insn[0] >> 24) & 0xf);
        }
        else {
          index0 =  (insn[0] >> ti->sft0) & ti->mask0;
          index1 =  (insn_u1 >> ti->sft1) & ti->mask1;
          index2 =  (insn_u2 >> ti->sft2) & ti->mask2;
        }
	if (type_exchange_loc[type]) {
	  if (ti->op1) {
	    tmp_op = &((ti->op1)[index1]);
	    disasm_op(t_pe, addr, insn_u1, insn_l1, tmp_op->name, tmp_op->args, buf);
	    message(" %-18s", buf);
	  }
	  if (ti->op0) {
	    message(" &");
	    tmp_op = &((ti->op0)[index0]);
	    disasm_op(t_pe, addr, insn[0], insn[1], tmp_op->name, tmp_op->args, buf);
	    message(" %-18s", buf);
	  }
        }
        else {
	  if (ti->op0) {
	    tmp_op = &((ti->op0)[index0]);
	    disasm_op(t_pe, addr, insn[0], insn[1], tmp_op->name, tmp_op->args, buf);
	    message(" %-18s", buf);
	  }
	  if (ti->op1) {
	    message(" &");
	    tmp_op = &((ti->op1)[index1]);
	    disasm_op(t_pe, addr, insn_u1, insn_l1, tmp_op->name, tmp_op->args, buf);
	    message(" %-18s", buf);
	  }
	}
	if (ti->op2) {
	    message(" &");
	    tmp_op = &((ti->op2)[index2]);
	    disasm_op(t_pe, addr, insn_u2, insn_l2, tmp_op->name, tmp_op->args, buf);
	    message(" %-18s", buf);
    	}
	message("\n");
    }
}

disasm_op(t_pe, addr, insn_u, insn_l, name, args, buf)
    unsigned t_pe, addr, insn_u, insn_l;
    char     *name, *args, *buf;
{
    union insn_form insn;
    unsigned tmp;
    char buf2[BUF_SIZE];

    insn.ful.insn_u = insn_u;
    insn.ful.insn_l = insn_l;

    if ((*args) == 'G') {
	args += 2;
	switch (insn.cop.R1_u >> 3) {
        case 1:
          sprintf(buf, "%sa ", name);
	  break;
	case 2:
          sprintf(buf, "%sb ", name);
	  break;
	default:
          sprintf(buf, "%s ", name);
	  break;
	}
    }
    else {
        sprintf(buf, "%s ", name);
    }

    for(;;) {
        switch (*args++) {
        case 0:
	    return;
	    break;
	case ',':
	    sprintf(buf2, ",");
	    break;
	case '1': /* rs1 register. */
	    sprintf(buf2, "gr%u", insn.i5_5_5_5.r1);
	    break;
	case '2': /* rs2 register. */
	    sprintf(buf2, "gr%u", insn.i5_5_5_5.r2);
	    break;
	case '3': /* rs3 register(for 20 bit OP). */
	    sprintf(buf2, "gr%u", insn.i5_5_5_5.r3);
	    break;
	case '4': /* rs3 register(for 40 bit OP). */
	    sprintf(buf2, "gr%u", insn.i5_5_25_5.r3);
	    break;
	case '5': /* rs3 register(for 60 bit OP). */
	    sprintf(buf2, "gr%u", insn.sys_aki.r3);
	    break;
	case 'e': /* frs1 floating point register. */
	    sprintf(buf2, "fr%u", insn.i5_5_5_5.r1);
	    break;
	case 'f': /* frs2 floating point register. */
	    sprintf(buf2, "fr%u", insn.i5_5_5_5.r2);
	    break;
	case 'g': /* frs3 floating point register(for 20 bit OP). */
	    sprintf(buf2, "fr%u", insn.i5_5_5_5.r3);
	    break;
	case 'h': /* frs3 floating point register(for 40 bit OP). */
	    sprintf(buf2, "fr%u", insn.i5_5_25_5.r3);
	    break;
	case 'i': /*  5 bit Immediate. */
	    sprintf(buf2, "%d", insn.i5_5_5_5.r2 > 15 ? insn.i5_5_5_5.r2 - 32 : insn.i5_5_5_5.r2);
	    break;
	case 'u': /*  5 bit Unsigned Immediate.(for shift OP) */
	    sprintf(buf2, "%u", insn.i5_5_5_5.r2);
	    break;
	case 'j': /* 12 bit immediate. */
	    sprintf(buf2, "%d(0x%X)", insn.i3_12_5.im, insn.i3_12_5.im);
	    break;
	case 'I': /* 25 bit Immediate. */
	    tmp = (insn.i5_5_25_5.im_u << 7) + insn.i5_5_25_5.im_l;
	    sprintf(buf2, "%d(0x%X)", tmp > 0x0ffffff ? tmp - 0x2000000 : tmp, tmp);
	    break;
	case 'J': /* 32 bit Immediate. */
            sprint_symbol(t_pe, (insn.i3_32_5.im_u << 7) + insn.i3_32_5.im_l, buf2);
	    break;
	case 'r': /* 12 bit PC relative immediate. */
	    tmp = insn.i3_12_5.im;
	    sprint_symbol(t_pe, ((tmp > 0x07ff ? tmp - 0x1000 : tmp) << 3) + addr + 8, buf2);
	    break;
	case 'R': /* 32 bit PC relative immediate. */
	    sprint_symbol(t_pe, (((insn.i3_32_5.im_u << 7) + insn.i3_32_5.im_l) << 3) + addr + 8, buf2);
	    break;
	case 's': /* integer/floating state register(for 20 bit OP). */
	    sprintf(buf2, "%s", star0[insn.i3_12_5.r3]);
	    break;
	case 't': /* integer/floating state register(for 40 bit OP). */
	    sprintf(buf2, "%s", star0[insn.i3_32_5.r3]);
	    break;
	case 'c': /* coprocessor state register(for 20 bit OP). */
	    sprintf(buf2, "%s", star1[insn.i3_12_5.r3]);
	    break;
	case 'd': /* coprocessor state register(for 40 bit OP). */
	    sprintf(buf2, "%s", star1[insn.i3_32_5.r3]);
	    break;
	case 'U': /* SRrsr register(for 0-31). */
	    sprintf(buf2, "sr%u", insn.sys_25.r3);
	    break;
	case 'V': /* SRrsr register(for 0-1023). */
	    sprintf(buf2, "sr%u", insn.sys_mov.r2);
	    break;
	case 'X': /* 4 bit unsigned immediate. */
	    sprintf(buf2, "%u", insn.sys_aki.im);
	    break;
	case 'Y': /* 8 bit unsigned immediate. */
	    sprintf(buf2, "%u", insn.sys_svc.im);
	    break;
	case 'y': /* rs2 register(for type-B). */
	    sprintf(buf2, "gr%u", (insn.sys_25.r1_u << 2) + insn.sys_25.r1_l);
	    break;
	case 'z': /* 25 bit immediate(for type-B). */
	    tmp = insn.sys_25.im;
	    sprintf(buf2, "%d(0x%X)", tmp > 0x0ffffff ? tmp - 0x2000000 : tmp, tmp);
	    break;

	case 'A': /* VP R1 */
	    sprintf(buf2, "vr%u", (insn.cop.R1_u << 2) + insn.cop.R1_l);
	    break;
	case 'B': /* VP R2 */
	    sprintf(buf2, "vr%u", insn.cop.R2);
	    break;
	case 'C': /* VP R3 */
	    sprintf(buf2, "vr%u", insn.cop.R3);
	    break;
	case 'D': /* VP R4 */
	    sprintf(buf2, "vr%u", insn.cop.R4);
	    break;
	case 'L': /* VP mask R1 */
	    sprintf(buf2, "mr%u", (insn.cop.R1_u << 2) + insn.cop.R1_l);
	    break;
	case 'M': /* VP mask R2 */
	    sprintf(buf2, "mr%u", insn.cop.R2);
	    break;
	case 'N': /* VP mask R3 */
	    sprintf(buf2, "mr%u", insn.cop.R3);
	    break;
	case 'O': /* VP mask R4 */
	    sprintf(buf2, "mr%u", insn.cop.R4);
	    break;
	case '6': /* VP rr1 GR */
	    sprintf(buf2, "gr%u", insn.cop.r1);
	    break;
	case '7': /* VP rr2 GR */
	    sprintf(buf2, "gr%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case '8': /* VP rw1 GR */
	    sprintf(buf2, "gr%u", insn.cop.R2 & 0x1f);
	    break;
	case '9': /* VP rw2 GR */
	    sprintf(buf2, "gr%u", insn.cop.R3 & 0x1f);
	    break;
	case 'E': /* VP rr2 FR */
	    sprintf(buf2, "fr%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case 'F': /* VP rw2 FR */
	    sprintf(buf2, "fr%u", insn.cop.R3 & 0x1f);
	    break;
	case 'P': /* VP vcr R2 */
	    sprintf(buf2, "vcr%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case 'Q': /* VP vcr R3 */
	    sprintf(buf2, "vcr%u", insn.cop.R3 & 0x1f);
	    break;
	case 'S': /* VP vut R2 */
	    sprintf(buf2, "vut%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case 'T': /* VP vut R3 */
	    sprintf(buf2, "vut%u", insn.cop.R3 & 0x1f);
	    break;
	case 'H': /* VP M */
	    sprintf(buf2, "%u", insn.cop.R4 & 3);
	    break;

	default:
	    message(" --illegal args\n");
	    return;
	    break;
	}
	strcat(buf, buf2);
    }
}

