/* @(#)facility.h	1.3    11/18/91 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* facility.h    89/10/1 */

#if 1

/******************* PE ****************************************/

#define EXCEPTION_EXIST    (*(unsigned*)&pe[T_PE].work_ird0 & 0xff7fffff)
#define IP_EXCEPTION_EXIST (*(unsigned*)&pe[T_PE].work_ird0 & 0xfb3fff00)
#define AP_EXCEPTION_EXIST (*(unsigned*)&pe[T_PE].work_ird0 & 0x040000ff)
#define FP_EXCEPTION_EXIST (*(unsigned*)&pe[T_PE].work_ird0 & 0x00400000)

/******************* SCALAR ************************************/

/******************* GR ****************************************/

#define sys_gr_lock(t_pe, num) 					\
{								\
    if ((num) > 0)						\
        pe[T_PE].gr_score[num] = SCORE_BUSY;			\
}

#define sys_gr_unlock(t_pe, num)				\
{								\
    pe[T_PE].gr_score[num] = SCORE_FREE;			\
}

#define sys_gr_check_score(t_pe, num, rw)			\
    (pe[T_PE].gr_score[num])

#define sys_gr_access(t_pe, num, rw, d)                         \
{								\
    if ((rw) == _R_) {                                          \
      if ((num) == 1 && pe[T_PE].sr[PEV].pev.u)                 \
        d = pe[T_PE].sr[UGR1].ful;                              \
      else                                                      \
        d = pe[T_PE].gr[num];                                   \
    }                                                           \
    else if ((rw) == _W_) {                                     \
      if ((num) == 1 && pe[T_PE].sr[PEV].pev.u)                 \
          pe[T_PE].sr[UGR1].ful = (d);			        \
      else if ((num) > 0)                                       \
          pe[T_PE].gr[num] = (d);    			        \
    }                                                           \
    else if ((rw) == _O_) {                                     \
      if ((num) == 1 && pe[T_PE].sr[PEV].pev.u)                 \
          pe[T_PE].sr[UGR1].ful |= (d);			        \
      else if ((num) > 0)                                       \
          pe[T_PE].gr[num] |= (d);    			        \
    }                                                           \
}

#define sys_async_gr_access(t_pe, num, u, rw, d)                \
{								\
    if ((rw) == _R_) {                                          \
      if ((num) == 1 && (u))                                    \
        d = pe[T_PE].sr[UGR1].ful;                              \
      else                                                      \
        d = pe[T_PE].gr[num];                                   \
    }                                                           \
    else if ((rw) == _W_) {                                     \
      if ((num) == 1 && (u))                                    \
          pe[T_PE].sr[UGR1].ful = (d);			        \
      else if ((num) > 0)                                       \
          pe[T_PE].gr[num] = (d);    			        \
    }                                                           \
    else if ((rw) == _O_) {                                     \
      if ((num) == 1 && (u))                                    \
          pe[T_PE].sr[UGR1].ful |= (d);			        \
      else if ((num) > 0)                                       \
          pe[T_PE].gr[num] |= (d);    			        \
    }                                                           \
}

/******************* FR ****************************************/

#define sys_fr_exception(t_pe, num)				\
{								\
    if ((num) > 0)						\
        pe[T_PE].fr_score[num] = SCORE_EXCEPTION;		\
}

#define sys_fr_lock(t_pe, num)					\
{								\
    if ((num) > 0)						\
        pe[T_PE].fr_score[num] = SCORE_BUSY;			\
}

#define sys_fr_unlock(t_pe, num)				\
{								\
    pe[T_PE].fr_score[num] = SCORE_FREE;			\
}

#define sys_fr_access(t_pe, num, rw, d1, d2)                    \
{                                                               \
    if ((rw) == _R_) {                                          \
        d1 = pe[T_PE].fr[num].u;                      		\
        d2 = pe[T_PE].fr[num].l;                       		\
    }                                                           \
    else if ((rw) == _W_) {                                     \
        if ((num) > 0) {                                        \
            pe[T_PE].fr[num].u = (d1);				\
            pe[T_PE].fr[num].l = (d2);				\
        }                                                       \
    }                                                           \
    else if ((rw) == _A_) {                                     \
        if ((num) > 0) {                                        \
            pe[T_PE].fr[num].u &= (d1);				\
            pe[T_PE].fr[num].l &= (d2);				\
        }                                                       \
    }                                                           \
    else if ((rw) == _O_) {                                     \
        if ((num) > 0) {                                        \
            pe[T_PE].fr[num].u |= (d1);				\
            pe[T_PE].fr[num].l |= (d2);				\
        }                                                       \
    }                                                           \
}

/******************* SR ****************************************/

#define sys_sr_lock(t_pe)					\
{								\
    pe[T_PE].sr_score = SCORE_BUSY;				\
}

#define sys_sr_unlock(t_pe) 					\
{								\
    pe[T_PE].sr_score = SCORE_FREE;				\
}

#define sys_sr_check_score(t_pe)				\
    (pe[T_PE].sr_score)

/******************* TOD ***************************************/

#define sys_tod_access(t_pe, rw, d1, d2)                        \
{                                                               \
    if ((rw) == _R_) {                                          \
        d1 = pe[T_PE].tod.u;                          		\
        d2 = pe[T_PE].tod.l;                          		\
    }                                                           \
    else if ((rw) == _W_) {                                     \
        pe[T_PE].tod.u = (d1);					\
        pe[T_PE].tod.l = (d2 & 0xffffff00);			\
    }                                                           \
}

#ifdef VCP

/******************* VECTOR ************************************/

/******************* VP ****************************************/

#define sys_vp_lock(t_pe)					\
{								\
    pe[T_PE].vp_score = SCORE_BUSY;				\
}

#define sys_vp_unlock(t_pe)					\
{								\
    pe[T_PE].vp_score = SCORE_FREE;				\
}

#define sys_vp_check_score(t_pe)				\
    (pe[T_PE].vp_score)

/******************* VR ****************************************/

#define sys_vr_lock(t_pe, select, rw)				\
{								\
    if ((rw) == _R_)						\
        pe[T_PE].vr_rscore[select]++;				\
    else if ((rw) == _W_)					\
        pe[T_PE].vr_wscore[select] = 1;				\
}

#define sys_vr_unlock(t_pe, select, rw)				\
{								\
    if ((rw) == _R_)						\
        pe[T_PE].vr_rscore[select]--;				\
    else if ((rw) == _W_)					\
        pe[T_PE].vr_wscore[select] = 0;				\
}

#define sys_vr_check_score(t_pe, select, rw)			\
    ((rw) == _R_						\
      ? (pe[T_PE].vr_wscore[select] > 0				\
        ? (pe[T_PE].vr_wr_conflict[select]++, SCORE_BUSY) : SCORE_FREE)\
    :(rw) == _W_						\
      ? (pe[T_PE].vr_rscore[select] > 0				\
        ? (pe[T_PE].vr_rw_conflict[select]++, SCORE_BUSY)	\
      : (pe[T_PE].vr_wscore[select] > 0				\
        ? (pe[T_PE].vr_ww_conflict[select]++, SCORE_BUSY) : SCORE_FREE))\
    : SCORE_FREE)

#define sys_vr_access(t_pe, select, num, rw, d1, d2)		\
{								\
    if ((rw) == _R_) {						\
      d1 = pe[T_PE].vr[select+(((num)-1)/VRL)][((num-1))&(VRL-1)].u;\
      d2 = pe[T_PE].vr[select+(((num)-1)/VRL)][((num-1))&(VRL-1)].l;\
    }								\
    else if ((rw) == _W_) {					\
      pe[T_PE].vr[select+(((num)-1)/VRL)][((num-1))&(VRL-1)].u = (d1);\
      pe[T_PE].vr[select+(((num)-1)/VRL)][((num-1))&(VRL-1)].l = (d2);\
    }								\
}

/******************* MR ****************************************/

#define sys_mr_lock(t_pe, select, rw, use_mr0)			\
{								\
    if (select || use_mr0) {					\
        if ((rw) == _R_)					\
            pe[T_PE].mr_rscore[select]++;			\
        else if ((rw) == _W_)					\
            pe[T_PE].mr_wscore[select] = 1;			\
    }								\
}

#define sys_mr_unlock(t_pe, select, rw, use_mr0)		\
{								\
    if (select || use_mr0) {					\
        if ((rw) == _R_)					\
            pe[T_PE].mr_rscore[select]--;			\
        else if ((rw) == _W_) 					\
            pe[T_PE].mr_wscore[select] = 0;			\
    }								\
}

#define sys_mr_check_score(t_pe, select, rw, use_mr0)		\
    ((select || use_mr0) 					\
      ? ((rw) == _R_						\
        ? (pe[T_PE].mr_wscore[select] > 0			\
          ? (pe[T_PE].mr_wr_conflict[select]++, SCORE_BUSY) : SCORE_FREE)\
      :  (rw) == _W_						\
        ? (pe[T_PE].mr_rscore[select] > 0			\
          ? (pe[T_PE].mr_rw_conflict[select]++, SCORE_BUSY)	\
        : (pe[T_PE].mr_wscore[select] > 0			\
          ? (pe[T_PE].mr_ww_conflict[select]++, SCORE_BUSY) : SCORE_FREE))\
      : SCORE_FREE)						\
    : SCORE_FREE)

#define sys_mr_access(t_pe, select, num, rw, d, use_mr0)	\
{								\
    unsigned tmp = ((num-1)) & (VRL-1);				\
								\
    if (select || use_mr0) {					\
      if ((rw) == _R_) {					\
        if (tmp < VRL/2)					\
          d = (pe[T_PE].mr[select+(((num-1))/VRL)].u>>(VRL/2-1-tmp)) & 1;\
        else							\
          d = (pe[T_PE].mr[select+(((num-1))/VRL)].l>>(VRL-1-tmp)) & 1;\
      }								\
      else if ((rw) == _W_) {					\
        if (d & 1) {						\
          if (tmp < VRL/2)					\
            pe[T_PE].mr[select+(((num-1))/VRL)].u |= 1<<(VRL/2-1-tmp);\
          else							\
            pe[T_PE].mr[select+(((num-1))/VRL)].l |= 1<<(VRL-1-tmp);\
        }							\
        else {							\
          if (tmp < VRL/2)					\
            pe[T_PE].mr[select+(((num-1))/VRL)].u &= ~(1<<(VRL/2-1-tmp));\
          else							\
            pe[T_PE].mr[select+(((num-1))/VRL)].l &= ~(1<<(VRL-1-tmp));\
        }							\
      }								\
    }								\
    else {							\
      if ((rw) == _R_) {                                        \
        d = 1;							\
      }								\
    }								\
}

/******************* VOP ***************************************/

#define sys_vop_lock_indirect(t_pe)				\
{								\
    pe[T_PE].vop_iscore = SCORE_BUSY;				\
}

#define sys_vop_unlock_indirect(t_pe)				\
{								\
    pe[T_PE].vop_iscore = SCORE_FREE;				\
}

#define sys_vop_check_indirect(t_pe)				\
    (pe[T_PE].vop_iscore)

#define sys_vop_lock_id(t_pe, id, rw)				\
{								\
    if ((id) == 1 || (id) == 2) {				\
      if ((rw) == _R_)                                          \
        pe[T_PE].vop_rscore[id]++; 	                        \
      else if ((rw) == _W_)                                     \
        pe[T_PE].vop_wscore[id] = 1;   		                \
    }								\
}

#define sys_vop_unlock_id(t_pe, id, rw)				\
{								\
    if ((id) == 1 || (id) == 2) {				\
      if ((rw) == _R_)						\
        pe[T_PE].vop_rscore[id]--;				\
      else if ((rw) == _W_)					\
        pe[T_PE].vop_wscore[id] = 0;				\
    }								\
}

#define sys_vop_check_id(t_pe, id, rw)				\
    (((id) == 1 || (id) == 2)					\
      ? ((rw) == _R_						\
        ? ( pe[T_PE].vop_wscore[id] > 0				\
          ? SCORE_BUSY : SCORE_FREE)				\
      :  (rw) == _W_						\
        ? ((pe[T_PE].vop_rscore[id] > 0 || pe[T_PE].vop_wscore[id] > 0)\
          ? SCORE_BUSY : SCORE_FREE)				\
      : SCORE_FREE)						\
    : SCORE_FREE) 						\

#endif

#ifdef VCP

#define TVOI pe[T_PE].vp_opiq   [0]
#define BVOI pe[T_PE].vp_opiq   [VP_OPIQNUM-1]

#define TVOM pe[T_PE].vp_opmq   [0]
#define BVOM pe[T_PE].vp_opmq   [VP_OPMQNUM-1]

#define TVOC pe[T_PE].vp_opcq   [0]
#define BVOC pe[T_PE].vp_opcq   [VP_OPCQNUM-1]

#define TVLQ pe[T_PE].vp_ldq    [0]
#define TVSQ pe[T_PE].vp_stq    [0]
#define TVAQ pe[T_PE].vp_addq   [0]
#define TVMQ pe[T_PE].vp_mulq   [0]
#define TVDQ pe[T_PE].vp_divq   [0]
#define TVKQ pe[T_PE].vp_mskq   [0]

#define BVLQ pe[T_PE].vp_ldq    [VP_LDQNUM-1]
#define BVSQ pe[T_PE].vp_stq    [VP_STQNUM-1]
#define BVAQ pe[T_PE].vp_addq   [VP_ADDQNUM-1]
#define BVMQ pe[T_PE].vp_mulq   [VP_MULQNUM-1]
#define BVDQ pe[T_PE].vp_divq   [VP_DIVQNUM-1]
#define BVKQ pe[T_PE].vp_mskq   [VP_MSKQNUM-1]

#define TVLP pe[T_PE].vp_ldp    [0]
#define TVSP pe[T_PE].vp_stp    [0]
#define TVAP pe[T_PE].vp_addp   [0]
#define TVMP pe[T_PE].vp_mulp   [0]
#define TVDP pe[T_PE].vp_divp   [0]
#define TVKP pe[T_PE].vp_mskp   [0]
 
#define PVLP pe[T_PE].vp_ldp    [1]
#define PVSP pe[T_PE].vp_stp    [1]
#define PVAP pe[T_PE].vp_addp   [1]
#define PVMP pe[T_PE].vp_mulp   [1]
#define PVDP pe[T_PE].vp_divp   [1]
#define PVKP pe[T_PE].vp_mskp   [1]
 
#define BVLP pe[T_PE].vp_ldp    [VP_LDPLEN-1]
#define BVSP pe[T_PE].vp_stp    [VP_STPLEN-1]
#define BVAP pe[T_PE].vp_addp   [VP_ADDPLEN-1]
#define BVMP pe[T_PE].vp_mulp   [VP_MULPLEN-1]
#define BVDP pe[T_PE].vp_divp   [VP_DIVPLEN-1]
#define BVKP pe[T_PE].vp_mskp   [VP_MSKPLEN-1]

#endif

#endif

