static char SccsId[] = "@(#)fsba.c	1.3    10/24/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* fsba.c    90/8/30 */

#ifdef FSBA

#include "tim.h"

sim_fsba(t_pe, t_fsba)
    unsigned t_pe, t_fsba;
{
/**********************
*  scan IOCCBS        *
**********************/
    if (pe[T_PE].smcr[IOCCBS].ful) { /* get command */

      if (pe[T_PE].mcr[IOCCB0].ioccb0.command    == 0x52
       && pe[T_PE].mcr[IOCCB0].ioccb0.sid        == 8
       && pe[T_PE].mcr[IOCCB0].ioccb0.channel_id == T_FSBA << 2
       && pe[T_PE].mcr[IOCCB2].ioccb2.fsln       == T_FSBA
       && pe[T_PE].mcr[IOCCB2].ioccb2.dmid       == 0) {

        pe[T_PE].smcr[IOCCBS].ful = 0;

        if (!pe[T_PE].mcr[ICISTA].icista.rpwait) {

          pe[T_PE].mcr[ICISTA].icista.rpwait     = 1;
          pe[T_PE].mcr[ICISTA].icista.rppend     = 1;
          pe[T_PE].mcr[IOCRB0].iocrb0.reply_cd   = 0x59;
          pe[T_PE].mcr[IOCRB0].iocrb0.did        = 8;
          pe[T_PE].mcr[IOCRB0].iocrb0.channel_id = T_FSBA << 2;
          pe[T_PE].mcr[IOCRB2].iocrb2.cc         = 0;
          pe[T_PE].mcr[IOCRB2].iocrb2.status     = 0;
          pe[T_PE].mcr[IOCRB2].iocrb2.fsln       = T_FSBA;
          pe[T_PE].mcr[IOCRB2].iocrb2.dmid       = 0;
          pe[T_PE].mcr[IOCRB3].ful               = 0;

          switch (pe[T_PE].mcr[IOCCB2].ioccb2.inst_code) {
          case 0x01: /* Interruption Answer */
#ifdef FST
            if (pe[T_PE].fstcr[T_FSBA].intr
             && ((1 << pe[T_PE].fstcr[T_FSBA].ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1))) {
              pe[T_PE].mcr[IOCRB2].iocrb2.intr_code = (12-pe[T_PE].fstcr[T_FSBA].ipl) << 2;
              pe[T_PE].mcr[IOCRB3].ful = (0x80 | FST_SLOTID) << 8;
              pe[T_PE].fstcr[T_FSBA].intr = 0;
            }
#endif
#ifdef DASD
            if (pe[T_PE].acr.aint
             && ((1 << pe[T_PE].acf.ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1))) {
              pe[T_PE].mcr[IOCRB2].iocrb2.intr_code = (12-pe[T_PE].acf.ipl) << 2;
              pe[T_PE].mcr[IOCRB3].ful = (0x80 | DASD_SLOTID) << 8;
              pe[T_PE].acr.ainp = 1;
              pe[T_PE].acr.aint = 0;
            }
#endif
            break;

          case 0x02: /* Interruption Level Check */
#ifdef FST
            if (pe[T_PE].fstcr[T_FSBA].intr
             && ((1 << pe[T_PE].fstcr[T_FSBA].ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1)))
              pe[T_PE].mcr[IOCRB3].ful = pe[T_PE].fstcr[T_FSBA].ipl << 2;
#endif
#ifdef DASD
            if (pe[T_PE].acr.aint
             && ((1 << pe[T_PE].acf.ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1)))
              pe[T_PE].mcr[IOCRB3].ful = pe[T_PE].acf.ipl << 2;
#endif
            break;

          case 0x84: /* Write-Direct */
            switch (pe[T_PE].mcr[IOCCB2].ioccb2.sub_op) {
            case 0x00: /* No operaion 2 */
              pe[T_PE].mcr[IOCRB2].iocrb2.cc = pe[T_PE].fsir[T_FSBA].setup ? 0 : 2;
              break;

            case 0x01: /* Write FSbus */
              if ((pe[T_PE].mcr[IOCCB3].ful & 0xf0f0) == 0x8000) {
	        switch ((pe[T_PE].mcr[IOCCB3].ful >> 8) & 0xf) {
                case FSBA_SLOTID:
                  pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
                  break;
#ifdef FST
                case FST_SLOTID:
                  sys_fstcr_access(t_pe, t_fsba, pe[T_PE].mcr[IOCCB3].ful & 0xf,_W_);
                  fst_reg_reactor(t_pe, t_fsba);
                  break;
#endif
#ifdef DASD
                case DASD_SLOTID:
                  sys_acr_access(t_pe, pe[T_PE].mcr[IOCCB3].ful & 0xf, _W_);
                  dasd_reg_reactor(t_pe, t_fsba);
                  if (pe[T_PE].acr.aint
                   && ((1 << pe[T_PE].acf.ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1)))
                    pe[T_PE].mcr[FSBARP].ful |= (unsigned)0x80000000 >> T_FSBA;
                  break;
#endif
                default:
                  pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
                  break;
                }
              }
              else {
                pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
              }
              break;

            case 0x08: /* Clear FSBA */
              /* do nothing */
              break;

            case 0x09: /* Load FSCR */
              *(unsigned*)&pe[T_PE].fscr[T_FSBA] = pe[T_PE].mcr[IOCCB5].ful;
#ifdef FST
              if (pe[T_PE].fstcr[T_FSBA].intr
               && ((1 << pe[T_PE].fstcr[T_FSBA].ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1)))
                pe[T_PE].mcr[FSBARP].ful |= (unsigned)0x80000000 >> T_FSBA;
#endif
#ifdef DASD
              if (pe[T_PE].acr.aint
               && ((1 << pe[T_PE].acf.ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1)))
                pe[T_PE].mcr[FSBARP].ful |= (unsigned)0x80000000 >> T_FSBA;
#endif
              break;

            case 0x0c: /* Write FSBA */
              sys_fsir_access(t_pe, t_fsba, pe[T_PE].mcr[IOCCB3].ful & 0xffff, _W_);
              break;

            case 0x0d: /* Write FSbus Standard */
#ifdef FST
              sys_fstmem_access(t_pe, t_fsba, pe[T_PE].mcr[IOCCB3].ful & 0x3fff, _W_);
#else
              pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
#endif
              break;

            case 0x0e: /* Write FSbus Extend */
              pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
              break;

            default:
              pe[T_PE].mcr[IOCRB2].iocrb2.status = 0x08;
              break;
            }
            break;

          case 0x85: /* Read-Direct */
            switch (pe[T_PE].mcr[IOCCB2].ioccb2.sub_op) {
            case 0x00: /* No operaion 1 */
              /* do nothing */
              break;

            case 0x01: /* Read FSbus */
              if ((pe[T_PE].mcr[IOCCB3].ful & 0xf0f0) == 0x8000) {
	        switch ((pe[T_PE].mcr[IOCCB3].ful >> 8) & 0xf) {
                case FSBA_SLOTID:
                  pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
                  break;
#ifdef FST
                case FST_SLOTID:
                  sys_fstcr_access(t_pe, t_fsba, pe[T_PE].mcr[IOCCB3].ful & 0xf,_R_);
                  break;
#endif
#ifdef DASD
                case DASD_SLOTID:
                  sys_acr_access(t_pe, pe[T_PE].mcr[IOCCB3].ful & 0xf, _R_);
                  break;
#endif
                default:
                  pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
                  break;
                }
              }
              else {
                pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
              }
              break;

            case 0x02: /* Read FSBA RAS Data */
              /* do nothing */
              break;

            case 0x04: /* Store FSCR and Reset Mask */
              pe[T_PE].mcr[IOCRB3].ful = *(unsigned*)&pe[T_PE].fscr[T_FSBA];
              break;

            case 0x08: /* Read FSBA */
              sys_fsir_access(t_pe, t_fsba, pe[T_PE].mcr[IOCCB3].ful & 0xffff, _R_);
              break;

            case 0x09: /* Sense Attribute */
              if ((pe[T_PE].mcr[IOCCB3].ful & 0xf000) == 0x8000) {
	        switch ((pe[T_PE].mcr[IOCCB3].ful >> 8) & 0xf) {
                case FSBA_SLOTID:
                  pe[T_PE].mcr[IOCRB3].ful = 0x00;
                  break;
#ifdef FST
                case FST_SLOTID:
                  if (pe[T_PE].fstcr[T_FSBA].dpi)
                    pe[T_PE].mcr[IOCRB2].iocrb2.cc = 2;
                  else
                    pe[T_PE].mcr[IOCRB3].ful = 0x1e;
                  break;
#endif
#ifdef DASD
                case DASD_SLOTID:
                  pe[T_PE].mcr[IOCRB3].ful = 0x01;
                  break;
#endif
                default:
                  pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
                  break;
                }
              }
              else {
                pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
              }
              break;

            case 0x0a: /* Read FSbus Standard */
#ifdef FST
              sys_fstmem_access(t_pe, t_fsba, pe[T_PE].mcr[IOCCB3].ful & 0x3fff, _R_);
#else
              pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
#endif
              break;

            case 0x0b: /* Read FSbus Extend */
              pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
              break;

            default:
              pe[T_PE].mcr[IOCRB2].iocrb2.status = 0x08;
              break;
            }
            break;

          default: /* Undefined */
            pe[T_PE].mcr[IOCRB2].iocrb2.status = 0x08;
            break;
          }
        }
      }
    }

/************************************
* update interruption request queue *
************************************/
    if (pe[T_PE].fsir[T_FSBA].setup && pe[T_PE].fsir[T_FSBA].trnen) {
#ifdef FST
      if (pe[T_PE].fsrq[T_FSBA][FST_SLOTID].count) {
        if (!--pe[T_PE].fsrq[T_FSBA][FST_SLOTID].count) {
          fst_dma(t_pe, t_fsba);
          if (pe[T_PE].fstcr[T_FSBA].intr
           && ((1 << pe[T_PE].fstcr[T_FSBA].ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1)))
            pe[T_PE].mcr[FSBARP].ful |= (unsigned)0x80000000 >> T_FSBA;
        }
      }
#endif
#ifdef DASD
      if (pe[T_PE].fsrq[T_FSBA][DASD_SLOTID].count) {
        if (!--pe[T_PE].fsrq[T_FSBA][DASD_SLOTID].count) {
          dasd_dma(t_pe, t_fsba);
          if (pe[T_PE].acr.aint
           && ((1 << pe[T_PE].acf.ipl) & (pe[T_PE].fscr[T_FSBA].lim << 1)))
            pe[T_PE].mcr[FSBARP].ful |= (unsigned)0x80000000 >> T_FSBA;
        }
      }
#endif
    }

/***********************
* update ext_interrupt *
***********************/
    if (pe[T_PE].mcr[FSBARP].ful)
      pe[T_PE].ext_interrupt |= FSBA_INTERRUPT;
}

#endif

