static char SccsId[] = "@(#)fst.c	1.1    6/12/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* fst.c   90/08/27 */

#ifdef FST

#include "tim.h"

fst_reg_reactor(t_pe, t_fsba)
    unsigned t_pe, t_fsba;
{
    if (pe[T_PE].fstcr[T_FSBA].rst) {
      /* reset register */
      pe[T_PE].fsrq[T_FSBA][FST_SLOTID].count  = 0;
      pe[T_PE].fstcr[T_FSBA].rst   = 0;
      pe[T_PE].fstcr[T_FSBA].busy  = 0;
      pe[T_PE].fstcr[T_FSBA].intr  = 0;
      pe[T_PE].fstcr[T_FSBA].dter  = 0;
      pe[T_PE].fstcr[T_FSBA].tot   = 0;
      pe[T_PE].fstcr[T_FSBA].beack = 0;
      pe[T_PE].fstcr[T_FSBA].econ  = 0;
      pe[T_PE].fstcr[T_FSBA].macrinh = 0;
      pe[T_PE].fstcr[T_FSBA].mainh = 0;
      pe[T_PE].fstcr[T_FSBA].pci   = 0;
      pe[T_PE].fstcr[T_FSBA].dtakm = 0;
      pe[T_PE].fstcr[T_FSBA].ampi  = 0;
      pe[T_PE].fstcr[T_FSBA].api   = 0;
      pe[T_PE].fstcr[T_FSBA].dpi   = 0;
      pe[T_PE].fstcr[T_FSBA].berr  = 0;
      pe[T_PE].fstcr[T_FSBA].sfail = 0;
      pe[T_PE].fstcr[T_FSBA].afail = 0;
    }
    else if (!pe[T_PE].fstcr[T_FSBA].exec) {
      /* cancel DMA transmission */
      pe[T_PE].fsrq[T_FSBA][FST_SLOTID].count = 0;
      pe[T_PE].fstcr[T_FSBA].busy = 0;
    }
    else if (!pe[T_PE].fstcr[T_FSBA].busy) {
      /* prepare DMA transmission */
      pe[T_PE].fsrq[T_FSBA][FST_SLOTID].count = FST_DMA_DELAY + pe[T_PE].fstcr[T_FSBA].cr;
      pe[T_PE].fstcr[T_FSBA].busy = 1;
    }
}

fst_dma(t_pe, t_fsba)
    unsigned t_pe, t_fsba;
{
    unsigned len, d;

    /* execute DMA transmission */
    pe[T_PE].fstcr[T_FSBA].exec = 0;
    pe[T_PE].fstcr[T_FSBA].busy = 0;

    switch (pe[T_PE].fstcr[T_FSBA].cmc) {
    case 0x00: /* read */
      if (pe[T_PE].fstcr[T_FSBA].dpi || pe[T_PE].fstcr[T_FSBA].api) {
        pe[T_PE].fstcr[T_FSBA].dter = 1;
        pe[T_PE].fstcr[T_FSBA].intr = 1;
        return;
      }
      if (pe[T_PE].fstcr[T_FSBA].berr) {
        pe[T_PE].fstcr[T_FSBA].beack = 1;
        pe[T_PE].fstcr[T_FSBA].intr = 1;
        return;
      }
      if ((len = 1 << (pe[T_PE].fstcr[T_FSBA].dtm & 3)) == 8) {
        pe[T_PE].fstcr[T_FSBA].beack = 1;
        pe[T_PE].fstcr[T_FSBA].intr = 1;
        return;
      }
      do {
        switch (len) {
        case 1:
          *(unsigned char *)  &d = pe[T_PE].fstmem[T_FSBA][pe[T_PE].fstcr[T_FSBA].mar&(FSTMEM_SIZE-1)];
          break;

        case 2:
          *(unsigned short *) &d = *(unsigned short *) &pe[T_PE].fstmem[T_FSBA][pe[T_PE].fstcr[T_FSBA].mar&(FSTMEM_SIZE-1)&~1];
          break;

        case 4:
          d = *(unsigned *) &pe[T_PE].fstmem[T_FSBA][pe[T_PE].fstcr[T_FSBA].mar&(FSTMEM_SIZE-1)&~3];
          break;
        }
        switch (sys_fop_access(t_pe,pe[T_PE].fstcr[T_FSBA].mar,len,_W_,&d)) {
        case RW_SUCCESS:
          break;

        case RW_BERR:
          pe[T_PE].fstcr[T_FSBA].beack = 1;
          break;

        case RW_TIMEOUT:
          pe[T_PE].fstcr[T_FSBA].tot = 1;
          break;
        }
        pe[T_PE].fstcr[T_FSBA].mar += len;
      } while (--pe[T_PE].fstcr[T_FSBA].cr != 0xffff);

      pe[T_PE].fstcr[T_FSBA].intr = 1;
      break;

    case 0x04: /* write */
      if (pe[T_PE].fstcr[T_FSBA].api) {
        pe[T_PE].fstcr[T_FSBA].dter = 1;
        pe[T_PE].fstcr[T_FSBA].intr = 1;
        return;
      }
      if (pe[T_PE].fstcr[T_FSBA].berr) {
        pe[T_PE].fstcr[T_FSBA].beack = 1;
        pe[T_PE].fstcr[T_FSBA].intr = 1;
        return;
      }
      if ((len = 1 << (pe[T_PE].fstcr[T_FSBA].dtm & 3)) == 8) {
        pe[T_PE].fstcr[T_FSBA].beack = 1;
        pe[T_PE].fstcr[T_FSBA].intr = 1;
        return;
      }
      do {
        switch (sys_fop_access(t_pe,pe[T_PE].fstcr[T_FSBA].mar,len,_R_,&d)) {
        case RW_SUCCESS:
          break;

        case RW_BERR:
          pe[T_PE].fstcr[T_FSBA].beack = 1;
          break;

        case RW_TIMEOUT:
          pe[T_PE].fstcr[T_FSBA].tot = 1;
          break;
        }
        switch (len) {
        case 1:
          pe[T_PE].fstmem[T_FSBA][pe[T_PE].fstcr[T_FSBA].mar&(FSTMEM_SIZE-1)] = *(unsigned char *) &d;
          break;

        case 2:
          *(unsigned short *) &pe[T_PE].fstmem[T_FSBA][pe[T_PE].fstcr[T_FSBA].mar&(FSTMEM_SIZE-1)] = *(unsigned short *) &d;
          break;

        case 4:
          *(unsigned *) &pe[T_PE].fstmem[T_FSBA][pe[T_PE].fstcr[T_FSBA].mar&(FSTMEM_SIZE-1)] = d;
          break;
        }
        pe[T_PE].fstcr[T_FSBA].mar += len;
      } while (--pe[T_PE].fstcr[T_FSBA].cr != 0xffff);

      pe[T_PE].fstcr[T_FSBA].intr = 1;
      break;

    default:
      break;
    }
}

#endif

