static char SccsId[] = "@(#)ssumv.c	1.7    12/4/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* ssumv.c    90/12/20 */

#ifdef SSUMOVER

#include "tim.h"

sim_ssumv(t_pe)
    unsigned t_pe;
{
    unsigned scw0[4], scw1[4];
    unsigned i, j;
    unsigned ssa, ssal, lsa, len;
    unsigned d[2];

    if (pe[T_PE].ssu_delay_count) {
      if (!--pe[T_PE].ssu_delay_count) {
	pe[T_PE].mcr[SMSSW0].ful = 0;

        switch (sys_sop_access(t_pe, pe[T_PE].mcr[SMCA].ful, 16, _R_, scw0)) {
	case RW_SUCCESS: /* do ssu action */
          if (!ssu_fd) {
            pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x08; /* ssu not operational */
            pe[T_PE].mcr[SMIN].smin.exin = 1;
            goto exit_ssu_action;
          }

          switch (scw0[0] >> 24) {
          case 0x00: /* read ssu */
            i = 1;
            pe[T_PE].mcr[SMSSW1].ful = pe[T_PE].mcr[SMCA].ful+16;
	    for (;; i++, pe[T_PE].mcr[SMSSW1].ful += 16) {
              if (sys_sop_access(t_pe, pe[T_PE].mcr[SMSSW1].ful, 16, _R_, scw1) != RW_SUCCESS) {
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }

              len = (scw1[0] >> 8) & 0xfffff;

              if (len == 0 || len > 0x80000) {
                pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x04; /* invalid operation */
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }

              ssal = (pe[T_PE].mcr[SSAL].ssal.ssalh << 31)
                   + (pe[T_PE].mcr[SSAL].ssal.ssall << 16)
                   + 0xffff;
              ssa = scw1[1] & ~(SSU_ELEMENT_SIZE-1); /* scw1[0].bit25-31 is ignored (too large) */
              ssa += (pe[T_PE].mcr[SSAB].ssab.ssabh << 31)
                   + (pe[T_PE].mcr[SSAB].ssab.ssabl << 16);

              if (ssa > ssal || (unsigned) (ssa+len*SSU_ELEMENT_SIZE-1) > ssal
               || ssa >= ssu_elements*SSU_ELEMENT_SIZE || ssa+len*SSU_ELEMENT_SIZE-1 >= ssu_elements*SSU_ELEMENT_SIZE) {
                pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x01; /* ssu error status stored */
                pe[T_PE].mcr[SMSSW0].smssw0.s0excp = 0x80; /* ss0 access timeout exception */
                pe[T_PE].mcr[SMSSW0].smssw0.s1excp = 0x80; /* ss1 access timeout exception */
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }

              lsa = scw1[2] & ~(SSU_ELEMENT_SIZE-1);
              lseek(ssu_fd, ssa, L_SET);
              for (j=0; j < len; j++, lsa += SSU_ELEMENT_SIZE) {
                read(ssu_fd, d, SSU_ELEMENT_SIZE);
                if (sys_sop_access(t_pe, lsa, SSU_ELEMENT_SIZE, _W_, d) != RW_SUCCESS) {
             	  pe[T_PE].mcr[SMIN].smin.exin = 1;
                  goto exit_ssu_action;
                }
              }

              if (scw1[0] & 0x80000000) {
                pe[T_PE].mcr[SMSSW0].smssw0.cc = 0x80; /* completed */
                if (scw0[0] & 0x00800000)
                  pe[T_PE].mcr[SMIN].smin.mcin = 1;
                goto exit_ssu_action;
              }
              else if (pe[T_PE].ssu_stop_request) {
                pe[T_PE].ssu_stop_request = 0;
                goto exit_ssu_action;
              }
              else if (i >= 511) {
                pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x04; /* invalid operation */
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }
            } 
            break;

          case 0x40: /* write ssu */
            i = 1;
            pe[T_PE].mcr[SMSSW1].ful = pe[T_PE].mcr[SMCA].ful+16;
	    for (;; i++, pe[T_PE].mcr[SMSSW1].ful += 16) {
              if (sys_sop_access(t_pe, pe[T_PE].mcr[SMSSW1].ful, 16, _R_, scw1) != RW_SUCCESS) {
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }

              len = (scw1[0] >> 8) & 0xfffff;

              if (len == 0 || len > 0x80000) {
                pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x04; /* invalid operation */
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }

              ssal = (pe[T_PE].mcr[SSAL].ssal.ssalh << 31)
                   + (pe[T_PE].mcr[SSAL].ssal.ssall << 16)
                   + 0xffff;
              ssa = scw1[1] & ~(SSU_ELEMENT_SIZE-1); /* scw1[0].bit25-31 is ignored (too large) */
              ssa += (pe[T_PE].mcr[SSAB].ssab.ssabh << 31)
                   + (pe[T_PE].mcr[SSAB].ssab.ssabl << 16);

              if (ssa > ssal || (unsigned) (ssa+len*SSU_ELEMENT_SIZE-1) > ssal
               || ssa >= ssu_elements*SSU_ELEMENT_SIZE || ssa+len*SSU_ELEMENT_SIZE-1 >= ssu_elements*SSU_ELEMENT_SIZE) {
                pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x01; /* ssu error status stored */
                pe[T_PE].mcr[SMSSW0].smssw0.s0excp = 0x80; /* ss0 access timeout exception */
                pe[T_PE].mcr[SMSSW0].smssw0.s1excp = 0x80; /* ss1 access timeout exception */
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }

              lsa = scw1[2] & ~(SSU_ELEMENT_SIZE-1);
              lseek(ssu_fd, ssa, L_SET);
              for (j=0; j < len; j++, lsa += SSU_ELEMENT_SIZE) {
                if (sys_sop_access(t_pe, lsa, SSU_ELEMENT_SIZE, _R_, d) != RW_SUCCESS) {
                  pe[T_PE].mcr[SMIN].smin.exin = 1;
                  goto exit_ssu_action;
                }
                write(ssu_fd, d, SSU_ELEMENT_SIZE);
              }

              if (scw1[0] & 0x80000000) {
                pe[T_PE].mcr[SMSSW0].smssw0.cc = 0x80; /* completed */
                if (scw0[0] & 0x00800000)
                  pe[T_PE].mcr[SMIN].smin.mcin = 1;
                goto exit_ssu_action;
              }
              else if (pe[T_PE].ssu_stop_request) {
                pe[T_PE].ssu_stop_request = 0;
                goto exit_ssu_action;
              }
              else if (i >= 511) {
                pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x04; /* invalid operation */
                pe[T_PE].mcr[SMIN].smin.exin = 1;
                goto exit_ssu_action;
              }
            }
            break;

          case 0x10: /* compare and swap */
            pe[T_PE].mcr[SMSSW1].ful = pe[T_PE].mcr[SMCA].ful+16;
            if (sys_sop_access(t_pe, pe[T_PE].mcr[SMSSW1].ful, 16, _R_, scw1) != RW_SUCCESS) {
              pe[T_PE].mcr[SMIN].smin.exin = 1;
              goto exit_ssu_action;
            }

            ssal = (pe[T_PE].mcr[SSAL].ssal.ssalh << 31)
                 + (pe[T_PE].mcr[SSAL].ssal.ssall << 16)
                 + 0xffff;
            ssa = scw1[1] & ~(SSU_ELEMENT_SIZE-1); /* scw1[0].bit25-31 is ignored (too large) */
            ssa += (pe[T_PE].mcr[SSAB].ssab.ssabh << 31)
                 + (pe[T_PE].mcr[SSAB].ssab.ssabl << 16);

            if (ssa > ssal || ssa >= ssu_elements*SSU_ELEMENT_SIZE) {
              pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x01; /* ssu error status stored */
              pe[T_PE].mcr[SMSSW0].smssw0.s0excp = 0x80; /* ss0 accss timeout exception */
              pe[T_PE].mcr[SMSSW0].smssw0.s1excp = 0x80; /* ss1 accss timeout exception */
              pe[T_PE].mcr[SMIN].smin.exin = 1;
              goto exit_ssu_action;
            }

            lseek(ssu_fd, ssa, L_SET);
            read(ssu_fd, d, SSU_ELEMENT_SIZE);
	    pe[T_PE].mcr[SMRDU].ful = d[0];
	    pe[T_PE].mcr[SMRDL].ful = d[1];
            if (scw0[2] == d[0] && scw0[3] == d[1]) {
              d[0] = scw1[2];
	      d[1] = scw1[3];
              lseek(ssu_fd, ssa, L_SET);
              write(ssu_fd, d, SSU_ELEMENT_SIZE);
              pe[T_PE].mcr[SMSSW0].smssw0.cc = 0x50; /* same */
            }
            else
              pe[T_PE].mcr[SMSSW0].smssw0.cc = 0x58; /* different */

            if (scw0[0] & 0x00800000)
              pe[T_PE].mcr[SMIN].smin.mcin = 1;
            if (pe[T_PE].ssu_stop_request)
              pe[T_PE].ssu_stop_request = 0;
            goto exit_ssu_action;

            break;

          default: /* reserved */
            pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x04; /* invalid operation */
            pe[T_PE].mcr[SMIN].smin.exin = 1;
            break;
          }
          break;

        case RW_BERR:
          pe[T_PE].mcr[SMIN].smin.exin = 1;
	  break;

	case RW_TIMEOUT:
          pe[T_PE].mcr[SMIN].smin.exin = 1;
	  break;
        }

exit_ssu_action:
        pe[T_PE].mcr[SMST].smst.busy = 0;
        if (pe[T_PE].mcr[SMIN].ful)
          pe[T_PE].ssumv_status = STATUS_SINTR;
        else
          pe[T_PE].ssumv_status = STATUS_SSLEEP;
      }
    }

    if (pe[T_PE].smcr[SMCTL].ful) { /* get start command */
      if (pe[T_PE].ssumv_status == STATUS_SSLEEP) {
        pe[T_PE].ssumv_status = STATUS_SBUSY;
        pe[T_PE].ssu_delay_count = SSU_DMA_DELAY;
        pe[T_PE].ssu_stop_request = 0;
        pe[T_PE].mcr[SMST].smst.busy = 1;
        pe[T_PE].mcr[SMSSW0].ful = 0xffffffff;
        pe[T_PE].mcr[SMSSW1].ful = 0xffffffff;
        pe[T_PE].mcr[SMRDU].ful  = 0xffffffff;
        pe[T_PE].mcr[SMRDL].ful  = 0xffffffff;
      }
      pe[T_PE].smcr[SMCTL].ful = 0;
    }

    if (pe[T_PE].smcr[SMSTP].ful) { /* get stop command */
      if (pe[T_PE].ssumv_status == STATUS_SBUSY)
        pe[T_PE].ssu_stop_request = 1;
      pe[T_PE].smcr[SMSTP].ful = 0;
    }

    if (pe[T_PE].smcr[SMCLR].ful) { /* get clear command */
      pe[T_PE].ssumv_status = STATUS_SSLEEP;
      pe[T_PE].ssu_delay_count = 0;
      pe[T_PE].ssu_stop_request = 0;
      pe[T_PE].mcr[SMST].smst.busy = 0;
      pe[T_PE].mcr[SMCA].ful   = 0;
      pe[T_PE].mcr[SMIN].ful   = 0;
      pe[T_PE].mcr[SMSSW0].ful = 0;
      pe[T_PE].mcr[SMSSW1].ful = 0;
      pe[T_PE].mcr[SMRDU].ful  = 0;
      pe[T_PE].mcr[SMRDL].ful  = 0;
      pe[T_PE].ext_interrupt &= ~SSU_INTERRUPT;
      pe[T_PE].smcr[SMCLR].ful = 0;
    }

    else if (pe[T_PE].mcr[SMIN].ful)
      pe[T_PE].ext_interrupt |= SSU_INTERRUPT;
}

#endif

