static char SccsId[] = "@(#)tco.c	1.12(7/21/94)";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

#include <stdio.h>
#include <termios.h>
#include <signal.h>
#include <sys/times.h>
#include <sys/file.h>
#include <fcntl.h>
#include <sys/ioctl_compat.h>
#include <sys/signal.h>

/* tco.c    90/8/19    by Y.Nakashima */

#define BUFFLEN     (1024)
#define BUFFMARGINE (80)
#define CSTRLEN     (20)
#define SVFWBYTE    (256)
#define SVFWWORD    (SVFWBYTE/4)
#define SAPCMAXX    (79)
#define SAPCMAXY    (23)
#define SAPCIMAGE   ((SAPCMAXX+1)*(SAPCMAXY+1))
#define MAXXBYTE    (16)
#define MAXXWORD    (MAXXBYTE/4)
#define MAXYLINE    (SVFWBYTE/MAXXBYTE)
#define MAXCURX     (MAXXBYTE*2-1)
#define MAXCURY     (MAXYLINE-1)
#define putstr(s)        { write(0, s, strlen(s)); }
#define putcha(i)        { *mbuf = i; write(0, mbuf, 1); }
#define tohex(c)         ( (c)<'a'?(c)-'0':(c)-'a'+10 )
#define clearmessage2()  { putstr("\033[19;1H\033[0J"); }
#define printmessage2(a) { sprintf(mbuf,"\033[19;1H\033[32;7m%s\033[0m",a); putstr(mbuf); }
#define clearmessage3()  { putstr("\033[26;1H\033[0J"); }
#define printmessage3(a) { sprintf(mbuf,"\033[26;1H\033[32;7m%s\033[0m",a); putstr(mbuf); }
#define printmessages(a) { sprintf(mbuf,"\033[26;1H\033[36;4m%s\033[0m",a); putstr(mbuf); }
#define clearscr()       { putstr("\033[1;1H\033[0J"); }
#define savecurs()       { putstr("\0337"); }
#define restcurs()       { putstr("\0338"); }
#define column1(y)       { sprintf(mbuf,"\033[%d;1H", (y)+2); putstr(mbuf); }
#define column2(y)       { sprintf(mbuf,"\033[%d;41H",(y)+2); putstr(mbuf); }
#define locate2(x,y)     { sprintf(mbuf,"\033[%d;%dH",(y)+2,(x)+((x)/8)+5); putstr(mbuf); }
#define echo2(x,y,i)     { sprintf(mbuf,"\033[%d;%dH%c",(y)+2,(x)+((x)/8)+5,i); putstr(mbuf); }
#define locate3(x,y)     { sprintf(mbuf,"\033[%d;%dH",(y)+2,(x)+1); putstr(mbuf); }
#define echo3(x,y,i)     { sprintf(mbuf,"\033[%d;%dH%c",(y)+2,(x)+1,i); putstr(mbuf); }

int            mode = 1;         /* 0:do nothing,      1:logical-console */
 				 /* 2:svpfirm-monitor, 3:tmpsapc-monitor */
int	       lock = 0;	 /* 0:unlocked         1:locked */
int	       pfd[2];		 /* PIPE */
int	       fd1, fd2;	 /* coin, cout */
int            ppid, pid;	 /* process ID */
unsigned       svfw[SVFWBYTE/4]; /* SVFW request block */
unsigned char  mbuf[BUFFLEN  ];  /* message buffer */
unsigned       cbuf[BUFFLEN/4];  /* communication buffer */
unsigned char  *ccbuf = (unsigned char*)cbuf;
char	       sapc[SAPCIMAGE];	 /* SAPC console image */
char	       aid;		 /* SAPC attention */
char	       curx, cury;	 /* cursor position */

swap4(x) unsigned x;
{
  return (((x)<<24)|(((x)&0xff00)<<8)|(((x)&0xff0000)>>8)|((x)>>24));
}

main(argc, argv) int argc; char **argv;
{

    int            onintr_con();
    struct sgttyb  termiosArg;
    int            retval, i, j;

    if (argc != 4) {
        fprintf(stderr, "usage: %s <tim's pid> <kbd_file> <display_file>\n", argv[0]);
        exit(0);
    }

    printf("connecting TaChyon/KAI simulator...\n");

    if (sscanf(argv[1],"%d",&ppid) != 1) {
        fprintf(stderr, "illegal tim's pid\n", argv[1]);
        exit(0);
    }
    if ((fd1=open(argv[3], O_RDONLY)) == -1) {
        fprintf(stderr, "can't open %s\n", argv[3]);
        exit(0);
    }
    if ((fd2=open(argv[2], O_WRONLY)) == -1) {
        fprintf(stderr, "can't open %s\n", argv[2]);
        exit(0);
    }
    if (pipe(pfd) == -1) {
        fprintf(stderr, "can't create pipe\n");
        exit(0);
    }

    printf("PSEUDO CONSOLE full-duplex connection established.\n\n");
    printf("If you use FMR/FMG, type \"^A^A\" to toggle CONSOLE/SIMULATOR window.\n");

    if (pid = fork()) {
      struct termios old_stty, new_stty;
      tcgetattr(1, &old_stty);
      tcgetattr(1, &new_stty);
      new_stty.c_lflag &= ~ICANON;
      new_stty.c_lflag |= ISIG;
      new_stty.c_lflag &= ~ECHO;
      new_stty.c_cc[VMIN] = 0;
      new_stty.c_cc[VTIME] = 0;
      tcsetattr(1, TCSANOW, &new_stty);

        while(retval = read(fd1, ccbuf, 1)) {

            if (retval == -1)
              continue;

            if (*ccbuf == '%') {
              for (i=0; i<CSTRLEN; i++) {
	        if (read(fd1, ccbuf+i, 1) != 1)
	          goto exit_console;
              }

              if      (!strncmp(ccbuf, "mode-logical-console", CSTRLEN)) {
	        clearscr();
	        putstr("<<< logical-console mode >>>\r\n");
                write(pfd[1], "%M1", 3);
	        kill(pid, SIGUSR1);
              }

              else if (!strncmp(ccbuf, "mode-svpfirm-monitor", CSTRLEN)) {
	        clearscr();
		putstr("<<< svpfirm-monitor mode >>>");
		for (i=0; i<SVFWWORD; i+=MAXXWORD) {
		  column1(i/MAXXWORD);
		  sprintf(mbuf, "%02.2X: %08.8X %08.8X %08.8X %08.8X",
		    i*MAXXWORD, swap4(svfw[i]), swap4(svfw[i+1]), swap4(svfw[i+2]), swap4(svfw[i+3]));
		  putstr(mbuf);
                }
                write(pfd[1], "%M2", 3);
	        kill(pid, SIGUSR1);
              }

              else if (!strncmp(ccbuf, "mode-tmpsapc-monitor", CSTRLEN)) {
	        clearscr();
		putstr("<<< tmpsapc-monitor mode >>>");
                write(pfd[1], "%M3", 3);
	        kill(pid, SIGUSR1);
              }

              else if (!strncmp(ccbuf, "stat-leading-sapcwrt", CSTRLEN)) {
		savecurs();
	        if (read(fd1, sapc, SAPCIMAGE) != SAPCIMAGE)
	          goto exit_console;
                for (i=0; i<SAPCIMAGE; i++) {
                  if (i%(SAPCMAXX+1) == 0)
		    locate3(0, i/(SAPCMAXX+1));
                  switch (sapc[i]) {
                  case '`': putstr("\033[0m \033[37;4m"); break;
                  case 'd': putstr("\033[0m \033[37;7m"); break;
                  case 'h': putstr("\033[0m \033[37;7m"); break;
                  case 'l': putstr("\033[0m \033[37;4m"); break;
                  case 'a': putstr("\033[0m \033[31;4m"); break;
                  case 'e': putstr("\033[0m \033[31;7m"); break;
                  case 'i': putstr("\033[0m \033[31;7m"); break;
                  case 'm': putstr("\033[0m \033[31;4m"); break;
                  case 'b': putstr("\033[0m \033[32m"); break;
                  case 'f': putstr("\033[0m \033[32;7m"); break;
                  case 'j': putstr("\033[0m \033[32;7m"); break;
                  case 'n': putstr("\033[0m \033[32m"); break;
                  case 'c': putstr("\033[0m \033[31m"); break;
                  case 'g': putstr("\033[0m \033[31;7m"); break;
                  case 'k': putstr("\033[0m \033[31;7m"); break;
                  case 'o': putstr("\033[0m \033[31m"); break;
                  default:
                    putcha(sapc[i] & 0x7f);
                    break;
                  }
                }
                putstr("\033[0m");
		restcurs();
                write(pfd[1], "%M5", 3);
                write(pfd[1], sapc, SAPCIMAGE);
		kill(pid, SIGUSR1);
              }

              else if (!strncmp(ccbuf, "stat-leading-sapcred", CSTRLEN)) {
                write(pfd[1], "%M6", 3);
		kill(pid, SIGUSR1);
              }

              else if (!strncmp(ccbuf, "stat-leading-prtsvfw", CSTRLEN)) {
		savecurs();
		for (i=0; i<SVFWWORD; i+=MAXXWORD) {
                  for (j=0; j<MAXXBYTE; j++) {
	            if (read(fd1, ccbuf+j, 1) != 1)
	              goto exit_console;
                  }
	          column2(i/MAXXWORD);
		  sprintf(mbuf, "%02.2X: %08.8X %08.8X %08.8X %08.8X",
		    i*MAXXWORD, swap4(cbuf[0]), swap4(cbuf[1]), swap4(cbuf[2]), swap4(cbuf[3]));
                  putstr(mbuf);
                }
		restcurs();
              }

              else if (!strncmp(ccbuf, "stat-leading-prtmess", CSTRLEN)) {
		savecurs();
		for (i=0; i<BUFFLEN-BUFFMARGINE; i++) {
	          if (read(fd1, ccbuf+i, 1) != 1)
	            goto exit_console;
                  if (ccbuf[i] == '&')
                    break;
                }
		if (i > 0) {
                  ccbuf[i] = 0;
                  printmessages(ccbuf);
                }
		restcurs();
              }

              else {
	        clearscr();
	        putstr("Undefined mode-control\r\n");
                putstr("  specify %mode-logical-console\r\n");
                putstr("  or      %mode-svpfirm-monitor\r\n");
                putstr("  or      %mode-svpsapc-monitor");
              }
            }

            else {
              write(1, ccbuf, 1);
            }
        }

	tcsetattr(1, TCSANOW, &old_stty);
        kill(pid, SIGTERM);

	printf("\033[1;1H\033[2J");
        printf("PSEUDO CONSOLE closed.\n");

        exit(0);
    }
    else {
      struct termios old_stty, new_stty;
      fd_set rfds;
      struct timeval tv;

      tcgetattr(0, &old_stty);
      tcgetattr(0, &new_stty);
      new_stty.c_lflag &= ~ICANON;
      new_stty.c_lflag |= ISIG;
      new_stty.c_lflag &= ~ECHO;
      new_stty.c_cc[VMIN] = 0;
      new_stty.c_cc[VTIME] = 0;
      tcsetattr(0, TCSANOW, &new_stty);

        signal(SIGUSR1, SIG_IGN);
        signal(SIGUSR1, onintr_con);

	while (1) {
	  FD_ZERO(&rfds);
	  FD_SET(0, &rfds); /* stdin ƻFDɲ */
	  tv.tv_sec = 0;
	  tv.tv_usec = 0;
	  if (select(1, &rfds, 0, 0, &tv) == 1) { /* Ϥ */

	    retval = read(0, ccbuf, 1);
	  
            if (retval == -1)
              continue;

	    switch (mode) {
            case 1: /* raw mode with ext_intr */
              write(fd2, ccbuf, 1);
	      kill(ppid, SIGUSR1);
              break;

            case 2: /* firmware mode with fxt_intr */
              clearmessage2();

              switch (*ccbuf) {
	      case '0': /* enter 0 */
	      case '1': /* enter 1 */
	      case '2': /* enter 2 */
	      case '3': /* enter 3 */
	      case '4': /* enter 4 */
	      case '5': /* enter 5 */
	      case '6': /* enter 6 */
	      case '7': /* enter 7 */
	      case '8': /* enter 8 */
	      case '9': /* enter 9 */
	      case 'a': /* enter a */
	      case 'b': /* enter b */
	      case 'c': /* enter c */
	      case 'd': /* enter d */
	      case 'e': /* enter e */
	      case 'f': /* enter f */
		svfw[cury*MAXXWORD+curx/8] &= ~((unsigned)0xf0000000          >> ((curx%8)*4));
		svfw[cury*MAXXWORD+curx/8] |=  ((unsigned)(tohex(*ccbuf)<<28) >> ((curx%8)*4));
		echo2(curx, cury, *ccbuf<'a'?*ccbuf:*ccbuf-'a'+'A');
	      case ' ': /* right */
	      case 'l': /* right */
                if (++curx > MAXCURX) { curx = 0; if (++cury > MAXCURY) cury = 0; }
		break;

	      case 'h': /* left */
                if (--curx < 0) { curx = MAXCURX; if (--cury < 0) cury = MAXCURY; }
		break;

	      case 'j': /* down */
                if (++cury > MAXCURY) cury = 0;
		break;

	      case 'k': /* up */
                if (--cury < 0) cury = MAXCURY;
		break;

	      case '\t': /* next word */
                if ((curx = (curx&~7)+8) > MAXCURX) {
		    curx = 0; if (++cury > MAXCURY) cury = 0;
                }
		break;

	      case '\b': /* previous word */
                if ((curx = (curx&~7)-8) < 0) {
		  curx = MAXCURX-7; if (--cury < 0) cury = MAXCURY;
                }
		break;

              case 'P'-'@': /* cntl-P */
                write(fd2, "%R2", 3);
                write(fd2, (char*)svfw, SVFWBYTE);
	        kill(ppid, SIGUSR2);
                printmessage2("SVFWRP is sent to FIRM");
                break;

              case 'L'-'@': /* cntl-L */
	        clearscr();
		putstr("<<< svpfirm-monitor mode >>>");
		for (i=0; i<SVFWWORD; i+=MAXXWORD) {
		  column1(i/MAXXWORD);
		  sprintf(mbuf, "%02.2X: %08.8X %08.8X %08.8X %08.8X",
		    i*MAXXWORD, swap4(svfw[i]), swap4(svfw[i+1]), swap4(svfw[i+2]), swap4(svfw[i+3]));
		  putstr(mbuf);
                }
                break;

	      default:
                printmessage2("undefined key (only h,j,k,l,\\t,\\b,^P,^L)");
                break;
              }
	      locate2(curx, cury);
              break;

            case 3: /* tmpsapc-monitor mode with DAPF */
              if (lock) {
		savecurs();
                printmessage3("\007XXXX locked XXXX");
		restcurs();
                continue;
              }

              clearmessage3();

              switch (*ccbuf) {
	      case 'L'-'@': /* right */
                if (++curx > SAPCMAXX) { curx = 0; if (++cury > SAPCMAXY) cury = 0; }
		break;

	      case 'H'-'@': /* left */
                if (--curx < 0) { curx = SAPCMAXX; if (--cury < 0) cury = SAPCMAXY; }
		break;

	      case 'J'-'@': /* down */
                if (++cury > SAPCMAXY) cury = 0;
		break;

	      case 'K'-'@': /* up */
                if (--cury < 0) cury = SAPCMAXY;
		break;

	      case 'Z'-'@': /* next input field */
		i = j = (curx+cury*(SAPCMAXX+1)+SAPCIMAGE-1) % SAPCIMAGE;
		while ((i = (i+1) % SAPCIMAGE) != j) {
                  if (sapc[i] == '`' || sapc[i] == 'd' || sapc[i] == 'h'
                   || sapc[i] == 'a' || sapc[i] == 'e' || sapc[i] == 'i')
		    break;
		}
                if (i != j) {
		  curx = (i+1)%(SAPCMAXX+1);
		  cury = (i+1)/(SAPCMAXX+1);
                }
		break;

	      case 'X'-'@': /* previous input field */
		i = j = (curx+cury*(SAPCMAXX+1)+SAPCIMAGE-1) % SAPCIMAGE;
		while ((i = (i+SAPCIMAGE-1) % SAPCIMAGE) != j) {
                  if (sapc[i] == '`' || sapc[i] == 'd' || sapc[i] == 'h'
                   || sapc[i] == 'a' || sapc[i] == 'e' || sapc[i] == 'i')
		    break;
		}
                if (i != j) {
		  curx = (i+1)%(SAPCMAXX+1);
		  cury = (i+1)/(SAPCMAXX+1);
                }
		break;

              case 'M'-'@': /* return */
                aid = 0;
		goto attention;
                break;

              case 'Q'-'@': /* PF1 */
                aid = 1;
		goto attention;
                break;

              case 'W'-'@': /* PF2 */
                aid = 2;
		goto attention;
                break;

              case 'E'-'@': /* PF3 */
                aid = 3;
		goto attention;
                break;

              case 'R'-'@': /* PF4 */
                aid = 4;
		goto attention;
                break;

              case 'T'-'@': /* PF5 */
                aid = 5;
		goto attention;
                break;

              case 'Y'-'@': /* PF6 */
                aid = 6;
		goto attention;
                break;

              case 'U'-'@': /* PF7 */
                aid = 7;
		goto attention;
                break;

              case 'I'-'@': /* PF8 */
                aid = 8;
		goto attention;
                break;

              case 'O'-'@': /* PF9 */
                aid = 9;
		goto attention;
                break;

              case 'P'-'@': /* PF10 */
                aid = 10;
		goto attention;
                break;

              case '['-'@': /* PF11 */
                aid = 11;
		goto attention;
                break;

              case ']'-'@': /* PF12 */
                aid = 12;
attention:
		lock = 1;
                write(fd2, "%R4", 3);
                kill(ppid, SIGUSR2);
                break;

	      default: /* character */
                if (*ccbuf >= 0x20 && *ccbuf <= 0x7e) {
                  if (sapc[curx+cury*(SAPCMAXX+1)] <= 0x5f) {
                    sapc[curx+cury*(SAPCMAXX+1)] = *ccbuf | 0x80;
	            echo3(curx, cury, *ccbuf);
                    if (++curx > SAPCMAXX) { curx = 0; if (++cury > SAPCMAXY) cury = 0; }
                  }
                  else {
		    savecurs();
                    printmessage3("\007XXXX protected XXXX");
		    restcurs();
                  }
                }
		break;
              }
	      locate3(curx, cury);
              break;
            }
	  }
	}

exit_console:

        tcsetattr(0, TCSANOW, &old_stty);

        exit(0);
    }
}

onintr_con()
{
    int i, j;
    char buf;

    if (read(pfd[0], &buf, 1) != 1
     || buf != '%' || read(pfd[0], &buf, 1) != 1
     || buf != 'M' || read(pfd[0], &buf, 1) != 1) {
      printmessages("lost %%M preamble for console->console");
      goto exit_onintr_con;
    }

    switch (buf) {
    case '1': /* logical-console */
      mode = 1;
      break;

    case '2': /* svpfirm-monitor */
      mode = 2;
      curx = 0;
      cury = 0;
      locate2(curx, cury);
      break;

    case '3': /* tmpsapc-monitor(transit) */
      mode = 3;
      for (i=0; i<SAPCIMAGE; i++)
        sapc[i] = ' ';
      curx = 0;
      cury = 0;
      locate3(curx, cury);
      break;

    case '5': /* tmpsapc-monitor(write) */
      lock = 0;
      clearmessage3();
      if (read(pfd[0], sapc, SAPCIMAGE) != SAPCIMAGE) {
        printmessages("lost SAPC data for console->console");
        goto exit_onintr_con;
      }
      i = j = SAPCIMAGE-1;
      { int tmp=SAPCIMAGE;
      while ((i = (i+1) % tmp) != j) {
        if (sapc[i] == '`' || sapc[i] == 'd' || sapc[i] == 'h'
         || sapc[i] == 'a' || sapc[i] == 'e' || sapc[i] == 'i')
        break;
      }
      }
      if (i != j) {
	curx = (i+1)%(SAPCMAXX+1);
	cury = (i+1)/(SAPCMAXX+1);
	locate3(curx, cury);
      }
      break;

    case '6': /* tmpsapc-monitor(read) */
      write(fd2, "%R6", 3);
      write(fd2, &aid,  1);
      curx++;
      cury++;
      write(fd2, &cury, 1); /* line */
      write(fd2, &curx, 1); /* column */
      curx--;
      cury--;
      write(fd2, sapc, SAPCIMAGE);
      kill(ppid, SIGUSR2);
      break;
    }

exit_onintr_con:
    signal(SIGUSR1, onintr_con);
}

