static char SccsId[] = "@(#)userdapf.c	1.2    9/28/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* userdapf.c    93/9/27 */

#ifdef DAPF

#define	_R_ 4
#define _W_ 2

/*									*/
/* Prepared functions are as follows.					*/
/*									*/
/* ---Functions---							*/
/*									*/
/*     cmd_gr_access(t_pe, num, _R_/_W_, *d)				*/
/*     cmd_fr_access(t_pe, num, _R_/_W_, *d1, *d2)			*/
/*     cmd_sr_access(t_pe, num, _R_/_W_, *d)				*/
/*     cmd_tod_access(t_pe, _R_/_W_, *d1, *d2)				*/
/*     cmd_mcr_access(t_pe, addr, len, _R_/_W_, *d)			*/
/*     cmd_mem_access(t_pe, 'v'/'r', addr, len, _R_/_W_, *d, 'y'/'n')	*/
/*     cmd_ext_interrupt(t_pe, level)					*/
/*									*/
/* ---Parameters---							*/
/*									*/
/*     unsigned t_pe;	: PE#						*/
/*     unsigned num;	: register number				*/
/*     unsigned addr;	: mcr/memory address				*/
/*              'v'	: virtual address				*/
/*              'r'	: real address					*/
/*     unsigned len;	: access length					*/
/*              _R_	: read access					*/
/*              _W_	: write access					*/
/*     unsigned *d;	: word						*/
/*     unsigned *d1;	: upper word					*/
/*     unsigned *d2;	: lower word					*/
/*              'y'	: ignore write protection (ste, pte, HSA)	*/
/*              'n'	: obey protection (ste, pte, HSA)		*/
/*     unsigned level;	: interrupt level (1-15)			*/
/*									*/
/* ---Return value---							*/
/*									*/
/*     none 								*/
/*									*/

user_dapf(t_pe, cmd, daprba)
    unsigned  t_pe, cmd, daprba;
{

    /* your codes here */

    /* sample */

    switch (cmd) {
    case 0xed00: /* Read system status */
    case 0xed01: /* Read detailed PE status */
    case 0xed50: /* Set PEPA Event Select Register */
    case 0xed51: /* Get PEPA Result */
      addsvpmes("PE#%u: DAPF command 0x%04.4X do nothing\n", t_pe, cmd);
      break;
    default:
      addsvpmes("PE#%u: unknown DAPF command 0x%04.4X (in DAPRB)\n", t_pe, cmd);
      break;
    }
}

#endif

