/* @(#)vp-decode.h	1.2    10/29/91 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/*
 * vp-decode.h - mnemonic table
 */

enum vp_operation_type
{
        O_NL,
        O_VL,  /* VP LOAD           */
        O_VLI, /* VP LOAD INDIRECT  */
        O_VS,  /* VP STORE          */
        O_VSI, /* VP STORE INDIRECT */
        O_VA,  /* VP ADD            */
        O_VM,  /* VP MULT           */
        O_VD,  /* VP DIVIDE         */
        O_VK,  /* VP MASK           */
        O_VN,  /* VP NO-PIPELINE    */
};

static struct vp_opcode
{
     /* char *name               ; */
	int  (*func)()           ;
	char  type               ;
	char  v                  ; /* 0: vcr1.v  must 1 */
	char  rx                 ; /* 1: vcr0.rx must 0 */
	char  p                  ; /* 1: privileged    */
	unsigned r_type_mask  : 6;
	unsigned r_type_match : 6;
	unsigned r_use_mask   : 5;
	unsigned r_use_match  : 5;
};

int	o_vnm(), o_vom(), o_vxm(), o_vtm();
int	o_vil(), o_vist();
int	o_vn(), o_vo(), o_vx(), o_vesll();
int	o_va(), o_vs(), o_vm();
int	o_vlr(), o_vlp();

int	o_vilX(), o_vistX();
int	o_vviX(), o_vvXi(), o_vvX();
int	o_vaX(), o_vsX(), o_vmX(), o_vdX();
int	o_vlpX();
int	o_vc(), o_vcX(), o_vcs(), o_vcsX();
int	o_vlm(), o_vstm();
int	o_vgm();
int	o_vgs();
int	o_vl(), o_vst(), o_vlcp(), o_vstx();
int	o_vns(), o_vos(), o_vxs();
int	o_vas(), o_vss(), o_vms();
int	o_vls();
int	o_vlX(), o_vstX(), o_vlcpX(), o_vstxX();
int	o_vsrl();
int	o_vasX(), o_vssX(), o_vmsX(), o_vdsX();
int	o_vlsX();
int	o_vsll();
int	o_vplcr();
int	o_vpscr();
int	o_vlvt();
int	o_vsvt();
int	o_vsmm();
int	o_vfm();
int	o_vfmx();
int	o_vltr();
int	o_vts();
int	o_vsm();
int	o_vfX();
int	o_vlcr();
int	o_vscr();
int	o_vtsX();
int	o_vsmX();
int	o_vfXX();
int	o_vpt();
int	o_vlvl();
int	o_vlvlf();

static struct vp_opcode oper_vp[] = {
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vnm"    */ {    o_vnm,     O_VK,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vom"    */ {    o_vom,     O_VK,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vxm"    */ {    o_vxm,     O_VK,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vtm"    */ {    o_vtm,     O_VK,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "vil"    */ {    o_vil,     O_VLI,	0,  0,	0,	0x00,	0x00,	0x0f,	0x08 },
/* "vist"   */ {    o_vist,    O_VSI,	0,  0,	0,	0x00,	0x00,	0x0f,	0x08 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vn"     */ {    o_vn,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vo"     */ {    o_vo,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vx"     */ {    o_vx,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vesll"  */ {    o_vesll,   O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "va"     */ {    o_va,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vs"     */ {    o_vs,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vm"     */ {    o_vm,      O_VM,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vlr"    */ {    o_vlr,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vlp"    */ {    o_vlp,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "vild"   */ {    o_vilX,    O_VLI,	0,  0,	0,	0x00,	0x00,	0x0f,	0x08 },
/* "vistd"  */ {    o_vistX,   O_VSI,	0,  0,	0,	0x00,	0x00,	0x0f,	0x08 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vvid"   */ {    o_vviX,    O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vvdi"   */ {    o_vvXi,    O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vved"   */ {    o_vvX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vad"    */ {    o_vaX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vsd"    */ {    o_vsX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vmd"    */ {    o_vmX,     O_VM,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vdd"    */ {    o_vdX,     O_VD,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vlpd"   */ {    o_vlpX,    O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "vile"   */ {    o_vilX,    O_VLI,	0,  0,	0,	0x00,	0x00,	0x0f,	0x08 },
/* "viste"  */ {    o_vistX,   O_VSI,	0,  0,	0,	0x00,	0x00,	0x0f,	0x08 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vvie"   */ {    o_vviX,    O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vvei"   */ {    o_vvXi,    O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vvde"   */ {    o_vvX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vae"    */ {    o_vaX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vse"    */ {    o_vsX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vme"    */ {    o_vmX,     O_VM,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vde"    */ {    o_vdX,     O_VD,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vlpe"   */ {    o_vlpX,    O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },


/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "vcf"    */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vch"    */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcl"    */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcne"   */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vce"    */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcnl"   */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcnh"   */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vct"    */ {    o_vc,      O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcsf"   */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vcsh"   */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vcsl"   */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vcsne"  */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vcse"   */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vcsnl"  */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vcsnh"  */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vcst"   */ {    o_vcs,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },

/* "vcfd"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vchd"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcld"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcned"  */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vced"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcnld"  */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcnhd"  */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vctd"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcsfd"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcshd"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsld"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsned" */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsed"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsnld" */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsnhd" */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcstd"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },

/* "vcfe"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vche"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcle"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcnee"  */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcee"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcnle"  */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcnhe"  */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcte"   */ {    o_vcX,     O_VA,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "vcsfe"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcshe"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsle"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsnee" */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsee"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsnle" */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcsnhe" */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vcste"  */ {    o_vcsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },


/* "vlm"    */ {    o_vlm,     O_VL,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vstm"   */ {    o_vstm,    O_VS,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vgm"    */ {    o_vgm,     O_VK,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vgs"    */ {    o_vgs,     O_VM,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "vl"     */ {    o_vl,      O_VL,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vst"    */ {    o_vst,     O_VS,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vlcp"   */ {    o_vlcp,    O_VL,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vstx"   */ {    o_vstx,    O_VS,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vns"    */ {    o_vns,     O_VA,	0,  0,	0,	0x30,	0x10,	0x0f,	0x04 },
/* "vos"    */ {    o_vos,     O_VA,	0,  0,	0,	0x30,	0x10,	0x0f,	0x04 },
/* "vxs"    */ {    o_vxs,     O_VA,	0,  0,	0,	0x30,	0x10,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vas"    */ {    o_vas,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vss"    */ {    o_vss,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vms"    */ {    o_vms,     O_VM,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vls"    */ {    o_vls,     O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "vld"    */ {    o_vlX,     O_VL,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vstd"   */ {    o_vstX,    O_VS,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vlcpd"  */ {    o_vlcpX,   O_VL,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vstxd"  */ {    o_vstxX,   O_VS,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vsrl"   */ {    o_vsrl,    O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vasd"   */ {    o_vasX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vssd"   */ {    o_vssX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vmsd"   */ {    o_vmsX,    O_VM,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vdsd"   */ {    o_vdsX,    O_VD,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vlsd"   */ {    o_vlsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "vle"    */ {    o_vlX,     O_VL,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vste"   */ {    o_vstX,    O_VS,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vlcpe"  */ {    o_vlcpX,   O_VL,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "vstxe"  */ {    o_vstxX,   O_VS,	0,  0,	0,	0x30,	0x00,	0x0f,	0x0c },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vsll"   */ {    o_vsll,    O_VA,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vase"   */ {    o_vasX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vsse"   */ {    o_vssX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vmse"   */ {    o_vmsX,    O_VM,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "vdse"   */ {    o_vdsX,    O_VD,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vlse"   */ {    o_vlsX,    O_VA,	0,  0,	0,	0x30,	0x20,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },


/* "vplcr"  */ {    o_vplcr,   O_VN,	1,  0,	1,	0x30,	0x00,	0x0f,	0x04 },
/* "vpscr"  */ {    o_vpscr,   O_VN,	1,  0,	1,	0x03,	0x00,	0x0f,	0x01 },
/* "vlvt"   */ {    o_vlvt,    O_VN,	0,  0,	1,	0x30,	0x00,	0x0f,	0x04 },
/* "vsvt"   */ {    o_vsvt,    O_VN,	0,  0,	1,	0x03,	0x00,	0x0f,	0x01 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vsmm"   */ {    o_vsmm,    O_VK,	0,  0,	0,	0x03,	0x00,	0x0f,	0x01 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vfm"    */ {    o_vfm,     O_VK,	0,  0,	0,	0x0c,	0x00,	0x0f,	0x02 },
/* "vfmx"   */ {    o_vfmx,    O_VK,	0,  0,	0,	0x0c,	0x00,	0x0f,	0x02 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },

/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vltr"   */ {    o_vltr,    O_VL,	0,  0,	1,	0x00,	0x00,	0x0f,	0x08 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vts"    */ {    o_vts,     O_VA,	0,  0,	0,	0x33,	0x00,	0x0f,	0x05 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vsm"    */ {    o_vsm,     O_VA,	0,  1,	0,	0x03,	0x00,	0x0f,	0x01 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vfx"    */ {    o_vfX,     O_VA,	0,  0,	0,	0x0f,	0x00,	0x0f,	0x03 },
/* "vfxx"   */ {    o_vfX,     O_VA,	0,  0,	0,	0x0f,	0x00,	0x0f,	0x03 },
/* "vfn"    */ {    o_vfX,     O_VA,	0,  0,	0,	0x0f,	0x00,	0x0f,	0x03 },
/* "vfnx"   */ {    o_vfX,     O_VA,	0,  0,	0,	0x0f,	0x00,	0x0f,	0x03 },

/* "vlcr"   */ {    o_vlcr,    O_VN,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vscr"   */ {    o_vscr,    O_VN,	0,  0,	0,	0x03,	0x00,	0x0f,	0x01 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vtsd"   */ {    o_vtsX,    O_VA,	0,  0,	0,	0x33,	0x02,	0x0f,	0x05 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vsmd"   */ {    o_vsmX,    O_VA,	0,  1,	0,	0x03,	0x02,	0x0f,	0x01 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vfxd"   */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },
/* "vfxdx"  */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },
/* "vfnd"   */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },
/* "vfndx"  */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },

/* "vpt"    */ {    o_vpt,     O_VN,	0,  0,	0,	0x00,	0x00,	0x0f,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vlvl"   */ {    o_vlvl,    O_VN,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "vlvlf"  */ {    o_vlvlf,   O_VN,	0,  0,	0,	0x30,	0x00,	0x0f,	0x04 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vtse"   */ {    o_vtsX,    O_VA,	0,  0,	0,	0x33,	0x02,	0x0f,	0x05 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vsme"   */ {    o_vsmX,    O_VA,	0,  1,	0,	0x03,	0x02,	0x0f,	0x01 },
/* "???"    */ {    NULL,      O_NL,	0,  0,	0,	0x00,	0x00,	0x00,	0x00 },
/* "vfxe"   */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },
/* "vfxex"  */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },
/* "vfne"   */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },
/* "vfnex"  */ {    o_vfXX,    O_VA,	0,  0,	0,	0x0f,	0x02,	0x0f,	0x03 },
};

