/* @(#)vp-fper.c	1.1    6/12/91 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Koseki      */

/* vp-fper.c       90/04/04 */

#ifdef VCP

#include "tim.h"
#include "facility.h"
#include "fp-form.def"

extern union fp_vp_cnt un_fcr;
extern union fp_vp_reg un_fr[];
extern union fp_vp_temp un_t[];
extern union fp_vp_flag un_fvct[];


/*  add  */

o_vaX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R1 ) || ( vlmask & BVOI.R2 ) ||
              ( vlmask & BVOI.R3 ) || ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R1, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R1, _R_ );
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  sys_vr_access( t_pe, BVAQ.R1, BVAQ.count, _R_,
                                   un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVAP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVAP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


o_vasX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          sys_fr_access( t_pe, BVOI.R1 & 0x01f, _R_, BVOI.scalar_u, BVOI.scalar_l );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          vp_temp_clear( t_pe );
          un_fr[VR_R1].fr[0] = BVAQ.scalar_u;
          un_fr[VR_R1].fr[1] = BVAQ.scalar_l;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  vp_fst_clear( t_pe );
                  vp_treg_clear( t_pe, VR_R1, VR_R2 );
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVAP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVAP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
     }
}


/*  subtract  */

o_vsX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R1 ) || ( vlmask & BVOI.R2 ) ||
              ( vlmask & BVOI.R3 ) || ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R1, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R1, _R_ );
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  sys_vr_access( t_pe, BVAQ.R1, BVAQ.count, _R_,
                                   un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  un_fr[VR_R2].c_data.s = un_fr[VR_R2].c_data.s ^ 0x00000001;
                  fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVAP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVAP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


o_vssX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          sys_fr_access( t_pe, BVOI.R1 & 0x01f, _R_, BVOI.scalar_u, BVOI.scalar_l );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          vp_temp_clear( t_pe );
          un_fr[VR_R1].fr[0] = BVAQ.scalar_u;
          un_fr[VR_R1].fr[1] = BVAQ.scalar_l;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  vp_fst_clear( t_pe );
                  vp_treg_clear( t_pe, VR_R1, VR_R2 );
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  un_fr[VR_R2].c_data.s = un_fr[VR_R2].c_data.s ^ 0x00000001;
                  fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVAP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVAP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
     }
}


/*  multiply  */

o_vmX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R1 ) || ( vlmask & BVOI.R2 ) ||
              ( vlmask & BVOI.R3 ) || ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R1, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R1, _R_ );
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVMQ.op & 0x10 )?1:0;
          TVMP.select = BVMQ.R3;
          for( i=0 ; i<8 && BVMQ.count<=BVMQ.vl ; i++, BVMQ.count++ ){
              sys_mr_access( t_pe, BVMQ.R4, BVMQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVMP.mask |= ( 0x80 >> i );
                  TVMP.num[i] = BVMQ.count;
                  sys_vr_access( t_pe, BVMQ.R1, BVMQ.count, _R_,
                                   un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  sys_vr_access( t_pe, BVMQ.R2, BVMQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  fp_mul_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVMP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVMP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVMP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVMP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


o_vmsX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          sys_fr_access( t_pe, BVOI.R1 & 0x01f, _R_, BVOI.scalar_u, BVOI.scalar_l );
          break;
      case 'x':
          dtype = ( BVMQ.op & 0x10 )?1:0;
          TVMP.select = BVMQ.R3;
          vp_temp_clear( t_pe );
          un_fr[VR_R1].fr[0] = BVMQ.scalar_u;
          un_fr[VR_R1].fr[1] = BVMQ.scalar_l;
          for( i=0 ; i<8 && BVMQ.count<=BVMQ.vl ; i++, BVMQ.count++ ){
              sys_mr_access( t_pe, BVMQ.R4, BVMQ.count, _R_, m, 0 );
              if( m ){
                  TVMP.mask |= ( 0x80 >> i );
                  TVMP.num[i] = BVMQ.count;
                  vp_fst_clear( t_pe );
                  vp_treg_clear( t_pe, VR_R1, VR_R2 );
                  sys_vr_access( t_pe, BVMQ.R2, BVMQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  fp_mul_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVMP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVMP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVMP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVMP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
     }
}



/*  divide  */


o_vdX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R1 ) || ( vlmask & BVOI.R2 ) ||
              ( vlmask & BVOI.R3 ) || ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R1, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R1, _R_ );
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVDQ.op & 0x10 )?1:0;
          TVDP.select = BVDQ.R3;
          for( i=0 ; i<8 && BVDQ.count<=BVDQ.vl ; i++, BVDQ.count++ ){
              sys_mr_access( t_pe, BVDQ.R4, BVDQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVDP.mask |= ( 0x80 >> i );
                  TVDP.num[i] = BVDQ.count;
                  sys_vr_access( t_pe, BVDQ.R1, BVDQ.count, _R_,
                                   un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  sys_vr_access( t_pe, BVDQ.R2, BVDQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  fp_div_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVDP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVDP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVDP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVDP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


o_vdsX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          sys_fr_access( t_pe, BVOI.R1 & 0x01f, _R_, BVOI.scalar_u, BVOI.scalar_l );
          break;
      case 'x':
          dtype = ( BVDQ.op & 0x10 )?1:0;
          TVDP.select = BVDQ.R3;
          vp_temp_clear( t_pe );
          un_fr[VR_R1].fr[0] = BVDQ.scalar_u;
          un_fr[VR_R1].fr[1] = BVDQ.scalar_l;
          for( i=0 ; i<8 && BVDQ.count<=BVDQ.vl ; i++, BVDQ.count++ ){
              sys_mr_access( t_pe, BVDQ.R4, BVDQ.count, _R_, m, 0 );
              if( m ){
                  TVDP.mask |= ( 0x80 >> i );
                  TVDP.num[i] = BVDQ.count;
                  vp_fst_clear( t_pe );
                  vp_treg_clear( t_pe, VR_R1, VR_R2 );
                  sys_vr_access( t_pe, BVDQ.R2, BVDQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  fp_div_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  TVDP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVDP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVDP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVDP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
     }
}


/*  compare  */

o_vcX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;
  unsigned   xtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R1 ) || ( vlmask & BVOI.R2 ) ||
              ( vlmask & BVOI.R3 ) || ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R1, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R3, _W_, 1 ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R1, _R_ );
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_mr_lock( t_pe, BVOI.R3, _W_, 1 );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          TVAP.select = BVAQ.R3;
          dtype = ( BVAQ.op & 0x10 )?1:0;
          xtype = BVAQ.op & 0x07;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  sys_vr_access( t_pe, BVAQ.R1, BVAQ.count, _R_,
                                   un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  if( xtype ){
                      if( fp_cmp_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype, xtype )
                                                              == FPU_SUCCEED ){
                          TVAP.d[i][0] = m && ( un_fcr.ctl.cmd & xtype );
                      }
                      else{
                          TVAP.d[i][0] = 0;
                      }
                      *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                    ( un_fcr.ctl.fxf << 3 ) );
                      *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
                  }
                  else{
                      fp_cnv_f_t( VR_R2, dtype );
                      TVAP.d[i][0] = un_fvct[VR_R2].ctl.nan;
                  }
              }
              else{
                  TVAP.d[i][0] = 0;
              }
              TVAP.mask |= ( 0x80 >> i );
              TVAP.num[i] = BVAQ.count;
          }
          return;
          break;
    }
}
  

o_vcsX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;
  unsigned   xtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R3, _W_, 1 ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_mr_lock( t_pe, BVOI.R3, _W_, 1 );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          sys_fr_access( t_pe, BVOI.R1 & 0x01f, _R_, BVOI.scalar_u, BVOI.scalar_l );
          break;
      case 'x':
          TVAP.select = BVAQ.R3;
          dtype = ( BVAQ.op & 0x10 )?1:0;
          xtype = BVAQ.op & 0x07;
          vp_temp_clear( t_pe );
          un_fr[VR_R1].fr[0] = BVAQ.scalar_u;
          un_fr[VR_R1].fr[1] = BVAQ.scalar_l;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_fst_clear( t_pe );
                  vp_treg_clear( t_pe, VR_R1, VR_R2 );
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                   un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                  if( xtype ){
                      if( fp_cmp_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype, xtype )
                                                              == FPU_SUCCEED ){
                          TVAP.d[i][0] = m && ( un_fcr.ctl.cmd & xtype );
                      }
                      else{
                          TVAP.d[i][0] = 0;
                      }
                      *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                    ( un_fcr.ctl.fxf << 3 ) );
                      *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
                  }
                  else{
                      fp_cnv_f_t( VR_R2, dtype );
                      TVAP.d[i][0] = un_fvct[VR_R2].ctl.nan;
                  }
              }
              else{
                  TVAP.d[i][0] = 0;
              }
              TVAP.mask |= ( 0x80 >> i );
              TVAP.num[i] = BVAQ.count;
          }
          return;
          break;
    }
}


/**************************
* vector macro operations *
**************************/


o_vfXX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;
  unsigned   xtype;
  unsigned   dmask;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R1 ) || ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R1, _R_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R1, _R_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          switch( BVAQ.op & 0x03 ){
              case 0:
                  xtype = DATA_GT;
                  break;
              case 1:
                  xtype = DATA_GT | DATA_EQ;
                  break;
              case 2:
                  xtype = DATA_LT;
                  break;
              case 3:
                  xtype = DATA_LT | DATA_EQ;
                  break;
          }
          dtype = ( BVAQ.op & 0x10 )?1:0;
          dmask = ( BVAQ.op & 0x10 )?0:0xffffffff;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  sys_vr_access( t_pe, BVAQ.R1, BVAQ.count, _R_,
                                   un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  if( !TVAP.d[0][1] ){
                      fp_cnv_f_t( VR_R1, dtype );
                      if( !un_fcr.ctl.trct && 
                          ( un_fvct[VR_R1].ctl.sts != F_STATUS_NAN ) ){
                          TVAP.d[0][1] = BVAQ.count;
                          TVAP.d[1][0] = un_fr[VR_R1].fr[0];
                          TVAP.d[1][1] = un_fr[VR_R1].fr[1] & dmask;
                      }
                  }
                  else{
                      un_fr[VR_R2].fr[0] = TVAP.d[1][0];
                      un_fr[VR_R2].fr[1] = TVAP.d[1][1];
                      if( fp_cmp_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype, 0 )
                                                             == FPU_SUCCEED ){
                          if( un_fcr.ctl.cmd & xtype ){
                              TVAP.d[0][1] = BVAQ.count;
                              TVAP.d[1][0] = un_fr[VR_R1].fr[0];
                              TVAP.d[1][1] = un_fr[VR_R1].fr[1] & dmask;
                          }
                      }
                  }
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
    }
}


o_vsmX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;
  unsigned   upper;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R1 ) || ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R1, _R_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          BVOI.vl += 8;
          BVOI.vsmcount = 0;
          for (i=0; i<16; i++){
              BVOI.vsmw[i][0] = 0x80000000;
              BVOI.vsmw[i][1] = 0x00000000;
          }
          sys_vr_lock(t_pe, BVOI.R1, _R_);
          sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          switch( BVAQ.vl - BVAQ.count ){
              default:
                  upper = (((BVAQ.count-1) >> 3) & 1);
                  for( i=0; i<8 && BVAQ.count<=BVAQ.vl-8; i++, BVAQ.count++ ){
                      sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
                      if( m ){
                          BVOI.vsmcount++;
                          vp_temp_clear( t_pe );
                          sys_vr_access( t_pe, BVAQ.R1, BVAQ.count, _R_,
                                     un_fr[VR_R2].fr[0], un_fr[VR_R2].fr[1] );
                          if( upper ){
                              un_fr[VR_R1].fr[0] = BVAQ.vsmw[i+8][0];
                              un_fr[VR_R1].fr[1] = BVAQ.vsmw[i+8][1];
                              fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                              BVAQ.vsmw[i+8][0] = un_fr[VR_W1].fr[0];
                              BVAQ.vsmw[i+8][1] = un_fr[VR_W1].fr[1];
                          }
                          else{
                              un_fr[VR_R1].fr[0] = BVAQ.vsmw[i][0];
                              un_fr[VR_R1].fr[1] = BVAQ.vsmw[i][1];
                              fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                              BVAQ.vsmw[i][0] = un_fr[VR_W1].fr[0];
                              BVAQ.vsmw[i][1] = un_fr[VR_W1].fr[1];
                          }
                          *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                        ( un_fcr.ctl.fxf << 3 ) );
                          *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
                      }
                  }
                  break;
              case 7 :
                  for( i=0 ; i<8 ; i++ ){
                      vp_temp_clear( t_pe );
                      un_fr[VR_R1].fr[0] = BVAQ.vsmw[i][0];
                      un_fr[VR_R1].fr[1] = BVAQ.vsmw[i][1];
                      un_fr[VR_R2].fr[0] = BVAQ.vsmw[i+8][0];
                      un_fr[VR_R2].fr[1] = BVAQ.vsmw[i+8][1];
                      fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                      BVAQ.vsmw[i][0] = un_fr[VR_W1].fr[0];
                      BVAQ.vsmw[i][1] = un_fr[VR_W1].fr[1];
                      *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                    ( un_fcr.ctl.fxf << 3 ) );
                      *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
                  }
                  BVAQ.count++;
                  break;
              case 6 :
                  vp_temp_clear( t_pe );
                  un_fr[VR_R1].fr[0] = BVAQ.vsmw[1][0];
                  un_fr[VR_R1].fr[1] = BVAQ.vsmw[1][1];
                  goto vsmx_common;
                  break;
              case 5 :
                  vp_temp_clear( t_pe );
                  un_fr[VR_R1].fr[0] = BVAQ.vsmw[2][0];
                  un_fr[VR_R1].fr[1] = BVAQ.vsmw[2][1];
                  goto vsmx_common;
                  break;
              case 4 :
                  vp_temp_clear( t_pe );
                  un_fr[VR_R1].fr[0] = BVAQ.vsmw[3][0];
                  un_fr[VR_R1].fr[1] = BVAQ.vsmw[3][1];
                  goto vsmx_common;
                  break;
              case 3 :
                  vp_temp_clear( t_pe );
                  un_fr[VR_R1].fr[0] = BVAQ.vsmw[4][0];
                  un_fr[VR_R1].fr[1] = BVAQ.vsmw[4][1];
                  goto vsmx_common;
                  break;
              case 2 :
                  vp_temp_clear( t_pe );
                  un_fr[VR_R1].fr[0] = BVAQ.vsmw[5][0];
                  un_fr[VR_R1].fr[1] = BVAQ.vsmw[5][1];
                  goto vsmx_common;
                  break;
              case 1 :
                  vp_temp_clear( t_pe );
                  un_fr[VR_R1].fr[0] = BVAQ.vsmw[6][0];
                  un_fr[VR_R1].fr[1] = BVAQ.vsmw[6][1];
                  goto vsmx_common;
                  break;
              case 0 :
                  vp_temp_clear( t_pe );
                  if( !BVOI.vsmcount ){
                      un_fr[VR_R1].fr[0] = un_fr[VR_R1].fr[1] = 0;
                      un_fr[VR_R2].fr[0] = un_fr[VR_R2].fr[1] = 0;
                  }else{
                      un_fr[VR_R1].fr[0] = BVAQ.vsmw[7][0];
                      un_fr[VR_R1].fr[1] = BVAQ.vsmw[7][1];
vsmx_common:
                      un_fr[VR_R2].fr[0] = BVAQ.vsmw[0][0];
                      un_fr[VR_R2].fr[1] = BVAQ.vsmw[0][1];
                  }
                  fp_add_temp( t_pe, VR_R1, VR_R2, VR_W1, dtype );
                  BVAQ.vsmw[0][0] = un_fr[VR_W1].fr[0];
                  BVAQ.vsmw[0][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
                  BVAQ.count++;
                  break;
          }
          return;
          break;
  }
}



o_vviX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;
  unsigned   dmy;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                                  dmy, un_fr[VR_R1].fr[0] );
                  fp_cnv_it_temp( t_pe, VR_R1, VR_W1, INTEGER_DATA, dtype );
                  TVAP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVAP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


o_vvXi(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                    un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  fp_cnv_ti_temp( t_pe, VR_R1, VR_W1, dtype, INTEGER_DATA );
                  TVAP.d[i][0] = 0;
                  TVAP.d[i][1] = un_fr[VR_W1].fr[0];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


o_vvX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                    un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  fp_cnv_temp( t_pe, VR_R1, VR_W1, !dtype, dtype);
                  TVAP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVAP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


o_vlpX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned   vlmask;
  unsigned   m;
  unsigned   i;
  unsigned   dtype;

  switch (cmd) {
      case 'c':
          vlmask = get_vlmask( BVOI.vl );
          if( ( vlmask & BVOI.R2 ) || ( vlmask & BVOI.R3 ) ||
                                      ( vlmask & BVOI.R4 ) ){
              pe[T_PE].vcr[2].vcr2.pif_spx = 1;
              return(SCORE_EXCEPTION);
          }
          if( ( sys_vr_check_score( t_pe, BVOI.R2, _R_ ) == SCORE_FREE ) &&
              ( sys_vr_check_score( t_pe, BVOI.R3, _W_ ) == SCORE_FREE ) &&
              ( sys_mr_check_score( t_pe, BVOI.R4, _R_, 0 ) == SCORE_FREE ) ){
              return( SCORE_FREE );
          }
          else{
              return(SCORE_BUSY);
          }
          break;
      case 'r':
          sys_vr_lock( t_pe, BVOI.R2, _R_ );
          sys_vr_lock( t_pe, BVOI.R3, _W_ );
          sys_mr_lock( t_pe, BVOI.R4, _R_, 0 );
          break;
      case 'x':
          dtype = ( BVAQ.op & 0x10 )?1:0;
          TVAP.select = BVAQ.R3;
          for( i=0 ; i<8 && BVAQ.count<=BVAQ.vl ; i++, BVAQ.count++ ){
              sys_mr_access( t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0 );
              if( m ){
                  vp_temp_clear( t_pe );
                  TVAP.mask |= ( 0x80 >> i );
                  TVAP.num[i] = BVAQ.count;
                  sys_vr_access( t_pe, BVAQ.R2, BVAQ.count, _R_,
                                    un_fr[VR_R1].fr[0], un_fr[VR_R1].fr[1] );
                  fp_positive_temp( t_pe, VR_R1, VR_W1, dtype);
                  TVAP.d[i][0] = un_fr[VR_W1].fr[0];
                  TVAP.d[i][1] = un_fr[VR_W1].fr[1];
                  *( unsigned *)&TVAP.vcr2 |= ( ( un_fcr.fct.ff << 5 ) |
                                                ( un_fcr.ctl.fxf << 3 ) );
                  *( unsigned *)&TVAP.vcr2 |= ( un_fcr.fct.sts << 19 );
              }
          }
          return;
          break;
      }
}


vp_interruption_check( t_pe, treg1, treg2, treg3 )
int       t_pe;
unsigned  treg1, treg2, treg3;
{
    TVAP.vcr2.pif_fof |= un_fcr.ctl.ivo &  pe[T_PE].vcr[2].vcr2.pim_fom;
    TVAP.vcr2.axf_fof |= un_fcr.ctl.ivo & !pe[T_PE].vcr[2].vcr2.pim_fom;
    TVAP.vcr2.pif_fdf |= un_fcr.ctl.dz  &  pe[T_PE].vcr[2].vcr2.pim_fdm;
    TVAP.vcr2.axf_fdf |= un_fcr.ctl.dz  & !pe[T_PE].vcr[2].vcr2.pim_fdm;
    TVAP.vcr2.pif_fvf |= un_fcr.ctl.irv &  pe[T_PE].vcr[2].vcr2.pim_fvm;
    TVAP.vcr2.axf_fvf |= un_fcr.ctl.irv & !pe[T_PE].vcr[2].vcr2.pim_fvm;
    TVAP.vcr2.pif_fuf |= un_fcr.ctl.iru &  pe[T_PE].vcr[2].vcr2.pim_fum;
    TVAP.vcr2.axf_fuf |= un_fcr.ctl.iru & !pe[T_PE].vcr[2].vcr2.pim_fum;
    TVAP.vcr2.pif_fif |= un_fcr.ctl.ine &  pe[T_PE].vcr[2].vcr2.pim_fim;
    TVAP.vcr2.axf_fif |= un_fcr.ctl.ine & !pe[T_PE].vcr[2].vcr2.pim_fim;
}

#endif


