static char SccsId[] = "@(#)vp.c	1.4    11/18/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* vp.c    89/10/1 */

#ifdef VCP

#include "tim.h"
#include "facility.h"
#include "vp-decode.h"

sim_vp(t_pe)
    unsigned t_pe;
{
    unsigned        cb;

    /* 5 nano -> 10 nano */
    if (++pe[T_PE].vut_5nano & 1) {

/**********************
*  update VUT         *
**********************/
      if (pe[T_PE].vut_5nano >= 200) {
        pe[T_PE].vut_5nano = 0;
        pe[T_PE].vut[0]++; /* micro seconds */
      }

/***********************
*  consume PIPES       *
***********************/
      vp_consume_pipes(t_pe);

/***********************
*  consume QUEUES      *
***********************/
      vp_consume_queues(t_pe);

/***********************
*  consume MCQUEUES    *
***********************/
      vp_consume_mcqueues(t_pe);

    }

/***********************
*  consume IQUEUES     *
***********************/
    vp_consume_iqueues(t_pe);

/********************
*  update IRD0.cir  *
********************/
    if (pe[T_PE].vcr[2].ful & 0xffff)
      pe[T_PE].ext_interrupt |= VP_INTERRUPT;

/********************
*  update STAR1     *
********************/
    if (pe[T_PE].avn_opiq || pe[T_PE].avn_opmq || pe[T_PE].avn_opcq
     || pe[T_PE].avn_ldq  || pe[T_PE].avn_stq  || pe[T_PE].avn_addq 
     || pe[T_PE].avn_mulq || pe[T_PE].avn_divq || pe[T_PE].avn_mskq
     || pe[T_PE].avn_ldp  || pe[T_PE].avn_stp  || pe[T_PE].avn_addp
     || pe[T_PE].avn_mulp || pe[T_PE].avn_divp || pe[T_PE].avn_mskp)
      cb = 1;
    else
      cb = 0;
  
    pe[T_PE].sr[STAR1].star1.cb0 = cb;
    pe[T_PE].sr[STAR1].star1.cba = cb;
    pe[T_PE].sr[STAR1].star1.cbu = cb & pe[T_PE].sr[PEV].pev.cum0;
    pe[T_PE].sr[STAR1].star1.cbs = cb & pe[T_PE].sr[CBSM].cbsm.cbsm0;
}

vp_consume_pipes(t_pe) unsigned t_pe;
{
    unsigned i;

/**********************
*  consume LOAD_PIPE  *
**********************/
    if (BVLP.av) {
      switch (BVLP.op) {
      case 0x10: /* VIL */
      case 0x20: /* VILD */
      case 0x30: /* VILE */
        if (BVLP.bot)
          sys_vop_unlock_indirect(t_pe);
      case 0x90: /* VL */
      case 0x92: /* VLCP */
      case 0xa0: /* VLD */
      case 0xa2: /* VLCPD */
      case 0xb0: /* VLE */
      case 0xb2: /* VLCPE */
        if (BVLP.bot)
          sys_vr_unlock(t_pe, BVLP.select, _W_);
        for (i = 0; i < 8; i++) {
          if (BVLP.mask & (0x80 >> i)) {
	    sys_vr_access(t_pe,BVLP.select,BVLP.num[i],_W_,BVLP.d[i][0],BVLP.d[i][1]);
          }
        }
        break;
      case 0x80: /* VLM */
        if (BVLP.bot)
          sys_mr_unlock(t_pe, BVLP.select, _W_, 1);
        for (i = 0; i < 8; i++) {
          if (BVLP.mask & (0x80 >> i)) {
	    sys_mr_access(t_pe,BVLP.select,BVLP.num[i],_W_,BVLP.d[i][0], 1);
          }
        }
        break;
      case 0xd2: /* VLTR */
        if (BVLP.bot)
          sys_vp_unlock(t_pe);
        for (i = 0; i < 8; i++) {
          if (BVLP.mask & (0x80 >> i))
	    sys_tr_access(t_pe,BVLP.num[i],_W_,&BVLP.d[i][0]);
        }
        break;
      default: /* internal error */
        message("internal error: VP_LDP.op=0x%02.2X\n", BVLP.op);
        break;
      }
      if (BVLP.bot)
        *(unsigned*)&pe[T_PE].vcr[2].ful |= *(unsigned*)&BVLP.vcr2;
      BVLP.av = 0;
      pe[T_PE].avn_ldp--;
    }
    if (pe[T_PE].avn_ldp) {
      for (i = VP_LDPLEN-1; i > 0; i--) 
        pe[T_PE].vp_ldp[i] = pe[T_PE].vp_ldp[i-1];
      if (PVLP.bot) {
        *(unsigned*)&TVLP.vcr2 = 0;
        for (i = 0; i < 8; i++)
          TVLP.d[i][0] = TVLP.d[i][1] = 0;
      }
      TVLP.av = 0;
    }

/**********************
*  consume STORE_PIPE *
**********************/
    if (BVSP.av) {
      switch (BVSP.op) {
      case 0xa1: /* VSTD */
      case 0xa3: /* VSTXD */
        if (BVSP.bot)
          sys_vop_unlock_id(t_pe, BVSP.id, _W_);
        for (i = 0; i < 8; i++) {
          if (BVSP.mask & (0x80 >> i)) {
	    if (sys_vop_access(t_pe,pe[T_PE].vcr[1].vcr1.vt?'v':'r',BVSP.addr[i],8,_W_,BVSP.d[i]) == RW_SUCCESS);
            else
	      *(unsigned*)&pe[T_PE].work_st_vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
          }
        }
        break;
      case 0x21: /* VISTD */
        if (BVSP.bot)
          sys_vop_unlock_indirect(t_pe);
        for (i = 0; i < 8; i++) {
          if (BVSP.mask & (0x80 >> i)) {
	    if (sys_vop_access(t_pe,pe[T_PE].vcr[1].vcr1.vt?'v':'r',BVSP.addr[i],8,_W_,BVSP.d[i]) == RW_SUCCESS);
            else
	      *(unsigned*)&pe[T_PE].work_st_vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
          }
        }
        break;
      case 0x81: /* VSTM */
      case 0x91: /* VST */
      case 0x93: /* VSTX */
      case 0xb1: /* VSTE */
      case 0xb3: /* VSTXE */
        if (BVSP.bot)
          sys_vop_unlock_id(t_pe, BVSP.id, _W_);
        for (i = 0; i < 8; i++) {
          if (BVSP.mask & (0x80 >> i)) {
	    if (sys_vop_access(t_pe,pe[T_PE].vcr[1].vcr1.vt?'v':'r',BVSP.addr[i],4,_W_,BVSP.d[i]) == RW_SUCCESS);
            else
	      *(unsigned*)&pe[T_PE].work_st_vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
          }
        }
        break;
      case 0x11: /* VIST */
      case 0x31: /* VISTE */
        if (BVSP.bot)
          sys_vop_unlock_indirect(t_pe);
        for (i = 0; i < 8; i++) {
          if (BVSP.mask & (0x80 >> i)) {
	    if (sys_vop_access(t_pe,pe[T_PE].vcr[1].vcr1.vt?'v':'r',BVSP.addr[i],4,_W_,BVSP.d[i]) == RW_SUCCESS);
            else
	      *(unsigned*)&pe[T_PE].work_st_vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
          }
        }
        break;
      default: /* internal error */
        message("internal error: VP_STP.op=0x%02.2X\n", BVSP.op);
        break;
      }
      if (BVSP.bot) {
        *(unsigned*)&pe[T_PE].vcr[2].ful |= *(unsigned*)&pe[T_PE].work_st_vcr2;
        *(unsigned*)&pe[T_PE].work_st_vcr2 = 0;
      }
      BVSP.av = 0;
      pe[T_PE].avn_stp--;
    }
    if (pe[T_PE].avn_stp) {
      for (i = VP_STPLEN-1; i > 0; i--) 
        pe[T_PE].vp_stp[i] = pe[T_PE].vp_stp[i-1];
      if (PVSP.bot) {
        *(unsigned*)&TVSP.vcr2 = 0;
        for (i = 0; i < 8; i++)
          TVSP.d[i][0] = TVSP.d[i][1] = 0;
      }
      TVSP.av = 0;
    }

/**********************
*  consume ADD_PIPE   *
**********************/
    if (BVAP.av) {
      switch (BVAP.op) {
      case 0x14: /* VN */	case 0x15: /* VO */	
      case 0x16: /* VX */	case 0x17: /* VESLL */	
      case 0x18: /* VA */	case 0x19: /* VS */	
      case 0x1c: /* VLR */	case 0x1e: /* VLP */
      case 0x24: /* VVID */	case 0x25: /* VVDI */
      case 0x26: /* VVED */	case 0x28: /* VAD */
      case 0x29: /* VSD */	case 0x2e: /* VLPD */
      case 0x34: /* VVIE */	case 0x35: /* VVEI */
      case 0x36: /* VVDE */	case 0x38: /* VAE */
      case 0x39: /* VSE */	case 0x3e: /* VLPE */
      case 0x94: /* VNS */	case 0x95: /* VOS */
      case 0x96: /* VXS */	case 0x98: /* VAS */
      case 0x99: /* VSS */	case 0x9e: /* VLS */
      case 0xa7: /* VSRL */	case 0xa8: /* VASD */
      case 0xa9: /* VSSD */	case 0xae: /* VLSD */
      case 0xb7: /* VSLL */	case 0xb8: /* VASE */
      case 0xb9: /* VSSE */	case 0xbe: /* VLSE */
        if (BVAP.bot)
          sys_vr_unlock(t_pe, BVAP.select, _W_);
        for (i = 0; i < 8; i++) {
          if (BVAP.mask & (0x80 >> i)) {
            sys_vr_access(t_pe,BVAP.select,BVAP.num[i],_W_,BVAP.d[i][0],BVAP.d[i][1]);     
          }
        }   
        break;
      case 0x50: /* VCF */	case 0x51: /* VCH */
      case 0x52: /* VCL */	case 0x53: /* VCNE */
      case 0x54: /* VCE */	case 0x55: /* VCNL */
      case 0x56: /* VCNH */	case 0x57: /* VCT */
      case 0x58: /* VCSF */	case 0x59: /* VCSH */
      case 0x5a: /* VCSL */	case 0x5b: /* VCSNE */
      case 0x5c: /* VCSE */	case 0x5d: /* VCSNL */
      case 0x5e: /* VCSNH */	case 0x5f: /* VCST */
      case 0x60: /* VCFD */	case 0x61: /* VCHD */
      case 0x62: /* VCLD */	case 0x63: /* VCNED */
      case 0x64: /* VCED */	case 0x65: /* VCNLD */
      case 0x66: /* VCNHD */	case 0x67: /* VCTD */
      case 0x68: /* VCSFD */	case 0x69: /* VCSHD */
      case 0x6a: /* VCSLD */	case 0x6b: /* VCSNED */
      case 0x6c: /* VCSED */	case 0x6d: /* VCSNLD */
      case 0x6e: /* VCSNHD */	case 0x6f: /* VCSTD */
      case 0x70: /* VCFE */	case 0x71: /* VCHE */
      case 0x72: /* VCLE */	case 0x73: /* VCNEE */
      case 0x74: /* VCEE */	case 0x75: /* VCNLE */
      case 0x76: /* VCNHE */	case 0x77: /* VCTE */
      case 0x78: /* VCSFE */	case 0x79: /* VCSHE */
      case 0x7a: /* VCSLE */	case 0x7b: /* VCSNEE */
      case 0x7c: /* VCSEE */	case 0x7d: /* VCSNLE */
      case 0x7e: /* VCSNHE */	case 0x7f: /* VCSTE */
        if (BVAP.bot)
          sys_mr_unlock(t_pe, BVAP.select, _W_, 1);
        for (i = 0; i < 8; i++) {
          if (BVAP.mask & (0x80 >> i)) {
            sys_mr_access(t_pe,BVAP.select,BVAP.num[i],_W_,BVAP.d[i][0], 1);
          }
        }   
        break;
      case 0xd8: /* VTS */
      case 0xda: /* VSM */
        if (BVAP.bot) {
          sys_gr_unlock(t_pe,BVAP.num[1]);
          sys_async_gr_access(t_pe,BVAP.num[1],BVAP.u,_W_,BVAP.d[1][1]);     
        }
        break;
      case 0xdc: /* VFX */
      case 0xdd: /* VFXX */
      case 0xde: /* VFN */
      case 0xdf: /* VFNX */
        if (BVAP.bot) {
          sys_gr_unlock(t_pe,BVAP.num[0]);
          sys_gr_unlock(t_pe,BVAP.num[1]);
          sys_async_gr_access(t_pe,BVAP.num[0],BVAP.u,_W_,BVAP.d[0][1]);     
          sys_async_gr_access(t_pe,BVAP.num[1],BVAP.u,_W_,BVAP.d[1][1]);     
        }
        break;
      case 0xe8: /* VTSD */
      case 0xea: /* VSMD */
      case 0xf8: /* VTSE */
      case 0xfa: /* VSME */
        if (BVAP.bot) {
          sys_fr_unlock(t_pe,BVAP.num[1]);
          sys_fr_access(t_pe,BVAP.num[1],_W_,BVAP.d[1][0],BVAP.d[1][1]);     
        }
        break;
      case 0xec: /* VFXD */
      case 0xed: /* VFXDX */
      case 0xee: /* VFND */
      case 0xef: /* VFNDX */
      case 0xfc: /* VFXE */
      case 0xfd: /* VFXEX */
      case 0xfe: /* VFNE */
      case 0xff: /* VFNEX */
        if (BVAP.bot) {
          sys_gr_unlock(t_pe,BVAP.num[0]);
          sys_fr_unlock(t_pe,BVAP.num[1]);
          sys_async_gr_access(t_pe,BVAP.num[0],BVAP.u,_W_,BVAP.d[0][1]);     
          sys_fr_access(t_pe,BVAP.num[1],_W_,BVAP.d[1][0],BVAP.d[1][1]);     
        }
        break;
      default: /* internal error */
        message("internal error: VP_ADDP.op=0x%02.2X\n", BVAP.op);
        break;
      }
      if (BVAP.bot)
        *(unsigned*)&pe[T_PE].vcr[2].ful |= *(unsigned*)&BVAP.vcr2;
      BVAP.av = 0;
      pe[T_PE].avn_addp--;
    }  
    if (pe[T_PE].avn_addp) {
      for (i = VP_ADDPLEN-1; i > 0; i--) 
        pe[T_PE].vp_addp[i] = pe[T_PE].vp_addp[i-1];
      if (PVAP.bot) {
        *(unsigned*)&TVAP.vcr2 = 0;
        for (i = 0; i < 8; i++)
          TVAP.d[i][0] = TVAP.d[i][1] = 0;
      }
      TVAP.av = 0;
    }

/**********************
*  consume MUL_PIPE   *
**********************/
    if (BVMP.av) {
      switch (BVMP.op) {
      case 0x1a: /* VM */
      case 0x2a: /* VMD */
      case 0x3a: /* VME */
      case 0x8a: /* VGS */
      case 0x9a: /* VMS */
      case 0xaa: /* VMSD */
      case 0xba: /* VMSE */
        for (i = 0; i < 8; i++) {
          if (BVMP.mask & (0x80 >> i)) {
            sys_vr_access(t_pe,BVMP.select,BVMP.num[i],_W_,BVMP.d[i][0],BVMP.d[i][1]);     
          }
        }   
        break;
      default: /* internal error */
        message("internal error: VP_MULP.op=0x%02.2X\n", BVMP.op);
        break;
      }
      if (BVMP.bot) {
        *(unsigned*)&pe[T_PE].vcr[2].ful |= *(unsigned*)&BVMP.vcr2;
        sys_vr_unlock(t_pe, BVMP.select, _W_);
      }
      BVMP.av = 0;
      pe[T_PE].avn_mulp--;
    }  
    if (pe[T_PE].avn_mulp) {
      for (i = VP_MULPLEN-1; i > 0; i--) 
        pe[T_PE].vp_mulp[i] = pe[T_PE].vp_mulp[i-1];
      if (PVMP.bot) {
        *(unsigned*)&TVMP.vcr2 = 0;
        for (i = 0; i < 8; i++)
          TVMP.d[i][0] = TVMP.d[i][1] = 0;
      }
      TVMP.av = 0;
    }

/**********************
*  consume DIV_PIPE   *
**********************/
    if (BVDP.av) {
      switch (BVDP.op) {
      case 0x2b: /* VDD */
      case 0x3b: /* VDE */
      case 0xab: /* VDSD */
      case 0xbb: /* VDSE */
        for (i = 0; i < 8; i++) {
          if (BVDP.mask & (0x80 >> i)) {
            sys_vr_access(t_pe,BVDP.select,BVDP.num[i],_W_,BVDP.d[i][0],BVDP.d[i][1]);     
          }
        }   
        break;
      default: /* internal error */
        message("internal error: VP_DIVP.op=0x%02.2X\n", BVDP.op);
        break;
      }
      if (BVDP.bot) {
        *(unsigned*)&pe[T_PE].vcr[2].ful |= *(unsigned*)&BVDP.vcr2;
        sys_vr_unlock(t_pe, BVDP.select, _W_);
      }
      BVDP.av = 0;
      pe[T_PE].avn_divp--;
    }  
    if (pe[T_PE].avn_divp) {
      for (i = VP_DIVPLEN-1; i > 0; i--) 
        pe[T_PE].vp_divp[i] = pe[T_PE].vp_divp[i-1];
      if (PVDP.bot) {
        *(unsigned*)&TVDP.vcr2 = 0;
        for (i = 0; i < 8; i++)
          TVDP.d[i][0] = TVDP.d[i][1] = 0;
      }
      TVDP.av = 0;
    }

/**********************
*  consume MSK_PIPE   *
**********************/
    if (BVKP.av) {
      switch (BVKP.op) {
      case 0x04: /* VNM */
      case 0x05: /* VOM */
      case 0x06: /* VXM */
      case 0x07: /* VTM */
      case 0x87: /* VGM */
        if (BVKP.bot)
          sys_mr_unlock(t_pe, BVKP.select, _W_, 1);
        for (i = 0; i < 8; i++) {
          if (BVKP.mask & (0x80 >> i)) {
            sys_mr_access(t_pe,BVKP.select,BVKP.num[i],_W_,BVKP.d[i], 1);
          }
        }   
        break;
      case 0xca: /* VSMM */
        if (BVKP.bot) {
          sys_gr_unlock(t_pe,BVKP.num[1]);
          sys_async_gr_access(t_pe,BVKP.num[1],BVKP.u,_W_,BVKP.d[1]);     
        }
        break;
      case 0xcc: /* VFM */
      case 0xcd: /* VFMX */
        if (BVKP.bot) {
          sys_gr_unlock(t_pe,BVKP.num[0]);
          sys_async_gr_access(t_pe,BVKP.num[0],BVKP.u,_W_,BVKP.d[0]);     
        }
        break;
      default: /* internal error */
        message("internal error: VP_MSKP.op=0x%02.2X\n", BVKP.op);
        break;
      }
      if (BVKP.bot)
        *(unsigned*)&pe[T_PE].vcr[2].ful |= *(unsigned*)&BVKP.vcr2;
      BVKP.av = 0;
      pe[T_PE].avn_mskp--;
    }  
    if (pe[T_PE].avn_mskp) {
      for (i = VP_MSKPLEN-1; i > 0; i--) 
        pe[T_PE].vp_mskp[i] = pe[T_PE].vp_mskp[i-1];
      if (PVKP.bot) {
        *(unsigned*)&TVKP.vcr2 = 0;
        for (i = 0; i < 8; i++)
          TVKP.d[i] = 0;
      }
      TVKP.av = 0;
    }
}

vp_consume_queues(t_pe) unsigned t_pe;
{
    unsigned i;

/***********************
*  consume LOAD_QUEUE  *
***********************/
    if (BVLQ.av) {
      pe[T_PE].avn_ldp++;
      TVLP.av     = 1;
      TVLP.op     = BVLQ.op;
      TVLP.mask   = 0;
      (oper_vp[BVLQ.op].func)(t_pe, 'x');
      if (BVLQ.count <= BVLQ.vl)
        TVLP.bot = 0;
      else {
        TVLP.bot = 1;
        TVLP.r_type = BVLQ.r_type;
        TVLP.r_use  = BVLQ.r_use;
        TVLP.u      = BVLQ.u;
        BVLQ.av = 0;

        switch (BVLQ.op) {
        case 0x10: /* VIL */
        case 0x20: /* VILD */
        case 0x30: /* VILE */
	  sys_vr_unlock(t_pe, BVLQ.R1, _R_);
          sys_mr_unlock(t_pe, BVLQ.R4, _R_, 0);
          break;
        case 0x90: /* VL */
        case 0x92: /* VLCP */
        case 0xa0: /* VLD */
        case 0xa2: /* VLCPD */
        case 0xb0: /* VLE */
        case 0xb2: /* VLCPE */
          sys_mr_unlock(t_pe, BVLQ.R4, _R_, 0);
        case 0x80: /* VLM */
          sys_vop_unlock_id(t_pe, BVLQ.R1 >> 5, _R_);
        case 0xd2: /* VLTR */
          break;
        default: /* internal error */
          message("internal error: VP_LDQ.op=0x%02.2X\n", BVLQ.op);
          break;
        }
      }
      if (!BVLQ.av)
        pe[T_PE].avn_ldq--;
    }  
    if (!BVLQ.av && pe[T_PE].avn_ldq) {
      for (i = VP_LDQNUM-1; i > 0; i--) 
        pe[T_PE].vp_ldq[i] = pe[T_PE].vp_ldq[i-1];
      TVLQ.av = 0;
    }

/***********************
*  consume STORE_QUEUE *
***********************/
    if (BVSQ.av) {
      pe[T_PE].avn_stp++;
      TVSP.av     = 1;
      TVSP.op     = BVSQ.op;
      TVSP.mask   = 0;
      (oper_vp[BVSQ.op].func)(t_pe, 'x');
      if (BVSQ.count <= BVSQ.vl)
        TVSP.bot = 0;
      else {
        TVSP.bot = 1;
        TVSP.r_type = BVSQ.r_type;
        TVSP.r_use  = BVSQ.r_use;
        TVSP.u      = BVSQ.u;
        TVSP.id     = BVSQ.R1 >> 5;
        BVSQ.av = 0;

        switch (BVSQ.op) {
        case 0x11: /* VIST */
        case 0x21: /* VISTD */
        case 0x31: /* VISTE */
	  sys_vr_unlock(t_pe, BVSQ.R1, _R_);
        case 0x91: /* VST */
        case 0x93: /* VSTX */
        case 0xa1: /* VSTD */
        case 0xa3: /* VSTXD */
        case 0xb1: /* VSTE */
        case 0xb3: /* VSTXE */
	  sys_vr_unlock(t_pe, BVSQ.R2, _R_);
	  sys_mr_unlock(t_pe, BVSQ.R4, _R_, 0);
          break;
        case 0x81: /* VSTM */
	  sys_mr_unlock(t_pe, BVSQ.R2, _R_, 1);
          break;
        default: /* internal error */
          message("internal error: VP_STQ.op=0x%02.2X\n", BVSQ.op);
          break;
        }
      }
      if (!BVSQ.av)
        pe[T_PE].avn_stq--;
    }  
    if (!BVSQ.av && pe[T_PE].avn_stq) {
      for (i = VP_STQNUM-1; i > 0; i--) 
        pe[T_PE].vp_stq[i] = pe[T_PE].vp_stq[i-1];
      TVSQ.av = 0;
    }

/***********************
*  consume ADD_QUEUE   *
***********************/
    if (BVAQ.av) {
      pe[T_PE].avn_addp++;
      TVAP.av     = 1;
      TVAP.op     = BVAQ.op;
      TVAP.mask   = 0;
      (oper_vp[BVAQ.op].func)(t_pe, 'x');
      if (BVAQ.count <= BVAQ.vl)
        TVAP.bot = 0;
      else {
        TVAP.bot = 1;
        TVAP.r_type = BVAQ.r_type;
        TVAP.r_use  = BVAQ.r_use;
        TVAP.u      = BVAQ.u;
        BVAQ.av = 0;

        switch (BVAQ.op) {
        case 0x14: /* VN */       case 0x15: /* VO */
        case 0x16: /* VX */       case 0x17: /* VESLL */
        case 0x18: /* VA */       case 0x19: /* VS */
        case 0x28: /* VAD */      case 0x29: /* VSD */     
        case 0x38: /* VAE */      case 0x39: /* VSE */
        case 0x50: /* VCF */      case 0x51: /* VCH */
        case 0x52: /* VCL */      case 0x53: /* VCNE */
        case 0x54: /* VCE */      case 0x55: /* VCNL */
        case 0x56: /* VCNH */     case 0x57: /* VCT */
        case 0x60: /* VCFD */     case 0x61: /* VCHD */
        case 0x62: /* VCLD */     case 0x63: /* VCNED */
        case 0x64: /* VCED */     case 0x65: /* VCNLD */
        case 0x66: /* VCNHD */    case 0x67: /* VCTD */
        case 0x70: /* VCFE */     case 0x71: /* VCHE */
        case 0x72: /* VCLE */     case 0x73: /* VCNEE */
        case 0x74: /* VCEE */     case 0x75: /* VCNLE */
        case 0x76: /* VCNHE */    case 0x77: /* VCTE */
          sys_vr_unlock(t_pe, BVAQ.R1, _R_);
        case 0x1c: /* VLR */      case 0x1e: /* VLP */
        case 0x24: /* VVID */     case 0x25: /* VVDI */
        case 0x26: /* VVED */     case 0x2e: /* VLPD */
        case 0x34: /* VVIE */     case 0x35: /* VVEI */
        case 0x36: /* VVDE */     case 0x3e: /* VLPE */
        case 0x58: /* VCSF */     case 0x59: /* VCSH */
        case 0x5a: /* VCSL */     case 0x5b: /* VCSNE */
        case 0x5c: /* VCSE */     case 0x5d: /* VCSNL */
        case 0x5e: /* VCSNH */    case 0x5f: /* VCST */
        case 0x68: /* VCSFD */    case 0x69: /* VCSHD */
        case 0x6a: /* VCSLD */    case 0x6b: /* VCSNED */
        case 0x6c: /* VCSED */    case 0x6d: /* VCSNLD */
        case 0x6e: /* VCSNHD */   case 0x6f: /* VCSTD */
        case 0x78: /* VCSFE */    case 0x79: /* VCSHE */
        case 0x7a: /* VCSLE */    case 0x7b: /* VCSNEE */
        case 0x7c: /* VCSEE */    case 0x7d: /* VCSNLE */
        case 0x7e: /* VCSNHE */   case 0x7f: /* VCSTE */
        case 0x94: /* VNS */      case 0x95: /* VOS */
        case 0x96: /* VXS */      case 0x98: /* VAS */
        case 0x99: /* VSS */      case 0xa7: /* VSRL */
        case 0xa8: /* VASD */     case 0xa9: /* VSSD */
        case 0xb7: /* VSLL */     case 0xb8: /* VASE */
        case 0xb9: /* VSSE */
          sys_vr_unlock(t_pe, BVAQ.R2, _R_);
          sys_mr_unlock(t_pe, BVAQ.R4, _R_, 0);
          break;
        case 0xd8: /* VTS */
        case 0xe8: /* VTSD */
        case 0xf8: /* VTSE */
          TVAP.num[1] = BVAQ.R3 & 0x1f;
          sys_vr_unlock(t_pe, BVAQ.R2, _R_);
          break;
        case 0xda: /* VSM */
        case 0xea: /* VSMD */
        case 0xfa: /* VSME */
          TVAP.d[1][0] = BVAQ.vsmw[0][0];
          TVAP.d[1][1] = BVAQ.vsmw[0][1];
        case 0xdc: /* VFX */
        case 0xdd: /* VFXX */
        case 0xde: /* VFN */
        case 0xdf: /* VFNX */
        case 0xec: /* VFXD */
        case 0xed: /* VFXDX */
        case 0xee: /* VFND */
        case 0xef: /* VFNDX */
        case 0xfc: /* VFXE */
        case 0xfd: /* VFXEX */
        case 0xfe: /* VFNE */
        case 0xff: /* VFNEX */
          TVAP.num[0] = BVAQ.R2 & 0x1f;
          TVAP.num[1] = BVAQ.R3 & 0x1f;
          sys_vr_unlock(t_pe, BVAQ.R1, _R_);
	case 0x9e: /* VLS */ 
        case 0xae: /* VLSD */
        case 0xbe: /* VLSE */
          sys_mr_unlock(t_pe, BVAQ.R4, _R_, 0);
          break;
        default: /* internal error */
          message("internal error: VP_ADDQ.op=0x%02.2X\n", BVAQ.op);
          break;
        }
      }
      if (!BVAQ.av)
        pe[T_PE].avn_addq--;
    }  
    if (!BVAQ.av && pe[T_PE].avn_addq) {
      for (i = VP_ADDQNUM-1; i > 0; i--) 
        pe[T_PE].vp_addq[i] = pe[T_PE].vp_addq[i-1];
      TVAQ.av = 0;
    }

/***********************
*  consume MUL_QUEUE   *
***********************/
    if (BVMQ.av) {
      pe[T_PE].avn_mulp++;
      TVMP.av     = 1;
      TVMP.op     = BVMQ.op;
      TVMP.mask   = 0;
      (oper_vp[BVMQ.op].func)(t_pe, 'x');
      if (BVMQ.count <= BVMQ.vl)
        TVMP.bot = 0;
      else {
        TVMP.bot = 1;
        TVMP.r_type = BVMQ.r_type;
        TVMP.r_use  = BVMQ.r_use;
        TVMP.u      = BVMQ.u;
        BVMQ.av = 0;

        switch (BVMQ.op) {
        case 0x1a: /* VM */
        case 0x2a: /* VMD */
        case 0x3a: /* VME */
	  sys_vr_unlock(t_pe, BVMQ.R1, _R_);
        case 0x9a: /* VMS */
        case 0xaa: /* VMSD */
        case 0xba: /* VMSE */
	  sys_vr_unlock(t_pe, BVMQ.R2, _R_);
        case 0x8a: /* VGS */
	  sys_mr_unlock(t_pe, BVMQ.R4, _R_, 0);
          break;
        default: /* internal error */
          message("internal error: VP_MULQ.op=0x%02.2X\n", BVMQ.op);
          break;
        }
      }
      if (!BVMQ.av)
        pe[T_PE].avn_mulq--;
    }  
    if (!BVMQ.av && pe[T_PE].avn_mulq) {
      for (i = VP_MULQNUM-1; i > 0; i--) 
        pe[T_PE].vp_mulq[i] = pe[T_PE].vp_mulq[i-1];
      TVMQ.av = 0;
    }

/***********************
*  consume DIV_QUEUE   *
***********************/
    if (BVDQ.av) {
      pe[T_PE].avn_divp++;
      TVDP.av     = 1;
      TVDP.op     = BVDQ.op;
      TVDP.mask   = 0;
      (oper_vp[BVDQ.op].func)(t_pe, 'x');
      if (BVDQ.count <= BVDQ.vl)
        TVDP.bot = 0;
      else {
        TVDP.bot = 1;
        TVDP.r_type = BVDQ.r_type;
        TVDP.r_use  = BVDQ.r_use;
        TVDP.u      = BVDQ.u;
        BVDQ.av = 0;

        switch (BVDQ.op) {
        case 0x2b: /* VDD */
        case 0x3b: /* VDE */
	  sys_vr_unlock(t_pe, BVDQ.R1, _R_);
        case 0xab: /* VDSD */
        case 0xbb: /* VDSE */
	  sys_vr_unlock(t_pe, BVDQ.R2, _R_);
	  sys_mr_unlock(t_pe, BVDQ.R4, _R_, 0);
          break;
        default: /* internal error */
          message("internal error: VP_DIVQ.op=0x%02.2X\n", BVDQ.op);
          break;
        }
      }
      if (!BVDQ.av)
        pe[T_PE].avn_divq--;
    }  
    if (!BVDQ.av && pe[T_PE].avn_divq) {
      for (i = VP_DIVQNUM-1; i > 0; i--) 
        pe[T_PE].vp_divq[i] = pe[T_PE].vp_divq[i-1];
      TVDQ.av = 0;
    }

/***********************
*  consume MSK_QUEUE   *
***********************/
    if (BVKQ.av) {
      pe[T_PE].avn_mskp++;
      TVKP.av     = 1;
      TVKP.op     = BVKQ.op;
      TVKP.mask   = 0;
      (oper_vp[BVKQ.op].func)(t_pe, 'x');
      if (BVKQ.count <= BVKQ.vl)
        TVKP.bot = 0;
      else {
        TVKP.bot = 1;
        TVKP.r_type = BVKQ.r_type;
        TVKP.r_use  = BVKQ.r_use;
        TVKP.u      = BVKQ.u;
        BVKQ.av = 0;

        switch (BVKQ.op) {
        case 0x04: /* VNM */
        case 0x05: /* VOM */
        case 0x06: /* VXM */
          sys_mr_unlock(t_pe, BVKQ.R1, _R_, 1);
        case 0x07: /* VTM */
          sys_mr_unlock(t_pe, BVKQ.R2, _R_, 1);
          break;
        case 0xca: /* VSMM */
          TVKP.num[1] = BVKQ.R3 & 0x1f;
          sys_mr_unlock(t_pe, BVKQ.R1, _R_, 1);
          break;
        case 0xcc: /* VFM */
        case 0xcd: /* VFMX */
          TVKP.num[0] = BVKQ.R2 & 0x1f;
          sys_mr_unlock(t_pe, BVKQ.R1, _R_, 1);
          break;
        case 0x87: /* VGM */
          break;
        default: /* internal error */
          message("internal error: VP_MSKQ.op=0x%02.2X\n", BVKQ.op);
          break;
        }
      }
      if (!BVKQ.av)
        pe[T_PE].avn_mskq--;
    }  
    if (!BVKQ.av && pe[T_PE].avn_mskq) {
      for (i = VP_MSKQNUM-1; i > 0; i--) 
        pe[T_PE].vp_mskq[i] = pe[T_PE].vp_mskq[i-1];
      TVKQ.av = 0;
    }
}

vp_consume_mcqueues(t_pe) unsigned t_pe;
{
    unsigned i;

/***********************
*  consume OPMQ        *
***********************/
    if (BVOM.av) {
      switch (oper_vp[BVOM.op].type) {
      case O_VL:
      case O_VLI:
        if (!TVLQ.av) {	
          pe[T_PE].avn_ldq++;
          TVLQ = BVOM;
          BVOM.av = 0;
        }
        break;
      case O_VS:
      case O_VSI:
        if (!TVSQ.av && !pe[T_PE].avn_divq && !pe[T_PE].avn_divp) {	
          pe[T_PE].avn_stq++;
          TVSQ = BVOM;
          BVOM.av = 0;
        }
        break;
      default: /* internal error */
        message("internal error: VP_OPMQ.op=0x%02.2X\n", BVOM.op);
	BVOM.av = 0;
        break;
      }
      if (!BVOM.av)
        pe[T_PE].avn_opmq--;
    }  
    if (!BVOM.av && pe[T_PE].avn_opmq) {
      for (i = VP_OPMQNUM-1; i > 0; i--) 
        pe[T_PE].vp_opmq[i] = pe[T_PE].vp_opmq[i-1];
      TVOM.av = 0;
    }

/***********************
*  consume OPCQ        *
***********************/
    if (BVOC.av) {
      switch (oper_vp[BVOC.op].type) {
      case O_VA:
        if (!TVAQ.av) {	
          pe[T_PE].avn_addq++;
          TVAQ = BVOC;
          BVOC.av = 0;
        }
        break;
      case O_VM:
        if (!TVMQ.av) {	
          pe[T_PE].avn_mulq++;
          TVMQ = BVOC;
          BVOC.av = 0;
        }
        break;
      case O_VD:
        if (!TVDQ.av && !pe[T_PE].avn_stq && !pe[T_PE].avn_stp) {	
          pe[T_PE].avn_divq++;
          TVDQ = BVOC;
          BVOC.av = 0;
        }
        break;
      case O_VK:
        if (!TVKQ.av) {	
          pe[T_PE].avn_mskq++;
          TVKQ = BVOC;
          BVOC.av = 0;
        }
        break;
      default: /* internal error */
        message("internal error: VP_OPCQ.op=0x%02.2X\n", BVOC.op);
	BVOC.av = 0;
        break;
      }
      if (!BVOC.av)
        pe[T_PE].avn_opcq--;
    }  
    if (!BVOC.av && pe[T_PE].avn_opcq) {
      for (i = VP_OPCQNUM-1; i > 0; i--) 
        pe[T_PE].vp_opcq[i] = pe[T_PE].vp_opcq[i-1];
      TVOC.av = 0;
    }
}

vp_consume_iqueues(t_pe) unsigned t_pe;
{
    unsigned i;

/***********************
*  consume OPIQ        *
***********************/
    if (BVOI.av) {

      BVOI.node     = pe[T_PE].vcr[1].vcr1.vt?'v':'r';
      BVOI.vl       = pe[T_PE].vcr[0].vcr0.vl;
      BVOI.count    = 1;
      BVOI.compress = 1;

      switch (oper_vp[BVOI.op].type) {
      case O_VL:
      case O_VLI:
      case O_VS:
      case O_VSI:
        if (!TVOM.av) {	
          if ((!pe[T_PE].vcr[1].vcr1.v  && !oper_vp[BVOI.op].v)
           || ( pe[T_PE].vcr[0].vcr0.rx &&  oper_vp[BVOI.op].rx)) {
            pe[T_PE].vcr[2].vcr2.pif_opx = 1;
            goto cop_abort;
            break;
          }
	  if (((BVOI.r_type & oper_vp[BVOI.op].r_type_mask) != oper_vp[BVOI.op].r_type_match)
           || ((BVOI.r_use  & oper_vp[BVOI.op].r_use_mask ) != oper_vp[BVOI.op].r_use_match)) {
            pe[T_PE].vcr[2].vcr2.pif_opx = 1;
            goto cop_abort;
            break;
          }
          if (pe[T_PE].sr[PEV].pev.u && oper_vp[BVOI.op].p) {
            pe[T_PE].vcr[2].vcr2.pif_pox = 1;
            goto cop_abort;
            break;
          }
          switch ((oper_vp[BVOI.op].func)(t_pe, 'c')) {
          case SCORE_FREE:
            (oper_vp[BVOI.op].func)(t_pe, 'r');
            COP_unlock(t_pe, BVOI.r_type, BVOI.r_use, BVOI.R1, BVOI.R2, BVOI.R3, _R_);
            pe[T_PE].avn_opmq++;
            TVOM = BVOI;
            BVOI.av = 0;
	    break;
	  case SCORE_BUSY:
	    break;
	  case SCORE_EXCEPTION:
            goto cop_abort;
            break;
          }
        }
        break;
      case O_VA:
      case O_VM:
      case O_VD:
      case O_VK:
        if (!TVOC.av) {	
          if ((!pe[T_PE].vcr[1].vcr1.v  && !oper_vp[BVOI.op].v)
           || ( pe[T_PE].vcr[0].vcr0.rx &&  oper_vp[BVOI.op].rx)) {
            pe[T_PE].vcr[2].vcr2.pif_opx = 1;
            goto cop_abort;
            break;
          }
	  if (((BVOI.r_type & oper_vp[BVOI.op].r_type_mask) != oper_vp[BVOI.op].r_type_match)
           || ((BVOI.r_use  & oper_vp[BVOI.op].r_use_mask ) != oper_vp[BVOI.op].r_use_match)) {
            pe[T_PE].vcr[2].vcr2.pif_opx = 1;
            goto cop_abort;
            break;
          }
          if (pe[T_PE].sr[PEV].pev.u && oper_vp[BVOI.op].p) {
            pe[T_PE].vcr[2].vcr2.pif_pox = 1;
            goto cop_abort;
            break;
          }
          switch ((oper_vp[BVOI.op].func)(t_pe, 'c')) {
          case SCORE_FREE:
            (oper_vp[BVOI.op].func)(t_pe, 'r');
            COP_unlock(t_pe, BVOI.r_type, BVOI.r_use, BVOI.R1, BVOI.R2, BVOI.R3, _R_);
            pe[T_PE].avn_opcq++;
            TVOC = BVOI;
            BVOI.av = 0;
	    break;
	  case SCORE_BUSY:
	    break;
	  case SCORE_EXCEPTION:
            goto cop_abort;
            break;
          }
        }
        break;
      case O_VN:
        if ((!pe[T_PE].vcr[1].vcr1.v  && !oper_vp[BVOI.op].v)
         || ( pe[T_PE].vcr[0].vcr0.rx &&  oper_vp[BVOI.op].rx)) {
          pe[T_PE].vcr[2].vcr2.pif_opx = 1;
          goto cop_abort;
          break;
        }
	if (((BVOI.r_type & oper_vp[BVOI.op].r_type_mask) != oper_vp[BVOI.op].r_type_match)
         || ((BVOI.r_use  & oper_vp[BVOI.op].r_use_mask ) != oper_vp[BVOI.op].r_use_match)) {
          pe[T_PE].vcr[2].vcr2.pif_opx = 1;
          goto cop_abort;
          break;
        }
        if (pe[T_PE].sr[PEV].pev.u && oper_vp[BVOI.op].p) {
          pe[T_PE].vcr[2].vcr2.pif_pox = 1;
          goto cop_abort;
          break;
        }
        switch ((oper_vp[BVOI.op].func)(t_pe, 'c')) {
        case SCORE_FREE:
          (oper_vp[BVOI.op].func)(t_pe, 'r');
          (oper_vp[BVOI.op].func)(t_pe, 'x');
          if (!BVOI.av)
            COP_unlock(t_pe, BVOI.r_type, BVOI.r_use, BVOI.R1, BVOI.R2, BVOI.R3, _R_);
	  break;
	case SCORE_BUSY:
	  break;
	case SCORE_EXCEPTION:
          goto cop_abort;
          break;
        }
        break;
      default: /* unknown operation */
        pe[T_PE].vcr[2].vcr2.pif_opx = 1;

cop_abort:
        COP_unlock(t_pe, BVOI.r_type, BVOI.r_use, BVOI.R1, BVOI.R2, BVOI.R3, _A_);
	BVOI.av = 0;
        break;
      }
      if (!BVOI.av)
        pe[T_PE].avn_opiq--;
    }  
    if (!BVOI.av && pe[T_PE].avn_opiq) {
      for (i = VP_OPIQNUM-1; i > 0; i--) 
        pe[T_PE].vp_opiq[i] = pe[T_PE].vp_opiq[i-1];
      TVOI.av = 0;
    }
}

#endif

