static char SccsId[] = "@(#)dapf.c	1.5    9/27/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* dapf.c    91/3/11 */

#ifdef DAPF

#include "tim.h"

sim_dapf(t_pe)
    unsigned t_pe;
{
    struct   tm *tm;
    long     ntime;
    unsigned ibuf[20];
    unsigned char *cbuf = (unsigned char*) ibuf;
    unsigned svsqna, svsqn, svsqsa, svsql;
    unsigned svsqba, svsqb;
    unsigned nphssa, retc_pre, retc, status;
    unsigned daprba, daprb, ssp, d, d2, i, N;
    unsigned sapccc, sapcadr, abs_sapcadr;
    unsigned devno, len;
    unsigned char *addr, c;

    if (pe[T_PE].dapf_sapc_pending == 4 || pe[T_PE].dapf_delay_count) {
      if (pe[T_PE].dapf_sapc_pending == 4 || !--pe[T_PE].dapf_delay_count) {

        clearsvpmes();

        if (svp_mem_access(t_pe,HSATBASE,4,_R_,&d)
         || d != ('H'<<24)+('S'<<16)+('A'<<8)+'T')
          addsvpmes("PE#%u: can't find HSAT (in HSA)\n", t_pe);

        else if (svp_mem_access(t_pe,HSATBASE+0x20,4,_R_,&d)
         || d != ('S'<<24)+('V'<<16)+('S'<<8)+'Q'
         || svp_mem_access(t_pe,HSATBASE+0x28,4,_R_,&svsqsa)
         || svp_mem_access(t_pe,HSATBASE+0x2c,4,_R_,&svsql))
          addsvpmes("PE#%u: can't find SVSQ (in HSA)\n", t_pe);

        else if ((svsqsa & 255) || (svsql & 255))
          addsvpmes("PE#%u: SVSQSA or SVSQL not aligned (in HSA)\n", t_pe);

        else if (svsql < 1024)
          addsvpmes("PE#%u: SVSQL < 1024 (in HSA)\n", t_pe);

        else if (svp_mem_access(t_pe,HSATBASE+0x50,4,_R_,&d)
         || d != ('N'<<24)+('P'<<16)+('H'<<8)+'S'
         || svp_mem_access(t_pe,HSATBASE+0x58,4,_R_,&nphssa))
          addsvpmes("PE#%u: can't find NPHS (in HSA)\n", t_pe);

        else if (nphssa & 65535)
          addsvpmes("PE#%u: NPHSSA not aligned (in HSA)\n", t_pe);

        else if (svp_mem_access(t_pe,nphssa+4,4,_R_,&daprba))
          addsvpmes("PE#%u: can't find DAPRBA (in NPHS)\n", t_pe);

        else {
          if (daprba & 31)
            retc_pre = 1;

          else if (svp_mem_access(t_pe,daprba,4,_R_,&daprb))
            retc_pre = 2;

          else if (svp_mem_access(t_pe,daprba+4,4,_R_,&ssp))
            retc_pre = 2;

          else if (pe[T_PE].dapf_sapc_pending != 4) { /* not attention */
            retc_pre = 0;
            retc = 0;

            switch (daprb >> 16) {
            case 0x0020: /* Store Real Clock */
              ntime = time(0);
              tm = localtime(&ntime);
              d = (( tm->tm_year  /10<<4) + ( tm->tm_year  %10) << 24)
                + (((tm->tm_mon+1)/10<<4) + ((tm->tm_mon+1)%10) << 16)
                + (( tm->tm_mday  /10<<4) + ( tm->tm_mday  %10) << 8)
	        + (( tm->tm_hour  /10<<4) + ( tm->tm_hour  %10));
              d2= (( tm->tm_min   /10<<4) + ( tm->tm_min   %10) << 24)
	        + (( tm->tm_sec   /10<<4) + ( tm->tm_sec   %10) << 16)
	        + 0x8900;
              if (svp_mem_access(t_pe,daprba+0x20,4,_W_,&d)
               || svp_mem_access(t_pe,daprba+0x24,4,_W_,&d2))
                retc = 0x20000000;
	      svp_mem_access(t_pe,daprba+0x10,4,_W_,&retc);
              break;

            case 0x0030: /* Write Console */
              for (i=0; i<20; i++) {
                if (svp_mem_access(t_pe,daprba+0x20+i*4,4,_R_,&ibuf[i])) {
                  retc = 0x20000000;
                  break;
                }
              }
              if (!retc) {
                a2a1024(cbuf+2, *cbuf*256+*(cbuf+1));
                addsvpmes("%s", cbuf+2);
              }
	      svp_mem_access(t_pe,daprba+0x10,4,_W_,&retc);
              break;

	    case 0xf002: /* Execute Pseudo I/O Function */
              if (svp_mem_access(t_pe,daprba+0x14,4,_R_,ibuf))
                retc = 0x20000000;
              else if (*ibuf >> 24 == 0) {
                devno = *ibuf & 0xffff;
                if (svp_mem_access(t_pe,daprba+0x20,4,_R_,ibuf))
                  retc = 0x20000000;
	        else {
                  sapccc  = *ibuf >> 24;
		  sapcadr = *ibuf & 0x00ffffff;
		  switch (sapccc) {
		  case 1: /* Write */
		    if (get_abs_addr(t_pe, _R_, sapcadr, &abs_sapcadr, 's'))
                      retc = 0x20000000;
		    else if (!cout_fd) {
                      addsvpmes("PE#%u: lost connection for simulator->console\n", t_pe);
                      retc = 0x20000000;
                    }
                    else if (devno == 0) { /* console */
	              write(cout_fd, "%stat-leading-sapcwrt", 21);
	              write(cout_fd, &pe[T_PE].mem[abs_sapcadr+4], SAPCIMAGE);
                      status = 0x0c000000;
	              svp_mem_access(t_pe,daprba+0x1c,4,_W_,&status);
		      retc = 0x04000000;
                    }
                    else if (devno == 1) { /* printer */
                      addr = &pe[T_PE].mem[abs_sapcadr];
                      len = strlen(addr);
                      for (i=0; i<len; i++) {
                        c = *(addr+i);
                        e2a1024(&c, 1);
	                write(cout_fd, &c, 1);
                        if (c == '\n') {
                          c = '\r';
	                  write(cout_fd, &c, 1);
                        }
                      }
                      status = 0x0c000000;
	              svp_mem_access(t_pe,daprba+0x1c,4,_W_,&status);
		      retc = 0x04000000;
                    }
                    break;

		  case 2: /* Read buffer */
		    if (!cout_fd) {
                      addsvpmes("PE#%u: lost connection for simulator->console\n", t_pe);
                      retc = 0x20000000;
                    }
                    else {
	              write(cout_fd, "%stat-leading-sapcred", 21);
 		      while (pe[T_PE].dapf_sapc_pending != 6) { /* wait for SIGUSR2 */
		        if (poll_interruption())
                          break;
                      }
 		      pe[T_PE].dapf_sapc_pending = 0;
                      for (i=0; i<SAPCFRAME; i++) {
                        if (svp_mem_access(t_pe,sapcadr+i,1,_W_,&pe[T_PE].dapf_sapc[i])) {
                          retc = 0x20000000;
                          break;
                        }
                      }
                      if (!retc) {
                        status = 0x0c000000;
	                svp_mem_access(t_pe,daprba+0x1c,4,_W_,&status);
		        retc = 0x04000000;
                      }
                    }
                    break;

                  default: /* nop */
		    break;
                  }
                }
              }
	      svp_mem_access(t_pe,daprba+0x10,4,_W_,&retc);
	      break;

	    case 0xf003: /* Control Pseudo I/O Action */
	      break;

            default:
              user_dapf(t_pe, daprb >> 16, daprba);
              break;
            }
          }

          svsqna = HSATBASE + 0x24;
          svsqba = nphssa + 8;
          N      = svsql / 256;

          if (svp_mem_access(t_pe,svsqna,4,_R_,&svsqn))
            addsvpmes("PE#%u: can't read SVSQN (in HSA)\n", t_pe);

          else if (svp_mem_access(t_pe,svsqba,4,_R_,&svsqb))
            addsvpmes("PE#%u: can't read SVSQB (in NPHS)\n", t_pe);

          else if ((svsqn + 1) % N == svsqb % N) {
            /* discard report */
          }
          else if ((svsqn + 2) % N == svsqb % N) {
            /* queue is full */
            d = 0x10800000;
            if (svp_mem_access(t_pe,svsqsa+svsqn*256,4,_W_,&d))
              addsvpmes("PE#%u: can't write SVSQ\n", t_pe);
            else if ((svsqn = (svsqn + 1) % N), svp_mem_access(t_pe,svsqna,4,_W_,&svsqn))
              addsvpmes("PE#%u: can't write SVSQN (in HSA)\n", t_pe);
          }
          else {
            if (pe[T_PE].dapf_sapc_pending == 4) { /* attention */
              pe[T_PE].dapf_sapc_pending = 0;
              d  = 0xf0800000;
              if (svp_mem_access(t_pe,svsqsa+svsqn*256  ,4,_W_,&d)
               || svp_mem_access(t_pe,svsqsa+svsqn*256+4,4,_W_,&d))
                addsvpmes("PE#%u: can't write SVSQ\n", t_pe);
              else if ((svsqn = (svsqn + 1) % N), svp_mem_access(t_pe,svsqna,4,_W_,&svsqn))
                addsvpmes("PE#%u: can't write SVSQN (in HSA)\n", t_pe);
            }
            else { /* not attention */
              d   = 0x00800000 | (retc_pre << 8);
              d2  = 0;
              if (svp_mem_access(t_pe,svsqsa+svsqn*256   ,4,_W_,&d)
               || svp_mem_access(t_pe,svsqsa+svsqn*256+ 4,4,_W_,&ssp)
               || svp_mem_access(t_pe,svsqsa+svsqn*256+ 8,4,_W_,&d2)
               || svp_mem_access(t_pe,svsqsa+svsqn*256+12,4,_W_,&daprba))
                addsvpmes("PE#%u: can't write SVSQ\n", t_pe);
              else if ((svsqn = (svsqn + 1) % N), svp_mem_access(t_pe,svsqna,4,_W_,&svsqn))
                addsvpmes("PE#%u: can't write SVSQN (in HSA)\n", t_pe);
            }
          }

          pe[T_PE].mcr[SVSCTL].svsctl.svsrp = 1;
          pe[T_PE].dapf_status = STATUS_DSLEEP;
        }
        prtsvpmes();
      }
    }

    if (pe[T_PE].smcr[SDAPSG].ful) { /* get start command */
      if (pe[T_PE].dapf_status == STATUS_DSLEEP) {
        pe[T_PE].dapf_status = STATUS_DBUSY;
        pe[T_PE].dapf_delay_count = DAPF_DMA_DELAY;
      }
      pe[T_PE].smcr[SDAPSG].ful = 0;
    }

    if (pe[T_PE].mcr[SVSCTL].ful)
      pe[T_PE].ext_interrupt |= SVS_INTERRUPT;
}

static char ascii[] =
{  0,  0,  0,  0,  0,'\t', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,'\n', 0,  0,'\r', 0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
 ' ',  0,  0,  0,  0,  0,  0,  0,  0,  0,'.','.','<','(','+','|',
 '&',  0,  0,  0,  0,  0,  0,  0,  0,  0,'!','\\','*',')',';','^',
 '-','/',  0,  0,  0,  0,  0,  0,  0,  0,'|',',','%','_','>','?',
   0,  0,  0,  0,  0,  0,  0,  0,  0,'`',':','#','@','\'','=','\"',
   0,'a','b','c','d','e','f','g','h','i',  0,  0,  0,  0,  0,  0,
   0,'j','k','l','m','n','o','p','q','r',  0,  0,  0,  0,  0,  0,
   0,'~','s','t','u','v','w','x','y','z',  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
 '{','A','B','C','D','E','F','G','H','I',  0,  0,  0,  0,  0,  0,
 '}','J','K','L','M','N','O','P','Q','R',  0,  0,  0,  0,  0,  0,
 '$',  0,'S','T','U','V','W','X','Y','Z',  0,  0,  0,  0,  0,  0,
 '0','1','2','3','4','5','6','7','8','9',  0,  0,  0,  0,  0,  0};

static char ebcdic[] = 
{ 
 0x00, 0x01, 0x02, 0x03, 0x37, 0x2d, 0x2e, 0x2f,
 0x16, 0x05, 0x15, 0x0b, 0x00, 0x0d, 0x0e, 0x0f,
 0x10, 0x11, 0x12, 0x13, 0x3c, 0x3d, 0x32, 0x26,
 0x18, 0x19, 0x3f, 0x27, 0x22, 0x00, 0x00, 0x00,
 0x40, 0x4f, 0x7f, 0x7b, 0x5b, 0x6c, 0x50, 0x7d,
 0x4d, 0x5d, 0x5c, 0x4e, 0x6b, 0x60, 0x4b, 0x61,
 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
 0xf8, 0xf9, 0x7a, 0x5e, 0x4c, 0x7e, 0x6e, 0x6f,
 0x7c, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
 0xc8, 0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6,
 0xd7, 0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6,
 0xe7, 0xe8, 0xe9, 0x4a, 0xe0, 0x5a, 0x5f, 0x6d,
 0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
 0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,
 0x97, 0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6,
 0xa7, 0xa8, 0xa9, 0xc0, 0x6a, 0xd0, 0xa1, 0x07,

 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

a2a1024(s, len) unsigned char *s; unsigned len;
{
        unsigned col;

        if (len > 1024)
            len = 1024;

	for (col = 0; col < len; col++, s++);

        *s = NULL;
}

e2a1024(s, len) unsigned char *s; unsigned len;
{
        unsigned col;

        if (len > 1024)
            len = 1024;

	for (col = 0; col < len; col++, s++)
	    *s = ascii[*s];

        *s = NULL;
}

a2e1024(s, len) unsigned char *s; unsigned len;
{
        unsigned col;

        if (len > 1024)
            len = 1024;

	for (col = 0; col < len; col++, s++)
	    *s = ebcdic[*s];
}

#endif

