static char SccsId[] = "@(#)dasd.c	1.4    10/24/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* dasd.c   90/8/29 */

#ifdef DASD

#include "tim.h"

dasd_reg_reactor(t_pe, t_fsba)
    unsigned t_pe, t_fsba;
{
    unsigned 	   da, bc, i;
    unsigned short status;
    unsigned char  d;

    if (pe[T_PE].acr.arst) {
      /* reset register */
      pe[T_PE].dasd_status = STATUS_NORMAL;
      pe[T_PE].fsrq[T_FSBA][DASD_SLOTID].count  = 0;
      pe[T_PE].acr.arst  = 0;
      pe[T_PE].acr.absy  = 0;
      pe[T_PE].acr.ainp  = 0;
      pe[T_PE].acr.dbsy  = 0;
      pe[T_PE].acr.aint  = 0;
      pe[T_PE].acr.idsw  = 0;
      pe[T_PE].acr.perr  = 0;
      pe[T_PE].acr.aerr  = 0;
    }
    else if (pe[T_PE].acr.aexc) {
      pe[T_PE].acr.aexc = 0;

      switch (pe[T_PE].acr.aoc) {
      case 0x02: /* IRCV  */
        if (pe[T_PE].acr.dva != DASD_DVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }
        if (pe[T_PE].acr.dbsy || (!pe[T_PE].acr.aint && !pe[T_PE].acr.ainp)) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 3;
          pe[T_PE].acr.ictl1 = 0;
          return;
        }

        pe[T_PE].acr.aint = 0; 
        pe[T_PE].acr.ainp = 0; 

        if (pe[T_PE].dasd_status == STATUS_PCI) {
          pe[T_PE].fsrq[T_FSBA][DASD_SLOTID].count = DASD_DMA_DELAY;
          pe[T_PE].acr.dbsy = 1;
        }

        break;

      case 0x03: /* SDCR  */
        if (pe[T_PE].acr.dva != DASD_DVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }
        if (pe[T_PE].acr.dbsy || pe[T_PE].acr.aint || pe[T_PE].acr.ainp) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 3;
          pe[T_PE].acr.ictl1 = 0;
          return;
        }
        if (sys_fop_access(t_pe, pe[T_PE].dcba, 4, _R_, &pe[T_PE].dcwa) != RW_SUCCESS
         || pe[T_PE].dcwa & 31
         || sys_fop_access(t_pe, pe[T_PE].dcwa, 4, _R_, &bc) != RW_SUCCESS) {
          dasd_update_status(t_pe, 0x20, 0x02, 0x01); /* PC, DCW, ADDR */
          return;
        }

        /* prepare DMA transmission */
        pe[T_PE].fsrq[T_FSBA][DASD_SLOTID].count = (bc & 0xffff) + DASD_DMA_DELAY;
        pe[T_PE].acr.dbsy = 1;
        pe[T_PE].dacr = pe[T_PE].acr;
        break;

      case 0x06: /* HDCR  */
        if (pe[T_PE].acr.dva != DASD_DVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }
        if (!pe[T_PE].acr.aint && !pe[T_PE].acr.ainp) {
          pe[T_PE].fsrq[T_FSBA][DASD_SLOTID].count  = 0;
          pe[T_PE].acr.dbsy = 0;
          dasd_update_status(t_pe, 0xc00, 0, 0); /* AE/DE */
          return;
        }
        break;

      case 0x08: /* RIDU  */
        pe[T_PE].acr.ictl0 = 0x80; 
        pe[T_PE].acr.ictl1 = 0x06; 
        break;

      case 0x09: /* RIDL  */
        pe[T_PE].acr.ictl0 = 0xf9; 
        pe[T_PE].acr.ictl1 = 0x10; 
        break;

      case 0x0a: /* WACF  */
        *((unsigned char *)&pe[T_PE].acf    ) = pe[T_PE].acr.ictl0;
        *((unsigned char *)&pe[T_PE].acf + 1) = pe[T_PE].acr.ictl1;
        break;

      case 0x0c: /* RACF  */
        pe[T_PE].acr.ictl0 = *((unsigned char *)&pe[T_PE].acf    );
        pe[T_PE].acr.ictl1 = *((unsigned char *)&pe[T_PE].acf + 1);
        break;

      case 0x0e: /* WDCAU */
        if (pe[T_PE].acr.dva != DASD_DVA && pe[T_PE].acr.dva != DASD_LDVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }
        if (pe[T_PE].acr.dbsy || pe[T_PE].acr.aint || pe[T_PE].acr.ainp) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 3;
          pe[T_PE].acr.ictl1 = 0;
          return;
        }

        pe[T_PE].dcba = pe[T_PE].dcba & 0x0000ffff
          | pe[T_PE].acr.ictl0 << 24 | pe[T_PE].acr.ictl1 << 16;
        break;

      case 0x0f: /* WDCAL */
        if (pe[T_PE].acr.dva != DASD_DVA && pe[T_PE].acr.dva != DASD_LDVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }
        if (pe[T_PE].acr.dbsy || pe[T_PE].acr.aint || pe[T_PE].acr.ainp) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 3;
          pe[T_PE].acr.ictl1 = 0;
          return;
        }
        if (pe[T_PE].acr.ictl1 & 31) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 5;
          return;
        }

        pe[T_PE].dcba = pe[T_PE].dcba & 0xffff0000
          | pe[T_PE].acr.ictl0 <<  8 | pe[T_PE].acr.ictl1;
        break;

      case 0x10: /* RDCAU */
        if (pe[T_PE].acr.dva != DASD_DVA && pe[T_PE].acr.dva != DASD_LDVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }

        pe[T_PE].acr.ictl0 = (pe[T_PE].dcba >> 24) & 0xff;
        pe[T_PE].acr.ictl1 = (pe[T_PE].dcba >> 16) & 0xff;
        break;

      case 0x11: /* RDCAL */
        if (pe[T_PE].acr.dva != DASD_DVA && pe[T_PE].acr.dva != DASD_LDVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }

        pe[T_PE].acr.ictl0 = (pe[T_PE].dcba >> 8) & 0xff;
        pe[T_PE].acr.ictl1 = (pe[T_PE].dcba     ) & 0xff;
        break;

      case 0x1e: /* SIPL  */
        if (pe[T_PE].acr.dva != DASD_DVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }
        if (pe[T_PE].acr.dbsy || pe[T_PE].acr.aint || pe[T_PE].acr.ainp) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 3;
          pe[T_PE].acr.ictl1 = 0;
          return;
        }

	status = 0x20; /* PC */

        if (sys_fop_access(t_pe, pe[T_PE].dcba,   4, _R_, &bc) != RW_SUCCESS
         || sys_fop_access(t_pe, pe[T_PE].dcba+4, 4, _R_, &da) != RW_SUCCESS
         || !(bc &= 0xffff)
         || da & 31) {
          pe[T_PE].acr.aint = 1;
          if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
            pe[T_PE].acr.idsw = 1;
          return;
        }
        if ((bc - 1) / DASD_BLOCK_SIZE >= dasd_blocks) {
          pe[T_PE].acr.aint = 1;
          if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
            pe[T_PE].acr.idsw = 1;
          return;
        }
        if (!dasd_fd) {
          pe[T_PE].acr.aint = 1;
          if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
            pe[T_PE].acr.idsw = 1;
          return;
        }

        lseek(dasd_fd, 0, L_SET);

        for (i=0; i<bc; i++, da++) {
          read(dasd_fd, &d, 1);
          if (sys_fop_access(t_pe, da, 1, _W_, &d) != RW_SUCCESS) {
            pe[T_PE].acr.aint = 1;
            if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
              pe[T_PE].acr.idsw = 1;
            return;
          }
        }

        status = 0xc00;

        pe[T_PE].acr.aint = 1;
        if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS) {
          pe[T_PE].acr.idsw = 1;
          return;
        }

        if (sys_fop_access(t_pe,pe[T_PE].dcba+28,4,_W_,&da) != RW_SUCCESS) {
          pe[T_PE].acr.idsw = 1;
          return;
        }

        break;

      case 0x1f: /* SIMPL  */
        if (pe[T_PE].acr.dva != DASD_LDVA) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 2;
          return;
        }
        if (pe[T_PE].acr.dbsy || pe[T_PE].acr.aint || pe[T_PE].acr.ainp) {
          pe[T_PE].acr.perr  = 1;
          pe[T_PE].acr.ictl0 = 3;
          pe[T_PE].acr.ictl1 = 0;
          return;
        }

	status = 0x20; /* PC */

        if (sys_fop_access(t_pe, pe[T_PE].dcba,   4, _R_, &bc) != RW_SUCCESS
         || sys_fop_access(t_pe, pe[T_PE].dcba+4, 4, _R_, &da) != RW_SUCCESS
         || !(bc &= 0x00ffffff)
         || da & 31) {
          pe[T_PE].acr.aint = 1;
          if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
            pe[T_PE].acr.idsw = 1;
          return;
        }
        if ((bc - 1) / DASD_BLOCK_SIZE >= dasd_blocks) {
          pe[T_PE].acr.aint = 1;
          if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
            pe[T_PE].acr.idsw = 1;
          return;
        }
        if (!dasd_fd) {
          pe[T_PE].acr.aint = 1;
          if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
            pe[T_PE].acr.idsw = 1;
          return;
        }

        lseek(dasd_fd, DASD_BLOCK_SIZE * 0x20, L_SET);

        for (i=0; i<bc; i++, da++) {
          read(dasd_fd, &d, 1);
          if (sys_fop_access(t_pe, da, 1, _W_, &d) != RW_SUCCESS) {
            pe[T_PE].acr.aint = 1;
            if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS)
              pe[T_PE].acr.idsw = 1;
            return;
          }
        }

        pe[T_PE].acr.dva = DASD_DVA;
        status = 0xc00;

        pe[T_PE].acr.aint = 1;
        if (sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS) {
          pe[T_PE].acr.idsw = 1;
          return;
        }

        if (sys_fop_access(t_pe,pe[T_PE].dcba+28,4,_W_,&da) != RW_SUCCESS) {
          pe[T_PE].acr.idsw = 1;
          return;
        }

        break;

      case 0x00: /* ANOP  */
      case 0x01: /* TDCR  */
      case 0x04: /* TSTS  */
      case 0x05: /* TDCRX */
      case 0x07: /* CDCR  */
      case 0x18: /* LMPU  */
      case 0x19: /* LMPL  */
      case 0x1a: /* DMPU  */
      case 0x1b: /* DMPL  */
      case 0x1d: /* SDIAG */
        break;

      default: /* Undefined */
        pe[T_PE].acr.perr  = 1;
        pe[T_PE].acr.ictl0 = 1;
        break;
      }
    }
}

static char inquiry[] = 
    {  0 , 0 , 1 , 1 ,31 , 0 , 0 , 0 ,
      'F','U','J','I','T','S','U', 0 ,
      'M','1','0','5','3', 0 , 0 , 0 ,
       0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
      'V','V', 0 , 0 };

static char characteristics[] =
    { 0x68, 0x53, 0xb0, 0x00, 0x30, 0x02, 0x00, 0x00,
      0x00, 0x44, 0x07, 0x2c, 0x00, 0x14, 0xd0, 0xb4,
      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

dasd_dma(t_pe, t_fsba)
    unsigned t_pe, t_fsba;
{
    /* flag.{cd,sli,skip,ida} are ignored */
    /* cdb.bc is ignored */

#define BC_LIMIT   2097152
#define CC_LIMIT   255
    unsigned	   da, dba, cc_sum, i, j;
    unsigned short bc;
    unsigned char  command, flag, dgrp, dopc, dlun, dlink;
    unsigned char  d;

    pe[T_PE].acr.dbsy = 0;
    cc_sum = 0;

    if (pe[T_PE].dasd_status != STATUS_PCI) {
      if (sys_fop_access(t_pe, pe[T_PE].dcba, 4, _R_, &pe[T_PE].dcwa) != RW_SUCCESS
       || pe[T_PE].dcwa & 31) {
        dasd_update_status(t_pe, 0x20, 0x02, 0x01); /* PC, DCW, ADDR */
        return;
      }
    }

    do { /* CC */

      /* extract DCW parameters */
      if (sys_fop_access(t_pe, pe[T_PE].dcwa   , 1, _R_, &command) != RW_SUCCESS
       || sys_fop_access(t_pe, pe[T_PE].dcwa+ 1, 1, _R_, &flag   ) != RW_SUCCESS
       || sys_fop_access(t_pe, pe[T_PE].dcwa+ 2, 2, _R_, &bc     ) != RW_SUCCESS
       || sys_fop_access(t_pe, pe[T_PE].dcwa+ 4, 4, _R_, &da     ) != RW_SUCCESS
       || sys_fop_access(t_pe, pe[T_PE].dcwa+ 8, 4, _R_, &dba    ) != RW_SUCCESS
       || sys_fop_access(t_pe, pe[T_PE].dcwa+13, 1, _R_, &dlink  ) != RW_SUCCESS) {
        dasd_update_status(t_pe, 0x20, 0x02, 0x01); /* PC, DCW, ADDR */
        return;
      }

      if (command == 0x08) { /**** TIC ****/
        if (pe[T_PE].dasd_status == STATUS_TIC) {
          pe[T_PE].dasd_status = STATUS_NORMAL;
          dasd_update_status(t_pe, 0x20, 0x03, 0x21); /* PC, DECODE, TIC2 */
          return;
        }
        if (da & 31 || da == pe[T_PE].dcwa) {
          dasd_update_status(t_pe, 0x20, 0x03, 0x22); /* PC, DECODE, TICA */
          return;
        }

        pe[T_PE].dasd_status = STATUS_TIC;
        pe[T_PE].dcwa = da;
        flag |= 0x40;
        continue;
      }

      /* handle PCI */
      if (pe[T_PE].dasd_status == STATUS_PCI) {
        pe[T_PE].dasd_status = STATUS_NORMAL;
      }
      else if (flag & 0x08) { /* PCI */
        if (!dasd_update_status(t_pe, 0x80, 0x03, 0)) /* PCI, PCI */
          pe[T_PE].dasd_status = STATUS_PCI;
        return;
      }

      /* extract CDB parameters */
      dgrp    = (dba >> 29) & 0x07;
      dopc    = (dba >> 24) & 0x1f;
      dlun    = (dba >> 21) & 0x07;
      dba     = (dba      ) & 0x1fffff;
      dlink   = (dlink    ) & 0x01;

      /* execute DMA transmission */
      switch (command) {
      case 0x03: /**** NOP ****/
        /* do nothing */
        break;

      case 0x01: /**** WRITE ****/
        if (dgrp) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, GROUP */
          return;
        }
        if (dlun) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x24); /* PC, EXECUTE, LUN */
          return;
        }
        if (dlink && !(flag & 0x40)) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x05); /* PC, EXECUTE, LINK */
          return;
        }
        if (!bc) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x02); /* PC, EXECUTE, BC */
          return;
        }
        break;
          
      case 0x02: /**** READ ****/
        if (dgrp) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, GROUP */
          return;
        }
        if (dlun) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x24); /* PC, EXECUTE, LUN */
          return;
        }
        if (dlink && !(flag & 0x40)) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x05); /* PC, EXECUTE, LINK */
          return;
        }
        if (!bc) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x02); /* PC, EXECUTE, BC */
          return;
        }

        switch (dopc) {
        case 0x03: /* Request Sense */
          /* do nothing */
          break;

        case 0x12: /* Inquiry */
          for (i=0; i<bc && i<(sizeof inquiry); i++, da++) {
            if (sys_fop_access(t_pe, da, 1, _W_, &inquiry[i]) != RW_SUCCESS) {
              dasd_update_status(t_pe, 0x20, 0x04, 0x01); /* PC, EXECUTE, ADDR */
              return;
            }
          }
          break;

        case 0x13: /* Read Device Characteristics */
          for (i=0; i<bc && i<(sizeof characteristics); i++, da++) {
            switch (i) {
            default:
              break;
            case 12:
              characteristics[i] = (dasd_blocks >> 24) & 0xff;
              break;
            case 13:
              characteristics[i] = (dasd_blocks >> 16) & 0xff;
              break;
            case 14:
              characteristics[i] = (dasd_blocks >>  8) & 0xff;
              break;
            case 15:
              characteristics[i] = (dasd_blocks      ) & 0xff;
              break;
            }
            if (sys_fop_access(t_pe, da, 1, _W_, &characteristics[i]) != RW_SUCCESS) {
              dasd_update_status(t_pe, 0x20, 0x04, 0x01); /* PC, EXECUTE, ADDR */
              return;
            }
          }
          break;

        default:
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, OPC */
          return;
        }
        break;

      case 0x11: /**** EXTENDED WRITE ****/
        if (dgrp) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, GROUP */
          return;
        }
        if (dlun) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x24); /* PC, EXECUTE, LUN */
          return;
        }
        if (dlink && !(flag & 0x40)) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x05); /* PC, EXECUTE, LINK */
          return;
        }
        if (!bc || bc > 0x1000) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x02); /* PC, EXECUTE, BC */
          return;
        }
        if (dba >= dasd_blocks || dba + bc - 1 >= dasd_blocks) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x25); /* PC, EXECUTE, DBA/DBC */
          return;
        }
        if (!dasd_fd) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x26); /* PC, EXECUTE, DASD */
          return;
        }

        switch (dopc) {
        case 0x0a: /* write */
          lseek(dasd_fd, dba*DASD_BLOCK_SIZE, L_SET);
          for (i=0; i<bc; i++) {
            for (j=0; j<DASD_BLOCK_SIZE; j++, da++) {
              if (sys_fop_access(t_pe, da, 1, _R_, &d) != RW_SUCCESS) {
                dasd_update_status(t_pe, 0x20, 0x04, 0x01); /* PC, EXECUTE, ADDR */
                return;
              }
              write(dasd_fd, &d, 1);
            }
          }
          break;

        default:
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, OPC */
          return;
        }
        break;

      case 0x12: /**** EXTENDED READ ****/
        if (dgrp) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, GROUP */
          return;
        }
        if (dlun) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x24); /* PC, EXECUTE, LUN */
          return;
        }
        if (dlink && !(flag & 0x40)) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x05); /* PC, EXECUTE, LINK */
          return;
        }
        if (!bc || bc > 0x1000) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x02); /* PC, EXECUTE, BC */
          return;
        }
        if (dba >= dasd_blocks || dba + bc - 1 >= dasd_blocks) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x25); /* PC, EXECUTE, DBA/DBC */
          return;
        }
        if (!dasd_fd) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x26); /* PC, EXECUTE, DASD */
          return;
        }

        switch (dopc) {
        case 0x08: /* read */
          lseek(dasd_fd, dba*DASD_BLOCK_SIZE, L_SET);
          for (i=0; i<bc; i++) {
            for (j=0; j<DASD_BLOCK_SIZE; j++, da++) {
              read(dasd_fd, &d, 1);
              if (sys_fop_access(t_pe, da, 1, _W_, &d) != RW_SUCCESS) {
                dasd_update_status(t_pe, 0x20, 0x04, 0x01); /* PC, EXECUTE, ADDR */
                return;
              }
            }
          }
          break;

        default:
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, OPC */
          return;
        }
        break;

      case 0x13: /**** CONTROL ****/
        if (dgrp) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, GROUP */
          return;
        }
        if (dlun) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x24); /* PC, EXECUTE, LUN */
          return;
        }
        if (dlink && !(flag & 0x40)) {
          dasd_update_status(t_pe, 0x20, 0x04, 0x05); /* PC, EXECUTE, LINK */
          return;
        }

        switch (dopc) {
        case 0x01: /* Rezero Unit */
          /* do nothing */
          break;

        default:
          dasd_update_status(t_pe, 0x20, 0x04, 0x23); /* PC, EXECUTE, OPC */
          return;
        }
        break;

      default:
        dasd_update_status(t_pe, 0x20, 0x03, 0x03); /* PC, DECODE, UNDEF */
        return;
      }

      /* traverse command chain */
      pe[T_PE].dcwa += 32;
    } while (flag & 0x40 && ++cc_sum < CC_LIMIT);

    if (cc_sum >= CC_LIMIT) {
      dasd_update_status(t_pe, 0x20, 0x02, 0x20); /* PC, DCW, CC_LIMIT */
      return;
    }

    dasd_update_status(t_pe, 0xc00, 0, 0); /* AE/DE */
}

dasd_update_status(t_pe, status, phase, code)
    unsigned       t_pe;
    unsigned short status;
    unsigned char  phase, code;
    /* return 0 if normally terminated */
{
    /* code: 0x00: normally terminated
             0x01: illegal address
             0x02: illegal BC
             0x03: undefined DCW Command
             0x05: CC is 0
             0x20: CC > CC_LIMIT
             0x21: TIC & TIC
             0x22: illegal NDCWA in TIC
             0x23: illegal GROUP/OPC in CDB
             0x24: illegal LUN in CDB
             0x25: illegal DBA/DBC in CDB
             0x26: can't access DASD image_file */

    unsigned	ndcwa;

    pe[T_PE].acr.aint = 1;
    pe[T_PE].acr.idva = DASD_DVA;
    ndcwa = pe[T_PE].dcwa + 32;

    if (sys_fop_access(t_pe,pe[T_PE].dcba+ 8,4,_W_,&ndcwa)  != RW_SUCCESS
     || sys_fop_access(t_pe,pe[T_PE].dcba+12,2,_W_,&status) != RW_SUCCESS
     || sys_fop_access(t_pe,pe[T_PE].dcba+18,1,_W_,&phase ) != RW_SUCCESS
     || sys_fop_access(t_pe,pe[T_PE].dcba+19,1,_W_,&code  ) != RW_SUCCESS) {
      pe[T_PE].acr.idsw = 1;
      return(1);
    }

    return(0);
}

#endif

