static char SccsId[] = "@(#)fp-baseop.c	1.5	6/5/92	16:15:50";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Koseki      */

/* fp-baseop.c       89/11/30 */

#ifdef   FPUTEST
#include "function.h"
#else
#include "tim.h"
#endif
#include "fp-form.def"

#ifdef FPUTEST
union    fp_vp_cnt     un_fcr;
union    fp_vp_flag    un_fvct[4];
union    fp_vp_reg     un_fr[4];
union    fp_vp_temp    un_t[4];
#else
union    fp_vp_cnt     un_fcr;
union    fp_vp_flag    un_fvct[3];
union    fp_vp_reg     un_fr[3];
union    fp_vp_temp    un_t[3];
#endif

#if 0
fp_temp_clear( t_pe )
int      t_pe;
{
    int     i, j;

    for( i = 0 ; i < 3 ; i++ ){
        for( j = 0 ; j < 4 ; j++ ){
            un_fr[i].fr[j] = un_t[i].l_data[j] = 0;
        }
        un_fvct[i].ful = 0;
    }
#ifdef FPUTEST
    un_fcr.ful = 0;
#else
    un_fcr.ful = pe[T_PE].sr[FPC].ful & 0xfe000000;
#endif
    un_fcr.ctl.fvm = un_fcr.ctl.fum = 1;
}

#ifdef VCP
vp_temp_clear( t_pe )
int      t_pe;
{
    int     i, j;

    for( i = 0 ; i < 3 ; i++ ){
        for( j = 0 ; j < 4 ; j++ ){
            un_fr[i].fr[j] = un_t[i].l_data[j] = 0;
        }
        un_fvct[i].ful = 0;
    }
    un_fcr.ful = ( pe[T_PE].vcr[2].ful & 0xf8000000 ) >> 2;
    un_fcr.ctl.ev = pe[T_PE].vcr[0].vcr0.ev;
    un_fcr.ctl.ed = pe[T_PE].vcr[0].vcr0.ed;
    un_fcr.ctl.vp = 1;
}

vp_treg_clear( t_pe, freg, treg )
int      t_pe;
int      freg, treg;
{
    int     i;

    for( i = 0 ; i < 4 ; i++ ){
        un_fr[treg].fr[i] = un_t[treg].l_data[i] = un_t[freg].l_data[i] = 0;
    }
    un_fvct[treg].ful = 0;
}

vp_fst_clear( t_pe )
{
    un_fcr.ful = ( ( pe[T_PE].vcr[2].ful & 0xf8000000 ) >> 2 ) | 0x40000000;
    un_fcr.ctl.ev = pe[T_PE].vcr[0].vcr0.ev;
    un_fcr.ctl.ed = pe[T_PE].vcr[0].vcr0.ed;
    un_fvct[VR_W1].ful = 0;
    un_fcr.ctl.vp = 1;
}
#endif

#endif



fp_cnv_f_t( treg, type )
unsigned treg;
int      type;
{
    switch( type ){
        case FLOAT_DATA :
                un_t[treg].t_data.s = un_fvct[treg].ctl.n = un_fr[treg].f_data.s;
                un_t[treg].f_data.f = un_fr[treg].f_data.f;
                if( un_fr[treg].f_data.e ){
                    if( un_fr[treg].f_data.e < FLOAT_EMAX ){
                        un_t[treg].t_data.e = ( un_fr[treg].f_data.e -
                                                FLOAT_BIAS ) + TEMP_BIAS;
                        un_t[treg].t_data.l = 1;
                    }
                    else{
                        un_t[treg].t_data.l = 0;
                        un_t[treg].t_data.e = TEMP_EMAX;
                        if( un_fr[treg].f_data.f ){
                            un_fvct[treg].ctl.nan = 1;
                            un_fvct[treg].ctl.sts = F_STATUS_NAN;
                            if( ( un_fr[treg].f_data.f >> 22 ) == 0 ){
                                un_fvct[treg].ctl.snan = 1;
                                if( un_fcr.ctl.fom ){
                                    un_fcr.ctl.trct = 1;
                                    un_fcr.ctl.fof = 1;
                                }
                                else{
                                    un_fcr.ctl.ivo = 1;
                                }
                            }
                        }
                        else{
                            un_fvct[treg].ctl.i   = 1;
                            un_fvct[treg].ctl.sts = F_STATUS_I;
                        }
                    }
                }
                else{
                    if( un_fr[treg].f_data.f ){ 
                        un_t[treg].t_data.e = TEMP_BIAS + FLOAT_BIAS_SU;
                        un_t[treg].t_data.l = 0;
                        un_fcr.ctl.fxf = 1;
                        un_fcr.ctl.trct = 1;
#ifdef IEEE
                        fp_implement( treg );
#endif
                    }
                    else{
                        un_fvct[treg].ctl.z = 1;
                        un_fvct[treg].ctl.sts = F_STATUS_Z;
                    }
                }
                break;
        case DOUBLE_DATA :
                un_t[treg].t_data.s = un_fvct[treg].ctl.n = un_fr[treg].d_data.s;
                un_t[treg].d_data.f1 = un_fr[treg].d_data.f1;
                un_t[treg].d_data.f2 = un_fr[treg].d_data.f2;
                un_t[treg].d_data.f3 = un_fr[treg].d_data.f3;
                if( un_fr[treg].d_data.e ){
                    if( un_fr[treg].d_data.e < DOUBLE_EMAX ){
                        un_t[treg].t_data.e = ( un_fr[treg].d_data.e -
                                                DOUBLE_BIAS ) + TEMP_BIAS;
                        un_t[treg].t_data.l = 1;
                    }
                    else{
                        un_t[treg].t_data.l = 0;
                        un_t[treg].t_data.e = TEMP_EMAX;
                        if( un_t[treg].t_data.f1 || un_t[treg].t_data.f2 ){
                            un_fvct[treg].ctl.nan = 1;
                            un_fvct[treg].ctl.sts = F_STATUS_NAN;
                            if( ( un_fr[treg].d_data.f1 >> 19 ) == 0 ){
                                un_fvct[treg].ctl.snan = 1;
                                if( un_fcr.ctl.fom ){
                                    un_fcr.ctl.trct = 1;
                                    un_fcr.ctl.fof = 1;
                                }
                                else{
                                    un_fcr.ctl.ivo = 1;
                                }
                            }
                        }
                        else{
                            un_fvct[treg].ctl.i   = 1;
                            un_fvct[treg].ctl.sts = F_STATUS_I;
                        }
                    }
                }
                else{
                    if( un_t[treg].t_data.f1 || un_t[treg].t_data.f2 ){
                        un_t[treg].t_data.e = TEMP_BIAS + DOUBLE_BIAS_SU;
                        un_t[treg].t_data.l = 0;
                        un_fcr.ctl.fxf = 1;
                        un_fcr.ctl.trct = 1;
#ifdef IEEE
                        fp_implement( treg );
#endif
                    }
                    else{
                        un_fvct[treg].ctl.z = 1;
                        un_fvct[treg].ctl.sts = F_STATUS_Z;
                    }
                }
                break;
        case EXTENDED_DATA :
                un_t[treg].t_data.s  = un_fvct[treg].ctl.n = un_fr[treg].e_data.s;
                un_t[treg].e_data.f1 = un_fr[treg].e_data.f1;
                un_t[treg].e_data.f2 = un_fr[treg].e_data.f2;
                un_t[treg].e_data.f3 = un_fr[treg].e_data.f3;
                un_t[treg].e_data.f4 = un_fr[treg].e_data.f4;
                un_t[treg].t_data.l  = un_fr[treg].e_data.l;
                if( un_fr[treg].e_data.e || un_fr[treg].e_data.l ){
                    if( un_fr[treg].e_data.e < EXTENDED_EMAX ){
                        if( !un_fr[treg].e_data.l ){
                            if( un_t[treg].t_data.f1 || un_t[treg].t_data.f2 ||
                                                        un_t[treg].t_data.f3 ){
                                un_fcr.ctl.fxf = 1;
                                un_fcr.ctl.trct = 1;
#ifdef IEEE
                                fp_implement( treg );
#endif
                            }
                            else{
                                un_fvct[treg].ctl.z = 1;
                                un_fvct[treg].ctl.sts = F_STATUS_Z;
                                break;
                            }
                        }
                        un_t[treg].t_data.e = ( un_fr[treg].e_data.e -
                                                EXTENDED_BIAS ) + TEMP_BIAS;
                    }
                    else{
                        un_t[treg].t_data.e = TEMP_EMAX;
                        if( un_t[treg].t_data.f1 || un_t[treg].t_data.f2 || 
                                                    un_t[treg].t_data.f3 ){
                            un_fvct[treg].ctl.nan = 1;
                            un_fvct[treg].ctl.sts = F_STATUS_NAN;
                            if( ( un_fr[treg].e_data.f1 >> 29 ) == 0 ){
                                un_fvct[treg].ctl.snan = 1;
                                if( un_fcr.ctl.fom ){
                                    un_fcr.ctl.trct = 1;
                                    un_fcr.ctl.fof = 1;
                                }
                                else{
                                    un_fcr.ctl.ivo = 1;
                                }
                            }
                        }
                        else{
                            un_fvct[treg].ctl.i   = 1;
                            un_fvct[treg].ctl.sts = F_STATUS_I;
                        }
                    }
                }
                else{
                    if( un_t[treg].t_data.f1 || un_t[treg].t_data.f2 || 
                                                un_t[treg].t_data.f3 ){
                        un_t[treg].t_data.e = TEMP_BIAS + EXTENDED_BIAS_SU;
                        un_t[treg].t_data.l = 0;
                        un_fcr.ctl.fxf = 1;
                        un_fcr.ctl.trct = 1;
#ifdef IEEE
                        fp_implement( treg );
#endif
                    }
                    else{
                        un_fvct[treg].ctl.z = 1;
                        un_fvct[treg].ctl.sts = F_STATUS_Z;
                    }
                }
                break;
    }
}



fp_shift_r( treg , count )
unsigned treg;
int      count;
{
    unsigned k;
    int      rcnt;
 
    k = 0;
    un_t[treg].t_data.e += count;
    if( count > 96 ){
        if( un_t[treg].l_data[1] || un_t[treg].l_data[2] ||
                                    un_t[treg].l_data[3] ){
            k = 1;
        }
        count = count % 96;
        un_t[treg].l_data[1] = un_t[treg].l_data[2] = 0;
        un_t[treg].l_data[3] = k;
    }
    while( count >= 32 ){
        count -= 32;
        if( un_t[treg].l_data[3] ){
            k = 1;
        }
        un_t[treg].l_data[3] = un_t[treg].l_data[2] | k;
        un_t[treg].l_data[2] = un_t[treg].l_data[1];
        un_t[treg].l_data[1] = 0;
    }
    if( count ){
        rcnt = 32 - count;
        if( un_t[treg].l_data[3] << rcnt ){
            k = 1;
        }
        un_t[treg].l_data[3] = ( un_t[treg].l_data[2] << rcnt ) +
                               ( un_t[treg].l_data[3] >> count );
        un_t[treg].l_data[2] = ( un_t[treg].l_data[1] << rcnt ) + 
                               ( un_t[treg].l_data[2] >> count );
        un_t[treg].l_data[1] = un_t[treg].l_data[1] >> count;
        un_t[treg].t_data.k = un_t[treg].t_data.k | k;
    }
}



fp_shift_l( treg , count )
unsigned treg;
int      count;
{
    unsigned k;
    unsigned top;
    int      rcnt;
 
    top = 0;
    k = un_t[treg].t_data.k;
    un_t[treg].t_data.k = 0;
    un_t[treg].t_data.e -= count;
    if( count > 96 ){
        if( un_t[treg].l_data[1] || un_t[treg].l_data[2] ||
                                    un_t[treg].l_data[3] ){
            top = 1;
        }
        count = count % 96;
        un_t[treg].l_data[1] = un_t[treg].l_data[2] = un_t[treg].l_data[3] = 0;
    }
    while( count >= 32 ){
        count -= 32;
        if( un_t[treg].l_data[1] ){
            top = 1;
        }
        un_t[treg].l_data[1] = un_t[treg].l_data[2];
        un_t[treg].l_data[2] = un_t[treg].l_data[3];
        un_t[treg].l_data[3] = 0;
    }
    if( count ){
        rcnt = 32 - count;
        if( un_t[treg].l_data[3] >> rcnt ){
            k = 1;
        }
        top |= un_t[treg].l_data[1] >> rcnt;
        un_t[treg].l_data[1] = ( un_t[treg].l_data[1] << count ) +
                               ( un_t[treg].l_data[2] >> rcnt );
        un_t[treg].l_data[2] = ( un_t[treg].l_data[2] << count ) +
                               ( un_t[treg].l_data[3] >> rcnt );
        un_t[treg].l_data[3] = un_t[treg].l_data[3] << count;
    }
    un_t[treg].t_data.k = k;
    return( top );
}



fp_implement( treg )
unsigned treg;
{
    unsigned k;
    unsigned top;

    k = un_t[treg].t_data.k;
    un_t[treg].t_data.k = 0;
    while( !un_t[treg].t_data.l ){
        un_t[treg].l_data[1] = ( un_t[treg].l_data[1] << 1 ) +
                               ( un_t[treg].l_data[2] >> 31 );
        un_t[treg].l_data[2] = ( un_t[treg].l_data[2] << 1 ) +
                               ( un_t[treg].l_data[3] >> 31 );
        un_t[treg].l_data[3] = un_t[treg].l_data[3] << 1;
        un_t[treg].t_data.e--;
    }
    un_t[treg].t_data.k = k;
}



fp_cnv_t_f( t_pe, treg, type, mode )
int      t_pe;
unsigned treg;
int      type, mode;
{
    static unsigned fdata_i[3][4] =
                      {   {  0x7ff00000, 0x00000000, 0x00000000, 0x00000000 },
                          {  0x7f800000, 0x00000000, 0x00000000, 0x00000000 },
                          {  0x7fff0000, 0x00000000, 0x00000000, 0x00000000 } };
    static unsigned fdata_nan_e[3] =
                                    {  DOUBLE_EMAX, FLOAT_EMAX, EXTENDED_EMAX };
    static struct {
                    int      or_colm;
                    unsigned or_data;
                  } nan_set[3] =  { { 0, 0x00080000 },
                                    { 0, 0x00400000 },
                                    { 2, 0x40000000 } };

    register int       k;
    register int       e;
    register int       bias, bias_su;
    register int       i;
    register unsigned  f;

    /* format conversion */
    for( k = 0 ; k < 4 ; k++ ){
        un_fr[treg].fr[k] = 0;
    }
    if( un_t[treg].t_data.v ){
        fp_shift_r( treg, 1 );
    }
    if( un_t[treg].l_data[1] || un_t[treg].l_data[2] || un_t[treg].l_data[3] ){
        /* k = f bit all 0? */
        k = 1;
    }
    else{
        k = 0;
    }
    un_fvct[treg].ctl.n = un_t[treg].t_data.s;
    if( un_t[treg].t_data.e >= TEMP_EMAX ){
        /*
        printf(" e error %d", un_t[treg].t_data.e );
         */
        if( un_t[treg].t_data.f1 || un_t[treg].l_data[2] ||
                                                  un_t[treg].l_data[3] ){
            /*
             * NAN data
             */
            un_fvct[treg].ctl.nan = 1;
            fp_cnv_t_f_sub( treg, type, fdata_nan_e[type] );
            un_fr[treg].fr[nan_set[type].or_colm] = 
                 un_fr[treg].fr[nan_set[type].or_colm] | nan_set[type].or_data;
        }
        else{
            /*
             * INFINITE data
             */
            for( i = 0 ; i < 4 ; i++ ){
                un_fr[treg].fr[i] = fdata_i[type][i];
            }
            un_fr[treg].c_data.s = un_t[treg].t_data.s;
            un_fvct[treg].ctl.i = 1;
        }
    }
    else{
        if( ( !un_t[treg].t_data.e ) && ( !k ) ){
            /* printf(" z error %d", un_t[treg].t_data.e ); */
            /*
             * ZERO data
             */
            for( i = 0 ; i < 4 ; i++ ){
                un_fr[treg].fr[i] = 0;
            }
            un_fr[treg].c_data.s = un_t[treg].t_data.s;
            un_fvct[treg].ctl.z = 1;
        }
        else{
            /*
             * NORMAL data
             */
            if( k ){
                k = un_t[treg].t_data.k;
                un_t[treg].t_data.k = 0;
                while( !un_t[treg].t_data.l ){
                    un_t[treg].l_data[1] = ( un_t[treg].l_data[1] << 1 ) +
                                           ( un_t[treg].l_data[2] >> 31 );
                    un_t[treg].l_data[2] = ( un_t[treg].l_data[2] << 1 ) +
                                           ( un_t[treg].l_data[3] >> 31 );
                    un_t[treg].l_data[3] = un_t[treg].l_data[3] << 1;
                    un_t[treg].t_data.e--;
                }
                un_t[treg].t_data.k = k;
            }
            /*::::::::::::::::::::::::::::::::::::::::::::::::*/
            k =  fp_rnd( t_pe, treg, type );
            /*::::::::::::::::::::::::::::::::::::::::::::::::*/
            e = un_t[treg].t_data.e - TEMP_BIAS;
            switch( type ){
                case FLOAT_DATA :
                        bias = FLOAT_BIAS;
                        bias_su = FLOAT_BIAS_SU;
                        break;
                case DOUBLE_DATA :
                        bias = DOUBLE_BIAS;
                        bias_su = DOUBLE_BIAS_SU;
                        break;
                case EXTENDED_DATA :
                        bias = EXTENDED_BIAS;
                        bias_su = EXTENDED_BIAS_SU;
                        break;
            }
            if( ( e > bias ) && ( un_fvct[treg].ctl.z == 0 ) ){
#ifndef VCP
                /* Intervention required overflow */

                if( k == RND_ON ){
                    if( un_fcr.ctl.fim ){
                        un_fcr.ctl.fif = 1;
                    }
                    else{
                        un_fcr.ctl.ine = 1;
                    }
                }
                fp_rebulate_bias( treg, type, OVERFLOW, un_fcr.ctl.ev );
                un_fcr.ctl.fvf = 1;
                return( FPU_IRV_ERROR );
#else
                /*  reserved intervention required overflow rootine(VP)   */
                /*  reserved intervention required overflow rootine(IEEE) */

                if( un_fcr.ctl.fvm ){
                    if( k == RND_ON ){
                        if( un_fcr.ctl.fim ){
                            un_fcr.ctl.fif = 1;
                        }
                        else{
                            un_fcr.ctl.ine = 1;
                        }
                    }
                    fp_rebulate_bias( treg, type, OVERFLOW, un_fcr.ctl.ev );
                    un_fcr.ctl.fvf = 1;
                    return( FPU_IRV_ERROR );
                }
                else{
                    if( un_fcr.ctl.fim ){
                        un_fcr.ctl.irv = 1;
                        fp_rebulate_bias( treg, type, OVERFLOW, un_fcr.ctl.ev );
                        un_fcr.ctl.fif = 1;
                        return( FPU_INE_ERROR );
                    }
                    else{
                        un_fcr.ctl.irv = 1;
                        if( k == RND_ON ){
                            /*
                            if( un_fcr.ctl.fim ){
                                fp_rebulate_bias( treg, type, OVERFLOW,
                                                                un_fcr.ctl.ev );
                                un_fcr.ctl.fif = 1;
                                return( FPU_INE_ERROR );
                            }
                            else{
                                un_fcr.ctl.ine = 1;
                            }
                             */
                            un_fcr.ctl.ine = 1;
                        }
                        fp_rebulate_bias( treg, type, OVERFLOW, 1 );
                        return( FPU_SUCCEED );
                    }
                    /*
                    fp_rebulate_bias( treg, type, OVERFLOW, un_fcr.ctl.ev );
                    return( FPU_SUCCEED );
                     */
                }
#endif
            }
            else{
                if( ( e < bias_su ) && ( un_fvct[treg].ctl.z == 0 ) ){
#ifndef VCP
                    /* Intervention required underflow */

                    if( k == RND_ON ){
                        if( un_fcr.ctl.fim ){
                            un_fcr.ctl.fif = 1;
                        }
                        else{
                            un_fcr.ctl.ine = 1;
                        }
                    }
                    fp_rebulate_bias( treg, type, UNDERFLOW, un_fcr.ctl.ed );
                    un_fcr.ctl.fuf = 1;
                    return( FPU_IRU_ERROR );
#else
                /*  reserved intervention required underflow rootine(VP)   */
                /*  reserved intervention required underflow rootine(IEEE) */

                    if( un_fcr.ctl.fum ){
                        if( k == RND_ON ){
                            if( un_fcr.ctl.fim ){
                                un_fcr.ctl.fif = 1;
                            }
                            else{
                                un_fcr.ctl.ine = 1;
                            }
                        }
                        fp_rebulate_bias( treg, type, UNDERFLOW, un_fcr.ctl.ed );
                        un_fcr.ctl.fuf = 1;
                        return( FPU_IRU_ERROR );
                    }
                    else{
                        un_fcr.ctl.iru = 1;
                        for( i = 0 ; i < 4 ; i++ ){
                            un_fr[treg].fr[i] = 0;
                        }
                        un_fr[treg].c_data.s = un_t[treg].t_data.s;
                        un_fvct[treg].ctl.z = 1;
                        if( k == RND_ON ){
                            if( un_fcr.ctl.fim ){
                                un_fcr.ctl.fif = 1;
                                return( FPU_INE_ERROR );
                            }
                            else{
                                un_fcr.ctl.ine = 1;
                            }
                        }
                        return( FPU_SUCCEED );
                    }
#endif
                }
                else{
                    if( k == RND_ON ){
                        e = un_t[treg].t_data.e - TEMP_BIAS + bias;
                        fp_cnv_t_f_sub( treg, type, e );
                        if( un_fcr.ctl.fim ){
                            un_fcr.ctl.fif = 1;
                            return( FPU_INE_ERROR );
                        }
                        else{
                            un_fcr.ctl.ine = 1;
                        }
                    }
                    else{
                        e = un_t[treg].t_data.e - TEMP_BIAS + bias;
                        fp_cnv_t_f_sub( treg, type, e );
                    }
                    return( FPU_SUCCEED );
                }
            }
        }
    }
    return( FPU_SUCCEED );
}
            


fp_cnv_t_f_sub( treg, type, e )
unsigned treg;
int      type;
int      e;
{
    switch( type ){
        case FLOAT_DATA :
            un_fr[treg].f_data.s = un_t[treg].f_data.s;
            un_fr[treg].f_data.e = e;
            un_fr[treg].f_data.f = un_t[treg].t_data.f1  >> 7;
            break;
        case DOUBLE_DATA :
            un_fr[treg].d_data.s = un_t[treg].d_data.s;
            un_fr[treg].d_data.e = e;
            un_fr[treg].d_data.f1 = un_t[treg].t_data.f1 >> 10;
            un_fr[treg].d_data.f2 = un_t[treg].d_data.f2;
            un_fr[treg].d_data.f3 = un_t[treg].d_data.f3;
            break;
        case EXTENDED_DATA :
            un_fr[treg].e_data.s = un_t[treg].e_data.s;
            un_fr[treg].e_data.e = e;
            un_fr[treg].e_data.l = un_t[treg].t_data.l;
            un_fr[treg].e_data.f1 = un_t[treg].t_data.f1;
            un_fr[treg].e_data.f2 = un_t[treg].e_data.f2;
            un_fr[treg].e_data.f3 = un_t[treg].e_data.f3;
            un_fr[treg].e_data.f4 = un_t[treg].e_data.f4;
            break;
    }
}



fp_rebulate_bias( treg, type, sign, e_flag )
unsigned treg;
int      type;
int      sign;
int      e_flag;
{
    int     e;
    int     i;

    static unsigned hard_nan[3][4] =
                {   {  0x7fffffff, 0xffffffff, 0x00000000, 0x00000000 },
                    {  0x7fffffff, 0x00000000, 0x00000000, 0x00000000 },
                    {  0x7fffffff, 0x00000000, 0x7fffffff, 0xffffffff } };
#ifdef IEEE
    static unsigned reserve_dest[3][4][2][4] =
        {   {   {   {  0x7ff00000, 0x00000000, 0x00000000,0x00000000 },
                    {  0xfff00000, 0x00000000, 0x00000000,0x00000000 } },
                {   {  0x7fefffff, 0xffffffff, 0x00000000,0x00000000 },
                    {  0xffefffff, 0xffffffff, 0x00000000,0x00000000 } },
                {   {  0x7ff00000, 0x00000000, 0x00000000,0x00000000 },
                    {  0xffefffff, 0xffffffff, 0x00000000,0x00000000 } },
                {   {  0x7fefffff, 0xffffffff, 0x00000000,0x00000000 },
                    {  0xfff00000, 0x00000000, 0x00000000,0x00000000 } } },
            {   {   {  0x7f800000, 0x00000000, 0x00000000,0x00000000 },
                    {  0xff800000, 0x00000000, 0x00000000,0x00000000 } },
                {   {  0x7f7fffff, 0x00000000, 0x00000000,0x00000000 },
                    {  0xff7fffff, 0x00000000, 0x00000000,0x00000000 } },
                {   {  0x7f800000, 0x00000000, 0x00000000,0x00000000 },
                    {  0xff7fffff, 0x00000000, 0x00000000,0x00000000 } },
                {   {  0x7f7fffff, 0x00000000, 0x00000000,0x00000000 },
                    {  0xff800000, 0x00000000, 0x00000000,0x00000000 } } },
            {   {   {  0x7fff0000, 0x00000000, 0x00000000,0x00000000 },
                    {  0xffff0000, 0x00000000, 0x00000000,0x00000000 } },
                {   {  0x7ffe0000, 0x00000000, 0xffffffff,0xffffffff },
                    {  0xfffe0000, 0x00000000, 0xffffffff,0xffffffff } },
                {   {  0x7fff0000, 0x00000000, 0x00000000,0x00000000 },
                    {  0xfffe0000, 0x00000000, 0xffffffff,0xffffffff } },
                {   {  0x7ffe0000, 0x00000000, 0xffffffff,0xffffffff },
                    {  0xffff0000, 0x00000000, 0x00000000,0x00000000 } } } };
#else
    static unsigned reserve_dest[3][2][4] = {
                {   {  0x7fefffff, 0xffffffff, 0x00000000, 0x00000000 },
                    {  0xffefffff, 0xffffffff, 0x00000000, 0x00000000 } },
                {   {  0x7f7fffff, 0x00000000, 0x00000000, 0x00000000 },
                    {  0xff7fffff, 0x00000000, 0x00000000, 0x00000000 } },
                {   {  0x7ffe0000, 0x00000000, 0xffffffff, 0xffffffff },
                    {  0xfffe0000, 0x00000000, 0xffffffff, 0xffffffff } } };
#endif


#ifdef VCP
    if( e_flag ){
        if( sign == OVERFLOW ){
            for( i = 0 ; i < 4 ; i++ ){
#ifdef IEEE
                un_fr[treg].fr[i] =
                    reserve_dest[type][un_fcr.ctl.rnd][un_t[treg].t_data.s][i];
#else
                un_fr[treg].fr[i] = reserve_dest[type][un_t[treg].t_data.s][i];
#endif
            }
        }
        else{
            /* UNDERFLOW */
            for( i = 0 ; i < 4 ; i++ ){
                un_fr[treg].fr[i] = 0;
            }
            un_fr[treg].c_data.s = un_t[treg].t_data.s;
        }
        return;
    }
#endif
    switch( type ){
        case FLOAT_DATA :
                e = un_t[treg].f_data.e - TEMP_BIAS - ( sign * FLOAT_BIAS_S );
                if( ( e > FLOAT_BIAS ) || ( e < FLOAT_BIAS_SU ) ){
                    for( i = 0 ; i < 4 ; i++ ){
                        un_fr[treg].fr[i] = hard_nan[type][i];
                    }
                    un_fvct[treg].ctl.nan = 1;
                    un_fvct[treg].ctl.sts = F_STATUS_NAN;
                }
                else{
                    fp_cnv_t_f_sub( treg, type, e + FLOAT_BIAS );
                }
                break;
        case DOUBLE_DATA :
                e = un_t[treg].d_data.e - TEMP_BIAS - ( sign * DOUBLE_BIAS_S );
                if( ( e > DOUBLE_BIAS ) || ( e < DOUBLE_BIAS_SU ) ){
                    for( i = 0 ; i < 4 ; i++ ){
                        un_fr[treg].fr[i] = hard_nan[type][i];
                    }
                    un_fvct[treg].ctl.nan = 1;
                    un_fvct[treg].ctl.sts = F_STATUS_NAN;
                }
                else{
                    fp_cnv_t_f_sub( treg, type, e + DOUBLE_BIAS );
                }
                break;
        case EXTENDED_DATA :
                e = un_t[treg].e_data.e - TEMP_BIAS - ( sign * EXTENDED_BIAS_S );
                if( ( e > EXTENDED_BIAS ) || ( e < EXTENDED_BIAS_SU ) ){
                    for( i = 0 ; i < 4 ; i++ ){
                        un_fr[treg].fr[i] = hard_nan[type][i];
                    }
                    un_fvct[treg].ctl.nan = 1;
                    un_fvct[treg].ctl.sts = F_STATUS_NAN;
                }
                else{
                    fp_cnv_t_f_sub( treg, type, e + EXTENDED_BIAS );
                }
                break;
    }
}



fp_rnd( t_pe, treg, type )
int      t_pe;
unsigned treg; 
int      type;
{
    register unsigned rg, rr ,rk ,ri;
    int      i;
    unsigned tmp;

    switch( type ){
        case FLOAT_DATA :
                    rg = ( unsigned char )un_t[treg].f_data.g;
                    rr = ( unsigned char )un_t[treg].f_data.r;
                    if( ( un_t[treg].l_data[1] << 27 ) ||
                        ( un_t[treg].l_data[2] ) ||
                        ( un_t[treg].l_data[3] ) ){
                        rk = 1;
                    }
                    else{
                        rk = 0;
                    }
                    ri = un_t[treg].f_data.f & 0x01;
                    if( fp_rnd_check( treg, type, rg, rr, rk, ri ) == RND_ON ){
                        un_t[treg].f_data.g = un_t[treg].f_data.r =
                                              un_t[treg].f_data.k = 0;
                        return( RND_ON );
                    }
                    break;
        case DOUBLE_DATA :
                    rg = ( unsigned char )un_t[treg].d_data.g; 
                    rr = ( unsigned char )un_t[treg].d_data.r;
                    if( ( un_t[treg].l_data[2] << 24 ) ||
                        ( un_t[treg].l_data[3] ) ){
                        rk = 1;
                    }
                    else{
                        rk = 0;
                    }
                    ri = un_t[treg].d_data.f3 & 0x01;
                    if( fp_rnd_check( treg, type, rg, rr, rk, ri ) == RND_ON ){
                        un_t[treg].d_data.g = un_t[treg].d_data.r =
                                              un_t[treg].d_data.k = 0;
                        return( RND_ON );
                    }
                    break;
        case EXTENDED_DATA :
                    rg = ( unsigned char )un_t[treg].e_data.g;  
                    rr = ( unsigned char )un_t[treg].e_data.r; 
                    if( un_t[treg].l_data[3] << 3 ){
                        rk = 1;
                    }
                    else{
                        rk = 0;
                    }
                    ri = un_t[treg].e_data.f4;
                    if( fp_rnd_check( treg, type, rg, rr, rk, ri ) == RND_ON ){
                        un_t[treg].e_data.g = un_t[treg].e_data.r =
                                              un_t[treg].e_data.k = 0;
                        return( RND_ON );
                    }
                    break;
        case INTEGER_DATA :
        case INTEGER_DATA_Z :
                    rg = ( unsigned char )un_t[treg].i_data.g;
                    rr = ( unsigned char )un_t[treg].i_data.r;
                    if( ( un_t[treg].l_data[2] << 2 ) ||
                        ( un_t[treg].l_data[3] ) ){
                        rk = 1;
                    }
                    else{
                        rk = 0;
                    }
                    ri = un_t[treg].i_data.f & 0x01;
                    if( fp_rnd_check( treg, type, rg, rr, rk, ri ) == RND_ON ){
                        un_t[treg].i_data.g = un_t[treg].i_data.r =
                                              un_t[treg].i_data.k = 0;
                        return( RND_ON );
                    }
                    break;
    }
    return( RND_OFF );
}



fp_rnd_check( treg, type, rg, rr, rk, ri )
unsigned      treg; 
int           type;
unsigned      rg, rr ,rk ,ri;
{
    /* 
     * rounding excute
     */
    if( ( rg == 0 ) && ( rr == 0 ) && ( rk == 0 ) ){
        return( RND_OFF );
    }
    else{
        /*
         * un_fcr.ctl.ine = 1;
         */
        switch( un_fcr.ctl.rnd ){
            case 0: /* RN mode */
                if( rg ){
                    if( ( rr == 0 ) && ( rk == 0 ) ){
                        if( ri ){
                            fp_fdata_up( treg, type );
                        }
                    }
                    else{
                        fp_fdata_up( treg, type );
                    }
                }
                break;
            case 1: /* RZ mode */
                break;
            case 2: /* RP mode */
                if( !un_t[treg].t_data.s ){
                    fp_fdata_up( treg, type );
                }
                break;
            case 3: /* RM mode */
                if( un_t[treg].t_data.s ){
                    fp_fdata_up( treg, type ); 
                } 
                break;
        }
    }
    return( RND_ON );
}



fp_fdata_up( treg, type )
unsigned treg;
int      type;  
{  
    switch( type ){
        case FLOAT_DATA :
                un_t[treg].f_data.f++;
                break;
        case DOUBLE_DATA :
                if( !(++un_t[treg].d_data.f3) ){
                    un_t[treg].l_data[1]++;
                }
                break;
        case EXTENDED_DATA :
                if( un_t[treg].e_data.f4 ){
                    if( !(++un_t[treg].l_data[2]) ){
                        un_t[treg].l_data[1]++;
                    }
                }
                un_t[treg].e_data.f4++;
                break;
        case INTEGER_DATA :
                un_t[treg].i_data.f++;
                break;
        case INTEGER_DATA_Z :
		return;
                break;
    }
    if( un_t[treg].t_data.v ){
        fp_shift_r( treg, 1 );
    }
}



fp_add_temp( t_pe, treg1, treg2, treg3, type )
int      t_pe;
unsigned treg1, treg2, treg3;
int      type;
{
    unsigned k;
    unsigned mode;
    unsigned tmp;

    fp_cnv_f_t( treg1, type );
    fp_cnv_f_t( treg2, type );

    if( un_fcr.ctl.trct ){
#ifdef VCP
        if( un_fcr.ctl.vp ){
            fp_set_hard_nan( treg3, type );
        }
#endif
        return( FPU_SRC_ERROR );
    }
    /*
    if( un_fcr.fck.sts ){
        return( FPU_SRC_ERROR );
    }
    */
 
    switch( combination( un_fvct[treg1].ctl.sts, un_fvct[treg2].ctl.sts ) ){
        case F_COMB_1:
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = 0;
                }
                if( un_fr[treg1].f_data.s != un_fr[treg2].f_data.s ){
                    if( un_fcr.ctl.rnd == 3 ){
                        /* rnd = RM mode */
                        un_fr[treg3].f_data.s = 1;
                    }
                    else{
                        un_fr[treg3].f_data.s = 0;
                    }
                }
                else{
                    un_fr[treg3].f_data.s = un_fr[treg1].f_data.s;
                }
                un_fvct[treg3].ctl.z = 1;
                un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                return( FPU_SUCCEED );
                break;
        case F_COMB_3:
        case F_COMB_6:
                fp_set_infinite( treg3, type );
                un_fr[treg3].c_data.s = un_fr[treg2].c_data.s;
                un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.i = 1;
                return( FPU_SUCCEED );
                break;
        case F_COMB_7:
        case F_COMB_8:
                fp_set_infinite( treg3, type );
                un_fr[treg3].c_data.s = un_fr[treg1].c_data.s;
                un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.i = 1; 
                return( FPU_SUCCEED );
                break;
        case F_COMB_9:
                fp_set_infinite( treg3, type );
                un_fr[treg3].c_data.s = un_fr[treg1].c_data.s;
                if( un_fr[treg1].f_data.s != un_fr[treg2].f_data.s ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
#ifdef VCP
                        if( un_fcr.ctl.vp ){
                            fp_set_hard_nan( treg3, type );
                        }
#endif
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        fp_set_hard_nan( treg3, type );
                        un_fcr.ctl.ivo = 1;
                        un_fvct[treg3].ctl.nan = 1;
                    }
                }
                un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.i = 1;
                return( FPU_SUCCEED );
                break;
#ifndef IEEE
        case F_COMB_x1:
        case F_COMB_x2:
        case F_COMB_x3:
        case F_COMB_y1:
        case F_COMB_y2:
        case F_COMB_y3:
        case F_COMB_m:
                fp_set_hard_nan( treg3, type );
                un_fvct[treg3].ctl.nan = 1;
                if( un_fvct[treg1].ctl.snan || un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                return( FPU_SUCCEED );
                break;
#else
        case F_COMB_x1:
        case F_COMB_x2:
        case F_COMB_x3:
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg1].fr[k];
                }
                fp_set_qnan_bit( treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
        case F_COMB_y1:
        case F_COMB_y2:
        case F_COMB_y3:
                if( un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){ 
                    un_fr[treg3].fr[k] = un_fr[treg2].fr[k]; 
                } 
                fp_set_qnan_bit( treg3, type ); 
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1; 
                return( FPU_SUCCEED );
                break;
        case F_COMB_m:
                if( un_fvct[treg1].ctl.snan || un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                fp_set_model_nan( treg1, treg2, treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;  
                return( FPU_SUCCEED );
                break;
#endif
        default:
                k = 0;
                if( un_t[treg1].t_data.e > un_t[treg2].t_data.e ){
                    fp_shift_r( treg2,
                             un_t[treg1].t_data.e - un_t[treg2].t_data.e );
                    un_t[treg3].t_data.e = un_t[treg1].t_data.e;
                    mode = DATA_GT;
                }
                else{
                    if( un_t[treg1].t_data.e < un_t[treg2].t_data.e ){
                        fp_shift_r( treg1,
                                 un_t[treg2].t_data.e - un_t[treg1].t_data.e );
                        un_t[treg3].t_data.e = un_t[treg2].t_data.e;
                        mode = DATA_LT;
                    }
                    else{
                        un_t[treg3].t_data.e = un_t[treg1].t_data.e;
                        mode = DATA_EQ;
                    }
                }
                fp_add_temp_sub( t_pe, treg1, treg2, treg3, mode );
                return( fp_cnv_t_f( t_pe, treg3, type, 0 ) );
                break;
    }
}



fp_add_temp_sub( t_pe, treg1, treg2, treg3, mode )
int           t_pe;
unsigned      treg1, treg2, treg3, mode;
{
    unsigned       x;
    int            i,ret;
    register unsigned dummy;

    x = 0;
    if( un_t[treg1].t_data.s == un_t[treg2].t_data.s ){
        for( i = 5 ; i >= 0 ; i-- ){
             dummy = ( unsigned )un_t[treg1].s_data[i + 2] +
                     ( unsigned )un_t[treg2].s_data[i + 2] + x;
             x = dummy >> 16;
             un_t[treg3].s_data[i + 2] = ( unsigned short )dummy;
        }
        un_t[treg3].t_data.s = un_t[treg1].t_data.s;
    }
    else{
        switch( mode ){
            case DATA_GT :
                    fp_temp_sub( treg1, treg2 ,treg3 );
                    break;
            case DATA_LT :
                    fp_temp_sub( treg2, treg1 ,treg3 );
                    break;
            case DATA_EQ :
                    i = 1;
                    while( !( ret = 
                       (un_t[treg1].l_data[i] == un_t[treg2].l_data[i])
                            ?0:(un_t[treg1].l_data[i]  > un_t[treg2].l_data[i])
                                ?1:-1 ) ){
                        if( ++i >= 4 ){
                            break;
                        }
                    }
                    switch( ret ){
                        case 0 :
                                for( i = 0 ; i < 4 ; i++ ){
                                    un_t[treg3].l_data[i] = 0;
                                }
                                if( un_fcr.ctl.rnd == 3 ){
                                    /* rnd = RM */
                                    un_t[treg3].t_data.s = 1;
                                }
                                else{
                                    /* rnd = RN, RZ, RP */
                                    un_t[treg3].t_data.s = 0; 
                                }
                                break;
                        case 1 :
                                fp_temp_sub( treg1, treg2 ,treg3 );
                                break;
                        case -1 :
                                fp_temp_sub( treg2, treg1 ,treg3 );
                                break;
                    }
                    break;
        }
    }
}



fp_temp_sub( treg1, treg2, treg3 )
unsigned      treg1, treg2, treg3;
{
    unsigned    x;
    int         i;
    register unsigned dummy;

    x = 0;
    for( i = 5 ; i > 0 ; i -- ){
        dummy = 0x00010000 +
                ( unsigned )un_t[treg1].s_data[i + 2] -
                ( unsigned )un_t[treg2].s_data[i + 2] - x;
        x = !( dummy >> 16 );
        un_t[treg3].s_data[i + 2] = ( unsigned short )dummy;
    }
    dummy = ( unsigned )un_t[treg1].s_data[2] -
            ( unsigned )un_t[treg2].s_data[2] - x;
    un_t[treg3].s_data[2] = ( unsigned short )dummy;
    un_t[treg3].t_data.s = un_t[treg1].t_data.s;
}



fp_cmp_temp( t_pe, treg1, treg2, treg3, type, vp_opt )
int      t_pe;
unsigned treg1, treg2, treg3;
int      type;
int      vp_opt;      /* 0:normal error 1:error skip */
{
    int     i, ret;

    fp_cnv_f_t( treg1, type );
    fp_cnv_f_t( treg2, type );

    if( un_fcr.ctl.trct /* || un_fcr.fck.sts */ ){
#ifdef VCP
        if( un_fcr.ctl.vp ){
            if( !vp_opt && un_fvct[treg2].ctl.nan ){
                un_fcr.ctl.cmd = DATA_IV;
                return( FPU_SUCCEED );
            }
        }
#endif
        return( FPU_SRC_ERROR );
    }

    switch( combination( un_fvct[treg1].ctl.sts, un_fvct[treg2].ctl.sts ) ){
        /* normal calc */
        case F_COMB_1:
        case F_COMB_2:
        case F_COMB_4:
        case F_COMB_5:
                if( un_fvct[treg1].ctl.z && un_fvct[treg2].ctl.z ){
                    un_fcr.ctl.cmd = DATA_EQ;
                }
                else{
                    switch( ( un_t[treg1].t_data.s * 2 ) +
                                                        un_t[treg2].t_data.s ){
                        case 0:
                            if( un_t[treg1].t_data.e == un_t[treg2].t_data.e ){
                                for( i=1 ; i<=3 ; i++ ){
                                    if( un_t[treg1].l_data[i] >
                                        un_t[treg2].l_data[i] ){
                                        un_fcr.ctl.cmd = DATA_GT;
                                        break;
                                    }
                                    else{
                                        if( un_t[treg1].l_data[i] <
                                            un_t[treg2].l_data[i] ){
                                            un_fcr.ctl.cmd = DATA_LT;
                                            break;
                                        }
                                        else{
                                            un_fcr.ctl.cmd = DATA_EQ;
                                        }
                                    }
                                }
                            }
                            else{
                                un_fcr.ctl.cmd = 
                                  (un_t[treg1].t_data.e == un_t[treg2].t_data.e) 
                                       ?DATA_EQ:
                                  (un_t[treg1].t_data.e > un_t[treg2].t_data.e)
                                            ?DATA_GT:DATA_LT;
                            }
                            break;
                        case 1:
                            un_fcr.ctl.cmd = DATA_GT;
                            break;
                        case 2:
                            un_fcr.ctl.cmd = DATA_LT;
                            break;
                        case 3:
                            if( un_t[treg1].t_data.e == un_t[treg2].t_data.e ){ 
                                for( i=1 ; i<=3 ; i++ ){
                                    if( un_t[treg1].l_data[i] >
                                        un_t[treg2].l_data[i] ){
                                        un_fcr.ctl.cmd = DATA_LT;
                                        break;
                                    }
                                    else{
                                        if( un_t[treg1].l_data[i] <
                                            un_t[treg2].l_data[i] ){
                                            un_fcr.ctl.cmd = DATA_GT;
                                            break;
                                        }
                                        else{
                                            un_fcr.ctl.cmd = DATA_EQ;
                                        }
                                    }
                                }   
                            }        
                            else{ 
                                un_fcr.ctl.cmd =  
                                   (un_t[treg1].t_data.e == un_t[treg2].t_data.e)  
                                       ?DATA_EQ: 
                                   (un_t[treg1].t_data.e < un_t[treg2].t_data.e) 
                                            ?DATA_GT:DATA_LT;
                            }  
                            break;
                    }
                }
                return( FPU_SUCCEED );
                break;
        /* infinite data comp */
        case F_COMB_3:
        case F_COMB_6:
        case F_COMB_7:
        case F_COMB_8:
        case F_COMB_9:
                if( un_fvct[treg1].ctl.i && un_fvct[treg2].ctl.i ){
                    /* treg1 = treg2 = infinite data */
                    un_fcr.ctl.cmd =
                      ( un_fvct[treg1].ctl.n == un_fvct[treg2].ctl.n )?DATA_EQ:
                      ( un_fvct[treg1].ctl.n <  un_fvct[treg2].ctl.n )?DATA_GT:DATA_LT;
                }
                else{
                    if( un_fvct[treg1].ctl.i ){
                        /* treg1 = infinite data */
                        un_fcr.ctl.cmd = un_fvct[treg1].ctl.n?DATA_LT:DATA_GT;
                    }
                    else{
                        /* treg2 = infinite data */
                        un_fcr.ctl.cmd = un_fvct[treg2].ctl.n?DATA_GT:DATA_LT;
                    }
                }
                return( FPU_SUCCEED );
                break;
        case F_COMB_x1:
        case F_COMB_x2:
        case F_COMB_x3:
        case F_COMB_y1:
        case F_COMB_y2:
        case F_COMB_y3:
        case F_COMB_m:
                un_fcr.ctl.cmd = DATA_UN;
                if( un_fvct[treg1].ctl.snan || un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                un_fvct[treg3].ctl.nan = 1;
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                return( FPU_SUCCEED );
                break;
    }
    return( FPU_SUCCEED );
}



fp_mul_temp( t_pe, treg1, treg2, treg3, type )
int      t_pe;
unsigned treg1, treg2, treg3;
int      type;
{
    unsigned k;
    unsigned tmp1, tmp2;

    fp_cnv_f_t( treg1, type );
    fp_cnv_f_t( treg2, type );

    if( un_fcr.ctl.trct ){
#ifdef VCP
        if( un_fcr.ctl.vp ){
            fp_set_hard_nan( treg3, type );
        }
#endif
        return( FPU_SRC_ERROR );
    }
    /*
    if( un_fcr.fck.sts ){
        return( FPU_SRC_ERROR );
    }
    */

    switch( combination( un_fvct[treg1].ctl.sts, un_fvct[treg2].ctl.sts ) ){
        case F_COMB_1:
        case F_COMB_2:
        case F_COMB_4:
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = 0;
                }
                tmp1 = un_fr[treg1].f_data.s;
                tmp2 = un_fr[treg2].f_data.s;
                un_fr[treg3].f_data.s = tmp1 ^ tmp2;
                un_fvct[treg3].ctl.z = 1;
                un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                return( FPU_SUCCEED );
                break;
        case F_COMB_3:
        case F_COMB_7:
                if( un_fcr.ctl.fom ){
                    un_fcr.ctl.trct = 1;
                    un_fcr.ctl.fof = 1;
#ifdef VCP
                    if( un_fcr.ctl.vp ){
                        fp_set_hard_nan( treg3, type );
                    }
#endif
                    return( FPU_IVO_ERROR );
                }
                else{
                    fp_set_hard_nan( treg3, type );
                    un_fcr.ctl.ivo = 1;
                    un_fvct[treg3].ctl.nan = 1;
                    un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                    return( FPU_SUCCEED );
                }
                break;
                break;
        case F_COMB_6:
        case F_COMB_8:
        case F_COMB_9:
                fp_set_infinite( treg3, type );
                tmp1 = un_fr[treg1].f_data.s;
                tmp2 = un_fr[treg2].f_data.s;
                un_fr[treg3].f_data.s = tmp1 ^ tmp2;
                un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.i = 1; 
                return( FPU_SUCCEED );
                break;
#ifndef IEEE
        case F_COMB_x1:
        case F_COMB_x2:
        case F_COMB_x3:
        case F_COMB_y1:
        case F_COMB_y2:
        case F_COMB_y3:
        case F_COMB_m:
                fp_set_hard_nan( treg3, type );
                un_fvct[treg3].ctl.nan = 1;
                if( un_fvct[treg1].ctl.snan || un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                fp_set_hard_nan( treg3, type );
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
#else
        case F_COMB_x1:
        case F_COMB_x2:
        case F_COMB_x3:
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg1].fr[k];
                }
                fp_set_qnan_bit( treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
        case F_COMB_y1:
        case F_COMB_y2:
        case F_COMB_y3:
                if( un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg2].fr[k];
                }
                fp_set_qnan_bit( treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
        case F_COMB_m:
                if( un_fvct[treg1].ctl.snan || un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                fp_set_model_nan( treg1, treg2, treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
#endif
        default:
                tmp1 = un_t[treg1].t_data.s;
                tmp2 = un_t[treg2].t_data.s;
                un_t[treg3].t_data.s = tmp1 ^ tmp2;
                un_t[treg3].t_data.e = ( un_t[treg1].t_data.e - TEMP_BIAS ) +
                                         un_t[treg2].t_data.e + 2;
                fp_mul_temp_sub( t_pe, treg1, treg2, treg3 );
                return( fp_cnv_t_f( t_pe, treg3, type, 0 ) );
                break;
    }
}



fp_mul_temp_sub( t_pe, treg1, treg2, treg3 )
int           t_pe;
unsigned      treg1, treg2, treg3;
{
    unsigned mdata[12];
    register unsigned dummy;
    register int      i, j;

    for( i = 0 ; i < 12 ; i++ ){
        mdata[i] = 0;
    }
    for( i = 5 ; i >= 0 ; i-- ){
        for( j = 5 ; j >= 0 ; j-- ){
            dummy = ( unsigned )un_t[treg1].s_data[i + 2] *
                    ( unsigned )un_t[treg2].s_data[j + 2];
            mdata[ i + j ]     += dummy >> 16;
            mdata[ i + j + 1 ] += dummy & 0x0000ffff;
        }
    }
    j = 0; /* j = k bit */
    for( i = 11 ; i > 5 ; i-- ){
        mdata[i - 1] += mdata[ i ] >> 16;
        mdata[ i ]    = mdata[ i ] & 0x0000ffff;
        j             = j | ( unsigned int )( mdata[ i ] );
    }
    if( j ){
        mdata[5] |= 1; 
    }
    for( i = 5 ; i > 0 ; i-- ){
        mdata[i - 1] += mdata[ i ] >> 16;
        un_t[treg3].s_data[i+2] = (unsigned short)(mdata[ i ] & 0x0000ffff);
    }
    un_t[treg3].s_data[2] = (unsigned short)(mdata[0]);
}



fp_div_temp( t_pe, treg1, treg2, treg3, type )
int      t_pe;
unsigned treg1, treg2, treg3;
int      type;
{
    unsigned k;
    unsigned tmp1, tmp2;

    fp_cnv_f_t( treg1, type );
    fp_cnv_f_t( treg2, type );

    if( un_fcr.ctl.trct ){
#ifdef VCP
        if( un_fcr.ctl.vp ){
            fp_set_hard_nan( treg3, type );
        }
        else{
#endif
        if( !un_fcr.ctl.fof ){
            if( un_fvct[treg2].ctl.z ){
                if( un_fcr.ctl.fdm ){
                    un_fcr.ctl.trct = 1;
                    un_fcr.ctl.fdf = 1;
                }
                else{
                    un_fcr.ctl.dz = 1;
                }
            }
        }
#ifdef VCP
        }
#endif
        return( FPU_SRC_ERROR );
    }
    /*
    if( un_fcr.fck.sts ){
        return( FPU_SRC_ERROR );
    }
    */
 
    switch( combination( un_fvct[treg1].ctl.sts, un_fvct[treg2].ctl.sts ) ){
        case F_COMB_1:
        case F_COMB_9:
                if( un_fcr.ctl.fom ){
                    un_fcr.ctl.trct = 1;
                    un_fcr.ctl.fof = 1;
#ifdef VCP
                    if( un_fcr.ctl.vp ){
                        fp_set_hard_nan( treg3, type );
                    }
#endif
                    return( FPU_IVO_ERROR );
                }
                else{
                    fp_set_hard_nan( treg3, type );
                    un_fcr.ctl.ivo = 1;
                    un_fvct[treg3].ctl.nan = 1;
                    un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                    return( FPU_SUCCEED );
                }
                break;
        case F_COMB_2:
        case F_COMB_3:
        case F_COMB_6:
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = 0;
                }
                tmp1 = un_fr[treg1].f_data.s;
                tmp2 = un_fr[treg2].f_data.s;
                un_fr[treg3].f_data.s = tmp1 ^ tmp2;
                un_fvct[treg3].ctl.z  = 1;
                un_fvct[treg3].ctl.n  = un_fr[treg3].f_data.s;
                return( FPU_SUCCEED );
                break;
        case F_COMB_4:
                if( un_fcr.ctl.fdm ){
                    un_fcr.ctl.trct = 1;
                    un_fcr.ctl.fdf = 1;
#ifdef VCP
                    if( un_fcr.ctl.vp ){
                        fp_set_infinite( treg3, type );
                        tmp1 = un_fr[treg1].f_data.s;
                        tmp2 = un_fr[treg2].f_data.s;
                        un_fr[treg3].f_data.s = tmp1 ^ tmp2;
                        un_fvct[treg3].ctl.n  = un_fr[treg3].f_data.s;
                        un_fvct[treg3].ctl.i  = 1; 
                    }
#endif
                    return( FPU_DZ_ERROR );
                }
                else{
                    fp_set_infinite( treg3, type );
                    tmp1 = un_fr[treg1].f_data.s;
                    tmp2 = un_fr[treg2].f_data.s;
                    un_fr[treg3].f_data.s = tmp1 ^ tmp2;
                    un_fvct[treg3].ctl.n  = un_fr[treg3].f_data.s;
                    un_fvct[treg3].ctl.i  = 1; 
                    un_fcr.ctl.dz = 1; 
                    return( FPU_SUCCEED );
                }
                break;
        case F_COMB_7:
        case F_COMB_8:
                fp_set_infinite( treg3, type );
                tmp1 = un_fr[treg1].f_data.s;
                tmp2 = un_fr[treg2].f_data.s;
                un_fr[treg3].f_data.s = tmp1 ^ tmp2;
                un_fvct[treg3].ctl.n = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.i = 1; 
                return( FPU_SUCCEED );
                break;
#ifndef IEEE
        case F_COMB_x1:
        case F_COMB_x2:
        case F_COMB_x3:
        case F_COMB_y1:
        case F_COMB_y2:
        case F_COMB_y3:
        case F_COMB_m:
                fp_set_hard_nan( treg3, type );
                un_fvct[treg3].ctl.nan = 1;
                if( un_fvct[treg1].ctl.snan || un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                fp_set_hard_nan( treg3, type );
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
#else
        case F_COMB_x1:
        case F_COMB_x2:
        case F_COMB_x3:
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg1].fr[k];
                }
                fp_set_qnan_bit( treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
        case F_COMB_y1:
        case F_COMB_y2:
        case F_COMB_y3:
                if( un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg2].fr[k];
                }
                fp_set_qnan_bit( treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
        case F_COMB_m:
                if( un_fvct[treg1].ctl.snan || un_fvct[treg2].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                fp_set_model_nan( treg1, treg2, treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].f_data.s;
                un_fvct[treg3].ctl.nan = 1;
                return( FPU_SUCCEED );
                break;
#endif
        default:
                tmp1 = un_t[treg1].t_data.s;
                tmp2 = un_t[treg2].t_data.s;
                un_t[treg3].t_data.s = tmp1 ^ tmp2;
                un_t[treg3].t_data.e = ( un_t[treg1].t_data.e - TEMP_BIAS ) -
                                         un_t[treg2].t_data.e - 3;
                fp_div_temp_sub( t_pe, treg1, treg2, treg3 );
                return( fp_cnv_t_f( t_pe, treg3, type, 0 ) );
                break;
    }
}



fp_div_temp_sub( t_pe, treg1, treg2, treg3 )
int           t_pe;
unsigned      treg1, treg2, treg3;
{
    register unsigned dummy;
    register int      i, j, k;
    register int      z_flag, k_bit, r_bit;

    z_flag = 0;
    un_t[treg1].l_data[4] = 0;
    un_t[treg1].l_data[5] = 0;
    un_t[treg1].l_data[6] = 0;
    un_t[treg2].l_data[4] = 0;
    un_t[treg2].l_data[5] = 0;
    un_t[treg2].l_data[6] = 0;
    for( i = 0 ; i < 96 ; i++ ){
        k_bit = r_bit = 0;
        if( !z_flag ){
            j = 1;
            while( !( k = (un_t[treg1].l_data[j] == un_t[treg2].l_data[j])
                ?0:(un_t[treg1].l_data[j]  > un_t[treg2].l_data[j]) ?1:-1 ) ){
                if( ++j > 6 ){
                    break;
                }
            }
            switch( k ){
                case 0 :
                        z_flag = 1;
                        k_bit = 1;
                        r_bit = 0;
                        break;
                case 1 :
                        for( j = 11 ; j > 0 ; j-- ){
                            dummy = 0x00010000 +
                            ( unsigned )un_t[treg1].s_data[j + 2] -
                            ( unsigned )un_t[treg2].s_data[j + 2] - k_bit;
                            k_bit = !( dummy >> 16 );
                            un_t[treg1].s_data[j + 2] = ( unsigned short )dummy;
                        }
                        dummy = ( unsigned )un_t[treg1].s_data[2] -
                                ( unsigned )un_t[treg2].s_data[2] - k_bit;
                        un_t[treg1].s_data[2] = ( unsigned short )dummy;
                        k_bit = 1;
                        r_bit = 1;
                        break;
                case -1 :
                        r_bit = 1;
                        break;
            }
            un_t[treg1].l_data[1] = ( un_t[treg1].l_data[1] << 1 ) +
                                    ( un_t[treg1].l_data[2] >> 31 );
            un_t[treg1].l_data[2] = ( un_t[treg1].l_data[2] << 1 ) +
                                    ( un_t[treg1].l_data[3] >> 31 );
            un_t[treg1].l_data[3] = ( un_t[treg1].l_data[3] << 1 ) +
                                    ( un_t[treg1].l_data[4] >> 31 );
            un_t[treg1].l_data[4] = ( un_t[treg1].l_data[4] << 1 ) +
                                    ( un_t[treg1].l_data[5] >> 31 );
            un_t[treg1].l_data[5] = ( un_t[treg1].l_data[5] << 1 ) +
                                    ( un_t[treg1].l_data[6] >> 31 );
            un_t[treg1].l_data[6] =   un_t[treg1].l_data[6] << 1;
        }
        un_t[treg3].l_data[1] = ( un_t[treg3].l_data[1] << 1 ) +
                                ( un_t[treg3].l_data[2] >> 31 );
        un_t[treg3].l_data[2] = ( un_t[treg3].l_data[2] << 1 ) +
                                ( un_t[treg3].l_data[3] >> 31 );
        un_t[treg3].l_data[3] = ( un_t[treg3].l_data[3] << 1 ) + k_bit;
    }
    un_t[treg3].l_data[3] |= r_bit;
}



fp_cnv_temp( t_pe, treg1, treg3, type1, type3 )
int      t_pe;
unsigned treg1, treg3;
int      type1, type3;
{
    unsigned k;

    fp_cnv_f_t( treg1, type1 );

    if( un_fcr.ctl.trct ){
#ifdef VCP
        if( un_fcr.ctl.vp ){
            fp_set_hard_nan( treg3, type3 );
        }
#endif
        return( FPU_SRC_ERROR );
    }
    /*
    if( un_fcr.fck.sts ){
        return( FPU_SRC_ERROR );
    }
    */

    switch( un_fvct[treg1].ctl.sts  ){
        case F_STATUS_NAN :
#ifndef IEEE
                fp_set_hard_nan( treg3, type3 );
                un_fvct[treg3].ctl.nan = 1;
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
#else
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg1].fr[k];
                }
                fp_set_qnan_bit( treg3, type3 );
                un_fvct[treg3].ctl.n   = un_fr[treg3].c_data.s;
                un_fvct[treg3].ctl.nan = 1;
#endif
                return( FPU_SUCCEED );
                break;
        case F_STATUS_I :
                fp_set_infinite( treg3, type3 );
                un_fvct[treg3].ctl.n = un_fr[treg3].c_data.s = 
                                       un_fr[treg1].c_data.s;
                un_fvct[treg3].ctl.i = 1; 
                return( FPU_SUCCEED );
                break;
        case F_STATUS_Z :
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = 0;
                }
                un_fvct[treg3].ctl.n = un_fr[treg3].c_data.s =
                                       un_fr[treg1].c_data.s;
                un_fvct[treg3].ctl.z = 1;
                return( FPU_SUCCEED );
                break;
        default:
                for( k = 0 ; k < 4 ; k++ ){
                    un_t[treg3].l_data[k] = un_t[treg1].l_data[k];
                }
#ifdef VCP
                if( un_fcr.ctl.vp ){
                    return( fp_cnv_t_f( t_pe, treg3, type3, 1 ) );
                }
#endif
                k = fp_cnv_t_f( t_pe, treg3, type3, 0 );
                if( un_fvct[treg3].ctl.sts == F_STATUS_NAN ){
                    un_fcr.fck.ff = un_fcr.fck.sts = 0;
                    un_fcr.ctl.fxf = 1;
                    un_fcr.ctl.trct = 1;
                    return( FPU_SRC_ERROR );
                }
                else{
                    return( k );
                }
                break;
    }
}



fp_cnv_ti_temp( t_pe, treg1, treg3, type1, type3 )
int      t_pe;
unsigned treg1, treg3;
int      type1, type3;
{
    unsigned k;
    int      i, j, f;
 
    fp_cnv_f_t( treg1, type1 );

    if( un_fcr.ctl.trct ){
#ifdef VCP
        if( un_fcr.ctl.vp ){
            for( j = 0 ; j < 4 ; j++ ){
                un_fr[treg3].fr[j] = 0;
            }
            un_fvct[treg3].ctl.z = 1;
        }
#endif
        return( FPU_SRC_ERROR );
    }
    /*
    if( un_fcr.fck.sts ){
        return( FPU_SRC_ERROR );
    }
    */

    switch( un_fvct[treg1].ctl.sts ){
        case F_STATUS_NAN :
#ifndef IEEE
#ifdef VCP
                if( un_fcr.ctl.vp ){
                    for( j = 0 ; j < 4 ; j++ ){
                        un_fr[treg3].fr[j] = 0;
                    }
                }
                else{
                    fp_set_hard_nan( treg3, type1 );
                }
#else
                fp_set_hard_nan( treg3, type1 );
#endif
                un_fvct[treg3].ctl.nan = 1;
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
                else{
                    un_fcr.ctl.fxf = un_fcr.ctl.trct = 1;
                    return( FPU_SRC_ERROR );
                }
#else
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg1].fr[k];
                }
                fp_set_qnan_bit( treg3, type3 );
                un_fvct[treg3].ctl.n   = un_fr[treg3].c_data.s;
                un_fvct[treg3].ctl.nan = 1;
#endif
                return( FPU_SUCCEED );
                break;
        case F_STATUS_I :
                un_fcr.ctl.trct = 1;
#ifdef VCP
                if( un_fcr.ctl.vp ){
                    for( j = 0 ; j < 4 ; j++ ){
                        un_fr[treg3].fr[j] = 0;
                    }
                }
#endif
                un_fcr.ctl.fxf = 1;
                return( FPU_UNI_ERROR );
                break;
        case F_STATUS_Z :
                for( j = 0 ; j < 4 ; j++ ){
                    un_fr[treg3].fr[j] = 0;
                }
                un_fvct[treg3].ctl.z = 1;
                return( FPU_SUCCEED );
                break;
        default:
                j = un_t[treg1].t_data.e - TEMP_BIAS;
                for( i = 0 ; i < 4 ; i++ ){
                    un_t[treg3].l_data[i] = un_t[treg1].l_data[i];
                }
                if( j > 30 ){
                    if( !fp_shift_l( treg3, j - 30 ) ){
                        if( ( un_t[treg3].l_data[1] ==  0x80000000 ) &&
                            un_t[treg3].t_data.s ){
                            if( fp_rnd( t_pe, treg3, type3 ) == RND_ON ){
                                if( un_t[treg3].l_data[1] == 0x80000000 ){
                                    un_fr[treg3].fr[0] = 0x80000000;
                                    if( un_fcr.ctl.fim ){
                                        /* un_fcr.ctl.trct = 1; */
                                        un_fcr.ctl.fif = 1;
                                        return( FPU_INE_ERROR );
                                    }
                                    else{
                                        un_fcr.ctl.ine = 1;
                                        return( FPU_SUCCEED );
                                    }
                                }
                            }
                            else{
                                un_fr[treg3].fr[0] = 0x80000000;
                                return( FPU_SUCCEED );
                            }
                        }
                    }
#ifdef VCP
                    if( un_fcr.ctl.vp ){
                        un_t[treg3].t_data.v = un_t[treg3].t_data.s;
                        /* un_fr[treg3].fr[0] = un_t[treg3].l_data[1]; */
                        un_fr[treg3].fr[0] = 0x80000000;
                    }
#endif
                    un_fcr.ctl.fxf = un_fcr.ctl.trct = 1;
                    return( FPU_SRC_ERROR );
                }
                else{
                    fp_shift_r( treg3, 30 - j );
                    f = fp_rnd( t_pe, treg3, type3 );
                    if( un_t[treg3].t_data.s ){
                        un_fr[treg3].fr[0] = 
                         ( unsigned )( ( int )un_t[treg3].l_data[1] * -1);
                    }
                    else{
                        un_fr[treg3].fr[0] = un_t[treg3].l_data[1];
                    }
                    if( f == RND_ON ){
                        if( ( un_t[treg3].t_data.e - TEMP_BIAS ) > 30 ){
                            if( un_t[treg3].t_data.s ){
                                un_fr[treg3].fr[0] = 0x80000000;
                            }
                            else{
                                un_fcr.ctl.fxf = 1;
                                /*
                                un_fcr.ctl.trct = 1;
                                 */
                                return( FPU_SRC_ERROR );
                            }
                        }
                        if( un_fcr.ctl.fim ){
                            /*
                            un_fcr.ctl.trct = 1;
                             */
                            un_fcr.ctl.fif = 1;
                            return( FPU_INE_ERROR );
                        }
                        else{
                            un_fcr.ctl.ine = 1;
                        }
                    }
                    return( FPU_SUCCEED );
                }
                break;
    }
}



fp_cnv_it_temp( t_pe, treg1, treg3, type1, type3 )
int      t_pe;
unsigned treg1, treg3;
int      type1, type3;
{
    unsigned k;
    int      i;

    if( un_fr[treg1].fr[0] ){
        un_t[treg3].t_data.s = un_fr[treg1].c_data.s;
        if( un_t[treg3].t_data.s ){
            un_t[treg3].l_data[1] = ( unsigned )( ( int )un_fr[treg1].fr[0] * -1 );
        }
        else{
            un_t[treg3].l_data[1] = un_fr[treg1].fr[0];
        }
        un_t[treg3].t_data.e = TEMP_BIAS + 30;
        return( fp_cnv_t_f( t_pe, treg3, type3, 0 ) );
    }
    else{
        un_fvct[treg3].ctl.z = 1;
        return( FPU_SUCCEED );
    }
}



fp_positive_temp( t_pe, treg1, treg3, type )
int      t_pe;
unsigned treg1, treg3;
int      type;
{
    unsigned k;

    fp_cnv_f_t( treg1, type );

    if( un_fcr.ctl.trct ){
#ifdef VCP
        if( un_fcr.ctl.vp ){
            fp_set_hard_nan( treg3, type );
        }
#endif
        return( FPU_SRC_ERROR );
    }
    /*
    if( un_fcr.fck.sts ){
        return( FPU_SRC_ERROR );
    }
    */

    switch( un_fvct[treg1].ctl.sts  ){
        case F_STATUS_NAN :
#ifndef IEEE
                fp_set_hard_nan( treg3, type );
                un_fvct[treg3].ctl.nan = 1;
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1; 
                    }
                }
#else
                if( un_fvct[treg1].ctl.snan ){
                    if( un_fcr.ctl.fom ){
                        un_fcr.ctl.trct = 1;
                        un_fcr.ctl.fof = 1;
                        return( FPU_IVO_ERROR );
                    }
                    else{
                        un_fcr.ctl.ivo = 1;
                    }
                }
                for( k = 0 ; k < 4 ; k++ ){
                    un_fr[treg3].fr[k] = un_fr[treg1].fr[k];
                }
                fp_set_qnan_bit( treg3, type );
                un_fvct[treg3].ctl.n   = un_fr[treg3].c_data.s;
                un_fvct[treg3].ctl.nan = 1;
#endif
                return( FPU_SUCCEED );
                break;
        default:
                switch( type ){
                    case FLOAT_DATA :
                            un_fr[treg3].fr[0] = un_fr[treg1].fr[0];
                            for( k = 1 ; k < 4 ; k++ ){
                                un_fr[treg3].fr[k] = 0;
                            }
                            break;
                    case DOUBLE_DATA :
                            un_fr[treg3].fr[0] = un_fr[treg1].fr[0];
                            un_fr[treg3].fr[1] = un_fr[treg1].fr[1];
                            un_fr[treg3].fr[2] = un_fr[treg3].fr[3] = 0;
                            break;
                    case EXTENDED_DATA :
                            for( k = 1 ; k < 4 ; k++ ){
                                un_fr[treg3].fr[k] = un_fr[treg1].fr[k];
                            }
                            break;
                }
                un_fr[treg3].c_data.s = 0;
                return( FPU_SUCCEED );
                break;
    }
}



fp_set_hard_nan( treg, type )
unsigned      treg;
int           type;
{
    static unsigned hard_nan[3][4] =
                {   {   0x7fffffff, 0xffffffff, 0x00000000, 0x00000000 },
                    {   0x7fffffff, 0x00000000, 0x00000000, 0x00000000 },
                    {   0x7fff0000, 0x00000000, 0x7fffffff, 0xffffffff } };
 int    i;

    for( i = 0 ; i < 4 ; i++ ){
        un_fr[treg].fr[i] = hard_nan[type][i];
    }
}



fp_set_qnan_bit( treg, type )
unsigned      treg;
int           type;
{
    static unsigned qnan_bit[3][4] =
                {   {   0x00080000, 0x00000000, 0x00000000, 0x00000000 },
                    {   0x00400000, 0x00000000, 0x00000000, 0x00000000 },
                    {   0x00000000, 0x00000000, 0x40000000, 0x00000000 } };
    int    i;

    for( i = 0 ; i < 4 ; i++ ){
        un_fr[treg].fr[i] = un_fr[treg].fr[i] | qnan_bit[type][i];
    }
}



fp_set_model_nan( treg1, treg2, treg3, type )
unsigned      treg1, treg2, treg3;
int           type;
{
    int       i;
    unsigned  tregx;

    if( ( !un_fvct[treg1].ctl.snan ) && un_fvct[treg2].ctl.snan ){
        tregx = treg2;
    }
    else{
        tregx = treg1;
    }
    for( i = 0 ; i < 4 ; i++ ){
        un_fr[treg3].fr[i] = un_fr[tregx].fr[i];
    }
    fp_set_qnan_bit( treg3, type );
}



fp_set_infinite( treg, type )
unsigned      treg;
int           type;
{
    static unsigned infinite[3][4] =
                {   {   0x7ff00000, 0x00000000, 0x00000000, 0x00000000 },
                    {   0x7f800000, 0x00000000, 0x00000000, 0x00000000 },
                    {   0x7fff0000, 0x00000000, 0x00000000, 0x00000000 } };
    int    i;

    for( i = 0 ; i < 4 ; i++ ){
        un_fr[treg].fr[i] = infinite[type][i];
    }
}
