static char SccsId[] = "@(#)gsigp.c	1.3    8/26/91";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* gsigp.c    90/12/20 */

#ifdef GSIGP

#include "tim.h"

sim_gsigp(t_pe)
    unsigned t_pe;
{
    unsigned dstpe, cc, status, i, any_received;

    if (pe[T_PE].gsigp_delay_count) {
      if (!--pe[T_PE].gsigp_delay_count) {

        dstpe  = pe[T_PE].mcr[GHC0].ghc0.clad;
        cc     = 0;
        status = 0;

        switch (pe[T_PE].mcr[GHC0].ghc0.order) {
        case 1: /* Cluster Sense */
          if (dstpe < PE_NUM) {
            if (pe[dstpe].mcr[GHIN].ghin.cscin) {
              cc     = 1;
              status |= 0x100;
            }
            if ((0x80 >> t_pe) & pe[dstpe].mcr[GHIN].ghin.cacin) {
              cc     = 1;
              status |= 0x80;
            }
          }
          else {
            cc     = 3;
            status = 1;
          }
          break;

        case 2: /* Cluster SC */
          if (dstpe < PE_NUM) {
            if (pe[dstpe].mcr[GHIN].ghin.cscin) {
              cc     = 1;
              status = 0x100;
            }
            else {
              pe[dstpe].mcr[GHIN].ghin.cscin = 1;
              pe[dstpe].mcr[GHII0].ghii0.clid = t_pe;
              pe[dstpe].mcr[GHII1].ful = pe[T_PE].mcr[GHC1].ful;
              pe[dstpe].mcr[GHII2].ful = pe[T_PE].mcr[GHC2].ful;
            }
          }
          else {
            cc     = 3;
            status = 1;
          }
          break;

        case 3: /* Cluster AC */
          if (dstpe < PE_NUM) {
            if ((0x80 >> t_pe) & pe[dstpe].mcr[GHIN].ghin.cacin) {
              cc     = 1;
              status = 0x80;
            }
            else {
              pe[dstpe].mcr[GHIN].ghin.cacin |= 0x80 >> t_pe;
            }
          }
          else {
            cc     = 3;
            status = 1;
          }
          break;

        case 7: /* Cluster Broadcast */
          any_received = 0;
          for (i=0; i<PE_NUM; i++) {
            if (i != t_pe) {
              any_received = 1;
              pe[i].mcr[GHIN].ghin.cbcin = 1;
            }
          }
          if (!any_received) {
            cc     = 2;
            status = 1;
          }
          break;

	default:
	  cc     = 1;
	  status = 2;
          break;
        }

        pe[T_PE].mcr[GHST].ghst.busy   = 0;
        pe[T_PE].mcr[GHST].ghst.cc     = cc;
        pe[T_PE].mcr[GHST].ghst.status = status;
      }
    }

    if (pe[T_PE].smcr[GHCTL].ful) { /* get start command */
      if (!pe[T_PE].mcr[GHST].ghst.busy) {
        pe[T_PE].mcr[GHST].ghst.busy = 1;
        pe[T_PE].gsigp_delay_count = GSIGP_DELAY;
      }
      pe[T_PE].smcr[GHCTL].ful = 0;
    }

    if (pe[T_PE].mcr[GHIN].ful)
      pe[T_PE].ext_interrupt |= GSIGP_INTERRUPT;
}

#endif

