static char SccsId[] = "@(#)main.c	1.11    4/22/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* main.c	89/10/1 */

#include "tim.h"

main(argc, argv) int argc; char **argv;
{
    int		onintr_startup();
    FILE	*create_file();
    FILE	*open_file();
    FILE	*open_rc();
    FILE	*open_command();
    char        *urindex();
    char        *getenv();
    char        *version();

    int		wargc;       /* work for traverse argc */
    char        **wargv;     /* work for traverse argv */
    char        **nargv;     /* new argv for fork */
    char        **wnargv;    /* work for tarverse nargv */
    char        *w_arg;      /* work for traverse *argv */
    char        *ww_arg;     /* work for traverse *argv */
    char        *term;       /* terminal type */
    char        *lines;      /* terminal lines */
    char	ppid[8];     /* tim's pid for signal */
    int		verbose = 0; /* work for "-v" option */
    int		discons = 0; /* work for "-n" option */
    unsigned	t_pe;        /* PE# */

    init_env(); /* initialize environment variables */

    wargc = argc;
    wargv = argv;
    for (wargc--, wargv++; wargc; wargc--, wargv++) {
        if (*(w_arg = *wargv) != '-') { /* regard as a file name */
	    strcpy(ENV_MODULE = malloc(strlen(w_arg) + 1), w_arg);
	    continue;
	}
        switch (*++w_arg) {
        case 'P':
#if PE_NUM == penum
            if (sscanf(w_arg+1, "%d", &PE_NUM) != 1) {
                fprintf(stderr, "illegal number of PEs: %s\n", w_arg+1);
                exit(1);
            }
#else
            fprintf(stderr, "number of PEs is fixed to %d\n", PE_NUM);
            exit(1);
#endif
	    break;
        case 'M':
            if (sscanf(w_arg+1, "%d", &pagenum) != 1) {
                fprintf(stderr, "illegal number of pages: %s\n", w_arg+1);
                exit(1);
            }
            memsize = PAGE_SIZE * pagenum;
	    break;
        case 'R':
	    strcpy(ENV_INITRC = malloc(strlen(w_arg+1) + 1), w_arg+1);
	    break;
        case 'C':
	    strcpy(ENV_COMMAND = malloc(strlen(w_arg+1) + 1), w_arg+1);
	    break;
        case 'D':
	    strcpy(ENV_CMDDIR = malloc(strlen(w_arg+1) + 1), w_arg+1);
	    break;
        case 'H':
	    strcpy(ENV_HISTORY = malloc(strlen(w_arg+1) + 1), w_arg+1);
	    break;
        case 'L':
	    strcpy(ENV_DISPLOG = malloc(strlen(w_arg+1) + 1), w_arg+1);
	    break;
        case 'G':
	    strcpy(ENV_GDBREPL = malloc(strlen(w_arg+1) + 1), w_arg+1);
	    break;
        case 'A':
	    strcpy(ENV_ALLFAC = malloc(strlen(w_arg+1) + 1), w_arg+1);
	    break;
        case 'F':
	    strcpy(ENV_DASD = malloc(strlen(w_arg+1) + 1), w_arg+1);
            for (ww_arg=ENV_DASD; *ww_arg; ww_arg++) {
                if (*ww_arg == '#') {
                    *ww_arg = NULL;
                    if (sscanf(ww_arg+1, "%d", &dasd_blocks) != 1) {
                        fprintf(stderr, "illegal dasd_blocks: %s\n", ww_arg+1);
                        exit(1);
                    }
                    break;
                }
            }
            if (!dasd_blocks) {
                fprintf(stderr, "missing dasd_blocks: %s\n", w_arg-1);
                exit(1);
            }
	    break;
        case 'S':
	    strcpy(ENV_SSU = malloc(strlen(w_arg+1) + 1), w_arg+1);
            for (ww_arg=ENV_SSU; *ww_arg; ww_arg++) {
                if (*ww_arg == '#') {
                    *ww_arg = NULL;
                    if (sscanf(ww_arg+1, "%d", &ssu_elements) != 1) {
                        fprintf(stderr, "illegal ssu_elements: %s\n", ww_arg+1);
                        exit(1);
                    }
                    break;
                }
            }
            if (!ssu_elements) {
                fprintf(stderr, "missing ssu_elements: %s\n", w_arg-1);
                exit(1);
            }
	    break;
        case 'v':
            verbose = 1;
            break;
        case 'n':
            discons = 1;
            break;
        case 'f':
            fast_mv = 1;
            break;
        case 'o':
            old_mode = 1;
            break;
        case 'g':
            kiodebug = 1;
            break;
        default:
            fprintf(stderr, "illegal option: %s\n", w_arg);
            fprintf(stderr, "  [<file>]            : load module\n");
            fprintf(stderr, "  -P<PEs>             : number of PEs\n");
            fprintf(stderr, "  -M<pages>           : number of pages for memory\n");
            fprintf(stderr, "  -R[<file>]          : input initial command from file\n");
            fprintf(stderr, "  -C<file>            : input command from file\n");
            fprintf(stderr, "  -D<dir>             : set script directory\n");
            fprintf(stderr, "  -H[<file>]          : output command history to file\n");
            fprintf(stderr, "  -L[<file>]          : output messages to file\n");
            fprintf(stderr, "  -G<file>            : output GDB-reply to file\n");
            fprintf(stderr, "  -A<file>            : read all facility from file\n");
            fprintf(stderr, "  -F<file>#<blocks>   : connect <file> as DASD\n");
            fprintf(stderr, "  -S<file>#<elements> : connect <file> as SSU\n");
            fprintf(stderr, "  -v                  : verbose\n");
            fprintf(stderr, "  -n                  : disable console\n");
            fprintf(stderr, "  -f                  : fast mover\n");
            fprintf(stderr, "  -o                  : old mode\n");
            fprintf(stderr, "  -g                  : set debug mode for GDB\n");
            fprintf(stderr, "                        - ext_intr,slrp_intr delayed\n");
	    exit(1);
            break;
        }
    }

    if ((command_fp = open_command(ENV_COMMAND)) == NULL)
        exit(1);

    if (command_fp == stdin) {
      switch (setup_scr(&term, &lines)) {
#ifndef DEBUG
      case 1: /* retry with 'vtem' */
        wargc  = argc;
        wargv  = argv;
        wnargv = nargv = (char **)malloc((wargc+3)*4);
        *wnargv++ = urindex(VTEM_PATH, '/');
        *wnargv++ = lines;
        for (;wargc; wargc--)
            *wnargv++ = *wargv++;
        *wnargv   = NULL;
        execvp(VTEM_PATH, nargv);
        break;

      case 2: /* retry with 'screen+vtem' */
        wargc  = argc;
        wargv  = argv;
        wnargv = nargv = (char **)malloc((wargc+4)*4);
        *wnargv++ = urindex(SCREEN_PATH, '/');
        *wnargv++ = VTEM_PATH;
        *wnargv++ = lines;
        for (;wargc; wargc--)
            *wnargv++ = *wargv++;
        *wnargv   = NULL;
        execvp(SCREEN_PATH, nargv);
        break;

      case 3: /* do nothing (poor terminal) */
        break;
#endif
      }
    }

#ifdef CONSOLE
    signal(SIGINT, onintr_startup);
    signal(SIGUSR1, SIG_IGN);
    signal(SIGUSR2, SIG_IGN);

    if (!discons) {
      create_console(ENV_COIN, _R_); 		/* create keyboard as read */
      create_console(ENV_COUT, _W_); 		/* create display as write */

      switch (fork()) {
      case -1:
        message("can't fork console\n");
        unlink(ENV_COIN);
        unlink(ENV_COUT);
        break;

      case 0:
        sprintf(ppid, "%d", getppid());

        if (getenv("DISPLAY"))
          execlp("kterm","kterm","-geometry","80x34+0+0","-e","tco",ppid,ENV_COIN,ENV_COUT,NULL);

        else if (getenv("WINDOW_ME"))
          execlp("/bin/shelltool","shelltool","-Wp","0","0","tco",ppid,ENV_COIN,ENV_COUT,NULL);

        else if (getenv("WINDOW"))
          execlp("screen","screen","tco",ppid,ENV_COIN,ENV_COUT,NULL);

        else {
	  sleep(2);
          message("\nautomatic startup for \"tco\" failed\n");
          message("invoke \"tco %s %s %s\" manually\n",ppid,ENV_COIN,ENV_COUT);
          message("waiting...\n");
          exit(1);
        }

        break;

      default:
        coin_fd = open_console(ENV_COIN, _R_); 	/* open keyboard as read */
        cout_fd = open_console(ENV_COUT, _W_); 	/* open display as write */
        break;
      }
    }
#endif

    dasd_fd = open_dasd(ENV_DASD);		/* open dasd as read/write */

#ifdef SSUMOVER
    ssu_fd = open_ssu(ENV_SSU);			/* open ssu as read/write */
#endif

#ifdef GDB
    gdbrepl_fp = open_file(ENV_GDBREPL, "w");	/* open GDB-reply_file as write */
#endif

    history_fp = open_file(ENV_HISTORY, "w");	/* open history_file as write */
    displog_fp = open_file(ENV_DISPLOG, "w");	/* open displaylog_file as write */
    rc_fp      = open_rc(ENV_INITRC);           /* open rc_file as read */

    if (command_fp != stdin)
        batchmode = 1;

    if (verbose) {
      message("TaChyon/KAI simulator Version t%s\n", version());
      message(" pe_num=%u", PE_NUM);
      message(" mem_size=%u", memsize);
#ifdef PHSA_SIZE
      message(" phsa_size=%u", PHSA_SIZE);
#endif
      message("\n");
#ifdef PHSA_PROTECT
      message(" phsa_protect");
#endif
#ifdef MANUAL_MAP
      message(" manual_map");
#endif
#ifdef MANUAL_INTR
      message(" manual_intr");
#endif
#ifdef MCR_AREA
      message(" mcr_area");
#endif
#ifdef FXT_INTR
      message(" fxt_intr");
#endif
#ifdef IVT_INTR
      message(" ivt_intr");
#endif
#ifdef WDT_INTR
      message(" wdt_intr");
#endif
      message("\n");
#ifdef VCP
      message(" vcp");
#endif
#ifdef MOVER
      message(" mover");
#endif
#ifdef BARRIER
      message(" barrier");
#endif
#ifdef SSUMOVER
      message(" ssumover");
#endif
#ifdef GSIGP
      message(" gsigp");
#endif
#ifdef FSBA
      message(" fsba");
#endif
#ifdef FSBA_NUM
      message(" fsba_num=%u", FSBA_NUM);
#endif
#ifdef FSBA_REAL_FSIR
      message(" fsba_real_fsir");
#endif
#ifdef FST
      message(" fst");
#endif
#ifdef CONSOLE
      message(" console");
#endif
#ifdef DASD
      message(" dasd");
#endif
#ifdef DAPF
      message(" dapf");
#endif
#ifdef GDB
      message(" gdb");
#endif
#ifdef DEBUG
      message(" debug");
#endif
      message("\n");
#ifdef SCREEN_PATH
      message(" screen_path=\"%s\"", SCREEN_PATH);
#endif
#ifdef VTEM_PATH
      message(" vtem_path=\"%s\"", VTEM_PATH);
#endif
#ifdef HELP_PATH
      message(" help_path=\"%s\"", HELP_PATH);
#endif
      message("\n");
    }

    init_all_facility();

    setup_tty();

    if (*ENV_ALLFAC)
        read_all(ENV_ALLFAC);	/* read all facility */

    if (*ENV_MODULE) {
        for (t_pe = 0; t_pe < PE_NUM; t_pe ++) {
            read_module(t_pe, 'r', 0, ENV_MODULE, 2, 0, 'n');	/* read load_module */
	}
    }

    if (rc_fp) {
        command('f', rc_fp, NULL, 1);
        fclose(rc_fp);
    }

    command('f', command_fp, NULL, 1);
    if (command_fp != stdin) fclose(command_fp);

    if (history_fp) fclose(history_fp);
    if (displog_fp) fclose(displog_fp);
    if (gdbrepl_fp) fclose(gdbrepl_fp);

#ifdef CONSOLE
    if (!discons) {
      if (coin_fd) close(coin_fd);
      if (cout_fd) close(cout_fd);
      unlink(ENV_COIN);
      unlink(ENV_COUT);
    }
#endif

    if (dasd_fd) close(dasd_fd);

#ifdef SSUMOVER
    if (ssu_fd) close(ssu_fd);
#endif

    wait((union wait *)0);

    restore_tty(); /* restore screen */

    exit(0);
}

onintr_startup()
{
    unlink(ENV_COIN);
    unlink(ENV_COUT);
    exit(0);
}

