static char SccsId[] = "@(#)mv.c	1.25    12/16/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* mv.c    89/10/1 */

#ifdef MOVER

#include "tim.h"

sim_mv(t_pe)
    unsigned t_pe;
{

#define THEDR   (pe[T_PE].mv_hedr.hedr)
#define DSTPE   (pe[T_PE].mv_hedr.hedr.dstnpa)

    int    	sqid, dqid;
    unsigned	i, addr, len, d[2];

    /* 5 nano -> 10 nano */
    if (++pe[T_PE].rqt_5nano & 1) {

/******/
if (pe[T_PE].mcr[MPSTW].mpstw.mpst == 2 && (pe[T_PE].rqt_5nano & 510) == 256)
  pe[T_PE].mv_pa[MVPA_MPAA]++;
/******/

/**********************
*  update RQTOT       *
**********************/
      if (pe[T_PE].mv_rcv_status == STATUS_CDOWN) {
        if (pe[T_PE].rqt_5nano >= 819200) {
          pe[T_PE].rqt_5nano = 0;
          if (pe[T_PE].mcr[RTOTW].rtotw.rtot == 0)
            pe[T_PE].timeout_req = 1;
          pe[T_PE].mcr[RTOTW].rtotw.rtot--;
        }
      }
      else
        pe[T_PE].rqt_5nano &= 511; /* for 20nano & 2560nano */

/**********************
*  transmit PACKET    *
**********************/
      /* if header is available */
      if (pe[T_PE].mv_hedr.av) {

        /* if destination_PE exists and running */
        if (DSTPE < PE_NUM && pe[DSTPE].ip_status != STATUS_HALT) {

          /* if STOP or (STOPWAIT and stop is accepted) or (RUN and valid RBA not found) */
          if (pe[DSTPE].mcr[MVST].mvst.recvst == 0
           ||(pe[DSTPE].mcr[MVST].mvst.recvst == 1
           && pe[DSTPE].mv_rcv_stoprq == 2)
           ||(pe[DSTPE].mcr[MVST].mvst.recvst == 3
           &&!pe[DSTPE].mcr[RBAR0].rbar0.rb0vl
           &&!pe[DSTPE].mcr[RBAR1].rbar1.rb1vl)) {

/******/
if (pe[T_PE].mcr[MPSTW].mpstw.mpst == 2 && (pe[T_PE].rqt_5nano & 510) == 256) 
  pe[T_PE].mv_pa[MVPA_TNTB]++;
/******/

            if (pe[DSTPE].mv_rcv_status == STATUS_AVAIL) {
              pe[DSTPE].mcr[RTOTW].ful = pe[DSTPE].mcr[RTOPW].ful;
              pe[DSTPE].mv_rcv_status = STATUS_CDOWN;
            }
          }

          /* if !STOP and (!STOPWAIT or stop is not accepted) and (!RUN or valid RBA found) */
          else {
            pe[DSTPE].mv_rcv_status = STATUS_AVAIL;
            if     (!pe[DSTPE].mv_rbsel && !pe[DSTPE].mcr[RBAR0].rbar0.rb0vl)
              pe[DSTPE].mv_rbsel = 1;
            else if (pe[DSTPE].mv_rbsel && !pe[DSTPE].mcr[RBAR1].rbar1.rb1vl)
              pe[DSTPE].mv_rbsel = 0;

            /* if destination_PE is available */
            if (!*(unsigned *)&pe[DSTPE].mv_mrprmi
             && (pe[DSTPE].mv_rcv_srcpe == -1 || pe[DSTPE].mv_rcv_srcpe == t_pe)) {
                pe[DSTPE].mv_rcv_srcpe = t_pe;
                sqid = THEDR.srcqid1;
                dqid = THEDR.dstpid;
  
/******/
if (pe[T_PE].mcr[MPSTW].mpstw.mpst == 2 && (pe[T_PE].rqt_5nano & 510) == 256)
  pe[T_PE].mv_pa[MVPA_TINP]++;
/******/

              /* if header is not transmitted yet */
              if (pe[T_PE].mv_hedr.hcount != sizeof (struct hedr_form)) {
mv_hedr_hcount_loop1:

                /******** get header ********/
                if (pe[T_PE].mv_hedr.hcount <= 16)
                  *d = *pe[T_PE].mv_hedr.ptr;

                if (pe[T_PE].mv_hedr.hcount >= 20
                 && sys_mop_access(t_pe, (sqid&0xc)==4, 's',
				   sqid&1, 0,
                                   pe[T_PE].mv_hqo+get_rptr(t_pe, sqid)*(sizeof (struct hedr_form))
                                  +pe[T_PE].mv_hedr.hcount,
                                   4, _R_, d) != RW_SUCCESS) {
                  pe[T_PE].work_sndmri.phav = 1;
	          mv_src_interruption(t_pe, sqid, DSTPE);
                  incr_rptr(t_pe, sqid);
		  mv_dst_interruption(DSTPE);
	        }

                /******** put header ********/
                else if (sys_mop_access(DSTPE, 0, 'd',
                         0, 0,
                        (pe[DSTPE].mv_rbsel
                       ? pe[DSTPE].mcr[RBAR1].ful & ~1
                       : pe[DSTPE].mcr[RBAR0].ful & ~1)
                        +pe[T_PE].mv_hedr.hcount,
                         4, _W_, d) != RW_SUCCESS) {
                  incr_rptr(t_pe, sqid);
                  mv_dst_interruption(DSTPE);
                }

                /******** 1 word (header) is copied completely ********/
                else {
                  if (pe[T_PE].mv_hedr.hcount == 4 && THEDR.srcdam == 3)
                    *pe[T_PE].mv_hedr.ptr++ = sizeof (struct hedr_form) / 4;
                  else if (pe[T_PE].mv_hedr.hcount == 28 && THEDR.rbbsf)
                    *pe[T_PE].mv_hedr.ptr++ = pe[DSTPE].mv_rbsel
                       ? (pe[DSTPE].mcr[RBAR1].ful & ~1) + sizeof (struct hedr_form)
                       : (pe[DSTPE].mcr[RBAR0].ful & ~1) + sizeof (struct hedr_form);
                  else
	            *pe[T_PE].mv_hedr.ptr++ = *d;
                  pe[T_PE].mv_hedr.hcount += 4;
                  if (fast_mv) {
                    if (pe[T_PE].mv_hedr.hcount != sizeof (struct hedr_form))
                      goto mv_hedr_hcount_loop1;
                  }
                }
              }

              /* if header is transmitted and body is not transmitted yet */
              else if (pe[T_PE].mv_hedr.bcount != (THEDR.elnum & 0x007fffff)) {

                /* normal mode */
                if (THEDR.srcdam != 3) {

                  /* wait for 10nano, if transmitting by 8bytes */
                  if (!(THEDR.type && (pe[T_PE].rqt_5nano & 2))) {
                    len = THEDR.type ? 8 : 4;
mv_hedr_bcountn_loop1:

                    /******** get body ********/
                    if (((THEDR.srcdam <= 1)
                      &&  sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                         sqid<=5?sqid&1:THEDR.svspid, THEDR.srcvas,
                                         THEDR.srcbad,
                                         len, _R_, d) != RW_SUCCESS)
                     || ((THEDR.srcdam == 2)
                      && (sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                         sqid<=5?sqid&1:THEDR.svspid, THEDR.srcvas,
                                         THEDR.srcbad,
                                         4, _R_, &addr) != RW_SUCCESS
                       || sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                         sqid<=5?sqid&1:THEDR.svspid, THEDR.srcvas,
                                         addr,
                                         len, _R_, d) != RW_SUCCESS))) {
                      pe[T_PE].work_sndmri.phav = 1;
	              mv_src_interruption(t_pe, sqid, DSTPE);
                      incr_rptr(t_pe, sqid);
                      pe[DSTPE].work_mrprmi.rbhv = 1;
	              mv_dst_interruption(DSTPE);
                    }

                    /******** put body ********/
                    else if (((THEDR.dstdam <= 1)
                      &&  sys_mop_access(DSTPE, THEDR.dstvaf, 'd',
                                         dqid, THEDR.dstvas, 
                                         THEDR.dstbad,
                                         len, _W_, d) != RW_SUCCESS)
                     || ((THEDR.dstdam == 2)
                      && (sys_mop_access(DSTPE, THEDR.dstvaf, 'd',
                                         dqid, THEDR.dstvas,
                                         THEDR.dstbad,
                                         4, _R_, &addr) != RW_SUCCESS
                       || sys_mop_access(DSTPE, THEDR.dstvaf, 'd',
                                         dqid, THEDR.dstvas,
                                         addr,
                                         len, _W_, d) != RW_SUCCESS))) {
                      incr_rptr(t_pe, sqid);
                      pe[DSTPE].work_mrprmi.rbhv = 1;
                      mv_dst_interruption(DSTPE);
                    }

                    /******** 1 element (body) is copied completely ********/
                    else {
                      pe[T_PE].mv_hedr.bcount++;
                      THEDR.srcbad +=
                        THEDR.srcdam == 0
                      ? THEDR.srcad1
                      : THEDR.srcdam == 1
                        ? ((pe[T_PE].mv_hedr.bcount
                            %(THEDR.srceln&0x001fffff?THEDR.srceln&0x001fffff:1))
                          ? THEDR.srcad1
                          : THEDR.srcad2)
                        : 4;
                      THEDR.dstbad +=
                        THEDR.dstdam == 0
                      ? THEDR.dstad1
                      : THEDR.dstdam == 1 
                        ? ((pe[T_PE].mv_hedr.bcount
                            %(THEDR.dsteln&0x001fffff?THEDR.dsteln&0x001fffff:1))
                          ? THEDR.dstad1
                          : THEDR.dstad2)
                        : 4;
                      if (fast_mv) {
                        if (pe[T_PE].mv_hedr.bcount != (THEDR.elnum & 0x007fffff))
                          goto mv_hedr_bcountn_loop1;
                      }
                    }
                  }
                }

                /* request mode */
                else {
 
                  /* initialize request mode */
                  if (pe[T_PE].mv_hedr.bcount == 0) {

                    /* transmission in progress */
                    if (sys_mop_access(DSTPE, 0, 'd',
                                       0, 0,
                                       pe[DSTPE].mcr[HQALAW].ful+get_hqofs(DSTPE, dqid),
                                       8, _R_, d) != RW_SUCCESS) {
                      incr_rptr(t_pe, sqid); /* must be sqid */
                      pe[DSTPE].work_mrprmi.rbhv = 1;
                      mv_dst_interruption(DSTPE);
                    }
  
                    /* check eqv */
                    else if (!get_eqv(DSTPE, dqid))
                      THEDR.elnum = 0;
  
                    /* check ovf */
                    else if (get_ovf(DSTPE, dqid) || incr_wptr(DSTPE, dqid, 1)) {
                      THEDR.dstbad = (pe[DSTPE].mv_rbsel
                                    ? pe[DSTPE].mcr[RBAR1].ful & ~1
                                    : pe[DSTPE].mcr[RBAR0].ful & ~1)+sizeof (struct hedr_form);
                      pe[DSTPE].work_mrprmi.rqo = 1;
                    }

                    else
                      THEDR.dstbad = (d[0] & 0xffff8000)+get_wptr(DSTPE, dqid)*(sizeof (struct hedr_form));
                  }
  
                  if (!*(unsigned *)&pe[T_PE].mv_mrprmi && THEDR.elnum) {
mv_hedr_bcountr_loop1:
  
                    /******** get body ********/
                    if (sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                       sqid&1, THEDR.srcvas,
                                       THEDR.srcbad,
                                       4, _R_, d) != RW_SUCCESS) {
                      pe[T_PE].work_sndmri.phav = 1;
                      mv_src_interruption(t_pe, sqid, DSTPE);
                      incr_rptr(t_pe, sqid);
                      pe[DSTPE].work_mrprmi.rbhv = 1;
                      mv_dst_interruption(DSTPE);
                    }

                    /******** put body ********/
                    else if (sys_mop_access(DSTPE, 0, 'd',
                                            0, 0,
                                            THEDR.dstbad,
                                            4, _W_, d) != RW_SUCCESS) {
                      incr_rptr(t_pe, sqid);
                      pe[DSTPE].work_mrprmi.rbhv = 1;
                      mv_dst_interruption(DSTPE);
                    }

                    /******** 1 element (body) is copied completely ********/
                    else {
                      pe[T_PE].mv_hedr.bcount++;
                      THEDR.srcbad += 4;
                      THEDR.dstbad += 4;
                      if (fast_mv) {
                        if (pe[T_PE].mv_hedr.bcount != (THEDR.elnum & 0x007fffff))
                          goto mv_hedr_bcountr_loop1;
                      }
                    }
                  }
                }
              }
  
              /* if body is transmitted */
              else {
	        unsigned srcerr = 0, dsterr = 0;
	        unsigned srccti = 0, dstcti = 0;
	        unsigned srcpci = 0, dstpci = 0;

                if (pe[DSTPE].work_mrprmi.rqo == 1)
                  pe[DSTPE].work_mrprmi.rbrrbv = 1;

                /******** packet source interruption ********/

                if (THEDR.srccen) {
                  if (sys_mop_access(t_pe, sqid<=5, 's',
                                     sqid&1, THEDR.srcvas,
                                     THEDR.srccta&0xfffffffc,
                                     4, _R_, d) != RW_SUCCESS) {
                    pe[T_PE].work_sndmri.phav = 1;
                    mv_src_interruption(t_pe, sqid, DSTPE);
                    pe[DSTPE].work_mrprmi.rbhv = 1;
                    mv_dst_interruption(DSTPE);
                    srcerr = 1;
                  }
                  else {
                    (*d)--;
                    if (sys_mop_access(t_pe, sqid<=5, 's',
                                       sqid&1, THEDR.srcvas,
                                       THEDR.srccta&0xfffffffc,
                                       4, _W_, d) != RW_SUCCESS) {
                      pe[T_PE].work_sndmri.phav = 1;
                      mv_src_interruption(t_pe, sqid, DSTPE);
                      pe[DSTPE].work_mrprmi.rbhv = 1;
                      mv_dst_interruption(DSTPE);
                      srcerr = 1;
                    }
                    else if (*d == 0 && sqid >= 8 && THEDR.srccti) {
                      srccti = 1;
                    }
                  }
                }
                if (THEDR.srcpci && sqid >= 8) {
                  srcpci = 1;
                }
                if (srccti || srcpci) {
                  if (srccti)
                    pe[T_PE].work_sndmri.sndcti = 1;
                  if (srcpci)
                    pe[T_PE].work_sndmri.sndpci = 1;
                  pe[T_PE].work_sndmri.phav = 1;
                  mv_src_interruption(t_pe, sqid, -1);
                }
                incr_rptr(t_pe, sqid);

                /******** packet destination interruption ********/

                if (!srcerr) {
                  if (pe[DSTPE].work_mrprmi.rqo) {
                    pe[DSTPE].work_mrprmi.rbhv = 1;
                    mv_dst_interruption(DSTPE);
                  }
                  else {
                    if (THEDR.dstcen) {
                      if (sys_mop_access(DSTPE, sqid<=5, 'd',
                                         dqid, THEDR.dstvas,
                                         THEDR.dstcta&0xfffffffc,
                                         4, _R_, d) != RW_SUCCESS) {
                        pe[DSTPE].work_mrprmi.rbhv = 1;
                        mv_dst_interruption(DSTPE);
                        dsterr = 1;
                      }
                      else {
                        (*d)--;
                        if (sys_mop_access(DSTPE, sqid<=5, 'd',
                                           dqid, THEDR.dstvas,
                                           THEDR.dstcta&0xfffffffc,
                                           4, _W_, d) != RW_SUCCESS) {
                          pe[DSTPE].work_mrprmi.rbhv = 1;
                          mv_dst_interruption(DSTPE);
                          dsterr = 1;
                        }
                        else if (*d == 0 && sqid >= 8 && THEDR.dstcti) {
                          dstcti = 1;
                        }
                      }
                    }
                    if (THEDR.dstpci && sqid >= 8) {
                      dstpci = 1;
                    }
                    if (dstcti || dstpci) {
                      if (dstcti)
                        pe[DSTPE].work_mrprmi.rcvcti = 1;
                      if (dstpci)
                        pe[DSTPE].work_mrprmi.rcvpci = 1;
                      pe[DSTPE].work_mrprmi.rbhv = 1;
                      mv_dst_interruption(DSTPE);
                    }
                    if (!dsterr && THEDR.srcdam == 3 && THEDR.elnum) {
                      incr_wptr(DSTPE, dqid, 0);
                    }
                    pe[DSTPE].mv_rcv_srcpe = -1;
                  }
                }
              }
            }

            /* destination_PE is not available */
            else { /* mover is blocked */

/******/
if (pe[T_PE].mcr[MPSTW].mpstw.mpst == 2 && (pe[T_PE].rqt_5nano & 510) == 256)
  pe[T_PE].mv_pa[MVPA_TNTB]++;
/******/

            }

            /* accept stop req */
            if (pe[DSTPE].mv_rcv_srcpe == -1) {
              if (pe[DSTPE].mcr[MVST].mvst.recvst == 1 && pe[DSTPE].mv_rcv_stoprq == 1) {
                if (*(unsigned*)&pe[DSTPE].mv_mrprmi)
                  pe[DSTPE].mv_mrprmi.rcvsrp = 1;
                else
                  pe[DSTPE].mcr[MRPRMI].mrprmi.rcvsrp = 1;
                pe[DSTPE].mv_rcv_stoprq = 2;
              }
            }
          }
        }

        /* transmit to the skies */
        else { /* mover is busy */

          /* if !STOP and (!STOPWAIT or stop is not accepted) and (!RUN or valid RBA found) */
          if (1) {

            /* if destination_PE is available */
            if (1) {
                sqid = THEDR.srcqid1;
  
/******/
if (pe[T_PE].mcr[MPSTW].mpstw.mpst == 2 && (pe[T_PE].rqt_5nano & 510) == 256)
  pe[T_PE].mv_pa[MVPA_TINP]++;
/******/

              /* if header is not transmitted yet */
              if (pe[T_PE].mv_hedr.hcount != sizeof (struct hedr_form)) {
mv_hedr_hcount_loop2:

                /******** get header ********/
                if (pe[T_PE].mv_hedr.hcount <= 16)
                  *d = *pe[T_PE].mv_hedr.ptr;

                if (pe[T_PE].mv_hedr.hcount >= 20
                 && sys_mop_access(t_pe, (sqid&0xc)==4, 's',
                                   sqid&1, 0,
                                   pe[T_PE].mv_hqo+get_rptr(t_pe, sqid)*(sizeof (struct hedr_form))
                                  +pe[T_PE].mv_hedr.hcount,
                                   4, _R_, d) != RW_SUCCESS) {
                  pe[T_PE].work_sndmri.phav = 1;
	          mv_src_interruption(t_pe, sqid, -1);
                  incr_rptr(t_pe, sqid);
	        }

                /******** put header ********/
                /* do nothing */

                /******** 1 word (header) is copied completely ********/
                else {
                  if (pe[T_PE].mv_hedr.hcount == 4 && THEDR.srcdam == 3)
                    *pe[T_PE].mv_hedr.ptr++ = sizeof (struct hedr_form) / 4;
                  else
                    *pe[T_PE].mv_hedr.ptr++ = *d;
                  pe[T_PE].mv_hedr.hcount += 4;
                  if (fast_mv) {
                    if (pe[T_PE].mv_hedr.hcount != sizeof (struct hedr_form))
                      goto mv_hedr_hcount_loop2;
                  }
                }
              }

              /* if header is transmitted and body is not transmitted yet */
              else if (pe[T_PE].mv_hedr.bcount != (THEDR.elnum & 0x007fffff)) {

                /* normal mode */
                if (THEDR.srcdam != 3) {

                  /* wait for 10nano, if transmitting by 8bytes */
                  if (!(THEDR.type && (pe[T_PE].rqt_5nano & 2))) {
                    len = THEDR.type ? 8 : 4;
mv_hedr_bcountn_loop2:

                    /******** get body ********/
                    if (((THEDR.srcdam <= 1)
                      &&  sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                         sqid<=5?sqid&1:THEDR.svspid, THEDR.srcvas,
                                         THEDR.srcbad,
                                         len, _R_, d) != RW_SUCCESS)
                     || ((THEDR.srcdam == 2)
                      && (sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                         sqid<=5?sqid&1:THEDR.svspid, THEDR.srcvas,
                                         THEDR.srcbad,
                                         4, _R_, &addr) != RW_SUCCESS
                       || sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                         sqid<=5?sqid&1:THEDR.svspid, THEDR.srcvas,
                                         addr,
                                         len, _R_, d) != RW_SUCCESS))) {
                      pe[T_PE].work_sndmri.phav = 1;
	              mv_src_interruption(t_pe, sqid, -1);
                      incr_rptr(t_pe, sqid);
                    }

                    /******** put body ********/
                    /* do nothing */

                    /******** 1 element (body) is copied completely ********/
                    else {
                      pe[T_PE].mv_hedr.bcount++;
                      THEDR.srcbad +=
                        THEDR.srcdam == 0
                      ? THEDR.srcad1
                      : THEDR.srcdam == 1
                        ? ((pe[T_PE].mv_hedr.bcount
                            %(THEDR.srceln&0x001fffff?THEDR.srceln&0x001fffff:1))
                          ? THEDR.srcad1
                          : THEDR.srcad2)
                        : 4;
                      if (fast_mv) {
                        if (pe[T_PE].mv_hedr.bcount != (THEDR.elnum & 0x007fffff))
                          goto mv_hedr_bcountn_loop2;
                      }
                    }
                  }
                }

                /* request mode */
                else {
 
                  /* initialize request mode */
                  /* do nothing */
  
                  if (1) {
mv_hedr_bcountr_loop2:
  
                    /******** get body ********/
                    if (sys_mop_access(t_pe, THEDR.srcvaf, 's',
                                       sqid&1, THEDR.srcvas,
                                       THEDR.srcbad,
                                       4, _R_, d) != RW_SUCCESS) {
                      pe[T_PE].work_sndmri.phav = 1;
                      mv_src_interruption(t_pe, sqid, -1);
                      incr_rptr(t_pe, sqid);
                    }

                    /******** put body ********/
                    /* do nothing */

                    /******** 1 element (body) is copied completely ********/
                    else {
                      pe[T_PE].mv_hedr.bcount++;
                      THEDR.srcbad += 4;
                      if (fast_mv) {
                        if (pe[T_PE].mv_hedr.bcount != (THEDR.elnum & 0x007fffff))
                          goto mv_hedr_bcountr_loop2;
                      }
                    }
                  }
                }
              }
  
              /* if body is transmitted */
              else {
	        unsigned srcerr = 0;
	        unsigned srccti = 0;
	        unsigned srcpci = 0;

                /******** packet source interruption ********/

                if (THEDR.srccen) {
                  if (sys_mop_access(t_pe, sqid<=5, 's',
                                     sqid&1, THEDR.srcvas,
                                     THEDR.srccta&0xfffffffc,
                                     4, _R_, d) != RW_SUCCESS) {
                    pe[T_PE].work_sndmri.phav = 1;
                    mv_src_interruption(t_pe, sqid, -1);
                    srcerr = 1;
                  }
                  else {
                    (*d)--;
                    if (sys_mop_access(t_pe, sqid<=5, 's',
                                       sqid&1, THEDR.srcvas,
                                       THEDR.srccta&0xfffffffc,
                                       4, _W_, d) != RW_SUCCESS) {
                      pe[T_PE].work_sndmri.phav = 1;
                      mv_src_interruption(t_pe, sqid, -1);
                      srcerr = 1;
                    }
                    else if (*d == 0 && sqid >= 8 && THEDR.srccti) {
                      srccti = 1;
                    }
                  }
                }
                if (THEDR.srcpci && sqid >= 8) {
                  srcpci = 1;
                }
                if (srccti || srcpci) {
                  if (srccti)
                    pe[T_PE].work_sndmri.sndcti = 1;
                  if (srcpci)
                    pe[T_PE].work_sndmri.sndpci = 1;
                  pe[T_PE].work_sndmri.phav = 1;
                  mv_src_interruption(t_pe, sqid, -1);
                }
                incr_rptr(t_pe, sqid);

                /******** packet destination interruption ********/
                /* do nothing */
              }
            }
          }
        }
      }

      /* nothing to transmit */
      else { /* mover is idle */
          /* do nothing */
      }

    } /* 5 nano -> 10 nano */

/**********************
*  accept stop req    *
**********************/
    if (pe[T_PE].mv_rcv_srcpe == -1) {
      if (pe[T_PE].mcr[MVST].mvst.recvst == 1 && pe[T_PE].mv_rcv_stoprq == 1) {
        if (*(unsigned*)&pe[T_PE].mv_mrprmi) 
          pe[T_PE].mv_mrprmi.rcvsrp = 1;
        else 
          pe[T_PE].mcr[MRPRMI].mrprmi.rcvsrp = 1;
        pe[T_PE].mv_rcv_stoprq = 2;
      }
    }

/***********************
*  check next transfer *
***********************/
    /* if transmission is available */
    if (!pe[T_PE].mv_hedr.av) {

      /* accept stop req */
      if (pe[T_PE].mcr[MVST].mvst.sendst == 1 && pe[T_PE].mv_snd_stoprq == 1) {
        pe[T_PE].mcr[MRPRMI].mrprmi.sndsrp = 1;
        pe[T_PE].mv_snd_stoprq = 2;
      }

      /* pick up header */
      else if (pe[T_PE].mv_rcv_status == STATUS_AVAIL
           &&  pe[T_PE].mcr[MVST].mvst.sendst == 3
           && !pe[T_PE].mcr[MRPRMI].mrprmi.sndmrp) {
  
        pe[T_PE].mv_qid = -1;
  
        /* check supervisor high priority queue */
        if      (get_sdv(t_pe, 8) && get_rptr(t_pe, 8) != get_wptr(t_pe, 8))
          pe[T_PE].mv_qid = 8;
  
        /* check supervisor low priority queue */
        else if (get_sdv(t_pe,12) && get_rptr(t_pe,12) != get_wptr(t_pe,12))
          pe[T_PE].mv_qid = 12;
  
        /* supervisor queue is updated */
        if (pe[T_PE].mv_qid >= 0) {
  
          /* get queue address */
          if (sys_mop_access(t_pe, 0, 's',
                             0, 0,
                             pe[T_PE].mcr[HQALAW].ful+get_hqofs(t_pe, pe[T_PE].mv_qid),
                             8, _R_, d) != RW_SUCCESS) {
            pe[T_PE].work_sndmri.psdsup = 1;
            mv_src_interruption(t_pe, pe[T_PE].mv_qid, -1);
          }
  
          /* get header */
          else {
            pe[T_PE].mv_hqo = d[0] & 0xffff8000;
            addr = pe[T_PE].mv_hqo + get_rptr(t_pe, pe[T_PE].mv_qid) * (sizeof (struct hedr_form));
  
            if (sys_mop_access(t_pe,0,'s',0,0,addr,   4,_R_,(unsigned*)&THEDR  ) != RW_SUCCESS
             || sys_mop_access(t_pe,0,'s',0,0,addr+4, 4,_R_,(unsigned*)&THEDR+1) != RW_SUCCESS
             || sys_mop_access(t_pe,0,'s',0,0,addr+16,4,_R_,(unsigned*)&THEDR+4) != RW_SUCCESS
             || get_real_netpa(t_pe, THEDR.dstnpf, THEDR.dstnpa, THEDR.svspid,
                               (unsigned*)&THEDR, (unsigned*)&THEDR+4) != RW_SUCCESS) {
              pe[T_PE].work_sndmri.phav = 1;
              pe[T_PE].work_sndmri.psdsup = 1;
              mv_src_interruption(t_pe, pe[T_PE].mv_qid, -1);
	      incr_rptr(t_pe, pe[T_PE].mv_qid);
            }
  
            else if (THEDR.srcdam == 3 || THEDR.dstdam == 3) {
              pe[T_PE].work_sndmri.sndprx = 1;
              pe[T_PE].work_sndmri.phav = 1;
              pe[T_PE].work_sndmri.psdsup = 1;
              mv_src_interruption(t_pe, pe[T_PE].mv_qid, -1);
              incr_rptr(t_pe, pe[T_PE].mv_qid);
            }
  
            else if (THEDR.rbbsf && (THEDR.dstdam != 0 || THEDR.dstvaf != 0)) {
              pe[T_PE].work_sndmri.sndprx = 1;
              pe[T_PE].work_sndmri.phav = 1;
              pe[T_PE].work_sndmri.psdsup = 1;
              mv_src_interruption(t_pe, pe[T_PE].mv_qid, -1);
              incr_rptr(t_pe, pe[T_PE].mv_qid);
            }
  
            else {
              THEDR.srcecc  = get_netpa_ecc(t_pe);
              THEDR.srcnpa  = t_pe;
              THEDR.srcqid1 = pe[T_PE].mv_qid;
              THEDR.srcqid2 = pe[T_PE].mv_qid;
              THEDR.srcqid3 = pe[T_PE].mv_qid;
              THEDR.srcqid4 = pe[T_PE].mv_qid;
              THEDR.dmy4a   = 0;
              THEDR.dmy4b   = 0;
              THEDR.dmy4c   = 0;
              THEDR.dmy4d   = 0;
              pe[T_PE].mv_hedr.av     = 1;
              pe[T_PE].mv_hedr.hcount = 0;
              pe[T_PE].mv_hedr.bcount = 0;
              pe[T_PE].mv_hedr.ptr    = (unsigned*)&THEDR;
            }
          }
        }
  
        /* check user queue */
        else {
          if ((get_sdv(t_pe, 0) && get_rptr(t_pe, 0) != get_wptr(t_pe, 0))
            ||(get_sdv(t_pe, 4) && get_rptr(t_pe, 4) != get_wptr(t_pe, 4))
            ||(get_sdv(t_pe, 1) && get_rptr(t_pe, 1) != get_wptr(t_pe, 1))
            ||(get_sdv(t_pe, 5) && get_rptr(t_pe, 5) != get_wptr(t_pe, 5))) {
  
            /* rotate user high priority */
            switch (pe[T_PE].mv_hround) {
            case 0:
              if      (check_hqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 4;
              else if (check_hqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 1;
              else if (check_hqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 5;
              else if (check_hqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 0;
	      break;
   
            case 4:
              if      (check_hqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 1;
              else if (check_hqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 5;
              else if (check_hqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 0;
              else if (check_hqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 4;
              break;
  
            case 1:
              if      (check_hqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 5;
              else if (check_hqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 0;
              else if (check_hqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 4;
              else if (check_hqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 1;
              break;
  
            case 5:
              if      (check_hqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 0;
              else if (check_hqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 4;
              else if (check_hqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 1;
              else if (check_hqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_hround = 5;
              break;
  
            default:
              break;
            }
  
            /* rotate user low priority */
            if (pe[T_PE].mv_qid < 0) {
              switch (pe[T_PE].mv_lround) {
              case 0:
                if      (check_lqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 4;
                else if (check_lqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 1;
                else if (check_lqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 5;
                else if (check_lqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 0;
	        break;
   
              case 4:
                if      (check_lqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 1;
                else if (check_lqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 5;
                else if (check_lqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 0;
                else if (check_lqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 4;
                break;
  
              case 1:
                if      (check_lqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 5;
                else if (check_lqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 0;
                else if (check_lqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 4;
                else if (check_lqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 1;
                break;
    
              case 5:
                if      (check_lqueue(t_pe, 0)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 0;
                else if (check_lqueue(t_pe, 4)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 4;
                else if (check_lqueue(t_pe, 1)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 1;
                else if (check_lqueue(t_pe, 5)) pe[T_PE].mv_qid = pe[T_PE].mv_lround = 5;
                break;
    
              default:
                break;
              }
            }
          }
  
          /* user queue is updated */
          if (pe[T_PE].mv_qid >= 0) {
  
            /* get queue address */
            if (sys_mop_access(t_pe, 0, 's',
                               0, 0,
                               pe[T_PE].mcr[HQALAW].ful+get_hqofs(t_pe, pe[T_PE].mv_qid),
                               8, _R_, d) != RW_SUCCESS) {
              pe[T_PE].work_sndmri.psdsup = 1;
              mv_src_interruption(t_pe, pe[T_PE].mv_qid, -1);
            }
    
            /* get header */
            else {
              pe[T_PE].mv_hqo = d[0] & 0xffff8000;
              addr = pe[T_PE].mv_hqo + get_rptr(t_pe, pe[T_PE].mv_qid) * (sizeof (struct hedr_form));
    
              if (sys_mop_access(t_pe,pe[T_PE].mv_qid&4,'s',pe[T_PE].mv_qid&1,0,addr,   4,_R_,(unsigned*)&THEDR  ) != RW_SUCCESS
               || sys_mop_access(t_pe,pe[T_PE].mv_qid&4,'s',pe[T_PE].mv_qid&1,0,addr+4, 4,_R_,(unsigned*)&THEDR+1) != RW_SUCCESS
               || sys_mop_access(t_pe,pe[T_PE].mv_qid&4,'s',pe[T_PE].mv_qid&1,0,addr+16,4,_R_,(unsigned*)&THEDR+4) != RW_SUCCESS
               || get_real_netpa(t_pe, 1, THEDR.dstnpa, pe[T_PE].mv_qid&1,
                                 (unsigned*)&THEDR, (unsigned*)&THEDR+4) != RW_SUCCESS) {
                pe[T_PE].work_sndmri.phav = 1;
                pe[T_PE].work_sndmri.psdsup = 1;
                mv_src_interruption(t_pe, pe[T_PE].mv_qid, -1);
	        incr_rptr(t_pe, pe[T_PE].mv_qid);
              }
    
              else if (pe[T_PE].mv_qid <= 1 && THEDR.srcdam == 3
                    || THEDR.srcdam != 3 && (THEDR.dstdam == 3
                    || pe[T_PE].mv_qid == 0 && pe[T_PE].mcr[SPIDW].spidw.lltau0 == 0 && THEDR.srcvas == 0
                    || pe[T_PE].mv_qid == 1 && pe[T_PE].mcr[SPIDW].spidw.lltau1 == 0 && THEDR.srcvas == 0
                    || pe[T_PE].mv_qid == 4 && pe[T_PE].mcr[SPIDW].spidw.lltau0 == 0 && THEDR.dstvas == 0
                    || pe[T_PE].mv_qid == 5 && pe[T_PE].mcr[SPIDW].spidw.lltau1 == 0 && THEDR.dstvas == 0)) {
                pe[T_PE].work_sndmri.sndprx = 1;
                pe[T_PE].work_sndmri.phav = 1;
                pe[T_PE].work_sndmri.psdsup = 1;
                mv_src_interruption(t_pe, pe[T_PE].mv_qid, -1);
                incr_rptr(t_pe, pe[T_PE].mv_qid);
              }
    
              else {
                THEDR.srcecc  = get_netpa_ecc(t_pe);
                THEDR.srcnpa  = t_pe;
                THEDR.srcqid1 = pe[T_PE].mv_qid;
                THEDR.srcqid2 = pe[T_PE].mv_qid;
                THEDR.srcqid3 = pe[T_PE].mv_qid;
                THEDR.srcqid4 = pe[T_PE].mv_qid;
                if (THEDR.srcdam == 3)
                  THEDR.dstdam = 3;
                THEDR.rbbsf   = 0;
                THEDR.dmy4a   = 0;
                THEDR.srcpci  = 0;
                THEDR.dstpci  = 0;
                THEDR.srccti  = 0;
                THEDR.dstcti  = 0;
                if (THEDR.srcdam == 3)
                  THEDR.dstcen = 0;
                THEDR.dmy4b   = 0;
                THEDR.dstnpf  = 1;
                THEDR.srcvaf  = 1;
                THEDR.dstvaf  = 1;
                THEDR.dmy4c   = 0;
                THEDR.dmy4d   = 0;
                pe[T_PE].mv_hedr.av     = 1;
                pe[T_PE].mv_hedr.hcount = 0;
                pe[T_PE].mv_hedr.bcount = 0;
                pe[T_PE].mv_hedr.ptr    = (unsigned*)&THEDR;
              }
            }
          }
        }
      }
    }

/**********************
*  scan MCMD          *
**********************/
    if (pe[T_PE].smcr[MCMDW].ful) { /* get command */
      switch (pe[T_PE].smcr[MCMDW].mcmdw.mcmd) {
      case 0: /* Start Transfer */
        if (pe[T_PE].mcr[MVST].mvst.sendst == 0)
          pe[T_PE].mcr[MVST].mvst.sendst = 3;
        break;

      case 1: /* Stop Transfer */
        /* after transmitted, pe[T_PE].mcr[MVST].mvst.sendst = 0; */
        if (pe[T_PE].mcr[MVST].mvst.sendst == 3) {
          pe[T_PE].mcr[MVST].mvst.sendst = 1;
          pe[T_PE].mv_snd_stoprq = 1;
        }
        break;

      case 2: /* Start Receive */
        if (pe[T_PE].mcr[MVST].mvst.recvst == 0)
          pe[T_PE].mcr[MVST].mvst.recvst = 3;
        break;

      case 3: /* Stop Receive */
        /* after received, pe[T_PE].mcr[MVST].mvst.recvst = 0; */
        if (pe[T_PE].mcr[MVST].mvst.recvst == 3) {
          pe[T_PE].mcr[MVST].mvst.recvst = 1;
          pe[T_PE].mv_rcv_stoprq = 1;
        }
        break;
      }

      pe[T_PE].smcr[MCMDW].ful = 0;
    }

/**********************
*  scan PA            *
**********************/
    if (pe[T_PE].smcr[MPSTA].ful) { /* start PA */
      pe[T_PE].mcr[MPSTW].mpstw.mpst = 2;
      pe[T_PE].smcr[MPSTA].ful = 0;
    }
    if (pe[T_PE].smcr[MPSTP].ful) { /* stop PA */
      pe[T_PE].mcr[MPSTW].mpstw.mpst = 0;
      pe[T_PE].smcr[MPSTP].ful = 0;
    }
    if (pe[T_PE].smcr[MPRST].ful) { /* reset PA */
      if (!pe[T_PE].mcr[MPSTW].mpstw.mpst) {
        for (i=0; i<MV_PANUM; i++)
          pe[T_PE].mv_pa[i] = 0;
      }
      pe[T_PE].smcr[MPRST].ful = 0;
    }

/***********************
* update ext_interrupt *
***********************/
    if (*(unsigned*)&pe[T_PE].mv_mrprmi && !pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp) {
      pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp = 1;
      pe[T_PE].mcr[MRPRMI].ful &= 0xf0000000;
      pe[T_PE].mcr[MRPRMI].ful |= (*(unsigned*)&pe[T_PE].mv_mrprmi);
      *(unsigned*)&pe[T_PE].mv_mrprmi = 0;
    }
    if (pe[T_PE].mcr[MRPRMI].ful & 0xf0000000)
      pe[T_PE].ext_interrupt |= MV_INTERRUPT;
}

mv_src_interruption(t_pe, qid, dstpe)
    unsigned t_pe;
    unsigned qid; /* 8:sh 12:sl 0:u0r 4:u0t 1:u1r 5:u1t */
    unsigned dstpe;
    /* pe[T_PE].mcr[MRPRMI].mrprmi.sndmrp must be 0 */
{
    pe[T_PE].mv_hedr.av = 0;

    pe[T_PE].mcr[MRPRMI].mrprmi.sndmrp = 1;
    pe[T_PE].mcr[SNDMRI].ful = *(unsigned*)&pe[T_PE].work_sndmri;
    pe[T_PE].mcr[SMIPHI].ful = ((pe[T_PE].mv_hqo+get_rptr(t_pe, qid)*(sizeof (struct hedr_form))) & 0xffffff80) | qid;

    if (dstpe != -1) {
      if (pe[T_PE].work_sndmri.sndalx || pe[T_PE].work_sndmri.sndtsx
       || pe[T_PE].work_sndmri.sndprx || pe[T_PE].work_sndmri.sndadx)
        pe[dstpe].work_mrprmi.srcexc = 1;
    }

    *(unsigned*)&pe[T_PE].work_sndmri = 0;
}

mv_dst_interruption(t_pe)
    unsigned t_pe;
    /* pe[T_PE].mv_mrprmi must be 0 */
{
    unsigned rbn;

    pe[T_PE].mv_rcv_srcpe = -1;

    if     (!pe[T_PE].mv_rbsel && pe[T_PE].mcr[RBAR0].rbar0.rb0vl) {
      pe[T_PE].mv_rbsel = 1;
      pe[T_PE].mcr[RBAR0].rbar0.rb0vl = 0;
      rbn = 0;
    }
    else if (pe[T_PE].mv_rbsel && pe[T_PE].mcr[RBAR1].rbar1.rb1vl) {
      pe[T_PE].mv_rbsel = 0;
      pe[T_PE].mcr[RBAR1].rbar1.rb1vl = 0;
      rbn = 1;
    }
    else {
      *(unsigned*)&pe[T_PE].work_mrprmi = 0;
      return;
    }

    *(unsigned*)&pe[T_PE].mv_mrprmi = *(unsigned*)&pe[T_PE].work_mrprmi;
    pe[T_PE].mv_mrprmi.rbn = rbn;

    *(unsigned*)&pe[T_PE].work_mrprmi = 0;
}

check_hqueue(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 0:u0r 4:u0t 1:u1r 5:u1t */
{
    switch (qid) {
    case 0:
      return(pe[T_PE].mcr[UHQPRI].uhqpri.hpgu0r && get_sdv(t_pe, 0) && get_rptr(t_pe, 0) != get_wptr(t_pe, 0));

    case 4:
      return(pe[T_PE].mcr[UHQPRI].uhqpri.hpgu0t && get_sdv(t_pe, 4) && get_rptr(t_pe, 4) != get_wptr(t_pe, 4));

    case 1:
      return(pe[T_PE].mcr[UHQPRI].uhqpri.hpgu1r && get_sdv(t_pe, 1) && get_rptr(t_pe, 1) != get_wptr(t_pe, 1));

    case 5:
      return(pe[T_PE].mcr[UHQPRI].uhqpri.hpgu1t && get_sdv(t_pe, 5) && get_rptr(t_pe, 5) != get_wptr(t_pe, 5));

    default:
      return(0);
    }
}

check_lqueue(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 0:u0r 4:u0t 1:u1r 5:u1t */
{
    switch (qid) {
    case 0:
      return(!pe[T_PE].mcr[UHQPRI].uhqpri.hpgu0r && get_sdv(t_pe, 0) && get_rptr(t_pe, 0) != get_wptr(t_pe, 0));

    case 4:
      return(!pe[T_PE].mcr[UHQPRI].uhqpri.hpgu0t && get_sdv(t_pe, 4) && get_rptr(t_pe, 4) != get_wptr(t_pe, 4));

    case 1:
      return(!pe[T_PE].mcr[UHQPRI].uhqpri.hpgu1r && get_sdv(t_pe, 1) && get_rptr(t_pe, 1) != get_wptr(t_pe, 1));

    case 5:
      return(!pe[T_PE].mcr[UHQPRI].uhqpri.hpgu1t && get_sdv(t_pe, 5) && get_rptr(t_pe, 5) != get_wptr(t_pe, 5));

    default:
      return(0);
    }
}

get_rptr(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 8:sh 12:sl 0:u0r 4:u0t 1:u1r 5:u1t */
{
    switch (qid) {
    case 8:
      return(pe[T_PE].mcr[HRSHTW].hrshtw.hqrsht&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.shqs |0xff));

    case 12:
      return(pe[T_PE].mcr[HRSLTW].hrsltw.hqrslt&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.shqs |0xff));

    case 0:
      return(pe[T_PE].mcr[HRU0RW].hru0rw.hqru0r&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u0hqs|0xff));

    case 4:
      return(pe[T_PE].mcr[HRU0TW].hru0tw.hqru0t&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u0hqs|0xff));

    case 1:
      return(pe[T_PE].mcr[HRU1RW].hru1rw.hqru1r&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u1hqs|0xff));

    case 5:
      return(pe[T_PE].mcr[HRU1TW].hru1tw.hqru1t&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u1hqs|0xff));

    default:
      return(0);
    }
}

get_wptr(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 8:sh 12:sl 0:u0r 4:u0t 1:u1r 5:u1t */
{
    switch (qid) {
    case 8:
      return(pe[T_PE].mcr[HWSHTW].hwshtw.hqwsht&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.shqs |0xff));

    case 12:
      return(pe[T_PE].mcr[HWSLTW].hwsltw.hqwslt&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.shqs |0xff));

    case 0:
      return(pe[T_PE].mcr[HWU0RW].hwu0rw.hqwu0r&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u0hqs|0xff));

    case 4:
      return(pe[T_PE].mcr[HWU0TW].hwu0tw.hqwu0t&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u0hqs|0xff));

    case 1:
      return(pe[T_PE].mcr[HWU1RW].hwu1rw.hqwu1r&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u1hqs|0xff));

    case 5:
      return(pe[T_PE].mcr[HWU1TW].hwu1tw.hqwu1t&(0xff<<pe[T_PE].mcr[HQSZ].hqsz.u1hqs|0xff));

    default:
      return(0);
    }
}

get_sdv(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 8:sh 12:sl 0:u0r 4:u0t 1:u1r 5:u1t */
{
    switch (qid) {
    case 8:
      return(pe[T_PE].mcr[HRSHTW].hrshtw.sdvsht);

    case 12:
      return(pe[T_PE].mcr[HRSLTW].hrsltw.sdvslt);

    case 0:
      return(pe[T_PE].mcr[HRU0RW].hru0rw.sdvu0r);

    case 4:
      return(pe[T_PE].mcr[HRU0TW].hru0tw.sdvu0t);

    case 1:
      return(pe[T_PE].mcr[HRU1RW].hru1rw.sdvu1r);

    case 5:
      return(pe[T_PE].mcr[HRU1TW].hru1tw.sdvu1t);

    default:
      return(0);
    }
}

get_hqofs(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 8:sh 12:sl 0:u0r 4:u0t 1:u1r 5:u1t */
{
    switch (qid) {
    case 8:
      return(0x00);

    case 12:
      return(0x08);

    case 0:
      return(0x10);

    case 4:
      return(0x18);

    case 1:
      return(0x20);

    case 5:
      return(0x28);

    default:
      return(0);
    }
}

get_eqv(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 0:u0r 1:u1r */
{
    switch (qid) {
    case 0:
      return(pe[T_PE].mcr[HWU0RW].hwu0rw.eqvu0r);

    case 1:
      return(pe[T_PE].mcr[HWU1RW].hwu1rw.eqvu1r);

    default:
      return(0);
    }
}

get_ovf(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 0:u0r 1:u1r */
{
    switch (qid) {
    case 0:
      return(pe[T_PE].mcr[HWU0RW].hwu0rw.ovfu0r);

    case 1:
      return(pe[T_PE].mcr[HWU1RW].hwu1rw.ovfu1r);

    default:
      return(0);
    }
}

incr_rptr(t_pe, qid)
    unsigned t_pe;
    unsigned qid; /* 8:sh 12:sl 0:u0r 4:u0t 1:u1r 5:u1t */
{
    pe[T_PE].mv_hedr.av = 0;

    switch (qid) {
    case 8:
      pe[T_PE].mcr[HRSHTW].hrshtw.hqrsht++;
      break;

    case 12:
      pe[T_PE].mcr[HRSLTW].hrsltw.hqrslt++;
      break;

    case 0:
      pe[T_PE].mcr[HRU0RW].hru0rw.hqru0r++;
      break;

    case 4:
      pe[T_PE].mcr[HRU0TW].hru0tw.hqru0t++;
      break;

    case 1:
      pe[T_PE].mcr[HRU1RW].hru1rw.hqru1r++;
      break;

    case 5:
      pe[T_PE].mcr[HRU1TW].hru1tw.hqru1t++;
      break;

    default:
      break;
    }
}

incr_wptr(t_pe, qid, decr)
    unsigned t_pe;
    unsigned qid; /* 0:u0r 1:u1r */
    unsigned decr;
{
    switch (qid) {

    case 0:
      pe[T_PE].mcr[HWU0RW].hwu0rw.hqwu0r++;
      pe[T_PE].mcr[HWU0RW].hwu0rw.ovfu0r = (get_rptr(t_pe, qid) == get_wptr(t_pe, qid));
      pe[T_PE].mcr[HWU0RW].hwu0rw.hqwu0r-=decr;
      return(pe[T_PE].mcr[HWU0RW].hwu0rw.ovfu0r);
      break;

    case 1:
      pe[T_PE].mcr[HWU1RW].hwu1rw.hqwu1r++;
      pe[T_PE].mcr[HWU1RW].hwu1rw.ovfu1r = (get_rptr(t_pe, qid) == get_wptr(t_pe, qid));
      pe[T_PE].mcr[HWU1RW].hwu1rw.hqwu1r-=decr;
      return(pe[T_PE].mcr[HWU1RW].hwu1rw.ovfu1r);
      break;

    default:
      return(0);
      break;
    }
}

#endif

