/* @(#)vp-oper.c	1.4    9/22/92 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* vp-oper.c    90/3/6 */

#ifdef VCP

#include "tim.h"
#include "facility.h"

/*******************************************
* 'c'  check EXCEPTION & check conflict    *
* 'r'  lock vr/mr                          *
* 'x'  execute (unlock)                    *
*******************************************/

/****************************
* vector control operations *
****************************/

#define PREDEC_ANY_BUSY \
     (pe[T_PE].avn_opmq  || pe[T_PE].avn_opcq		   	     \
   || pe[T_PE].avn_ldq   || pe[T_PE].avn_stq   || pe[T_PE].avn_addq  \
   || pe[T_PE].avn_mulq  || pe[T_PE].avn_divq  || pe[T_PE].avn_mskq  \
   || pe[T_PE].avn_ldp   || pe[T_PE].avn_stp   || pe[T_PE].avn_addp  \
   || pe[T_PE].avn_mulp  || pe[T_PE].avn_divp  || pe[T_PE].avn_mskp)

#define PREDEC_MEM_BUSY \
     (pe[T_PE].avn_opmq  || pe[T_PE].avn_ldq   || pe[T_PE].avn_stq   \
                         || pe[T_PE].avn_ldp   || pe[T_PE].avn_stp)

o_vplcr(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d;

  switch (cmd) {
  case 'c':
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, d);
    sys_vcr_access(t_pe, BVOI.R3 & 0x1f, _W_, &d);
    BVOI.av = 0;
    return;
    break;
  }
}


o_vpscr(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d;

  switch (cmd) {
  case 'c':
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    sys_vcr_access(t_pe, BVOI.R1 & 0x1f, _R_, &d);
    sys_async_gr_access(t_pe, BVOI.R3 & 0x1f, BVOI.u, _W_, d);
    sys_gr_unlock(t_pe, BVOI.R3 & 0x1f);
    BVOI.av = 0;
    return;
    break;
  }
}


o_vlcr(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d;

  switch (cmd) {
  case 'c':
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    if (!(BVOI.R3 & 0x1f)) {
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, d);
      sys_vcr_access(t_pe, BVOI.R3 & 0x1f, _W_, &d);
    }
    BVOI.av = 0;
    return;
    break;
  }
}


o_vscr(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d;

  switch (cmd) {
  case 'c':
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    sys_vcr_access(t_pe, BVOI.R1 & 0x1f, _R_, &d);
    sys_async_gr_access(t_pe, BVOI.R3 & 0x1f, BVOI.u, _W_, d);
    sys_gr_unlock(t_pe, BVOI.R3 & 0x1f);
    BVOI.av = 0;
    return;
    break;
  }
}


o_vlvl(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d1, d2;

  switch (cmd) {
  case 'c':
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, d1);
    sys_vcr_access(t_pe, 0, _R_, &d2);
    d2 = (d2 & 0xffff0000) | (d1 & 0x0000ffff);
    sys_vcr_access(t_pe, 0, _W_, &d2);
    BVOI.av = 0;
    return;
    break;
  }
}


o_vlvlf(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d1, d2;

  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, d1);
    sys_vcr_access(t_pe, 0, _R_, &d2);
    d2 = (d2 & 0xffff0000) | (d1 & 0x0000ffff);
    sys_vcr_access(t_pe, 0, _W_, &d2);
    BVOI.av = 0;
    return;
    break;
  }
}


o_vlvt(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d;

  switch (cmd) {
  case 'c':
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, d);
    sys_vut_access(t_pe, BVOI.R3 & 0x1f, _W_, &d);
    BVOI.av = 0;
    return;
    break;
  }
}


o_vsvt(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned d;

  switch (cmd) {
  case 'c':
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    sys_vut_access(t_pe, BVOI.R1 & 0x1f, _R_, &d);
    sys_async_gr_access(t_pe, BVOI.R3 & 0x1f, BVOI.u, _W_, d);
    sys_gr_unlock(t_pe, BVOI.R3 & 0x1f);
    BVOI.av = 0;
    return;
    break;
  }
}


o_vltr(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned i;

  switch (cmd) {
  case 'c':
    if (BVOI.r1 & 7) {
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;
      return(SCORE_EXCEPTION);
    }
    if (PREDEC_ANY_BUSY)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    BVOI.vl = 32;
    sys_vp_lock(t_pe);
    break;
  case 'x':
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++, BVLQ.r1 += 8) {
      if (sys_vop_access(t_pe, 'r', BVLQ.r1, 8, _R_, TVLP.d[i]) == RW_SUCCESS) {
        TVLP.mask |= (0x80 >> i);
        TVLP.num[i] = BVLQ.count-1;
      }
      else
        *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
    }
    return;
    break;
  }
}


o_vpt(t_pe, cmd)
  unsigned t_pe, cmd;
{
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    break;
  case 'x':
    if (PREDEC_MEM_BUSY) {
      pe[T_PE].sr[STAR1].star1.es0 = 1;
      pe[T_PE].sr[STAR1].star1.es1 = 1;
    }
    else {
      pe[T_PE].sr[STAR1].star1.es0 = 0;
      pe[T_PE].sr[STAR1].star1.es1 = pe[T_PE].sr[STAR1].star1.asam;
      BVOI.av = 0;
    }
    return;
    break;
  }
}

/*************************
* vector load operations *
*************************/

o_vl(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = 4;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if ((BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & 3) || (BVOI.distance & 3)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);		

    if (sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _R_);
    break;
  case 'x':
    TVLP.select = BVLQ.R3;
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++, BVLQ.r1 += BVLQ.distance) {
      sys_mr_access(t_pe, BVLQ.R4, BVLQ.count, _R_, m, 0);
      if (m) {
        if (sys_vop_access(t_pe, BVLQ.node, BVLQ.r1, 4, _R_, &TVLP.d[i][1]) == RW_SUCCESS) {
          TVLP.mask |= (0x80 >> i);
          TVLP.num[i] = BVLQ.count;
          TVLP.d[i][0] = 0;
        }
        else
          *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
      }
    }
    return;
    break;
  }
}


o_vlX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned len, vlmask, err;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    len = (BVOI.op & 0x10) ? 4 : 8;
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = len;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if ((BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & (len-1)) || (BVOI.distance & (len-1))) {
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);		

    if (sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _R_);
    break;
  case 'x':
    len = (BVLQ.op & 0x10) ? 4 : 8;
    TVLP.select = BVLQ.R3;
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++, BVLQ.r1 += BVLQ.distance) {
      sys_mr_access(t_pe, BVLQ.R4, BVLQ.count, _R_, m, 0);
      if (m) {
        TVLP.d[i][1] = 0;
        if (sys_vop_access(t_pe, BVLQ.node, BVLQ.r1, len, _R_, TVLP.d[i]) == RW_SUCCESS) {
          TVLP.mask |= (0x80 >> i);
          TVLP.num[i] = BVLQ.count;
        }
        else
          *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
      }
    }
    return;
    break;
  }
}


o_vlm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = 4;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if (BVOI.R3 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & 3) || (BVOI.distance & 3)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _R_);
    break;
  case 'x':
    TVLP.select = BVLQ.R3;
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++, BVLQ.r1 += BVLQ.distance) {
      if (sys_vop_access(t_pe, BVLQ.node, BVLQ.r1, 4, _R_, &TVLP.d[i][0]) == RW_SUCCESS) {
        TVLP.mask |= (0x80 >> i);
        TVLP.num[i] = BVLQ.count;
      }
      else
        *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
    }
    return;
    break;
  }
}


o_vil(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i, m, d, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);

    err = 0;
    if ((BVOI.R1 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask) || (BVOI.R1 == BVOI.R3)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if (BVOI.r1 & 3) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (!PREDEC_MEM_BUSY
     && sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_indirect(t_pe);
    break;
  case 'x':
    TVLP.select = BVLQ.R3;
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++) {
      sys_mr_access(t_pe, BVLQ.R4, BVLQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVLQ.R1, BVLQ.count, _R_, dmy, d);
        if (sys_vop_access(t_pe, BVLQ.node, BVLQ.r1+d*4, 4, _R_, &TVLP.d[i][1]) == RW_SUCCESS) {
          TVLP.mask |= (0x80 >> i);
          TVLP.num[i] = BVLQ.count;
          TVLP.d[i][0] = 0;
        }
        else
          *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
      }
    }
    return;
    break;
  }
}


o_vilX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned len, sft, vlmask, err;
  unsigned i, m, d, dmy;

  switch (cmd) {
  case 'c':
    len = (BVOI.op & 0x10) ? 4 : 8;
    vlmask = get_vlmask(BVOI.vl);

    err = 0;
    if ((BVOI.R1 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask) || (BVOI.R1 == BVOI.R3)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if (BVOI.r1 & (len-1)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);		

    if (!PREDEC_MEM_BUSY
     && sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_indirect(t_pe);
    break;
  case 'x':
    len = (BVLQ.op & 0x10) ? 4 : 8;
    sft = (BVLQ.op & 0x10) ? 2 : 3;
    TVLP.select = BVLQ.R3;
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++) {
      sys_mr_access(t_pe, BVLQ.R4, BVLQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVLQ.R1, BVLQ.count, _R_, dmy, d);
        TVLP.d[i][1] = 0;
        if (sys_vop_access(t_pe, BVLQ.node, BVLQ.r1+(d<<sft), len, _R_, TVLP.d[i]) == RW_SUCCESS) {
          TVLP.mask |= (0x80 >> i);
          TVLP.num[i] = BVLQ.count;
        }
        else
          *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
      }
    }
    return;
    break;
  }
}


o_vlcp(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = 4;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if ((BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & 3) || (BVOI.distance & 3)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _R_);
    break;
  case 'x':
    TVLP.select = BVLQ.R3;
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++, BVLQ.r1 += BVLQ.distance) {
      sys_mr_access(t_pe, BVLQ.R4, BVLQ.count, _R_, m, 0);
      if (m) {
        if (sys_vop_access(t_pe, BVLQ.node, BVLQ.r1, 4, _R_, &TVLP.d[i][1]) == RW_SUCCESS) {
          TVLP.d[i][0] = 0;
          TVLP.mask |= (0x80 >> i);
          TVLP.num[i] = BVLQ.compress;
        }
        else
          *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
        BVLQ.compress++;
      }
    }
    return;
    break;
  }
}


o_vlcpX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned len, vlmask, err;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    len = (BVOI.op & 0x10) ? 4 : 8;
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = len;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if ((BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & (len-1)) || (BVOI.distance & (len-1))) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);		

    if (sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _R_);
    break;
  case 'x':
    len = (BVLQ.op & 0x10) ? 4 : 8;
    TVLP.select = BVLQ.R3;
    for (i=0; i<8 && BVLQ.count<=BVLQ.vl; i++, BVLQ.count++, BVLQ.r1 += BVLQ.distance) {
      sys_mr_access(t_pe, BVLQ.R4, BVLQ.count, _R_, m, 0);
      if (m) {
        TVLP.d[i][1] = 0;
        if (sys_vop_access(t_pe, BVLQ.node, BVLQ.r1, len, _R_, TVLP.d[i]) == RW_SUCCESS) {
          TVLP.mask |= (0x80 >> i);
          TVLP.num[i] = BVLQ.compress;
        }
        else
          *(unsigned*)&TVLP.vcr2 |= *(unsigned*)&pe[T_PE].work_vcr2;
        BVLQ.compress++;
      }
    }
    return;
    break;
  }
}

/**************************
* vector store operations *
**************************/

o_vst(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i, m, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = 4;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);
  
    err = 0;
    if ((BVOI.R2 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & 3) || (BVOI.distance & 3)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _W_);
    break;
  case 'x':
    for (i=0; i<8 && BVSQ.count<=BVSQ.vl; i++, BVSQ.count++, BVSQ.r1 += BVSQ.distance) {
      sys_mr_access(t_pe, BVSQ.R4, BVSQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVSQ.R2, BVSQ.count, _R_, dmy, TVSP.d[i][0]);
        TVSP.mask |= (0x80 >> i);
        TVSP.addr[i] = BVSQ.r1;
      }
    }
    return;
    break;
  }
}


o_vstX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned len, vlmask, err;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    len = (BVOI.op & 0x10) ? 4 : 8;
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = len;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if ((BVOI.R2 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & (len-1)) || (BVOI.distance & (len-1))) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);		

    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _W_);
    break;
  case 'x':
    for (i=0; i<8 && BVSQ.count<=BVSQ.vl; i++, BVSQ.count++, BVSQ.r1 += BVSQ.distance) {
      sys_mr_access(t_pe, BVSQ.R4, BVSQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVSQ.R2, BVSQ.count, _R_, TVSP.d[i][0], TVSP.d[i][1]);
        TVSP.mask |= (0x80 >> i);
        TVSP.addr[i] = BVSQ.r1;
      }
    }
    return;
    break;
  }
}


o_vstm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = 4;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if (BVOI.R2 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & 3) || (BVOI.distance & 3)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (sys_mr_check_score(t_pe, BVOI.R2, _R_, 1) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R2, _R_, 1);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _W_);
    break;
  case 'x':
    for (i=0; i<8 && BVSQ.count<=BVSQ.vl; i++, BVSQ.count++, BVSQ.r1 += BVSQ.distance) {
      sys_mr_access(t_pe, BVSQ.R2, BVSQ.count, _R_, TVSP.d[i][0], 1);
      TVSP.mask |= (0x80 >> i);
      TVSP.addr[i] = BVSQ.r1;
    }
    return;
    break;
  }
}


o_vist(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i, m, d, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);

    err = 0;
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if (BVOI.r1 & 3) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (!PREDEC_MEM_BUSY
     && sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_indirect(t_pe);
    break;
  case 'x':
    for (i=0; i<8 && BVSQ.count<=BVSQ.vl; i++, BVSQ.count++) {
      sys_mr_access(t_pe, BVSQ.R4, BVSQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVSQ.R1, BVSQ.count, _R_, dmy, d);
        sys_vr_access(t_pe, BVSQ.R2, BVSQ.count, _R_, dmy, TVSP.d[i][0]);
        TVSP.mask |= (0x80 >> i);
        TVSP.addr[i] = BVSQ.r1+d*4;
      }
    }
    return;
    break;
  }
}


o_vistX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned len, sft, vlmask, err;
  unsigned i, m, d, dmy;

  switch (cmd) {
  case 'c':
    len = (BVOI.op & 0x10) ? 4 : 8;
    vlmask = get_vlmask(BVOI.vl);

    err = 0;
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if (BVOI.r1 & (len-1)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (!PREDEC_MEM_BUSY
     && sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_indirect(t_pe);
    break;
  case 'x':
    sft = (BVSQ.op & 0x10) ? 2 : 3;
    for (i=0; i<8 && BVSQ.count<=BVSQ.vl; i++, BVSQ.count++) {
      sys_mr_access(t_pe, BVSQ.R4, BVSQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVSQ.R1, BVSQ.count, _R_, dmy, d);
        sys_vr_access(t_pe, BVSQ.R2, BVSQ.count, _R_, TVSP.d[i][0], TVSP.d[i][1]);
        TVSP.mask |= (0x80 >> i);
        TVSP.addr[i] = BVSQ.r1+(d<<sft);
      }
    }
    return;
    break;
  }
}


o_vstx(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, err;
  unsigned i, m, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = 4;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if ((BVOI.R2 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & 3) || (BVOI.distance & 3)) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);

    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _W_);
    break;
  case 'x':
    for (i=0; i<8 && BVSQ.count<=BVSQ.vl; i++, BVSQ.count++, BVSQ.r1 += BVSQ.distance) {
      sys_mr_access(t_pe, BVSQ.R4, BVSQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVSQ.R2, BVSQ.compress, _R_, dmy, TVSP.d[i][0]);
        BVSQ.compress++;
        TVSP.mask |= (0x80 >> i);
        TVSP.addr[i] = BVSQ.r1;
      }
    }
    return;
    break;
  }
}


o_vstxX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned len, vlmask, err;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    len = (BVOI.op & 0x10) ? 4 : 8;
    vlmask = get_vlmask(BVOI.vl);
    if (!(BVOI.R1 & 0x1f))
      BVOI.distance = len;
    else
      sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.distance);

    err = 0;
    if ((BVOI.R2 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      err++;
    }
    if ((BVOI.r1 & (len-1)) || (BVOI.distance & (len-1))) {			
      pe[T_PE].vcr[2].vcr2.pif_nax = 1;	
      err++;
    } 					
    if (err)
      return(SCORE_EXCEPTION);		

    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE
     && sys_vop_check_indirect(t_pe) == SCORE_FREE
     && sys_vop_check_id(t_pe, BVOI.R1 >> 5, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    sys_vop_lock_id(t_pe, BVOI.R1 >> 5, _W_);
    break;
  case 'x':
    for (i=0; i<8 && BVSQ.count<=BVSQ.vl; i++, BVSQ.count++, BVSQ.r1 += BVSQ.distance) {
      sys_mr_access(t_pe, BVSQ.R4, BVSQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVSQ.R2, BVSQ.compress, _R_, TVSP.d[i][0], TVSP.d[i][1]);
        BVSQ.compress++;
        TVSP.mask |= (0x80 >> i);
        TVSP.addr[i] = BVSQ.r1;
      }
    }
    return;
    break;
  }
}

/*******************************
* vector arithmetic operations *
*******************************/

o_va(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dest, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src1);
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, src2);
        dest = src1 + src2;
        if (!(src1>>31)&&!(src2>>31)&&(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x7fffffff;
        }
        else if ((src1>>31)&&(src2>>31)&&!(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x80000000;
        }
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = 0;
        TVAP.d[i][1] = dest;
      }
    }
    return;
    break;
  }
}


o_vas(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dest, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    src1 = BVAQ.scalar_l;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, src2);
        dest = src1 + src2;
        if (!(src1>>31)&&!(src2>>31)&&(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x7fffffff;
        }
        else if ((src1>>31)&&(src2>>31)&&!(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x80000000;
        }
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = 0;
        TVAP.d[i][1] = dest;
      }
    }
    return;
    break;
  }
}


o_vs(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dest, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src1);
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, src2);
        dest = src1 - src2;
        if (!(src1>>31)&&(src2>>31)&&(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x7fffffff;
        }
        else if ((src1>>31)&&!(src2>>31)&&!(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x80000000;
        }
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = 0;
        TVAP.d[i][1] = dest;
      }
    }
    return;
    break;
  }
}


o_vss(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dest, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    src1 = BVAQ.scalar_l;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, src2);
        dest = src1 - src2;
        if (!(src1>>31)&&(src2>>31)&&(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x7fffffff;
        }
        else if ((src1>>31)&&!(src2>>31)&&!(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x80000000;
        }
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = 0;
        TVAP.d[i][1] = dest;
      }
    }
    return;
    break;
  }
}


o_vm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dest1, dest2, dmy;
  unsigned a, b, c, d, n;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVMP.select = BVMQ.R3;
    for (i=0; i<8 && BVMQ.count<=BVMQ.vl; i++, BVMQ.count++) {
      sys_mr_access(t_pe, BVMQ.R4, BVMQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVMQ.R1, BVMQ.count, _R_, dmy, src1);
        sys_vr_access(t_pe, BVMQ.R2, BVMQ.count, _R_, dmy, src2);
        if ((src1 & 0x80000000) ^ (src2 & 0x80000000))
          n = 1;
        else
          n = 0;
        if (src1 & 0x80000000) src1 = -src1;
        if (src2 & 0x80000000) src2 = -src2;
        a = src1 >> 16; b = src1 & 0xffff;
        c = src2 >> 16; d = src2 & 0xffff;
        dest1 = a * c;
        dest2 = b * d;
        a *= d;
        b *= c;
        if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
        dest1 += a >> 16; dest2 += a << 16;
        if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
        dest1 += b >> 16; dest2 += b << 16;
        if (n) {
          dest1 = ~dest1; dest2 = ~dest2;
          if (((1+(dest2&0xffff))&0x10000) && ((1+(dest2>>16))&0x10000)) dest1++;
          dest2++;
        }
        TVMP.mask |= (0x80 >> i);
        TVMP.num[i] = BVMQ.count;
        TVMP.d[i][0] = dest1;
        TVMP.d[i][1] = dest2;
      }
    }
    return;
    break;
  }
}


o_vms(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dest1, dest2, dmy;
  unsigned a, b, c, d, n;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVMP.select = BVMQ.R3;
    for (i=0; i<8 && BVMQ.count<=BVMQ.vl; i++, BVMQ.count++) {
      sys_mr_access(t_pe, BVMQ.R4, BVMQ.count, _R_, m, 0);
      if (m) {
        src1 = BVMQ.scalar_l;
        sys_vr_access(t_pe, BVMQ.R2, BVMQ.count, _R_, dmy, src2);
        if ((src1 & 0x80000000) ^ (src2 & 0x80000000))
          n = 1;
        else
          n = 0;
        if (src1 & 0x80000000) src1 = -src1;
        if (src2 & 0x80000000) src2 = -src2;
        a = src1 >> 16; b = src1 & 0xffff;
        c = src2 >> 16; d = src2 & 0xffff;
        dest1 = a * c;
        dest2 = b * d;
        a *= d;
        b *= c;
        if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
        dest1 += a >> 16; dest2 += a << 16;
        if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
        dest1 += b >> 16; dest2 += b << 16;
        if (n) {
          dest1 = ~dest1; dest2 = ~dest2;
          if (((1+(dest2&0xffff))&0x10000) && ((1+(dest2>>16))&0x10000)) dest1++;
          dest2++;
        }
        TVMP.mask |= (0x80 >> i);
        TVMP.num[i] = BVMQ.count;
        TVMP.d[i][0] = dest1;
        TVMP.d[i][1] = dest2;
      }
    }
    return;
    break;
  }
}

/****************************
* vector compare operations *
****************************/

o_vc(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {	
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src1);
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, src2);
        switch (BVAQ.op & 7) {
        case 0: /* F */
          TVAP.d[i][0] = 0;
          break;
        case 1: /* H */
          TVAP.d[i][0] = ((int) src1 >  (int) src2);
          break;
        case 2: /* L */
          TVAP.d[i][0] = ((int) src1 <  (int) src2);
          break;
        case 3: /* NE */
          TVAP.d[i][0] = ((int) src1 != (int) src2);
          break;
        case 4: /* E */
          TVAP.d[i][0] = ((int) src1 == (int) src2);
          break;
        case 5: /* NL */
          TVAP.d[i][0] = ((int) src1 >= (int) src2);
          break;
        case 6: /* NH */
          TVAP.d[i][0] = ((int) src1 <= (int) src2);
          break;
        case 7: /* T */
          TVAP.d[i][0] = 1;
          break;
        }
      }
      else {
        TVAP.d[i][0] = 0;
      }
      TVAP.mask |= (0x80 >> i);
      TVAP.num[i] = BVAQ.count;
    }
    return;
    break;
  }
}


o_vcs(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    src1 = BVAQ.scalar_l;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, src2);
        switch (BVAQ.op & 7) {
        case 0: /* F */
          TVAP.d[i][0] = 0;
          break;
        case 1: /* H */
          TVAP.d[i][0] = ((int) src1 >  (int) src2);
          break;
        case 2: /* L */
          TVAP.d[i][0] = ((int) src1 <  (int) src2);
          break;
        case 3: /* NE */
          TVAP.d[i][0] = ((int) src1 != (int) src2);
          break;
        case 4: /* E */
          TVAP.d[i][0] = ((int) src1 == (int) src2);
          break;
        case 5: /* NL */
          TVAP.d[i][0] = ((int) src1 >= (int) src2);
          break;
        case 6: /* NH */
          TVAP.d[i][0] = ((int) src1 <= (int) src2);
          break;
        case 7: /* T */
          TVAP.d[i][0] = 1;
          break;
        }
      }
      else {
        TVAP.d[i][0] = 0;
      }
      TVAP.mask |= (0x80 >> i);
      TVAP.num[i] = BVAQ.count;
    }
    return;
    break;
  }
}

/****************************
* vector logical operations *
****************************/

o_vn(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1u, src1l, src2u, src2l;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, src1u, src1l);
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, src2u, src2l);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = src1u & src2u;
        TVAP.d[i][1] = src1l & src2l;
      }
    }
    return;
    break;
  }
}


o_vns(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1u, src1l, src2u, src2l;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (BVOI.R1 & 1) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, (BVOI.R1 & 0x1f)  , BVOI.u, _R_, BVOI.scalar_u);
    sys_async_gr_access(t_pe, (BVOI.R1 & 0x1f)+1, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    src1u = BVAQ.scalar_u;
    src1l = BVAQ.scalar_l;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, src2u, src2l);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = src1u & src2u;
        TVAP.d[i][1] = src1l & src2l;
      }
    }
    return;
    break;
  }
}


o_vnm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m54, m55, src1, src2;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R1, _R_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R2, _R_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R1, _R_, 1);
    sys_mr_lock(t_pe, BVOI.R2, _R_, 1);
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    break;
  case 'x':
    TVKP.select = BVKQ.R3;
    m54 = (BVKQ.R4 >> 1) & 1;
    m55 = (BVKQ.R4     ) & 1;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      sys_mr_access(t_pe, BVKQ.R1, BVKQ.count, _R_, src1, 1);
      sys_mr_access(t_pe, BVKQ.R2, BVKQ.count, _R_, src2, 1);
      TVKP.mask |= (0x80 >> i);
      TVKP.num[i] = BVKQ.count;
      TVKP.d[i] = (src1 ^ m54) & (src2 ^ m55);
    }
    return;
    break;
  }
}


o_vo(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1u, src1l, src2u, src2l;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, src1u, src1l);
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, src2u, src2l);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = src1u | src2u;
        TVAP.d[i][1] = src1l | src2l;
      }
    }
    return;
    break;
  }
}


o_vos(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1u, src1l, src2u, src2l;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (BVOI.R1 & 1) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, (BVOI.R1 & 0x1f)  , BVOI.u, _R_, BVOI.scalar_u);
    sys_async_gr_access(t_pe, (BVOI.R1 & 0x1f)+1, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    src1u = BVAQ.scalar_u;
    src1l = BVAQ.scalar_l;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, src2u, src2l);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = src1u | src2u;
        TVAP.d[i][1] = src1l | src2l;
      }
    }
    return;
    break;
  }
}


o_vom(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m54, m55, src1, src2;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R1, _R_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R2, _R_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R1, _R_, 1);
    sys_mr_lock(t_pe, BVOI.R2, _R_, 1);
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    break;
  case 'x':
    TVKP.select = BVKQ.R3;
    m54 = (BVKQ.R4 >> 1) & 1;
    m55 = (BVKQ.R4     ) & 1;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      sys_mr_access(t_pe, BVKQ.R1, BVKQ.count, _R_, src1, 1);
      sys_mr_access(t_pe, BVKQ.R2, BVKQ.count, _R_, src2, 1);
      TVKP.mask |= (0x80 >> i);
      TVKP.num[i] = BVKQ.count;
      TVKP.d[i] = (src1 ^ m54) | (src2 ^ m55);
    }
    return;
    break;
  }
}


o_vx(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1u, src1l, src2u, src2l;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, src1u, src1l);
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, src2u, src2l);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = src1u ^ src2u;
        TVAP.d[i][1] = src1l ^ src2l;
      }
    }
    return;
    break;
  }
}


o_vxs(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src1u, src1l, src2u, src2l;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (BVOI.R1 & 1) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, (BVOI.R1 & 0x1f)  , BVOI.u, _R_, BVOI.scalar_u);
    sys_async_gr_access(t_pe, (BVOI.R1 & 0x1f)+1, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    src1u = BVAQ.scalar_u;
    src1l = BVAQ.scalar_l;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, src2u, src2l);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = src1u ^ src2u;
        TVAP.d[i][1] = src1l ^ src2l;
      }
    }
    return;
    break;
  }
}


o_vxm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m54, m55, src1, src2;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R1, _R_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R2, _R_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R1, _R_, 1);
    sys_mr_lock(t_pe, BVOI.R2, _R_, 1);
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    break;
  case 'x':
    TVKP.select = BVKQ.R3;
    m54 = (BVKQ.R4 >> 1) & 1;
    m55 = (BVKQ.R4     ) & 1;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      sys_mr_access(t_pe, BVKQ.R1, BVKQ.count, _R_, src1, 1);
      sys_mr_access(t_pe, BVKQ.R2, BVKQ.count, _R_, src2, 1);
      TVKP.mask |= (0x80 >> i);
      TVKP.num[i] = BVKQ.count;
      TVKP.d[i] = (src1 ^ m54) ^ (src2 ^ m55);
    }
    return;
    break;
  }
}


o_vsll(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, sft, srcu, srcl;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    sft = BVAQ.scalar_l & 0x3f;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, srcu, srcl);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        if (!sft) {
          TVAP.d[i][0] = srcu;
          TVAP.d[i][1] = srcl;
        }
        else if (sft < 32) {
          TVAP.d[i][0] = (srcu << sft) | (srcl >> (32-sft));
          TVAP.d[i][1] = (srcl << sft);
        }
        else {
          TVAP.d[i][0] = (srcl << (sft-32));
          TVAP.d[i][1] = 0;
        }
      }
    }
    return;
    break;
  }
}


o_vsrl(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, sft, srcu, srcl;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    sft = BVAQ.scalar_l & 0x3f;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, srcu, srcl);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        if (!sft) {
          TVAP.d[i][0] = srcu;
          TVAP.d[i][1] = srcl;
        }
        else if (sft < 32) {
          TVAP.d[i][0] = (srcu >> sft);
          TVAP.d[i][1] = (srcu << (32-sft)) | (srcl >> sft);
        }
        else {
          TVAP.d[i][0] = 0;
          TVAP.d[i][1] = (srcu >> (sft-32));
        }
      }
    }
    return;
    break;
  }
}


o_vesll(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, sftu, sftl, srcu, srcl;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, sftu, sftl);
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, srcu, srcl);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        if (sftl & 0x80000000) {
          sftl = (~sftl+1) & 0x3f;
          if (!sftl) {
            TVAP.d[i][0] = srcu;
            TVAP.d[i][1] = srcl;
          }
          else if (sftl < 32) {
            TVAP.d[i][0] = (srcu >> sftl);
            TVAP.d[i][1] = (srcu << (32-sftl)) | (srcl >> sftl);
          }
          else {
            TVAP.d[i][0] = 0;
            TVAP.d[i][1] = (srcu >> (sftl-32));
          }
        }
        else {
          sftl &= 0x3f;
          if (!sftl) {
            TVAP.d[i][0] = srcu;
            TVAP.d[i][1] = srcl;
          }
          else if (sftl < 32) {
            TVAP.d[i][0] = (srcu << sftl) | (srcl >> (32-sftl));
            TVAP.d[i][1] = (srcl << sftl);
          }
          else {
            TVAP.d[i][0] = (srcl << (sftl-32));
            TVAP.d[i][1] = 0;
          }
        }
      }
    }
    return;
    break;
  }
}


o_vtm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m55, src;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R2, _R_, 1) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R2, _R_, 1);
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    break;
  case 'x':
    TVKP.select = BVKQ.R3;
    m55 = BVKQ.R4 & 1;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      sys_mr_access(t_pe, BVKQ.R2, BVKQ.count, _R_, src, 1);
      TVKP.mask |= (0x80 >> i);
      TVKP.num[i] = BVKQ.count;
      TVKP.d[i] = src ^ m55;
    }
    return;
    break;
  }
}

/**************************
* vector macro operations *
**************************/

o_vfm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m54, src;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (BVOI.R1 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R1, _R_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R1, _R_, 1);
    break;
  case 'x':
    m54 = (BVKQ.R4 >> 1) & 1;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      if (!TVKP.d[0]) {
        sys_mr_access(t_pe, BVKQ.R1, BVKQ.count, _R_, src, 1);
        if (src ^ m54)
          TVKP.d[0] = BVKQ.count;
      }
    }
    return;
    break;
  }
}


o_vfX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    switch (BVAQ.op & 3) {
    case 0:
      for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
        sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
        if (m) {
          sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src);
          if (!TVAP.d[0][1] || ((int)TVAP.d[1][1] < (int)src)) {
            TVAP.d[0][1] = BVAQ.count;
            TVAP.d[1][1] = src;
          }
        }
      }
      break;
    case 1:
      for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
        sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
        if (m) {
          sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src);
          if (!TVAP.d[0][1] || ((int)TVAP.d[1][1] <= (int)src)) {
            TVAP.d[0][1] = BVAQ.count;
            TVAP.d[1][1] = src;
          }
        }   
      }
      break;
    case 2:
      for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
        sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
        if (m) {
          sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src);
          if (!TVAP.d[0][1] || ((int)TVAP.d[1][1] > (int)src)) {
            TVAP.d[0][1] = BVAQ.count;
            TVAP.d[1][1] = src;
          }
        }
      }
      break;
    case 3:
      for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
        sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
        if (m) {
          sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src);
          if (!TVAP.d[0][1] || ((int)TVAP.d[1][1] >= (int)src)) {
            TVAP.d[0][1] = BVAQ.count;
            TVAP.d[1][1] = src;
          }
        }
      }
      break;
    }
    return;
    break;
  }
}


o_vfmx(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m54, src;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (BVOI.R1 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R1, _R_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R1, _R_, 1);
    break;
  case 'x':
    m54 = (BVKQ.R4 >> 1) & 1;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      sys_mr_access(t_pe, BVKQ.R1, BVKQ.count, _R_, src, 1);
      if (src ^ m54)
        TVKP.d[0] = BVKQ.count;
    }
    return;
    break;
  }
}


o_vgs(t_pe, cmd)
{
  unsigned vlmask;
  unsigned i, m, src1, src2, dest1, dest2;
  unsigned a, b, c, d, n;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVMP.select = BVMQ.R3;
    for (i=0; i<8 && BVMQ.count<=BVMQ.vl; i++, BVMQ.count++) {
      sys_mr_access(t_pe, BVMQ.R4, BVMQ.count, _R_, m, 0);
      if (m) {
        src1 = BVMQ.scalar_l;
        src2 = BVMQ.count;
        if ((src1 & 0x80000000) ^ (src2 & 0x80000000))
          n = 1;
        else
          n = 0;
        if (src1 & 0x80000000) src1 = -src1;
        if (src2 & 0x80000000) src2 = -src2;
        a = src1 >> 16; b = src1 & 0xffff;
        c = src2 >> 16; d = src2 & 0xffff;
        dest1 = a * c;
        dest2 = b * d;
        a *= d;
        b *= c;
        if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
        dest1 += a >> 16; dest2 += a << 16;
        if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
        dest1 += b >> 16; dest2 += b << 16;
        if (n) {
          dest1 = ~dest1; dest2 = ~dest2;
          if (((1+(dest2&0xffff))&0x10000) && ((1+(dest2>>16))&0x10000)) dest1++;
          dest2++;
        }
        TVMP.mask |= (0x80 >> i);
        TVMP.num[i] = BVMQ.count;
        TVMP.d[i][0] = dest1;
        TVMP.d[i][1] = dest2;
      }
    }
    return;
    break;
  }
}


o_vgm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m54, idx;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (BVOI.R3 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R3, _W_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_mr_lock(t_pe, BVOI.R3, _W_, 1);
    break;
  case 'x':
    TVKP.select = BVKQ.R3;
    m54 = (BVKQ.R4 >> 1) & 1;
    idx = BVKQ.scalar_l & 0xffff;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      TVKP.mask |= (0x80 >> i);
      TVKP.num[i] = BVKQ.count;
      if (idx == BVKQ.count)
        TVKP.d[i] = ~m54;
      else
        TVKP.d[i] = m54;
    }
    return;
    break;
  }
}


o_vsm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask, upper;
  unsigned i, m, src1, src2, dest, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R1 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R1, _R_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    BVOI.vl += 8;
    for (i=0; i<16; i++)
      BVOI.vsmw[i][1] = 0;
    sys_vr_lock(t_pe, BVOI.R1, _R_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    switch (BVAQ.vl - BVAQ.count) {
    default:
      upper = (((BVAQ.count-1) >> 3) & 1);
      for (i=0; i<8 && BVAQ.count<=BVAQ.vl-8; i++, BVAQ.count++) {
        sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
        if (m) {
          src1 = upper ? BVAQ.vsmw[i+8][1] : BVAQ.vsmw[i][1];
          sys_vr_access(t_pe, BVAQ.R1, BVAQ.count, _R_, dmy, src2);
          dest = src1 + src2;
          if (!(src1>>31)&&!(src2>>31)&&(dest>>31)) {
            if (pe[T_PE].vcr[2].vcr2.pim_ivm)
              TVAP.vcr2.pif_ivf = 1;
            if (pe[T_PE].vcr[0].vcr0.iv)
              dest = 0x7fffffff;
          }
          else if ((src1>>31)&&(src2>>31)&&!(dest>>31)) {
            if (pe[T_PE].vcr[2].vcr2.pim_ivm)
              TVAP.vcr2.pif_ivf = 1;
            if (pe[T_PE].vcr[0].vcr0.iv)
              dest = 0x80000000;
          }
          if (upper) BVAQ.vsmw[i+8][1] = dest;
          else       BVAQ.vsmw[i  ][1] = dest;
        }
      }
      break;
    case 7:
      for (i=0; i<8; i++) {
        src1 = BVAQ.vsmw[i  ][1];
        src2 = BVAQ.vsmw[i+8][1];
        dest = src1 + src2;
        if (!(src1>>31)&&!(src2>>31)&&(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x7fffffff;
        }
        else if ((src1>>31)&&(src2>>31)&&!(dest>>31)) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x80000000;
        }
        BVAQ.vsmw[i][1] = dest;
      }
      BVAQ.count++;
      break;
    case 6:
      src1 = BVAQ.vsmw[1][1];
      goto vsm_common;
      break;
    case 5:
      src1 = BVAQ.vsmw[2][1];
      goto vsm_common;
      break;
    case 4:
      src1 = BVAQ.vsmw[3][1];
      goto vsm_common;
      break;
    case 3:
      src1 = BVAQ.vsmw[4][1];
      goto vsm_common;
      break;
    case 2:
      src1 = BVAQ.vsmw[5][1];
      goto vsm_common;
      break;
    case 1:
      src1 = BVAQ.vsmw[6][1];
      goto vsm_common;
      break;
    case 0:
      src1 = BVAQ.vsmw[7][1];
vsm_common:
      src2 = BVAQ.vsmw[0][1];
      dest = src1 + src2;
      if (!(src1>>31)&&!(src2>>31)&&(dest>>31)) {
        if (pe[T_PE].vcr[2].vcr2.pim_ivm)
          TVAP.vcr2.pif_ivf = 1;
        if (pe[T_PE].vcr[0].vcr0.iv)
          dest = 0x7fffffff;
      }
      else if ((src1>>31)&&(src2>>31)&&!(dest>>31)) {
        if (pe[T_PE].vcr[2].vcr2.pim_ivm)
          TVAP.vcr2.pif_ivf = 1;
        if (pe[T_PE].vcr[0].vcr0.iv)
          dest = 0x80000000;
      }
      BVAQ.vsmw[0][1] = dest;
      BVAQ.count++;
      break;
    }
    return;
    break;
  }
}


o_vsmm(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m54, src;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (BVOI.R1 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_mr_check_score(t_pe, BVOI.R1, _R_, 1) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_mr_lock(t_pe, BVOI.R1, _R_, 1);
    break;
  case 'x':
    m54 = (BVKQ.R4 >> 1) & 1;
    for (i=0; i<8 && BVKQ.count<=BVKQ.vl; i++, BVKQ.count++) {
      sys_mr_access(t_pe, BVKQ.R1, BVKQ.count, _R_, src, 1);
      if (src ^ m54)
        TVKP.d[1]++;
    }
    return;
    break;
  }
}

/*************************
* vector edit operations *
*************************/

o_vls(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = 0;
        TVAP.d[i][1] = BVAQ.scalar_l;
      }
    }
    return;
    break;
  }
}


o_vlsX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_fr_access(t_pe, BVOI.R1 & 0x1f, _R_, BVOI.scalar_u, BVOI.scalar_l);
    if (BVOI.op & 0x10)
      BVOI.scalar_l = 0;
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = BVAQ.scalar_u;
        TVAP.d[i][1] = BVAQ.scalar_l;
      }
    }
    return;
    break;
  }
}


o_vts(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, idx, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (BVOI.R2 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    break;
  case 'x':
    idx = BVAQ.scalar_l & 0xffff;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      if (idx == BVAQ.count) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, TVAP.d[1][1]);
      }
    }
    return;
    break;
  }
}


o_vtsX(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, idx;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if (BVOI.R2 & vlmask) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_async_gr_access(t_pe, BVOI.R1 & 0x1f, BVOI.u, _R_, BVOI.scalar_l);
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    break;
  case 'x':
    idx = BVAQ.scalar_l & 0xffff;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      if (idx == BVAQ.count) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, TVAP.d[1][0], TVAP.d[1][1]);
        if (BVAQ.op & 0x10)
          TVAP.d[1][1] = 0;
      }
    }
    return;
    break;
  }
}


o_vlp(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m, src, dest, dmy;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, dmy, src);
        dest = ((int)(src) > 0) ? src : -src;
        if (dest == (unsigned)0x80000000) {
          if (pe[T_PE].vcr[2].vcr2.pim_ivm)
            TVAP.vcr2.pif_ivf = 1;
          if (pe[T_PE].vcr[0].vcr0.iv)
            dest = 0x7fffffff;
        }
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
        TVAP.d[i][0] = 0;
        TVAP.d[i][1] = dest;
      }
    }
    return;
    break;
  }
}


o_vlr(t_pe, cmd)
  unsigned t_pe, cmd;
{
  unsigned vlmask;
  unsigned i, m;

  switch (cmd) {
  case 'c':
    vlmask = get_vlmask(BVOI.vl);
    if ((BVOI.R2 & vlmask) || (BVOI.R3 & vlmask) || (BVOI.R4 & vlmask)) {
      pe[T_PE].vcr[2].vcr2.pif_spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_vr_check_score(t_pe, BVOI.R2, _R_) == SCORE_FREE
     && sys_vr_check_score(t_pe, BVOI.R3, _W_) == SCORE_FREE
     && sys_mr_check_score(t_pe, BVOI.R4, _R_, 0) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_vr_lock(t_pe, BVOI.R2, _R_);
    sys_vr_lock(t_pe, BVOI.R3, _W_);
    sys_mr_lock(t_pe, BVOI.R4, _R_, 0);
    break;
  case 'x':
    TVAP.select = BVAQ.R3;
    for (i=0; i<8 && BVAQ.count<=BVAQ.vl; i++, BVAQ.count++) {
      sys_mr_access(t_pe, BVAQ.R4, BVAQ.count, _R_, m, 0);
      if (m) {
        sys_vr_access(t_pe, BVAQ.R2, BVAQ.count, _R_, TVAP.d[i][0], TVAP.d[i][1]);
        TVAP.mask |= (0x80 >> i);
        TVAP.num[i] = BVAQ.count;
      }
    }
    return;
    break;
  }
}

#endif

