#include	<stdio.h>
#include	<ctype.h>
#include	<string.h>

#include  	"tachyon.h"
#include	"sim.h"
#include	"extern.h"


DICTIONARY	*entry(p,g,wordp,basep,indxp,mode)
DICTIONARY	*p;
GRAPH		*g;
char		*wordp,*basep,*indxp;
int		mode;
{
  DATA_DIC	*data_entry();
  int		rno;

  if ((rno=is_register(wordp))>= 0 && rno<=1663)
    reg_entry(p,g,rno,mode);
  else
    p->memory = data_entry(p->memory,p,g,wordp,basep,indxp,mode);
  return(p);
}

reg_entry(p,g,rno,mode)
DICTIONARY	*p;   /* ROOT of DICTIONARY    */
GRAPH		*g;   /* transacted graph node */
long		rno;  /* Register Number       */
long            mode; /* DEFine or REFerence   */
{
  G_CHAIN	*list,*addchain(),*delchain();
  GRAPH		*defg;
  char		entry_f;

/*    rno==0  : GR0    */
/*    rno==32 : FR0    */

  if (rno==0 || rno==32) return;

  defg = p->regtbl[rno].defgraph;
  if (mode == DEF){
    /* MAKE CHAIN for ANTI DEPENDENCE */
    for (list=p->regtbl[rno].reflist;list!=NULL;list=list->next){ 
      if(list->node != NULL && list->node != g){
	list->node->forward = addchain(list->node->forward,g,ANTI_DEP);
	g->back = addchain(g->back,list->node,ANTI_DEP);
      }
    } 
    /* CLEAR REGISTER TABLE */ 
    for (;;){
      if (list=p->regtbl[rno].reflist){
        p->regtbl[rno].reflist = delchain(list,list);
        free(list);
      }
      else break;
    }
    if (p->regtbl[rno].reflist !=NULL){
      printf("ERROR REGISTER TABLE not CLEARED.\n");
      exit(1);
    }
    if (defg){
      defg->forward = addchain(defg->forward,g,DEPENDENCE);
      g->back = addchain(g->back,defg,DEPENDENCE);
    }
    p->regtbl[rno].defgraph = g;
  }
  else{
    if (defg && g!=defg){
      g->back = addchain(g->back,defg,DEPENDENCE);
      defg->forward = addchain(defg->forward,g,DEPENDENCE);
    }
    p->regtbl[rno].reflist = addchain(p->regtbl[rno].reflist,g,DEPENDENCE);
/*
    for (entry_f=1,list=p->regtbl[rno].reflist;list;list=list->next){
      if (is_parent(g,list->node)){
        entry_f=0;
        break;
      }
      else if(is_parent(list->node,g)){
        p->regtbl[rno].reflist=delchain(p->regtbl[rno].reflist,list->node);
        break;
      }
    }
    if (entry_f)
      p->regtbl[rno].reflist = addchain(p->regtbl[rno].reflist,g,DEPENDENCE);
*/
  }
}

DATA_DIC	*data_entry(p,dicp,g,wordp,basep,indxp,mode)
DATA_DIC	*p;
DICTIONARY	*dicp;
GRAPH		*g;
char		*wordp,*basep,*indxp;
int		mode;
{
  DATA_DIC	*d_list,*prev;
  GRAPH		*defg,*search_def();
  G_CHAIN	*glist,*addchain();
  int		cond;
  char		*strsave();
   
#ifdef DEBUG
  printf(" ENTER data_entry()\n");
  printf(" wordp = %s\n",wordp);
  if (basep) printf(" basep = %s\n",basep);
  else printf(" basep = NULL \n");
  if (indxp) printf(" indxp = %s\n",indxp);
  else printf(" indxp = NULL \n");
#endif

  if (p==NULL){
    p = (DATA_DIC *)a4alloc(sizeof(DATA_DIC));
    p->name = strsave(wordp);
    p->base = strsave(basep);
    p->indx = strsave(indxp);
    if (basep) p->basedef = search_def(basep,dicroot);
    if (indxp) p->indxdef = search_def(indxp,dicroot);
    p->left = p->right = p->next = NULL;
    if (mode==DEF){
      p->defgraph = g;
      p->reflist  = NULL;
    }
    else{
      p->defgraph = NULL;
      p->reflist  = addchain(p->reflist,g,NORELATION);
    }
    if (dicp->memory) mem_dependence(dicp->memory,g,basep,indxp);
  }
  else if ((cond=strcmp(p->name,wordp))==0){
/*   
    g  : New data of address(basep,indxp)
    p  : Previous data of address(p->base,p->indx)
*/
    for (d_list=p,prev=NULL;d_list!=NULL;prev=d_list,d_list=d_list->next)
      if (is_same_addr(basep,indxp,d_list)){
        if (mode==DEF){
	  d_list->defgraph = g ;
          for (glist=d_list->reflist;glist!=NULL;glist=glist->next){
	    if (glist->node) {
	      glist->node->forward = addchain(glist->node->forward,g,ANTI_DEP);
	      g->back = addchain(g->back,glist->node,ANTI_DEP);
	      glist->node=NULL;
            }
          }
        }
	else{
	  if (defg = d_list->defgraph){
	    defg->forward = addchain(defg->forward,g,DEPENDENCE);
	    g->back = addchain(g->back,defg,DEPENDENCE);
          }
	  d_list->reflist = addchain(d_list->reflist,g,NORELATION);
        }
        if (dicp->memory) mem_dependence(dicp->memory,g,basep,indxp);
	break;
      }
    if (d_list==NULL){
      d_list = (DATA_DIC *)a4alloc(sizeof(DATA_DIC));
      d_list->name = strsave(wordp);
      d_list->base = strsave(basep);
      d_list->indx = strsave(indxp);
      if (basep) d_list->basedef = search_def(basep,dicroot);
      if (indxp) d_list->indxdef = search_def(indxp,dicroot);
      d_list->left=d_list->right=d_list->next=NULL;
      if (mode==DEF){
        d_list->defgraph = g;
        d_list->reflist  = NULL;
      }
      else{
        d_list->defgraph = NULL;
        d_list->reflist  = addchain(d_list->reflist,g,NORELATION);
      }
      if (dicp->memory) mem_dependence(dicp->memory,g,basep,indxp);
      prev->next = d_list;
    }
  }
  else if (cond < 0)
    p->left = data_entry(p->left,dicp,g,wordp,basep,indxp,mode);
  else 
    p->right = data_entry(p->right,dicp,g,wordp,basep,indxp,mode);

  return(p);
}

is_same_addr(basep,indxp,olddata)
char 		*basep,*indxp;
DATA_DIC	*olddata;
{
  DATA_DIC	*basedic,*indxdic;
  GRAPH		*basedef,*indxdef,*search_def();

  if (basep) basedef = search_def(basep,dicroot);
  if (indxp) indxdef = search_def(indxp,dicroot);
  return (opr_content(basep,olddata->base,basedef,olddata->basedef)==1 && opr_content(indxp,olddata->indx,indxdef,olddata->indxdef)) ;

}

mem_dependence(dic,g,basep,indxp)
DATA_DIC	*dic;
GRAPH		*g;
char		*basep,*indxp;
{
  DATA_DIC	*basedic,*indxdic;
  GRAPH		*basedef,*indxdef,*search_def();

  if (dic->left) mem_dependence(dic->left,g,basep,indxp);
  if (basep) basedef = search_def(basep,dicroot);
  if (indxp) indxdef = search_def(indxp,dicroot);
  if (opr_content(basep,dic->base,basedef,dic->basedef)==1 ){
    if (indxp && is_register(indxp) == NUMBER  && dic->indx && is_register(dic->indx)==NUMBER && abs(atoi(indxp)-atoi(dic->indx))>=insttbl[g->inst_indx].mem_def) return;
  }
  if (opr_content(indxp,dic->indx,indxdef,dic->indxdef)==1 ){
    if (basep && is_register(basep) == NUMBER  && dic->base && is_register(dic->base)==NUMBER && abs(atoi(basep)-atoi(dic->base))>=insttbl[g->inst_indx].mem_def) return;
  }
/* Make Memory Dependence  */
  if (dic->defgraph){
    if (g->node_no < dic->defgraph->node_no ){
      dic->defgraph->forward = addchain(dic->defgraph->forward,g,MEMORY_DEP);
      g->back = addchain(g->back,dic->defgraph,MEMORY_DEP);
    }
  }  
  if (dic->right) mem_dependence(dic->right,g,basep,indxp);
}

is_register(s)
char		*s;
{
  int	rno;
  char	c;

  rno= -1;
  if (strncmp(s,"gr",2)==0 || strncmp(s,"GR",2)==0){
    if ((rno = atoi(&s[2]))>=0 && rno <=9 && s[3]=='\0');
    else if (rno>=10 && rno <=31 && s[4]=='\0');
    else rno = -1;
  }
  else if (strncmp(s,"%gr",3)==0){
    if ((rno = atoi(&s[3]))>=0 && rno <=9 && s[4]=='\0');
    else if (rno>=10 && rno <=31 && s[5]=='\0');
    else rno = -1;
  }
  else if (strncmp(s,"fr",2)==0 || strncmp(s,"FR",2)==0){
    if (((rno = atoi(&s[2]))>=0 && rno <=9 && s[3]=='\0')||(rno>=10 && rno <=31 && s[4]=='\0'))
      rno = atoi(&s[2])+ 32; /* FREG_BEGIN-GREGBEGIN-1 */ 
    else rno = -1;
  }
  else if (strncmp(s,"%fr",3)==0){
    if (((rno = atoi(&s[3]))>=0 && rno <=9 && s[4]=='\0')||(rno>=10 && rno <=31 && s[5]=='\0'))
      rno = atoi(&s[3])+ 32; /* FREG_BEGIN-GREGBEGIN-1 */ 
    else rno = -1;
  }
  else if (strncmp(s,"sr",2)==0 || strncmp(s,"SR",2)==0){
    if (((rno = atoi(&s[2]))>=0 && rno <=9 && s[3]=='\0')||(rno>=10 && rno <=99 && s[4]=='\0')||(rno>=100 && rno <=999 && s[5]=='\0')||(rno>=1000 && rno<=1023 && s[6]=='\0'))
      rno = atoi(&s[2])+ 64; /* SREG_BEGIN-GREGBEGIN-1 */ 
    else rno = -1;
  }
  else if (strncmp(s,"vcr",3)==0 || strncmp(s,"VCR",3)==0){
    if (((rno = atoi(&s[3]))>=0 && rno <=9 && s[4]=='\0')||(rno>=10 && rno <=31 && s[5]=='\0'))
      rno = atoi(&s[2])+ 1088; /* VCREG_BEGIN-GREGBEGIN-1 */ 
    else rno = -1;
  }
  else if (strncmp(s,"mr",2)==0 || strncmp(s,"MR",2)==0){
    if (((rno = atoi(&s[2]))>=0 && rno <=9 && s[3]=='\0')||(rno>=10 && rno <=99 && s[4]=='\0')||(rno>=100 && rno <=256 && s[5]=='\0'))
      rno = atoi(&s[2])+ 1120; /* MREG_BEGIN-GREGBEGIN-1 */ 
    else rno = -1;
  }
  else if (strncmp(s,"vr",2)==0 || strncmp(s,"VR",2)==0){
    if (((rno = atoi(&s[2]))>=0 && rno <=9 && s[3]=='\0')||(rno>=10 && rno <=99 && s[4]=='\0')||(rno>=100 && rno <=256 && s[5]=='\0'))
      rno = atoi(&s[2])+ 1376; /* VREG_BEGIN-GREGBEGIN-1 */ 
    else rno = -1;
  }
  else if (strncmp(s,"vut",3)==0 || strncmp(s,"VUT",3)==0){
    if (((rno = atoi(&s[3]))>=0 && rno <=9 && s[4]=='\0')||(rno>=10 && rno <=31 && s[5]=='\0'))
      rno = atoi(&s[2])+ 1631; /* VUTEG_BEGIN-GREGBEGIN-1 */ 
    else rno = -1;
  }
  else if (isdigit(c=s[0]) || (c=='-'||c=='+')&&isdigit(s[1])){
    rno = NUMBER;
  }	
  else if (isalpha(c=s[0])){
    rno = NAME;
  }	
  return(rno);
}

DATA_DIC	*consult_dic(s,root)
char		*s;
DATA_DIC	*root;
{
  DATA_DIC	*p;
  int		cond;

  p=root;
  while(p){
    if ((cond=strcmp(s,p->name))==0) break;
    else if (cond<0) p=p->left;
    else p=p->right;
  }
  return(p);
}

opr_content(r_now,r_old,r_now_def,r_old_def)
char	*r_now,*r_old;
GRAPH	*r_now_def,*r_old_def;
{
  int rno;
  int ret = -1;

  if (r_now==NULL){
    if (r_old==NULL) ret = 1;
    else ret = 0;
  }
  else{
    if (r_old==NULL) ret = 0;
    else{
      if (strcmp(r_now,r_old)==0)
	if ((rno=is_register(r_now))>=0 && rno<=1663){
	  if (r_now_def == r_old_def) ret = 1;
        }
        else ret = 1;
    }
  }
   
  return(ret);
}

GRAPH	*search_def(word,p)
char		*word;
DICTIONARY	*p;
{
  int	rno;
  DATA_DIC	*consult_dic(),*dicitem;

  if ((rno=is_register(word))>= 0 && rno<=1663)
    return(p->regtbl[rno].defgraph);
  else{
    if (dicitem = consult_dic(word,p->memory))
      return(dicitem->defgraph);
    else NULL;
  }
}

is_parent(parent,child)
GRAPH	*parent,*child;
{
  G_CHAIN	*glist;

  for (glist=child->back;glist;glist=glist->next)
    if (parent==glist->node) return 1;
/*
  for (glist=child->back;glist;glist=glist->next)
    if (is_parent(parent,glist->node)) return 1;
*/
  return 0;
}
