#include "stdio.h"
#include "ctype.h"
#include "tachyon.h"
#include "sim.h"
#include "extern.h"
 
static   INST_BUF   *last_op[4];

graphana(grt,srt)
GRAPH   **grt,**srt;
{
  GRAPH   *tracept;

  for(tracept= *grt;tracept!=NULL;tracept=tracept->next){
#ifdef  DEBUG2
  printf(" GRAPHANA  IN  %s\n",tracept->inst);
#endif
    dispatch_calc(tracept);
    if(tracept->forward==NULL) calc(tracept);
  }
  sorting(grt,srt);
}

calc(g)
GRAPH  *g;
{
  G_CHAIN *bl;
  GRAPH		*p;

  if(g==NULL) return;
  for(bl=g->back;bl!=NULL;bl=bl->next)
    if((p=bl->node)!=NULL){ 
      p->priority=
        MAX(p->priority, g->priority+insttbl[p->inst_indx].time);
/*
      p->priority=
        MAX(p->priority, g->priority+1);
*/
    }
  for(bl=g->back;bl!=NULL;bl=bl->next) calc(bl->node);
}
 
sorting(grt,srt)
GRAPH   **grt,**srt;
{

  GRAPH	*p,*q,*minp,*ppre,*minppre,*qpre;

  for (;;){
    if((minp = *grt)==NULL) break; 
    minppre = NULL;
    for (qpre=minp,q=minp->next;q!=NULL;qpre=q,q=q->next){
      if (minp->priority > q->priority ||
	  minp->priority == q->priority && minp->dispatcht > q->dispatcht ||
	  minp->priority == q->priority && minp->dispatcht == q->dispatcht && minp->node_no > q->node_no){
	  minp = q;
	  minppre = qpre;
      } 
    }
    delete(minp,minppre,grt);
    ins_list(minp,srt);
  }
}

delete(q,qpre,p)
GRAPH	*q,*qpre,**p;
{
  if (qpre==NULL) *p = q->next;
  else qpre->next = q->next;
}

ins_list(q,p)
GRAPH	*q,**p;
{
  if (*p == NULL) q->next=NULL;
  else q->next = *p;
  *p = q;
}

schedule(srt,instl,lastcc)
GRAPH		*srt;
INST_BUF	**instl;
GRAPH		*lastcc;
{
  GRAPH     *g,*lastg;
  G_CHAIN   *gl,*fwdl;
  int		kind,k0,point;	
  INST_BUF	*tac_inst;

  for(lastg=NULL,g=srt;g!=NULL;lastg=g,g=g->next) insert(instl,g);

/*  BRANCH CONDITION */
  if (lastg && (lastg->instkind == IK_BRC || lastg->instkind == IK_BRCS) && lastcc!=NULL && (point=search(lastg->inst,"iccp.",SEARCH_LINE))>0){
    for(gl=lastg->back;gl!=NULL;gl=gl->next){
      if (gl->node == lastcc){
	if (gl->node){
	  tac_inst=gl->node->inst_bufp;
	  if (tac_inst->inst[1]==lastcc && tac_inst->inst[0] && (k0=tac_inst->inst[0]->instkind)!=IK_LDG && k0!=IK_LDF && k0!=IK_STG && k0!=IK_STF && k0!=IK_JMP && k0!=IK_MOV && k0!=IK_MULT ){
	    lastg->inst[point-1+3]='s';
	    break;
          }
        }
      }
    }
  }
/* 
    for(insert(instl,gl->node),fwdl=gl->node->forward;
        fwdl!=NULL;
        fwdl = fwdl->next) insert(instl,fwdl->node);
*/
}

int  tac_no=0;

insert(instl,g)
INST_BUF  **instl;
GRAPH     *g;
{
  INST_BUF  *p,*retp,*prep,*lastopr,*fndbkinst();
  GRAPH     *inst;
  G_CHAIN   *gl;
  int        i,n;
  char	 	*a4alloc();

#ifdef DEBUG2
  printf(" INSERT IN : %s\n",g->inst);
#endif

  if(g->inst_bufp != NULL) return;
/*lastopr=last_op[getoptype(insttbl[g->inst_indx].type)];*/
/*
  lastopr=fndbkinst(g);
  if (lastopr==NULL && (*instl)!=NULL) retp= *instl;
  else retp=lastopr;
  */
  prep=NULL; 
  retp= *instl;
  if (retp && (g->instkind == IK_CALL || g->instkind==IK_BRC || g->instkind==IK_BRCS || g->instkind==IK_JMP))
    for (;retp->next;retp=retp->next);
  for(gl=g->back;gl!=NULL;gl=gl->next){
    p=retp;
    for (;p!=NULL;p=p->next)
      if (((inst=gl->node)!=NULL)
           &&(inst==p->inst[0]||inst==p->inst[1]||inst==p->inst[2])){
/* STRONG */
        if (gl->kind <= ANTI_DEP+COND_DEP) retp=p;
        else {
	  prep=p;
	  retp=p->next;
        }
/*  WEAK? 
	prep=p;
	retp=p->next;
*/
        break; 
      }
  } 
  for(p=retp;p!=NULL;prep=p,p=p->next)
    if (i=avail(p,g,lastcond)) {
#ifdef DEBUG2
      printf(" AVAIL VAL= %d\n",i);
#endif
      p->inst[i-1]=g; 
      g->inst_bufp=p;
      after_proc(p,i-1,lastcond,last_op);
      return;
    }
#ifdef DEBUG2
  printf(" MAKE INST_BUF\n");
  printf(" GRAPH= %d\n",g->node_no);
#endif

  p=(INST_BUF *)a4alloc(sizeof(INST_BUF));
  p->frmt=0;
  p->inst_no= ++tac_no;
  p->next=NULL;
  p->inst[0]=p->inst[1]=p->inst[2]=NULL;
  p->inst[n=(g->operation)]=g;
  g->inst_bufp=p;
  after_proc(p,n,lastcond,last_op);
  if ((*instl)==NULL) *instl=p;
  else prep->next=p;
  return;
}

avail(p,g,lcnd)
INST_BUF  *p;
GRAPH     *g;
int       lcnd[];
{
  int   i,itype,optype[3],operation;
  int	opsize;

#ifdef DEBUG2
  printf(" AVAIL IN \n    g->node_no = %d\n    lcond=%d %d\n",
          g->node_no,lcnd[0],lcnd[1]);  
#endif

  itype=g->instkind;
  for(i=0;i<=2;i++)
    if(p->inst[i]==NULL)
      optype[i]=IK_NON;
    else if(p->inst[i]== &DUMMY_OPR){
      if(i==0) {
        printf(" ERROR st AVAIL() \n");
        exit(1);
      }
      optype[i]=p->inst[i-1]->instkind;
    }
    else
      optype[i]=p->inst[i]->instkind; 

  opsize = size_tbl[itype]; 
  if (((operation=g->operation)==0) &&
      (possible_pos[itype]&0x80)&&(p->inst[0]==NULL)&& 
      ((opsize==1)||(opsize==2  &&  p->inst[1]==NULL ) ||  
       (p->inst[1]==NULL && p->inst[2]==NULL)) &&
      (is_c12[itype][optype[1]]) && (is_c13[itype][optype[2]]))
    return(1); 

  if ((operation<=1) &&
      (possible_pos[itype]&0x40)&&(p->inst[1]==NULL) &&
      (is_c12[optype[0]][itype]) && (is_c23[itype][optype[2]]) &&
      ((opsize==1) || (p->inst[2]==NULL))){  
/*
    if (itype==IT_I || itype==IT_II) {
       if (lcnd[1]>p->inst_no) return(2);
    }
    else return(2);
*/
    return(2);
  }

  if ((operation<=2) &&
      (possible_pos[itype]&0x20)&&(p->inst[2]==NULL) &&
      (is_c13[optype[0]][itype]) && (is_c23[optype[1]][itype]))
    return(3); 

  return(0);  
}

#define     UNDEF    -1

noopt(g,irt)
GRAPH *g;
INST_BUF	**irt;
{
  INST_BUF   *ibuf,*lastinst;
  GRAPH      *p;
  char       *a4alloc();  

  for(p=g;p!=NULL;p=p->next){
    ibuf=(INST_BUF *)a4alloc(sizeof(INST_BUF));
    ibuf->frmt= UNDEF;
    ibuf->inst[0]=p;
    ibuf->inst[1]=ibuf->inst[2]=NULL;
    ibuf->next=NULL;
    if (*irt==NULL) *irt=ibuf;
    else lastinst->next=ibuf;
    lastinst=ibuf;
  }
}

#define MAXLASTPOS (MAX(MAX(lastpos[0],lastpos[1]),MAX(lastpos[2],lastpos[3])))

mkchart(iroot,opt)
INST_BUF  *iroot;
int        opt;
{
  INST_BUF  *ip;
  int       dispatch,i,paraf;
  
  for(dispatch=1,ip=iroot;ip!=NULL;ip=ip->next,dispatch++)
    for(i=0;i<=2;i++)
      if(ip->inst[i]!=NULL) takepos(ip->inst[i],dispatch,opt,parachk(ip,i));
} 

parachk(p,i)
INST_BUF    *p;
int          i;
{
  int   optype,ret;

  if (i==0) return(0);
  else {
    if ((optype=getoptype(insttbl[p->inst[i]->inst_indx].type))!=0 &&
         optype!=1) return(0);
    if (i>=1){ 
      if (p->inst[0]!=NULL && 
          ((optype=getoptype(insttbl[p->inst[0]->inst_indx].type))==0 ||
            optype==1)){
         if ((ret=p->inst[0]->dispatcht)==0) {
           printf(" INTERNAL ERROR. dispatch time is 0? \n");
           exit(1);
         }
         return(ret);
      }
    } 
    if (i>=2){ 
      if (p->inst[1]!=NULL && 
          ((optype=getoptype(insttbl[p->inst[1]->inst_indx].type))==0 || 
            optype==1)){
         if ((ret=p->inst[1]->dispatcht)==0) {
           printf(" INTERNAL ERROR. 2nd. op's dispatch time is 0? \n");
           exit(1);
         }
         return(ret);
      }
    } 
    return(0);
  }
}
 
takepos(g,dispatch,opt,paraf)
GRAPH    *g;
int      dispatch,opt,paraf;
{
  int  val,plusv,optype,lastpv,lastpp;
  GRAPH   *p;
  G_CHAIN *gl;
 
#ifdef DEBUG2
  printf(" ENTER TAKEPOS DISPATC=%d\n",dispatch);
  printf(" MAXLASTPOS=%d\n",MAXLASTPOS);
#endif
  if (g==NULL) return;
  optype=getoptype(insttbl[g->inst_indx].type);
  if (opt!=NOOPT) 
    switch(optype){
      case 0: /*  LOAD/STORE PIPE       */
      case 1: /*  INTEGER OPERATOR PIPE */
        if (paraf){
          lastpv=paraf;  
          lastpp=(lastpos[0]==paraf ?0:1);
        }
        else{
          lastpv=MAX(lastpos[0],lastpos[1]);  
          lastpp=(lastpos[0]>=lastpos[1] ?0:1);
        }
	if (g->inst_indx ==INDX_BRC)
	  lastpv=MAXLASTPOS;
        break;
      case 2:
#ifdef  UNIV
/*  UNIVERSAL OPERATOR Floating Add * 2  BEGIN */
        lastpv=MIN(lastpos[2],lastpos[3]);
        lastpp=(lastpos[2]<=lastpos[3] ?2:3);
        break;
/*  UNIVERSAL OPERATOR Floating Add * 2  END */
#endif
      default: 
        lastpv=lastpos[optype];
        lastpp=optype;
    } 
    else lastpp=optype;
  if (g->back==NULL)
    if (opt==NOOPT) val=MAX(MAXLASTPOS,dispatch);
    else            val=lastpv;
  else
    for(val=1,gl=g->back;gl!=NULL;gl=gl->next){
      if (gl->node==NULL) continue;
      else
        if (opt==NOOPT)
          val=imax4(val,MAXLASTPOS,
                    gl->node->dispatcht+insttbl[gl->node->inst_indx].time,
                    dispatch);
        else
          val=imax3(val,lastpv,
                    gl->node->dispatcht+insttbl[gl->node->inst_indx].time);
    }
  g->dispatcht=val;
  g->oprdpipe=lastpp;
  if(opt==NOOPT) plusv=insttbl[g->inst_indx].time;
  else           plusv=1;
  lastpos[lastpp]=val+plusv;
} 

after_proc(p,n,lcnd,lopr) 
INST_BUF   *p;
int         n, lcnd[];
INST_BUF   *lopr[];
{
  int  opindx,itype;
/*
  if ((opindx=p->inst[n]->inst_indx)==INDX_BRC ||
       opindx==INDX_JMP  || opindx==INDX_CALL) 
    lcnd[0] = lcnd[1] =MAXINT4;
  else if ((itype=insttbl[opindx].type)==IT_I ||
            itype==IT_II)
    lcnd[n]=p->inst_no;
  lopr[getoptype(insttbl[opindx].type)]=p;
*/
  if (n<=1 && size_tbl[p->inst[n]->instkind]==2){
    if (p->inst[n+1]!=NULL){
      printf("INTERNAL ERROR !! at AFTER_PROC\n");
      exit(1);
    }
    else p->inst[n+1]= &DUMMY_OPR;
  }
}

dispatch_calc(g)
GRAPH  *g;
{
  G_CHAIN *bl;
  int      ppos;
  GRAPH    *w_g;

  if(g==NULL) return;
  g->oprdpipe = getoptype(insttbl[g->inst_indx].type);
  ppos=0;
  if (g->back!=NULL)
    for(bl=g->back;bl!=NULL;bl=bl->next){
      w_g=bl->node;
      ppos=MAX(ppos,w_g->dispatcht+insttbl[w_g->inst_indx].time);
    }
  g->dispatcht=ppos;
}

INST_BUF   *fndbkinst(g)
GRAPH      *g;
{
  G_CHAIN     *gl;
  INST_BUF    *retp;

  if (g->back == NULL) return(NULL);
  else {
    retp = g->back->node->inst_bufp;
    for(gl=g->back->next;gl!=NULL;gl=gl->next){
#ifdef DEBUG2
    printf("retp tac_no is %d\n",retp->inst_no);
    printf("next tac_no is %d\n",retp->inst_no);
#endif
      if(retp->inst_no < gl->node->inst_bufp->inst_no)
        retp = gl->node->inst_bufp;
    }
    return(retp);
  }
}    
