#include  "stdio.h"
#include  "ctype.h"
#include  "string.h"
#include  "tachyon.h"
#include  "sim.h"
#include  "extern.h"

char      operand[MAXL]; 
static char	  Nullstr[]="                                        ";
char 	dispp[MAXL],basep[MAXL];	

mkgraph(sl,grt,lastcc)
ASMLIST    *sl;
GRAPH	   **grt;
GRAPH	   **lastcc;
{
  ASMLIST   *listp;
  GRAPH     *gp,*lgp,*glist;
  G_CHAIN   *addchain();
  char      *a4alloc(),*strsave(),*gets(),*nextt(),*p,c;
  long       i,j,indx,instcount,operation ;
  DICTIONARY *entry();

  for(instcount=0,listp=sl;listp!=NULL ;listp=listp->next){
#ifdef DEBUG1
    printf(" DEBUG1: LINE=%s\n",listp->line);
#endif
    pos=listp->line;
    if((*pos)=='!') /* COMMENT LINE */
      continue;
    if ((indx=getterm())==ASTERISC) /* COMMENT LINE */
      continue;
    if (indx==NAME){
      if((indx=getterm())==COLON){
        listp->kind=1;
        continue;
      }
      else {
        printf("ERROR: LABEL expected. indx=%d term=%s in %s\n"
                ,indx,term,listp->line);
        exit(1);
      }
    }
    else if (indx==PERIOD){
      listp->kind = 1;
      continue ;
    }
    else if (indx==SHARP){
      listp->kind = 1;
      continue ;
    }
    else if (indx==SLASH){
      listp->kind = 1;
      continue ;
    }
    else if (indx==COMMENT){
      listp->kind = 1;
      continue ;
    }
    else if (indx==LABEL){
      listp->kind = 1;
      continue ;
    }
    else if (indx==TYPE){
      listp->kind = 1;
      continue ;
    }
    else if (indx==INDX_NOP){
      continue;
    }
    else if (indx==ILLEGAL){ 
      printf(" ILLEGAL INSTRUCTION ?! INDX=%d\n",indx);
      exit(1);
    }
    else{
      for(operation=0;indx==AMPERSAND;indx=getterm(),operation++)
        listp->line[search(listp->line,"&",SEARCH_LINE)-1]=' ';
      if (indx>=INST_BEGIN && indx<=INST_END){
        gp=(GRAPH *)a4alloc(sizeof(GRAPH));
        gp->inst      = listp->line;
        gp->node_no   = listp->line_no;
	gp->priority  = 0;
        gp->dispatcht = 0;
        gp->inst_bufp = NULL;
        gp->back      = gp->forward = NULL;
        gp->next      = NULL; 
        gp->inst_indx = indx; 
        gp->instkind  = insttbl[indx].type; 
        gp->is_ccrenew= 0; 
        gp->operation = operation+oprtnpos(gp->instkind);
      }
      else{ 
        printf(" ILLEGAL INSTRUCTION ?! INDX=%d\n",indx);
        exit(1);
      }
    }

/* operand analysis */
#ifdef DEBUG1 
    printf("insttbl[%d].num_of_op=%d\n",indx,insttbl[indx].num_of_op);
#endif

    switch(gp->instkind){
      case IK_STG:
      case IK_STGL:
      /*  OPERAND 1 */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END)
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
      /*  OPERAND 2 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	  strcpy(basep,term);
        }
	else if (symkind == NAME){ 
	  gp->instkind = IK_STGL;
	  gp->operation = oprtnpos(IK_STGL);    
	  strcpy(basep,"gr0");
	  strcpy(dispp,term);
	  strcpy(operand,basep);
	  strcat(operand,dispp);
	  dicroot = entry(dicroot,gp,operand,basep,dispp,DEF);
	  break;
	}
      /*  OPERAND 3 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	}
	else if(symkind == NUMBER){
	  gp->instkind = IK_STGL;
	  gp->operation = oprtnpos(IK_STGL);    
	}
	else if(symkind == NAME){
	  gp->instkind = IK_STGL;
	  gp->operation = oprtnpos(IK_STGL);
	}
	strcpy(dispp,term);

        strcpy(operand,basep);
	strcat(operand,dispp);
	dicroot = entry(dicroot,gp,operand,basep,dispp,DEF);
	break;
      case IK_STF:
      case IK_STFL:
      /*  OPERAND 1 */
        if ((symkind=getterm())>=FREG_BEGIN && symkind<=FREG_END)
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
      /*  OPERAND 2 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	  strcpy(basep,term);
        }
	else if (symkind == NAME){ 
	  gp->instkind = IK_STFL;
	  gp->operation = oprtnpos(IK_STFL);    
	  strcpy(basep,"gr0");
	  strcpy(dispp,term);
	  strcpy(operand,basep);
	  strcat(operand,dispp);
	  dicroot = entry(dicroot,gp,operand,basep,dispp,DEF);
	  break;
	}
      /*  OPERAND 3 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	}
	else if(symkind == NUMBER){
	  gp->instkind = IK_STFL;
	  gp->operation = oprtnpos(IK_STFL);    
	}
	else if(symkind == NAME){
	  gp->instkind = IK_STFL;
	  gp->operation = oprtnpos(IK_STFL);
	}
	strcpy(dispp,term);

        strcpy(operand,basep);
	strcat(operand,dispp);
	dicroot = entry(dicroot,gp,operand,basep,dispp,DEF);
	break;
      case IK_LDG:
      case IK_LDGL:
      /*  OPERAND 1 */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	  strcpy(basep,term);
        }
	else if(symkind == NAME){
	  gp->instkind = IK_LDGL;
	  gp->operation = oprtnpos(IK_LDGL);    
	  strcpy(basep,"gr0");
	  strcpy(dispp,term);

	  strcpy(operand,basep);
	  strcat(operand,dispp);
	  dicroot = entry(dicroot,gp,operand,basep,dispp,REF);

	  symkind = getterm(); /* skip COMMA */
          if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END)
	    dicroot = entry(dicroot,gp,term,NULL,NULL,DEF);
	  break;
	}
      /*  OPERAND 2 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	    dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	}
	else if(symkind == NUMBER){
	  gp->instkind = IK_LDGL;
	  gp->operation = oprtnpos(IK_LDGL);
	}
	else if(symkind == NAME){
	  gp->instkind = IK_LDGL;
	  gp->operation = oprtnpos(IK_LDGL);
	}
	strcpy(dispp,term);

        strcpy(operand,basep);
	strcat(operand,dispp);
	dicroot = entry(dicroot,gp,operand,basep,dispp,REF);
      /*  OPERAND 3 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,DEF);
	  if (indx==INDX_LD_L){
	    strcpy(term,nextt(term));
	    dicroot = entry(dicroot,gp,term,NULL,NULL,DEF);
          }
        }
	break; 
      case IK_LDF:
      case IK_LDFL:
      /*  OPERAND 1 */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	  strcpy(basep,term);
        }
	else if(symkind == NAME){
	  gp->instkind = IK_LDFL;
	  gp->operation = oprtnpos(IK_LDFL);    
	  strcpy(basep,"gr0");
	  strcpy(dispp,term);

	  strcpy(operand,basep);
	  strcat(operand,dispp);
	  dicroot = entry(dicroot,gp,operand,basep,dispp,REF);

	  symkind = getterm(); /* skip COMMA */
          if ((symkind=getterm())>=FREG_BEGIN && symkind<=FREG_END)
	    dicroot = entry(dicroot,gp,term,NULL,NULL,DEF);
	  break;
	}
      /*  OPERAND 2 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=GREG_BEGIN && symkind<=GREG_END){
	    dicroot = entry(dicroot,gp,term,NULL,NULL,REF);
	}
	else if(symkind == NUMBER){
	  gp->instkind = IK_LDFL;
	  gp->operation = oprtnpos(IK_LDFL);
	}
	else if(symkind == NAME){
	  gp->instkind = IK_LDFL;
	  gp->operation = oprtnpos(IK_LDFL);
	}
	strcpy(dispp,term);

        strcpy(operand,basep);
	strcat(operand,dispp);
	dicroot = entry(dicroot,gp,operand,basep,dispp,REF);
      /*  OPERAND 3 */
	symkind = getterm(); /* skip COMMA */
        if ((symkind=getterm())>=FREG_BEGIN && symkind<=FREG_END){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,DEF);
	  if (indx==INDX_LD_PD || indx==INDX_LD_PF){
	    strcpy(term,nextt(term));
	    dicroot = entry(dicroot,gp,term,NULL,NULL,DEF);
          }
        }
	break; 
      case IK_BRC:
      case IK_BRCS:
/*
	for(glist = *grt;glist!=NULL;glist=glist->next){
	  gp->back = addchain(gp->back,glist,BRANCH_DEP);
	  glist->forward = addchain(glist->forward,gp,BRANCH_DEP);
        }
*/	
        gp->priority -= 5;
        if ((symkind=getterm())!=TRUE){
          if (*lastcc){
            (*lastcc)->forward = addchain((*lastcc)->forward,gp,BRANCH_DEP);
            gp->back = addchain(gp->back,*lastcc,BRANCH_DEP);
          }
	}
        break;
      case IK_CALL:
      case IK_JMP:
        gp->priority -= 5;
        symkind=getterm();
        dicroot = entry(dicroot,gp,term,NULL,NULL,DEF);
	break;
      case IK_MULT:
      case IK_LC:
	if(gp->instkind==IK_LC){ 
	  gp->is_ccrenew = 1;
	  if (*lastcc){
	    (*lastcc)->forward = addchain((*lastcc)->forward,gp,COND_DEP);
	    gp->back = addchain(gp->back,*lastcc,COND_DEP);
          }
	  *lastcc = gp;
	}
        for(symkind=getterm(),i=1;i<=insttbl[indx].num_of_op;i++){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,i==insttbl[indx].num_of_op);
	  if (i==2 && symkind==NUMBER){
	    gp->instkind ++;
	    gp->operation = oprtnpos(gp->instkind);
          }
          if ((symkind=getterm()) == COMMA) symkind=getterm();
        }
	break; 
       case IK_MVLD:
	  for(symkind=getterm(),i=1;i<=insttbl[indx].num_of_op;i++){
	    dicroot = entry(dicroot,gp,term,NULL,NULL,i==insttbl[indx].num_of_op);
  	    if (i==1) {
	      strcpy(term,nextt(term));
    	      dicroot = entry(dicroot,gp,term,NULL,NULL,i==insttbl[indx].num_of_op);
	    }
	    if ((symkind=getterm()) == COMMA) symkind=getterm();
	  }
	  break;
       case IK_MVDL:
	  for(symkind=getterm(),i=1;i<=insttbl[indx].num_of_op;i++){
	    dicroot = entry(dicroot,gp,term,NULL,NULL,i==insttbl[indx].num_of_op);
	    if (i==2) {
	      strcpy(term,nextt(term));
	      dicroot = entry(dicroot,gp,term,NULL,NULL,i==insttbl[indx].num_of_op);
	    }
	    if ((symkind=getterm()) == COMMA) symkind=getterm();
	  }
	break;
      case IK_IC:
      case IK_ICL:
        for(symkind=getterm(),i=1;i<=insttbl[indx].num_of_op;i++){
          dicroot = entry(dicroot,gp,term,NULL,NULL,i==insttbl[indx].num_of_op);
          if ((symkind=getterm()) == COMMA) symkind=getterm();
        }
	gp->is_ccrenew = 1;
	if (*lastcc){
          (*lastcc)->forward = addchain((*lastcc)->forward,gp,COND_DEP);
          gp->back = addchain(gp->back,*lastcc,COND_DEP);
        }
        *lastcc = gp;
        break;
      default: 
        for(symkind=getterm(),i=1;i<=insttbl[indx].num_of_op;i++){
	  dicroot = entry(dicroot,gp,term,NULL,NULL,i==insttbl[indx].num_of_op);
          if ((symkind=getterm()) == COMMA) symkind=getterm();
        }
	if (gp->instkind == IK_SFT || strncmp(insttbl[indx].mnemonic,"fcmp",4)==0 || strncmp(insttbl[indx].mnemonic,"cs",2)==0){ /* RENEW Condition Code  */ 
	  gp->is_ccrenew = 1;
	  if (*lastcc){
	    (*lastcc)->forward = addchain((*lastcc)->forward,gp,COND_DEP);
	    gp->back = addchain(gp->back,*lastcc,COND_DEP);
          }
	  *lastcc = gp;
        }
        break;
    }
    if ((*grt)==NULL) {
      *grt =gp;
      lgp  =gp;
    }
    else{
      lgp->next = gp;
      lgp=gp;
    }
    if (!schedf){
      j=fhash(instcount);
      HT[j]=addchain(HT[j],gp,NORELATION);
    }
  }
} 

char *strsave(s)
char *s;
{
  char  *p,*a4alloc();

  if (s==NULL) return(NULL);
  if((p=a4alloc(strlen(s)+1)) != NULL) strcpy(p,s);
  return(p);
}

G_CHAIN   *addchain(l,g,depkind)
G_CHAIN   *l;
GRAPH     *g;
int	  depkind;
{
  char    *a4alloc();

  if (g==NULL) return(l); 
  if (l==NULL) {
    l=(G_CHAIN *)a4alloc(sizeof(G_CHAIN));
    l->node=g;
    l->kind=depkind;
    l->next=NULL;
  }
  else 
    if(l->node==NULL) l->node=g; 
    else if(l->node==g){
      l->kind = l->kind | depkind ; 
    }
    else l->next=addchain(l->next,g,depkind);
  return(l);
} 

G_CHAIN   *delchain(rt,l)
G_CHAIN   *rt,*l;
{
  G_CHAIN *p,*prev;
  
  for (prev=NULL,p=rt;p!=NULL && p!=l ;prev=p, p=p->next);
  if (p==l){
    if (p==rt) return p->next;
    else {
      prev->next = p->next;
      return rt;
    }
  }
  else return rt;
}    

fhash(i)
int   i;
{
  return(mod(i,HASHSIZE));
}

mod(x,y)
int x,y;
{
  int ret;

  return(x-(x/y)*y);
}
  
readinstf(fp,irt)
FILE     *fp;
INST_BUF	**irt;
{
  INST_BUF   *ibuf,*libuf;
  int         kind,i;
  GRAPH      *findgraph();
  char       *a4alloc();
  
  for(;fgets(line,MAXL,fp)!=0;){
    pos=line;
    ibuf=(INST_BUF *)a4alloc(sizeof(INST_BUF));
    ibuf->frmt=0;
    ibuf->next=NULL;
    for(i=0,kind=getterm();kind==NUMBER && i<=2;i++){
      if (symnumber!=0)
        ibuf->inst[i]=findgraph(symnumber);
      else ibuf->inst[i]=NULL; 
      if ((kind=getterm())==COMMA) kind=getterm(); 
    }
    if (*irt==NULL){
      *irt =ibuf;
      libuf   =ibuf;
    }
    else {
      libuf->next=ibuf;
      libuf      =ibuf;
    }
  }
}

GRAPH   *findgraph(inum)
int      inum;
{
  G_CHAIN   *gl;

  for (gl=HT[fhash(inum)];gl!=NULL;gl=gl->next)
    if (gl->node != NULL)
      if (gl->node->node_no == inum) return(gl->node);
      else continue;
    else return(NULL); 
}      
 
static char   nextreg[6];
char   *nextt(s)
char   *s;
{
  int   i,v;
  char  *p;

  for (i=0,p=s;isdigit(*p)==0;p++,i++)
    nextreg[i]= *p;
  v=atoi(p);
  v++;

#ifdef DEBUG1
  printf(" IN NEXTT . v= %d\n",v);
#endif 
  
  if (v>=10){
    nextreg[i++]= (v / 10) + '0';
    v = v-(v/10)*10;
  } 
  nextreg[i++]= v + '0';
  nextreg[i]='\0';
#ifdef DEBUG1
  printf(" IN NEXTT . nextreg= %s\n",nextreg);
#endif 
  return (nextreg);
}
