#include     "stdio.h"
#include     "ctype.h"
#include     "string.h"
#include     "tachyon.h"
#include     "sim.h"
#include     "extern.h"

prtgraph(rt)
GRAPH	*rt;
{
/*   for  DEBUG  */  
  GRAPH   *p;
  G_CHAIN *l;

  if (rt==NULL) return;
  printf("--< DATA DEPENDENT GRAPH >--\n");
  for(p=rt;p!=NULL;p=p->next){
    printf("==============================================\n");
    printf("%5d : %s\n",p->node_no,p->inst);
    printf("    INST_INDX=%d\n",p->inst_indx);
    printf("    PRIORITY=%d\n",p->priority);
    printf("    DISPATCH TIME=%d\n\n",p->dispatcht);
    printf("    OPERATION=%d\n",p->operation);
    printf("    BACK CHAIN:\n");
    for(l=p->back;l!=NULL;l=l->next)
      printf("     < %4d >  DEP kind= %d\n",l->node->node_no,l->kind);
    putchar('\n');
    printf("    FORWARD CHAIN:\n");
    for(l=p->forward;l!=NULL;l=l->next)
      printf("     < %4d >  DEP kind= %d\n",l->node->node_no,l->kind);
    putchar('\n');
  } 
  printf("==============================================\n");
}

sortprt(srt)
GRAPH  	*srt;
{
  GRAPH   *l;

  if (srt==NULL) return;
  printf(" --<  SORTING LIST  >--\n\n");
  for(l=srt;l!=NULL;l=l->next){
    printf("  < %4d > :%4d\n",l->node_no,l->priority);
  }
}

#define   NUM_OF_INST  2
printinst(irt)
INST_BUF	*irt;
{
  INST_BUF   *p;
  int        i,buf[3];

  if(irt==NULL) return;
  printf(" --< TaChyon Instruction >--\n\n");
  for(p=irt;p!=NULL;p=p->next){
    for(i=0;i<=NUM_OF_INST;i++)
      if (p->inst[i]==NULL)  buf[i]=0;
      else buf[i]=p->inst[i]->node_no;
    printf("[ %4d | %4d | %4d | %4d ]\n",0,buf[0],buf[1],buf[2]);
  }
  printf(" -------------------------------------------\n\n");
} 

#define MAXLASTPOS  (MAX(MAX(lastpos[0],lastpos[1]),MAX(lastpos[2],lastpos[3])))
printchart(irt,srt)
INST_BUF	*irt;
GRAPH		*srt;
{
  int     *chrt[5];
  int     i,j,max,optype,itype;
  char    *malloc();
  GRAPH	  *gl;
  
  if (irt==NULL) return;
  max=MAXLASTPOS;
  for(i=0;i<=4;i++)
    chrt[i]=(int *)malloc(max*sizeof(int));
  for(i=0;i<=4;i++)
    for(j=0;j<=max-1;j++) chrt[i][j]=0; 
  for(gl=srt;gl!=NULL;gl=gl->next){
    chrt[gl->oprdpipe][gl->dispatcht]=gl->node_no;
  }
  printf("\n --< Timing Chart >--\n");
  printf(" Time | LS/I | LS/I | FADD | FMUL | OTHERS \n");
  printf(" ------------------------------------------\n");
  for(j=1;j<=max-1;j++) 
    printf(" %4d | %4d | %4d | %4d | %4d | %6d \n",j,
           chrt[0][j],chrt[1][j],chrt[2][j],chrt[3][j],chrt[4][j]);
  printf(" ------------------------------------------\n\n");
}

prtinput(grt)
GRAPH	*grt;
{
  GRAPH   *g;
  int     i;

  if(grt==NULL) return;
  printf(" --<Input Instruction>--\n");
  for(i=1,g=grt;g!=NULL;g=g->next,i++)
    printf("%4d:%s",i,g->inst);
  printf(" -------------------------------------\n\n");
}    

prasmlst(sl)
ASMLIST  *sl;
{
  ASMLIST   *p;
  for(p=sl;p!=NULL;p=p->next){
    printf("%3d %s",p->line_no,p->line);
  }
  putchar('\n');
}

char      buf[MAXL]; 
pure_tac(irt)
INST_BUF	*irt;
{
  INST_BUF   *p;
  int         i,j;
  char         k1,k2;

  if(irt==NULL) return;
  for(p=irt;p!=NULL;p=p->next){
    if ((p->inst[1]&&((k2=p->inst[1]->instkind)==IK_ICL||k2==IK_LCL))&&((p->inst[0]==NULL)||(k1=p->inst[0]->instkind)==IK_LDG||k1==IK_LDF||k1==IK_STG||k1==IK_STF||k1==IK_JMP||k1==IK_MOV||k1==IK_MVLD||k1==IK_MVDL||k1==IK_MULT)){ /* Type 8 */
      p->inst[1]->inst[strlen(p->inst[1]->inst)-1]='\0'; 
      printf("%s",p->inst[1]->inst); 
      if (p->inst[0]!=NULL){
        printf(" & ");
        printf("%s",p->inst[0]->inst); 
      }
    }
    else{
      for(i=0;i<=NUM_OF_INST;i++)
        if (p->inst[i]!=NULL && p->inst[i]!= &DUMMY_OPR){
          if (i>=1) printf(" & ");
          else printf("   "); 
          p->inst[i]->inst[strlen(p->inst[i]->inst)-1]='\0'; 
          printf("%s",p->inst[i]->inst); 
        }
    }
    printf("\n");
  }
} 

prt_pesudo(al)
ASMLIST   *al;
{
  ASMLIST   *p;

  for(p=al;al!=NULL && al->kind!=0;al=al->next)
    printf("%s",al->line);
}
