#include    <string.h>
#include    <stdio.h>
#include    <ctype.h>

#include    "tachyon.h"
#include    "sim.h"
#include    "extern.h"

#define 	LIMIT_NUM  25

char       line[MAXL],term[MAXL];
char       *pos; 
int        symkind;
int        symnumber=0,schedf;
int        lastpos[5]={1,1,1,1,1};
int        lastcond[2]={MAXINT4,MAXINT4};
GRAPH      *root=NULL;
GRAPH      *Last_cc = NULL;
GRAPH	    *sortroot=NULL;
G_CHAIN    *HT[HASHSIZE]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
INST_BUF   *instroot=NULL;
DICTIONARY dicbody;
DICTIONARY *dicroot=&dicbody;

#ifdef   UNIV
#include   "iset_univ.h"
#else
#include   "inst_set.h"
#endif

int        graphprtf=0;
ASMLIST    *source=NULL;
int        src_option=0;
int        time_option=0;
int        path_option=0;
int        optimize   =1;
/*
GRAPH      DUMMY_OPR={{"DUMMY"},{-1},{0},{0},{0},{0},{0},
                       {NULL},{NULL},{NULL},{NULL}};
*/
GRAPH      DUMMY_OPR ;
char      *DUMMY_STR="DUMMY" ; 
 
main(argc,argv)
int  argc;
char *argv[];
{
  int  i,blockf,count;
  char  *lastf,*fgets();
  FILE *inputfp,*instfp;
  G_CHAIN  *gl;
  ASMLIST  *mkasmlist(),*lastsrc; 

  DUMMY_OPR.inst= DUMMY_STR;
  DUMMY_OPR.node_no = -1;
  DUMMY_OPR.inst_indx = 
  DUMMY_OPR.instkind  = 
  DUMMY_OPR.dispatcht = 
  DUMMY_OPR.oprdpipe  = 
  DUMMY_OPR.operation = 
  DUMMY_OPR.priority  = 0;
  DUMMY_OPR.inst_bufp = NULL;
  DUMMY_OPR.forward   = 
  DUMMY_OPR.back      = NULL; 
  DUMMY_OPR.next      = NULL;

  option_ana(argc,argv,&inputfp,&instfp,&optimize);

  if (instfp==NULL) schedf=1;
  else              schedf=0;

  if (fgets(line,MAXL,inputfp)==NULL){
    printf("ERROR: file is empty.\n");
    exit(1);
  }
  do{
    init(); 
    count=0;
    do{
      blockf=0;
      count++;
      if (source==NULL)
        source = (lastsrc = mkasmlist(line,&blockf,count));
      else
        lastsrc = (lastsrc->next = mkasmlist(line,&blockf,count)); 
    } while((lastf=fgets(line,MAXL,inputfp))!=NULL && blockf==0 && islabel(line)==0 && count<=LIMIT_NUM);  
    
    simulate(source,&root,&sortroot,&instroot);

/*
    freeall(); 
*/
  } while(lastf!=NULL);
    return(0);
}

islabel(s)
char   *s;
{
  int ret;
  char *p;

  for(p=s;*p==' ' || *p=='\t' ;p++);
  if (*p=='.'||*p=='!' ||*p=='/' || *p=='*' || *p=='#' ||*p=='\n' || *p=='@') ret=1; /* COMMENT LINE */ 
  else ret=search(s,":",SEARCH_LINE);

#ifdef DEBUG3
  printf(" ISLABEL RETURN is %d\n",ret);
#endif

  return(ret);

}

init()
{
  int i;

  for(i=0;i<=4;i++) lastpos[i]=1;
  lastcond[0]=MAXINT4;
  lastcond[1]=MAXINT4;
  root=NULL;
  instroot=NULL;
  dic_clr(&dicbody);
  dicroot = &dicbody;
  sortroot=NULL;
  source=NULL;
  Last_cc = NULL; 
}

freeall()
{
  GRAPH  *rp,*rpnext;
  INST_BUF *ip,*ipnext;
  G_CHAIN *gcp,*gcpnext;  
  ASMLIST  *srcp,*srcpnext; 

  for (rp=root;rp!=NULL;rp=rpnext){
    for(gcp=rp->forward;gcp!=NULL;gcp=gcpnext){
      gcpnext=gcp->next;
      free(gcp);
    }
    for(gcp=rp->back;gcp!=NULL;gcp=gcpnext){
      gcpnext=gcp->next;
      free(gcp);
    }
    rpnext=rp->next;
    free(rp);
  } 
  for (ip=instroot;ip!=NULL;ip=ipnext){
    ipnext=ip->next;
    free(ip);
  }
  for( srcp=source;srcp!=NULL;srcp=srcpnext){
    srcpnext=srcp->next;
    free(srcp);
  }  
}

ASMLIST   *mkasmlist(l,flag,c)
char      *l;
int       *flag,c;
{
  char      *strsave(),*a4alloc(),*p;
  ASMLIST   *list;

#ifdef DEBUG3
  printf("DEBUG:  mkasmlist in line is= %s\n",l);
#endif

  list=(ASMLIST  *)a4alloc(sizeof(ASMLIST));
  list->line=strsave(l);
  list->line_no=c;
  for (p=l;*p!='\0' && *p!='\n';p++) if (*p!=' ' && *p!='\t') break; 
  if (*p=='.' || *p=='!'|| *p=='/' || *p=='#') list->kind = 1; 
  else list->kind=0; 
  list->next=NULL; 
  if (search(l,"brc",SEARCH_WORD)!=0 || search(l,"call",SEARCH_WORD) || search(l,"brnc",SEARCH_WORD)!=0|| search(l,"jmp",SEARCH_WORD)!=0 || search(l,"brcs",SEARCH_WORD)!=0 || search(l,"brncs",SEARCH_WORD)!=0)
     *flag=1;
  return(list);
}

search(s1,s2,mode)
char   *s1;
char   *s2;
int	mode;
{
  int  i,j;
  int  len,srchmx;
  char c;

#ifdef DEBUG3
  printf("SEARCH in s1: %d  =  %s\n",strlen(s1),s1); 
  printf("          s2: %d  =  %s\n",strlen(s2),s2); 
#endif

  srchmx=strlen(s1);
  len=strlen(s2); 
  for(i=0;i<srchmx ;i++) 
    if(strncmp(s1+i,s2,len)==0){
      if (mode==SEARCH_LINE) return(i+1);
      else if((c = *(s1+i+len))==' '||c=='\t'||c=='\0'||c=='\n') return(i+1);
    }
  return(0);
} 
        
simulate(sl,grt,srt,tacl)
ASMLIST  *sl;
GRAPH	 **grt,**srt;
INST_BUF **tacl;
{
  int  i;
  G_CHAIN  *gl;

#ifdef DEBUG3 
  printf("DEBUG : simulate in.\n");
#endif

  if (src_option) prasmlst(sl);

#ifdef DEBUG3 
  printf("DEBUG : mkgraph  in.\n");
#endif

  mkgraph(sl,grt,&Last_cc);
 
  if(graphprtf){
     prtgraph(*grt);
     sortprt(*srt); 
  }

#ifdef DEBUG3
  printf("SCHEDULEF=%d\n",schedf);
  for(i=0;i<=9;i++)
    if(HT[i]!=NULL)
      for(gl=HT[i];gl!=NULL;gl=gl->next)
        if(gl->node!=NULL)
          printf("DEBUG  HT %d\n",gl->node->node_no);
#endif

  graphana(grt,srt);

/*
  if (instfp!=NULL) 
    readinstf(instfp,tacl);
  else{
*/
    if(optimize>0)
      schedule(*srt,tacl,Last_cc);
    else
      noopt(grt,tacl); 

/*
  }
  prtinput(*grt);
*/
  prt_pesudo(sl); 
  pure_tac(*tacl);  
/*
  printinst(*tacl);
*/
  if (time_option){
    mkchart(*tacl,optimize);
    printchart(*tacl,*srt);
  }
  if (path_option && (*srt) !=NULL){
    printf("\n============= LONGEST PATH ===============\n");
    printf(" Longest Path = %d\n",sortroot->priority);
    printf("===========================================\n");
  }
  if(graphprtf){
     prtgraph(*grt);
     sortprt(*srt); 
  }
}
 
char   fname[MAXL];
option_ana(c,v,ifp,instfp,opt)
int      c;
char    *v[];
FILE    **ifp;
FILE    **instfp;
int     *opt;
{
  int   i,ifpf,instfpf;
  FILE  *fopen();
#ifdef DEBUG3
  printf(" ENTER: OPTION_ANA\n");
  printf("      ARGC=%d\n",c);
  for (i=0;i<c;i++)
    printf("      ARGV[%d]=%s\n",i,v[i]);
#endif

  *opt=1;
  ifpf=instfpf=0;
 
  if (c==1);
  else{
    for(i=1;i<c;i++){
      if (strncmp(v[i],"-ta",3)==0 || strncmp(v[i],"-TA",3)==0){
        getname(fname,v[i]+3);
        if (((*instfp)=fopen(fname,"r"))==NULL){
          printf(" OPEN ERROR INSTRUCTION FILE name= %s\n",fname);
          exit(1);
        }
        else instfpf=1;
      }
      else if (strncmp(v[i],"-in",3)==0 || strncmp(v[i],"-IN",3)==0){
        getname(fname,v[i]+3);
        if (((*ifp)=fopen(fname,"r"))==NULL){
          printf(" OPEN ERROR INPUT FILE name= %s\n",fname);
          exit(1);
        }
        else ifpf=1;
      }
      else if (strncmp(v[i],"-opt",4)==0 || strncmp(v[i],"-OPT",4)==0){
        getname(fname,v[i]+4); 
        *opt = *fname - '0';
      }
      else if (strncmp(v[i],"-g",2)==0 || strncmp(v[i],"-G",2)==0){
        graphprtf=1;
      }
      else if (strncmp(v[i],"-s",2)==0 || strncmp(v[i],"-S",2)==0){
        src_option=1;
      }
      else if (strncmp(v[i],"-t",2)==0 || strncmp(v[i],"-T",2)==0){
        time_option=1;
      }
      else if (strncmp(v[i],"-c",2)==0 || strncmp(v[i],"-C",2)==0){
        path_option=1;
      }
      else {
        printf(" ILLEGAL OPTIONS OPTION=%s\n",v[i]);
        exit(1);
      }
    }
  }
  if (!ifpf)    (*ifp)=stdin;
  if (!instfpf) (*instfp)=NULL;
}

getname(s1,s2)
char  *s1,*s2;
{
  char  c;
  int   i;

  for (;*s2 == ' ';s2++);
  if (*s2 == '\n') {
    printf(" GETNAME ERROR \n");
    exit(1);
  }
  strncpy(s1,s2,i=strlen(s2));
  s1[i]='\0';
#ifdef DEBUG3
  printf(" GETNAME=%s\n",s1);
#endif
}

dic_clr(dic)
DICTIONARY	*dic;
{
  int i;
  G_CHAIN	*g_list_free();
  DATA_DIC	*data_dic_free();

  for(i=0;i<1664;i++){
    dic->regtbl[i].defgraph = NULL;
    dic->regtbl[i].reflist  = g_list_free(dic->regtbl[i].reflist);
  }
  dic->memory = data_dic_free(dic->memory);
}

G_CHAIN		*g_list_free(gl)
G_CHAIN		*gl;
{
  return NULL;
}

DATA_DIC	*data_dic_free(d)
DATA_DIC	*d;
{
  return NULL;
}
