/* This is a header file.                                                */
/* "tachyon.h":Archetecture define file have to be included before this. */  


typedef struct  asmlist{
  int    kind;
  int    line_no;
  char   *line;
  struct asmlist *next;
}ASMLIST;

typedef struct  g_chain{
  struct graph *node;
  struct g_chain *next;
  int		kind;
}G_CHAIN;

typedef struct graph {
  char  *inst;
  unsigned char  inst_indx;    	/*  insttable index */
  char  instkind;
  char  operation;    		/*  operation no.  0,1,2 */
  char  is_ccrenew;
  int   node_no;
  int   dispatcht;    		/*  instruction dispatch time */ 
  int   oprdpipe;     		/*  instruction pipe */ 
  int   priority;
  struct inst_buf *inst_bufp; 	/*  output instruction buffer pointer */
  struct g_chain  *forward;
  struct g_chain  *back;
  struct graph    *next;
}GRAPH; 

typedef  struct data_d{
  char              *name,*base,*indx;
  int               kind;
  GRAPH             *defgraph,*basedef,*indxdef; 
  G_CHAIN           *reflist;
  struct data_d     *left,*right,*next;
}DATA_DIC;

typedef  struct reg_d{
  GRAPH		*defgraph;
  G_CHAIN	*reflist;
  int   	contentkind;
}REG_DIC;

typedef  struct dictionary{
  struct reg_d  regtbl[1664];
  struct data_d	*memory;
}DICTIONARY;


#define   NAME      1700+INST_END
#define   NUMBER    1701+INST_END
#define   LPAREN    1702+INST_END
#define   RPAREN    1703+INST_END
#define   COMMA     1704+INST_END
#define   SEMICOLON 1705+INST_END  
#define   COLON     1706+INST_END  
#define   PERIOD    1707+INST_END  
#define   SHARP     1708+INST_END  
#define   SLASH     1709+INST_END  
#define   AMPERSAND 1710+INST_END  
#define   ASTERISC  1711+INST_END  
#define   COMMENT   1712+INST_END  
#define   LABEL     1713+INST_END  
#define   TYPE      1714+INST_END  
#define   TRUE      1715+INST_END  
#define   EOL       0
#define   ILLEGAL   -1

#define   MAXL      1024

#define   NOOPT     0
#define   OPT       1 

#define   SCHEDULE  1

#define   HASHSIZE  10

#define   MAX(x,y)  ((x)>(y)?(x):(y))
#define   MIN(x,y)  ((x)<(y)?(x):(y))
 
#define   MAXINT4  0x7fffffff

#define   DEF	1
#define   REF	0

#define	  NORELATION 	0
#define   COND_DEP	1
#define	  ANTI_DEP	2 
#define   DEPENDENCE	4
#define   MEMORY_DEP	8
#define   BRANCH_DEP	16

#define	  SEARCH_LINE  	0
#define   SEARCH_WORD	1
