static char SccsId[] = "@(#)xc.c	1.6    11/27/90";

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>

struct a_out {
	short a_info, magic;
	unsigned text_length;
	unsigned data_length;
	unsigned bss_length;
	unsigned symbol_length;
	unsigned start_address;
	unsigned text_reloc;
	unsigned data_reloc;
} a_out;

#define MAGIC_H 0x00c8
#define MAGIC_L 0x0107

main(argc, argv)
        int argc;
        char *argv[];
{
  int fd,fd2,touch=0;
  char *i;
  char buf[81];
 
  switch (argc) {
  case 2: 
    for (; --argc>0;){
      if ((fd = open(argv[1], O_RDONLY)) < 0){
        fprintf(stderr, "can't open %s \n",argv[1]);
          exit(1);
      }
      for (i=argv[1]; *i && *i != '.'; i++) {
	if (*i >= 'a' && *i <= 'z') {
          touch = 1;
          *i -= 'a' - 'A';
        }
      }
      if (!touch) {
        fprintf(stderr,"file name must include lower case\n");
        exit(1); 
      }
      /* if (i - argv[1] != 6) {
        fprintf(stderr,"file name must be XXXXXX.*\n");
        exit(1); 
      } */
      *i = NULL; 		
      /* create filename */
      unlink(argv[1]);
      if ((fd2 = open(argv[1], O_CREAT, 0755)) < 0){
        fprintf(stderr, "can't create %s \n",argv[1]);
        exit(1);
      }
      close(fd2);
      if ((fd2 = open(argv[1], O_WRONLY)) < 0){
        fprintf(stderr, "can't write on %s \n",argv[1]);
        exit(1);
      }
      if(read(fd, (char *) &a_out, sizeof a_out) == 0) {
        fprintf(stderr,"unexpected EOF\n");
        exit(1); 
      }
      /* check magicnumber */
      if(a_out.a_info != MAGIC_H || a_out.magic != MAGIC_L) {
        fprintf(stderr,"magicnumber error \n");
        exit(1); 
      }
      card(fd, fd2, a_out.start_address, a_out.text_length);
      card(fd, fd2, a_out.start_address, a_out.data_length);
      card(NULL, fd2, a_out.start_address, (a_out.text_length+a_out.data_length) % 16);
      sprintf(buf,"       END                                                                      ");
      atoe(buf);
      write(fd2, buf, 80);
      sprintf(buf,"/*                                                                              ");
      atoe(buf);
      write(fd2, buf, 80);
      close(fd2);
      close(fd);
    }
    break;
  default:
    fprintf(stderr, "Usage: xc <file>\n");
    exit(1);
  }
  printf("%s\n", argv[1]);
  exit(0);
}

card(fd,fd2,start_address,length)
  int fd,fd2;
  unsigned start_address,length;
{
  static int word_counter; 
  static unsigned a[4];
  unsigned d;
  char buf[81];

  for(;length;length-=4,word_counter++) {
    if (fd) {
      if(read(fd,(char *) &d,4) == NULL) {
        fprintf(stderr,"unexpected EOF\n");
        exit(1); 
      }
    }
    else {
      d = 0;
    }
    switch((word_counter%4)) {
    case 0:
      a[0] = d;
      break;
    case 1:
      a[1] = d;
      break;
    case 2:
      a[2] = d;
      break;
    case 3:
      a[3] = d;
      sprintf(buf,"       DC   X'%08.8X%08.8X%08.8X%08.8X'                                 ", a[0],a[1],a[2],a[3]) ;
      atoe(buf);
      write(fd2, buf, 80);
      break;
    }
  }
}

char ascii_to_ebcdic[] = 
{ 
 0x00, 0x01, 0x02, 0x03, 0x37, 0x2d, 0x2e, 0x2f,
 0x16, 0x05, 0x15, 0x0b, 0x00, 0x0d, 0x0e, 0x0f,
 0x10, 0x11, 0x12, 0x13, 0x3c, 0x3d, 0x32, 0x26,
 0x18, 0x19, 0x3f, 0x27, 0x22, 0x00, 0x00, 0x00,
 0x40, 0x4f, 0x7f, 0x7b, 0x5b, 0x6c, 0x50, 0x7d,
 0x4d, 0x5d, 0x5c, 0x4e, 0x6b, 0x60, 0x4b, 0x61,
 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
 0xf8, 0xf9, 0x7a, 0x5e, 0x4c, 0x7e, 0x6e, 0x6f,
 0x7c, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
 0xc8, 0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6,
 0xd7, 0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6,
 0xe7, 0xe8, 0xe9, 0x4a, 0xe0, 0x5a, 0x5f, 0x6d,
 0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
 0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,
 0x97, 0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6,
 0xa7, 0xa8, 0xa9, 0xc0, 0x6a, 0xd0, 0xa1, 0x07,

 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* ascii to ebcdic */
atoe(buf)
char *buf;
{
  for(;*buf ;buf++){
	*buf = ascii_to_ebcdic[*buf];
  }	
}
