static char SccsId[] = "@(#)facility.c	1.40    4/21/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* facility.c    89/10/1 */

#include "tim.h"

swap4(x) unsigned x;
{
  return (((x)<<24)|(((x)&0xff00)<<8)|(((x)&0xff0000)>>8)|((x)>>24));
}

swap2(x) unsigned x;
{
  return (((x)&0xff)<<8)|(((x)&0xff00)>>8);
}

/*************************************************************************
*                    PE							 *
*************************************************************************/

init_all_facility()
{
    unsigned t_pe;

#if PE_NUM == penum
    if ((pe=(struct pe_form*)malloc(sizeof(struct pe_form)*PE_NUM))==NULL) {
        message("specified PEs too large: %u\n", PE_NUM);
        exit(1);
    }
    bzero(pe, sizeof(struct pe_form)*PE_NUM);
#endif

    for (t_pe=0; t_pe<PE_NUM; t_pe++) {
        /* must use memalign(4,4) ??? */
        *(unsigned*)(pe[T_PE].header) = TACHYONMAGIC | OMAGIC;
        if ((pe[T_PE].mem=(unsigned char*)malloc(memsize))==NULL) {
            message("specified pages too large: %u\n", pagenum);
            exit(1);
        }
        bzero(pe[T_PE].mem, memsize);
        if ((pe[T_PE].mbp=(unsigned char*)malloc(memsize/8))==NULL) {
            message("specified pages too large: %u\n", pagenum);
            exit(1);
        }
        bzero(pe[T_PE].mbp, memsize/8);
        pe[T_PE].memsize = memsize;
        *(unsigned*)(pe[T_PE].symtbl=(unsigned char *)malloc(4))=4;
        pe[T_PE].symsize = 4;
#ifdef MANUAL_MAP
        pe[T_PE].map_free[0].abs_addr = 0;
        pe[T_PE].map_free[0].bytes    = memsize;
#endif
        init_sr(t_pe);
#ifdef MCR_AREA
        init_mcr(t_pe);
#endif
#ifdef VCP
        init_vcr(t_pe);
        init_vut(t_pe);
        init_tr(t_pe);
#endif
#ifdef FSBA
        init_fscr(t_pe);
        init_fsir(t_pe);
#endif
#ifdef FST
        init_fstcr(t_pe);
#endif
#ifdef DASD
        init_acr(t_pe);
#endif
	general_reset(t_pe);
    }
    init_grhash();
    init_frhash();
    init_srhash();
#ifdef MCR_AREA
    init_mcrhash();
#endif
#ifdef VCP
    init_vrhash();
    init_mrhash();
    init_vcrhash();
    init_vuthash();
    init_trhash();
#endif
}

randomize_all(num) unsigned num;
{
    unsigned t_pe, tmp;

    for (t_pe=0; t_pe<PE_NUM; t_pe++) {
	randomize_mem(t_pe, num);
	randomize_tlb(t_pe);
	randomize_che(t_pe, num);
	randomize_gr(t_pe);
	randomize_fr(t_pe);
	randomize_sr(t_pe);
	randomize_tod(t_pe);
#ifdef MCR_AREA
	randomize_mcr(t_pe);
#endif
        init_sr(t_pe);
        tmp = pe[T_PE].gr[1];
        pe[T_PE].gr[1] = pe[T_PE].sr[UGR1].ful;
        pe[T_PE].sr[UGR1].ful = tmp;
#ifdef MCR_AREA
        init_mcr(t_pe);
#endif
#ifdef VCP
	randomize_vr(t_pe);
	randomize_mr(t_pe);
	randomize_vcr(t_pe);
	randomize_vut(t_pe);
	randomize_tr(t_pe);
        init_vcr(t_pe);
        pe[T_PE].vcr[0].vcr0.vl = VRL * 32;
        pe[T_PE].vcr[1].vcr1.ps = 11;
        init_vut(t_pe);
        init_tr(t_pe);
#endif
    }
}

general_reset(t_pe) unsigned t_pe;
{
    unsigned i, t_fsba;

    pe[T_PE].sr[OPEV].ful = pe[T_PE].sr[PEV].ful;
    pe[T_PE].sr[OPC] .ful = pe[T_PE].sr[PC] .ful;
    pe[T_PE].sr[PC]  .ful = 0x00000000;
    pe[T_PE].sr[PEV].pev.al     = 15;
    pe[T_PE].sr[PEV].pev.arm    = 0;
    pe[T_PE].sr[PEV].pev.sync   = 0;
    pe[T_PE].sr[PEV].pev.fstop  = 1;
    pe[T_PE].sr[PEV].pev.nic    = 1;
    pe[T_PE].sr[PEV].pev.u      = 0;
    pe[T_PE].sr[PEV].pev.va     = 0;
    pe[T_PE].sr[PEV].pev.ivm    = 0;
    pe[T_PE].sr[PEV].pev.spu    = 0;
    pe[T_PE].sr[STAR1].ful      = 0;

    pe[T_PE].tod_5nano    = 0;
    pe[T_PE].tod.u        = 0;
    pe[T_PE].tod.l        = 0;
    pe[T_PE].firmstate    = 0;
    pe[T_PE].nullify      = 0;
    pe[T_PE].lpc          = 0xfffffff8;
    pe[T_PE].ip_status    = STATUS_FREE;
    pe[T_PE].hangup_timer = 0;
    pe[T_PE].timeout_req  = 0;
    pe[T_PE].svc_interrupt = 0;
    pe[T_PE].fwc_interrupt = 0;
    pe[T_PE].ext_interrupt = 0;
    pe[T_PE].ext_intr_level  = 0;
    pe[T_PE].slrp_intr_level = 0;
    pe[T_PE].ext_intr_delay  = 0;
    pe[T_PE].slrp_intr_delay = 0;

#ifdef FXT_INTR
    pe[T_PE].fxt_intr_level  = 0;
    pe[T_PE].fxt_intr_delay  = 0;
#endif

    *(unsigned*)&pe[T_PE].work_ird0 = 0;
    *(unsigned*)&pe[T_PE].work_ird1 = 0;
    for (i=0; i<GR_NUM; i++)
      pe[T_PE].gr_score[i] = SCORE_FREE;
    for (i=0; i<FR_NUM; i++)
      pe[T_PE].fr_score[i] = SCORE_FREE;
    pe[T_PE].sr_score      = SCORE_FREE;
    pe[T_PE].if_multiple_cycle = 0;
    pe[T_PE].ip_multiple_cycle = 0;
    pe[T_PE].fq_top        = 0;
    pe[T_PE].avn_fpwd      = 0;
    for (i=0; i<FQ_NUM; i++)
      pe[T_PE].fqi[i].write = 0;
    for (i=0; i<FP_WRITE_DELAY; i++)
      pe[T_PE].fpwd[i].fqno = 0;
    pe[T_PE].fpdb.fqno = 0;
    for (i=0; i<AP_DATQNUM; i++)
      pe[T_PE].ap_datq[i].av = 0;
    for (i=0; i<AP_CHEQNUM; i++)
      pe[T_PE].ap_cheq[i].av = 0;

#ifdef MCR_AREA
    pe[T_PE].wdt_5nano                 = 0;
    pe[T_PE].mcr[IVT].ful              = 0;
    pe[T_PE].mcr[WDTW].wdtw.wdt        = 0xffff;
    pe[T_PE].mcr[HSAPCW].hsapcw.hsapc  = 0;
    pe[T_PE].mcr[PONLW].ponlw.ponl     = 0;
    pe[T_PE].mcr[FWRMW].fwrmw.fwrm     = 0;
    pe[T_PE].mcr[SVFWRW].svfwrw.svfwrp = 0;
    pe[T_PE].mcr[FWFWRW].fwfwrw.fwfwrp = 0;
    pe[T_PE].mcr[FCPUSW].fcpusw.fcpus  = 0;
    pe[T_PE].mcr[SCPUSW].scpusw.scpus  = 0;
    pe[T_PE].mcr[CPUHCT].cpuhct.cpuhs  = 0;
    pe[T_PE].mcr[DISSIN].dissin.ds     = 0;
    pe[T_PE].mcr[TCPUSW].tcpusw.tcpus  = 0;
    pe[T_PE].smcr[FSVSG].ful           = 0;
#endif

#ifdef VCP
    pe[T_PE].vut_5nano = 0;
    pe[T_PE].vcr[0].ful = 0x00000000;
    pe[T_PE].vcr[1].ful = 0x710b0000;
    pe[T_PE].vcr[2].ful = 0x00000000;
    *(unsigned*)&pe[T_PE].work_vcr2 = 0;
    *(unsigned*)&pe[T_PE].work_st_vcr2 = 0;
    pe[T_PE].vp_score = SCORE_FREE;
    for (i=0; i<VR_NUM; i++) {
      pe[T_PE].vr_rscore[i] = SCORE_FREE;
      pe[T_PE].vr_wscore[i] = SCORE_FREE;
    }
    for (i=0; i<MR_NUM; i++) {
      pe[T_PE].mr_rscore[i] = SCORE_FREE;
      pe[T_PE].mr_wscore[i] = SCORE_FREE;
    }
    pe[T_PE].vop_iscore = SCORE_FREE;
    for (i=0; i<ID_NUM; i++) {
      pe[T_PE].vop_rscore[i] = SCORE_FREE;
      pe[T_PE].vop_wscore[i] = SCORE_FREE;
    }
    pe[T_PE].avn_opiq = 0;
    pe[T_PE].avn_opmq = 0;
    pe[T_PE].avn_opcq = 0;
    pe[T_PE].avn_ldq = 0;
    pe[T_PE].avn_stq = 0;
    pe[T_PE].avn_addq = 0;
    pe[T_PE].avn_mulq = 0;
    pe[T_PE].avn_divq = 0;
    pe[T_PE].avn_mskq = 0;
    pe[T_PE].avn_ldp = 0;
    pe[T_PE].avn_stp = 0;
    pe[T_PE].avn_addp = 0;
    pe[T_PE].avn_mulp = 0;
    pe[T_PE].avn_divp = 0;
    pe[T_PE].avn_mskp = 0;
    for (i=0; i<VP_OPIQNUM; i++)
      pe[T_PE].vp_opiq[i].av = 0;
    for (i=0; i<VP_OPMQNUM; i++)
      pe[T_PE].vp_opmq[i].av = 0;
    for (i=0; i<VP_OPCQNUM; i++)
      pe[T_PE].vp_opcq[i].av = 0;
    for (i=0; i<VP_LDQNUM; i++)
      pe[T_PE].vp_ldq[i].av = 0;
    for (i=0; i<VP_STQNUM; i++)
      pe[T_PE].vp_stq[i].av = 0;
    for (i=0; i<VP_ADDQNUM; i++)
      pe[T_PE].vp_addq[i].av = 0;
    for (i=0; i<VP_MULQNUM; i++)
      pe[T_PE].vp_mulq[i].av = 0;
    for (i=0; i<VP_DIVQNUM; i++)
      pe[T_PE].vp_divq[i].av = 0;
    for (i=0; i<VP_MSKQNUM; i++)
      pe[T_PE].vp_mskq[i].av = 0;
    for (i=0; i<VP_LDPLEN; i++)
      pe[T_PE].vp_ldp[i].av = 0;
    for (i=0; i<VP_STPLEN; i++)
      pe[T_PE].vp_stp[i].av = 0;
    for (i=0; i<VP_ADDPLEN; i++)
      pe[T_PE].vp_addp[i].av = 0;
    for (i=0; i<VP_MULPLEN; i++)
      pe[T_PE].vp_mulp[i].av = 0;
    for (i=0; i<VP_DIVPLEN; i++)
      pe[T_PE].vp_divp[i].av = 0;
    for (i=0; i<VP_MSKPLEN; i++)
      pe[T_PE].vp_mskp[i].av = 0;
#endif

#ifdef MOVER
    pe[T_PE].rqt_5nano = 0;
    *(unsigned*)&pe[T_PE].work_mrprmi = 0;
    *(unsigned*)&pe[T_PE].work_sndmri = 0;
    *(unsigned*)&pe[T_PE].mv_mrprmi   = 0;
    pe[T_PE].mv_rcv_srcpe  = -1;
    pe[T_PE].mv_rcv_status = STATUS_AVAIL;
    pe[T_PE].mv_rcv_stoprq = 0;
    pe[T_PE].mv_snd_stoprq = 0;
    pe[T_PE].mv_hround  = 0; /* 0 -> 4 -> 1 -> 5 -> 0 ... */
    pe[T_PE].mv_lround  = 0; /* 0 -> 4 -> 1 -> 5 -> 0 ... */
    pe[T_PE].mv_hqo	= 0;
    pe[T_PE].mv_qid	= 0;
    pe[T_PE].mv_rbsel   = 0;
    pe[T_PE].mv_hedr.av = 0;
    pe[T_PE].mcr[MRPRMI].ful        = 0x0f7ffdff;
    pe[T_PE].mcr[SNDMRI].ful        = 0x0cf81dec;
    pe[T_PE].mcr[MVST].mvst.sendst  = 3;
    pe[T_PE].mcr[MVST].mvst.recvst  = 3;
    pe[T_PE].mcr[SMIPHI].ful        = 0xffffff8f;
    pe[T_PE].mcr[MTC].mtc.dnupro    = 0;
    pe[T_PE].mcr[SPIDW].ful         = 0;
    pe[T_PE].mcr[HQALAW].ful      = 0;
    pe[T_PE].mcr[HQSZ].hqsz.shqs  = 0;
    pe[T_PE].mcr[HQSZ].hqsz.u0hqs = 0;
    pe[T_PE].mcr[HQSZ].hqsz.u1hqs = 0;
    pe[T_PE].mcr[HWSHTW].ful = 0;
    pe[T_PE].mcr[HRSHTW].ful = 0;
    pe[T_PE].mcr[HWSLTW].ful = 0;
    pe[T_PE].mcr[HRSLTW].ful = 0;
    pe[T_PE].mcr[HWU0RW].ful = 0;
    pe[T_PE].mcr[HRU0RW].ful = 0;
    pe[T_PE].mcr[HWU0TW].ful = 0;
    pe[T_PE].mcr[HRU0TW].ful = 0;
    pe[T_PE].mcr[HWU1RW].ful = 0;
    pe[T_PE].mcr[HRU1RW].ful = 0;
    pe[T_PE].mcr[HWU1TW].ful = 0;
    pe[T_PE].mcr[HRU1TW].ful = 0;
    pe[T_PE].mcr[RBAR0].rbar0.rb0vl = 0;
    pe[T_PE].mcr[RBAR1].rbar1.rb1vl = 0;
    pe[T_PE].mcr[RTOTW].rtotw.rtot  = 0xffff;
    pe[T_PE].mcr[RTOPW].rtopw.rtop  = 0xffff;
    pe[T_PE].mcr[UHQPRI].ful = 0;
    pe[T_PE].mcr[UAHWTW].ful = 0;
    pe[T_PE].mcr[UAHRTW].ful = 0;
    pe[T_PE].smcr[MCMDW].ful = 0;
#endif

#ifdef BARRIER
    pe[T_PE].bpu_5nano = 0;
    pe[T_PE].mcr[BSDCMC].bsdcmc.bsdcon = 0;
    pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp = 0;
    pe[T_PE].mcr[BSTN0W].bstn0w.bstnl0 = 0;
    pe[T_PE].mcr[BSTN1W].bstn1w.bstnl1 = 0;
    pe[T_PE].mcr[BMMAP0].ful = 0;
    pe[T_PE].mcr[BMMAP1].ful = 0;
    pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0 = 0;
    pe[T_PE].mcr[LBSY1W].lbsy1w.lbsy1 = 0;
    pe[T_PE].mcr[BMSK00].ful = 0;
    pe[T_PE].mcr[BMSK01].ful = 0;
    pe[T_PE].mcr[BMSK02].ful = 0;
    pe[T_PE].mcr[BMSK03].ful = 0;
    pe[T_PE].mcr[BMSK10].ful = 0;
    pe[T_PE].mcr[BMSK11].ful = 0;
    pe[T_PE].mcr[BMSK12].ful = 0;
    pe[T_PE].mcr[BMSK13].ful = 0;
#endif

#ifdef SSUMOVER
    pe[T_PE].ssumv_status     = STATUS_SSLEEP;
    pe[T_PE].ssu_delay_count  = 0;
    pe[T_PE].ssu_stop_request = 0;
    pe[T_PE].mcr[SSAB].ssab.ssabh = 0;
    pe[T_PE].mcr[SSAB].ssab.ssabl = 0;
    pe[T_PE].mcr[SSAL].ssal.ssalh = 0;
    pe[T_PE].mcr[SSAL].ssal.ssall = 0;
    pe[T_PE].mcr[SMST].smst.busy  = 0;
    pe[T_PE].mcr[SMCA].ful   = 0;
    pe[T_PE].mcr[SMIN].ful   = 0;
    pe[T_PE].mcr[SMSSW0].ful = 0;
    pe[T_PE].mcr[SMSSW1].ful = 0;
    pe[T_PE].mcr[SMRDU].ful  = 0;
    pe[T_PE].mcr[SMRDL].ful  = 0;
    pe[T_PE].mcr[SMEMW].smemw.sbem = 0;
    pe[T_PE].smcr[SMCTL].ful = 0;
    pe[T_PE].smcr[SMSTP].ful = 0;
    pe[T_PE].smcr[SMCLR].ful = 0;
#endif

#ifdef GSIGP
    pe[T_PE].gsigp_delay_count  = 0;
    pe[T_PE].mcr[GHST].ful  = 0;
    pe[T_PE].mcr[GHC0].ful  = 0;
    pe[T_PE].mcr[GHC1].ful  = 0;
    pe[T_PE].mcr[GHC2].ful  = 0;
    pe[T_PE].mcr[GHIN].ful  = 0;
    pe[T_PE].mcr[GHII0].ful = 0xffffffff;
    pe[T_PE].mcr[GHII1].ful = 0xffffffff;
    pe[T_PE].mcr[GHII2].ful = 0xffffffff;
    pe[T_PE].smcr[GHCTL].ful = 0;
#endif

#ifdef FSBA
    pe[T_PE].mcr[ICISTA].ful = 0;
    pe[T_PE].mcr[FSBARP].ful = 0;
    pe[T_PE].mcr[IOCCB0].ful = 0;
    pe[T_PE].mcr[IOCCB1].ful = 0;
    pe[T_PE].mcr[IOCCB2].ful = 0;
    pe[T_PE].mcr[IOCCB3].ful = 0;
    pe[T_PE].mcr[IOCCB4].ful = 0;
    pe[T_PE].mcr[IOCCB5].ful = 0;
    pe[T_PE].mcr[IOCRB0].ful = 0xffffffff;
    pe[T_PE].mcr[IOCRB1].ful = 0xffffffff;
    pe[T_PE].mcr[IOCRB2].ful = 0xffffffff;
    pe[T_PE].mcr[IOCRB3].ful = 0xffffffff;
    pe[T_PE].smcr[IOCCBS].ful = 0;
    for (t_fsba=0; t_fsba<FSBA_NUM; t_fsba++) {
      *(unsigned*)&pe[T_PE].fscr[T_FSBA] = 0;
      pe[T_PE].fsir[T_FSBA].setup = 0;
      pe[T_PE].fsir[T_FSBA].trnen = 0;
      for (i=0; i<FSBA_SLOT_NUM; i++)
        pe[T_PE].fsrq[T_FSBA][i].count = 0;
    }
#endif

#ifdef DAPF
    pe[T_PE].dapf_status = STATUS_DSLEEP;
    pe[T_PE].dapf_delay_count = 0;
    pe[T_PE].mcr[SVSCTL].ful  = 0;
    pe[T_PE].smcr[SDAPSG].ful = 0;
#endif

}

score_busy_found(t_pe) unsigned t_pe;
    /* return 1 if BUSY found, return 0 if all FREE */
{
    unsigned i;

    for (i=0; i<GR_NUM; i++)
      if (pe[T_PE].gr_score[i] != SCORE_FREE) return(1);
    for (i=0; i<FR_NUM; i++)
      if (pe[T_PE].fr_score[i] != SCORE_FREE) return(1);
    if (pe[T_PE].sr_score      != SCORE_FREE) return(1);
    if (pe[T_PE].if_multiple_cycle != 0) return(1);
    if (pe[T_PE].ip_multiple_cycle != 0) return(1);
    for (i=0; i<AP_DATQNUM; i++)
      if (pe[T_PE].ap_datq[i].av != 0) return(1);
    for (i=0; i<AP_CHEQNUM; i++)
      if (pe[T_PE].ap_cheq[i].av != 0) return(1);
#ifdef VCP
    if (pe[T_PE].vp_score != SCORE_FREE) return(1);
    for (i=0; i<VR_NUM; i++) {
      if (pe[T_PE].vr_rscore[i] != SCORE_FREE) return(1);
      if (pe[T_PE].vr_wscore[i] != SCORE_FREE) return(1);
    }
    for (i=0; i<MR_NUM; i++) {
      if (pe[T_PE].mr_rscore[i] != SCORE_FREE) return(1);
      if (pe[T_PE].mr_wscore[i] != SCORE_FREE) return(1);
    }
    if (pe[T_PE].vop_iscore != SCORE_FREE) return(1);
    for (i=0; i<ID_NUM; i++) {
      if (pe[T_PE].vop_rscore[i] != SCORE_FREE) return(1);
      if (pe[T_PE].vop_wscore[i] != SCORE_FREE) return(1);
    }
    if (pe[T_PE].avn_opiq != 0) return(1);
    if (pe[T_PE].avn_opmq != 0) return(1);
    if (pe[T_PE].avn_opcq != 0) return(1);
    if (pe[T_PE].avn_ldq != 0) return(1);
    if (pe[T_PE].avn_stq != 0) return(1);
    if (pe[T_PE].avn_addq != 0) return(1);
    if (pe[T_PE].avn_mulq != 0) return(1);
    if (pe[T_PE].avn_divq != 0) return(1);
    if (pe[T_PE].avn_mskq != 0) return(1);
    if (pe[T_PE].avn_ldp != 0) return(1);
    if (pe[T_PE].avn_stp != 0) return(1);
    if (pe[T_PE].avn_addp != 0) return(1);
    if (pe[T_PE].avn_mulp != 0) return(1);
    if (pe[T_PE].avn_divp != 0) return(1);
    if (pe[T_PE].avn_mskp != 0) return(1);
    for (i=0; i<VP_OPIQNUM; i++)
      if (pe[T_PE].vp_opiq[i].av != 0) return(1);
    for (i=0; i<VP_OPMQNUM; i++)
      if (pe[T_PE].vp_opmq[i].av != 0) return(1);
    for (i=0; i<VP_OPCQNUM; i++)
      if (pe[T_PE].vp_opcq[i].av != 0) return(1);
    for (i=0; i<VP_LDQNUM; i++)
      if (pe[T_PE].vp_ldq[i].av != 0) return(1);
    for (i=0; i<VP_STQNUM; i++)
      if (pe[T_PE].vp_stq[i].av != 0) return(1);
    for (i=0; i<VP_ADDQNUM; i++)
      if (pe[T_PE].vp_addq[i].av != 0) return(1);
    for (i=0; i<VP_MULQNUM; i++)
      if (pe[T_PE].vp_mulq[i].av != 0) return(1);
    for (i=0; i<VP_DIVQNUM; i++)
      if (pe[T_PE].vp_divq[i].av != 0) return(1);
    for (i=0; i<VP_MSKQNUM; i++)
      if (pe[T_PE].vp_mskq[i].av != 0) return(1);
    for (i=0; i<VP_LDPLEN; i++)
      if (pe[T_PE].vp_ldp[i].av != 0) return(1);
    for (i=0; i<VP_STPLEN; i++)
      if (pe[T_PE].vp_stp[i].av != 0) return(1);
    for (i=0; i<VP_ADDPLEN; i++)
      if (pe[T_PE].vp_addp[i].av != 0) return(1);
    for (i=0; i<VP_MULPLEN; i++)
      if (pe[T_PE].vp_mulp[i].av != 0) return(1);
    for (i=0; i<VP_DIVPLEN; i++)
      if (pe[T_PE].vp_divp[i].av != 0) return(1);
    for (i=0; i<VP_MSKPLEN; i++)
      if (pe[T_PE].vp_mskp[i].av != 0) return(1);
#endif
    return(0);
}

cmd_ext_interrupt(t_pe, level) unsigned t_pe, level;
    /* return 1 if failed, 0 if succeeded */
{
    if (level == 0 || level >= 16) {
        message("not exist: interrupt level %u\n", level);
        return(1);
    }
    pe[T_PE].ext_interrupt |= ((unsigned)0x80000000 >> level);
    return(0);
}

/*************************************************************************
*                    SCALAR						 *
*************************************************************************/

/******************* GR *************************************************/

struct grinfo { char *name; };
struct grinfo GRINFO[GR_NUM] = {
#define    DEF_GR(NAME) { NAME },
#include   "gr-name.def"
#undef     DEF_GR
};
#define    GRHASH_SIZE     (GR_NUM*2)
#define    grrehash(x)     ((x+137) % GRHASH_SIZE)
struct     grhash  { char *name; unsigned grnum; };
struct     grhash  GRHASH[GRHASH_SIZE];

init_grhash()
{
    unsigned i;

    for (i=0; i<GR_NUM; i++)
        GRHASH[put_grhash(GRINFO[i].name)].grnum = i;
}

gr_hash(s) char *s;
{
    unsigned hashval;
        
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % GRHASH_SIZE);
}

put_grhash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = gr_hash(name);
    while (GRHASH[hashval].name != NULL) {
        if (!strcmp(name, GRHASH[hashval].name)) return(hashval);
        hashval = grrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (GRHASH[hashval].name != NULL) message("too many gr names\n");
    GRHASH[hashval].name = name;
    return(hashval);
}

get_grnumber(name) char *name;
{
    unsigned  hashval, hashsave;
 
    hashval = hashsave = gr_hash(name);
    while (GRHASH[hashval].name != NULL) {
        if (!strcmp(name, GRHASH[hashval].name))
          return(GRHASH[hashval].grnum);
        hashval = grrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not gr\n", name); */
    return(GR_NUM);
}

randomize_gr(t_pe) unsigned t_pe;
{
    unsigned i, j;

    for (i=0; i<GR_NUM; i++) {
      j = ((unsigned char)i<<24)+((unsigned char)i<<16)+((unsigned char)i<<8)+(unsigned char)i;
      pe[T_PE].gr[i] = j;
    }
}

cmd_gr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (num >= GR_NUM) {
        message("not exist: gr%u\n", num);
        return(1);
    }
    if (rw == _R_) {
        if (num == 1 && pe[T_PE].sr[PEV].pev.u)
          *d = pe[T_PE].sr[UGR1].ful;
	else
          *d = pe[T_PE].gr[num];
        return(0);
    }
    else if (rw == _W_) {
        if (num == 1 && pe[T_PE].sr[PEV].pev.u)
          pe[T_PE].sr[UGR1].ful = *d;
	else if (num > 0)
          pe[T_PE].gr[num] = *d;
        return(0);
    }
    else {
        message("internal error: cmd_gr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

#if 0
sys_gr_lock(t_pe, num) unsigned t_pe, num;
{
#ifdef DEBUG
    if (num >= GR_NUM) {
        message("not exist(sys): gr%u\n", num);
        return;
    }
#endif
    if (num > 0)
        pe[T_PE].gr_score[num] = SCORE_BUSY;
}
#endif

#if 0
sys_gr_unlock(t_pe, num) unsigned t_pe, num;
{       
#ifdef DEBUG
    if (num >= GR_NUM) {
        message("not exist(sys): gr%u\n", num);
        return;
    }
#endif  
    pe[T_PE].gr_score[num] = SCORE_FREE;
} 
#endif

#if 0
sys_gr_check_score(t_pe, num, rw) unsigned t_pe, num, rw;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
#ifdef DEBUG
    if (num >= GR_NUM) {
        message("not exist(sys): gr%u\n", num);
        return(SCORE_BUSY);
    }
#endif
    return (pe[T_PE].gr_score[num]);
}
#endif

#if 0
sys_gr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_: write _O_: ored write */
{
    if (rw == _R_) {
        if (num == 1 && pe[T_PE].sr[PEV].pev.u)
          *d = pe[T_PE].sr[UGR1].ful;
	else
          *d = pe[T_PE].gr[num];
    }
    else if (rw == _W_) {
        if (num == 1 && pe[T_PE].sr[PEV].pev.u)
          pe[T_PE].sr[UGR1].ful = *d;
	else if (num > 0)
          pe[T_PE].gr[num] = *d;
    }
    else if (rw == _O_) {
        if (num == 1 && pe[T_PE].sr[PEV].pev.u)
          pe[T_PE].sr[UGR1].ful |= *d;
	else if (num > 0)
          pe[T_PE].gr[num] |= *d;
    }
}
#endif

#if 0
sys_async_gr_access(t_pe, num, u, rw, d) unsigned t_pe, num, u, rw, *d;
    /* rw ... _R_: read _W_: write _O_: ored write */
{
    if (rw == _R_) {
        if (num == 1 && u)
          *d = pe[T_PE].sr[UGR1].ful;
	else
          *d = pe[T_PE].gr[num];
    }
    else if (rw == _W_) {
        if (num == 1 && u)
          pe[T_PE].sr[UGR1].ful = *d;
	else if (num > 0)
          pe[T_PE].gr[num] = *d;
    }
    else if (rw == _O_) {
        if (num == 1 && u)
          pe[T_PE].sr[UGR1].ful |= *d;
	else if (num > 0)
          pe[T_PE].gr[num] |= *d;
    }
}
#endif

/******************* FR *************************************************/

struct frinfo { char *name; };
struct frinfo FRINFO[FR_NUM] = {
#define    DEF_FR(NAME) { NAME },
#include   "fr-name.def"
#undef     DEF_FR
};
#define    FRHASH_SIZE     (FR_NUM*2)
#define    frrehash(x)     ((x+137) % FRHASH_SIZE)
struct     frhash  { char *name; unsigned frnum; };
struct     frhash  FRHASH[FRHASH_SIZE];

struct fsinfo { char r1, r2, r3, p1, p2, p3, cmp; };
struct fsinfo FSINFO[32] = {
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fadd     */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fadd.d   */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fsub     */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fsub.d   */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fmul     */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fmul.d   */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fdiv     */
	      {       1,  1,  1,  0,  0,  0,  0 },   /* fdiv.d   */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnv.fd  */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnv.df  */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnv.if  */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnv.fi  */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnv.id  */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnv.di  */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnz.fi  */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       1,  0,  1,  0,  0,  0,  0 },   /* fcnz.di  */
	      {       1,  1,  0,  0,  0,  0,  1 },   /* fcmp     */
	      {       1,  1,  0,  0,  0,  0,  1 },   /* fcmp.d   */
	      {       1,  1,  0,  1,  1,  0,  1 },   /* fcmp.x   */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       1,  1,  1,  1,  1,  1,  0 },   /* fadd.x   */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       1,  1,  1,  1,  1,  1,  0 },   /* fsub.x   */
	      {       0,  0,  0,  0,  0,  0,  0 },   /* reserved */
	      {       1,  0,  1,  0,  0,  1,  0 },   /* fcnv.dx  */
	      {       1,  0,  1,  1,  0,  0,  0 }    /* fcnv.xd  */
};

init_frhash()
{
    unsigned i;

    for (i=0; i<FR_NUM; i++)
        FRHASH[put_frhash(FRINFO[i].name)].frnum = i;
}

fr_hash(s) char *s;
{
    unsigned hashval;
    
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % FRHASH_SIZE);
}

put_frhash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = fr_hash(name);
    while (FRHASH[hashval].name != NULL) {
        if (!strcmp(name, FRHASH[hashval].name)) return(hashval);
        hashval = frrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (FRHASH[hashval].name != NULL) message("too many fr names\n");
    FRHASH[hashval].name = name;
    return(hashval);
}

get_frnumber(name) char *name;
{
    unsigned  hashval, hashsave;
 
    hashval = hashsave = fr_hash(name);
    while (FRHASH[hashval].name != NULL) {
        if (!strcmp(name, FRHASH[hashval].name))
            return(FRHASH[hashval].frnum);
        hashval = frrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not fr\n", name); */
    return(FR_NUM);
}

randomize_fr(t_pe) unsigned t_pe;
{
    unsigned i, j;

    for (i=0; i<FR_NUM; i++) {
      j = ((unsigned char)i<<24)+((unsigned char)i<<16)+((unsigned char)i<<8)+(unsigned char)i;
      pe[T_PE].fr[i].u = pe[T_PE].fr[i].l = j;
    }
}

cmd_fr_access(t_pe, num, rw, d1, d2) unsigned t_pe, num, rw, *d1, *d2;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (num >= FR_NUM) {
        message("not exist: fr%u\n", num);
        return(1);
    }
    if (rw == _R_) {
        *d1 = pe[T_PE].fr[num].u;
        *d2 = pe[T_PE].fr[num].l;
        return(0);
    }
    else if (rw == _W_) {
        if (num > 0) {
            pe[T_PE].fr[num].u = *d1;
            pe[T_PE].fr[num].l = *d2;
        }
        return(0);
    }
    else {
        message("internal error: cmd_fr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

#if 0
sys_fr_exception(t_pe, num) unsigned t_pe, num;
{
#ifdef DEBUG
    if (num >= FR_NUM) {
        message("not exist(sys): fr%u\n", num);
        return;
    }
#endif
    if (num > 0)
        pe[T_PE].fr_score[num] = SCORE_EXCEPTION;
}
#endif

#if 0
sys_fr_lock(t_pe, num) unsigned t_pe, num;
{
#ifdef DEBUG
    if (num >= FR_NUM) {
        message("not exist(sys): fr%u\n", num);
        return;
    }
#endif
    if (num > 0)
        pe[T_PE].fr_score[num] = SCORE_BUSY;
}
#endif

#if 0
sys_fr_unlock(t_pe, num) unsigned t_pe, num;
{
#ifdef DEBUG
    if (num >= FR_NUM) {
        message("not exist(sys): fr%u\n", num);
        return;
    }
#endif
    pe[T_PE].fr_score[num] = SCORE_FREE;
}
#endif

sys_fr_check_score(t_pe, num, rw, qnum) unsigned t_pe, num, rw, qnum;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting, SCORE_EXCEPTION if exception found */
{
    unsigned fopch, fopcl, tmp;

#ifdef DEBUG
    if (num >= FR_NUM) {
        message("not exist(sys): fr%u\n", num);
        return(SCORE_BUSY);
    }
#endif
/* check 0~(qnum-1) FPQ */
    if (!num)
      return(SCORE_FREE);
    if (!pe[T_PE].sr[PEV].pev.fstop) {
      if (rw == _R_) {
        for (tmp=0; tmp<qnum; tmp++) {
	  if (pe[T_PE].sr[FQE0H+tmp*2].fqeh.av) {
            if (pe[T_PE].sr[FQE0H+tmp*2].ful & 0x3f000000)
              return (SCORE_EXCEPTION);
            if (pe[T_PE].sr[FQE0L+tmp*2].ful & 0x3f000000)
              return (SCORE_EXCEPTION);
            if (pe[T_PE].sr[FQE0H+tmp*2].fqeh.ne) {
	      fopch = pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_op;
	      if (FSINFO[fopch].r3 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r3   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopch].p3 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r3+1 == num)
	        return (SCORE_BUSY);
            }
	    if (pe[T_PE].sr[FQE0L+tmp*2].fqel.ne) {
	      fopcl = pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_op;
	      if (FSINFO[fopcl].r3 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r3   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopcl].p3 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r3+1 == num)
	        return (SCORE_BUSY);
            }
	  }
        }
      }
      else if (rw == _W_) {
        for (tmp=0; tmp<qnum; tmp++) {
	  if (pe[T_PE].sr[FQE0H+tmp*2].fqeh.av) {
            if (pe[T_PE].sr[FQE0H+tmp*2].ful & 0x3f000000)
              return (SCORE_EXCEPTION);
            if (pe[T_PE].sr[FQE0L+tmp*2].ful & 0x3f000000)
              return (SCORE_EXCEPTION);
            if (pe[T_PE].sr[FQE0H+tmp*2].fqeh.ne) {
	      fopch = pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_op;
	      if (FSINFO[fopch].r1 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r1   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopch].p1 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r1+1 == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopch].r2 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r2   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopch].p2 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r2+1 == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopch].r3 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r3   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopch].p3 && pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_r3+1 == num)
	        return (SCORE_BUSY);
            }
	    if (pe[T_PE].sr[FQE0L+tmp*2].fqel.ne) {
	      fopcl = pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_op;
	      if (FSINFO[fopcl].r1 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r1   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopcl].p1 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r1+1 == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopcl].r2 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r2   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopcl].p2 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r2+1 == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopcl].r3 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r3   == num)
	        return (SCORE_BUSY);
	      if (FSINFO[fopcl].p3 && pe[T_PE].sr[FQE0L+tmp*2].fqel.sfopc_r3+1 == num)
	        return (SCORE_BUSY);
            }
	  }
        }
      }
    }
    return (pe[T_PE].fr_score[num]);
}

#if 0
sys_fr_access(t_pe, num, rw, d1, d2) unsigned t_pe, num, rw, *d1, *d2;
    /* rw ... _R_: read _W_: write _A_: anded write _O_: ored write */
{
    if (rw == _R_) {
      *d1 = pe[T_PE].fr[num].u;
      *d2 = pe[T_PE].fr[num].l;
    }
    else if (rw == _W_) {
      if (num > 0) {
        pe[T_PE].fr[num].u = *d1;
        pe[T_PE].fr[num].l = *d2;
      }
    }
    else if (rw == _A_) {
      if (num > 0) {
        pe[T_PE].fr[num].u &= *d1;
        pe[T_PE].fr[num].l &= *d2;
      }
    }
    else if (rw == _O_) {
      if (num > 0) {
        pe[T_PE].fr[num].u |= *d1;
        pe[T_PE].fr[num].l |= *d2;
      }
    }
}
#endif

/******************* SR *************************************************/

struct srinfo { char *name;
                unsigned cmd_r_mask, cmd_w_mask;
                unsigned sys_r_mask, sys_w_mask; };
struct srinfo SRINFO[SR_REALNUM] = {
#define    DEF_SR(NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK) \
                { NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK },
#include   "sr-name.def"
#undef     DEF_SR
};
#define    SRHASH_SIZE     (SR_REALNUM*2)
#define    srrehash(x)     ((x+137) % SRHASH_SIZE)
struct     srhash  { char *name; unsigned srnum; };
struct     srhash  SRHASH[SRHASH_SIZE];

init_sr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<SR_REALNUM; i++)
        pe[T_PE].sr[i].ful = (SRINFO[i].sys_r_mask | pe[T_PE].sr[i].ful)
			    & SRINFO[i].sys_w_mask;
}

init_srhash()
{
    unsigned i;

    for (i=0; i<SR_REALNUM; i++)
        SRHASH[put_srhash(SRINFO[i].name)].srnum = i;
}

sr_hash(s) char *s;
{
    unsigned hashval;
        
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % SRHASH_SIZE);
}

put_srhash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = sr_hash(name);
    while (SRHASH[hashval].name != NULL) {
        if (!strcmp(name, SRHASH[hashval].name)) return(hashval);
        hashval = srrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (SRHASH[hashval].name != NULL) message("too many sr names\n");
    SRHASH[hashval].name = name;
    return(hashval);
}

get_srnumber(name) char *name;
{
    unsigned  hashval, hashsave;

    hashval = hashsave = sr_hash(name);
    while (SRHASH[hashval].name != NULL) {
        if (!strcmp(name, SRHASH[hashval].name))
            return(SRHASH[hashval].srnum);
        hashval = srrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not sr\n", name); */
    return(SR_NUM);
}

char *
get_srname(num) unsigned num;
{
    static char ext_srname[8];

    if (num >= SR_REALNUM) {
      sprintf(ext_srname, "sr%04.4d", num);
      return(ext_srname);
    }
    else
      return(SRINFO[num].name);
}

randomize_sr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<SR_REALNUM; i++) {
      pe[T_PE].sr[i].ful = ~0;
    }
}

cmd_sr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (num >= SR_NUM) {
        message("not exist: sr%u\n", num);
        return(1);
    }

    if (num >= SR_REALNUM) {
        if (rw == _R_) *d = 0;
        return(0);
    }

    if (rw == _R_) {
        *d = pe[T_PE].sr[num].ful;
        return(0);
    }
    else if (rw == _W_) {
        pe[T_PE].sr[num].ful = (SRINFO[num].cmd_r_mask&pe[T_PE].sr[num].ful)
                             | (SRINFO[num].cmd_w_mask&*d)
                             | (SRINFO[num].cmd_r_mask&SRINFO[num].cmd_w_mask);
	switch (num) {
	case STAR0:
          pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
          pe[T_PE].sr[STAR0].star0.fcc_le = pe[T_PE].sr[STAR0].star0.fcc_e | pe[T_PE].sr[STAR0].star0.fcc_l;
          pe[T_PE].sr[STAR0].star0.fcc_ge = pe[T_PE].sr[STAR0].star0.fcc_e | pe[T_PE].sr[STAR0].star0.fcc_g;
          pe[T_PE].sr[STAR0].star0.fcc_ue = pe[T_PE].sr[STAR0].star0.fcc_e | pe[T_PE].sr[STAR0].star0.fcc_u;
	  break;
	case CLAXC0:  pe[T_PE].sr[LAXC0]  .ful = pe[T_PE].sr[CLAXC0].ful; break;
	case CLAXA0:  pe[T_PE].sr[LAXA0]  .ful = pe[T_PE].sr[CLAXA0].ful; break;
	case CLAXS00: pe[T_PE].sr[LAXS00] .ful = pe[T_PE].sr[CLAXS00].ful; break;
 	case CLAXS01: pe[T_PE].sr[LAXS01] .ful = pe[T_PE].sr[CLAXS01].ful; break;
	case CLAXS02: pe[T_PE].sr[LAXS02] .ful = pe[T_PE].sr[CLAXS02].ful; break;
	case CLAXS03: pe[T_PE].sr[LAXS03] .ful = pe[T_PE].sr[CLAXS03].ful; break;

	case LAXC0:   pe[T_PE].sr[CLAXC0] .ful = pe[T_PE].sr[LAXC0].ful; break;
	case LAXA0:   pe[T_PE].sr[CLAXA0] .ful = pe[T_PE].sr[LAXA0].ful; break;
	case LAXS00:  pe[T_PE].sr[CLAXS00].ful = pe[T_PE].sr[LAXS00].ful; break;
 	case LAXS01:  pe[T_PE].sr[CLAXS01].ful = pe[T_PE].sr[LAXS01].ful; break;
	case LAXS02:  pe[T_PE].sr[CLAXS02].ful = pe[T_PE].sr[LAXS02].ful; break;
	case LAXS03:  pe[T_PE].sr[CLAXS03].ful = pe[T_PE].sr[LAXS03].ful; break;

        case FQE0H:
        case FQE0L:   pe[T_PE].fqi[0].write = 0; break;
        case FQE1H:
        case FQE1L:   pe[T_PE].fqi[1].write = 0; break;
        case FQE2H:
        case FQE2L:   pe[T_PE].fqi[2].write = 0; break;
        case FQE3H:
        case FQE3L:   pe[T_PE].fqi[3].write = 0; break;
        case FQE4H:
        case FQE4L:   pe[T_PE].fqi[4].write = 0; break;
        case FQE5H:
        case FQE5L:   pe[T_PE].fqi[5].write = 0; break;
	}
        return(0);
    }
    else {
        message("internal error: cmd_sr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

#if 0
sys_sr_lock(t_pe) unsigned t_pe;
{
    pe[T_PE].sr_score = SCORE_BUSY;
}   
#endif

#if 0
sys_sr_unlock(t_pe) unsigned t_pe;
{
    pe[T_PE].sr_score = SCORE_FREE;
}
#endif

#if 0
sys_sr_check_score(t_pe) unsigned t_pe;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
    return (pe[T_PE].sr_score);
}
#endif

sys_star0_check_score(t_pe) unsigned t_pe;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
    unsigned tmp;

    if (!pe[T_PE].sr[PEV].pev.fstop) {
      for (tmp=0; tmp<FQ_NUM; tmp++) {
	if (pe[T_PE].sr[FQE0H+tmp*2].fqeh.av) {
          if (pe[T_PE].sr[FQE0H+tmp*2].ful & 0x7f000000) {
	    if (FSINFO[pe[T_PE].sr[FQE0H+tmp*2].fqeh.fopc_op].cmp)
	      return (SCORE_BUSY);
          }
        }
      }
    }
    return (SCORE_FREE);
}

sys_sr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
{
    if (num >= SR_REALNUM) {
        if (rw == _R_) *d = 0;
        return;
    }

    if (rw == _R_) {
        *d = pe[T_PE].sr[num].ful;
    }
    else if (rw == _W_) {
        pe[T_PE].sr[num].ful = (SRINFO[num].sys_r_mask&pe[T_PE].sr[num].ful)
                             | (SRINFO[num].sys_w_mask&*d)
                             | (SRINFO[num].sys_r_mask&SRINFO[num].sys_w_mask);
	switch (num) {
	case STAR0:
          pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
          pe[T_PE].sr[STAR0].star0.fcc_le = pe[T_PE].sr[STAR0].star0.fcc_e | pe[T_PE].sr[STAR0].star0.fcc_l;
          pe[T_PE].sr[STAR0].star0.fcc_ge = pe[T_PE].sr[STAR0].star0.fcc_e | pe[T_PE].sr[STAR0].star0.fcc_g;
          pe[T_PE].sr[STAR0].star0.fcc_ue = pe[T_PE].sr[STAR0].star0.fcc_e | pe[T_PE].sr[STAR0].star0.fcc_u;
	  break;
	case CLAXC0:  pe[T_PE].sr[LAXC0]  .ful = pe[T_PE].sr[CLAXC0].ful; break;
	case CLAXA0:  pe[T_PE].sr[LAXA0]  .ful = pe[T_PE].sr[CLAXA0].ful; break;
	case CLAXS00: pe[T_PE].sr[LAXS00] .ful = pe[T_PE].sr[CLAXS00].ful; break;
 	case CLAXS01: pe[T_PE].sr[LAXS01] .ful = pe[T_PE].sr[CLAXS01].ful; break;
	case CLAXS02: pe[T_PE].sr[LAXS02] .ful = pe[T_PE].sr[CLAXS02].ful; break;
	case CLAXS03: pe[T_PE].sr[LAXS03] .ful = pe[T_PE].sr[CLAXS03].ful; break;

	case LAXC0:   pe[T_PE].sr[CLAXC0] .ful = pe[T_PE].sr[LAXC0].ful; break;
	case LAXA0:   pe[T_PE].sr[CLAXA0] .ful = pe[T_PE].sr[LAXA0].ful; break;
	case LAXS00:  pe[T_PE].sr[CLAXS00].ful = pe[T_PE].sr[LAXS00].ful; break;
 	case LAXS01:  pe[T_PE].sr[CLAXS01].ful = pe[T_PE].sr[LAXS01].ful; break;
	case LAXS02:  pe[T_PE].sr[CLAXS02].ful = pe[T_PE].sr[LAXS02].ful; break;
	case LAXS03:  pe[T_PE].sr[CLAXS03].ful = pe[T_PE].sr[LAXS03].ful; break;

        case FQE0H:
        case FQE0L:   pe[T_PE].fqi[0].write = 0; break;
        case FQE1H:
        case FQE1L:   pe[T_PE].fqi[1].write = 0; break;
        case FQE2H:
        case FQE2L:   pe[T_PE].fqi[2].write = 0; break;
        case FQE3H:
        case FQE3L:   pe[T_PE].fqi[3].write = 0; break;
        case FQE4H:
        case FQE4L:   pe[T_PE].fqi[4].write = 0; break;
        case FQE5H:
        case FQE5L:   pe[T_PE].fqi[5].write = 0; break;
	}
    }
}

/******************* TOD ************************************************/

randomize_tod(t_pe) unsigned t_pe;
{
    pe[T_PE].tod.u = 0x12345678;
    pe[T_PE].tod.l = 0x9abcde00;
}

cmd_tod_access(t_pe, rw, d1, d2) unsigned t_pe, rw, *d1, *d2;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (rw == _R_) {
        *d1 = pe[T_PE].tod.u;
        *d2 = pe[T_PE].tod.l;
        return(0);
    }
    else if (rw == _W_) {
        pe[T_PE].tod.u = (*d1);
        pe[T_PE].tod.l = (*d2 & 0xffffff00);
        return(0);
    }
    else {
        message("internal error: cmd_tod_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

#if 0
sys_tod_access(t_pe, rw, d1, d2) unsigned t_pe, rw, *d1, *d2;
    /* rw ... _R_: read _W_: write */
{
    if (rw == _R_) {
        *d1 = pe[T_PE].tod.u;
        *d2 = pe[T_PE].tod.l;
    }
    else if (rw == _W_) {
        pe[T_PE].tod.u = (*d1);
        pe[T_PE].tod.l = (*d2 & 0xffffff00);
    }
}
#endif

#ifdef MCR_AREA
/******************* MCR ************************************************/

struct mcrinfo { char *name; unsigned rev, r_mask, w_mask; };
struct mcrinfo MCRINFO[MCR_REALNUM] = {
#define    DEF_MCR(NAME, REV, R_MASK, W_MASK) \
                 { NAME, REV, R_MASK, W_MASK },
#include   "mcr-name.def"
#undef     DEF_MCR
};
#define    MCRHASH_SIZE    (MCR_REALNUM*2)
#define    mcrrehash(x)    ((x+137) % MCRHASH_SIZE)
struct     mcrhash  { char *name; unsigned mcrnum; };
struct     mcrhash  MCRHASH[MCRHASH_SIZE];

init_mcr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<MCR_REALNUM; i++)
        pe[T_PE].mcr[i].ful
          = ((MCRINFO[i].r_mask ^ MCRINFO[i].rev) | pe[T_PE].mcr[i].ful)
            & MCRINFO[i].w_mask;
    pe[T_PE].mcr[MSMAP].ful = (memsize-1) & 0xffff0000;
    pe[T_PE].mcr[NETPAW].netpaw.netpa = t_pe;
}

init_mcrhash()
{
    unsigned i;

    for (i=0; i<MCR_REALNUM; i++)
        MCRHASH[put_mcrhash(MCRINFO[i].name)].mcrnum = i;
}

mcr_hash(s) char *s;
{
    unsigned hashval;

    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % MCRHASH_SIZE);
}

put_mcrhash(name) char *name;
{
    unsigned hashval, hashsave;

    hashval = hashsave = mcr_hash(name);
    while (MCRHASH[hashval].name != NULL) {
        if (!strcmp(name, MCRHASH[hashval].name)) return(hashval);
        hashval = mcrrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (MCRHASH[hashval].name != NULL) message("too many mcr names\n");
    MCRHASH[hashval].name = name;
    return(hashval);
}

get_mcrnumber(name) char *name;
{
    unsigned  hashval, hashsave;

    hashval = hashsave = mcr_hash(name);
    while (MCRHASH[hashval].name != NULL) {
        if (!strcmp(name, MCRHASH[hashval].name))
            return(MCRHASH[hashval].mcrnum);
        hashval = mcrrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not mcr\n", name); */
    return(MCR_NUM);
}

char *
get_mcrname(addr) unsigned addr;
{
    unsigned num = addr >> 3;
    static char ext_mcrname[8];

    if (num >= MCR_REALNUM || addr & 4) {
      sprintf(ext_mcrname, "mcr%04.4x", addr);
      return(ext_mcrname);
    }
    else
      return(MCRINFO[num].name);
}

randomize_mcr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<MCR_REALNUM; i++) {
      pe[T_PE].mcr[i].ful = ~0;
    }
}

cmd_mcr_access(t_pe, addr, len, rw, d) unsigned t_pe, addr, len, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned num = addr >> 3;

    if (num >= MCR_NUM) {
        message("not exist: mcr%x\n", addr);
        return(1);
    }
    if (len != 4) {
        message("illegal: mcr len=%u\n", len);
        return(1);
    }
    if (addr & (len-1)) {
        message("not aligned: mcr addr=0x%08.8X len=%u\n", addr, len);
        return(1);
    }

    if (num >= MCR_REALNUM || addr & 4) {
        if (rw == _R_) *d = 0;
        return(0);
    }

    if (rw == _R_) {
        switch (num) {

#ifdef MOVER
        case MPDTW:
          if (pe[T_PE].mcr[MPSTW].mpstw.mpst)
              *d = ~0;
          else
              *d = pe[T_PE].mv_pa[pe[T_PE].smcr[MPCIDW].mpcidw.mpcid];
          break;
#endif

        default:
          *d = pe[T_PE].mcr[num].ful;
          break;
        }
        return(0);
    }
    else if (rw == _W_) {
        pe[T_PE].mcr[num].ful
         =(((MCRINFO[num].r_mask&pe[T_PE].mcr[num].ful)^MCRINFO[num].rev)
         |  (MCRINFO[num].w_mask&*d)
         | ((MCRINFO[num].r_mask&MCRINFO[num].w_mask)^MCRINFO[num].rev))
         ^   MCRINFO[num].rev;
        switch (num) {

        case FSVSG:
          pe[T_PE].smcr[FSVSG].ful = MCRINFO[FSVSG].w_mask&~0;
          break;

#ifdef IVT_INTR
        case IVT:
          if (!(*d>>31))
            pe[T_PE].ext_interrupt &= ~IVT_INTERRUPT;
          break;
#endif

#ifdef MOVER
        case MRPRMI:
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.sndmrp) {
            pe[T_PE].mcr[SNDMRI].ful = 0x0cf81dec;
	    pe[T_PE].mcr[SMIPHI].ful = 0xffffff8f;
	  }
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp) {
            if (!*(unsigned*)&pe[T_PE].mv_mrprmi) {
              pe[T_PE].mcr[MRPRMI].ful &= 0xf0000000;
              pe[T_PE].mcr[MRPRMI].ful |= 0x0f7ffdff;
            }
            else {
              pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp = 1;
              pe[T_PE].mcr[MRPRMI].ful &= 0xf0000000;
              pe[T_PE].mcr[MRPRMI].ful |= (*(unsigned*)&pe[T_PE].mv_mrprmi);
              *(unsigned*)&pe[T_PE].mv_mrprmi = 0;
            }
	  }
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.sndmrp
           && !pe[T_PE].mcr[MRPRMI].mrprmi.sndsrp) {
            if (pe[T_PE].mcr[MVST].mvst.sendst == 1 && pe[T_PE].mv_snd_stoprq == 2) {
              pe[T_PE].mcr[MVST].mvst.sendst = 0;
              pe[T_PE].mv_snd_stoprq = 0;
            }
          }
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp
           && !pe[T_PE].mcr[MRPRMI].mrprmi.rcvsrp) {
            if (pe[T_PE].mcr[MVST].mvst.recvst == 1 && pe[T_PE].mv_rcv_stoprq == 2) {
              pe[T_PE].mcr[MVST].mvst.recvst = 0;
              pe[T_PE].mv_rcv_stoprq = 0;
            }
          }
          if (!(pe[T_PE].mcr[MRPRMI].ful & 0xf0000000))
            pe[T_PE].ext_interrupt &= ~MV_INTERRUPT;
          break;

        case MCMDW:
          pe[T_PE].smcr[MCMDW].ful = 0xfffffffc | *d;
          break;
          
	case SPIDW:
	case HWU0TW:
	case HRU0TW:
	case HWU1TW:
	case HRU1TW:
          if (pe[T_PE].mcr[SPIDW].spidw.spid) {
	    pe[T_PE].mcr[UAHWTW].ful = pe[T_PE].mcr[HWU1TW].ful;
	    pe[T_PE].mcr[UAHRTW].ful = pe[T_PE].mcr[HRU1TW].ful;
          }
          else {
	    pe[T_PE].mcr[UAHWTW].ful = pe[T_PE].mcr[HWU0TW].ful;
	    pe[T_PE].mcr[UAHRTW].ful = pe[T_PE].mcr[HRU0TW].ful;
          }
	  break;

	case UAHWTW:
	  if (pe[T_PE].mcr[SPIDW].spidw.spid)
	    pe[T_PE].mcr[HWU1TW].ful = pe[T_PE].mcr[UAHWTW].ful;
          else
	    pe[T_PE].mcr[HWU0TW].ful = pe[T_PE].mcr[UAHWTW].ful;
	  break;

	case UAHRTW:
	  if (pe[T_PE].mcr[SPIDW].spidw.spid)
	    pe[T_PE].mcr[HRU1TW].ful = pe[T_PE].mcr[UAHRTW].ful;
          else
	    pe[T_PE].mcr[HRU0TW].ful = pe[T_PE].mcr[UAHRTW].ful;
	  break;

	case MPSTA:
	case MPSTP:
	case MPRST:
          pe[T_PE].smcr[num].ful = MCRINFO[num].w_mask&~0;
          break;
#endif

#ifdef DAPF
	case SDAPSG:
          pe[T_PE].smcr[SDAPSG].ful = MCRINFO[SDAPSG].w_mask&~0;
          break;

        case SVSCTL:
          if (!pe[T_PE].mcr[SVSCTL].ful)
            pe[T_PE].ext_interrupt &= ~SVS_INTERRUPT;
          break;
#endif

#ifdef BARRIER
	case BSDCMC:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0:
	    pe[T_PE].sr[STAR1].star1.es2 = 0;
            pe[T_PE].sr[STAR1].star1.es3 = 0;
	    break;
          case 1:
	    pe[T_PE].sr[STAR1].star1.es2 = pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0;
            pe[T_PE].sr[STAR1].star1.es3 = 0;
	    break;
          case 2:
	    pe[T_PE].sr[STAR1].star1.es2 = pe[T_PE].mcr[LBSY1W].lbsy1w.lbsy1;
            pe[T_PE].sr[STAR1].star1.es3 = 0;
	    break;
	  case 3:
	    pe[T_PE].sr[STAR1].star1.es2 = pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0;
	    pe[T_PE].sr[STAR1].star1.es3 = pe[T_PE].mcr[LBSY1W].lbsy1w.lbsy1;
	    break;
	  }
	  break;

	case BMSKU00:
	case BMSKU01:
	case BMSKU02:
	case BMSKU03:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0:         break;
	  case 1: case 3: pe[T_PE].mcr[num-BMSKU00+BMSK00].ful = *d; break;
	  case 2:         pe[T_PE].mcr[num-BMSKU00+BMSK10].ful = *d; break;
          }
	  break;

	case BMSKU10:
	case BMSKU11:
	case BMSKU12:
	case BMSKU13:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0:         break;
          case 1: case 2: break;
	  case 3:         pe[T_PE].mcr[num-BMSKU10+BMSK10].ful = *d; break;
          }
	  break;

	case LBSY0W:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 2: break;
	  case 1: case 3: pe[T_PE].sr[STAR1].star1.es2 = *d; break;
          }
	  break;

	case LBSY1W:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 1: break;
          case 2:         pe[T_PE].sr[STAR1].star1.es2 = *d; break;
	  case 3:         pe[T_PE].sr[STAR1].star1.es3 = *d; break;
          }
	  break;
#endif

#ifdef SSUMOVER
        case SMCTL:
        case SMSTP:
        case SMCLR:
          pe[T_PE].smcr[num].ful = MCRINFO[num].w_mask&~0;
          break;

        case SMIN:
          if (!pe[T_PE].mcr[SMIN].ful) {
            pe[T_PE].ext_interrupt &= ~SSU_INTERRUPT;
            if (pe[T_PE].ssumv_status == STATUS_SINTR)
	      pe[T_PE].ssumv_status = STATUS_SSLEEP;
          }
          break;
#endif

#ifdef GSIGP
        case GHCTL:
          pe[T_PE].smcr[GHCTL].ful = MCRINFO[GHCTL].w_mask&~0;
          break;

	case GHIN:
	  if (!pe[T_PE].mcr[GHIN].ful)
            pe[T_PE].ext_interrupt &= ~GSIGP_INTERRUPT;
	  if (!pe[T_PE].mcr[GHIN].ghin.cscin) {
            pe[T_PE].mcr[GHII0].ful = 0xffffffff;
            pe[T_PE].mcr[GHII1].ful = 0xffffffff;
            pe[T_PE].mcr[GHII2].ful = 0xffffffff;
          }
	  break;
#endif

#ifdef FSBA
        case IOCCBS:
          pe[T_PE].smcr[IOCCBS].ful = MCRINFO[IOCCBS].w_mask&~0;
          break;

        case ICISTA:
          if (!pe[T_PE].mcr[ICISTA].icista.rppend) {
            pe[T_PE].mcr[IOCRB0].ful = 0xffffffff;
            pe[T_PE].mcr[IOCRB1].ful = 0xffffffff;
            pe[T_PE].mcr[IOCRB2].ful = 0xffffffff;
            pe[T_PE].mcr[IOCRB3].ful = 0xffffffff;
          }
          break;

        case FSBARP:
          if (!pe[T_PE].mcr[FSBARP].ful)
            pe[T_PE].ext_interrupt &= ~FSBA_INTERRUPT;
          break;
#endif

        default:
          pe[T_PE].smcr[num].ful = MCRINFO[num].w_mask&*d;
          break;
        }
        return(0);
    }
    else {
        message("internal error: cmd_mcr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

cmd_smcr_access(t_pe, addr, len, rw, d) unsigned t_pe, addr, len, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned num = addr >> 3;

    if (num >= MCR_NUM) {
        message("not exist: smcr%x\n", addr);
        return(1);
    }
    if (len != 4) {
        message("illegal: smcr len=%u\n", len);
        return(1);
    }
    if (addr & (len-1)) {
        message("not aligned: smcr addr=0x%08.8X len=%u\n", addr, len);
        return(1);
    }

    if (num >= MCR_REALNUM || addr & 4) {
        if (rw == _R_) *d = 0;
        return(0);
    }

    if (rw == _R_) {
        *d = pe[T_PE].smcr[num].ful;
        return(0);
    }
    else {
        message("internal error: cmd_smcr_access.rw=0x%X (must be _R_)\n", rw);
        return(1);
    }
}

sys_mcr_access(t_pe, addr, rw, d) unsigned t_pe, addr, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return RW_MCR_P_EXCEPTION   if protected */
    /* return RW_SUCCESS           if scceeded  */
{
    unsigned num = (addr >> 3) & (MCR_NUM-1);

    if (pe[T_PE].sr[PEV].pev.u && pe[T_PE].sr[PEV].pev.spu) {
      if (!(pe[T_PE].mcr[MCRUAA].ful & ((unsigned)0x80000000 >> (num >> 8)))) {
        pe[T_PE].work_ird0.cir  = 1;
        pe[T_PE].work_ird1.crr3 = 1;
        return(RW_MCR_P_EXCEPTION);
      }
    }

    if (num >= MCR_REALNUM || addr & 4) {
        if (rw == _R_) *d = 0;
        return(RW_SUCCESS);
    }

    if (rw == _R_) {
        switch (num) {

#ifdef MOVER
        case MPDTW:
          if (pe[T_PE].mcr[MPSTW].mpstw.mpst)
              *d = ~0;
          else
              *d = pe[T_PE].mv_pa[pe[T_PE].smcr[MPCIDW].mpcidw.mpcid];
          break;
#endif

        default:
          *d = pe[T_PE].mcr[num].ful;
          break;
        }
        return(RW_SUCCESS);
    }
    else if (rw & _W_) {
        pe[T_PE].mcr[num].ful
         =(((MCRINFO[num].r_mask&pe[T_PE].mcr[num].ful)^MCRINFO[num].rev)
         |  (MCRINFO[num].w_mask&*d)
         | ((MCRINFO[num].r_mask&MCRINFO[num].w_mask)^MCRINFO[num].rev))
         ^   MCRINFO[num].rev;
        switch (num) {

        case FSVSG:
          pe[T_PE].smcr[FSVSG].ful = MCRINFO[FSVSG].w_mask&~0;
          break;

#ifdef IVT_INTR
        case IVT:
          if (!(*d>>31))
            pe[T_PE].ext_interrupt &= ~IVT_INTERRUPT;
          break;
#endif

#ifdef MOVER
        case MRPRMI:
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.sndmrp) {
            pe[T_PE].mcr[SNDMRI].ful = 0x0cf81dec;
	    pe[T_PE].mcr[SMIPHI].ful = 0xffffff8f;
	  }
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp) {
            if (!*(unsigned*)&pe[T_PE].mv_mrprmi) {
              pe[T_PE].mcr[MRPRMI].ful &= 0xf0000000;
              pe[T_PE].mcr[MRPRMI].ful |= 0x0f7ffdff;
            }
            else {
              pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp = 1;
              pe[T_PE].mcr[MRPRMI].ful &= 0xf0000000;
              pe[T_PE].mcr[MRPRMI].ful |= (*(unsigned*)&pe[T_PE].mv_mrprmi);
              *(unsigned*)&pe[T_PE].mv_mrprmi = 0;
            }
	  }
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.sndmrp
           && !pe[T_PE].mcr[MRPRMI].mrprmi.sndsrp) {
            if (pe[T_PE].mcr[MVST].mvst.sendst == 1 && pe[T_PE].mv_snd_stoprq == 2) {
              pe[T_PE].mcr[MVST].mvst.sendst = 0;
              pe[T_PE].mv_snd_stoprq = 0;
            }
          }
          if (!pe[T_PE].mcr[MRPRMI].mrprmi.rcvmrp
           && !pe[T_PE].mcr[MRPRMI].mrprmi.rcvsrp) {
            if (pe[T_PE].mcr[MVST].mvst.recvst == 1 && pe[T_PE].mv_rcv_stoprq == 2) {
              pe[T_PE].mcr[MVST].mvst.recvst = 0;
              pe[T_PE].mv_rcv_stoprq = 0;
            }
          }
          if (!(pe[T_PE].mcr[MRPRMI].ful & 0xf0000000))
            pe[T_PE].ext_interrupt &= ~MV_INTERRUPT;
          break;

        case MCMDW:
          pe[T_PE].smcr[MCMDW].ful = 0xfffffffc | *d;
          break;
          
        case SPIDW:
        case HWU0TW:
        case HRU0TW:
        case HWU1TW:
        case HRU1TW:
          if (pe[T_PE].mcr[SPIDW].spidw.spid) {
            pe[T_PE].mcr[UAHWTW].ful = pe[T_PE].mcr[HWU1TW].ful;
            pe[T_PE].mcr[UAHRTW].ful = pe[T_PE].mcr[HRU1TW].ful;
          }
          else {
            pe[T_PE].mcr[UAHWTW].ful = pe[T_PE].mcr[HWU0TW].ful;
            pe[T_PE].mcr[UAHRTW].ful = pe[T_PE].mcr[HRU0TW].ful;
          }
          break;

        case UAHWTW:
          if (pe[T_PE].mcr[SPIDW].spidw.spid)
            pe[T_PE].mcr[HWU1TW].ful = pe[T_PE].mcr[UAHWTW].ful;
          else
            pe[T_PE].mcr[HWU0TW].ful = pe[T_PE].mcr[UAHWTW].ful;
          break;

        case UAHRTW:
          if (pe[T_PE].mcr[SPIDW].spidw.spid)
            pe[T_PE].mcr[HRU1TW].ful = pe[T_PE].mcr[UAHRTW].ful;
          else
            pe[T_PE].mcr[HRU0TW].ful = pe[T_PE].mcr[UAHRTW].ful;
          break;

	case MPSTA:
	case MPSTP:
	case MPRST:
          pe[T_PE].smcr[num].ful = MCRINFO[num].w_mask&~0;
          break;
#endif

#ifdef DAPF
	case SDAPSG:
          pe[T_PE].smcr[SDAPSG].ful = MCRINFO[SDAPSG].w_mask&~0;
          break;

        case SVSCTL:
          if (!pe[T_PE].mcr[SVSCTL].ful)
            pe[T_PE].ext_interrupt &= ~SVS_INTERRUPT;
          break;
#endif

#ifdef BARRIER
	case BSDCMC:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0:
	    pe[T_PE].sr[STAR1].star1.es2 = 0;
            pe[T_PE].sr[STAR1].star1.es3 = 0;
	    break;
          case 1:
	    pe[T_PE].sr[STAR1].star1.es2 = pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0;
            pe[T_PE].sr[STAR1].star1.es3 = 0;
	    break;
          case 2:
	    pe[T_PE].sr[STAR1].star1.es2 = pe[T_PE].mcr[LBSY1W].lbsy1w.lbsy1;
            pe[T_PE].sr[STAR1].star1.es3 = 0;
	    break;
	  case 3:
	    pe[T_PE].sr[STAR1].star1.es2 = pe[T_PE].mcr[LBSY0W].lbsy0w.lbsy0;
	    pe[T_PE].sr[STAR1].star1.es3 = pe[T_PE].mcr[LBSY1W].lbsy1w.lbsy1;
	    break;
	  }
	  break;

	case BMSKU00:
	case BMSKU01:
	case BMSKU02:
	case BMSKU03:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0:         break;
	  case 1: case 3: pe[T_PE].mcr[num-BMSKU00+BMSK00].ful = *d; break;
	  case 2:         pe[T_PE].mcr[num-BMSKU00+BMSK10].ful = *d; break;
          }
	  break;

	case BMSKU10:
	case BMSKU11:
	case BMSKU12:
	case BMSKU13:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0:         break;
          case 1: case 2: break;
	  case 3:         pe[T_PE].mcr[num-BMSKU10+BMSK10].ful = *d; break;
          }
	  break;

	case LBSY0W:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 2: break;
	  case 1: case 3: pe[T_PE].sr[STAR1].star1.es2 = *d; break;
          }
	  break;

	case LBSY1W:
	  switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
          case 0: case 1: break;
          case 2:         pe[T_PE].sr[STAR1].star1.es2 = *d; break;
	  case 3:         pe[T_PE].sr[STAR1].star1.es3 = *d; break;
          }
	  break;
#endif

#ifdef SSUMOVER
        case SMCTL:
        case SMSTP:
        case SMCLR:
          pe[T_PE].smcr[num].ful = MCRINFO[num].w_mask&~0;
          break;

        case SMIN:
          if (!pe[T_PE].mcr[SMIN].ful) {
            pe[T_PE].ext_interrupt &= ~SSU_INTERRUPT;
            if (pe[T_PE].ssumv_status == STATUS_SINTR)
	      pe[T_PE].ssumv_status = STATUS_SSLEEP;
          }
          break;
#endif

#ifdef GSIGP
        case GHCTL:
          pe[T_PE].smcr[GHCTL].ful = MCRINFO[GHCTL].w_mask&~0;
          break;

	case GHIN:
	  if (!pe[T_PE].mcr[GHIN].ful)
            pe[T_PE].ext_interrupt &= ~GSIGP_INTERRUPT;
	  if (!pe[T_PE].mcr[GHIN].ghin.cscin) {
            pe[T_PE].mcr[GHII0].ful = 0xffffffff;
            pe[T_PE].mcr[GHII1].ful = 0xffffffff;
            pe[T_PE].mcr[GHII2].ful = 0xffffffff;
          }
	  break;
#endif

#ifdef FSBA
        case IOCCBS:
          pe[T_PE].smcr[IOCCBS].ful = MCRINFO[IOCCBS].w_mask&~0;
          break;

        case ICISTA:
          if (!pe[T_PE].mcr[ICISTA].icista.rppend) {
            pe[T_PE].mcr[IOCRB0].ful = 0xffffffff;
            pe[T_PE].mcr[IOCRB1].ful = 0xffffffff;
            pe[T_PE].mcr[IOCRB2].ful = 0xffffffff;
            pe[T_PE].mcr[IOCRB3].ful = 0xffffffff;
          }
          break;

        case FSBARP:
          if (!pe[T_PE].mcr[FSBARP].ful)
            pe[T_PE].ext_interrupt &= ~FSBA_INTERRUPT;
          break;
#endif

        default:
          pe[T_PE].smcr[num].ful = MCRINFO[num].w_mask&*d;
          break;
        }
        return(RW_SUCCESS);
    }
}
#endif

#ifdef VCP

/*************************************************************************
*                    VECTOR						 *
*************************************************************************/

/******************* VP *************************************************/

#if 0
sys_vp_lock(t_pe) unsigned t_pe;
{
    pe[T_PE].vp_score = SCORE_BUSY;
}
#endif

#if 0
sys_vp_unlock(t_pe) unsigned t_pe;
{       
    pe[T_PE].vp_score = SCORE_FREE;
} 
#endif

#if 0
sys_vp_check_score(t_pe) unsigned t_pe;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
    return(pe[T_PE].vp_score);
}
#endif

/******************* VR *************************************************/

struct vrinfo { char *name; };
struct vrinfo VRINFO[VR_NUM] = {
#define    DEF_VR(NAME) { NAME },
#include   "vr-name.def"
#undef     DEF_VR
};
#define    VRHASH_SIZE     (VR_NUM*2)
#define    vrrehash(x)     ((x+137) % VRHASH_SIZE)
struct     vrhash  { char *name; unsigned vrnum; };
struct     vrhash  VRHASH[VRHASH_SIZE];

init_vrhash()
{
    unsigned i;

    for (i=0; i<VR_NUM; i++)
        VRHASH[put_vrhash(VRINFO[i].name)].vrnum = i;
}

vr_hash(s) char *s;
{
    unsigned hashval;
    
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % VRHASH_SIZE);
}

put_vrhash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = vr_hash(name);
    while (VRHASH[hashval].name != NULL) {
        if (!strcmp(name, VRHASH[hashval].name)) return(hashval);
        hashval = vrrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (VRHASH[hashval].name != NULL) message("too many vr names\n");
    VRHASH[hashval].name = name;
    return(hashval);
}

get_vrnumber(name) char *name;
{
    unsigned  hashval, hashsave;
 
    hashval = hashsave = vr_hash(name);
    while (VRHASH[hashval].name != NULL) {
        if (!strcmp(name, VRHASH[hashval].name))
            return(VRHASH[hashval].vrnum);
        hashval = vrrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not vr\n", name); */
    return(VR_NUM);
}

randomize_vr(t_pe) unsigned t_pe;
{
    unsigned i, j, k;

    for (i=0; i<VR_NUM; i++) {
      for (j=0; j<VRL; j++) {
        k = ((unsigned char)i<<24)+((unsigned char)j<<16)+((unsigned char)i<<8)+(unsigned char)j;
        pe[T_PE].vr[i][j].u = pe[T_PE].vr[i][j].l = k;
      }
    }
}

get_vlmask(vl) unsigned vl;
{
    if      (vl > VRL*16) { return(31); }
    else if (vl > VRL*8 ) { return(15); }
    else if (vl > VRL*4 ) { return( 7); }
    else if (vl > VRL*2 ) { return( 3); }
    else if (vl > VRL   ) { return( 1); }
    else		  { return( 0); }
}

get_vrselect(t_pe, select, num, retsel, retnum)
    unsigned t_pe, select, num, *retsel, *retnum;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned vl, i;

    if (select >= VR_NUM) {
      message("not exist: vr%u\n", select);
      return(1);
    }

/*
    if (num <= VRL) { 
      *retsel = select;
      *retnum = num-1;
      return(0);
    }

    vl = pe[T_PE].vcr[0].vcr0.vl;
    if (vl > VRL*32) {
      message("too long: vcr0.vl=%u\n", vl);
      return(1);
    }

    i = get_vlmask(vl);

    if (select & i) {
      message("not exist: vr%u\n", select);
      return(1);
    }
    else if (num == 0 || num > VRL*(i+1)) {
      message("not exist: vr%u.%u\n", select, num);
      return(1);
    }
*/

    for (i=1; i<32; i*=2) {
      if (select & i)
        break;
    }

    if (num > VRL*i) {
      message("not exist: vr%u.%u\n", select, num);
      return(1);
    }

    *retsel = select + ((num-1) / VRL);
    *retnum = (num-1) & (VRL-1);
    return(0);
}

cmd_vr_access(t_pe, select, num, rw, d1, d2) unsigned t_pe, select, num, rw, *d1, *d2;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (get_vrselect(t_pe, select, num, &select, &num))
        return(1);

    if (rw == _R_) {
        *d1 = pe[T_PE].vr[select][num].u;
        *d2 = pe[T_PE].vr[select][num].l;
        return(0);
    }
    else if (rw == _W_) {
        pe[T_PE].vr[select][num].u = *d1;
        pe[T_PE].vr[select][num].l = *d2;
        return(0);
    }
    else {
        message("internal error: cmd_vr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

#if 0
sys_vr_lock(t_pe, select, rw) unsigned t_pe, select, rw;
{
#ifdef DEBUG
    if (select >= VR_NUM) {
        message("not exist(sys): vr%u\n", select);
        return;
    }
#endif
    if (rw == _R_)
        pe[T_PE].vr_rscore[select]++;
    else if (rw == _W_)
        pe[T_PE].vr_wscore[select] = 1;
}
#endif

#if 0
sys_vr_unlock(t_pe, select, rw) unsigned t_pe, select, rw;
{       
#ifdef DEBUG
    if (select >= VR_NUM) {
        message("not exist(sys): vr%u\n", select);
        return;
    }
#endif  
    if (rw == _R_)
        pe[T_PE].vr_rscore[select]--;
    else if (rw == _W_)
        pe[T_PE].vr_wscore[select] = 0;
} 
#endif

#if 0
sys_vr_check_score(t_pe, select, rw) unsigned t_pe, select, rw;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
#ifdef DEBUG
    if (select >= VR_NUM) {
        message("not exist(sys): vr%u\n", select);
        return(SCORE_BUSY);
    }
#endif
    return(rw == _R_
      ? (pe[T_PE].vr_wscore[select] > 0
        ? (pe[T_PE].vr_wr_conflict[select]++, SCORE_BUSY) : SCORE_FREE)
    : rw == _W_
      ? (pe[T_PE].vr_rscore[select] > 0
        ? (pe[T_PE].vr_rw_conflict[select]++, SCORE_BUSY)
      : (pe[T_PE].vr_wscore[select] > 0
        ? (pe[T_PE].vr_ww_conflict[select]++, SCORE_BUSY) : SCORE_FREE))
    : SCORE_FREE);
}
#endif

#if 0
sys_vr_access(t_pe, select, num, rw, d1, d2)
    unsigned t_pe, select, num, rw, *d1, *d2;
    /* rw ... _R_: read _W_ : write */
{
    if (rw == _R_) {
      *d1 = pe[T_PE].vr[select+((num-1)/VRL)][(num-1)&(VRL-1)].u;
      *d2 = pe[T_PE].vr[select+((num-1)/VRL)][(num-1)&(VRL-1)].l;
    }
    else if (rw == _W_) {
      pe[T_PE].vr[select+((num-1)/VRL)][(num-1)&(VRL-1)].u = *d1;
      pe[T_PE].vr[select+((num-1)/VRL)][(num-1)&(VRL-1)].l = *d2;
    }
}
#endif

/******************* MR *************************************************/

struct mrinfo { char *name; };
struct mrinfo MRINFO[MR_NUM] = {
#define    DEF_MR(NAME) { NAME },
#include   "mr-name.def"
#undef     DEF_MR
};
#define    MRHASH_SIZE     (MR_NUM*2)
#define    mrrehash(x)     ((x+137) % MRHASH_SIZE)
struct     mrhash  { char *name; unsigned mrnum; };
struct     mrhash  MRHASH[MRHASH_SIZE];

init_mrhash()
{
    unsigned i;

    for (i=0; i<MR_NUM; i++)
        MRHASH[put_mrhash(MRINFO[i].name)].mrnum = i;
}

mr_hash(s) char *s;
{
    unsigned hashval;
    
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % MRHASH_SIZE);
}

put_mrhash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = mr_hash(name);
    while (MRHASH[hashval].name != NULL) {
        if (!strcmp(name, MRHASH[hashval].name)) return(hashval);
        hashval = mrrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (MRHASH[hashval].name != NULL) message("too many mr names\n");
    MRHASH[hashval].name = name;
    return(hashval);
}

get_mrnumber(name) char *name;
{
    unsigned  hashval, hashsave;
 
    hashval = hashsave = mr_hash(name);
    while (MRHASH[hashval].name != NULL) {
        if (!strcmp(name, MRHASH[hashval].name))
            return(MRHASH[hashval].mrnum);
        hashval = mrrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not mr\n", name); */
    return(MR_NUM);
}

randomize_mr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<MR_NUM; i++) {
      pe[T_PE].mr[i].u = pe[T_PE].mr[i].l = ~0;
    }
}

get_mrselect(t_pe, select, num, retsel, retnum)
    unsigned t_pe, select, num, *retsel, *retnum;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned vl, i;

    if (select >= MR_NUM) {
      message("not exist: mr%u\n", select);
      return(1);
    }

/*
    if (num <= VRL) { 
      *retsel = select;
      *retnum = num-1;
      return(0);
    }

    vl = pe[T_PE].vcr[0].vcr0.vl;
    if (vl > VRL*32) {
      message("too long: vcr0.vl=%u\n", vl);
      return(1);
    }

    i = get_vlmask(vl);

    if (select & i) {
      message("not exist: mr%u\n", select);
      return(1);
    }
    else if (num == 0 || num > VRL*(i+1)) {
      message("not exist: mr%u.%u\n", select, num);
      return(1);
    }
*/

    for (i=1; i<32; i*=2) {
      if (select & i)
        break;
    }

    if (num > VRL*i) {
      message("not exist: mr%u.%u\n", select, num);
      return(1);
    }

    *retsel = select + ((num-1) / VRL);
    *retnum = (num-1) & (VRL-1);
    return(0);
}

cmd_mr_access(t_pe, select, num, len, rw, d) unsigned t_pe, select, num, len, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (!(len == 1 || (rw == _R_ && len == 32))) {
        message("illegal: mr len=%u\n", len);
        return(1);
    }
    if ((num-1) & (len-1)) {
        message("not aligned: mr num=%u len=%u\n", num, len);
        return(1);
    }

    if (get_mrselect(t_pe, select, num, &select, &num))
        return(1);

    if (rw == _R_) {
        if (num < VRL/2)
          *d = (len == 1) ? (pe[T_PE].mr[select].u >> (VRL/2-1-num)) & 1
                          : (pe[T_PE].mr[select].u);
        else
          *d = (len == 1) ? (pe[T_PE].mr[select].l >> (VRL-1-num)) & 1
                          : (pe[T_PE].mr[select].l);
        return(0);
    }
    else if (rw == _W_) {
        if (*d & 1) {
          if (num < VRL/2)
            pe[T_PE].mr[select].u |= 1 << (VRL/2-1-num);
          else
            pe[T_PE].mr[select].l |= 1 << (VRL-1-num);
        }
        else {
          if (num < VRL/2)
            pe[T_PE].mr[select].u &= ~(1 << (VRL/2-1-num));
          else
            pe[T_PE].mr[select].l &= ~(1 << (VRL-1-num));
        }
        return(0);
    }
    else {
        message("internal error: cmd_mr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

#if 0
sys_mr_lock(t_pe, select, rw, use_mr0)
    unsigned t_pe, select, rw, use_mr0;
    /* rw ... _R_: read _W_ : write */
    /* use_mr0 ... 0: mr0 is dummy, 1: mr0 is normally used */
{
#ifdef DEBUG
    if (select >= MR_NUM) {
        message("not exist(sys): mr%u\n", select);
        return;
    }
#endif
    if (select || use_mr0) {
        if (rw == _R_)
            pe[T_PE].mr_rscore[select]++;
        else if (rw == _W_)
            pe[T_PE].mr_wscore[select] = 1;
    }
}
#endif

#if 0
sys_mr_unlock(t_pe, select, rw, use_mr0)
    unsigned t_pe, select, rw, use_mr0;
    /* rw ... _R_: read _W_ : write */
    /* use_mr0 ... 0: mr0 is dummy, 1: mr0 is normally used */
{       
#ifdef DEBUG
    if (select >= MR_NUM) {
        message("not exist(sys): mr%u\n", select);
        return;
    }
#endif  
    if (select || use_mr0) {
        if (rw == _R_)
            pe[T_PE].mr_rscore[select]--;
        else if (rw == _W_)
            pe[T_PE].mr_wscore[select] = 0;
    }
} 
#endif

#if 0
sys_mr_check_score(t_pe, select, rw, use_mr0)
    unsigned t_pe, select, rw, use_mr0;
    /* rw ... _R_: read _W_ : write */
    /* use_mr0 ... 0: mr0 is dummy, 1: mr0 is normally used */
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
#ifdef DEBUG
    if (select >= MR_NUM) {
        message("not exist(sys): mr%u\n", select);
        return(SCORE_BUSY);
    }
#endif
    return((select || use_mr0)
      ? ( rw == _R_
        ? (pe[T_PE].mr_wscore[select] > 0
          ? (pe[T_PE].mr_wr_conflict[select]++, SCORE_BUSY) : SCORE_FREE)
      : rw == _W_
        ? (pe[T_PE].mr_rscore[select] > 0
          ? (pe[T_PE].mr_rw_conflict[select]++, SCORE_BUSY)
        : (pe[T_PE].mr_wscore[select] > 0
          ? (pe[T_PE].mr_ww_conflict[select]++, SCORE_BUSY) : SCORE_FREE))
      : SCORE_FREE)
    : SCORE_FREE);
}
#endif

#if 0
sys_mr_access(t_pe, select, num, rw, d, use_mr0)
    unsigned t_pe, select, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* use_mr0 ... 0: mr0 is dummy, 1: mr0 is normally used */
{
    unsigned tmp         = (num-1) & (VRL-1);

    if (select || use_mr0) {
      if (rw == _R_) {
        if (tmp < VRL/2)
          *d = (pe[T_PE].mr[select+((num-1)/VRL)].u>>(VRL/2-1-tmp)) & 1;
        else
          *d = (pe[T_PE].mr[select+((num-1)/VRL)].l>>(VRL-1-tmp)) & 1;
      }
      else if (rw == _W_) {
        if (*d & 1) {
          if (tmp < VRL/2)
            pe[T_PE].mr[select+((num-1)/VRL)].u |= 1<<(VRL/2-1-tmp);
          else
            pe[T_PE].mr[select+((num-1)/VRL)].l |= 1<<(VRL-1-tmp);
        }
        else {
          if (tmp < VRL/2)
            pe[T_PE].mr[select+((num-1)/VRL)].u &= ~(1<<(VRL/2-1-tmp));
          else
            pe[T_PE].mr[select+((num-1)/VRL)].l &= ~(1<<(VRL-1-tmp));
        }
      }
    }
    else {
      if (rw == _R_) {
        *d = 1;
      }
    }
}
#endif

/******************* VCR *************************************************/

struct vcrinfo { char *name;
                 unsigned cmd_r_mask, cmd_w_mask;
                 unsigned sys_r_mask, sys_w_mask; };
struct vcrinfo VCRINFO[VCR_NUM] = {
#define    DEF_VCR(NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK) \
                 { NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK },
#include   "vcr-name.def"
#undef     DEF_VCR
};
#define    VCRHASH_SIZE    (VCR_NUM*2)
#define    vcrrehash(x)    ((x+137) % VCRHASH_SIZE)
struct     vcrhash  { char *name; unsigned vcrnum; };
struct     vcrhash  VCRHASH[VCRHASH_SIZE];

init_vcr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<VCR_NUM; i++)
        pe[T_PE].vcr[i].ful = (VCRINFO[i].sys_r_mask | pe[T_PE].vcr[i].ful)
			     & VCRINFO[i].sys_w_mask;
}

init_vcrhash()
{
    unsigned i;

    for (i=0; i<VCR_NUM; i++)
        VCRHASH[put_vcrhash(VCRINFO[i].name)].vcrnum = i;
}

vcr_hash(s) char *s;
{
    unsigned hashval;
        
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % VCRHASH_SIZE);
}

put_vcrhash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = vcr_hash(name);
    while (VCRHASH[hashval].name != NULL) {
        if (!strcmp(name, VCRHASH[hashval].name)) return(hashval);
        hashval = vcrrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (VCRHASH[hashval].name != NULL) message("too many vcr names\n");
    VCRHASH[hashval].name = name;
    return(hashval);
}

get_vcrnumber(name) char *name;
{
    unsigned  hashval, hashsave;

    hashval = hashsave = vcr_hash(name);
    while (VCRHASH[hashval].name != NULL) {
        if (!strcmp(name, VCRHASH[hashval].name))
            return(VCRHASH[hashval].vcrnum);
        hashval = vcrrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not vcr\n", name); */
    return(VCR_NUM);
}

randomize_vcr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<VCR_NUM; i++) {
      pe[T_PE].vcr[i].ful = ~0;
    }
}

cmd_vcr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned tmp; 

    if (num >= VCR_NUM) {
        message("not exist: vcr%u\n", num);
        return(1);
    }
    if (rw == _R_) {
        *d = pe[T_PE].vcr[num].ful;
        return(0);
    }
    else if (rw == _W_) {
	if (!num && ((*d & 0xffff) > VRL * 32)) {
            message("illegal write: vcr0.vl=%u (must be 0 - VRL*32)\n", *d & 0xffff);
	    return(1);
	}
	else if (num == 1
             && (tmp = (*d & 0xf0000) >> 16) != 11 && tmp != 13 && tmp != 15) {
            message("illegal write: vcr1.ps=%u (must be 11,13,15)\n", (*d & 0xf0000) >> 16);
	    return(1);
        }
	else {
            pe[T_PE].vcr[num].ful
              = (VCRINFO[num].cmd_r_mask&pe[T_PE].vcr[num].ful)
              | (VCRINFO[num].cmd_w_mask&*d)
              | (VCRINFO[num].cmd_r_mask&VCRINFO[num].cmd_w_mask);
            if (num == 2 && !(*d & 0xffff))
              pe[T_PE].ext_interrupt &= ~VP_INTERRUPT;
            return(0);
	}
    }
    else {
        message("internal error: cmd_vcr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

sys_vcr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
{
    unsigned tmp; 

    if (rw == _R_) {
        *d = pe[T_PE].vcr[num].ful;
    }
    else if (rw == _W_) {
	if (!num && ((*d & 0xffff) > VRL * 32)) {
            pe[T_PE].vcr[2].vcr2.pif_spx = 1;
        }   
        else if (num == 1 &&
            ((tmp = (*d & 0xf0000) >> 16)) != 11 && tmp != 13 && tmp != 15) {
            pe[T_PE].vcr[2].vcr2.pif_spx = 1;
        }
	else {
            pe[T_PE].vcr[num].ful
              = (VCRINFO[num].sys_r_mask&pe[T_PE].vcr[num].ful)
              | (VCRINFO[num].sys_w_mask&*d)
              | (VCRINFO[num].sys_r_mask&VCRINFO[num].sys_w_mask);
            if (num == 2 && !(*d & 0xffff))
              pe[T_PE].ext_interrupt &= ~VP_INTERRUPT;
        }
    }
}

/******************* VUT ************************************************/

struct vutinfo { char *name;
                 unsigned cmd_r_mask, cmd_w_mask;
                 unsigned sys_r_mask, sys_w_mask; };
struct vutinfo VUTINFO[VUT_NUM] = {
#define    DEF_VUT(NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK) \
                 { NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK },
#include   "vut-name.def"
#undef     DEF_VUT
};
#define    VUTHASH_SIZE    (VUT_NUM*2)
#define    vutrehash(x)    ((x+137) % VUTHASH_SIZE)
struct     vuthash  { char *name; unsigned vutnum; };
struct     vuthash  VUTHASH[VUTHASH_SIZE];

init_vut(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<VUT_NUM; i++)
        pe[T_PE].vut[i] = (VUTINFO[i].sys_r_mask | pe[T_PE].vut[i])
		         & VUTINFO[i].sys_w_mask;
}

init_vuthash()
{
    unsigned i;

    for (i=0; i<VUT_NUM; i++)
        VUTHASH[put_vuthash(VUTINFO[i].name)].vutnum = i;
}

vut_hash(s) char *s;
{
    unsigned hashval;
        
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % VUTHASH_SIZE);
}

put_vuthash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = vut_hash(name);
    while (VUTHASH[hashval].name != NULL) {
        if (!strcmp(name, VUTHASH[hashval].name)) return(hashval);
        hashval = vutrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (VUTHASH[hashval].name != NULL) message("too many vut names\n");
    VUTHASH[hashval].name = name;
    return(hashval);
}

get_vutnumber(name) char *name;
{
    unsigned  hashval, hashsave;

    hashval = hashsave = vut_hash(name);
    while (VUTHASH[hashval].name != NULL) {
        if (!strcmp(name, VUTHASH[hashval].name))
            return(VUTHASH[hashval].vutnum);
        hashval = vutrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not vut\n", name); */
    return(VUT_NUM);
}

randomize_vut(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<VUT_NUM; i++) {
      pe[T_PE].vut[i] = ~0;
    }
}

cmd_vut_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (num >= VUT_NUM) {
        message("not exist: vut%u\n", num);
        return(1);
    }
    if (rw == _R_) {
        *d = pe[T_PE].vut[num];
        return(0);
    }
    else if (rw == _W_) {
        pe[T_PE].vut[num]
          = (VUTINFO[num].cmd_r_mask&pe[T_PE].vut[num])
          | (VUTINFO[num].cmd_w_mask&*d)
          | (VUTINFO[num].cmd_r_mask&VUTINFO[num].cmd_w_mask);
        return(0);
    }
    else {
        message("internal error: cmd_vut_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

sys_vut_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
{
    if (rw == _R_) {
        *d = pe[T_PE].vut[num];
    }
    else if (rw == _W_) {
        pe[T_PE].vut[num]
          = (VUTINFO[num].sys_r_mask&pe[T_PE].vut[num])
          | (VUTINFO[num].sys_w_mask&*d)
          | (VUTINFO[num].sys_r_mask&VUTINFO[num].sys_w_mask);
    }
}

/******************* TR *************************************************/

struct trinfo { char *name;
		unsigned cmd_r_mask, cmd_w_mask;
                unsigned sys_r_mask, sys_w_mask; };
struct trinfo TRINFO[TR_NUM] = {
#define    DEF_TR(NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK) \
                { NAME, CMD_R_MASK, CMD_W_MASK, SYS_R_MASK, SYS_W_MASK },
#include   "tr-name.def"
#undef     DEF_TR
};
#define    TRHASH_SIZE     (TR_NUM*2)
#define    trrehash(x)     ((x+137) % TRHASH_SIZE)
struct     trhash  { char *name; unsigned trnum; };
struct     trhash  TRHASH[TRHASH_SIZE];

init_tr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<TR_NUM; i++)
        pe[T_PE].tr[i].ful = (TRINFO[i].sys_r_mask | pe[T_PE].tr[i].ful)
			    & TRINFO[i].sys_w_mask;
}

init_trhash()
{
    unsigned i;

    for (i=0; i<TR_NUM; i++)
        TRHASH[put_trhash(TRINFO[i].name)].trnum = i;
}

tr_hash(s) char *s;
{
    unsigned hashval;
        
    for (hashval=0; isalnum(*s);)
        hashval += *s++;
    return(hashval % TRHASH_SIZE);
}

put_trhash(name) char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = tr_hash(name);
    while (TRHASH[hashval].name != NULL) {
        if (!strcmp(name, TRHASH[hashval].name)) return(hashval);
        hashval = trrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (TRHASH[hashval].name != NULL) message("too many tr names\n");
    TRHASH[hashval].name = name;
    return(hashval);
}

get_trnumber(name) char *name;
{
    unsigned  hashval, hashsave;
 
    hashval = hashsave = tr_hash(name);
    while (TRHASH[hashval].name != NULL) {
        if (!strcmp(name, TRHASH[hashval].name))
            return(TRHASH[hashval].trnum);
        hashval = trrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not tr\n", name); */
    return(TR_NUM);
}

randomize_tr(t_pe) unsigned t_pe;
{
    unsigned i, j;

    for (i=0; i<TR_NUM; i++) {
      j = ((unsigned char)i<<24)+((unsigned char)i<<16)+((unsigned char)i<<8)+(unsigned char)i;
      pe[T_PE].tr[i].ful = j;
    }
}

cmd_tr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_ : write */
    /* return 1 if failed, 0 if succeeded */
{
    if (num >= TR_NUM) {
        message("not exist: tr%u\n", num);
        return(1);
    }
    if (rw == _R_) {
        *d = pe[T_PE].tr[num].ful;
        return(0);
    }
    else if (rw == _W_) {
        pe[T_PE].tr[num].ful
          = (TRINFO[num].sys_r_mask&pe[T_PE].tr[num].ful)
          | (TRINFO[num].sys_w_mask&*d)
          | (TRINFO[num].sys_r_mask&SRINFO[num].sys_w_mask);
        return(0);
    }
    else {
        message("internal error: cmd_tr_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

sys_tr_access(t_pe, num, rw, d) unsigned t_pe, num, rw, *d;
    /* rw ... _R_: read _W_: write */
{
    if (rw == _R_) {
        *d = pe[T_PE].tr[num].ful;
    }
    else if (rw == _W_) {
        pe[T_PE].tr[num].ful
          = (TRINFO[num].sys_r_mask&pe[T_PE].tr[num].ful)
          | (TRINFO[num].sys_w_mask&*d)
          | (TRINFO[num].sys_r_mask&SRINFO[num].sys_w_mask);
    }
}

#endif

#ifdef FSBA

/*************************************************************************
*                    FSBA						 *
*************************************************************************/

/******************* FSCR *************************************************/

init_fscr(t_pe) unsigned t_pe;
{
    unsigned t_fsba;

    for (t_fsba=0; t_fsba<FSBA_NUM; t_fsba++)
      *(unsigned*)&pe[T_PE].fscr[T_FSBA] = 0;
}

/******************* FSIR *************************************************/

struct fsirinfo { char *name; unsigned char r_mask, w_mask; };
struct fsirinfo FSIRINFO[FSIR_NUM] = {
#define    DEF_FSIR(NAME, R_MASK, W_MASK) \
                  { NAME, R_MASK, W_MASK },
#include   "fsir-name.def"
#undef     DEF_FSIR
};

init_fsir(t_pe) unsigned t_pe;
{
    unsigned i, t_fsba;

    for (t_fsba=0; t_fsba<FSBA_NUM; t_fsba++) {
        for (i=0; i<FSIR_NUM; i++)
            *((unsigned char *)&pe[T_PE].fsir[T_FSBA] + i)
                = (FSIRINFO[i].r_mask | *((unsigned char *)&pe[T_PE].fsir[T_FSBA] + i))
	         & FSIRINFO[i].w_mask;
    }
}

sys_fsir_access(t_pe, t_fsba, num, rw) unsigned t_pe, t_fsba, num, rw;
{
    switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
    case 3:
    case 1:
    case 0:
        if (!(num & pe[T_PE].mcr[IOCCB2].ioccb2.bc))
            break;
    default:
        pe[T_PE].mcr[IOCRB2].iocrb2.status = 0x02;
        return;
        break;
    }

    if (num >= FSIR_NUM) {
        pe[T_PE].mcr[IOCRB2].iocrb2.cc = 1;
        return;
    }
    
    if (rw == _R_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 8) { /* read */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].fsir[T_FSBA]+(num>>2));
            break;
        case 1:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].fsir[T_FSBA]+(num>>2))&((unsigned)0xffff0000>>((num&2)<<3));
            break;
        case 0:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].fsir[T_FSBA]+(num>>2))&((unsigned)0xff000000>>((num&3)<<3));
            break;
        }
    }
    else if (rw == _W_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 12) { /* write */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num+3)
                = (FSIRINFO[num+3].r_mask & *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num+3))
                | (FSIRINFO[num+3].w_mask & (pe[T_PE].mcr[IOCCB5].ful   ))
                | (FSIRINFO[num+3].r_mask & FSIRINFO[num+3].w_mask);
            *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num+2)
                = (FSIRINFO[num+2].r_mask & *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num+2))
                | (FSIRINFO[num+2].w_mask & (pe[T_PE].mcr[IOCCB5].ful>>8))
                | (FSIRINFO[num+2].r_mask & FSIRINFO[num+2].w_mask);
        case 1:
            *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num+1)
                = (FSIRINFO[num+1].r_mask & *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num+1))
                | (FSIRINFO[num+1].w_mask & (pe[T_PE].mcr[IOCCB5].ful>>((~num&2)<<3)))
                | (FSIRINFO[num+1].r_mask & FSIRINFO[num+1].w_mask);
        case 0:
            *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num  )
                = (FSIRINFO[num  ].r_mask & *((unsigned char *)&pe[T_PE].fsir[T_FSBA]+num  ))
                | (FSIRINFO[num  ].w_mask & (pe[T_PE].mcr[IOCCB5].ful>>((~num&3)<<3)))
                | (FSIRINFO[num  ].r_mask & FSIRINFO[num  ].w_mask);
            break;
        }
    }
}

#endif

#ifdef FST

/*************************************************************************
*                    FST						 *
*************************************************************************/

/******************* FSTCR **********************************************/

struct fstcrinfo { char *name; unsigned short r_mask, w_mask; };
struct fstcrinfo FSTCRINFO[FSTCR_NUM] = {
#define    DEF_FSTCR(NAME, R_MASK, W_MASK) \
                   { NAME, R_MASK, W_MASK },
#include   "fstcr-name.def"
#undef     DEF_FSTCR
};

init_fstcr(t_pe) unsigned t_pe;
{
    unsigned i, t_fsba;

    for (t_fsba=0; t_fsba<FSBA_NUM; t_fsba++) {
        for (i=0; i<FSTCR_NUM; i++)
            *((unsigned short *)&pe[T_PE].fstcr[T_FSBA] + i)
                = (FSTCRINFO[i].r_mask | *((unsigned short *)&pe[T_PE].fstcr[T_FSBA] + i))
	         & FSTCRINFO[i].w_mask;
    }
}

sys_fstcr_access(t_pe, t_fsba, num, rw) unsigned t_pe, t_fsba, num, rw;
{
    switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
    case 3:
    case 1:
    case 0:
        if (!(num & pe[T_PE].mcr[IOCCB2].ioccb2.bc))
            break;
    default:
        pe[T_PE].mcr[IOCRB2].iocrb2.status = 0x02;
        return;
        break;
    }

    num >>= 1;

    if (rw == _R_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 1) { /* read */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].fstcr[T_FSBA]+(num>>1));
            break;
        case 1:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].fstcr[T_FSBA]+(num>>1))&((unsigned)0xffff0000>>((num&1)<<4));
            break;
        case 0:
            pe[T_PE].mcr[IOCRB2].iocrb2.cc = 1;
            break;
        }
    }
    else if (rw == _W_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 1) { /* write */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            *((unsigned short *)&pe[T_PE].fstcr[T_FSBA]+num+1)
                = (FSTCRINFO[num+1].r_mask & *((unsigned short *)&pe[T_PE].fstcr[T_FSBA]+num+1))
                | (FSTCRINFO[num+1].w_mask & (pe[T_PE].mcr[IOCCB5].ful   ))
                | (FSTCRINFO[num+1].r_mask & FSTCRINFO[num+1].w_mask);
        case 1:
            *((unsigned short *)&pe[T_PE].fstcr[T_FSBA]+num  )
                = (FSTCRINFO[num  ].r_mask & *((unsigned short *)&pe[T_PE].fstcr[T_FSBA]+num  ))
                | (FSTCRINFO[num  ].w_mask & (pe[T_PE].mcr[IOCCB5].ful>>((~num&1)<<4)))
                | (FSTCRINFO[num  ].r_mask & FSTCRINFO[num  ].w_mask);
            break;
        case 0:
            pe[T_PE].mcr[IOCRB2].iocrb2.cc = 1;
            break;
        }
    }
}

/******************* FSTMEM **********************************************/

sys_fstmem_access(t_pe, t_fsba, addr, rw) unsigned t_pe, t_fsba, addr, rw;
{
    switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
    case 3:
    case 1:
    case 0:
        if (!(pe[T_PE].mcr[IOCCB3].ful & pe[T_PE].mcr[IOCCB2].ioccb2.bc))
            break;
    default:
        pe[T_PE].mcr[IOCRB2].iocrb2.status = 0x02;
        return;
        break;
    }

    if (!pe[T_PE].fstcr[T_FSBA].ase || 
      (pe[T_PE].mcr[IOCCB3].ful&0xffc000)!=(0xe00000|(pe[T_PE].fstcr[T_FSBA].asr<<14))) {
        pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
        return;
    }
    
    if (rw == _R_ && pe[T_PE].fstcr[T_FSBA].dpi) {
        pe[T_PE].mcr[IOCRB2].iocrb2.cc = 2;
        return;
    }

    if (pe[T_PE].fstcr[T_FSBA].berr) {
        pe[T_PE].mcr[IOCRB2].iocrb2.cc = 1;
        return;
    }

    if (rw == _R_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 10) { /* read */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)pe[T_PE].fstmem[T_FSBA]+(addr>>2));
            break;
        case 1:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)pe[T_PE].fstmem[T_FSBA]+(addr>>2))&((unsigned)0xffff0000>>((addr&2)<<3));
            break;
        case 0:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)pe[T_PE].fstmem[T_FSBA]+(addr>>2))&((unsigned)0xff000000>>((addr&3)<<3));
            break;
        }
    }
    else if (rw == _W_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 13) { /* write */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            pe[T_PE].fstmem[T_FSBA][addr+3] = pe[T_PE].mcr[IOCCB5].ful;
            pe[T_PE].fstmem[T_FSBA][addr+2] = pe[T_PE].mcr[IOCCB5].ful>>8;
        case 1:
            pe[T_PE].fstmem[T_FSBA][addr+1] = pe[T_PE].mcr[IOCCB5].ful>>((~addr&2)<<3);
        case 0:
            pe[T_PE].fstmem[T_FSBA][addr  ] = pe[T_PE].mcr[IOCCB5].ful>>((~addr&3)<<3);
            break;
        }
    }
}

#endif

#ifdef DASD

/*************************************************************************
*                    DASD						 *
*************************************************************************/

/******************* ACR ************************************************/

struct acrinfo { char *name; unsigned char r_mask, w_mask; };
struct acrinfo ACRINFO[ACR_NUM] = {
#define    DEF_ACR(NAME, R_MASK, W_MASK) \
                 { NAME, R_MASK, W_MASK },
#include   "acr-name.def"
#undef     DEF_ACR
};

init_acr(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<ACR_NUM; i++)
        *((unsigned char *)&pe[T_PE].acr + i)
            = (ACRINFO[i].r_mask | *((unsigned char *)&pe[T_PE].acr + i))
             & ACRINFO[i].w_mask;
}

sys_acr_access(t_pe, num, rw) unsigned t_pe, num, rw;
{
    switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
    case 3:
    case 1:
    case 0:
        if (!(num & pe[T_PE].mcr[IOCCB2].ioccb2.bc))
            break;
    default:
        pe[T_PE].mcr[IOCRB2].iocrb2.status = 0x02;
        return;
        break;
    }

    if (num >= ACR_NUM) {
        pe[T_PE].mcr[IOCRB2].iocrb2.cc = 3;
        return;
    }

    if (rw == _R_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 1) { /* read */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].acr+(num>>2));
            break;
        case 1:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].acr+(num>>2))&((unsigned)0xffff0000>>((num&2)<<3));
            break;
        case 0:
            pe[T_PE].mcr[IOCRB3].ful = *((unsigned *)&pe[T_PE].acr+(num>>2))&((unsigned)0xff000000>>((num&3)<<3));
            break;
        }
    }
    else if (rw == _W_ && pe[T_PE].mcr[IOCCB2].ioccb2.sub_op == 1) { /* write */
        switch (pe[T_PE].mcr[IOCCB2].ioccb2.bc) {
        case 3:
            *((unsigned char *)&pe[T_PE].acr+num+3)
                = (ACRINFO[num+3].r_mask & *((unsigned char *)&pe[T_PE].acr+num+3))
                | (ACRINFO[num+3].w_mask & (pe[T_PE].mcr[IOCCB5].ful   ))
                | (ACRINFO[num+3].r_mask & ACRINFO[num+3].w_mask);
            *((unsigned char *)&pe[T_PE].acr+num+2)
                = (ACRINFO[num+2].r_mask & *((unsigned char *)&pe[T_PE].acr+num+2))
                | (ACRINFO[num+2].w_mask & (pe[T_PE].mcr[IOCCB5].ful>>8))
                | (ACRINFO[num+2].r_mask & ACRINFO[num+2].w_mask);
        case 1:
            *((unsigned char *)&pe[T_PE].acr+num+1)
                = (ACRINFO[num+1].r_mask & *((unsigned char *)&pe[T_PE].acr+num+1))
                | (ACRINFO[num+1].w_mask & (pe[T_PE].mcr[IOCCB5].ful>>((~num&2)<<3)))
                | (ACRINFO[num+1].r_mask & ACRINFO[num+1].w_mask);
        case 0:
            *((unsigned char *)&pe[T_PE].acr+num  )
                = (ACRINFO[num  ].r_mask & *((unsigned char *)&pe[T_PE].acr+num  ))
                | (ACRINFO[num  ].w_mask & (pe[T_PE].mcr[IOCCB5].ful>>((~num&3)<<3)))
                | (ACRINFO[num  ].r_mask & ACRINFO[num  ].w_mask);
            break;
        }
    }
}

#endif

/*************************************************************************
*                    SCALAR/VECTOR/MOVER/SSUMOVER/FSBA			 *
*************************************************************************/

/******************* MEM ************************************************/

#define         memrehash(x)     ((x+137) % MEMHASH_SIZE)

init_memhash(t_pe) unsigned t_pe;
{
    unsigned       t_syms, i;
    unsigned char  *t_strings;
    unsigned       tmp;

    t_syms    = swap4(*(unsigned *) (pe[T_PE].header+16));
    t_strings = pe[T_PE].symtbl+t_syms;

    for (i=0; i<MEMHASH_SIZE; i++) {
        pe[T_PE].MEMSHASH[i].name = NULL;
        pe[T_PE].MEMAHASH[i].type = 0;
    }
    /* read symbols from a.out */
    for (i=0; i<t_syms; i+=12) {
        if (!(pe[T_PE].symtbl[i+4] & 0xfe)) {
            message("undefined: %s\n",t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]));
            continue;
        }
        pe[T_PE].MEMSHASH[put_memshash(t_pe, t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]), swap4(*(unsigned*)&pe[T_PE].symtbl[i+8]))].memaddr
        = swap4(*(unsigned*)&pe[T_PE].symtbl[i+8]);
        tmp = put_memahash(t_pe, swap4(*(unsigned*)&pe[T_PE].symtbl[i+8]), t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]));
        pe[T_PE].MEMAHASH[tmp].name = (char*)(t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]));
        pe[T_PE].MEMAHASH[tmp].type = pe[T_PE].symtbl[i+4] & 0xfe;
    }
}

disp_symbol(t_pe, memaddr) unsigned t_pe, memaddr; 
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = memaddr % MEMHASH_SIZE;
    while (pe[T_PE].MEMAHASH[hashval].type) {
        if (memaddr == pe[T_PE].MEMAHASH[hashval].memaddr) {
          message("%-16s = 0x%08.8X  ", pe[T_PE].MEMAHASH[hashval].name, pe[T_PE].MEMAHASH[hashval].memaddr);
	  switch (pe[T_PE].MEMAHASH[hashval].type) {
	  case 2:
	      message("(ABS)\n");
	      break;

	  case 4:
	      message("(TEXT)\n");
	      break;

	  case 6:
	      message("(DATA)\n");
	      break;

	  case 8:
	      message("(BSS)\n");
	      break;

	  default:
	      message("()\n");
	      break;
	  }
	  return;
	}
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    message("%-16s = 0x%08.8X\n", "*unknown*", memaddr);
}

disp_symbols(t_pe) unsigned t_pe;
{
    unsigned       t_syms, i;
    unsigned char  *t_strings;

    t_syms    = swap4(*(unsigned *) (pe[T_PE].header+16));
    t_strings = pe[T_PE].symtbl+t_syms;

    /* read symbols from a.out */
    for (i=0; i<t_syms; i+=12) {
        if (!(pe[T_PE].symtbl[i+4] & 0xfe)) {
            message("undefined: %s\n",t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]));
            continue;
        }
        message("%-16s = 0x%08.8X  ",
            t_strings+swap4(*(unsigned*)&pe[T_PE].symtbl[i]),
            swap4(*(unsigned*)&pe[T_PE].symtbl[i+8]));
	switch (pe[T_PE].symtbl[i+4] & 0xfe) {
	case 2:
	    message("(ABS)\n");
	    break;

	case 4:
	    message("(TEXT)\n");
	    break;

	case 6:
	    message("(DATA)\n");
	    break;

	case 8:
	    message("(BSS)\n");
	    break;

	default:
	    message("()\n");
	    break;
	}
    }
}

mem_hash(s) char *s;
{
    unsigned hashval;
        
    for (hashval=0; *s == '$' || *s == '_' || *s == '.' || isalnum(*s);)
        hashval += *s++;
    return(hashval % MEMHASH_SIZE);
}

put_memshash(t_pe, name, memaddr) unsigned t_pe, memaddr; char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = mem_hash(name);
    while (pe[T_PE].MEMSHASH[hashval].name != NULL) {
        if (!strcmp(name, pe[T_PE].MEMSHASH[hashval].name)) {
	  /* message("duplicated label: %s (0x%08.8X -> 0x%08.8X)\n", name, pe[T_PE].MEMSHASH[hashval].memaddr, memaddr); */
	  return(hashval);
	}
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (pe[T_PE].MEMSHASH[hashval].name != NULL) message("too many SYMBOLs: %s is ignored\n", name);
    pe[T_PE].MEMSHASH[hashval].name = name;
    return(hashval);
}

put_memahash(t_pe, memaddr, name) unsigned t_pe, memaddr; char *name;
{
    unsigned hashval, hashsave;
 
    hashval = hashsave = memaddr % MEMHASH_SIZE;
    while (pe[T_PE].MEMAHASH[hashval].type) {
        if (memaddr == pe[T_PE].MEMAHASH[hashval].memaddr) {
	  /* message("duplicated address: 0x%08.8X (%-16s -> %-16s)\n", memaddr, pe[T_PE].MEMAHASH[hashval].name, name); */
	  return(hashval);
	}
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    if (pe[T_PE].MEMAHASH[hashval].type) message("too many SYMBOLs: %s is ignored\n", name);
    pe[T_PE].MEMAHASH[hashval].memaddr = memaddr;
    return(hashval);
}

get_memnumber(t_pe, name, val) unsigned t_pe; char *name; unsigned *val;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned  hashval, hashsave;
 
    hashval = hashsave = mem_hash(name);
    while (pe[T_PE].MEMSHASH[hashval].name != NULL) {
        if (!strcmp(name, pe[T_PE].MEMSHASH[hashval].name)) {
	    *val = pe[T_PE].MEMSHASH[hashval].memaddr;
	    return(0);
	}
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    /* message("%s not LABEL\n", name); */
    return(1);
}

get_memname(t_pe, memaddr, name) unsigned t_pe, memaddr; char **name;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned  hashval, hashsave;
#define EXT_MEMNAME_SIZE 82
    static char ext_memname[EXT_MEMNAME_SIZE];
 
    hashval = hashsave = memaddr % MEMHASH_SIZE;
    while (pe[T_PE].MEMAHASH[hashval].type) {
        if (memaddr == pe[T_PE].MEMAHASH[hashval].memaddr) {
          strncpy(*name = ext_memname, pe[T_PE].MEMAHASH[hashval].name, 81);
          ext_memname[81] = NULL;
          return(0);
        }
        hashval = memrehash(hashval);
        if (hashval == hashsave) break;
    }
    sprintf(*name = ext_memname, "0x%08.8X", memaddr);
    return(1);
}

randomize_mem(t_pe, num) unsigned t_pe, num;
{
    unsigned i, j = (unsigned char) num;

    for (i=0; i<memsize; i++)
      pe[T_PE].mem[i] = j;
}

randomize_tlb(t_pe) unsigned t_pe;
{
    unsigned i;

    for (i=0; i<TLB_NUM; i++) {
      pe[T_PE].text_tlb[i].pid = pe[T_PE].data_tlb[i].pid = ~0;
      pe[T_PE].text_tlb[i].la  = pe[T_PE].data_tlb[i].la  = ~0;
      pe[T_PE].text_tlb[i].pa  = pe[T_PE].data_tlb[i].pa  = ~0;
      pe[T_PE].text_tlb[i].vmc = pe[T_PE].data_tlb[i].vmc = ~0;
    /*pe[T_PE].text_tlb[i].nc  = pe[T_PE].data_tlb[i].nc  = ~0;*/
      pe[T_PE].text_tlb[i].wp  = pe[T_PE].data_tlb[i].wp  = ~0;
      pe[T_PE].text_tlb[i].prot= pe[T_PE].data_tlb[i].prot= ~0;
    }
}

randomize_che(t_pe, num) unsigned t_pe, num;
{
    unsigned i, k, j = (unsigned char) num;

    j = (j<<24)+(j<<16)+(j<<8)+j;
    for (i=0; i<CACHE_NUM; i++) {
      pe[T_PE].text_cache[i].pa  = pe[T_PE].data_cache[i].pa  = ~0;
      pe[T_PE].text_cache[i].v   = pe[T_PE].data_cache[i].v   = ~0;
      for (k=0; k<CACHE_BLOCK_SIZE; k++)
        pe[T_PE].text_cache[i].body[k] = pe[T_PE].data_cache[i].body[k] = j;
    }
}

cmd_mem_map(t_pe, num, prot, start, end, abs_addr)
    unsigned t_pe;
    unsigned num; /* MAP[] entry */
    unsigned prot;
    unsigned start;
    unsigned end;
    unsigned *abs_addr;
    /* return 1 if failed, 0 if succeeded */
{
#ifdef MANUAL_MAP
    unsigned bytes, tmp;

    if (start > end) {
      message("mapping length < 0\n");
      return(1);
    }
    for (tmp = 0; tmp < MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (!(start < pe[T_PE].map[tmp].start && end < pe[T_PE].map[tmp].start)
          &&!(start > pe[T_PE].map[tmp].end   && end > pe[T_PE].map[tmp].end)) {
	  message("mapping duplicated\n");
	  return(1);
	}
      }
    }

    bytes = end - start + 1;

    if (bytes) {
      for (tmp = 0; tmp < MAP_FREE_NUM; tmp++) {
        if (pe[T_PE].map_free[tmp].bytes >= bytes) {
          *abs_addr = pe[T_PE].map_free[tmp].abs_addr;
	  pe[T_PE].map_free[tmp].abs_addr += bytes;
	  pe[T_PE].map_free[tmp].bytes    -= bytes;
          pe[T_PE].map[num].prot           = prot;
          pe[T_PE].map[num].start          = start;
          pe[T_PE].map[num].end            = end;
          pe[T_PE].map[num].abs_addr       = *abs_addr;
	  return(0);
        }
      }
    }

    message("not enough continuous memory\n");

    return(1);
#else
    *abs_addr = start;
    return(0);
#endif
}

cmd_mem_free_status(t_pe)
{
#ifdef MANUAL_MAP
    unsigned tmp, found;

    for (found = 0, tmp = 0; tmp < MAP_FREE_NUM; tmp++) {
      if (pe[T_PE].map_free[tmp].bytes) {
        found++;
        message("free abs_addr: 0x%08.8X-0x%08.8X\n",
          pe[T_PE].map_free[tmp].abs_addr, 
          pe[T_PE].map_free[tmp].abs_addr+pe[T_PE].map_free[tmp].bytes-1);
      }
    }
    if (!found) 
      message("no free abs_addr\n");
#endif
}

cmd_mem_all_free(t_pe)
    unsigned t_pe;
{
#ifdef MANUAL_MAP
    unsigned num;

    for (num = 0; num < MAP_NUM; num++)
      cmd_mem_free(t_pe, num, pe[T_PE].map[num].start, pe[T_PE].map[num].end, pe[T_PE].map[num].abs_addr);
#endif
}

cmd_mem_free(t_pe, num, start, end, abs_addr)
    unsigned t_pe;
    unsigned num; /* MAP[] entry */
    unsigned start;
    unsigned end;
    unsigned abs_addr;
{
#ifdef MANUAL_MAP
    unsigned abs_end, bytes, frp, tmp;

    if (num >= MAP_NUM || !pe[T_PE].map[num].prot)
      return;

    pe[T_PE].map[num].prot = 0;

    if (start > end) {
      message("mapping length < 0\n");
      return;
    }

    bytes   = end - start + 1;
    abs_end = abs_addr + bytes - 1;

    for (frp = 0; frp < MAP_FREE_NUM; frp++) {
      if (!pe[T_PE].map_free[frp].bytes) {
        pe[T_PE].map_free[frp].abs_addr = abs_addr;
        pe[T_PE].map_free[frp].bytes    = bytes;
	break;
      }
    }
    if (frp == MAP_FREE_NUM) {
      message("not enough space for map_free\n");
      return;
    }
    for (tmp = 0; tmp < MAP_FREE_NUM; tmp++) {
      if (pe[T_PE].map_free[frp].abs_addr==pe[T_PE].map_free[tmp].abs_addr+pe[T_PE].map_free[tmp].bytes) {
	pe[T_PE].map_free[frp].abs_addr = pe[T_PE].map_free[tmp].abs_addr;
        pe[T_PE].map_free[frp].bytes   += pe[T_PE].map_free[tmp].bytes;
        pe[T_PE].map_free[tmp].bytes = 0;
      }
      else if (pe[T_PE].map_free[frp].abs_addr+pe[T_PE].map_free[frp].bytes == pe[T_PE].map_free[tmp].abs_addr) {
	pe[T_PE].map_free[frp].bytes   += pe[T_PE].map_free[tmp].bytes;
        pe[T_PE].map_free[tmp].bytes = 0;
      }
    }
#endif
}

cmd_mem_access(t_pe, t_mode, addr, len, rw, d, t_forcew)
    unsigned t_pe;
    unsigned t_mode; /* 'r': real 'v' : virtual */
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned *d;
    unsigned t_forcew;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned real_addr;
    unsigned abs_addr;
    unsigned *abs_ptr;

    if (!(len == 1 || len == 2 || len == 4 || len == 8 || len == 16)) {
        message("illegal: mem len=%u\n", len);
        return(1);
    }
    if (addr & (len-1)) {
        message("not aligned: mem addr=0x%08.8X len=%u\n", addr, len);
        return(1);
    }

    if (get_mem_real_addr(t_pe, t_mode, rw, addr, &real_addr, t_forcew))
	return(1);

    if (real_addr >= MCU_MAX_MEM_SIZE) {
        message("too large real_addr: real_addr=0x%08.8X (must < 0x%08.8X)\n", real_addr, MCU_MAX_MEM_SIZE);
        return(1);
    }

    if (get_abs_addr(t_pe, rw, real_addr, &abs_addr, t_forcew))
        return(1);
        
    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
        switch (len) {
        case 16:
            *d++ = swap4(*abs_ptr++);
            *d++ = swap4(*abs_ptr++);

        case 8:
            *d++ = swap4(*abs_ptr++);

        case 4:
            *d   = swap4(*abs_ptr);
            break;

        case 2:
            *d   = swap2(*(unsigned short *) abs_ptr);
            break;

        case 1:
            *d   = *(unsigned char *) abs_ptr;
            break;
        }
        return(0);
    }
    else if (rw == _W_) {
        switch (len) {
        case 16:
            *abs_ptr++ = swap4(*d++);
            *abs_ptr++ = swap4(*d++);

        case 8:
            *abs_ptr++ = swap4(*d++);

        case 4:
            *abs_ptr   = swap4(*d);
            break;

        case 2:
            *(unsigned short *) abs_ptr = swap2(*d);
            break;

        case 1:
            *(unsigned char *) abs_ptr = *d;
            break;
        }
        return(0);
    }
    else {
        message("internal error: cmd_mem_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

svp_mem_access(t_pe, addr, len, rw, d)
    unsigned t_pe;
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned *d;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned abs_addr;
    unsigned *abs_ptr;
    unsigned che_ent;

    if (addr & (len-1)) {
        message("not aligned: mem addr=0x%08.8X len=%u\n", addr, len);
        return(1);
    }

    if (get_abs_addr(t_pe, rw, addr, &abs_addr, 's'))
        return(1);
        
    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
        switch (len) {
        case 4:
            *d = swap4(*abs_ptr);
            break;

        case 1:
            *(unsigned char *)d = *(unsigned char *) abs_ptr;
            break;
        }
        return(0);
    }
    else if (rw == _W_) {
        switch (len) {
        case 4:
            *abs_ptr = swap4(*d);
            break;

        case 1:
	    *(unsigned char *) abs_ptr = *(unsigned char *)d;
            break;
        }

	/* flush scalar_text/data_cache */
        che_ent = (addr>>6) & (CACHE_NUM-1);
        if (pe[T_PE].text_cache[che_ent].pa == (addr>>15))
          pe[T_PE].text_cache[che_ent].v = 0;
        if (pe[T_PE].data_cache[che_ent].pa == (addr>>15))
          pe[T_PE].data_cache[che_ent].v = 0;

        return(0);
    }
    else {
        message("internal error: svp_mem_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

get_mem_real_addr(t_pe, t_mode, rw, addr, real_addr, t_forcew)
    unsigned t_pe;
    unsigned t_mode;
    unsigned rw;
    unsigned addr;
    unsigned *real_addr;
    unsigned t_forcew;
    /* return 1 if failed, 0 if succeeded */
{
    if (t_mode == 'r') {
        *real_addr = addr;
    }
    else if (t_mode == 'v') {
	if (cmd_mem_dat(t_pe, rw, addr, real_addr, t_forcew, 0))
	    return(1);
    }
    else {
        message("internal error: get_mem_real_addr.mode='%c' (must be 'r' or 'v')\n", t_mode);
        return(1);
    }
    return(0);
}

cmd_mem_dat(t_pe, rw, addr, real_addr, t_forcew, show)
    unsigned t_pe;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned addr;
    unsigned *real_addr;
    unsigned t_forcew;
    unsigned show; /* 1: show translation process */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned ste, pte, ptea;

    /* if (!pe[T_PE].sr[PEV].pev.va) {
        message("DAT inactive (pev.va=0)\n");
        return(1);
    } */

    if (show) message("virtual =0x%08.8X\n", addr);
    if (addr >> (22 - pe[T_PE].sr[STD].std.sts*2) > 0x3ff) {
        message("segment not found: segment_index=0x%08.8X std.sts=0x%08.8X\n",addr>>22,pe[T_PE].sr[STD].std.sts);
        return(1);
    }
    if (show) message("ste_addr=0x%08.8X\n", (unsigned)(pe[T_PE].sr[STD].std.stb<<6|(addr>>22)<<2));
    if (cmd_mem_access(t_pe,'r',pe[T_PE].sr[STD].std.stb<<6|(addr>>22)<<2,4,_R_,&ste,'n')) {
        return(1);
    }
    if (show) message("ste     =0x%08.8X\n", ste);
    if (ste & 1) {
        message("segment not found: ste.si=1\n");
        return(1);
    }
    if (((addr&0x3f8000) >> (15 - (ste & 6))) > 0x7f) {
        message("page not found: page_index=0x%08.8X ste.pts=0x%08.8X\n",(addr&0x3f8000)>>15,ste>>1&3);
        return(1);
    }
    if (show) message("pte_addr=0x%08.8X\n", (unsigned)((ste & 0xfffffff0)|(addr&0x3f8000)>>13));
    ptea = (ste & 0xfffffff0) | (addr & 0x3f8000) >> 13;
    if (cmd_mem_access(t_pe,'r',ptea,4,_R_,&pte,'n')) {
        return(1);
    }
    if (show) message("pte     =0x%08.8X\n", pte);
    if (pte & 1) {
        message("page not found: pte.pi=1\n");
        return(1);
    }

    *real_addr = (pte & 0xffff8000) | (addr & 0x7fff);

    if (*real_addr >= MCU_MAX_MEM_SIZE) {
      message("too large pte.pfn: pte.pfn=0x%08.8X (must < 0x%08.8X)\n", pte & 0xffff8000, MCU_MAX_MEM_SIZE);
      return(1);
    }
    if ((ste & 8) && rw == _W_) {
        message("write protected segment: addr=0x%08.8X ste.wp=1\n", addr);
        if (t_forcew == 'y') 
            message(" (ignored)\n");
        else {
            message("\n");
            return(1);
        }
    }
    switch ((pte & 0xf0) >> 4) {
    case 0: case 14: case 15:
        message("protected page: addr=0x%08.8X pte.prot=0x%X rw='%c'\n", addr, (pte&0xf0)>>4, rw==_R_?'R':'W');
        return(1);
        break;

    case 1: case 2: case 6: case 7: case 8:
        if (rw == _W_) {
            message("protected page: addr=0x%08.8X pte.prot=0x%X rw='%c'", addr, (pte&0xf0)>>4, rw==_R_?'R':'W');
            if (t_forcew == 'y') 
                message(" (ignored)\n");
            else {
                message("\n");
                return(1);
            }
        }
        break;

    default:
        break;
    }
    if (show) message("real    =0x%08.8X\n", *real_addr);

    return(0);
}

get_abs_addr(t_pe, rw, real_addr, abs_addr, t_forcew)
    unsigned t_pe;
    unsigned rw;
    unsigned real_addr;
    unsigned *abs_addr;
    unsigned t_forcew; /* 'y', 'n', 's'(for SVP) */
    /* return 1 if failed, 0 if succeeded */
{
    unsigned tmp;

#ifdef MCR_AREA
#ifdef PHSA_PROTECT
    if (t_forcew != 's') { /* if not from svp_mem_access() */
      if (rw == _W_ && real_addr < PHSA_SIZE && pe[T_PE].mcr[HSAPCW].hsapcw.hsapc) {
        message("protected HSA (0x00000000-0x%08.8X): real_addr=%08.8X HSAPC=1", PHSA_SIZE-1, real_addr);
        if (t_forcew == 'y') {
          message(" (ignored)\n");
        }
        else {
          message("\n");
          return(1);
        }
      }
    }
#endif
#endif

#ifdef MANUAL_MAP
    for (tmp=0; tmp<MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (real_addr>=pe[T_PE].map[tmp].start&&real_addr<=pe[T_PE].map[tmp].end) {
          if (pe[T_PE].map[tmp].prot & rw) {
            *abs_addr = pe[T_PE].map[tmp].abs_addr+(real_addr-pe[T_PE].map[tmp].start);
            return(0);
	  }
	  else {
            message("memory map protection error: prot=%s%s%s\n",
 	      pe[T_PE].map[tmp].prot & _R_ ? "R" : "-",
              pe[T_PE].map[tmp].prot & _W_ ? "W" : "-",
              pe[T_PE].map[tmp].prot & _X_ ? "X" : "-");
            return(1);
	  }
        }  
      } 
    } 
#else
    if (real_addr < memsize) {
      *abs_addr = real_addr;
      return(0);
    }
#endif
    message("memory not exist: real_addr=0x%08.8X\n", real_addr);
    return(1);
}

sys_mem_access(t_pe, t_mode, addr, len, rw, d, drn, mao)
    unsigned t_pe;
    unsigned t_mode; /* 'r':real, 'v':virtual */
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write, _A_:cs, _X_:execution */
    unsigned *d;
    unsigned drn;
    unsigned mao;
    /* return RW_MEM_P/L_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    unsigned real_addr;
    unsigned abs_addr;
    unsigned lirc, lsf;

    if (addr & (len-1)) { /* not aligned exception */
        lirc = 1;
	sys_mem_l_exception(t_pe, addr, len, rw, d, drn, mao, lirc, 0);
        return(RW_MEM_L_EXCEPTION);
    }
    else if (t_mode == 'r') {
        real_addr = addr;
    }
    else if (t_mode == 'v' && sys_mem_tlb(t_pe, rw, addr, &real_addr)) {
        switch (sys_mem_dat(t_pe, rw, addr, &real_addr, &lirc, &lsf)) {
	case RW_SUCCESS:
            if (rw == _X_)
              pe[T_PE].if_multiple_cycle += IF_DATDELAY;
	    break;

	case RW_MEM_P_EXCEPTION:
	    return(RW_MEM_P_EXCEPTION);
	    break;

	case RW_MEM_L_EXCEPTION:
	    sys_mem_l_exception(t_pe, addr, len, rw, d, drn, mao, lirc, lsf);
            return(RW_MEM_L_EXCEPTION);
	    break;
	}
    }

    if (real_addr >= MCU_MAX_MEM_SIZE) {
	sys_mem_a_exception(t_pe, real_addr);
        return(RW_MEM_P_EXCEPTION);
    }

    switch (sys_mem_che(t_pe,t_mode,addr,real_addr,&abs_addr,len,rw,d,mao)) {
    case RW_MEM_P_EXCEPTION:
        return(RW_MEM_P_EXCEPTION);
        break;

    case RW_MEM_WAIT:
        sys_mem_mem(t_pe,t_mode,addr,real_addr,abs_addr,len,rw,d);
        if (rw == _X_)
          pe[T_PE].if_multiple_cycle += IF_CHEDELAY;

    case RW_SUCCESS:
        return(RW_SUCCESS);
        break;
    }
}

sys_mem_l_exception(t_pe, addr, len, rw, d, drn, mao, lirc, lsf)
    unsigned t_pe;
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write, _A_:cs, _X_:execution */
    unsigned *d;
    unsigned drn;
    unsigned mao;
    unsigned lirc;
    unsigned lsf;
{
    unsigned lax_ent;

    if (!(lax_ent = 6 * pe[T_PE].work_ird0.nlax++)) {
        pe[T_PE].sr[CLAXC0].laxc.lirc = lirc;
        pe[T_PE].sr[CLAXC0].laxc.mao  = mao;
        pe[T_PE].sr[CLAXA0].ful       = addr;
	if (rw == _R_) {
          pe[T_PE].sr[CLAXC0].laxc.lsf = lsf;
          pe[T_PE].sr[CLAXC0].laxc.drn = drn;
	}
	else if (rw == _W_) {
          unsigned *d2 = d;

          switch (len) {
          case 1:
            *(unsigned char*)&pe[T_PE].sr[CLAXS00].ful = *d2;
	    break;

          case 2:
            *(unsigned short*)&pe[T_PE].sr[CLAXS00].ful = swap2(*d2);
	    break;

          case 4:
            pe[T_PE].sr[CLAXS00].ful = swap4(*d2);
	    break;

          case 8:
            pe[T_PE].sr[CLAXS00].ful = swap4(*d2++);
            pe[T_PE].sr[CLAXS01].ful = swap4(*d2);
	    break;

          case 16:
            pe[T_PE].sr[CLAXS00].ful = swap4(*d2++);
            pe[T_PE].sr[CLAXS01].ful = swap4(*d2++);
            pe[T_PE].sr[CLAXS02].ful = swap4(*d2++);
            pe[T_PE].sr[CLAXS03].ful = swap4(*d2);
	    break;
          }
	}
	else if (rw == _A_) {
          pe[T_PE].sr[CLAXC0].laxc.lsf = lsf;
          /* pe[T_PE].sr[CLAXC0].laxc.drn = drn; */
	}
    }
    pe[T_PE].sr[LAXC0+lax_ent].laxc.lirc = lirc;
    pe[T_PE].sr[LAXC0+lax_ent].laxc.mao  = mao;
    pe[T_PE].sr[LAXA0+lax_ent].ful       = addr;
    if (rw == _R_) {
      pe[T_PE].sr[LAXC0+lax_ent].laxc.lsf = lsf;
      pe[T_PE].sr[LAXC0+lax_ent].laxc.drn = drn;
    }
    else if (rw == _W_) {
      switch (len) {
      case 1:
        *(unsigned char*)&pe[T_PE].sr[LAXS00+lax_ent].ful = *d;
        break;

      case 2:
        *(unsigned short*)&pe[T_PE].sr[LAXS00+lax_ent].ful = swap2(*d);
        break;

      case 4:
        pe[T_PE].sr[LAXS00+lax_ent].ful = swap4(*d);
        break;

      case 8:
        pe[T_PE].sr[LAXS00+lax_ent].ful = swap4(*d++);
        pe[T_PE].sr[LAXS01+lax_ent].ful = swap4(*d);
        break;

      case 16:
        pe[T_PE].sr[LAXS00+lax_ent].ful = swap4(*d++);
        pe[T_PE].sr[LAXS01+lax_ent].ful = swap4(*d++);
        pe[T_PE].sr[LAXS02+lax_ent].ful = swap4(*d++);
        pe[T_PE].sr[LAXS03+lax_ent].ful = swap4(*d);
        break;
      }
    }
    else if (rw == _A_) {
      pe[T_PE].sr[LAXC0+lax_ent].laxc.lsf = lsf;
      /* pe[T_PE].sr[LAXC0+lax_ent].laxc.drn = drn; */
    }
}

sys_mem_a_exception(t_pe, addr)
    unsigned t_pe;
    unsigned addr;
{
        pe[T_PE].work_ird0.pax = 1;

/* In fact, PAXA is invalid under KAI  */
/* (ignored for debugging convenience) */
        if      (!pe[T_PE].work_ird1.paxk0) {
            pe[T_PE].work_ird1.paxk0 = 1;
            pe[T_PE].sr[PAXA0].ful = addr & PAX_MASK;
        }
        else if (!pe[T_PE].work_ird1.paxk1) {
            pe[T_PE].work_ird1.paxk1 = 1;
            pe[T_PE].sr[PAXA1].ful = addr & PAX_MASK;
        }
        else if (!pe[T_PE].work_ird1.paxk2) {
            pe[T_PE].work_ird1.paxk2 = 1;
            pe[T_PE].sr[PAXA2].ful = addr & PAX_MASK;
        }
        else if (!pe[T_PE].work_ird1.paxk3) {
            pe[T_PE].work_ird1.paxk3 = 1;
            pe[T_PE].sr[PAXA3].ful = addr & PAX_MASK;
        }
}

sys_mem_tlb(t_pe, rw, addr, real_addr)
    unsigned t_pe;
    unsigned rw;   /* _R_:read, _W_:write, _A_:cs, _X_:execution */
    unsigned addr;
    unsigned *real_addr;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned tlb_ent;

    /* TLB function */
    /* We regard 'cs' operation as single cycle TLB manipulation. */
    /* TLB reference ocurrs only one time. (not same with REAL MACHINE !) */

    tlb_ent = ( addr >> 15 ) & 0x00ff;

    if (rw == _X_) {
      pe[T_PE].text_tlb_access++;
      if (pe[T_PE].text_tlb[tlb_ent].vmc & 4) {
        if ((pe[T_PE].text_tlb[tlb_ent].vmc&1)||(pe[T_PE].text_tlb[tlb_ent].pid==pe[T_PE].sr[PID].pid.pid)) {
          if (pe[T_PE].text_tlb[tlb_ent].la == (addr >> 23)) {
            if (pe[T_PE].sr[PEV].pev.u) {
              switch (pe[T_PE].text_tlb[tlb_ent].prot) {
              case 8: case 12: case 13:
                *real_addr = (pe[T_PE].text_tlb[tlb_ent].pa << 15) | (addr & 0x7fff);
                pe[T_PE].text_tlb_hit++;
                return (0);
                break;
              }
            }
            else {
              switch (pe[T_PE].text_tlb[tlb_ent].prot) {
              case 6: case 7: case 8: case 9: case 10: case 11: case 12: case 13:
                *real_addr = (pe[T_PE].text_tlb[tlb_ent].pa << 15) | (addr & 0x7fff);
                pe[T_PE].text_tlb_hit++;
                return (0);
                break;
              }
            }
          } 
        } 
      }
    }   
    else if (rw == _R_) {
      pe[T_PE].data_tlb_access++;
      if (pe[T_PE].data_tlb[tlb_ent].vmc & 4) {
        if ((pe[T_PE].data_tlb[tlb_ent].vmc&1)||(pe[T_PE].data_tlb[tlb_ent].pid==pe[T_PE].sr[PID].pid.pid)) {
          if (pe[T_PE].data_tlb[tlb_ent].la == (addr >> 23)) {
            if (pe[T_PE].sr[PEV].pev.u) {
              switch (pe[T_PE].data_tlb[tlb_ent].prot) {
              case 2: case 4: case 5: case 7: case 8: case 10: case 11: case 12: case 13:
                *real_addr = (pe[T_PE].data_tlb[tlb_ent].pa << 15) | (addr & 0x7fff);
                pe[T_PE].data_tlb_hit++;
                return (0);
                break; 
              }
            }
            else {
              switch (pe[T_PE].data_tlb[tlb_ent].prot) {
              case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9:
              case 10: case 11: case 12: case 13:
                *real_addr = (pe[T_PE].data_tlb[tlb_ent].pa << 15) | (addr & 0x7fff);
                pe[T_PE].data_tlb_hit++;
                return (0);
                break; 
              }
            }
          }
        }   
      }   
    }
    else if (rw & _W_) {
      pe[T_PE].data_tlb_access++;
      if (pe[T_PE].data_tlb[tlb_ent].vmc & 4) {
        if ((pe[T_PE].data_tlb[tlb_ent].vmc&1)||(pe[T_PE].data_tlb[tlb_ent].pid==pe[T_PE].sr[PID].pid.pid)) {
          if (pe[T_PE].data_tlb[tlb_ent].la == (addr >> 23)) {
            if (!pe[T_PE].data_tlb[tlb_ent].wp) {
              if (pe[T_PE].sr[PEV].pev.u) {
                switch (pe[T_PE].data_tlb[tlb_ent].prot) {
                case 5: case 11: case 13:
                  if (pe[T_PE].data_tlb[tlb_ent].vmc & 2) {
                    *real_addr = (pe[T_PE].data_tlb[tlb_ent].pa << 15) | (addr & 0x7fff);
                    pe[T_PE].data_tlb_hit++;
                    return (0);
                  }
                  break; 
                }
              }
              else {
                switch (pe[T_PE].data_tlb[tlb_ent].prot) {
                case 3: case 4: case 5: case 9: case 10: case 11: case 12: case 13:
                  if (pe[T_PE].data_tlb[tlb_ent].vmc & 2) {
                    *real_addr = (pe[T_PE].data_tlb[tlb_ent].pa << 15) | (addr & 0x7fff);
                    pe[T_PE].data_tlb_hit++;
                    return (0);
                  }
                  break; 
                }
              }
            }
          }
        }   
      }   
    }
    return (1);
}

sys_mem_dat(t_pe, rw, addr, real_addr, lirc, lsf)
    unsigned t_pe;
    unsigned rw;   /* _R_:read, _W_:write, _A_:cs, _X_:execution */
    unsigned addr;
    unsigned *real_addr;
    unsigned *lirc, *lsf;
    /* return RW_MEM_P/L_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    unsigned ste, pte;
    unsigned ptea, tlb_ent;

    if (addr >> (22 - pe[T_PE].sr[STD].std.sts*2) > 0x3ff) { /* segment not found */
        *lirc = 4;
	*lsf = 0;
        return(RW_MEM_L_EXCEPTION);
    }
    if (sys_mem_access(t_pe,'r',pe[T_PE].sr[STD].std.stb<<6|(addr>>22)<<2,4,_R_,&ste,0,0) != RW_SUCCESS)
        return(RW_MEM_P_EXCEPTION);
    if (ste & 1) { /* segment not found */
        *lirc = 4;
	*lsf = 0;
        return(RW_MEM_L_EXCEPTION);
    }
    if ((addr&0x3f8000) >> (15 - (ste & 6)) > 0x7f) { /* page not found */
        *lirc = 5;
	*lsf = 0;
        return(RW_MEM_L_EXCEPTION);
    }
    ptea = (ste & 0xfffffff0) | (addr & 0x3f8000) >> 13;
    if (sys_mem_access(t_pe,'r',ptea,4,_R_,&pte,0,0) != RW_SUCCESS) {
        return(RW_MEM_P_EXCEPTION);
    }
    if (pte & 1) { /* page not found */
        *lirc = 5;
	*lsf = 0;
        return(RW_MEM_L_EXCEPTION);
    }

    *real_addr = (pte & 0xffff8000) | (addr & 0x7fff);

    if (*real_addr >= MCU_MAX_MEM_SIZE) {
	sys_mem_a_exception(t_pe, *real_addr);
        return(RW_MEM_P_EXCEPTION);
    }
    if ((ste & 8) && rw & _W_) { /* write protected */
        *lirc = 3;
	*lsf = 1;
        return(RW_MEM_L_EXCEPTION);
    }
    if (pe[T_PE].sr[PEV].pev.u) {
        switch ((pte & 0xf0) >> 4) { /* protected page */
        case 0: case 1: case 3: case 6: case 9: case 14: case 15:
            {
                *lirc = 3;
                *lsf = 0;
                return(RW_MEM_L_EXCEPTION);
            }
            break;

        case 2: case 4: case 7: case 10:
            if (rw & _W_ || rw == _X_) {
                *lirc = 3;
                *lsf = 1;
                return(RW_MEM_L_EXCEPTION);
            }
            break;

        case 5: case 11:
            if (rw == _X_) {
                *lirc = 3;
                *lsf = 0;
                return(RW_MEM_L_EXCEPTION);
            }
            break;

        case 8: case 12:
            if (rw & _W_) {
                *lirc = 3;
                *lsf = 1;
                return(RW_MEM_L_EXCEPTION);
            }
            break;

	default:
	    break;
        }
    }
    else {
        switch ((pte & 0xf0) >> 4) { /* protected page */
        case 0: case 14: case 15:
            {
                *lirc = 3;
		*lsf = 0;
		return(RW_MEM_L_EXCEPTION);
	    }
	    break;

        case 1: case 2:
            if (rw & _W_ || rw == _X_) {
		*lirc = 3;
		*lsf = 1;
		return(RW_MEM_L_EXCEPTION);
	    }
            break;

        case 3: case 4: case 5:
            if (rw == _X_) {
		*lirc = 3;
		*lsf = 0;
		return(RW_MEM_L_EXCEPTION);
            }
            break;

        case 6: case 7: case 8:
            if (rw & _W_) {
		*lirc = 3;
		*lsf = 1;
		return(RW_MEM_L_EXCEPTION);
            }
            break;

	default:
	    break;
	}
    }

    if (rw == _R_ || rw == _X_) {
        pte |= 0x400;
        if (sys_mem_access(t_pe,'r',ptea,4,_W_,&pte,0,0) != RW_SUCCESS)
            return(RW_MEM_P_EXCEPTION);
    }
    else if (rw & _W_) {
        pte |= 0x600;
        if (sys_mem_access(t_pe,'r',ptea,4,_W_,&pte,0,0) != RW_SUCCESS)
            return(RW_MEM_P_EXCEPTION);
    }

    /* TLB function */
    tlb_ent = (addr >> 15) & 0x00ff;
    if (rw == _X_) {
        pe[T_PE].text_tlb[tlb_ent].pid = pe[T_PE].sr[PID].pid.pid;
        pe[T_PE].text_tlb[tlb_ent].la  = addr >> 23;
        pe[T_PE].text_tlb[tlb_ent].pa  = *real_addr >> 15;
        pe[T_PE].text_tlb[tlb_ent].vmc = 0x04 | ((pte & 0x0300) >> 8);
      /*pe[T_PE].text_tlb[tlb_ent].nc  = (pte & 4) >> 2;*/
        pe[T_PE].text_tlb[tlb_ent].wp  = (ste & 8) >> 3;
        pe[T_PE].text_tlb[tlb_ent].prot= (pte & 0xf0) >> 4;
    }
    else {
        pe[T_PE].data_tlb[tlb_ent].pid = pe[T_PE].sr[PID].pid.pid;
        pe[T_PE].data_tlb[tlb_ent].la  = addr >> 23;
        pe[T_PE].data_tlb[tlb_ent].pa  = *real_addr >> 15;
        pe[T_PE].data_tlb[tlb_ent].vmc = 0x04 | ((pte & 0x0300) >> 8);
      /*pe[T_PE].data_tlb[tlb_ent].nc  = (pte & 4) >> 2;*/
        pe[T_PE].data_tlb[tlb_ent].wp  = (ste & 8) >> 3;
        pe[T_PE].data_tlb[tlb_ent].prot= (pte & 0xf0) >> 4;
    }
    /* TLB end      */

    return(RW_SUCCESS);
}

sys_mem_che(t_pe, t_mode, addr, real_addr, abs_addr, len, rw, d, mao)
    unsigned t_pe;
    unsigned t_mode; /* 'r':real, 'v':virtual */
    unsigned addr, real_addr, *abs_addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write, _A_:cs, _X_:execution */
    unsigned *d;
    unsigned mao;
    /* return RW_MEM_P_EXCEPTION   if failed   */
    /* return RW_SUCCESS           if scceeded */
    /* return RW_MEM_WAIT          if waiting  */
{
    unsigned char   mbp;
    unsigned bp_no;
    unsigned pax_ent;
    unsigned che_ent;
    unsigned *abs_ptr;
    unsigned tmp;

    if (rw == _X_)
        pe[T_PE].text_access++;
    else
        pe[T_PE].data_access++;

#ifdef MCR_AREA
#ifdef PHSA_PROTECT
  /* case PHSA */
    if (rw & _W_ && real_addr < PHSA_SIZE && pe[T_PE].mcr[HSAPCW].hsapcw.hsapc)
      goto mem_p_exception;
#endif
#endif

  /* case MEM */
#ifdef MANUAL_MAP
    for (tmp=0; tmp<MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (real_addr>=pe[T_PE].map[tmp].start&&real_addr<=pe[T_PE].map[tmp].end) {
          if ((pe[T_PE].map[tmp].prot & rw) == rw) {
            *abs_addr = pe[T_PE].map[tmp].abs_addr+(real_addr-pe[T_PE].map[tmp].start);
            goto mem_p_found;
	  }
	  else
	    goto mem_p_exception;
        }  
      } 
    } 
    goto mem_p_exception;
#else
    if (real_addr < memsize)
      *abs_addr = real_addr;
    else
      goto mem_p_exception;
#endif

mem_p_found:

    switch (len) {
    case 1:
      mbp = pe[T_PE].mbp[*abs_addr/8] & 0x0080 >> (*abs_addr & 7);
      break;

    case 2:
      mbp = pe[T_PE].mbp[*abs_addr/8] & 0x00c0 >> (*abs_addr & 7);
      break;

    case 4:
      mbp = pe[T_PE].mbp[*abs_addr/8] & 0x00f0 >> (*abs_addr & 7);
      break;

    case 8:
      mbp = pe[T_PE].mbp[*abs_addr/8];
      break;

    case 16:
      mbp = pe[T_PE].mbp[*abs_addr/8] | pe[T_PE].mbp[*abs_addr/8+1];
      break;

    default:
      mbp = 0;
      break;
    }
    if (mbp) {
      for (bp_no = 0; bp_no < BP_NUM; bp_no++) {
        if ((pe[T_PE].bp_table[bp_no].access & rw)
          && pe[T_PE].bp_table[bp_no].abs_addr >= *abs_addr
          && pe[T_PE].bp_table[bp_no].abs_addr <= *abs_addr+len-1) {
	  if (pe[T_PE].bp_table[bp_no].interval == ++pe[T_PE].bp_table[bp_no].count) {
	    pe[T_PE].bp_table[bp_no].count = 0;
	    if (pe[T_PE].bp_table[bp_no].b_or_c == 'b') {
	      bp_match = 1;
              pe[T_PE].bp_entry = bp_no;
	    }
	    else {
	      cp_match = 1;
	      pe[T_PE].cp_entry = bp_no;
	    }
	  }
        }
      }
    }

/* non cache */
    if (pe[T_PE].sr[PEV].pev.nic)
      return(RW_MEM_WAIT);

/* cache */
/*  if (t_mode == 'v'){
      if ((rw==_X_&&(pe[T_PE].text_tlb[(addr>>15)&0x00ff].nc))
	||(rw!=_X_&&(pe[T_PE].data_tlb[(addr>>15)&0x00ff].nc))) {
        return(RW_MEM_WAIT);
      }
    }
*/

    che_ent = (real_addr >> 6) & 0x01ff;

    if (rw == _X_) {
      pe[T_PE].text_cache_access++;
      if (!(pe[T_PE].text_cache[che_ent].v&&pe[T_PE].text_cache[che_ent].pa==(real_addr>>15)))
	return(RW_MEM_WAIT);
      else {
        /* cache -> data read */
        abs_ptr = (unsigned *) &pe[T_PE].text_cache[che_ent].body[real_addr&0x003f];
        switch (len) {
        case 16:
          *d++ = swap4(*abs_ptr++);
          *d++ = swap4(*abs_ptr++);

        case 8:
          *d++ = swap4(*abs_ptr++);

        case 4:
          *d   = swap4(*abs_ptr);
          break;

        case 2:
          *d   = swap2(*(unsigned short *) abs_ptr);
          break;

        case 1:
          *d   = *(unsigned char *) abs_ptr;
          break;
        }
        pe[T_PE].text_cache_hit++;
        return(RW_SUCCESS);
      }
    }
    else if (rw == _R_) {
      pe[T_PE].data_cache_access++;
      if (!(pe[T_PE].data_cache[che_ent].v&&pe[T_PE].data_cache[che_ent].pa==(real_addr>>15)))
        return(RW_MEM_WAIT);
      else {
        /* cache -> data read */
        abs_ptr = (unsigned *) &pe[T_PE].data_cache[che_ent].body[real_addr&0x003f];
        switch (len) {
        case 16:
          *d++ = swap4(*abs_ptr++);
          *d++ = swap4(*abs_ptr++);

        case 8:
          *d++ = swap4(*abs_ptr++);

        case 4:
          *d   = swap4(*abs_ptr);
          break;

        case 2:
          *d   = swap2(*(unsigned short *) abs_ptr);
          break;

        case 1:
          *d   = *(unsigned char *) abs_ptr;
          break;
        }
        pe[T_PE].data_cache_hit++;
        return(RW_SUCCESS);
      }
    }
    else if (rw == _W_) {
      if (pe[T_PE].data_cache[che_ent].v&&pe[T_PE].data_cache[che_ent].pa==(real_addr>>15)) { 
        /* cache <- data write */
        unsigned *d2 = d;

        abs_ptr = (unsigned *) &pe[T_PE].data_cache[che_ent].body[real_addr&0x003f];
        switch (len) {
        case 16:
          *abs_ptr++ = swap4(*d2++);
          *abs_ptr++ = swap4(*d2++);

        case 8:
          *abs_ptr++ = swap4(*d2++);

        case 4:
          *abs_ptr   = swap4(*d2); 
          break;

        case 2:
          *(unsigned short *) abs_ptr = swap2(*d2);
          break;

        case 1:
          *(unsigned char *) abs_ptr = *d2; 
          break;
        }
      }
      abs_ptr = (unsigned *) &pe[T_PE].mem[*abs_addr];
      switch (len) {
      case 16:
        *abs_ptr++ = swap4(*d++);
        *abs_ptr++ = swap4(*d++);

      case 8:
        *abs_ptr++ = swap4(*d++);

      case 4:
        *abs_ptr   = swap4(*d); 
        break;

      case 2:
        *(unsigned short *) abs_ptr = swap2(*d);
        break;

      case 1:
        *(unsigned char *) abs_ptr = *d;
        break;
      }
      return(RW_SUCCESS);
    }
    else if (rw == _A_) {
      if (pe[T_PE].data_cache[che_ent].v&&pe[T_PE].data_cache[che_ent].pa==(real_addr>>15)) { 
        /* cache <- data write */
        * (unsigned *) &pe[T_PE].data_cache[che_ent].body[real_addr&0x003f] = *d;
      }
      * (unsigned *) &pe[T_PE].mem[*abs_addr] = *d;
      return(RW_SUCCESS);
    }

mem_p_exception:
    if (rw == _R_ || rw == _X_) {
      sys_mem_a_exception(t_pe, real_addr);
      return(RW_MEM_P_EXCEPTION);
    }
    else if (rw & _W_) { /* cpr1 interruption */
      pe[T_PE].work_ird0.cir  = 1;
      pe[T_PE].work_ird1.crr1 = 1;
      return(RW_SUCCESS);
    }
}

sys_mem_mem(t_pe, t_mode, addr, real_addr, abs_addr, len, rw, d)
    unsigned t_pe;
    unsigned t_mode; /* 'r':real, 'v':virtual */
    unsigned addr, real_addr, abs_addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write, _A_:cs, _X_:execution */
    unsigned *d;
    /* always return RW_SUCCESS */
{
    unsigned che_ent;
    unsigned *abs_ptr;
    unsigned i;

/* non cache */
    if (pe[T_PE].sr[PEV].pev.nic)
      goto no_cache_rw;

/* cache */
/*  if (t_mode == 'v'){
      if ((rw==_X_&&(pe[T_PE].text_tlb[(addr>>15)&0x00ff].nc))
        ||(rw!=_X_&&(pe[T_PE].data_tlb[(addr>>15)&0x00ff].nc))) {
        goto no_cache_rw;
      }
    }
*/

    che_ent = (real_addr >> 6) & 0x01ff;

    if (rw == _X_) {
      if (!(pe[T_PE].text_cache[che_ent].v&&pe[T_PE].text_cache[che_ent].pa==(real_addr>>15))) {
        unsigned *src, *dst;

        pe[T_PE].text_cache[che_ent].pa = real_addr >> 15;
        pe[T_PE].text_cache[che_ent].v  = 1;
        src = (unsigned *) &pe[T_PE].mem[abs_addr&0xffffffc0];
        dst = (unsigned *) pe[T_PE].text_cache[che_ent].body;
        for (i=0; i<16; i++)
          *dst++ = *src++;
      }
      /* cache -> data read */
      abs_ptr = (unsigned *) &pe[T_PE].text_cache[che_ent].body[real_addr&0x003f];
      switch (len) {
      case 16:
        *d++ = swap4(*abs_ptr++);
        *d++ = swap4(*abs_ptr++);

      case 8:
        *d++ = swap4(*abs_ptr++);

      case 4:
        *d   = swap4(*abs_ptr);
        break;

      case 2:
        *d   = swap2(*(unsigned short *) abs_ptr);
        break;

      case 1:
        *d   = *(unsigned char *) abs_ptr;
        break;
      }
      return(RW_SUCCESS);
    }
    else if (rw == _R_) {
      if (!(pe[T_PE].data_cache[che_ent].v&&pe[T_PE].data_cache[che_ent].pa==(real_addr>>15))) {
        unsigned *src, *dst;
    
        pe[T_PE].data_cache[che_ent].pa = real_addr >> 15;
        pe[T_PE].data_cache[che_ent].v  = 1;
        src = (unsigned *) &pe[T_PE].mem[abs_addr&0xffffffc0];
        dst = (unsigned *) pe[T_PE].data_cache[che_ent].body;
        for (i=0; i<16; i++)
          *dst++ = *src++;
      }
      /* cache -> data read */
      abs_ptr = (unsigned *) &pe[T_PE].data_cache[che_ent].body[real_addr&0x003f];
      switch (len) {
      case 16:
        *d++ = swap4(*abs_ptr++);
        *d++ = swap4(*abs_ptr++);

      case 8:
        *d++ = swap4(*abs_ptr++);

      case 4:
        *d   = swap4(*abs_ptr);
        break;

      case 2:
        *d   = swap2(*(unsigned short *) abs_ptr);
        break;

      case 1:
        *d   = *(unsigned char *) abs_ptr;
        break;
      }
      return(RW_SUCCESS);
    }
    else if (rw == _W_) {
      if (pe[T_PE].data_cache[che_ent].v&&pe[T_PE].data_cache[che_ent].pa==(real_addr>>15)) {
        /* cache <- data write */
        unsigned *d2 = d;

        abs_ptr = (unsigned *) &pe[T_PE].data_cache[che_ent].body[real_addr&0x003f];
        switch (len) {
        case 16:
          *abs_ptr++ = swap4(*d2++);
          *abs_ptr++ = swap4(*d2++);

        case 8:
          *abs_ptr++ = swap4(*d2++);

        case 4:
          *abs_ptr   = swap4(*d2);
          break;

        case 2:
          *(unsigned short *) abs_ptr = swap2(*d2);
          break;

        case 1:
          *(unsigned char *) abs_ptr = *d2;
          break;
        }
      }
      abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
      switch (len) {
      case 16:
        *abs_ptr++ = swap4(*d++);
        *abs_ptr++ = swap4(*d++);

      case 8:
        *abs_ptr++ = swap4(*d++);

      case 4:
        *abs_ptr   = swap4(*d);
        break;

      case 2:
        *(unsigned short *) abs_ptr = swap2(*d);
        break;

      case 1:
        *(unsigned char *) abs_ptr = *d;
        break;
      }
      return(RW_SUCCESS);
    }
    else if (rw == _A_) {
      if (pe[T_PE].data_cache[che_ent].v&&pe[T_PE].data_cache[che_ent].pa==(real_addr>>15)) {
        /* cache <- data write */
        * (unsigned *) &pe[T_PE].data_cache[che_ent].body[real_addr&0x003f] = *d;
      }
      * (unsigned *) &pe[T_PE].mem[abs_addr] = *d;
      return(RW_SUCCESS);
    }

no_cache_rw:
    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _X_ || rw == _R_) {
      switch (len) {
      case 16:
        *d++ = swap4(*abs_ptr++);
        *d++ = swap4(*abs_ptr++);

      case 8:
        *d++ = swap4(*abs_ptr++);

      case 4:
        *d   = swap4(*abs_ptr);
        break;

      case 2:
        *d   = swap2(*(unsigned short *) abs_ptr);
        break;

      case 1:
        *d   = *(unsigned char *) abs_ptr;
        break;
      }
    }
    else if (rw == _W_) {
      switch (len) {
      case 16:
        *abs_ptr++ = swap4(*d++);
        *abs_ptr++ = swap4(*d++);

      case 8:
        *abs_ptr++ = swap4(*d++);

      case 4:
        *abs_ptr   = swap4(*d);
        break;

      case 2:
        *(unsigned short *) abs_ptr = swap2(*d);
        break;

      case 1:
        *(unsigned char *) abs_ptr = *d;
        break;
      }
    }
    else if (rw == _A_)
      *abs_ptr = *d;
    return(RW_SUCCESS);
}

#ifdef VCP

cmd_vop_access(t_pe, t_node, addr, len, rw, d, t_forcew)
    unsigned t_pe;
    unsigned t_node; /* 'r': real 'v' : virtual */
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned *d;
    unsigned t_forcew;
    /* return 1 if failed, 0 if succeeded */
{
    unsigned real_addr;
    unsigned abs_addr;
    unsigned *abs_ptr;

    if (!(len == 1 || len == 4 || len == 8 || len == 16)) {
        message("illegal: vop len=%u\n", len);
        return(1);
    }
    if (addr & (len-1)) {
        message("not aligned: vop addr=0x%08.8X len=%u\n", addr, len);
        return(1);
    }

    if (get_vop_real_addr(t_pe, t_node, rw, addr, &real_addr, t_forcew))
	return(1);

    if (get_abs_addr(t_pe, rw, real_addr, &abs_addr, t_forcew))
        return(1);
        
    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
        switch (len) {
        case 16:
            *d++ = swap4(*abs_ptr++);
            *d++ = swap4(*abs_ptr++);

        case 8:
            *d++ = swap4(*abs_ptr++);

        case 4:
            *d   = swap4(*abs_ptr);
            break;

        case 1:
            *d   = *(unsigned char *) abs_ptr;
            break;
        }
        return(0);
    }
    else if (rw == _W_) {
        switch (len) {
        case 16:
            *abs_ptr++ = swap4(*d++);
            *abs_ptr++ = swap4(*d++);

        case 8:
            *abs_ptr++ = swap4(*d++);

        case 4:
            *abs_ptr   = swap4(*d);
            break;

        case 1:
            *(unsigned char *) abs_ptr = *d;
            break;
        }
        return(0);
    }
    else {
        message("internal error: cmd_vop_access.rw=0x%X (must be _R_ or _W_)\n", rw);
        return(1);
    }
}

get_vop_real_addr(t_pe, t_node, rw, addr, real_addr, t_forcew)
    unsigned t_pe;
    unsigned t_node;
    unsigned rw;
    unsigned addr;
    unsigned *real_addr;
    unsigned t_forcew;
    /* return 1 if failed, 0 if succeeded */
{
    if (t_node == 'r') {
        *real_addr = addr;
    }
    else if (t_node == 'v') {
	if (cmd_vop_dat(t_pe, rw, addr, real_addr, t_forcew, 0))
	    return(1);
    }
    else {
        message("internal error: get_vop_real_addr.node='%c' (must be 'r' or 'v')\n", t_node);
        return(1);
    }
    return(0);
}

cmd_vop_dat(t_pe, rw, addr, real_addr, t_forcew, show)
    unsigned t_pe;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned addr;
    unsigned *real_addr;
    unsigned t_forcew;
    unsigned show; /* 1: show translation process */
    /* return 1 if failed, 0 if succeeded */
{
    union tr_form  tre;
    unsigned       tr_num;

    /* if (!pe[T_PE].vcr[1].vcr1.vt) {
        message("DAT inactive (vcr1.vt=0)\n");
        return(1);
    } */

    if (show) message("virtual =0x%08.8X\n", addr);

    switch (pe[T_PE].vcr[1].vcr1.ps) {
    case 11:
	tr_num = (addr >> 21) & 0x1f;
	break;

    case 13:
	tr_num = (addr >> 23) & 0x1f;
	break;

    case 15:
	tr_num = (addr >> 25) & 0x1f;
	break;

    default:
        message("illegal page size: vcr1.ps=%u\n", pe[T_PE].vcr[1].vcr1.ps);
	return(1);
	break;
    }

    tre.ful = pe[T_PE].tr[tr_num].ful;

    if (show) {
        message("tr_num  =%u\n", tr_num);
        message("tr      =0x%08.8X\n", tre.ful);
    }

    if (tre.tr.i) {
        message("invalidated page: tr[%u].i=1\n", tr_num);
        return(1);
    }

    switch (pe[T_PE].vcr[1].vcr1.ps) {
    case 11:
        if (addr >> 26 != tre.tr.sa >> 2) {
            message("section address mismatch: tr[%u].sa=0x%X\n", tr_num, tre.tr.sa >> 2);
            return(1);
        }
        *real_addr = (tre.ful & 0xffe00000) | (addr & 0x001fffff);
	break;

    case 13:
        if (addr >> 28 != tre.tr.sa >> 4) {
            message("section address mismatch: tr[%u].sa=0x%X\n", tr_num, tre.tr.sa >> 4);
            return(1);
        }
        *real_addr = (tre.ful & 0xff800000) | (addr & 0x007fffff);
	break;

    case 15:
        if (addr >> 30 != tre.tr.sa >> 6) {
            message("section address mismatch: tr[%u].sa=0x%X\n", tr_num, tre.tr.sa >> 6);
            return(1);
        }
        *real_addr = (tre.ful & 0xfe000000) | (addr & 0x01ffffff);
	break;
    }

    if (show) message("real    =0x%08.8X\n", *real_addr);

    return(0);
}

#if 0
sys_vop_lock_indirect(t_pe) unsigned t_pe;
{
    pe[T_PE].vop_iscore = SCORE_BUSY;
}
#endif

#if 0
sys_vop_unlock_indirect(t_pe) unsigned t_pe;
{       
    pe[T_PE].vop_iscore = SCORE_FREE;
} 
#endif

#if 0
sys_vop_check_indirect(t_pe) unsigned t_pe;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
    return(pe[T_PE].vop_iscore);
}
#endif

#if 0
sys_vop_lock_id(t_pe, id, rw) unsigned t_pe, id, rw;
{
#ifdef DEBUG
    if (id >= ID_NUM) {
        message("too large(sys): id%u\n", id);
        return;
    }
#endif
    if (id == 1 || id == 2) {
      if (rw == _R_)
        pe[T_PE].vop_rscore[id]++;
      else if (rw == _W_)
        pe[T_PE].vop_wscore[id] = 1;
    }
}
#endif

#if 0
sys_vop_unlock_id(t_pe, id, rw) unsigned t_pe, id, rw;
{       
#ifdef DEBUG
    if (id >= ID_NUM) {
        message("too large(sys): id%u\n", id);
        return;
    }
#endif  
    if (id == 1 || id == 2) {
      if (rw == _R_)
        pe[T_PE].vop_rscore[id]--;
      else if (rw == _W_)
        pe[T_PE].vop_wscore[id] = 0;
    }
} 
#endif

#if 0
sys_vop_check_id(t_pe, id, rw) unsigned t_pe, id, rw;
    /* return SCORE_BUSY if waiting, SCORE_FREE if not waiting */
{
#ifdef DEBUG
    if (id >= ID_NUM) {
        message("too large(sys): id%u\n", id);
        return(SCORE_BUSY);
    }
#endif
    return((id == 1 || id == 2)
      ? ( rw == _R_
        ? ( pe[T_PE].vop_wscore[id] > 0
          ? SCORE_BUSY : SCORE_FREE)
        : rw == _W_
        ? ((pe[T_PE].vop_rscore[id] > 0 || pe[T_PE].vop_wscore[id] > 0)
          ? SCORE_BUSY : SCORE_FREE)
        : SCORE_FREE)
      : SCORE_FREE);
}
#endif

sys_vop_access(t_pe, t_node, addr, len, rw, d)
    unsigned t_pe;
    unsigned t_node; /* 'r': real 'v' : virtual */
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned *d;
    /* return RW_MEM_P/L_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    unsigned real_addr;

    *(unsigned*)&pe[T_PE].work_vcr2 = 0;

    if (addr & (len-1)) { /* not aligned exception */
        pe[T_PE].work_vcr2.pif_nax = 1;
        return(RW_MEM_L_EXCEPTION);
    }
    else if (t_node == 'r') {
        real_addr = addr;
    }
    else if (t_node == 'v') {
        switch (sys_vop_dat(t_pe, rw, addr, &real_addr)) {
        case RW_SUCCESS:
            break;

        case RW_MEM_L_EXCEPTION:
            return(RW_MEM_L_EXCEPTION);
            break;
        }
    }

    return(sys_vop_mem(t_pe,t_node,real_addr,len,rw,d));
}

sys_vop_dat(t_pe, rw, addr, real_addr)
    unsigned t_pe;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned addr;
    unsigned *real_addr;
    /* return RW_MEM_L_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    union tr_form   tre;
    unsigned        tr_num;

    switch (pe[T_PE].vcr[1].vcr1.ps) {
    case 11:
	tr_num = (addr >> 21) & 0x1f;
	break;

    case 13:
	tr_num = (addr >> 23) & 0x1f;
	break;

    case 15:
	tr_num = (addr >> 25) & 0x1f;
	break;

    default:
        /* pe[T_PE].work_vcr2.pif_spx = 1;
	return(RW_MEM_L_EXCEPTION); */
	break;
    }

    tre.ful = pe[T_PE].tr[tr_num].ful;

    if (rw == _W_ && tre.tr.p && pe[T_PE].sr[PEV].pev.u) {
        pe[T_PE].work_vcr2.pif_mpx = 1;
	return(RW_MEM_L_EXCEPTION);
    }

    if (tre.tr.i) {
        pe[T_PE].work_vcr2.pif_mpx = 1;
	return(RW_MEM_L_EXCEPTION);
    }

    switch (pe[T_PE].vcr[1].vcr1.ps) {
    case 11:
        if (addr >> 26 != tre.tr.sa >> 2) {
            pe[T_PE].work_vcr2.pif_mpx = 1;
	    return(RW_MEM_L_EXCEPTION);
        }
        *real_addr = (tre.ful & 0xffe00000) | (addr & 0x001fffff);
	break;

    case 13:
        if (addr >> 28 != tre.tr.sa >> 4) {
            pe[T_PE].work_vcr2.pif_mpx = 1;
	    return(RW_MEM_L_EXCEPTION);
        }
        *real_addr = (tre.ful & 0xff800000) | (addr & 0x007fffff);
	break;

    case 15:
        if (addr >> 30 != tre.tr.sa >> 6) {
            pe[T_PE].work_vcr2.pif_mpx = 1;
	    return(RW_MEM_L_EXCEPTION);
        }
        *real_addr = (tre.ful & 0xfe000000) | (addr & 0x01ffffff);
	break;
    }

    return(RW_SUCCESS);
}

sys_vop_mem(t_pe, t_node, real_addr, len, rw, d)
    unsigned t_pe;
    unsigned t_node; /* 'r':real, 'v':virtual */
    unsigned real_addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write */
    unsigned *d;
    /* return RW_MEM_P_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    unsigned char   mbp;
    unsigned bp_no;
    unsigned abs_addr;
    unsigned *abs_ptr;
    unsigned che_ent;
    unsigned tmp;

#ifdef MCR_AREA
#ifdef PHSA_PROTECT
  /* case PHSA */
    if (rw == _W_ && real_addr < PHSA_SIZE)
      goto mem_vp_exception;
#endif
#endif

  /* case MEM */
#ifdef MANUAL_MAP
    for (tmp=0; tmp<MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (real_addr>=pe[T_PE].map[tmp].start&&real_addr<=pe[T_PE].map[tmp].end) {
          if ((pe[T_PE].map[tmp].prot & rw) == rw) {
            abs_addr = pe[T_PE].map[tmp].abs_addr+(real_addr-pe[T_PE].map[tmp].start);
            goto mem_vp_found;
	  }
	  else
	    goto mem_vp_exception;
        }  
      } 
    } 
    goto mem_vp_exception;
#else
    if (real_addr < memsize)
      abs_addr = real_addr;
    else
      goto mem_vp_exception;
#endif

mem_vp_found:

    switch (len) {
    case 4:
      mbp = pe[T_PE].mbp[abs_addr/8] & 0x00f0 >> (abs_addr & 7);
      break;

    case 8:
      mbp = pe[T_PE].mbp[abs_addr/8];
      break;

    default:
      mbp = 0;
      break;
    }
    if (mbp) {
      for (bp_no = 0; bp_no < BP_NUM; bp_no++) {
        if ((pe[T_PE].bp_table[bp_no].access & rw)
          && pe[T_PE].bp_table[bp_no].abs_addr >= abs_addr
          && pe[T_PE].bp_table[bp_no].abs_addr <= abs_addr+len-1) {
	  if (pe[T_PE].bp_table[bp_no].interval == ++pe[T_PE].bp_table[bp_no].count) {
	    pe[T_PE].bp_table[bp_no].count = 0;
	    if (pe[T_PE].bp_table[bp_no].b_or_c == 'b') {
	      bp_match = 1;
              pe[T_PE].bp_entry = bp_no;
	    }
	    else {
	      cp_match = 1;
	      pe[T_PE].cp_entry = bp_no;
	    }
	  }
        }
      }
    }

    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
      switch (len) {
      case 8:
        *d++ = swap4(*abs_ptr++);

      case 4:
        *d   = swap4(*abs_ptr);
        break;
      }
    }
    else if (rw == _W_) {
      switch (len) {
      case 8:
        *abs_ptr++ = swap4(*d++);

      case 4:
        *abs_ptr   = swap4(*d);
        break;
      }

      /* flush scalar_data_cache */
      che_ent = (real_addr>>6) & (CACHE_NUM-1);
      if (pe[T_PE].data_cache[che_ent].pa == (real_addr>>15))
        pe[T_PE].data_cache[che_ent].v = 0;
    }
    return(RW_SUCCESS);

mem_vp_exception:
    pe[T_PE].work_vcr2.pif_asx = 1;
    return(RW_MEM_P_EXCEPTION);
}

#endif

#ifdef MOVER

get_netpa_ecc(t_pe)
    unsigned t_pe;
{
    return((((t_pe>> 7^t_pe>> 6^t_pe>> 5^t_pe>> 4^t_pe>> 3^t_pe>> 2^t_pe>> 1^t_pe    )&1)<<5)
         | (((t_pe>>12^t_pe>>11^t_pe>>10^t_pe>> 9^t_pe>> 8^t_pe>> 2^t_pe>> 1^t_pe    )&1)<<4)
         | (((t_pe>>14^t_pe>>13^t_pe>>10^t_pe>> 9^t_pe>> 8^t_pe>> 5^t_pe>> 4^t_pe>> 3)&1)<<3)
         | (((t_pe>>15^t_pe>>13^t_pe>>11^t_pe>> 8^t_pe>> 7^t_pe>> 6^t_pe>> 3^t_pe    )&1)<<2)
         | (((t_pe>>15^t_pe>>14^t_pe>>12^t_pe>>11^t_pe>> 9^t_pe>> 6^t_pe>> 4^t_pe>> 1)&1)<<1)
         | (((t_pe>>15^t_pe>>14^t_pe>>13^t_pe>>12^t_pe>>10^t_pe>> 7^t_pe>> 5^t_pe>> 2)&1)   ));
}

get_real_netpa(t_pe, npf, netpa, upid, real_netpa, dupid)
    unsigned t_pe;
    unsigned npf;
    unsigned netpa;
    unsigned upid;
    unsigned *real_netpa;
    unsigned *dupid;
    /* return RW_REG_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    union mcr_form	ntre;

    if (!npf) {
        *real_netpa = netpa;
    }
    else {
        switch (pe[T_PE].mcr[MTC].mtc.ps) {
        case 11:
        case 13:
        case 15:
            break;

        default:
            goto sys_netpa_spec_exception;
            break;
        }

        switch (pe[T_PE].mcr[MTC].mtc.dnupro) {
        case 0:
            goto sys_netpa_prot_exception;
            break;

        case 1:
        case 2:
            if (upid >= pe[T_PE].mcr[MTC].mtc.dnupro || netpa >= NTR_NUM)
                goto sys_netpa_prot_exception;

            ntre.ful = pe[T_PE].smcr[NTRE000+NTR_NUM*upid+netpa].ful;

            if (ntre.ntr.i)
                goto sys_netpa_prot_exception;

            *real_netpa = ntre.ntr.rnetpa;
            *dupid      = (*dupid & ~1) | ntre.ntr.dupid;
            break;

        default:
            goto sys_netpa_spec_exception;
            break;
        }
    }

    return(RW_SUCCESS);

sys_netpa_spec_exception:
    pe[T_PE].work_sndmri.sndtsx = 1;
    return(RW_REG_EXCEPTION);

sys_netpa_prot_exception:
    pe[T_PE].work_sndmri.sndprx = 1;
    return(RW_REG_EXCEPTION);
}

cmd_mop_dat1(t_pe, upid, mtr, addr)
    unsigned t_pe;
    unsigned upid;
    unsigned mtr;
    unsigned addr;
    /* return 1 if failed, 0 if succeeded */
{
    union mcr_form	mtre;
    unsigned		mtr_num;
    unsigned		real_addr;

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        mtr_num = (addr >> 21) & 0x1f;
        break;

    case 13:
        mtr_num = (addr >> 23) & 0x1f;
        break;

    case 15:
        mtr_num = (addr >> 25) & 0x1f;
        break;
    }

    if (upid > 0) {
        message("illegal upid: upid=%u\n", upid);
        return(1);
    }

    if (mtr == 0)
        mtre.ful = pe[T_PE].smcr[MTRLE00+mtr_num].ful;
    else
        mtre.ful = pe[T_PE].smcr[MTRGE00+mtr_num].ful;

    if (mtre.mtr.i) {
        message("invalidated page: mtr[%u].i=1\n", mtr_num);
        return(1);
    }

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        if (addr >> 26 != mtre.mtr.sa >> 10) {
            message("section address mismatch: mtr[%u].sa=0x%X\n", mtr_num, mtre.mtr.sa >> 10);
            return(1);
        }
        real_addr = (mtre.ful & 0xffe00000) | (addr & 0x001fffff);
        break;

    case 13:
        if (addr >> 28 != mtre.mtr.sa >> 12) {
            message("section address mismatch: mtr[%u].sa=0x%X\n", mtr_num, mtre.mtr.sa >> 12);
            return(1);
        }
        real_addr = (mtre.ful & 0xff800000) | (addr & 0x007fffff);
        break;

    case 15:
        if (addr >> 30 != mtre.mtr.sa >> 14) {
            message("section address mismatch: mtr[%u].sa=0x%X\n", mtr_num, mtre.mtr.sa >> 14);
            return(1);
        }
        real_addr = (mtre.ful & 0xfe000000) | (addr & 0x01ffffff);
        break;
    }

    message("%08.8X\n", real_addr);

    return(0);
}

cmd_mop_dat2(t_pe, upid, mtr, addr)
    unsigned t_pe;
    unsigned upid;
    unsigned mtr;
    unsigned addr;
    /* return 1 if failed, 0 if succeeded */
{
    union mcr_form	mtre;
    unsigned		mtr_num;
    unsigned		real_addr;

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        mtr_num = (addr >> 21) & 0xf;
        break;

    case 13:
        mtr_num = (addr >> 23) & 0xf;
        break;

    case 15:
        mtr_num = (addr >> 25) & 0xf;
        break;
    }

    if (upid > 1) {
        message("illegal upid: upid=%u\n", upid);
        return(1);
    }

    if (mtr == 0)
        mtre.ful = pe[T_PE].smcr[MTRLE00+mtr_num+upid*MTR_NUM/2].ful;
    else
        mtre.ful = pe[T_PE].smcr[MTRGE00+mtr_num+upid*MTR_NUM/2].ful;

    if (mtre.mtr.i) {
        message("invalidated page: mtr[%u].i=1\n", mtr_num);
        return(1);
    }

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        if (addr >> 25 != mtre.mtr.sa >> 9) {
            message("section address mismatch: mtr[%u].sa=0x%X\n", mtr_num, mtre.mtr.sa >> 9);
            return(1);
        }
        real_addr = (mtre.ful & 0xffe00000) | (addr & 0x001fffff);
        break;

    case 13:
        if (addr >> 27 != mtre.mtr.sa >> 11) {
            message("section address mismatch: mtr[%u].sa=0x%X\n", mtr_num, mtre.mtr.sa >> 11);
            return(1);
        }
        real_addr = (mtre.ful & 0xff800000) | (addr & 0x007fffff);
        break;

    case 15:
        if (addr >> 29 != mtre.mtr.sa >> 13) {
            message("section address mismatch: mtr[%u].sa=0x%X\n", mtr_num, mtre.mtr.sa >> 13);
            return(1);
        }
        real_addr = (mtre.ful & 0xfe000000) | (addr & 0x01ffffff);
        break;
    }

    message("%08.8X\n", real_addr);

    return(0);
}

sys_mop_access(t_pe, adf, sd, upid, mtr, addr, len, rw, d)
    unsigned t_pe;
    unsigned adf;
    unsigned sd;    /* 's':source, 'd':destination */
    unsigned upid;
    unsigned mtr;
    unsigned addr;
    unsigned len;
    unsigned rw;    /* _R_: read, _W_ : write */
    unsigned *d;
    /* return RW_MEM_P/L_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    unsigned real_addr;

    if (!adf) /* REPLY is always here */
        real_addr = addr;
    else {
        switch (pe[T_PE].mcr[MTC].mtc.ps) {
        case 11:
        case 13:
        case 15:
            break;

        default:
            goto sys_mop_spec_exception;
            break;
        }

        switch (pe[T_PE].mcr[MTC].mtc.dnupro) {
        case 0:
            goto sys_mop_prot_exception;
            break;

        case 1:
            switch (sys_mop_dat1(t_pe, sd, upid, mtr, rw, addr, &real_addr)) {
            case RW_SUCCESS:
                break;
            case RW_MEM_L_EXCEPTION:
                return(RW_MEM_L_EXCEPTION);
                break;
            }
            break;

        case 2:
            switch (sys_mop_dat2(t_pe, sd, upid, mtr, rw, addr, &real_addr)) {
            case RW_SUCCESS:
                break;
            case RW_MEM_L_EXCEPTION:
                return(RW_MEM_L_EXCEPTION);
                break;
            }
            break;

        default:
            goto sys_mop_spec_exception;
            break;
        }
    }

    return(sys_mop_mem(t_pe,sd,real_addr,len,rw,d));

sys_mop_spec_exception:
    if (sd == 's') {
        pe[T_PE].work_sndmri.sndtsx = 1;
    }
    else if (sd == 'd') {
        pe[T_PE].work_mrprmi.rcvtsx = 1;
    }
    return(RW_MEM_L_EXCEPTION);

sys_mop_prot_exception:
    if (sd == 's') {
        pe[T_PE].work_sndmri.sndprx = 1;
    }
    else if (sd == 'd') {
        pe[T_PE].work_mrprmi.rcvprx = 1;
    }
    return(RW_MEM_L_EXCEPTION);
}

sys_mop_dat1(t_pe, sd, upid, mtr, rw, addr, real_addr)
    unsigned t_pe;
    unsigned sd;
    unsigned upid;
    unsigned mtr;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned addr;
    unsigned *real_addr;
    /* return RW_MEM_L_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    union mcr_form	mtre;
    unsigned		mtr_num;

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        mtr_num = (addr >> 21) & 0x1f;
        break;

    case 13:
        mtr_num = (addr >> 23) & 0x1f;
        break;

    case 15:
        mtr_num = (addr >> 25) & 0x1f;
        break;
    }

    if (upid > 0)
        goto sys_mp1_prot_exception;

    if (mtr == 0)
        mtre.ful = pe[T_PE].smcr[MTRLE00+mtr_num].ful;
    else
        mtre.ful = pe[T_PE].smcr[MTRGE00+mtr_num].ful;

    if ((rw == _W_ && mtre.mtr.p) || mtre.mtr.i)
        goto sys_mp1_prot_exception;

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        if (addr >> 26 != mtre.mtr.sa >> 10)
            goto sys_mp1_prot_exception;
        *real_addr = (mtre.ful & 0xffe00000) | (addr & 0x001fffff);
        break;

    case 13:
        if (addr >> 28 != mtre.mtr.sa >> 12)
            goto sys_mp1_prot_exception;
        *real_addr = (mtre.ful & 0xff800000) | (addr & 0x007fffff);
        break;

    case 15:
        if (addr >> 30 != mtre.mtr.sa >> 14)
            goto sys_mp1_prot_exception;
        *real_addr = (mtre.ful & 0xfe000000) | (addr & 0x01ffffff);
        break;
    }

    return(RW_SUCCESS);

sys_mp1_prot_exception:
    if (sd == 's') {
        pe[T_PE].work_sndmri.sndprx = 1;
    }
    else if (sd == 'd') {
        pe[T_PE].work_mrprmi.rcvprx = 1;
    }
    return(RW_MEM_L_EXCEPTION);
}

sys_mop_dat2(t_pe, sd, upid, mtr, rw, addr, real_addr)
    unsigned t_pe;
    unsigned sd;
    unsigned upid;
    unsigned mtr;
    unsigned rw;   /* _R_: read _W_ : write */
    unsigned addr;
    unsigned *real_addr;
    /* return RW_MEM_L_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    union mcr_form	mtre;
    unsigned		mtr_num;

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        mtr_num = (addr >> 21) & 0xf;
        break;

    case 13:
        mtr_num = (addr >> 23) & 0xf;
        break;

    case 15:
        mtr_num = (addr >> 25) & 0xf;
        break;
    }

    if (upid > 1)
        goto sys_mp2_prot_exception;

    if (mtr == 0)
        mtre.ful = pe[T_PE].smcr[MTRLE00+mtr_num+upid*MTR_NUM/2].ful;
    else
        mtre.ful = pe[T_PE].smcr[MTRGE00+mtr_num+upid*MTR_NUM/2].ful;

    if ((rw == _W_ && mtre.mtr.p) || mtre.mtr.i)
        goto sys_mp2_prot_exception;

    switch(pe[T_PE].mcr[MTC].mtc.ps) {
    case 11:
        if (addr >> 25 != mtre.mtr.sa >> 9)
            goto sys_mp2_prot_exception;
        *real_addr = (mtre.ful & 0xffe00000) | (addr & 0x001fffff);
        break;

    case 13:
        if (addr >> 27 != mtre.mtr.sa >> 11)
            goto sys_mp2_prot_exception;
        *real_addr = (mtre.ful & 0xff800000) | (addr & 0x007fffff);
        break;

    case 15:
        if (addr >> 29 != mtre.mtr.sa >> 13)
            goto sys_mp2_prot_exception;
        *real_addr = (mtre.ful & 0xfe000000) | (addr & 0x01ffffff);
        break;
    }

    return(RW_SUCCESS);

sys_mp2_prot_exception:
    if (sd == 's') {
        pe[T_PE].work_sndmri.sndprx = 1;
    }
    else if (sd == 'd') {
        pe[T_PE].work_mrprmi.rcvprx = 1;
    }
    return(RW_MEM_L_EXCEPTION);
}

sys_mop_mem(t_pe, sd, real_addr, len, rw, d)
    unsigned t_pe;
    unsigned sd;   /* 's':source, 'd':destination */
    unsigned real_addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write */
    unsigned *d;
    /* return RW_MEM_P_EXCEPTION if failed, RW_SUCCESS if succeeded */
{
    unsigned char   mbp;
    unsigned bp_no;
    unsigned abs_addr;
    unsigned *abs_ptr;
    unsigned che_ent;
    unsigned tmp;

    if (real_addr & (len-1)) { /* not aligned exception */
      goto mem_mp_ali_exception;
    }

#ifdef MCR_AREA
#ifdef PHSA_PROTECT
  /* case PHSA */
    if (rw == _W_ && real_addr < PHSA_SIZE)
      goto mem_mp_adr_exception;
#endif
#endif

  /* case MEM */
#ifdef MANUAL_MAP
    for (tmp=0; tmp<MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (real_addr>=pe[T_PE].map[tmp].start&&real_addr<=pe[T_PE].map[tmp].end) {
          if ((pe[T_PE].map[tmp].prot & rw) == rw) {
            abs_addr = pe[T_PE].map[tmp].abs_addr+(real_addr-pe[T_PE].map[tmp].start);
            goto mem_mp_found;
	  }
	  else
	    goto mem_mp_adr_exception;
        }  
      } 
    } 
    goto mem_mp_adr_exception;
#else
    if (real_addr < memsize)
      abs_addr = real_addr;
    else
      goto mem_mp_adr_exception;
#endif

mem_mp_found:

    switch (len) {
    case 4:
      mbp = pe[T_PE].mbp[abs_addr/8] & 0x00f0 >> (abs_addr & 7);
      break;

    case 8:
      mbp = pe[T_PE].mbp[abs_addr/8];
      break;

    default:
      mbp = 0;
      break;
    }
    if (mbp) {
      for (bp_no = 0; bp_no < BP_NUM; bp_no++) {
        if ((pe[T_PE].bp_table[bp_no].access & rw)
          && pe[T_PE].bp_table[bp_no].abs_addr >= abs_addr
          && pe[T_PE].bp_table[bp_no].abs_addr <= abs_addr+len-1) {
	  if (pe[T_PE].bp_table[bp_no].interval == ++pe[T_PE].bp_table[bp_no].count) {
	    pe[T_PE].bp_table[bp_no].count = 0;
	    if (pe[T_PE].bp_table[bp_no].b_or_c == 'b') {
	      bp_match = 1;
              pe[T_PE].bp_entry = bp_no;
	    }
	    else {
	      cp_match = 1;
	      pe[T_PE].cp_entry = bp_no;
	    }
	  }
        }
      }
    }

    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
      switch (len) {
      case 8:
        *d++ = swap4(*abs_ptr++);

      case 4:
        *d   = swap4(*abs_ptr);
        break;
      }
    }
    else if (rw == _W_) {
      switch (len) {
      case 8:
        *abs_ptr++ = swap4(*d++);

      case 4:
        *abs_ptr   = swap4(*d);
        break;
      }

      /* flush scalar_text/data_cache */
      che_ent = (real_addr>>6) & (CACHE_NUM-1);
      if (pe[T_PE].text_cache[che_ent].pa == (real_addr>>15))
        pe[T_PE].text_cache[che_ent].v = 0;
      if (pe[T_PE].data_cache[che_ent].pa == (real_addr>>15))
        pe[T_PE].data_cache[che_ent].v = 0;
    }
    return(RW_SUCCESS);

mem_mp_ali_exception:
    if (sd == 's') {
        pe[T_PE].work_sndmri.sndalx = 1;
    }
    else if (sd == 'd') {
        pe[T_PE].work_mrprmi.rcvalx = 1;
    }
    return(RW_MEM_P_EXCEPTION);

mem_mp_adr_exception:
    if (sd == 's') {
        pe[T_PE].work_sndmri.sndadx = 1;
    }
    else if (sd == 'd') {
        pe[T_PE].work_mrprmi.rcvadx = 1;
    }
    return(RW_MEM_P_EXCEPTION);
}

#endif

#ifdef SSUMOVER

sys_sop_access(t_pe, addr, len, rw, d)
    unsigned t_pe;
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write */
    unsigned *d;
    /* return RW_BERR/RW_TIMEOUT if failed, RW_SUCCESS if succeeded */
{
    unsigned char   mbp;
    unsigned bp_no;
    unsigned abs_addr;
    unsigned *abs_ptr;
    unsigned che_ent;
    unsigned tmp;

    if (addr & (len-1)) { /* not aligned exception */
      goto mem_sp_inv_operation;
    }

#ifdef MCR_AREA
#ifdef PHSA_PROTECT
  /* case PHSA */
    if (rw == _W_ && addr < PHSA_SIZE)
      goto mem_sp_adr_exception;
#endif
#endif

  /* case MEM */
#ifdef MANUAL_MAP
    for (tmp=0; tmp<MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (addr>=pe[T_PE].map[tmp].start&&addr<=pe[T_PE].map[tmp].end) {
          if ((pe[T_PE].map[tmp].prot & rw) == rw) {
            abs_addr = pe[T_PE].map[tmp].abs_addr+(addr-pe[T_PE].map[tmp].start);
            goto mem_sp_found;
	  }
	  else
	    goto mem_sp_adr_exception;
        }  
      } 
    } 
    goto mem_sp_adr_exception;
#else
    if (addr < memsize)
      abs_addr = addr;
    else
      goto mem_sp_adr_exception;
#endif

mem_sp_found:

    switch (len) {
    case 8:
      mbp = pe[T_PE].mbp[abs_addr/8];
      break;

    case 16:
      mbp = pe[T_PE].mbp[abs_addr/8] | pe[T_PE].mbp[abs_addr/8+1];
      break;

    default:
      mbp = 0;
      break;
    }
    if (mbp) {
      for (bp_no = 0; bp_no < BP_NUM; bp_no++) {
        if ((pe[T_PE].bp_table[bp_no].access & rw)
          && pe[T_PE].bp_table[bp_no].abs_addr >= abs_addr
          && pe[T_PE].bp_table[bp_no].abs_addr <= abs_addr+len-1) {
	  if (pe[T_PE].bp_table[bp_no].interval == ++pe[T_PE].bp_table[bp_no].count) {
	    pe[T_PE].bp_table[bp_no].count = 0;
	    if (pe[T_PE].bp_table[bp_no].b_or_c == 'b') {
	      bp_match = 1;
              pe[T_PE].bp_entry = bp_no;
	    }
	    else {
	      cp_match = 1;
	      pe[T_PE].cp_entry = bp_no;
	    }
	  }
        }
      }
    }

    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
      switch (len) {
      case 16:
        *d++ = swap4(*abs_ptr++);
        *d++ = swap4(*abs_ptr++);

      case 8:
        *d++ = swap4(*abs_ptr++);
        *d   = swap4(*abs_ptr);
        break;
      }
    }
    else if (rw == _W_) {
      switch (len) {
      case 16:
        *abs_ptr++ = swap4(*d++);
        *abs_ptr++ = swap4(*d++);

      case 8:
        *abs_ptr++ = swap4(*d++);
        *abs_ptr   = swap4(*d);
        break;
      }

      /* flush scalar_text/data_cache */
      che_ent = (addr>>6) & (CACHE_NUM-1);
      if (pe[T_PE].text_cache[che_ent].pa == (addr>>15))
        pe[T_PE].text_cache[che_ent].v = 0;
      if (pe[T_PE].data_cache[che_ent].pa == (addr>>15))
        pe[T_PE].data_cache[che_ent].v = 0;
    }
    return(RW_SUCCESS);

mem_sp_inv_operation:
    pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x04;
    return(RW_BERR);

mem_sp_adr_exception:
    pe[T_PE].mcr[SMSSW0].smssw0.smexcp = 0x80;
    return(RW_TIMEOUT);
}

#endif

#ifdef FSBA

sys_fop_access(t_pe, addr, len, rw, d)
    unsigned t_pe;
    unsigned addr;
    unsigned len;
    unsigned rw;   /* _R_:read, _W_:write */
    unsigned *d;
    /* return RW_BERR/RW_TIMEOUT if failed, RW_SUCCESS if succeeded */
{
    unsigned char   mbp;
    unsigned bp_no;
    unsigned abs_addr;
    unsigned *abs_ptr;
    unsigned che_ent;
    unsigned tmp;

    if (addr & (len-1)) { /* not aligned exception */
      return(RW_BERR);
    }

#ifdef MCR_AREA
#ifdef PHSA_PROTECT
  /* case PHSA */
    if (rw == _W_ && addr < PHSA_SIZE)
      goto mem_fp_adr_exception;
#endif
#endif

  /* case MEM */
#ifdef MANUAL_MAP
    for (tmp=0; tmp<MAP_NUM; tmp++) {
      if (pe[T_PE].map[tmp].prot) {
        if (addr>=pe[T_PE].map[tmp].start&&addr<=pe[T_PE].map[tmp].end) {
          if ((pe[T_PE].map[tmp].prot & rw) == rw) {
            abs_addr = pe[T_PE].map[tmp].abs_addr+(addr-pe[T_PE].map[tmp].start);
            goto mem_fp_found;
	  }
	  else
	    goto mem_fp_adr_exception;
        }  
      } 
    } 
    goto mem_fp_adr_exception;
#else
    if (addr < memsize)
      abs_addr = addr;
    else
      goto mem_fp_adr_exception;
#endif

mem_fp_found:

    switch (len) {
    case 1:
      mbp = pe[T_PE].mbp[abs_addr/8] & 0x0080 >> (abs_addr & 7);
      break;

    case 2:
      mbp = pe[T_PE].mbp[abs_addr/8] & 0x00c0 >> (abs_addr & 7);
      break;

    case 4:
      mbp = pe[T_PE].mbp[abs_addr/8] & 0x00f0 >> (abs_addr & 7);
      break;

    default:
      mbp = 0;
      break;
    }
    if (mbp) {
      for (bp_no = 0; bp_no < BP_NUM; bp_no++) {
        if ((pe[T_PE].bp_table[bp_no].access & rw)
          && pe[T_PE].bp_table[bp_no].abs_addr >= abs_addr
          && pe[T_PE].bp_table[bp_no].abs_addr <= abs_addr+len-1) {
	  if (pe[T_PE].bp_table[bp_no].interval == ++pe[T_PE].bp_table[bp_no].count) {
	    pe[T_PE].bp_table[bp_no].count = 0;
	    if (pe[T_PE].bp_table[bp_no].b_or_c == 'b') {
	      bp_match = 1;
              pe[T_PE].bp_entry = bp_no;
	    }
	    else {
	      cp_match = 1;
	      pe[T_PE].cp_entry = bp_no;
	    }
	  }
        }
      }
    }

    abs_ptr = (unsigned *) &pe[T_PE].mem[abs_addr];
    if (rw == _R_) {
      switch (len) {
      case 4:
        *d = swap4(*abs_ptr);
        break;

      case 2:
        *(unsigned short *)d = swap2(*(unsigned short *) abs_ptr);
        break;

      case 1:
        *(unsigned char *)d = *(unsigned char *) abs_ptr;
        break;
      }
    }
    else if (rw == _W_) {
      switch (len) {
      case 4:
        *abs_ptr = swap4(*d);
        break;

      case 2:
        *(unsigned short *) abs_ptr = swap2(*(unsigned short *)d);
        break;

      case 1:
        *(unsigned char *) abs_ptr = *(unsigned char *)d;
        break;
      }

      /* flush scalar_text/data_cache */
      che_ent = (addr>>6) & (CACHE_NUM-1);
      if (pe[T_PE].text_cache[che_ent].pa == (addr>>15))
        pe[T_PE].text_cache[che_ent].v = 0;
      if (pe[T_PE].data_cache[che_ent].pa == (addr>>15))
        pe[T_PE].data_cache[che_ent].v = 0;
    }
    return(RW_SUCCESS);

mem_fp_adr_exception:
    return(RW_TIMEOUT);
}

#endif

